/* MessageDialogView.c generated by valac 0.42.7, the Vala compiler
 * generated from MessageDialogView.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2017 elementary LLC. (https://elementary.io)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include "granite.h"
#include <gio/gio.h>


#define TYPE_MESSAGE_DIALOG_VIEW (message_dialog_view_get_type ())
#define MESSAGE_DIALOG_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MESSAGE_DIALOG_VIEW, MessageDialogView))
#define MESSAGE_DIALOG_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MESSAGE_DIALOG_VIEW, MessageDialogViewClass))
#define IS_MESSAGE_DIALOG_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MESSAGE_DIALOG_VIEW))
#define IS_MESSAGE_DIALOG_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MESSAGE_DIALOG_VIEW))
#define MESSAGE_DIALOG_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MESSAGE_DIALOG_VIEW, MessageDialogViewClass))

typedef struct _MessageDialogView MessageDialogView;
typedef struct _MessageDialogViewClass MessageDialogViewClass;
typedef struct _MessageDialogViewPrivate MessageDialogViewPrivate;
enum  {
	MESSAGE_DIALOG_VIEW_0_PROPERTY,
	MESSAGE_DIALOG_VIEW_WINDOW_PROPERTY,
	MESSAGE_DIALOG_VIEW_NUM_PROPERTIES
};
static GParamSpec* message_dialog_view_properties[MESSAGE_DIALOG_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _MessageDialogView {
	GtkGrid parent_instance;
	MessageDialogViewPrivate * priv;
};

struct _MessageDialogViewClass {
	GtkGridClass parent_class;
};

struct _MessageDialogViewPrivate {
	GtkWindow* _window;
	GraniteWidgetsToast* toast;
};


static gint MessageDialogView_private_offset;
static gpointer message_dialog_view_parent_class = NULL;

GType message_dialog_view_get_type (void) G_GNUC_CONST;
MessageDialogView* message_dialog_view_new (GtkWindow* window);
MessageDialogView* message_dialog_view_construct (GType object_type,
                                                  GtkWindow* window);
static void message_dialog_view_show_message_dialog (MessageDialogView* self);
GtkWindow* message_dialog_view_get_window (MessageDialogView* self);
static void message_dialog_view_set_window (MessageDialogView* self,
                                     GtkWindow* value);
static GObject * message_dialog_view_constructor (GType type,
                                           guint n_construct_properties,
                                           GObjectConstructParam * construct_properties);
static void _message_dialog_view_show_message_dialog_gtk_button_clicked (GtkButton* _sender,
                                                                  gpointer self);
static void message_dialog_view_finalize (GObject * obj);
static void _vala_message_dialog_view_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec);
static void _vala_message_dialog_view_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec);


static inline gpointer
message_dialog_view_get_instance_private (MessageDialogView* self)
{
	return G_STRUCT_MEMBER_P (self, MessageDialogView_private_offset);
}


MessageDialogView*
message_dialog_view_construct (GType object_type,
                               GtkWindow* window)
{
	MessageDialogView * self = NULL;
#line 26 "../demo/Views/MessageDialogView.vala"
	g_return_val_if_fail (window != NULL, NULL);
#line 27 "../demo/Views/MessageDialogView.vala"
	self = (MessageDialogView*) g_object_new (object_type, "window", window, NULL);
#line 26 "../demo/Views/MessageDialogView.vala"
	return self;
#line 111 "MessageDialogView.c"
}


MessageDialogView*
message_dialog_view_new (GtkWindow* window)
{
#line 26 "../demo/Views/MessageDialogView.vala"
	return message_dialog_view_construct (TYPE_MESSAGE_DIALOG_VIEW, window);
#line 120 "MessageDialogView.c"
}


static void
message_dialog_view_show_message_dialog (MessageDialogView* self)
{
	GraniteMessageDialog* message_dialog = NULL;
	GraniteMessageDialog* _tmp0_;
	GraniteMessageDialog* _tmp1_;
	GThemedIcon* _tmp2_;
	GThemedIcon* _tmp3_;
	GraniteMessageDialog* _tmp4_;
	GtkWindow* _tmp5_;
	GtkButton* suggested_button = NULL;
	GtkButton* _tmp6_;
	GtkButton* _tmp7_;
	GtkStyleContext* _tmp8_;
	GraniteMessageDialog* _tmp9_;
	GtkButton* _tmp10_;
	GtkCheckButton* custom_widget = NULL;
	GtkCheckButton* _tmp11_;
	GraniteMessageDialog* _tmp12_;
	GraniteMessageDialog* _tmp13_;
	GtkBin* _tmp14_;
	GtkBin* _tmp15_;
	GtkCheckButton* _tmp16_;
	GraniteMessageDialog* _tmp17_;
	GraniteMessageDialog* _tmp18_;
	GraniteMessageDialog* _tmp20_;
#line 44 "../demo/Views/MessageDialogView.vala"
	g_return_if_fail (self != NULL);
#line 45 "../demo/Views/MessageDialogView.vala"
	_tmp0_ = granite_message_dialog_new_with_image_from_icon_name ("Basic Information and a Suggestion", "Further details, including information that explains any unobvious con" \
"sequences of actions.", "phone", GTK_BUTTONS_CANCEL);
#line 45 "../demo/Views/MessageDialogView.vala"
	g_object_ref_sink (_tmp0_);
#line 45 "../demo/Views/MessageDialogView.vala"
	message_dialog = _tmp0_;
#line 51 "../demo/Views/MessageDialogView.vala"
	_tmp1_ = message_dialog;
#line 51 "../demo/Views/MessageDialogView.vala"
	_tmp2_ = (GThemedIcon*) g_themed_icon_new ("dialog-information");
#line 51 "../demo/Views/MessageDialogView.vala"
	_tmp3_ = _tmp2_;
#line 51 "../demo/Views/MessageDialogView.vala"
	granite_message_dialog_set_badge_icon (_tmp1_, (GIcon*) _tmp3_);
#line 51 "../demo/Views/MessageDialogView.vala"
	_g_object_unref0 (_tmp3_);
#line 52 "../demo/Views/MessageDialogView.vala"
	_tmp4_ = message_dialog;
#line 52 "../demo/Views/MessageDialogView.vala"
	_tmp5_ = self->priv->_window;
#line 52 "../demo/Views/MessageDialogView.vala"
	gtk_window_set_transient_for ((GtkWindow*) _tmp4_, _tmp5_);
#line 54 "../demo/Views/MessageDialogView.vala"
	_tmp6_ = (GtkButton*) gtk_button_new_with_label ("Suggested Action");
#line 54 "../demo/Views/MessageDialogView.vala"
	g_object_ref_sink (_tmp6_);
#line 54 "../demo/Views/MessageDialogView.vala"
	suggested_button = _tmp6_;
#line 55 "../demo/Views/MessageDialogView.vala"
	_tmp7_ = suggested_button;
#line 55 "../demo/Views/MessageDialogView.vala"
	_tmp8_ = gtk_widget_get_style_context ((GtkWidget*) _tmp7_);
#line 55 "../demo/Views/MessageDialogView.vala"
	gtk_style_context_add_class (_tmp8_, GTK_STYLE_CLASS_SUGGESTED_ACTION);
#line 56 "../demo/Views/MessageDialogView.vala"
	_tmp9_ = message_dialog;
#line 56 "../demo/Views/MessageDialogView.vala"
	_tmp10_ = suggested_button;
#line 56 "../demo/Views/MessageDialogView.vala"
	gtk_dialog_add_action_widget ((GtkDialog*) _tmp9_, (GtkWidget*) _tmp10_, (gint) GTK_RESPONSE_ACCEPT);
#line 58 "../demo/Views/MessageDialogView.vala"
	_tmp11_ = (GtkCheckButton*) gtk_check_button_new_with_label ("Custom widget");
#line 58 "../demo/Views/MessageDialogView.vala"
	g_object_ref_sink (_tmp11_);
#line 58 "../demo/Views/MessageDialogView.vala"
	custom_widget = _tmp11_;
#line 60 "../demo/Views/MessageDialogView.vala"
	_tmp12_ = message_dialog;
#line 60 "../demo/Views/MessageDialogView.vala"
	granite_message_dialog_show_error_details (_tmp12_, "The details of a possible error.");
#line 61 "../demo/Views/MessageDialogView.vala"
	_tmp13_ = message_dialog;
#line 61 "../demo/Views/MessageDialogView.vala"
	_tmp14_ = granite_message_dialog_get_custom_bin (_tmp13_);
#line 61 "../demo/Views/MessageDialogView.vala"
	_tmp15_ = _tmp14_;
#line 61 "../demo/Views/MessageDialogView.vala"
	_tmp16_ = custom_widget;
#line 61 "../demo/Views/MessageDialogView.vala"
	gtk_container_add ((GtkContainer*) _tmp15_, (GtkWidget*) _tmp16_);
#line 62 "../demo/Views/MessageDialogView.vala"
	_tmp17_ = message_dialog;
#line 62 "../demo/Views/MessageDialogView.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp17_);
#line 63 "../demo/Views/MessageDialogView.vala"
	_tmp18_ = message_dialog;
#line 63 "../demo/Views/MessageDialogView.vala"
	if (gtk_dialog_run ((GtkDialog*) _tmp18_) == ((gint) GTK_RESPONSE_ACCEPT)) {
#line 220 "MessageDialogView.c"
		GraniteWidgetsToast* _tmp19_;
#line 64 "../demo/Views/MessageDialogView.vala"
		_tmp19_ = self->priv->toast;
#line 64 "../demo/Views/MessageDialogView.vala"
		granite_widgets_toast_send_notification (_tmp19_);
#line 226 "MessageDialogView.c"
	}
#line 67 "../demo/Views/MessageDialogView.vala"
	_tmp20_ = message_dialog;
#line 67 "../demo/Views/MessageDialogView.vala"
	gtk_widget_destroy ((GtkWidget*) _tmp20_);
#line 44 "../demo/Views/MessageDialogView.vala"
	_g_object_unref0 (custom_widget);
#line 44 "../demo/Views/MessageDialogView.vala"
	_g_object_unref0 (suggested_button);
#line 44 "../demo/Views/MessageDialogView.vala"
	_g_object_unref0 (message_dialog);
#line 238 "MessageDialogView.c"
}


GtkWindow*
message_dialog_view_get_window (MessageDialogView* self)
{
	GtkWindow* result;
	GtkWindow* _tmp0_;
#line 22 "../demo/Views/MessageDialogView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 22 "../demo/Views/MessageDialogView.vala"
	_tmp0_ = self->priv->_window;
#line 22 "../demo/Views/MessageDialogView.vala"
	result = _tmp0_;
#line 22 "../demo/Views/MessageDialogView.vala"
	return result;
#line 255 "MessageDialogView.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 22 "../demo/Views/MessageDialogView.vala"
	return self ? g_object_ref (self) : NULL;
#line 264 "MessageDialogView.c"
}


static void
message_dialog_view_set_window (MessageDialogView* self,
                                GtkWindow* value)
{
#line 22 "../demo/Views/MessageDialogView.vala"
	g_return_if_fail (self != NULL);
#line 22 "../demo/Views/MessageDialogView.vala"
	if (message_dialog_view_get_window (self) != value) {
#line 276 "MessageDialogView.c"
		GtkWindow* _tmp0_;
#line 22 "../demo/Views/MessageDialogView.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 22 "../demo/Views/MessageDialogView.vala"
		_g_object_unref0 (self->priv->_window);
#line 22 "../demo/Views/MessageDialogView.vala"
		self->priv->_window = _tmp0_;
#line 22 "../demo/Views/MessageDialogView.vala"
		g_object_notify_by_pspec ((GObject *) self, message_dialog_view_properties[MESSAGE_DIALOG_VIEW_WINDOW_PROPERTY]);
#line 286 "MessageDialogView.c"
	}
}


static void
_message_dialog_view_show_message_dialog_gtk_button_clicked (GtkButton* _sender,
                                                             gpointer self)
{
#line 36 "../demo/Views/MessageDialogView.vala"
	message_dialog_view_show_message_dialog ((MessageDialogView*) self);
#line 297 "MessageDialogView.c"
}


static GObject *
message_dialog_view_constructor (GType type,
                                 guint n_construct_properties,
                                 GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MessageDialogView * self;
	GtkButton* button = NULL;
	GtkButton* _tmp0_;
	GtkButton* _tmp1_;
	GtkButton* _tmp2_;
	GtkButton* _tmp3_;
	GtkButton* _tmp4_;
	GraniteWidgetsToast* _tmp5_;
	GraniteWidgetsToast* _tmp6_;
	GtkButton* _tmp7_;
#line 30 "../demo/Views/MessageDialogView.vala"
	parent_class = G_OBJECT_CLASS (message_dialog_view_parent_class);
#line 30 "../demo/Views/MessageDialogView.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 30 "../demo/Views/MessageDialogView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MESSAGE_DIALOG_VIEW, MessageDialogView);
#line 31 "../demo/Views/MessageDialogView.vala"
	_tmp0_ = (GtkButton*) gtk_button_new_with_label ("Show MessageDialog");
#line 31 "../demo/Views/MessageDialogView.vala"
	g_object_ref_sink (_tmp0_);
#line 31 "../demo/Views/MessageDialogView.vala"
	button = _tmp0_;
#line 32 "../demo/Views/MessageDialogView.vala"
	_tmp1_ = button;
#line 32 "../demo/Views/MessageDialogView.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp1_, GTK_ALIGN_CENTER);
#line 33 "../demo/Views/MessageDialogView.vala"
	_tmp2_ = button;
#line 33 "../demo/Views/MessageDialogView.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp2_, GTK_ALIGN_CENTER);
#line 34 "../demo/Views/MessageDialogView.vala"
	_tmp3_ = button;
#line 34 "../demo/Views/MessageDialogView.vala"
	g_object_set ((GtkWidget*) _tmp3_, "expand", TRUE, NULL);
#line 36 "../demo/Views/MessageDialogView.vala"
	_tmp4_ = button;
#line 36 "../demo/Views/MessageDialogView.vala"
	g_signal_connect_object (_tmp4_, "clicked", (GCallback) _message_dialog_view_show_message_dialog_gtk_button_clicked, self, 0);
#line 38 "../demo/Views/MessageDialogView.vala"
	_tmp5_ = granite_widgets_toast_new ("Did something");
#line 38 "../demo/Views/MessageDialogView.vala"
	g_object_ref_sink (_tmp5_);
#line 38 "../demo/Views/MessageDialogView.vala"
	_g_object_unref0 (self->priv->toast);
#line 38 "../demo/Views/MessageDialogView.vala"
	self->priv->toast = _tmp5_;
#line 40 "../demo/Views/MessageDialogView.vala"
	_tmp6_ = self->priv->toast;
#line 40 "../demo/Views/MessageDialogView.vala"
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp6_, 0, 0, 1, 1);
#line 41 "../demo/Views/MessageDialogView.vala"
	_tmp7_ = button;
#line 41 "../demo/Views/MessageDialogView.vala"
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp7_, 0, 1, 1, 1);
#line 30 "../demo/Views/MessageDialogView.vala"
	_g_object_unref0 (button);
#line 30 "../demo/Views/MessageDialogView.vala"
	return obj;
#line 366 "MessageDialogView.c"
}


static void
message_dialog_view_class_init (MessageDialogViewClass * klass)
{
#line 21 "../demo/Views/MessageDialogView.vala"
	message_dialog_view_parent_class = g_type_class_peek_parent (klass);
#line 21 "../demo/Views/MessageDialogView.vala"
	g_type_class_adjust_private_offset (klass, &MessageDialogView_private_offset);
#line 21 "../demo/Views/MessageDialogView.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_message_dialog_view_get_property;
#line 21 "../demo/Views/MessageDialogView.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_message_dialog_view_set_property;
#line 21 "../demo/Views/MessageDialogView.vala"
	G_OBJECT_CLASS (klass)->constructor = message_dialog_view_constructor;
#line 21 "../demo/Views/MessageDialogView.vala"
	G_OBJECT_CLASS (klass)->finalize = message_dialog_view_finalize;
#line 21 "../demo/Views/MessageDialogView.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MESSAGE_DIALOG_VIEW_WINDOW_PROPERTY, message_dialog_view_properties[MESSAGE_DIALOG_VIEW_WINDOW_PROPERTY] = g_param_spec_object ("window", "window", "window", gtk_window_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 387 "MessageDialogView.c"
}


static void
message_dialog_view_instance_init (MessageDialogView * self)
{
#line 21 "../demo/Views/MessageDialogView.vala"
	self->priv = message_dialog_view_get_instance_private (self);
#line 396 "MessageDialogView.c"
}


static void
message_dialog_view_finalize (GObject * obj)
{
	MessageDialogView * self;
#line 21 "../demo/Views/MessageDialogView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MESSAGE_DIALOG_VIEW, MessageDialogView);
#line 22 "../demo/Views/MessageDialogView.vala"
	_g_object_unref0 (self->priv->_window);
#line 24 "../demo/Views/MessageDialogView.vala"
	_g_object_unref0 (self->priv->toast);
#line 21 "../demo/Views/MessageDialogView.vala"
	G_OBJECT_CLASS (message_dialog_view_parent_class)->finalize (obj);
#line 412 "MessageDialogView.c"
}


GType
message_dialog_view_get_type (void)
{
	static volatile gsize message_dialog_view_type_id__volatile = 0;
	if (g_once_init_enter (&message_dialog_view_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (MessageDialogViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) message_dialog_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MessageDialogView), 0, (GInstanceInitFunc) message_dialog_view_instance_init, NULL };
		GType message_dialog_view_type_id;
		message_dialog_view_type_id = g_type_register_static (gtk_grid_get_type (), "MessageDialogView", &g_define_type_info, 0);
		MessageDialogView_private_offset = g_type_add_instance_private (message_dialog_view_type_id, sizeof (MessageDialogViewPrivate));
		g_once_init_leave (&message_dialog_view_type_id__volatile, message_dialog_view_type_id);
	}
	return message_dialog_view_type_id__volatile;
}


static void
_vala_message_dialog_view_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec)
{
	MessageDialogView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_MESSAGE_DIALOG_VIEW, MessageDialogView);
#line 21 "../demo/Views/MessageDialogView.vala"
	switch (property_id) {
#line 21 "../demo/Views/MessageDialogView.vala"
		case MESSAGE_DIALOG_VIEW_WINDOW_PROPERTY:
#line 21 "../demo/Views/MessageDialogView.vala"
		g_value_set_object (value, message_dialog_view_get_window (self));
#line 21 "../demo/Views/MessageDialogView.vala"
		break;
#line 447 "MessageDialogView.c"
		default:
#line 21 "../demo/Views/MessageDialogView.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../demo/Views/MessageDialogView.vala"
		break;
#line 453 "MessageDialogView.c"
	}
}


static void
_vala_message_dialog_view_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec)
{
	MessageDialogView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_MESSAGE_DIALOG_VIEW, MessageDialogView);
#line 21 "../demo/Views/MessageDialogView.vala"
	switch (property_id) {
#line 21 "../demo/Views/MessageDialogView.vala"
		case MESSAGE_DIALOG_VIEW_WINDOW_PROPERTY:
#line 21 "../demo/Views/MessageDialogView.vala"
		message_dialog_view_set_window (self, g_value_get_object (value));
#line 21 "../demo/Views/MessageDialogView.vala"
		break;
#line 474 "MessageDialogView.c"
		default:
#line 21 "../demo/Views/MessageDialogView.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../demo/Views/MessageDialogView.vala"
		break;
#line 480 "MessageDialogView.c"
	}
}



