/* Color.c generated by valac 0.42.7, the Vala compiler
 * generated from Color.vala, do not modify */

/*
 *  Copyright (C) 2011-2013 Robert Dyer
 *
 *  This program or library is free software; you can redistribute it
 *  and/or modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 3 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General
 *  Public License along with this library; if not, write to the
 *  Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 *  Boston, MA 02110-1301 USA.
 */


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>


#define GRANITE_SERVICES_TYPE_SETTINGS_SERIALIZABLE (granite_services_settings_serializable_get_type ())
#define GRANITE_SERVICES_SETTINGS_SERIALIZABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GRANITE_SERVICES_TYPE_SETTINGS_SERIALIZABLE, GraniteServicesSettingsSerializable))
#define GRANITE_SERVICES_IS_SETTINGS_SERIALIZABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GRANITE_SERVICES_TYPE_SETTINGS_SERIALIZABLE))
#define GRANITE_SERVICES_SETTINGS_SERIALIZABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GRANITE_SERVICES_TYPE_SETTINGS_SERIALIZABLE, GraniteServicesSettingsSerializableIface))

typedef struct _GraniteServicesSettingsSerializable GraniteServicesSettingsSerializable;
typedef struct _GraniteServicesSettingsSerializableIface GraniteServicesSettingsSerializableIface;

#define GRANITE_DRAWING_TYPE_COLOR (granite_drawing_color_get_type ())
#define GRANITE_DRAWING_COLOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GRANITE_DRAWING_TYPE_COLOR, GraniteDrawingColor))
#define GRANITE_DRAWING_COLOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GRANITE_DRAWING_TYPE_COLOR, GraniteDrawingColorClass))
#define GRANITE_DRAWING_IS_COLOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GRANITE_DRAWING_TYPE_COLOR))
#define GRANITE_DRAWING_IS_COLOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GRANITE_DRAWING_TYPE_COLOR))
#define GRANITE_DRAWING_COLOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GRANITE_DRAWING_TYPE_COLOR, GraniteDrawingColorClass))

typedef struct _GraniteDrawingColor GraniteDrawingColor;
typedef struct _GraniteDrawingColorClass GraniteDrawingColorClass;
typedef struct _GraniteDrawingColorPrivate GraniteDrawingColorPrivate;
enum  {
	GRANITE_DRAWING_COLOR_0_PROPERTY,
	GRANITE_DRAWING_COLOR_NUM_PROPERTIES
};
static GParamSpec* granite_drawing_color_properties[GRANITE_DRAWING_COLOR_NUM_PROPERTIES];
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _GraniteServicesSettingsSerializableIface {
	GTypeInterface parent_iface;
	gchar* (*settings_serialize) (GraniteServicesSettingsSerializable* self);
	void (*settings_deserialize) (GraniteServicesSettingsSerializable* self, const gchar* s);
};

struct _GraniteDrawingColor {
	GObject parent_instance;
	gdouble R;
	gdouble G;
	gdouble B;
	gdouble A;
	GraniteDrawingColorPrivate * priv;
};

struct _GraniteDrawingColorClass {
	GObjectClass parent_class;
};


static gpointer granite_drawing_color_parent_class = NULL;
static GraniteServicesSettingsSerializableIface * granite_drawing_color_granite_services_settings_serializable_parent_iface = NULL;

GType granite_services_settings_serializable_get_type (void) G_GNUC_CONST;
GType granite_drawing_color_get_type (void) G_GNUC_CONST;
guint8 granite_drawing_color_alpha_from_int (gint color);
guint8 granite_drawing_color_red_from_int (gint color);
guint8 granite_drawing_color_green_from_int (gint color);
guint8 granite_drawing_color_blue_from_int (gint color);
GraniteDrawingColor* granite_drawing_color_new (gdouble R,
                                                gdouble G,
                                                gdouble B,
                                                gdouble A);
GraniteDrawingColor* granite_drawing_color_construct (GType object_type,
                                                      gdouble R,
                                                      gdouble G,
                                                      gdouble B,
                                                      gdouble A);
GraniteDrawingColor* granite_drawing_color_new_from_gdk (GdkColor* color);
GraniteDrawingColor* granite_drawing_color_construct_from_gdk (GType object_type,
                                                               GdkColor* color);
GraniteDrawingColor* granite_drawing_color_new_from_rgba (GdkRGBA* color);
GraniteDrawingColor* granite_drawing_color_construct_from_rgba (GType object_type,
                                                                GdkRGBA* color);
static void granite_drawing_color_set_from_rgba (GraniteDrawingColor* self,
                                          GdkRGBA* color);
GraniteDrawingColor* granite_drawing_color_new_from_string (const gchar* color);
GraniteDrawingColor* granite_drawing_color_construct_from_string (GType object_type,
                                                                  const gchar* color);
GraniteDrawingColor* granite_drawing_color_new_from_int (gint color);
GraniteDrawingColor* granite_drawing_color_construct_from_int (GType object_type,
                                                               gint color);
GraniteDrawingColor* granite_drawing_color_set_hue (GraniteDrawingColor* self,
                                                    gdouble hue);
static void granite_drawing_color_rgb_to_hsv (GraniteDrawingColor* self,
                                       gdouble r,
                                       gdouble g,
                                       gdouble b,
                                       gdouble* h,
                                       gdouble* s,
                                       gdouble* v);
static void granite_drawing_color_hsv_to_rgb (GraniteDrawingColor* self,
                                       gdouble h,
                                       gdouble s,
                                       gdouble v,
                                       gdouble* r,
                                       gdouble* g,
                                       gdouble* b);
GraniteDrawingColor* granite_drawing_color_set_sat (GraniteDrawingColor* self,
                                                    gdouble sat);
GraniteDrawingColor* granite_drawing_color_set_val (GraniteDrawingColor* self,
                                                    gdouble val);
GraniteDrawingColor* granite_drawing_color_set_alpha (GraniteDrawingColor* self,
                                                      gdouble alpha);
gdouble granite_drawing_color_get_hue (GraniteDrawingColor* self);
gdouble granite_drawing_color_get_sat (GraniteDrawingColor* self);
gdouble granite_drawing_color_get_val (GraniteDrawingColor* self);
GraniteDrawingColor* granite_drawing_color_add_hue (GraniteDrawingColor* self,
                                                    gdouble val);
GraniteDrawingColor* granite_drawing_color_set_min_sat (GraniteDrawingColor* self,
                                                        gdouble sat);
GraniteDrawingColor* granite_drawing_color_set_min_value (GraniteDrawingColor* self,
                                                          gdouble val);
GraniteDrawingColor* granite_drawing_color_set_max_sat (GraniteDrawingColor* self,
                                                        gdouble sat);
GraniteDrawingColor* granite_drawing_color_set_max_val (GraniteDrawingColor* self,
                                                        gdouble val);
GraniteDrawingColor* granite_drawing_color_multiply_sat (GraniteDrawingColor* self,
                                                         gdouble amount);
GraniteDrawingColor* granite_drawing_color_brighten_val (GraniteDrawingColor* self,
                                                         gdouble amount);
GraniteDrawingColor* granite_drawing_color_darken_val (GraniteDrawingColor* self,
                                                       gdouble amount);
GraniteDrawingColor* granite_drawing_color_darken_by_sat (GraniteDrawingColor* self,
                                                          gdouble amount);
static gchar* granite_drawing_color_real_settings_serialize (GraniteServicesSettingsSerializable* base);
static void granite_drawing_color_real_settings_deserialize (GraniteServicesSettingsSerializable* base,
                                                      const gchar* s);
gchar* granite_drawing_color_to_string (GraniteDrawingColor* self);
gint granite_drawing_color_to_int (GraniteDrawingColor* self);
static void granite_drawing_color_finalize (GObject * obj);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


/**
         * Extracts the alpha value from the integer value
         * serialized by {@link Granite.Drawing.Color.to_int}.
         * 
         * @return the alpha channel value as a uint8 ranging from 0 - 255.
         */
guint8
granite_drawing_color_alpha_from_int (gint color)
{
	guint8 result = 0U;
#line 55 "../lib/Drawing/Color.vala"
	result = (guint8) ((color >> 24) & 0xFF);
#line 55 "../lib/Drawing/Color.vala"
	return result;
#line 186 "Color.c"
}


/**
         * Extracts the red value from the integer value
         * serialized by {@link Granite.Drawing.Color.to_int}.
         * 
         * @return the red channel value as a uint8 ranging from 0 - 255.
         */
guint8
granite_drawing_color_red_from_int (gint color)
{
	guint8 result = 0U;
#line 65 "../lib/Drawing/Color.vala"
	result = (guint8) ((color >> 16) & 0xFF);
#line 65 "../lib/Drawing/Color.vala"
	return result;
#line 204 "Color.c"
}


/**
         * Extracts the green value from the integer value
         * serialized by {@link Granite.Drawing.Color.to_int}.
         * 
         * @return the green channel value as a uint8 ranging from 0 - 255.
         */
guint8
granite_drawing_color_green_from_int (gint color)
{
	guint8 result = 0U;
#line 75 "../lib/Drawing/Color.vala"
	result = (guint8) ((color >> 8) & 0xFF);
#line 75 "../lib/Drawing/Color.vala"
	return result;
#line 222 "Color.c"
}


/**
         * Extracts the blue value from the integer value
         * serialized by {@link Granite.Drawing.Color.to_int}.
         * 
         * @return the blue channel value as a uint8 ranging from 0 - 255.
         */
guint8
granite_drawing_color_blue_from_int (gint color)
{
	guint8 result = 0U;
#line 85 "../lib/Drawing/Color.vala"
	result = (guint8) (color & 0xFF);
#line 85 "../lib/Drawing/Color.vala"
	return result;
#line 240 "Color.c"
}


/**
         * Constructs a new {@link Granite.Drawing.Color} with the supplied values.
         *
         * @param R the value of the red channel as a double
         * @param G the value of the green channel as a double
         * @param B the value of the blue channel as a double
         * @param A the value of the alpha channel as a double
         */
GraniteDrawingColor*
granite_drawing_color_construct (GType object_type,
                                 gdouble R,
                                 gdouble G,
                                 gdouble B,
                                 gdouble A)
{
	GraniteDrawingColor * self = NULL;
#line 96 "../lib/Drawing/Color.vala"
	self = (GraniteDrawingColor*) g_object_new (object_type, NULL);
#line 98 "../lib/Drawing/Color.vala"
	self->R = R;
#line 99 "../lib/Drawing/Color.vala"
	self->G = G;
#line 100 "../lib/Drawing/Color.vala"
	self->B = B;
#line 101 "../lib/Drawing/Color.vala"
	self->A = A;
#line 96 "../lib/Drawing/Color.vala"
	return self;
#line 272 "Color.c"
}


GraniteDrawingColor*
granite_drawing_color_new (gdouble R,
                           gdouble G,
                           gdouble B,
                           gdouble A)
{
#line 96 "../lib/Drawing/Color.vala"
	return granite_drawing_color_construct (GRANITE_DRAWING_TYPE_COLOR, R, G, B, A);
#line 284 "Color.c"
}


/**
         * Constructs a new {@link Granite.Drawing.Color} from a {@link Gdk.Color}.
         *
         * @param color the {@link Gdk.Color}
         */
GraniteDrawingColor*
granite_drawing_color_construct_from_gdk (GType object_type,
                                          GdkColor* color)
{
	GraniteDrawingColor * self = NULL;
	GdkColor _tmp0_;
	guint16 _tmp1_;
	GdkColor _tmp2_;
	guint16 _tmp3_;
	GdkColor _tmp4_;
	guint16 _tmp5_;
#line 109 "../lib/Drawing/Color.vala"
	g_return_val_if_fail (color != NULL, NULL);
#line 109 "../lib/Drawing/Color.vala"
	self = (GraniteDrawingColor*) g_object_new (object_type, NULL);
#line 111 "../lib/Drawing/Color.vala"
	_tmp0_ = *color;
#line 111 "../lib/Drawing/Color.vala"
	_tmp1_ = _tmp0_.red;
#line 111 "../lib/Drawing/Color.vala"
	self->R = _tmp1_ / ((gdouble) G_MAXUINT16);
#line 112 "../lib/Drawing/Color.vala"
	_tmp2_ = *color;
#line 112 "../lib/Drawing/Color.vala"
	_tmp3_ = _tmp2_.green;
#line 112 "../lib/Drawing/Color.vala"
	self->G = _tmp3_ / ((gdouble) G_MAXUINT16);
#line 113 "../lib/Drawing/Color.vala"
	_tmp4_ = *color;
#line 113 "../lib/Drawing/Color.vala"
	_tmp5_ = _tmp4_.blue;
#line 113 "../lib/Drawing/Color.vala"
	self->B = _tmp5_ / ((gdouble) G_MAXUINT16);
#line 114 "../lib/Drawing/Color.vala"
	self->A = 1.0;
#line 109 "../lib/Drawing/Color.vala"
	return self;
#line 330 "Color.c"
}


GraniteDrawingColor*
granite_drawing_color_new_from_gdk (GdkColor* color)
{
#line 109 "../lib/Drawing/Color.vala"
	return granite_drawing_color_construct_from_gdk (GRANITE_DRAWING_TYPE_COLOR, color);
#line 339 "Color.c"
}


/**
         * Constructs a new {@link Granite.Drawing.Color} from a {@link Gdk.RGBA}.
         *
         * @param color the {@link Gdk.RGBA}
         */
GraniteDrawingColor*
granite_drawing_color_construct_from_rgba (GType object_type,
                                           GdkRGBA* color)
{
	GraniteDrawingColor * self = NULL;
	GdkRGBA _tmp0_;
#line 122 "../lib/Drawing/Color.vala"
	g_return_val_if_fail (color != NULL, NULL);
#line 122 "../lib/Drawing/Color.vala"
	self = (GraniteDrawingColor*) g_object_new (object_type, NULL);
#line 123 "../lib/Drawing/Color.vala"
	_tmp0_ = *color;
#line 123 "../lib/Drawing/Color.vala"
	granite_drawing_color_set_from_rgba (self, &_tmp0_);
#line 122 "../lib/Drawing/Color.vala"
	return self;
#line 364 "Color.c"
}


GraniteDrawingColor*
granite_drawing_color_new_from_rgba (GdkRGBA* color)
{
#line 122 "../lib/Drawing/Color.vala"
	return granite_drawing_color_construct_from_rgba (GRANITE_DRAWING_TYPE_COLOR, color);
#line 373 "Color.c"
}


/**
         * Constructs a new {@link Granite.Drawing.Color} from a string.
         *
         * The string can be either one of:
         *
         * * A standard name (Taken from the X11 rgb.txt file).
         * * A hexadecimal value in the form “#rgb”, “#rrggbb”, “#rrrgggbbb” or ”#rrrrggggbbbb”
         * * A RGB color in the form “rgb(r,g,b)” (In this case the color will have full opacity)
         * * A RGBA color in the form “rgba(r,g,b,a)”
         *
         * For more details on formatting and how this function works see {@link Gdk.RGBA.parse}
         *
         * @param color the string specifying the color
         */
GraniteDrawingColor*
granite_drawing_color_construct_from_string (GType object_type,
                                             const gchar* color)
{
	GraniteDrawingColor * self = NULL;
	GdkRGBA rgba = {0};
	GdkRGBA _tmp0_;
#line 140 "../lib/Drawing/Color.vala"
	g_return_val_if_fail (color != NULL, NULL);
#line 140 "../lib/Drawing/Color.vala"
	self = (GraniteDrawingColor*) g_object_new (object_type, NULL);
#line 141 "../lib/Drawing/Color.vala"
	memset (&rgba, 0, sizeof (GdkRGBA));
#line 142 "../lib/Drawing/Color.vala"
	gdk_rgba_parse (&rgba, color);
#line 143 "../lib/Drawing/Color.vala"
	_tmp0_ = rgba;
#line 143 "../lib/Drawing/Color.vala"
	granite_drawing_color_set_from_rgba (self, &_tmp0_);
#line 140 "../lib/Drawing/Color.vala"
	return self;
#line 412 "Color.c"
}


GraniteDrawingColor*
granite_drawing_color_new_from_string (const gchar* color)
{
#line 140 "../lib/Drawing/Color.vala"
	return granite_drawing_color_construct_from_string (GRANITE_DRAWING_TYPE_COLOR, color);
#line 421 "Color.c"
}


/**
         * Constructs a new {@link Granite.Drawing.Color} from an integer.
         * 
         * This constructor should be used when deserializing the previously serialized
         * color by {@link Granite.Drawing.Color.to_int}.
         * 
         * For more details on what format the color integer representation has, see {@link Granite.Drawing.Color.to_int}.
         * 
         * If you would like to deserialize the A, R, G and B values from the integer without
         * creating a new instance of {@link Granite.Drawing.Color}, you can use the available
         * //*_from_int// static method collection such as {@link Granite.Drawing.Color.alpha_from_int}.
         * 
         * @param color the integer specyfying the color
         */
GraniteDrawingColor*
granite_drawing_color_construct_from_int (GType object_type,
                                          gint color)
{
	GraniteDrawingColor * self = NULL;
#line 160 "../lib/Drawing/Color.vala"
	self = (GraniteDrawingColor*) g_object_new (object_type, NULL);
#line 161 "../lib/Drawing/Color.vala"
	self->R = ((gdouble) granite_drawing_color_red_from_int (color)) / ((gdouble) G_MAXUINT8);
#line 162 "../lib/Drawing/Color.vala"
	self->G = ((gdouble) granite_drawing_color_green_from_int (color)) / ((gdouble) G_MAXUINT8);
#line 163 "../lib/Drawing/Color.vala"
	self->B = ((gdouble) granite_drawing_color_blue_from_int (color)) / ((gdouble) G_MAXUINT8);
#line 164 "../lib/Drawing/Color.vala"
	self->A = ((gdouble) granite_drawing_color_alpha_from_int (color)) / ((gdouble) G_MAXUINT8);
#line 160 "../lib/Drawing/Color.vala"
	return self;
#line 456 "Color.c"
}


GraniteDrawingColor*
granite_drawing_color_new_from_int (gint color)
{
#line 160 "../lib/Drawing/Color.vala"
	return granite_drawing_color_construct_from_int (GRANITE_DRAWING_TYPE_COLOR, color);
#line 465 "Color.c"
}


/**
         * Changes the hue of this color to the supplied one.
         *
         * @param hue the hue to change this color to
         *
         * @return the new {@link Granite.Drawing.Color}
         */
static gpointer
_g_object_ref0 (gpointer self)
{
#line 181 "../lib/Drawing/Color.vala"
	return self ? g_object_ref (self) : NULL;
#line 481 "Color.c"
}


GraniteDrawingColor*
granite_drawing_color_set_hue (GraniteDrawingColor* self,
                               gdouble hue)
{
	GraniteDrawingColor* result = NULL;
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_;
	gdouble _tmp7_ = 0.0;
	gdouble _tmp8_ = 0.0;
	gdouble _tmp9_ = 0.0;
	GraniteDrawingColor* _tmp10_;
#line 174 "../lib/Drawing/Color.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 174 "../lib/Drawing/Color.vala"
	_vala_return_val_if_fail ((hue >= ((gdouble) 0)) && (hue <= ((gdouble) 360)), "hue >= 0 && hue <= 360", NULL);
#line 177 "../lib/Drawing/Color.vala"
	_tmp0_ = self->R;
#line 177 "../lib/Drawing/Color.vala"
	_tmp1_ = self->G;
#line 177 "../lib/Drawing/Color.vala"
	_tmp2_ = self->B;
#line 177 "../lib/Drawing/Color.vala"
	granite_drawing_color_rgb_to_hsv (self, _tmp0_, _tmp1_, _tmp2_, &_tmp3_, &_tmp4_, &_tmp5_);
#line 177 "../lib/Drawing/Color.vala"
	h = _tmp3_;
#line 177 "../lib/Drawing/Color.vala"
	s = _tmp4_;
#line 177 "../lib/Drawing/Color.vala"
	v = _tmp5_;
#line 178 "../lib/Drawing/Color.vala"
	h = hue;
#line 179 "../lib/Drawing/Color.vala"
	_tmp6_ = h;
#line 179 "../lib/Drawing/Color.vala"
	granite_drawing_color_hsv_to_rgb (self, _tmp6_, s, v, &_tmp7_, &_tmp8_, &_tmp9_);
#line 179 "../lib/Drawing/Color.vala"
	self->R = _tmp7_;
#line 179 "../lib/Drawing/Color.vala"
	self->G = _tmp8_;
#line 179 "../lib/Drawing/Color.vala"
	self->B = _tmp9_;
#line 181 "../lib/Drawing/Color.vala"
	_tmp10_ = _g_object_ref0 (self);
#line 181 "../lib/Drawing/Color.vala"
	result = _tmp10_;
#line 181 "../lib/Drawing/Color.vala"
	return result;
#line 540 "Color.c"
}


/**
         * Changes the saturation of this color to the supplied one.
         *
         * @param sat the saturation to change this color to
         *
         * @return the new {@link Granite.Drawing.Color}
         */
GraniteDrawingColor*
granite_drawing_color_set_sat (GraniteDrawingColor* self,
                               gdouble sat)
{
	GraniteDrawingColor* result = NULL;
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_;
	gdouble _tmp7_ = 0.0;
	gdouble _tmp8_ = 0.0;
	gdouble _tmp9_ = 0.0;
	GraniteDrawingColor* _tmp10_;
#line 191 "../lib/Drawing/Color.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 191 "../lib/Drawing/Color.vala"
	_vala_return_val_if_fail ((sat >= ((gdouble) 0)) && (sat <= ((gdouble) 1)), "sat >= 0 && sat <= 1", NULL);
#line 194 "../lib/Drawing/Color.vala"
	_tmp0_ = self->R;
#line 194 "../lib/Drawing/Color.vala"
	_tmp1_ = self->G;
#line 194 "../lib/Drawing/Color.vala"
	_tmp2_ = self->B;
#line 194 "../lib/Drawing/Color.vala"
	granite_drawing_color_rgb_to_hsv (self, _tmp0_, _tmp1_, _tmp2_, &_tmp3_, &_tmp4_, &_tmp5_);
#line 194 "../lib/Drawing/Color.vala"
	h = _tmp3_;
#line 194 "../lib/Drawing/Color.vala"
	s = _tmp4_;
#line 194 "../lib/Drawing/Color.vala"
	v = _tmp5_;
#line 195 "../lib/Drawing/Color.vala"
	s = sat;
#line 196 "../lib/Drawing/Color.vala"
	_tmp6_ = s;
#line 196 "../lib/Drawing/Color.vala"
	granite_drawing_color_hsv_to_rgb (self, h, _tmp6_, v, &_tmp7_, &_tmp8_, &_tmp9_);
#line 196 "../lib/Drawing/Color.vala"
	self->R = _tmp7_;
#line 196 "../lib/Drawing/Color.vala"
	self->G = _tmp8_;
#line 196 "../lib/Drawing/Color.vala"
	self->B = _tmp9_;
#line 198 "../lib/Drawing/Color.vala"
	_tmp10_ = _g_object_ref0 (self);
#line 198 "../lib/Drawing/Color.vala"
	result = _tmp10_;
#line 198 "../lib/Drawing/Color.vala"
	return result;
#line 606 "Color.c"
}


/**
         * Changes the value of this color to the supplied one.
         *
         * @param val the value to change this color to
         *
         * @return the new {@link Granite.Drawing.Color}
         */
GraniteDrawingColor*
granite_drawing_color_set_val (GraniteDrawingColor* self,
                               gdouble val)
{
	GraniteDrawingColor* result = NULL;
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_;
	gdouble _tmp7_ = 0.0;
	gdouble _tmp8_ = 0.0;
	gdouble _tmp9_ = 0.0;
	GraniteDrawingColor* _tmp10_;
#line 208 "../lib/Drawing/Color.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 208 "../lib/Drawing/Color.vala"
	_vala_return_val_if_fail ((val >= ((gdouble) 0)) && (val <= ((gdouble) 1)), "val >= 0 && val <= 1", NULL);
#line 211 "../lib/Drawing/Color.vala"
	_tmp0_ = self->R;
#line 211 "../lib/Drawing/Color.vala"
	_tmp1_ = self->G;
#line 211 "../lib/Drawing/Color.vala"
	_tmp2_ = self->B;
#line 211 "../lib/Drawing/Color.vala"
	granite_drawing_color_rgb_to_hsv (self, _tmp0_, _tmp1_, _tmp2_, &_tmp3_, &_tmp4_, &_tmp5_);
#line 211 "../lib/Drawing/Color.vala"
	h = _tmp3_;
#line 211 "../lib/Drawing/Color.vala"
	s = _tmp4_;
#line 211 "../lib/Drawing/Color.vala"
	v = _tmp5_;
#line 212 "../lib/Drawing/Color.vala"
	v = val;
#line 213 "../lib/Drawing/Color.vala"
	_tmp6_ = v;
#line 213 "../lib/Drawing/Color.vala"
	granite_drawing_color_hsv_to_rgb (self, h, s, _tmp6_, &_tmp7_, &_tmp8_, &_tmp9_);
#line 213 "../lib/Drawing/Color.vala"
	self->R = _tmp7_;
#line 213 "../lib/Drawing/Color.vala"
	self->G = _tmp8_;
#line 213 "../lib/Drawing/Color.vala"
	self->B = _tmp9_;
#line 215 "../lib/Drawing/Color.vala"
	_tmp10_ = _g_object_ref0 (self);
#line 215 "../lib/Drawing/Color.vala"
	result = _tmp10_;
#line 215 "../lib/Drawing/Color.vala"
	return result;
#line 672 "Color.c"
}


/**
         * Changes the value of the alpha channel.
         *
         * @param alpha the value of the alpha channel
         *
         * @return the new {@link Granite.Drawing.Color}
         */
GraniteDrawingColor*
granite_drawing_color_set_alpha (GraniteDrawingColor* self,
                                 gdouble alpha)
{
	GraniteDrawingColor* result = NULL;
	GraniteDrawingColor* _tmp0_;
#line 225 "../lib/Drawing/Color.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 225 "../lib/Drawing/Color.vala"
	_vala_return_val_if_fail ((alpha >= ((gdouble) 0)) && (alpha <= ((gdouble) 1)), "alpha >= 0 && alpha <= 1", NULL);
#line 227 "../lib/Drawing/Color.vala"
	self->A = alpha;
#line 228 "../lib/Drawing/Color.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 228 "../lib/Drawing/Color.vala"
	result = _tmp0_;
#line 228 "../lib/Drawing/Color.vala"
	return result;
#line 701 "Color.c"
}


/**
         * Get the value.
         * @return the hue of this color, as a double value
         */
gdouble
granite_drawing_color_get_hue (GraniteDrawingColor* self)
{
	gdouble result = 0.0;
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
#line 235 "../lib/Drawing/Color.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 238 "../lib/Drawing/Color.vala"
	_tmp0_ = self->R;
#line 238 "../lib/Drawing/Color.vala"
	_tmp1_ = self->G;
#line 238 "../lib/Drawing/Color.vala"
	_tmp2_ = self->B;
#line 238 "../lib/Drawing/Color.vala"
	granite_drawing_color_rgb_to_hsv (self, _tmp0_, _tmp1_, _tmp2_, &_tmp3_, &_tmp4_, &_tmp5_);
#line 238 "../lib/Drawing/Color.vala"
	h = _tmp3_;
#line 238 "../lib/Drawing/Color.vala"
	s = _tmp4_;
#line 238 "../lib/Drawing/Color.vala"
	v = _tmp5_;
#line 239 "../lib/Drawing/Color.vala"
	result = h;
#line 239 "../lib/Drawing/Color.vala"
	return result;
#line 742 "Color.c"
}


/**
         * Get the value.
         * @return the saturation of this color, as a double value
         */
gdouble
granite_drawing_color_get_sat (GraniteDrawingColor* self)
{
	gdouble result = 0.0;
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
#line 246 "../lib/Drawing/Color.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 249 "../lib/Drawing/Color.vala"
	_tmp0_ = self->R;
#line 249 "../lib/Drawing/Color.vala"
	_tmp1_ = self->G;
#line 249 "../lib/Drawing/Color.vala"
	_tmp2_ = self->B;
#line 249 "../lib/Drawing/Color.vala"
	granite_drawing_color_rgb_to_hsv (self, _tmp0_, _tmp1_, _tmp2_, &_tmp3_, &_tmp4_, &_tmp5_);
#line 249 "../lib/Drawing/Color.vala"
	h = _tmp3_;
#line 249 "../lib/Drawing/Color.vala"
	s = _tmp4_;
#line 249 "../lib/Drawing/Color.vala"
	v = _tmp5_;
#line 250 "../lib/Drawing/Color.vala"
	result = s;
#line 250 "../lib/Drawing/Color.vala"
	return result;
#line 783 "Color.c"
}


/**
         * Get the value.
         *
         * @return the value of this color, as a double value
         */
gdouble
granite_drawing_color_get_val (GraniteDrawingColor* self)
{
	gdouble result = 0.0;
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
#line 258 "../lib/Drawing/Color.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 261 "../lib/Drawing/Color.vala"
	_tmp0_ = self->R;
#line 261 "../lib/Drawing/Color.vala"
	_tmp1_ = self->G;
#line 261 "../lib/Drawing/Color.vala"
	_tmp2_ = self->B;
#line 261 "../lib/Drawing/Color.vala"
	granite_drawing_color_rgb_to_hsv (self, _tmp0_, _tmp1_, _tmp2_, &_tmp3_, &_tmp4_, &_tmp5_);
#line 261 "../lib/Drawing/Color.vala"
	h = _tmp3_;
#line 261 "../lib/Drawing/Color.vala"
	s = _tmp4_;
#line 261 "../lib/Drawing/Color.vala"
	v = _tmp5_;
#line 262 "../lib/Drawing/Color.vala"
	result = v;
#line 262 "../lib/Drawing/Color.vala"
	return result;
#line 825 "Color.c"
}


/**
         * Adds the supplied hue value to this color's hue value.
         *
         * @param val the hue to add to this color's hue
         *
         * @return the new {@link Granite.Drawing.Color}
         */
GraniteDrawingColor*
granite_drawing_color_add_hue (GraniteDrawingColor* self,
                               gdouble val)
{
	GraniteDrawingColor* result = NULL;
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_;
	gdouble _tmp7_;
	gdouble _tmp8_ = 0.0;
	gdouble _tmp9_ = 0.0;
	gdouble _tmp10_ = 0.0;
	GraniteDrawingColor* _tmp11_;
#line 272 "../lib/Drawing/Color.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 275 "../lib/Drawing/Color.vala"
	_tmp0_ = self->R;
#line 275 "../lib/Drawing/Color.vala"
	_tmp1_ = self->G;
#line 275 "../lib/Drawing/Color.vala"
	_tmp2_ = self->B;
#line 275 "../lib/Drawing/Color.vala"
	granite_drawing_color_rgb_to_hsv (self, _tmp0_, _tmp1_, _tmp2_, &_tmp3_, &_tmp4_, &_tmp5_);
#line 275 "../lib/Drawing/Color.vala"
	h = _tmp3_;
#line 275 "../lib/Drawing/Color.vala"
	s = _tmp4_;
#line 275 "../lib/Drawing/Color.vala"
	v = _tmp5_;
#line 276 "../lib/Drawing/Color.vala"
	_tmp6_ = h;
#line 276 "../lib/Drawing/Color.vala"
	h = fmod (fmod (_tmp6_ + val, 360) + 360, 360);
#line 277 "../lib/Drawing/Color.vala"
	_tmp7_ = h;
#line 277 "../lib/Drawing/Color.vala"
	granite_drawing_color_hsv_to_rgb (self, _tmp7_, s, v, &_tmp8_, &_tmp9_, &_tmp10_);
#line 277 "../lib/Drawing/Color.vala"
	self->R = _tmp8_;
#line 277 "../lib/Drawing/Color.vala"
	self->G = _tmp9_;
#line 277 "../lib/Drawing/Color.vala"
	self->B = _tmp10_;
#line 279 "../lib/Drawing/Color.vala"
	_tmp11_ = _g_object_ref0 (self);
#line 279 "../lib/Drawing/Color.vala"
	result = _tmp11_;
#line 279 "../lib/Drawing/Color.vala"
	return result;
#line 892 "Color.c"
}


/**
         * Changes this color's saturation to the supplied saturation, if it is greater than this color's saturation.
         *
         * @param sat the saturation to change this color to
         *
         * @return the new {@link Granite.Drawing.Color}
         */
GraniteDrawingColor*
granite_drawing_color_set_min_sat (GraniteDrawingColor* self,
                                   gdouble sat)
{
	GraniteDrawingColor* result = NULL;
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_;
	gdouble _tmp7_;
	gdouble _tmp8_ = 0.0;
	gdouble _tmp9_ = 0.0;
	gdouble _tmp10_ = 0.0;
	GraniteDrawingColor* _tmp11_;
#line 289 "../lib/Drawing/Color.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 289 "../lib/Drawing/Color.vala"
	_vala_return_val_if_fail ((sat >= ((gdouble) 0)) && (sat <= ((gdouble) 1)), "sat >= 0 && sat <= 1", NULL);
#line 292 "../lib/Drawing/Color.vala"
	_tmp0_ = self->R;
#line 292 "../lib/Drawing/Color.vala"
	_tmp1_ = self->G;
#line 292 "../lib/Drawing/Color.vala"
	_tmp2_ = self->B;
#line 292 "../lib/Drawing/Color.vala"
	granite_drawing_color_rgb_to_hsv (self, _tmp0_, _tmp1_, _tmp2_, &_tmp3_, &_tmp4_, &_tmp5_);
#line 292 "../lib/Drawing/Color.vala"
	h = _tmp3_;
#line 292 "../lib/Drawing/Color.vala"
	s = _tmp4_;
#line 292 "../lib/Drawing/Color.vala"
	v = _tmp5_;
#line 293 "../lib/Drawing/Color.vala"
	_tmp6_ = s;
#line 293 "../lib/Drawing/Color.vala"
	s = MAX (_tmp6_, sat);
#line 294 "../lib/Drawing/Color.vala"
	_tmp7_ = s;
#line 294 "../lib/Drawing/Color.vala"
	granite_drawing_color_hsv_to_rgb (self, h, _tmp7_, v, &_tmp8_, &_tmp9_, &_tmp10_);
#line 294 "../lib/Drawing/Color.vala"
	self->R = _tmp8_;
#line 294 "../lib/Drawing/Color.vala"
	self->G = _tmp9_;
#line 294 "../lib/Drawing/Color.vala"
	self->B = _tmp10_;
#line 296 "../lib/Drawing/Color.vala"
	_tmp11_ = _g_object_ref0 (self);
#line 296 "../lib/Drawing/Color.vala"
	result = _tmp11_;
#line 296 "../lib/Drawing/Color.vala"
	return result;
#line 961 "Color.c"
}


/**
         * Changes this color's value to the supplied value, if it is greater than this color's value.
         *
         * @param val the value to change this color to
         *
         * @return the new {@link Granite.Drawing.Color}
         */
GraniteDrawingColor*
granite_drawing_color_set_min_value (GraniteDrawingColor* self,
                                     gdouble val)
{
	GraniteDrawingColor* result = NULL;
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_;
	gdouble _tmp7_;
	gdouble _tmp8_ = 0.0;
	gdouble _tmp9_ = 0.0;
	gdouble _tmp10_ = 0.0;
	GraniteDrawingColor* _tmp11_;
#line 306 "../lib/Drawing/Color.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 306 "../lib/Drawing/Color.vala"
	_vala_return_val_if_fail ((val >= ((gdouble) 0)) && (val <= ((gdouble) 1)), "val >= 0 && val <= 1", NULL);
#line 309 "../lib/Drawing/Color.vala"
	_tmp0_ = self->R;
#line 309 "../lib/Drawing/Color.vala"
	_tmp1_ = self->G;
#line 309 "../lib/Drawing/Color.vala"
	_tmp2_ = self->B;
#line 309 "../lib/Drawing/Color.vala"
	granite_drawing_color_rgb_to_hsv (self, _tmp0_, _tmp1_, _tmp2_, &_tmp3_, &_tmp4_, &_tmp5_);
#line 309 "../lib/Drawing/Color.vala"
	h = _tmp3_;
#line 309 "../lib/Drawing/Color.vala"
	s = _tmp4_;
#line 309 "../lib/Drawing/Color.vala"
	v = _tmp5_;
#line 310 "../lib/Drawing/Color.vala"
	_tmp6_ = v;
#line 310 "../lib/Drawing/Color.vala"
	v = MAX (_tmp6_, val);
#line 311 "../lib/Drawing/Color.vala"
	_tmp7_ = v;
#line 311 "../lib/Drawing/Color.vala"
	granite_drawing_color_hsv_to_rgb (self, h, s, _tmp7_, &_tmp8_, &_tmp9_, &_tmp10_);
#line 311 "../lib/Drawing/Color.vala"
	self->R = _tmp8_;
#line 311 "../lib/Drawing/Color.vala"
	self->G = _tmp9_;
#line 311 "../lib/Drawing/Color.vala"
	self->B = _tmp10_;
#line 313 "../lib/Drawing/Color.vala"
	_tmp11_ = _g_object_ref0 (self);
#line 313 "../lib/Drawing/Color.vala"
	result = _tmp11_;
#line 313 "../lib/Drawing/Color.vala"
	return result;
#line 1030 "Color.c"
}


/**
         * Changes this color's saturation to the supplied saturation, if it is smaller than this color's saturation.
         *
         * @param sat the hue to change this color to
         *
         * @return the new {@link Granite.Drawing.Color}
         */
GraniteDrawingColor*
granite_drawing_color_set_max_sat (GraniteDrawingColor* self,
                                   gdouble sat)
{
	GraniteDrawingColor* result = NULL;
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_;
	gdouble _tmp7_;
	gdouble _tmp8_ = 0.0;
	gdouble _tmp9_ = 0.0;
	gdouble _tmp10_ = 0.0;
	GraniteDrawingColor* _tmp11_;
#line 323 "../lib/Drawing/Color.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 323 "../lib/Drawing/Color.vala"
	_vala_return_val_if_fail ((sat >= ((gdouble) 0)) && (sat <= ((gdouble) 1)), "sat >= 0 && sat <= 1", NULL);
#line 326 "../lib/Drawing/Color.vala"
	_tmp0_ = self->R;
#line 326 "../lib/Drawing/Color.vala"
	_tmp1_ = self->G;
#line 326 "../lib/Drawing/Color.vala"
	_tmp2_ = self->B;
#line 326 "../lib/Drawing/Color.vala"
	granite_drawing_color_rgb_to_hsv (self, _tmp0_, _tmp1_, _tmp2_, &_tmp3_, &_tmp4_, &_tmp5_);
#line 326 "../lib/Drawing/Color.vala"
	h = _tmp3_;
#line 326 "../lib/Drawing/Color.vala"
	s = _tmp4_;
#line 326 "../lib/Drawing/Color.vala"
	v = _tmp5_;
#line 327 "../lib/Drawing/Color.vala"
	_tmp6_ = s;
#line 327 "../lib/Drawing/Color.vala"
	s = MIN (_tmp6_, sat);
#line 328 "../lib/Drawing/Color.vala"
	_tmp7_ = s;
#line 328 "../lib/Drawing/Color.vala"
	granite_drawing_color_hsv_to_rgb (self, h, _tmp7_, v, &_tmp8_, &_tmp9_, &_tmp10_);
#line 328 "../lib/Drawing/Color.vala"
	self->R = _tmp8_;
#line 328 "../lib/Drawing/Color.vala"
	self->G = _tmp9_;
#line 328 "../lib/Drawing/Color.vala"
	self->B = _tmp10_;
#line 330 "../lib/Drawing/Color.vala"
	_tmp11_ = _g_object_ref0 (self);
#line 330 "../lib/Drawing/Color.vala"
	result = _tmp11_;
#line 330 "../lib/Drawing/Color.vala"
	return result;
#line 1099 "Color.c"
}


/**
         * Changes this color's value to the supplied value, if it is smaller than this color's value.
         *
         * @param val the value to change this color to
         *
         * @return the new {@link Granite.Drawing.Color}
         */
GraniteDrawingColor*
granite_drawing_color_set_max_val (GraniteDrawingColor* self,
                                   gdouble val)
{
	GraniteDrawingColor* result = NULL;
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_;
	gdouble _tmp7_;
	gdouble _tmp8_ = 0.0;
	gdouble _tmp9_ = 0.0;
	gdouble _tmp10_ = 0.0;
	GraniteDrawingColor* _tmp11_;
#line 340 "../lib/Drawing/Color.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 340 "../lib/Drawing/Color.vala"
	_vala_return_val_if_fail ((val >= ((gdouble) 0)) && (val <= ((gdouble) 1)), "val >= 0 && val <= 1", NULL);
#line 343 "../lib/Drawing/Color.vala"
	_tmp0_ = self->R;
#line 343 "../lib/Drawing/Color.vala"
	_tmp1_ = self->G;
#line 343 "../lib/Drawing/Color.vala"
	_tmp2_ = self->B;
#line 343 "../lib/Drawing/Color.vala"
	granite_drawing_color_rgb_to_hsv (self, _tmp0_, _tmp1_, _tmp2_, &_tmp3_, &_tmp4_, &_tmp5_);
#line 343 "../lib/Drawing/Color.vala"
	h = _tmp3_;
#line 343 "../lib/Drawing/Color.vala"
	s = _tmp4_;
#line 343 "../lib/Drawing/Color.vala"
	v = _tmp5_;
#line 344 "../lib/Drawing/Color.vala"
	_tmp6_ = v;
#line 344 "../lib/Drawing/Color.vala"
	v = MIN (_tmp6_, val);
#line 345 "../lib/Drawing/Color.vala"
	_tmp7_ = v;
#line 345 "../lib/Drawing/Color.vala"
	granite_drawing_color_hsv_to_rgb (self, h, s, _tmp7_, &_tmp8_, &_tmp9_, &_tmp10_);
#line 345 "../lib/Drawing/Color.vala"
	self->R = _tmp8_;
#line 345 "../lib/Drawing/Color.vala"
	self->G = _tmp9_;
#line 345 "../lib/Drawing/Color.vala"
	self->B = _tmp10_;
#line 347 "../lib/Drawing/Color.vala"
	_tmp11_ = _g_object_ref0 (self);
#line 347 "../lib/Drawing/Color.vala"
	result = _tmp11_;
#line 347 "../lib/Drawing/Color.vala"
	return result;
#line 1168 "Color.c"
}


/**
         * Multiplies this color's saturation by the supplied amount.
         *
         * @param amount the amount to multiply the saturation by
         *
         * @return the new {@link Granite.Drawing.Color}
         */
GraniteDrawingColor*
granite_drawing_color_multiply_sat (GraniteDrawingColor* self,
                                    gdouble amount)
{
	GraniteDrawingColor* result = NULL;
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_;
	gdouble _tmp7_;
	gdouble _tmp8_ = 0.0;
	gdouble _tmp9_ = 0.0;
	gdouble _tmp10_ = 0.0;
	GraniteDrawingColor* _tmp11_;
#line 357 "../lib/Drawing/Color.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 357 "../lib/Drawing/Color.vala"
	_vala_return_val_if_fail (amount >= ((gdouble) 0), "amount >= 0", NULL);
#line 359 "../lib/Drawing/Color.vala"
	_tmp0_ = self->R;
#line 359 "../lib/Drawing/Color.vala"
	_tmp1_ = self->G;
#line 359 "../lib/Drawing/Color.vala"
	_tmp2_ = self->B;
#line 359 "../lib/Drawing/Color.vala"
	granite_drawing_color_rgb_to_hsv (self, _tmp0_, _tmp1_, _tmp2_, &_tmp3_, &_tmp4_, &_tmp5_);
#line 359 "../lib/Drawing/Color.vala"
	h = _tmp3_;
#line 359 "../lib/Drawing/Color.vala"
	s = _tmp4_;
#line 359 "../lib/Drawing/Color.vala"
	v = _tmp5_;
#line 360 "../lib/Drawing/Color.vala"
	_tmp6_ = s;
#line 360 "../lib/Drawing/Color.vala"
	s = MIN ((gdouble) 1, _tmp6_ * amount);
#line 361 "../lib/Drawing/Color.vala"
	_tmp7_ = s;
#line 361 "../lib/Drawing/Color.vala"
	granite_drawing_color_hsv_to_rgb (self, h, _tmp7_, v, &_tmp8_, &_tmp9_, &_tmp10_);
#line 361 "../lib/Drawing/Color.vala"
	self->R = _tmp8_;
#line 361 "../lib/Drawing/Color.vala"
	self->G = _tmp9_;
#line 361 "../lib/Drawing/Color.vala"
	self->B = _tmp10_;
#line 363 "../lib/Drawing/Color.vala"
	_tmp11_ = _g_object_ref0 (self);
#line 363 "../lib/Drawing/Color.vala"
	result = _tmp11_;
#line 363 "../lib/Drawing/Color.vala"
	return result;
#line 1237 "Color.c"
}


/**
         * Brightens this color's value by the supplied amount.
         *
         * @param amount the amount to brighten the value by
         *
         * @return the new {@link Granite.Drawing.Color}
         */
GraniteDrawingColor*
granite_drawing_color_brighten_val (GraniteDrawingColor* self,
                                    gdouble amount)
{
	GraniteDrawingColor* result = NULL;
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_;
	gdouble _tmp7_;
	gdouble _tmp8_;
	gdouble _tmp9_ = 0.0;
	gdouble _tmp10_ = 0.0;
	gdouble _tmp11_ = 0.0;
	GraniteDrawingColor* _tmp12_;
#line 373 "../lib/Drawing/Color.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 373 "../lib/Drawing/Color.vala"
	_vala_return_val_if_fail ((amount >= ((gdouble) 0)) && (amount <= ((gdouble) 1)), "amount >= 0 && amount <= 1", NULL);
#line 376 "../lib/Drawing/Color.vala"
	_tmp0_ = self->R;
#line 376 "../lib/Drawing/Color.vala"
	_tmp1_ = self->G;
#line 376 "../lib/Drawing/Color.vala"
	_tmp2_ = self->B;
#line 376 "../lib/Drawing/Color.vala"
	granite_drawing_color_rgb_to_hsv (self, _tmp0_, _tmp1_, _tmp2_, &_tmp3_, &_tmp4_, &_tmp5_);
#line 376 "../lib/Drawing/Color.vala"
	h = _tmp3_;
#line 376 "../lib/Drawing/Color.vala"
	s = _tmp4_;
#line 376 "../lib/Drawing/Color.vala"
	v = _tmp5_;
#line 377 "../lib/Drawing/Color.vala"
	_tmp6_ = v;
#line 377 "../lib/Drawing/Color.vala"
	_tmp7_ = v;
#line 377 "../lib/Drawing/Color.vala"
	v = MIN ((gdouble) 1, _tmp6_ + ((1 - _tmp7_) * amount));
#line 378 "../lib/Drawing/Color.vala"
	_tmp8_ = v;
#line 378 "../lib/Drawing/Color.vala"
	granite_drawing_color_hsv_to_rgb (self, h, s, _tmp8_, &_tmp9_, &_tmp10_, &_tmp11_);
#line 378 "../lib/Drawing/Color.vala"
	self->R = _tmp9_;
#line 378 "../lib/Drawing/Color.vala"
	self->G = _tmp10_;
#line 378 "../lib/Drawing/Color.vala"
	self->B = _tmp11_;
#line 380 "../lib/Drawing/Color.vala"
	_tmp12_ = _g_object_ref0 (self);
#line 380 "../lib/Drawing/Color.vala"
	result = _tmp12_;
#line 380 "../lib/Drawing/Color.vala"
	return result;
#line 1309 "Color.c"
}


/**
         * Darkens this color's value by the supplied amount.
         *
         * @param amount the amount to darken the value by
         *
         * @return the new {@link Granite.Drawing.Color}
         */
GraniteDrawingColor*
granite_drawing_color_darken_val (GraniteDrawingColor* self,
                                  gdouble amount)
{
	GraniteDrawingColor* result = NULL;
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_;
	gdouble _tmp7_;
	gdouble _tmp8_;
	gdouble _tmp9_ = 0.0;
	gdouble _tmp10_ = 0.0;
	gdouble _tmp11_ = 0.0;
	GraniteDrawingColor* _tmp12_;
#line 390 "../lib/Drawing/Color.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 390 "../lib/Drawing/Color.vala"
	_vala_return_val_if_fail ((amount >= ((gdouble) 0)) && (amount <= ((gdouble) 1)), "amount >= 0 && amount <= 1", NULL);
#line 393 "../lib/Drawing/Color.vala"
	_tmp0_ = self->R;
#line 393 "../lib/Drawing/Color.vala"
	_tmp1_ = self->G;
#line 393 "../lib/Drawing/Color.vala"
	_tmp2_ = self->B;
#line 393 "../lib/Drawing/Color.vala"
	granite_drawing_color_rgb_to_hsv (self, _tmp0_, _tmp1_, _tmp2_, &_tmp3_, &_tmp4_, &_tmp5_);
#line 393 "../lib/Drawing/Color.vala"
	h = _tmp3_;
#line 393 "../lib/Drawing/Color.vala"
	s = _tmp4_;
#line 393 "../lib/Drawing/Color.vala"
	v = _tmp5_;
#line 394 "../lib/Drawing/Color.vala"
	_tmp6_ = v;
#line 394 "../lib/Drawing/Color.vala"
	_tmp7_ = v;
#line 394 "../lib/Drawing/Color.vala"
	v = MAX ((gdouble) 0, _tmp6_ - ((1 - _tmp7_) * amount));
#line 395 "../lib/Drawing/Color.vala"
	_tmp8_ = v;
#line 395 "../lib/Drawing/Color.vala"
	granite_drawing_color_hsv_to_rgb (self, h, s, _tmp8_, &_tmp9_, &_tmp10_, &_tmp11_);
#line 395 "../lib/Drawing/Color.vala"
	self->R = _tmp9_;
#line 395 "../lib/Drawing/Color.vala"
	self->G = _tmp10_;
#line 395 "../lib/Drawing/Color.vala"
	self->B = _tmp11_;
#line 397 "../lib/Drawing/Color.vala"
	_tmp12_ = _g_object_ref0 (self);
#line 397 "../lib/Drawing/Color.vala"
	result = _tmp12_;
#line 397 "../lib/Drawing/Color.vala"
	return result;
#line 1381 "Color.c"
}


/**
         * Darkens this color's value by the supplied amount * color's saturation.
         *
         * @param amount the amount to darken the value by
         *
         * @return the new {@link Granite.Drawing.Color}
         */
GraniteDrawingColor*
granite_drawing_color_darken_by_sat (GraniteDrawingColor* self,
                                     gdouble amount)
{
	GraniteDrawingColor* result = NULL;
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_;
	gdouble _tmp7_;
	gdouble _tmp8_ = 0.0;
	gdouble _tmp9_ = 0.0;
	gdouble _tmp10_ = 0.0;
	GraniteDrawingColor* _tmp11_;
#line 407 "../lib/Drawing/Color.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 407 "../lib/Drawing/Color.vala"
	_vala_return_val_if_fail ((amount >= ((gdouble) 0)) && (amount <= ((gdouble) 1)), "amount >= 0 && amount <= 1", NULL);
#line 410 "../lib/Drawing/Color.vala"
	_tmp0_ = self->R;
#line 410 "../lib/Drawing/Color.vala"
	_tmp1_ = self->G;
#line 410 "../lib/Drawing/Color.vala"
	_tmp2_ = self->B;
#line 410 "../lib/Drawing/Color.vala"
	granite_drawing_color_rgb_to_hsv (self, _tmp0_, _tmp1_, _tmp2_, &_tmp3_, &_tmp4_, &_tmp5_);
#line 410 "../lib/Drawing/Color.vala"
	h = _tmp3_;
#line 410 "../lib/Drawing/Color.vala"
	s = _tmp4_;
#line 410 "../lib/Drawing/Color.vala"
	v = _tmp5_;
#line 411 "../lib/Drawing/Color.vala"
	_tmp6_ = v;
#line 411 "../lib/Drawing/Color.vala"
	v = MAX ((gdouble) 0, _tmp6_ - (amount * s));
#line 412 "../lib/Drawing/Color.vala"
	_tmp7_ = v;
#line 412 "../lib/Drawing/Color.vala"
	granite_drawing_color_hsv_to_rgb (self, h, s, _tmp7_, &_tmp8_, &_tmp9_, &_tmp10_);
#line 412 "../lib/Drawing/Color.vala"
	self->R = _tmp8_;
#line 412 "../lib/Drawing/Color.vala"
	self->G = _tmp9_;
#line 412 "../lib/Drawing/Color.vala"
	self->B = _tmp10_;
#line 414 "../lib/Drawing/Color.vala"
	_tmp11_ = _g_object_ref0 (self);
#line 414 "../lib/Drawing/Color.vala"
	result = _tmp11_;
#line 414 "../lib/Drawing/Color.vala"
	return result;
#line 1450 "Color.c"
}


static void
granite_drawing_color_rgb_to_hsv (GraniteDrawingColor* self,
                                  gdouble r,
                                  gdouble g,
                                  gdouble b,
                                  gdouble* h,
                                  gdouble* s,
                                  gdouble* v)
{
	gdouble _vala_h = 0.0;
	gdouble _vala_s = 0.0;
	gdouble _vala_v = 0.0;
	gdouble min = 0.0;
	gdouble max = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	gdouble _tmp4_;
	gdouble delta = 0.0;
	gdouble _tmp5_;
	gdouble _tmp6_;
	gdouble _tmp7_;
	gdouble _tmp8_;
	gdouble _tmp9_;
	gdouble _tmp10_;
	gdouble _tmp11_;
	gdouble _tmp12_;
	gdouble _tmp13_;
	gdouble _tmp14_;
	gdouble _tmp15_;
#line 417 "../lib/Drawing/Color.vala"
	g_return_if_fail (self != NULL);
#line 417 "../lib/Drawing/Color.vala"
	_vala_return_if_fail ((r >= ((gdouble) 0)) && (r <= ((gdouble) 1)), "r >= 0 && r <= 1");
#line 417 "../lib/Drawing/Color.vala"
	_vala_return_if_fail ((g >= ((gdouble) 0)) && (g <= ((gdouble) 1)), "g >= 0 && g <= 1");
#line 417 "../lib/Drawing/Color.vala"
	_vala_return_if_fail ((b >= ((gdouble) 0)) && (b <= ((gdouble) 1)), "b >= 0 && b <= 1");
#line 422 "../lib/Drawing/Color.vala"
	min = MIN (r, MIN (g, b));
#line 423 "../lib/Drawing/Color.vala"
	max = MAX (r, MAX (g, b));
#line 425 "../lib/Drawing/Color.vala"
	_tmp0_ = max;
#line 425 "../lib/Drawing/Color.vala"
	_vala_v = _tmp0_;
#line 426 "../lib/Drawing/Color.vala"
	_tmp1_ = _vala_v;
#line 426 "../lib/Drawing/Color.vala"
	if (_tmp1_ == ((gdouble) 0)) {
#line 427 "../lib/Drawing/Color.vala"
		_vala_h = (gdouble) 0;
#line 428 "../lib/Drawing/Color.vala"
		_vala_s = (gdouble) 0;
#line 429 "../lib/Drawing/Color.vala"
		if (h) {
#line 429 "../lib/Drawing/Color.vala"
			*h = _vala_h;
#line 1513 "Color.c"
		}
#line 429 "../lib/Drawing/Color.vala"
		if (s) {
#line 429 "../lib/Drawing/Color.vala"
			*s = _vala_s;
#line 1519 "Color.c"
		}
#line 429 "../lib/Drawing/Color.vala"
		if (v) {
#line 429 "../lib/Drawing/Color.vala"
			*v = _vala_v;
#line 1525 "Color.c"
		}
#line 429 "../lib/Drawing/Color.vala"
		return;
#line 1529 "Color.c"
	}
#line 433 "../lib/Drawing/Color.vala"
	_tmp2_ = _vala_v;
#line 433 "../lib/Drawing/Color.vala"
	r = r / _tmp2_;
#line 434 "../lib/Drawing/Color.vala"
	_tmp3_ = _vala_v;
#line 434 "../lib/Drawing/Color.vala"
	g = g / _tmp3_;
#line 435 "../lib/Drawing/Color.vala"
	_tmp4_ = _vala_v;
#line 435 "../lib/Drawing/Color.vala"
	b = b / _tmp4_;
#line 437 "../lib/Drawing/Color.vala"
	min = MIN (r, MIN (g, b));
#line 438 "../lib/Drawing/Color.vala"
	max = MAX (r, MAX (g, b));
#line 440 "../lib/Drawing/Color.vala"
	_tmp5_ = max;
#line 440 "../lib/Drawing/Color.vala"
	_tmp6_ = min;
#line 440 "../lib/Drawing/Color.vala"
	delta = _tmp5_ - _tmp6_;
#line 441 "../lib/Drawing/Color.vala"
	_tmp7_ = delta;
#line 441 "../lib/Drawing/Color.vala"
	_vala_s = _tmp7_;
#line 442 "../lib/Drawing/Color.vala"
	_tmp8_ = _vala_s;
#line 442 "../lib/Drawing/Color.vala"
	if (_tmp8_ == ((gdouble) 0)) {
#line 443 "../lib/Drawing/Color.vala"
		_vala_h = (gdouble) 0;
#line 444 "../lib/Drawing/Color.vala"
		if (h) {
#line 444 "../lib/Drawing/Color.vala"
			*h = _vala_h;
#line 1567 "Color.c"
		}
#line 444 "../lib/Drawing/Color.vala"
		if (s) {
#line 444 "../lib/Drawing/Color.vala"
			*s = _vala_s;
#line 1573 "Color.c"
		}
#line 444 "../lib/Drawing/Color.vala"
		if (v) {
#line 444 "../lib/Drawing/Color.vala"
			*v = _vala_v;
#line 1579 "Color.c"
		}
#line 444 "../lib/Drawing/Color.vala"
		return;
#line 1583 "Color.c"
	}
#line 448 "../lib/Drawing/Color.vala"
	_tmp9_ = min;
#line 448 "../lib/Drawing/Color.vala"
	_tmp10_ = delta;
#line 448 "../lib/Drawing/Color.vala"
	r = (r - _tmp9_) / _tmp10_;
#line 449 "../lib/Drawing/Color.vala"
	_tmp11_ = min;
#line 449 "../lib/Drawing/Color.vala"
	_tmp12_ = delta;
#line 449 "../lib/Drawing/Color.vala"
	g = (g - _tmp11_) / _tmp12_;
#line 450 "../lib/Drawing/Color.vala"
	_tmp13_ = min;
#line 450 "../lib/Drawing/Color.vala"
	_tmp14_ = delta;
#line 450 "../lib/Drawing/Color.vala"
	b = (b - _tmp13_) / _tmp14_;
#line 452 "../lib/Drawing/Color.vala"
	_tmp15_ = max;
#line 452 "../lib/Drawing/Color.vala"
	if (_tmp15_ == r) {
#line 1607 "Color.c"
		gdouble _tmp16_;
#line 453 "../lib/Drawing/Color.vala"
		_vala_h = 0 + (60 * (g - b));
#line 454 "../lib/Drawing/Color.vala"
		_tmp16_ = _vala_h;
#line 454 "../lib/Drawing/Color.vala"
		if (_tmp16_ < ((gdouble) 0)) {
#line 1615 "Color.c"
			gdouble _tmp17_;
#line 455 "../lib/Drawing/Color.vala"
			_tmp17_ = _vala_h;
#line 455 "../lib/Drawing/Color.vala"
			_vala_h = _tmp17_ + 360;
#line 1621 "Color.c"
		}
	} else {
		gdouble _tmp18_;
#line 456 "../lib/Drawing/Color.vala"
		_tmp18_ = max;
#line 456 "../lib/Drawing/Color.vala"
		if (_tmp18_ == g) {
#line 457 "../lib/Drawing/Color.vala"
			_vala_h = 120 + (60 * (b - r));
#line 1631 "Color.c"
		} else {
#line 459 "../lib/Drawing/Color.vala"
			_vala_h = 240 + (60 * (r - g));
#line 1635 "Color.c"
		}
	}
#line 417 "../lib/Drawing/Color.vala"
	if (h) {
#line 417 "../lib/Drawing/Color.vala"
		*h = _vala_h;
#line 1642 "Color.c"
	}
#line 417 "../lib/Drawing/Color.vala"
	if (s) {
#line 417 "../lib/Drawing/Color.vala"
		*s = _vala_s;
#line 1648 "Color.c"
	}
#line 417 "../lib/Drawing/Color.vala"
	if (v) {
#line 417 "../lib/Drawing/Color.vala"
		*v = _vala_v;
#line 1654 "Color.c"
	}
}


static void
granite_drawing_color_hsv_to_rgb (GraniteDrawingColor* self,
                                  gdouble h,
                                  gdouble s,
                                  gdouble v,
                                  gdouble* r,
                                  gdouble* g,
                                  gdouble* b)
{
	gdouble _vala_r = 0.0;
	gdouble _vala_g = 0.0;
	gdouble _vala_b = 0.0;
#line 463 "../lib/Drawing/Color.vala"
	g_return_if_fail (self != NULL);
#line 463 "../lib/Drawing/Color.vala"
	_vala_return_if_fail ((h >= ((gdouble) 0)) && (h <= ((gdouble) 360)), "h >= 0 && h <= 360");
#line 463 "../lib/Drawing/Color.vala"
	_vala_return_if_fail ((s >= ((gdouble) 0)) && (s <= ((gdouble) 1)), "s >= 0 && s <= 1");
#line 463 "../lib/Drawing/Color.vala"
	_vala_return_if_fail ((v >= ((gdouble) 0)) && (v <= ((gdouble) 1)), "v >= 0 && v <= 1");
#line 468 "../lib/Drawing/Color.vala"
	_vala_r = (gdouble) 0;
#line 469 "../lib/Drawing/Color.vala"
	_vala_g = (gdouble) 0;
#line 470 "../lib/Drawing/Color.vala"
	_vala_b = (gdouble) 0;
#line 472 "../lib/Drawing/Color.vala"
	if (s == ((gdouble) 0)) {
#line 473 "../lib/Drawing/Color.vala"
		_vala_r = v;
#line 474 "../lib/Drawing/Color.vala"
		_vala_g = v;
#line 475 "../lib/Drawing/Color.vala"
		_vala_b = v;
#line 1693 "Color.c"
	} else {
		gint secNum = 0;
		gdouble fracSec = 0.0;
		gint _tmp0_;
		gdouble p = 0.0;
		gdouble q = 0.0;
		gdouble _tmp1_;
		gdouble t = 0.0;
		gdouble _tmp2_;
		gint _tmp3_;
#line 477 "../lib/Drawing/Color.vala"
		secNum = (gint) floor (h / 60);
#line 478 "../lib/Drawing/Color.vala"
		_tmp0_ = secNum;
#line 478 "../lib/Drawing/Color.vala"
		fracSec = (h / 60.0) - _tmp0_;
#line 480 "../lib/Drawing/Color.vala"
		p = v * (1 - s);
#line 481 "../lib/Drawing/Color.vala"
		_tmp1_ = fracSec;
#line 481 "../lib/Drawing/Color.vala"
		q = v * (1 - (s * _tmp1_));
#line 482 "../lib/Drawing/Color.vala"
		_tmp2_ = fracSec;
#line 482 "../lib/Drawing/Color.vala"
		t = v * (1 - (s * (1 - _tmp2_)));
#line 484 "../lib/Drawing/Color.vala"
		_tmp3_ = secNum;
#line 484 "../lib/Drawing/Color.vala"
		switch (_tmp3_) {
#line 484 "../lib/Drawing/Color.vala"
			case 0:
#line 1726 "Color.c"
			{
				gdouble _tmp4_;
				gdouble _tmp5_;
#line 486 "../lib/Drawing/Color.vala"
				_vala_r = v;
#line 487 "../lib/Drawing/Color.vala"
				_tmp4_ = t;
#line 487 "../lib/Drawing/Color.vala"
				_vala_g = _tmp4_;
#line 488 "../lib/Drawing/Color.vala"
				_tmp5_ = p;
#line 488 "../lib/Drawing/Color.vala"
				_vala_b = _tmp5_;
#line 489 "../lib/Drawing/Color.vala"
				break;
#line 1742 "Color.c"
			}
#line 484 "../lib/Drawing/Color.vala"
			case 1:
#line 1746 "Color.c"
			{
				gdouble _tmp6_;
				gdouble _tmp7_;
#line 491 "../lib/Drawing/Color.vala"
				_tmp6_ = q;
#line 491 "../lib/Drawing/Color.vala"
				_vala_r = _tmp6_;
#line 492 "../lib/Drawing/Color.vala"
				_vala_g = v;
#line 493 "../lib/Drawing/Color.vala"
				_tmp7_ = p;
#line 493 "../lib/Drawing/Color.vala"
				_vala_b = _tmp7_;
#line 494 "../lib/Drawing/Color.vala"
				break;
#line 1762 "Color.c"
			}
#line 484 "../lib/Drawing/Color.vala"
			case 2:
#line 1766 "Color.c"
			{
				gdouble _tmp8_;
				gdouble _tmp9_;
#line 496 "../lib/Drawing/Color.vala"
				_tmp8_ = p;
#line 496 "../lib/Drawing/Color.vala"
				_vala_r = _tmp8_;
#line 497 "../lib/Drawing/Color.vala"
				_vala_g = v;
#line 498 "../lib/Drawing/Color.vala"
				_tmp9_ = t;
#line 498 "../lib/Drawing/Color.vala"
				_vala_b = _tmp9_;
#line 499 "../lib/Drawing/Color.vala"
				break;
#line 1782 "Color.c"
			}
#line 484 "../lib/Drawing/Color.vala"
			case 3:
#line 1786 "Color.c"
			{
				gdouble _tmp10_;
				gdouble _tmp11_;
#line 501 "../lib/Drawing/Color.vala"
				_tmp10_ = p;
#line 501 "../lib/Drawing/Color.vala"
				_vala_r = _tmp10_;
#line 502 "../lib/Drawing/Color.vala"
				_tmp11_ = q;
#line 502 "../lib/Drawing/Color.vala"
				_vala_g = _tmp11_;
#line 503 "../lib/Drawing/Color.vala"
				_vala_b = v;
#line 504 "../lib/Drawing/Color.vala"
				break;
#line 1802 "Color.c"
			}
#line 484 "../lib/Drawing/Color.vala"
			case 4:
#line 1806 "Color.c"
			{
				gdouble _tmp12_;
				gdouble _tmp13_;
#line 506 "../lib/Drawing/Color.vala"
				_tmp12_ = t;
#line 506 "../lib/Drawing/Color.vala"
				_vala_r = _tmp12_;
#line 507 "../lib/Drawing/Color.vala"
				_tmp13_ = p;
#line 507 "../lib/Drawing/Color.vala"
				_vala_g = _tmp13_;
#line 508 "../lib/Drawing/Color.vala"
				_vala_b = v;
#line 509 "../lib/Drawing/Color.vala"
				break;
#line 1822 "Color.c"
			}
#line 484 "../lib/Drawing/Color.vala"
			case 5:
#line 1826 "Color.c"
			{
				gdouble _tmp14_;
				gdouble _tmp15_;
#line 511 "../lib/Drawing/Color.vala"
				_vala_r = v;
#line 512 "../lib/Drawing/Color.vala"
				_tmp14_ = p;
#line 512 "../lib/Drawing/Color.vala"
				_vala_g = _tmp14_;
#line 513 "../lib/Drawing/Color.vala"
				_tmp15_ = q;
#line 513 "../lib/Drawing/Color.vala"
				_vala_b = _tmp15_;
#line 514 "../lib/Drawing/Color.vala"
				break;
#line 1842 "Color.c"
			}
			default:
#line 484 "../lib/Drawing/Color.vala"
			break;
#line 1847 "Color.c"
		}
	}
#line 463 "../lib/Drawing/Color.vala"
	if (r) {
#line 463 "../lib/Drawing/Color.vala"
		*r = _vala_r;
#line 1854 "Color.c"
	}
#line 463 "../lib/Drawing/Color.vala"
	if (g) {
#line 463 "../lib/Drawing/Color.vala"
		*g = _vala_g;
#line 1860 "Color.c"
	}
#line 463 "../lib/Drawing/Color.vala"
	if (b) {
#line 463 "../lib/Drawing/Color.vala"
		*b = _vala_b;
#line 1866 "Color.c"
	}
}


/**
         * {@inheritDoc}
         */
static gchar*
granite_drawing_color_real_settings_serialize (GraniteServicesSettingsSerializable* base)
{
	GraniteDrawingColor * self;
	gchar* result = NULL;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	gchar* _tmp4_;
#line 522 "../lib/Drawing/Color.vala"
	self = (GraniteDrawingColor*) base;
#line 524 "../lib/Drawing/Color.vala"
	_tmp0_ = self->R;
#line 524 "../lib/Drawing/Color.vala"
	_tmp1_ = self->G;
#line 524 "../lib/Drawing/Color.vala"
	_tmp2_ = self->B;
#line 524 "../lib/Drawing/Color.vala"
	_tmp3_ = self->A;
#line 524 "../lib/Drawing/Color.vala"
	_tmp4_ = g_strdup_printf ("%d;;%d;;%d;;%d", (gint) (_tmp0_ * G_MAXUINT8), (gint) (_tmp1_ * G_MAXUINT8), (gint) (_tmp2_ * G_MAXUINT8), (gint) (_tmp3_ * G_MAXUINT8));
#line 524 "../lib/Drawing/Color.vala"
	result = _tmp4_;
#line 524 "../lib/Drawing/Color.vala"
	return result;
#line 1900 "Color.c"
}


/**
         * {@inheritDoc}
         */
static void
granite_drawing_color_real_settings_deserialize (GraniteServicesSettingsSerializable* base,
                                                 const gchar* s)
{
	GraniteDrawingColor * self;
	gchar** parts = NULL;
	gchar** _tmp0_;
	gchar** _tmp1_;
	gint parts_length1;
	gint _parts_size_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
#line 533 "../lib/Drawing/Color.vala"
	self = (GraniteDrawingColor*) base;
#line 533 "../lib/Drawing/Color.vala"
	g_return_if_fail (s != NULL);
#line 535 "../lib/Drawing/Color.vala"
	_tmp1_ = _tmp0_ = g_strsplit (s, ";;", 0);
#line 535 "../lib/Drawing/Color.vala"
	parts = _tmp1_;
#line 535 "../lib/Drawing/Color.vala"
	parts_length1 = _vala_array_length (_tmp0_);
#line 535 "../lib/Drawing/Color.vala"
	_parts_size_ = parts_length1;
#line 537 "../lib/Drawing/Color.vala"
	_tmp2_ = parts[0];
#line 537 "../lib/Drawing/Color.vala"
	self->R = MIN ((gdouble) G_MAXUINT8, MAX ((gdouble) 0, (gdouble) atoi (_tmp2_))) / G_MAXUINT8;
#line 538 "../lib/Drawing/Color.vala"
	_tmp3_ = parts[1];
#line 538 "../lib/Drawing/Color.vala"
	self->G = MIN ((gdouble) G_MAXUINT8, MAX ((gdouble) 0, (gdouble) atoi (_tmp3_))) / G_MAXUINT8;
#line 539 "../lib/Drawing/Color.vala"
	_tmp4_ = parts[2];
#line 539 "../lib/Drawing/Color.vala"
	self->B = MIN ((gdouble) G_MAXUINT8, MAX ((gdouble) 0, (gdouble) atoi (_tmp4_))) / G_MAXUINT8;
#line 540 "../lib/Drawing/Color.vala"
	_tmp5_ = parts[3];
#line 540 "../lib/Drawing/Color.vala"
	self->A = MIN ((gdouble) G_MAXUINT8, MAX ((gdouble) 0, (gdouble) atoi (_tmp5_))) / G_MAXUINT8;
#line 533 "../lib/Drawing/Color.vala"
	parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 1951 "Color.c"
}


/**
         * Returns a textual specification of this in the form `rgb (r, g, b)` or `rgba (r, g, b, a)`,
         * where “r”, “g”, “b” and “a” represent the red, green, blue and alpha values respectively.
         *
         * r, g, and b are represented as integers in the range 0 to 255, and a is represented as
         * floating point value in the range 0 to 1.
         *
         * Note: that this string representation may lose some precision, since r, g and b are represented
         * as 8-bit integers. If this is a concern, you should use a different representation.
         *
         * This returns the same string as a {@link Gdk.RGBA} would return in {@link Gdk.RGBA.to_string}
         *
         * @return the text string
         */
gchar*
granite_drawing_color_to_string (GraniteDrawingColor* self)
{
	gchar* result = NULL;
	GdkRGBA rgba = {0};
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	GdkRGBA _tmp4_ = {0};
	gchar* _tmp5_;
#line 557 "../lib/Drawing/Color.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 558 "../lib/Drawing/Color.vala"
	_tmp0_ = self->R;
#line 558 "../lib/Drawing/Color.vala"
	_tmp1_ = self->G;
#line 558 "../lib/Drawing/Color.vala"
	_tmp2_ = self->B;
#line 558 "../lib/Drawing/Color.vala"
	_tmp3_ = self->A;
#line 558 "../lib/Drawing/Color.vala"
	_tmp4_.red = _tmp0_;
#line 558 "../lib/Drawing/Color.vala"
	_tmp4_.green = _tmp1_;
#line 558 "../lib/Drawing/Color.vala"
	_tmp4_.blue = _tmp2_;
#line 558 "../lib/Drawing/Color.vala"
	_tmp4_.alpha = _tmp3_;
#line 558 "../lib/Drawing/Color.vala"
	rgba = _tmp4_;
#line 559 "../lib/Drawing/Color.vala"
	_tmp5_ = gdk_rgba_to_string (&rgba);
#line 559 "../lib/Drawing/Color.vala"
	result = _tmp5_;
#line 559 "../lib/Drawing/Color.vala"
	return result;
#line 2006 "Color.c"
}


/**
         * Converts this to a 32 bit integer.
         * 
         * This function can be useful for serializing the color so that it can be stored
         * and retrieved easily with hash tables and lists.
         * 
         * The returned integer will contain the four channels
         * that define the {@link Granite.Drawing.Color} class: alpha, red, green and blue.
         * 
         * Each channel is represented by 8 bits.
         * The first 8 bits of the integer conatin the alpha channel while all other 24 bits represent
         * red, green and blue channels respectively.
         * 
         * The format written as a string would look like this:
         * 
         * //AAAAAAAA RRRRRRRR GGGGGGGG BBBBBBBB//
         * 
         * where //A// is one bit of alpha chnnel, //R// of red channel, //G// of green channel and //B// of blue channel.
         * 
         * @return a 32 bit integer representing this
         */
gint
granite_drawing_color_to_int (GraniteDrawingColor* self)
{
	gint result = 0;
	guint8 red = 0U;
	gdouble _tmp0_;
	guint8 green = 0U;
	gdouble _tmp1_;
	guint8 blue = 0U;
	gdouble _tmp2_;
	guint8 alpha = 0U;
	gdouble _tmp3_;
#line 583 "../lib/Drawing/Color.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 584 "../lib/Drawing/Color.vala"
	_tmp0_ = self->R;
#line 584 "../lib/Drawing/Color.vala"
	red = (guint8) (_tmp0_ * G_MAXUINT8);
#line 585 "../lib/Drawing/Color.vala"
	_tmp1_ = self->G;
#line 585 "../lib/Drawing/Color.vala"
	green = (guint8) (_tmp1_ * G_MAXUINT8);
#line 586 "../lib/Drawing/Color.vala"
	_tmp2_ = self->B;
#line 586 "../lib/Drawing/Color.vala"
	blue = (guint8) (_tmp2_ * G_MAXUINT8);
#line 587 "../lib/Drawing/Color.vala"
	_tmp3_ = self->A;
#line 587 "../lib/Drawing/Color.vala"
	alpha = (guint8) (_tmp3_ * G_MAXUINT8);
#line 589 "../lib/Drawing/Color.vala"
	result = (((alpha << 24) | (red << 16)) | (green << 8)) | blue;
#line 589 "../lib/Drawing/Color.vala"
	return result;
#line 2065 "Color.c"
}


static void
granite_drawing_color_set_from_rgba (GraniteDrawingColor* self,
                                     GdkRGBA* color)
{
	GdkRGBA _tmp0_;
	gdouble _tmp1_;
	GdkRGBA _tmp2_;
	gdouble _tmp3_;
	GdkRGBA _tmp4_;
	gdouble _tmp5_;
	GdkRGBA _tmp6_;
	gdouble _tmp7_;
#line 592 "../lib/Drawing/Color.vala"
	g_return_if_fail (self != NULL);
#line 592 "../lib/Drawing/Color.vala"
	g_return_if_fail (color != NULL);
#line 593 "../lib/Drawing/Color.vala"
	_tmp0_ = *color;
#line 593 "../lib/Drawing/Color.vala"
	_tmp1_ = _tmp0_.red;
#line 593 "../lib/Drawing/Color.vala"
	self->R = _tmp1_;
#line 594 "../lib/Drawing/Color.vala"
	_tmp2_ = *color;
#line 594 "../lib/Drawing/Color.vala"
	_tmp3_ = _tmp2_.green;
#line 594 "../lib/Drawing/Color.vala"
	self->G = _tmp3_;
#line 595 "../lib/Drawing/Color.vala"
	_tmp4_ = *color;
#line 595 "../lib/Drawing/Color.vala"
	_tmp5_ = _tmp4_.blue;
#line 595 "../lib/Drawing/Color.vala"
	self->B = _tmp5_;
#line 596 "../lib/Drawing/Color.vala"
	_tmp6_ = *color;
#line 596 "../lib/Drawing/Color.vala"
	_tmp7_ = _tmp6_.alpha;
#line 596 "../lib/Drawing/Color.vala"
	self->A = _tmp7_;
#line 2109 "Color.c"
}


static void
granite_drawing_color_class_init (GraniteDrawingColorClass * klass)
{
#line 29 "../lib/Drawing/Color.vala"
	granite_drawing_color_parent_class = g_type_class_peek_parent (klass);
#line 29 "../lib/Drawing/Color.vala"
	G_OBJECT_CLASS (klass)->finalize = granite_drawing_color_finalize;
#line 2120 "Color.c"
}


static void
granite_drawing_color_granite_services_settings_serializable_interface_init (GraniteServicesSettingsSerializableIface * iface)
{
#line 29 "../lib/Drawing/Color.vala"
	granite_drawing_color_granite_services_settings_serializable_parent_iface = g_type_interface_peek_parent (iface);
#line 29 "../lib/Drawing/Color.vala"
	iface->settings_serialize = (gchar* (*) (GraniteServicesSettingsSerializable*)) granite_drawing_color_real_settings_serialize;
#line 29 "../lib/Drawing/Color.vala"
	iface->settings_deserialize = (void (*) (GraniteServicesSettingsSerializable*, const gchar*)) granite_drawing_color_real_settings_deserialize;
#line 2133 "Color.c"
}


static void
granite_drawing_color_instance_init (GraniteDrawingColor * self)
{
}


static void
granite_drawing_color_finalize (GObject * obj)
{
	GraniteDrawingColor * self;
#line 29 "../lib/Drawing/Color.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GRANITE_DRAWING_TYPE_COLOR, GraniteDrawingColor);
#line 29 "../lib/Drawing/Color.vala"
	G_OBJECT_CLASS (granite_drawing_color_parent_class)->finalize (obj);
#line 2151 "Color.c"
}


/**
     * A class containing an RGBA color and methods for more powerful color manipulation.
     */
GType
granite_drawing_color_get_type (void)
{
	static volatile gsize granite_drawing_color_type_id__volatile = 0;
	if (g_once_init_enter (&granite_drawing_color_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GraniteDrawingColorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) granite_drawing_color_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GraniteDrawingColor), 0, (GInstanceInitFunc) granite_drawing_color_instance_init, NULL };
		static const GInterfaceInfo granite_services_settings_serializable_info = { (GInterfaceInitFunc) granite_drawing_color_granite_services_settings_serializable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType granite_drawing_color_type_id;
		granite_drawing_color_type_id = g_type_register_static (G_TYPE_OBJECT, "GraniteDrawingColor", &g_define_type_info, 0);
		g_type_add_interface_static (granite_drawing_color_type_id, GRANITE_SERVICES_TYPE_SETTINGS_SERIALIZABLE, &granite_services_settings_serializable_info);
		g_once_init_leave (&granite_drawing_color_type_id__volatile, granite_drawing_color_type_id);
	}
	return granite_drawing_color_type_id__volatile;
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



