/* Utilities.c generated by valac 0.42.7, the Vala compiler
 * generated from Utilities.vala, do not modify */

/*
 *  Copyright (C) 2011-2013 Maxwell Barvian <maxwell@elementaryos.org>,
 *                          Robert Dyer
 *
 *  This program or library is free software; you can redistribute it
 *  and/or modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 3 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General
 *  Public License along with this library; if not, write to the
 *  Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 *  Boston, MA 02110-1301 USA.
 */


#include <glib.h>
#include <glib-object.h>
#include <cairo.h>
#include <float.h>
#include <math.h>
#include <gdk-pixbuf/gdk-pixbuf.h>


#define GRANITE_DRAWING_TYPE_UTILITIES (granite_drawing_utilities_get_type ())
#define GRANITE_DRAWING_UTILITIES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GRANITE_DRAWING_TYPE_UTILITIES, GraniteDrawingUtilities))
#define GRANITE_DRAWING_UTILITIES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GRANITE_DRAWING_TYPE_UTILITIES, GraniteDrawingUtilitiesClass))
#define GRANITE_DRAWING_IS_UTILITIES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GRANITE_DRAWING_TYPE_UTILITIES))
#define GRANITE_DRAWING_IS_UTILITIES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GRANITE_DRAWING_TYPE_UTILITIES))
#define GRANITE_DRAWING_UTILITIES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GRANITE_DRAWING_TYPE_UTILITIES, GraniteDrawingUtilitiesClass))

typedef struct _GraniteDrawingUtilities GraniteDrawingUtilities;
typedef struct _GraniteDrawingUtilitiesClass GraniteDrawingUtilitiesClass;
typedef struct _GraniteDrawingUtilitiesPrivate GraniteDrawingUtilitiesPrivate;
enum  {
	GRANITE_DRAWING_UTILITIES_0_PROPERTY,
	GRANITE_DRAWING_UTILITIES_NUM_PROPERTIES
};
static GParamSpec* granite_drawing_utilities_properties[GRANITE_DRAWING_UTILITIES_NUM_PROPERTIES];

#define GRANITE_DRAWING_TYPE_COLOR (granite_drawing_color_get_type ())
#define GRANITE_DRAWING_COLOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GRANITE_DRAWING_TYPE_COLOR, GraniteDrawingColor))
#define GRANITE_DRAWING_COLOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GRANITE_DRAWING_TYPE_COLOR, GraniteDrawingColorClass))
#define GRANITE_DRAWING_IS_COLOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GRANITE_DRAWING_TYPE_COLOR))
#define GRANITE_DRAWING_IS_COLOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GRANITE_DRAWING_TYPE_COLOR))
#define GRANITE_DRAWING_COLOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GRANITE_DRAWING_TYPE_COLOR, GraniteDrawingColorClass))

typedef struct _GraniteDrawingColor GraniteDrawingColor;
typedef struct _GraniteDrawingColorClass GraniteDrawingColorClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _GraniteDrawingUtilities {
	GObject parent_instance;
	GraniteDrawingUtilitiesPrivate * priv;
};

struct _GraniteDrawingUtilitiesClass {
	GObjectClass parent_class;
};


static gpointer granite_drawing_utilities_parent_class = NULL;

GType granite_drawing_utilities_get_type (void) G_GNUC_CONST;
void granite_drawing_utilities_cairo_rounded_rectangle (cairo_t* cr,
                                                        gdouble x,
                                                        gdouble y,
                                                        gdouble width,
                                                        gdouble height,
                                                        gdouble radius);
GType granite_drawing_color_get_type (void) G_GNUC_CONST;
GraniteDrawingColor* granite_drawing_utilities_average_color (GdkPixbuf* source);
GraniteDrawingColor* granite_drawing_color_new (gdouble R,
                                                gdouble G,
                                                gdouble B,
                                                gdouble A);
GraniteDrawingColor* granite_drawing_color_construct (GType object_type,
                                                      gdouble R,
                                                      gdouble G,
                                                      gdouble B,
                                                      gdouble A);
GraniteDrawingColor* granite_drawing_color_set_val (GraniteDrawingColor* self,
                                                    gdouble val);
GraniteDrawingColor* granite_drawing_color_multiply_sat (GraniteDrawingColor* self,
                                                         gdouble amount);
GraniteDrawingUtilities* granite_drawing_utilities_new (void);
GraniteDrawingUtilities* granite_drawing_utilities_construct (GType object_type);


/**
         * Adds a closed sub-path rounded rectangle of the given size and border radius to the current path
         * at position (x, y) in user-space coordinates.
         *
         * @param cr a {@link Cairo.Context}
         * @param x the X coordinate of the top left corner of the rounded rectangle
         * @param y the Y coordinate to the top left corner of the rounded rectangle
         * @param width the width of the rounded rectangle
         * @param height the height of the rounded rectangle
         * @param radius the border radius of the rounded rectangle
         */
void
granite_drawing_utilities_cairo_rounded_rectangle (cairo_t* cr,
                                                   gdouble x,
                                                   gdouble y,
                                                   gdouble width,
                                                   gdouble height,
                                                   gdouble radius)
{
#line 45 "../lib/Drawing/Utilities.vala"
	g_return_if_fail (cr != NULL);
#line 47 "../lib/Drawing/Utilities.vala"
	cairo_move_to (cr, x + radius, y);
#line 48 "../lib/Drawing/Utilities.vala"
	cairo_arc (cr, (x + width) - radius, y + radius, radius, G_PI * 1.5, G_PI * 2);
#line 49 "../lib/Drawing/Utilities.vala"
	cairo_arc (cr, (x + width) - radius, (y + height) - radius, radius, (gdouble) 0, G_PI * 0.5);
#line 50 "../lib/Drawing/Utilities.vala"
	cairo_arc (cr, x + radius, (y + height) - radius, radius, G_PI * 0.5, G_PI);
#line 51 "../lib/Drawing/Utilities.vala"
	cairo_arc (cr, x + radius, y + radius, radius, G_PI, G_PI * 1.5);
#line 52 "../lib/Drawing/Utilities.vala"
	cairo_close_path (cr);
#line 132 "Utilities.c"
}


/**
         * Averages the colors in the {@link Gdk.Pixbuf} and returns it.
         *
         * @param source the {@link Gdk.Pixbuf}
         * 
         * @return the {@link Granite.Drawing.Color} containing the averaged color
         */
GraniteDrawingColor*
granite_drawing_utilities_average_color (GdkPixbuf* source)
{
	GraniteDrawingColor* result = NULL;
	gdouble rTotal = 0.0;
	gdouble gTotal = 0.0;
	gdouble bTotal = 0.0;
	guint8* dataPtr = NULL;
	guint8* _tmp0_;
	gdouble pixels = 0.0;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gdouble _tmp42_;
	gdouble _tmp43_;
	gdouble _tmp44_;
	gdouble _tmp45_;
	gdouble _tmp46_;
	gdouble _tmp47_;
	GraniteDrawingColor* _tmp48_;
	GraniteDrawingColor* _tmp49_;
	GraniteDrawingColor* _tmp50_;
	GraniteDrawingColor* _tmp51_;
	GraniteDrawingColor* _tmp52_;
	GraniteDrawingColor* _tmp53_;
#line 62 "../lib/Drawing/Utilities.vala"
	g_return_val_if_fail (source != NULL, NULL);
#line 64 "../lib/Drawing/Utilities.vala"
	rTotal = 0.0;
#line 65 "../lib/Drawing/Utilities.vala"
	gTotal = 0.0;
#line 66 "../lib/Drawing/Utilities.vala"
	bTotal = 0.0;
#line 68 "../lib/Drawing/Utilities.vala"
	_tmp0_ = gdk_pixbuf_get_pixels (source);
#line 68 "../lib/Drawing/Utilities.vala"
	dataPtr = _tmp0_;
#line 69 "../lib/Drawing/Utilities.vala"
	_tmp1_ = gdk_pixbuf_get_height (source);
#line 69 "../lib/Drawing/Utilities.vala"
	_tmp2_ = _tmp1_;
#line 69 "../lib/Drawing/Utilities.vala"
	_tmp3_ = gdk_pixbuf_get_rowstride (source);
#line 69 "../lib/Drawing/Utilities.vala"
	_tmp4_ = _tmp3_;
#line 69 "../lib/Drawing/Utilities.vala"
	_tmp5_ = gdk_pixbuf_get_n_channels (source);
#line 69 "../lib/Drawing/Utilities.vala"
	_tmp6_ = _tmp5_;
#line 69 "../lib/Drawing/Utilities.vala"
	pixels = (gdouble) ((_tmp2_ * _tmp4_) / _tmp6_);
#line 197 "Utilities.c"
	{
		gint i = 0;
#line 71 "../lib/Drawing/Utilities.vala"
		i = 0;
#line 202 "Utilities.c"
		{
			gboolean _tmp7_ = FALSE;
#line 71 "../lib/Drawing/Utilities.vala"
			_tmp7_ = TRUE;
#line 71 "../lib/Drawing/Utilities.vala"
			while (TRUE) {
#line 209 "Utilities.c"
				gint _tmp9_;
				gdouble _tmp10_;
				guint8 r = 0U;
				guint8* _tmp11_;
				guint8 _tmp12_;
				guint8 g = 0U;
				guint8* _tmp13_;
				guint8 _tmp14_;
				guint8 b = 0U;
				guint8* _tmp15_;
				guint8 _tmp16_;
				guint8 max = 0U;
				guint8 _tmp17_;
				guint8 _tmp18_;
				guint8 _tmp19_;
				guint8 min = 0U;
				guint8 _tmp20_;
				guint8 _tmp21_;
				guint8 _tmp22_;
				gdouble delta = 0.0;
				guint8 _tmp23_;
				guint8 _tmp24_;
				gdouble _tmp25_ = 0.0;
				gdouble _tmp26_;
				gdouble sat = 0.0;
				gdouble score = 0.0;
				gdouble _tmp29_;
				gdouble _tmp30_;
				guint8 _tmp31_;
				gdouble _tmp32_;
				gdouble _tmp33_;
				guint8 _tmp34_;
				gdouble _tmp35_;
				gdouble _tmp36_;
				guint8 _tmp37_;
				gdouble _tmp38_;
				guint8* _tmp39_;
				gint _tmp40_;
				gint _tmp41_;
#line 71 "../lib/Drawing/Utilities.vala"
				if (!_tmp7_) {
#line 251 "Utilities.c"
					gint _tmp8_;
#line 71 "../lib/Drawing/Utilities.vala"
					_tmp8_ = i;
#line 71 "../lib/Drawing/Utilities.vala"
					i = _tmp8_ + 1;
#line 257 "Utilities.c"
				}
#line 71 "../lib/Drawing/Utilities.vala"
				_tmp7_ = FALSE;
#line 71 "../lib/Drawing/Utilities.vala"
				_tmp9_ = i;
#line 71 "../lib/Drawing/Utilities.vala"
				_tmp10_ = pixels;
#line 71 "../lib/Drawing/Utilities.vala"
				if (!(((gdouble) _tmp9_) < _tmp10_)) {
#line 71 "../lib/Drawing/Utilities.vala"
					break;
#line 269 "Utilities.c"
				}
#line 72 "../lib/Drawing/Utilities.vala"
				_tmp11_ = dataPtr;
#line 72 "../lib/Drawing/Utilities.vala"
				_tmp12_ = _tmp11_[0];
#line 72 "../lib/Drawing/Utilities.vala"
				r = _tmp12_;
#line 73 "../lib/Drawing/Utilities.vala"
				_tmp13_ = dataPtr;
#line 73 "../lib/Drawing/Utilities.vala"
				_tmp14_ = _tmp13_[1];
#line 73 "../lib/Drawing/Utilities.vala"
				g = _tmp14_;
#line 74 "../lib/Drawing/Utilities.vala"
				_tmp15_ = dataPtr;
#line 74 "../lib/Drawing/Utilities.vala"
				_tmp16_ = _tmp15_[2];
#line 74 "../lib/Drawing/Utilities.vala"
				b = _tmp16_;
#line 76 "../lib/Drawing/Utilities.vala"
				_tmp17_ = r;
#line 76 "../lib/Drawing/Utilities.vala"
				_tmp18_ = g;
#line 76 "../lib/Drawing/Utilities.vala"
				_tmp19_ = b;
#line 76 "../lib/Drawing/Utilities.vala"
				max = (guint8) MAX ((gdouble) _tmp17_, MAX ((gdouble) _tmp18_, (gdouble) _tmp19_));
#line 77 "../lib/Drawing/Utilities.vala"
				_tmp20_ = r;
#line 77 "../lib/Drawing/Utilities.vala"
				_tmp21_ = g;
#line 77 "../lib/Drawing/Utilities.vala"
				_tmp22_ = b;
#line 77 "../lib/Drawing/Utilities.vala"
				min = (guint8) MIN ((gdouble) _tmp20_, MIN ((gdouble) _tmp21_, (gdouble) _tmp22_));
#line 78 "../lib/Drawing/Utilities.vala"
				_tmp23_ = max;
#line 78 "../lib/Drawing/Utilities.vala"
				_tmp24_ = min;
#line 78 "../lib/Drawing/Utilities.vala"
				delta = (gdouble) (_tmp23_ - _tmp24_);
#line 80 "../lib/Drawing/Utilities.vala"
				_tmp26_ = delta;
#line 80 "../lib/Drawing/Utilities.vala"
				if (_tmp26_ == ((gdouble) 0)) {
#line 80 "../lib/Drawing/Utilities.vala"
					_tmp25_ = 0.0;
#line 317 "Utilities.c"
				} else {
					gdouble _tmp27_;
					guint8 _tmp28_;
#line 80 "../lib/Drawing/Utilities.vala"
					_tmp27_ = delta;
#line 80 "../lib/Drawing/Utilities.vala"
					_tmp28_ = max;
#line 80 "../lib/Drawing/Utilities.vala"
					_tmp25_ = _tmp27_ / _tmp28_;
#line 327 "Utilities.c"
				}
#line 80 "../lib/Drawing/Utilities.vala"
				sat = _tmp25_;
#line 81 "../lib/Drawing/Utilities.vala"
				_tmp29_ = sat;
#line 81 "../lib/Drawing/Utilities.vala"
				score = 0.2 + (0.8 * _tmp29_);
#line 83 "../lib/Drawing/Utilities.vala"
				_tmp30_ = rTotal;
#line 83 "../lib/Drawing/Utilities.vala"
				_tmp31_ = r;
#line 83 "../lib/Drawing/Utilities.vala"
				_tmp32_ = score;
#line 83 "../lib/Drawing/Utilities.vala"
				rTotal = _tmp30_ + (_tmp31_ * _tmp32_);
#line 84 "../lib/Drawing/Utilities.vala"
				_tmp33_ = gTotal;
#line 84 "../lib/Drawing/Utilities.vala"
				_tmp34_ = g;
#line 84 "../lib/Drawing/Utilities.vala"
				_tmp35_ = score;
#line 84 "../lib/Drawing/Utilities.vala"
				gTotal = _tmp33_ + (_tmp34_ * _tmp35_);
#line 85 "../lib/Drawing/Utilities.vala"
				_tmp36_ = bTotal;
#line 85 "../lib/Drawing/Utilities.vala"
				_tmp37_ = b;
#line 85 "../lib/Drawing/Utilities.vala"
				_tmp38_ = score;
#line 85 "../lib/Drawing/Utilities.vala"
				bTotal = _tmp36_ + (_tmp37_ * _tmp38_);
#line 87 "../lib/Drawing/Utilities.vala"
				_tmp39_ = dataPtr;
#line 87 "../lib/Drawing/Utilities.vala"
				_tmp40_ = gdk_pixbuf_get_n_channels (source);
#line 87 "../lib/Drawing/Utilities.vala"
				_tmp41_ = _tmp40_;
#line 87 "../lib/Drawing/Utilities.vala"
				dataPtr = _tmp39_ + _tmp41_;
#line 367 "Utilities.c"
			}
		}
	}
#line 90 "../lib/Drawing/Utilities.vala"
	_tmp42_ = rTotal;
#line 90 "../lib/Drawing/Utilities.vala"
	_tmp43_ = pixels;
#line 90 "../lib/Drawing/Utilities.vala"
	_tmp44_ = gTotal;
#line 90 "../lib/Drawing/Utilities.vala"
	_tmp45_ = pixels;
#line 90 "../lib/Drawing/Utilities.vala"
	_tmp46_ = bTotal;
#line 90 "../lib/Drawing/Utilities.vala"
	_tmp47_ = pixels;
#line 90 "../lib/Drawing/Utilities.vala"
	_tmp48_ = granite_drawing_color_new ((_tmp42_ / G_MAXUINT8) / _tmp43_, (_tmp44_ / G_MAXUINT8) / _tmp45_, (_tmp46_ / G_MAXUINT8) / _tmp47_, (gdouble) 1);
#line 90 "../lib/Drawing/Utilities.vala"
	_tmp49_ = _tmp48_;
#line 90 "../lib/Drawing/Utilities.vala"
	_tmp50_ = granite_drawing_color_set_val (_tmp49_, 0.8);
#line 90 "../lib/Drawing/Utilities.vala"
	_tmp51_ = _tmp50_;
#line 90 "../lib/Drawing/Utilities.vala"
	_tmp52_ = granite_drawing_color_multiply_sat (_tmp51_, 1.15);
#line 90 "../lib/Drawing/Utilities.vala"
	_tmp53_ = _tmp52_;
#line 90 "../lib/Drawing/Utilities.vala"
	_g_object_unref0 (_tmp51_);
#line 90 "../lib/Drawing/Utilities.vala"
	_g_object_unref0 (_tmp49_);
#line 90 "../lib/Drawing/Utilities.vala"
	result = _tmp53_;
#line 90 "../lib/Drawing/Utilities.vala"
	return result;
#line 403 "Utilities.c"
}


GraniteDrawingUtilities*
granite_drawing_utilities_construct (GType object_type)
{
	GraniteDrawingUtilities * self = NULL;
#line 32 "../lib/Drawing/Utilities.vala"
	self = (GraniteDrawingUtilities*) g_object_new (object_type, NULL);
#line 32 "../lib/Drawing/Utilities.vala"
	return self;
#line 415 "Utilities.c"
}


GraniteDrawingUtilities*
granite_drawing_utilities_new (void)
{
#line 32 "../lib/Drawing/Utilities.vala"
	return granite_drawing_utilities_construct (GRANITE_DRAWING_TYPE_UTILITIES);
#line 424 "Utilities.c"
}


static void
granite_drawing_utilities_class_init (GraniteDrawingUtilitiesClass * klass)
{
#line 32 "../lib/Drawing/Utilities.vala"
	granite_drawing_utilities_parent_class = g_type_class_peek_parent (klass);
#line 433 "Utilities.c"
}


static void
granite_drawing_utilities_instance_init (GraniteDrawingUtilities * self)
{
}


/**
     * A utility class for frequently-performed drawing operations.
     */
GType
granite_drawing_utilities_get_type (void)
{
	static volatile gsize granite_drawing_utilities_type_id__volatile = 0;
	if (g_once_init_enter (&granite_drawing_utilities_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GraniteDrawingUtilitiesClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) granite_drawing_utilities_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GraniteDrawingUtilities), 0, (GInstanceInitFunc) granite_drawing_utilities_instance_init, NULL };
		GType granite_drawing_utilities_type_id;
		granite_drawing_utilities_type_id = g_type_register_static (G_TYPE_OBJECT, "GraniteDrawingUtilities", &g_define_type_info, 0);
		g_once_init_leave (&granite_drawing_utilities_type_id__volatile, granite_drawing_utilities_type_id);
	}
	return granite_drawing_utilities_type_id__volatile;
}



