/* Settings.c generated by valac 0.42.7, the Vala compiler
 * generated from Settings.vala, do not modify */

/*
 *  Copyright (C) 2011-2013 Robert Dyer,
 *                          Rico Tzschichholz <ricotz@ubuntu.com>
 *
 *  This program or library is free software; you can redistribute it
 *  and/or modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 3 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General
 *  Public License along with this library; if not, write to the
 *  Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 *  Boston, MA 02110-1301 USA.
 */


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <float.h>
#include <math.h>


#define GRANITE_SERVICES_TYPE_SETTINGS_SERIALIZABLE (granite_services_settings_serializable_get_type ())
#define GRANITE_SERVICES_SETTINGS_SERIALIZABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GRANITE_SERVICES_TYPE_SETTINGS_SERIALIZABLE, GraniteServicesSettingsSerializable))
#define GRANITE_SERVICES_IS_SETTINGS_SERIALIZABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GRANITE_SERVICES_TYPE_SETTINGS_SERIALIZABLE))
#define GRANITE_SERVICES_SETTINGS_SERIALIZABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GRANITE_SERVICES_TYPE_SETTINGS_SERIALIZABLE, GraniteServicesSettingsSerializableIface))

typedef struct _GraniteServicesSettingsSerializable GraniteServicesSettingsSerializable;
typedef struct _GraniteServicesSettingsSerializableIface GraniteServicesSettingsSerializableIface;

#define GRANITE_SERVICES_TYPE_SETTINGS (granite_services_settings_get_type ())
#define GRANITE_SERVICES_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GRANITE_SERVICES_TYPE_SETTINGS, GraniteServicesSettings))
#define GRANITE_SERVICES_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GRANITE_SERVICES_TYPE_SETTINGS, GraniteServicesSettingsClass))
#define GRANITE_SERVICES_IS_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GRANITE_SERVICES_TYPE_SETTINGS))
#define GRANITE_SERVICES_IS_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GRANITE_SERVICES_TYPE_SETTINGS))
#define GRANITE_SERVICES_SETTINGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GRANITE_SERVICES_TYPE_SETTINGS, GraniteServicesSettingsClass))

typedef struct _GraniteServicesSettings GraniteServicesSettings;
typedef struct _GraniteServicesSettingsClass GraniteServicesSettingsClass;
typedef struct _GraniteServicesSettingsPrivate GraniteServicesSettingsPrivate;
enum  {
	GRANITE_SERVICES_SETTINGS_0_PROPERTY,
	GRANITE_SERVICES_SETTINGS_SCHEMA_PROPERTY,
	GRANITE_SERVICES_SETTINGS_NUM_PROPERTIES
};
static GParamSpec* granite_services_settings_properties[GRANITE_SERVICES_SETTINGS_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_param_spec_unref0(var) ((var == NULL) ? NULL : (var = (g_param_spec_unref (var), NULL)))
#define _g_type_class_unref0(var) ((var == NULL) ? NULL : (var = (g_type_class_unref (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
enum  {
	GRANITE_SERVICES_SETTINGS_CHANGED_SIGNAL,
	GRANITE_SERVICES_SETTINGS_NUM_SIGNALS
};
static guint granite_services_settings_signals[GRANITE_SERVICES_SETTINGS_NUM_SIGNALS] = {0};

struct _GraniteServicesSettingsSerializableIface {
	GTypeInterface parent_iface;
	gchar* (*settings_serialize) (GraniteServicesSettingsSerializable* self);
	void (*settings_deserialize) (GraniteServicesSettingsSerializable* self, const gchar* s);
};

struct _GraniteServicesSettings {
	GObject parent_instance;
	GraniteServicesSettingsPrivate * priv;
};

struct _GraniteServicesSettingsClass {
	GObjectClass parent_class;
	void (*verify) (GraniteServicesSettings* self, const gchar* key);
};

struct _GraniteServicesSettingsPrivate {
	gboolean saving_key;
	GSettings* _schema;
};


static gint GraniteServicesSettings_private_offset;
static gpointer granite_services_settings_parent_class = NULL;

GType granite_services_settings_serializable_get_type (void) G_GNUC_CONST;
gchar* granite_services_settings_serializable_settings_serialize (GraniteServicesSettingsSerializable* self);
void granite_services_settings_serializable_settings_deserialize (GraniteServicesSettingsSerializable* self,
                                                                  const gchar* s);
GType granite_services_settings_get_type (void) G_GNUC_CONST;
static void granite_services_settings_stop_monitor (GraniteServicesSettings* self);
GraniteServicesSettings* granite_services_settings_construct (GType object_type,
                                                              const gchar* schema);
GraniteServicesSettings* granite_services_settings_construct_with_backend (GType object_type,
                                                                           const gchar* schema,
                                                                           GSettingsBackend* backend);
GraniteServicesSettings* granite_services_settings_construct_with_backend_and_path (GType object_type,
                                                                                    const gchar* schema,
                                                                                    GSettingsBackend* backend,
                                                                                    const gchar* path);
GraniteServicesSettings* granite_services_settings_construct_with_path (GType object_type,
                                                                        const gchar* schema,
                                                                        const gchar* path);
GSettings* granite_services_settings_get_schema (GraniteServicesSettings* self);
static void granite_services_settings_load_key (GraniteServicesSettings* self,
                                         const gchar* key);
static void _granite_services_settings_load_key_g_settings_changed (GSettings* _sender,
                                                             const gchar* key,
                                                             gpointer self);
static void granite_services_settings_start_monitor (GraniteServicesSettings* self);
static void granite_services_settings_handle_notify (GraniteServicesSettings* self,
                                              GObject* sender,
                                              GParamSpec* property);
static void _granite_services_settings_handle_notify_g_object_notify (GObject* _sender,
                                                               GParamSpec* pspec,
                                                               gpointer self);
static void granite_services_settings_call_verify (GraniteServicesSettings* self,
                                            const gchar* key);
static void granite_services_settings_save_key (GraniteServicesSettings* self,
                                         const gchar* key);
static void granite_services_settings_handle_verify_notify (GraniteServicesSettings* self,
                                                     GObject* sender,
                                                     GParamSpec* property);
static void _granite_services_settings_handle_verify_notify_g_object_notify (GObject* _sender,
                                                                      GParamSpec* pspec,
                                                                      gpointer self);
void granite_services_settings_verify (GraniteServicesSettings* self,
                                       const gchar* key);
static void granite_services_settings_real_verify (GraniteServicesSettings* self,
                                            const gchar* key);
static void granite_services_settings_set_schema (GraniteServicesSettings* self,
                                           GSettings* value);
static GObject * granite_services_settings_constructor (GType type,
                                                 guint n_construct_properties,
                                                 GObjectConstructParam * construct_properties);
static void granite_services_settings_finalize (GObject * obj);
static void _vala_granite_services_settings_get_property (GObject * object,
                                                   guint property_id,
                                                   GValue * value,
                                                   GParamSpec * pspec);
static void _vala_granite_services_settings_set_property (GObject * object,
                                                   guint property_id,
                                                   const GValue * value,
                                                   GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


/**
         * Serializes the object into a string representation.
         *
         * @return the string representation of the object
         */
gchar*
granite_services_settings_serializable_settings_serialize (GraniteServicesSettingsSerializable* self)
{
#line 34 "../lib/Services/Settings.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 34 "../lib/Services/Settings.vala"
	return GRANITE_SERVICES_SETTINGS_SERIALIZABLE_GET_INTERFACE (self)->settings_serialize (self);
#line 175 "Settings.c"
}


/**
         * Un-serializes the object from a string representation.
         *
         * @param s the string representation of the object
         */
void
granite_services_settings_serializable_settings_deserialize (GraniteServicesSettingsSerializable* self,
                                                             const gchar* s)
{
#line 41 "../lib/Services/Settings.vala"
	g_return_if_fail (self != NULL);
#line 41 "../lib/Services/Settings.vala"
	GRANITE_SERVICES_SETTINGS_SERIALIZABLE_GET_INTERFACE (self)->settings_deserialize (self, s);
#line 192 "Settings.c"
}


static void
granite_services_settings_serializable_default_init (GraniteServicesSettingsSerializableIface * iface)
{
}


/**
     * This interface is used by objects that need to be serialized in a Settings.
     * The object must have a string representation and provide these methods to
     * translate between the string and object representations.
     */
GType
granite_services_settings_serializable_get_type (void)
{
	static volatile gsize granite_services_settings_serializable_type_id__volatile = 0;
	if (g_once_init_enter (&granite_services_settings_serializable_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GraniteServicesSettingsSerializableIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) granite_services_settings_serializable_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType granite_services_settings_serializable_type_id;
		granite_services_settings_serializable_type_id = g_type_register_static (G_TYPE_INTERFACE, "GraniteServicesSettingsSerializable", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (granite_services_settings_serializable_type_id, G_TYPE_OBJECT);
		g_once_init_leave (&granite_services_settings_serializable_type_id__volatile, granite_services_settings_serializable_type_id);
	}
	return granite_services_settings_serializable_type_id__volatile;
}


static inline gpointer
granite_services_settings_get_instance_private (GraniteServicesSettings* self)
{
	return G_STRUCT_MEMBER_P (self, GraniteServicesSettings_private_offset);
}


/**
         * Creates a new {@link Granite.Services.Settings} object for the supplied schema.
         *
         * @param schema the name of the schema to interact with
         */
GraniteServicesSettings*
granite_services_settings_construct (GType object_type,
                                     const gchar* schema)
{
	GraniteServicesSettings * self = NULL;
	GSettings* _tmp0_;
	GSettings* _tmp1_;
#line 120 "../lib/Services/Settings.vala"
	g_return_val_if_fail (schema != NULL, NULL);
#line 121 "../lib/Services/Settings.vala"
	_tmp0_ = g_settings_new (schema);
#line 121 "../lib/Services/Settings.vala"
	_tmp1_ = _tmp0_;
#line 121 "../lib/Services/Settings.vala"
	self = (GraniteServicesSettings*) g_object_new (object_type, "schema", _tmp1_, NULL);
#line 121 "../lib/Services/Settings.vala"
	_g_object_unref0 (_tmp1_);
#line 120 "../lib/Services/Settings.vala"
	return self;
#line 253 "Settings.c"
}


/**
         * Creates a new {@link Granite.Services.Settings} object for the supplied schema and {@link GLib.SettingsBackend}.
         *
         * @param schema the name of the schema to interact with
         * @param backend the desired backend to use
         */
GraniteServicesSettings*
granite_services_settings_construct_with_backend (GType object_type,
                                                  const gchar* schema,
                                                  GSettingsBackend* backend)
{
	GraniteServicesSettings * self = NULL;
	GSettings* _tmp0_;
	GSettings* _tmp1_;
#line 130 "../lib/Services/Settings.vala"
	g_return_val_if_fail (schema != NULL, NULL);
#line 130 "../lib/Services/Settings.vala"
	g_return_val_if_fail (backend != NULL, NULL);
#line 131 "../lib/Services/Settings.vala"
	_tmp0_ = g_settings_new_with_backend (schema, backend);
#line 131 "../lib/Services/Settings.vala"
	_tmp1_ = _tmp0_;
#line 131 "../lib/Services/Settings.vala"
	self = (GraniteServicesSettings*) g_object_new (object_type, "schema", _tmp1_, NULL);
#line 131 "../lib/Services/Settings.vala"
	_g_object_unref0 (_tmp1_);
#line 130 "../lib/Services/Settings.vala"
	return self;
#line 285 "Settings.c"
}


/**
         * Creates a new {@link Granite.Services.Settings} object for the supplied schema, {@link GLib.SettingsBackend}, and path.
         * 
         *
         * @param schema the name of the schema to interact with
         * @param backend the desired backend to use
         * @param path the path to use
         */
GraniteServicesSettings*
granite_services_settings_construct_with_backend_and_path (GType object_type,
                                                           const gchar* schema,
                                                           GSettingsBackend* backend,
                                                           const gchar* path)
{
	GraniteServicesSettings * self = NULL;
	GSettings* _tmp0_;
	GSettings* _tmp1_;
#line 142 "../lib/Services/Settings.vala"
	g_return_val_if_fail (schema != NULL, NULL);
#line 142 "../lib/Services/Settings.vala"
	g_return_val_if_fail (backend != NULL, NULL);
#line 142 "../lib/Services/Settings.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 143 "../lib/Services/Settings.vala"
	_tmp0_ = g_settings_new_with_backend_and_path (schema, backend, path);
#line 143 "../lib/Services/Settings.vala"
	_tmp1_ = _tmp0_;
#line 143 "../lib/Services/Settings.vala"
	self = (GraniteServicesSettings*) g_object_new (object_type, "schema", _tmp1_, NULL);
#line 143 "../lib/Services/Settings.vala"
	_g_object_unref0 (_tmp1_);
#line 142 "../lib/Services/Settings.vala"
	return self;
#line 322 "Settings.c"
}


/**
         * Creates a new {@link Granite.Services.Settings} object for the supplied schema, and path.
         * 
         * You only need to do this if you want to directly create a settings object with a schema that
         * doesn't have a specified path of its own. That's quite rare.
         *
         * It is a programmer error to call this function for a schema that has an explicitly specified path.
         *
         * @param schema the name of the schema to interact with
         * @param path the path to use
         */
GraniteServicesSettings*
granite_services_settings_construct_with_path (GType object_type,
                                               const gchar* schema,
                                               const gchar* path)
{
	GraniteServicesSettings * self = NULL;
	GSettings* _tmp0_;
	GSettings* _tmp1_;
#line 157 "../lib/Services/Settings.vala"
	g_return_val_if_fail (schema != NULL, NULL);
#line 157 "../lib/Services/Settings.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 158 "../lib/Services/Settings.vala"
	_tmp0_ = g_settings_new_with_path (schema, path);
#line 158 "../lib/Services/Settings.vala"
	_tmp1_ = _tmp0_;
#line 158 "../lib/Services/Settings.vala"
	self = (GraniteServicesSettings*) g_object_new (object_type, "schema", _tmp1_, NULL);
#line 158 "../lib/Services/Settings.vala"
	_g_object_unref0 (_tmp1_);
#line 157 "../lib/Services/Settings.vala"
	return self;
#line 359 "Settings.c"
}


static void
_granite_services_settings_load_key_g_settings_changed (GSettings* _sender,
                                                        const gchar* key,
                                                        gpointer self)
{
#line 179 "../lib/Services/Settings.vala"
	granite_services_settings_load_key ((GraniteServicesSettings*) self, key);
#line 370 "Settings.c"
}


static void
granite_services_settings_stop_monitor (GraniteServicesSettings* self)
{
	GSettings* _tmp0_;
	guint _tmp1_;
#line 177 "../lib/Services/Settings.vala"
	g_return_if_fail (self != NULL);
#line 179 "../lib/Services/Settings.vala"
	_tmp0_ = self->priv->_schema;
#line 179 "../lib/Services/Settings.vala"
	g_signal_parse_name ("changed", g_settings_get_type (), &_tmp1_, NULL, FALSE);
#line 179 "../lib/Services/Settings.vala"
	g_signal_handlers_disconnect_matched (_tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _granite_services_settings_load_key_g_settings_changed, self);
#line 387 "Settings.c"
}


static void
granite_services_settings_start_monitor (GraniteServicesSettings* self)
{
	GSettings* _tmp0_;
#line 182 "../lib/Services/Settings.vala"
	g_return_if_fail (self != NULL);
#line 184 "../lib/Services/Settings.vala"
	_tmp0_ = self->priv->_schema;
#line 184 "../lib/Services/Settings.vala"
	g_signal_connect_object (_tmp0_, "changed", (GCallback) _granite_services_settings_load_key_g_settings_changed, self, 0);
#line 401 "Settings.c"
}


static void
_granite_services_settings_handle_notify_g_object_notify (GObject* _sender,
                                                          GParamSpec* pspec,
                                                          gpointer self)
{
#line 189 "../lib/Services/Settings.vala"
	granite_services_settings_handle_notify ((GraniteServicesSettings*) self, _sender, pspec);
#line 412 "Settings.c"
}


static void
granite_services_settings_handle_notify (GraniteServicesSettings* self,
                                         GObject* sender,
                                         GParamSpec* property)
{
	guint _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
#line 187 "../lib/Services/Settings.vala"
	g_return_if_fail (self != NULL);
#line 187 "../lib/Services/Settings.vala"
	g_return_if_fail (sender != NULL);
#line 187 "../lib/Services/Settings.vala"
	g_return_if_fail (property != NULL);
#line 189 "../lib/Services/Settings.vala"
	g_signal_parse_name ("notify", G_TYPE_OBJECT, &_tmp0_, NULL, FALSE);
#line 189 "../lib/Services/Settings.vala"
	g_signal_handlers_disconnect_matched ((GObject*) self, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) _granite_services_settings_handle_notify_g_object_notify, self);
#line 190 "../lib/Services/Settings.vala"
	_tmp1_ = property->name;
#line 190 "../lib/Services/Settings.vala"
	granite_services_settings_call_verify (self, _tmp1_);
#line 191 "../lib/Services/Settings.vala"
	g_signal_connect_object ((GObject*) self, "notify", (GCallback) _granite_services_settings_handle_notify_g_object_notify, self, 0);
#line 193 "../lib/Services/Settings.vala"
	_tmp2_ = property->name;
#line 193 "../lib/Services/Settings.vala"
	granite_services_settings_save_key (self, _tmp2_);
#line 444 "Settings.c"
}


static void
granite_services_settings_handle_verify_notify (GraniteServicesSettings* self,
                                                GObject* sender,
                                                GParamSpec* property)
{
	const gchar* _tmp0_;
	GSettings* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
#line 196 "../lib/Services/Settings.vala"
	g_return_if_fail (self != NULL);
#line 196 "../lib/Services/Settings.vala"
	g_return_if_fail (sender != NULL);
#line 196 "../lib/Services/Settings.vala"
	g_return_if_fail (property != NULL);
#line 198 "../lib/Services/Settings.vala"
	_tmp0_ = property->name;
#line 198 "../lib/Services/Settings.vala"
	_tmp1_ = self->priv->_schema;
#line 198 "../lib/Services/Settings.vala"
	g_object_get (_tmp1_, "schema-id", &_tmp2_, NULL);
#line 198 "../lib/Services/Settings.vala"
	_tmp3_ = _tmp2_;
#line 198 "../lib/Services/Settings.vala"
	_tmp4_ = _tmp3_;
#line 198 "../lib/Services/Settings.vala"
	g_warning ("Settings.vala:198: Key '%s' failed verification in schema '%s', changi" \
"ng value", _tmp0_, _tmp4_);
#line 198 "../lib/Services/Settings.vala"
	_g_free0 (_tmp4_);
#line 478 "Settings.c"
}


static void
_granite_services_settings_handle_verify_notify_g_object_notify (GObject* _sender,
                                                                 GParamSpec* pspec,
                                                                 gpointer self)
{
#line 203 "../lib/Services/Settings.vala"
	granite_services_settings_handle_verify_notify ((GraniteServicesSettings*) self, _sender, pspec);
#line 489 "Settings.c"
}


static void
granite_services_settings_call_verify (GraniteServicesSettings* self,
                                       const gchar* key)
{
	guint _tmp0_;
#line 201 "../lib/Services/Settings.vala"
	g_return_if_fail (self != NULL);
#line 201 "../lib/Services/Settings.vala"
	g_return_if_fail (key != NULL);
#line 203 "../lib/Services/Settings.vala"
	g_signal_connect_object ((GObject*) self, "notify", (GCallback) _granite_services_settings_handle_verify_notify_g_object_notify, self, 0);
#line 204 "../lib/Services/Settings.vala"
	granite_services_settings_verify (self, key);
#line 205 "../lib/Services/Settings.vala"
	g_signal_emit (self, granite_services_settings_signals[GRANITE_SERVICES_SETTINGS_CHANGED_SIGNAL], g_quark_from_string (key));
#line 206 "../lib/Services/Settings.vala"
	g_signal_parse_name ("notify", G_TYPE_OBJECT, &_tmp0_, NULL, FALSE);
#line 206 "../lib/Services/Settings.vala"
	g_signal_handlers_disconnect_matched ((GObject*) self, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) _granite_services_settings_handle_verify_notify_g_object_notify, self);
#line 512 "Settings.c"
}


/**
         * Verify the given key, changing the property if necessary. Refer to the example given for the class.
         *
         * @param key the key in question
         */
static void
granite_services_settings_real_verify (GraniteServicesSettings* self,
                                       const gchar* key)
{
#line 214 "../lib/Services/Settings.vala"
	g_return_if_fail (key != NULL);
#line 527 "Settings.c"
}


void
granite_services_settings_verify (GraniteServicesSettings* self,
                                  const gchar* key)
{
#line 214 "../lib/Services/Settings.vala"
	g_return_if_fail (self != NULL);
#line 214 "../lib/Services/Settings.vala"
	GRANITE_SERVICES_SETTINGS_GET_CLASS (self)->verify (self, key);
#line 539 "Settings.c"
}


static gpointer
_g_param_spec_ref0 (gpointer self)
{
#line 224 "../lib/Services/Settings.vala"
	return self ? g_param_spec_ref (self) : NULL;
#line 548 "Settings.c"
}


static void
granite_services_settings_load_key (GraniteServicesSettings* self,
                                    const gchar* key)
{
	GObjectClass* obj_class = NULL;
	GTypeClass* _tmp0_;
	GParamSpec* prop = NULL;
	GObjectClass* _tmp1_;
	GParamSpec* _tmp2_;
	GParamSpec* _tmp3_;
	GParamSpec* _tmp4_;
	guint _tmp5_;
	GType type = 0UL;
	GParamSpec* _tmp6_;
	GType _tmp7_;
	GValue val = {0};
	GType _tmp8_;
	GValue _tmp9_ = {0};
	GParamSpec* _tmp10_;
	const gchar* _tmp11_;
	GParamSpec* _tmp12_;
	GType _tmp13_;
#line 219 "../lib/Services/Settings.vala"
	g_return_if_fail (self != NULL);
#line 219 "../lib/Services/Settings.vala"
	g_return_if_fail (key != NULL);
#line 220 "../lib/Services/Settings.vala"
	if (g_strcmp0 (key, "schema") == 0) {
#line 221 "../lib/Services/Settings.vala"
		return;
#line 582 "Settings.c"
	}
#line 223 "../lib/Services/Settings.vala"
	_tmp0_ = g_type_class_ref (G_TYPE_FROM_INSTANCE ((GObject*) self));
#line 223 "../lib/Services/Settings.vala"
	obj_class = (GObjectClass*) _tmp0_;
#line 224 "../lib/Services/Settings.vala"
	_tmp1_ = obj_class;
#line 224 "../lib/Services/Settings.vala"
	_tmp2_ = g_object_class_find_property (_tmp1_, key);
#line 224 "../lib/Services/Settings.vala"
	_tmp3_ = _g_param_spec_ref0 (_tmp2_);
#line 224 "../lib/Services/Settings.vala"
	prop = _tmp3_;
#line 228 "../lib/Services/Settings.vala"
	_tmp4_ = prop;
#line 228 "../lib/Services/Settings.vala"
	if (_tmp4_ == NULL) {
#line 229 "../lib/Services/Settings.vala"
		_g_param_spec_unref0 (prop);
#line 229 "../lib/Services/Settings.vala"
		_g_type_class_unref0 (obj_class);
#line 229 "../lib/Services/Settings.vala"
		return;
#line 606 "Settings.c"
	}
#line 231 "../lib/Services/Settings.vala"
	g_signal_parse_name ("notify", G_TYPE_OBJECT, &_tmp5_, NULL, FALSE);
#line 231 "../lib/Services/Settings.vala"
	g_signal_handlers_disconnect_matched ((GObject*) self, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _granite_services_settings_handle_notify_g_object_notify, self);
#line 233 "../lib/Services/Settings.vala"
	_tmp6_ = prop;
#line 233 "../lib/Services/Settings.vala"
	_tmp7_ = _tmp6_->value_type;
#line 233 "../lib/Services/Settings.vala"
	type = _tmp7_;
#line 234 "../lib/Services/Settings.vala"
	_tmp8_ = type;
#line 234 "../lib/Services/Settings.vala"
	g_value_init (&_tmp9_, _tmp8_);
#line 234 "../lib/Services/Settings.vala"
	val = _tmp9_;
#line 235 "../lib/Services/Settings.vala"
	_tmp10_ = prop;
#line 235 "../lib/Services/Settings.vala"
	_tmp11_ = _tmp10_->name;
#line 235 "../lib/Services/Settings.vala"
	g_object_get_property ((GObject*) self, _tmp11_, &val);
#line 237 "../lib/Services/Settings.vala"
	_tmp12_ = prop;
#line 237 "../lib/Services/Settings.vala"
	_tmp13_ = _tmp12_->value_type;
#line 237 "../lib/Services/Settings.vala"
	if (G_VALUE_TYPE (&val) == _tmp13_) {
#line 636 "Settings.c"
		GType _tmp14_;
#line 240 "../lib/Services/Settings.vala"
		_tmp14_ = type;
#line 240 "../lib/Services/Settings.vala"
		if (_tmp14_ == G_TYPE_INT) {
#line 642 "Settings.c"
			GParamSpec* _tmp15_;
			const gchar* _tmp16_;
			GSettings* _tmp17_;
			GValue _tmp18_ = {0};
#line 241 "../lib/Services/Settings.vala"
			_tmp15_ = prop;
#line 241 "../lib/Services/Settings.vala"
			_tmp16_ = _tmp15_->name;
#line 241 "../lib/Services/Settings.vala"
			_tmp17_ = self->priv->_schema;
#line 241 "../lib/Services/Settings.vala"
			g_value_init (&_tmp18_, G_TYPE_INT);
#line 241 "../lib/Services/Settings.vala"
			g_value_set_int (&_tmp18_, g_settings_get_int (_tmp17_, key));
#line 241 "../lib/Services/Settings.vala"
			g_object_set_property ((GObject*) self, _tmp16_, &_tmp18_);
#line 241 "../lib/Services/Settings.vala"
			G_IS_VALUE (&_tmp18_) ? (g_value_unset (&_tmp18_), NULL) : NULL;
#line 661 "Settings.c"
		} else {
			GType _tmp19_;
#line 242 "../lib/Services/Settings.vala"
			_tmp19_ = type;
#line 242 "../lib/Services/Settings.vala"
			if (_tmp19_ == G_TYPE_UINT) {
#line 668 "Settings.c"
				GParamSpec* _tmp20_;
				const gchar* _tmp21_;
				GSettings* _tmp22_;
				GValue _tmp23_ = {0};
#line 243 "../lib/Services/Settings.vala"
				_tmp20_ = prop;
#line 243 "../lib/Services/Settings.vala"
				_tmp21_ = _tmp20_->name;
#line 243 "../lib/Services/Settings.vala"
				_tmp22_ = self->priv->_schema;
#line 243 "../lib/Services/Settings.vala"
				g_value_init (&_tmp23_, G_TYPE_UINT);
#line 243 "../lib/Services/Settings.vala"
				g_value_set_uint (&_tmp23_, g_settings_get_uint (_tmp22_, key));
#line 243 "../lib/Services/Settings.vala"
				g_object_set_property ((GObject*) self, _tmp21_, &_tmp23_);
#line 243 "../lib/Services/Settings.vala"
				G_IS_VALUE (&_tmp23_) ? (g_value_unset (&_tmp23_), NULL) : NULL;
#line 687 "Settings.c"
			} else {
				GType _tmp24_;
#line 244 "../lib/Services/Settings.vala"
				_tmp24_ = type;
#line 244 "../lib/Services/Settings.vala"
				if (_tmp24_ == G_TYPE_DOUBLE) {
#line 694 "Settings.c"
					GParamSpec* _tmp25_;
					const gchar* _tmp26_;
					GSettings* _tmp27_;
					GValue _tmp28_ = {0};
#line 245 "../lib/Services/Settings.vala"
					_tmp25_ = prop;
#line 245 "../lib/Services/Settings.vala"
					_tmp26_ = _tmp25_->name;
#line 245 "../lib/Services/Settings.vala"
					_tmp27_ = self->priv->_schema;
#line 245 "../lib/Services/Settings.vala"
					g_value_init (&_tmp28_, G_TYPE_DOUBLE);
#line 245 "../lib/Services/Settings.vala"
					g_value_set_double (&_tmp28_, g_settings_get_double (_tmp27_, key));
#line 245 "../lib/Services/Settings.vala"
					g_object_set_property ((GObject*) self, _tmp26_, &_tmp28_);
#line 245 "../lib/Services/Settings.vala"
					G_IS_VALUE (&_tmp28_) ? (g_value_unset (&_tmp28_), NULL) : NULL;
#line 713 "Settings.c"
				} else {
					GType _tmp29_;
#line 246 "../lib/Services/Settings.vala"
					_tmp29_ = type;
#line 246 "../lib/Services/Settings.vala"
					if (_tmp29_ == G_TYPE_STRING) {
#line 720 "Settings.c"
						GParamSpec* _tmp30_;
						const gchar* _tmp31_;
						GSettings* _tmp32_;
						gchar* _tmp33_;
						GValue _tmp34_ = {0};
#line 247 "../lib/Services/Settings.vala"
						_tmp30_ = prop;
#line 247 "../lib/Services/Settings.vala"
						_tmp31_ = _tmp30_->name;
#line 247 "../lib/Services/Settings.vala"
						_tmp32_ = self->priv->_schema;
#line 247 "../lib/Services/Settings.vala"
						_tmp33_ = g_settings_get_string (_tmp32_, key);
#line 247 "../lib/Services/Settings.vala"
						g_value_init (&_tmp34_, G_TYPE_STRING);
#line 247 "../lib/Services/Settings.vala"
						g_value_take_string (&_tmp34_, _tmp33_);
#line 247 "../lib/Services/Settings.vala"
						g_object_set_property ((GObject*) self, _tmp31_, &_tmp34_);
#line 247 "../lib/Services/Settings.vala"
						G_IS_VALUE (&_tmp34_) ? (g_value_unset (&_tmp34_), NULL) : NULL;
#line 742 "Settings.c"
					} else {
						GType _tmp35_;
#line 248 "../lib/Services/Settings.vala"
						_tmp35_ = type;
#line 248 "../lib/Services/Settings.vala"
						if (_tmp35_ == G_TYPE_STRV) {
#line 749 "Settings.c"
							GParamSpec* _tmp36_;
							const gchar* _tmp37_;
							GSettings* _tmp38_;
							gchar** _tmp39_;
							gchar** _tmp40_;
							GValue _tmp41_ = {0};
#line 249 "../lib/Services/Settings.vala"
							_tmp36_ = prop;
#line 249 "../lib/Services/Settings.vala"
							_tmp37_ = _tmp36_->name;
#line 249 "../lib/Services/Settings.vala"
							_tmp38_ = self->priv->_schema;
#line 249 "../lib/Services/Settings.vala"
							_tmp40_ = _tmp39_ = g_settings_get_strv (_tmp38_, key);
#line 249 "../lib/Services/Settings.vala"
							g_value_init (&_tmp41_, G_TYPE_STRV);
#line 249 "../lib/Services/Settings.vala"
							g_value_take_boxed (&_tmp41_, _tmp40_);
#line 249 "../lib/Services/Settings.vala"
							g_object_set_property ((GObject*) self, _tmp37_, &_tmp41_);
#line 249 "../lib/Services/Settings.vala"
							G_IS_VALUE (&_tmp41_) ? (g_value_unset (&_tmp41_), NULL) : NULL;
#line 772 "Settings.c"
						} else {
							GType _tmp42_;
#line 250 "../lib/Services/Settings.vala"
							_tmp42_ = type;
#line 250 "../lib/Services/Settings.vala"
							if (_tmp42_ == G_TYPE_BOOLEAN) {
#line 779 "Settings.c"
								GParamSpec* _tmp43_;
								const gchar* _tmp44_;
								GSettings* _tmp45_;
								GValue _tmp46_ = {0};
#line 251 "../lib/Services/Settings.vala"
								_tmp43_ = prop;
#line 251 "../lib/Services/Settings.vala"
								_tmp44_ = _tmp43_->name;
#line 251 "../lib/Services/Settings.vala"
								_tmp45_ = self->priv->_schema;
#line 251 "../lib/Services/Settings.vala"
								g_value_init (&_tmp46_, G_TYPE_BOOLEAN);
#line 251 "../lib/Services/Settings.vala"
								g_value_set_boolean (&_tmp46_, g_settings_get_boolean (_tmp45_, key));
#line 251 "../lib/Services/Settings.vala"
								g_object_set_property ((GObject*) self, _tmp44_, &_tmp46_);
#line 251 "../lib/Services/Settings.vala"
								G_IS_VALUE (&_tmp46_) ? (g_value_unset (&_tmp46_), NULL) : NULL;
#line 798 "Settings.c"
							} else {
								GType _tmp47_;
#line 252 "../lib/Services/Settings.vala"
								_tmp47_ = type;
#line 252 "../lib/Services/Settings.vala"
								if (_tmp47_ == G_TYPE_INT64) {
#line 805 "Settings.c"
									GParamSpec* _tmp48_;
									const gchar* _tmp49_;
									GSettings* _tmp50_;
									GVariant* _tmp51_;
									GVariant* _tmp52_;
									GValue _tmp53_ = {0};
#line 253 "../lib/Services/Settings.vala"
									_tmp48_ = prop;
#line 253 "../lib/Services/Settings.vala"
									_tmp49_ = _tmp48_->name;
#line 253 "../lib/Services/Settings.vala"
									_tmp50_ = self->priv->_schema;
#line 253 "../lib/Services/Settings.vala"
									_tmp51_ = g_settings_get_value (_tmp50_, key);
#line 253 "../lib/Services/Settings.vala"
									_tmp52_ = _tmp51_;
#line 253 "../lib/Services/Settings.vala"
									g_value_init (&_tmp53_, G_TYPE_INT64);
#line 253 "../lib/Services/Settings.vala"
									g_value_set_int64 (&_tmp53_, g_variant_get_int64 (_tmp52_));
#line 253 "../lib/Services/Settings.vala"
									g_object_set_property ((GObject*) self, _tmp49_, &_tmp53_);
#line 253 "../lib/Services/Settings.vala"
									G_IS_VALUE (&_tmp53_) ? (g_value_unset (&_tmp53_), NULL) : NULL;
#line 253 "../lib/Services/Settings.vala"
									_g_variant_unref0 (_tmp52_);
#line 832 "Settings.c"
								} else {
									GType _tmp54_;
#line 254 "../lib/Services/Settings.vala"
									_tmp54_ = type;
#line 254 "../lib/Services/Settings.vala"
									if (_tmp54_ == G_TYPE_UINT64) {
#line 839 "Settings.c"
										GParamSpec* _tmp55_;
										const gchar* _tmp56_;
										GSettings* _tmp57_;
										GVariant* _tmp58_;
										GVariant* _tmp59_;
										GValue _tmp60_ = {0};
#line 255 "../lib/Services/Settings.vala"
										_tmp55_ = prop;
#line 255 "../lib/Services/Settings.vala"
										_tmp56_ = _tmp55_->name;
#line 255 "../lib/Services/Settings.vala"
										_tmp57_ = self->priv->_schema;
#line 255 "../lib/Services/Settings.vala"
										_tmp58_ = g_settings_get_value (_tmp57_, key);
#line 255 "../lib/Services/Settings.vala"
										_tmp59_ = _tmp58_;
#line 255 "../lib/Services/Settings.vala"
										g_value_init (&_tmp60_, G_TYPE_UINT64);
#line 255 "../lib/Services/Settings.vala"
										g_value_set_uint64 (&_tmp60_, g_variant_get_uint64 (_tmp59_));
#line 255 "../lib/Services/Settings.vala"
										g_object_set_property ((GObject*) self, _tmp56_, &_tmp60_);
#line 255 "../lib/Services/Settings.vala"
										G_IS_VALUE (&_tmp60_) ? (g_value_unset (&_tmp60_), NULL) : NULL;
#line 255 "../lib/Services/Settings.vala"
										_g_variant_unref0 (_tmp59_);
#line 866 "Settings.c"
									} else {
										GType _tmp61_;
#line 256 "../lib/Services/Settings.vala"
										_tmp61_ = type;
#line 256 "../lib/Services/Settings.vala"
										if (G_TYPE_IS_ENUM (_tmp61_)) {
#line 873 "Settings.c"
											GParamSpec* _tmp62_;
											const gchar* _tmp63_;
											GSettings* _tmp64_;
											GValue _tmp65_ = {0};
#line 257 "../lib/Services/Settings.vala"
											_tmp62_ = prop;
#line 257 "../lib/Services/Settings.vala"
											_tmp63_ = _tmp62_->name;
#line 257 "../lib/Services/Settings.vala"
											_tmp64_ = self->priv->_schema;
#line 257 "../lib/Services/Settings.vala"
											g_value_init (&_tmp65_, G_TYPE_INT);
#line 257 "../lib/Services/Settings.vala"
											g_value_set_int (&_tmp65_, g_settings_get_enum (_tmp64_, key));
#line 257 "../lib/Services/Settings.vala"
											g_object_set_property ((GObject*) self, _tmp63_, &_tmp65_);
#line 257 "../lib/Services/Settings.vala"
											G_IS_VALUE (&_tmp65_) ? (g_value_unset (&_tmp65_), NULL) : NULL;
#line 892 "Settings.c"
										}
									}
								}
							}
						}
					}
				}
			}
		}
	} else {
		GType _tmp66_;
#line 258 "../lib/Services/Settings.vala"
		_tmp66_ = type;
#line 258 "../lib/Services/Settings.vala"
		if (g_type_is_a (_tmp66_, GRANITE_SERVICES_TYPE_SETTINGS_SERIALIZABLE)) {
#line 908 "Settings.c"
			GObject* _tmp67_;
			GSettings* _tmp68_;
			gchar* _tmp69_;
			gchar* _tmp70_;
#line 259 "../lib/Services/Settings.vala"
			g_object_get_property ((GObject*) self, key, &val);
#line 260 "../lib/Services/Settings.vala"
			_tmp67_ = g_value_get_object (&val);
#line 260 "../lib/Services/Settings.vala"
			_tmp68_ = self->priv->_schema;
#line 260 "../lib/Services/Settings.vala"
			_tmp69_ = g_settings_get_string (_tmp68_, key);
#line 260 "../lib/Services/Settings.vala"
			_tmp70_ = _tmp69_;
#line 260 "../lib/Services/Settings.vala"
			granite_services_settings_serializable_settings_deserialize (G_TYPE_CHECK_INSTANCE_TYPE (_tmp67_, GRANITE_SERVICES_TYPE_SETTINGS_SERIALIZABLE) ? ((GraniteServicesSettingsSerializable*) _tmp67_) : NULL, _tmp70_);
#line 260 "../lib/Services/Settings.vala"
			_g_free0 (_tmp70_);
#line 261 "../lib/Services/Settings.vala"
			g_signal_connect_object ((GObject*) self, "notify", (GCallback) _granite_services_settings_handle_notify_g_object_notify, self, 0);
#line 262 "../lib/Services/Settings.vala"
			G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 262 "../lib/Services/Settings.vala"
			_g_param_spec_unref0 (prop);
#line 262 "../lib/Services/Settings.vala"
			_g_type_class_unref0 (obj_class);
#line 262 "../lib/Services/Settings.vala"
			return;
#line 937 "Settings.c"
		} else {
			GType _tmp71_;
			const gchar* _tmp72_;
			GSettings* _tmp73_;
			gchar* _tmp74_;
			gchar* _tmp75_;
			gchar* _tmp76_;
#line 264 "../lib/Services/Settings.vala"
			_tmp71_ = type;
#line 264 "../lib/Services/Settings.vala"
			_tmp72_ = g_type_name (_tmp71_);
#line 264 "../lib/Services/Settings.vala"
			_tmp73_ = self->priv->_schema;
#line 264 "../lib/Services/Settings.vala"
			g_object_get (_tmp73_, "schema-id", &_tmp74_, NULL);
#line 264 "../lib/Services/Settings.vala"
			_tmp75_ = _tmp74_;
#line 264 "../lib/Services/Settings.vala"
			_tmp76_ = _tmp75_;
#line 264 "../lib/Services/Settings.vala"
			g_debug ("Settings.vala:264: Unsupported settings type '%s' for key '%s' in sche" \
"ma '%s'", _tmp72_, key, _tmp76_);
#line 264 "../lib/Services/Settings.vala"
			_g_free0 (_tmp76_);
#line 265 "../lib/Services/Settings.vala"
			g_signal_connect_object ((GObject*) self, "notify", (GCallback) _granite_services_settings_handle_notify_g_object_notify, self, 0);
#line 266 "../lib/Services/Settings.vala"
			G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 266 "../lib/Services/Settings.vala"
			_g_param_spec_unref0 (prop);
#line 266 "../lib/Services/Settings.vala"
			_g_type_class_unref0 (obj_class);
#line 266 "../lib/Services/Settings.vala"
			return;
#line 971 "Settings.c"
		}
	}
#line 269 "../lib/Services/Settings.vala"
	granite_services_settings_call_verify (self, key);
#line 271 "../lib/Services/Settings.vala"
	g_signal_connect_object ((GObject*) self, "notify", (GCallback) _granite_services_settings_handle_notify_g_object_notify, self, 0);
#line 219 "../lib/Services/Settings.vala"
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 219 "../lib/Services/Settings.vala"
	_g_param_spec_unref0 (prop);
#line 219 "../lib/Services/Settings.vala"
	_g_type_class_unref0 (obj_class);
#line 984 "Settings.c"
}


static void
granite_services_settings_save_key (GraniteServicesSettings* self,
                                    const gchar* key)
{
	gboolean _tmp0_ = FALSE;
	GObjectClass* obj_class = NULL;
	GTypeClass* _tmp2_;
	GParamSpec* prop = NULL;
	GObjectClass* _tmp3_;
	GParamSpec* _tmp4_;
	GParamSpec* _tmp5_;
	GParamSpec* _tmp6_;
	gboolean success = FALSE;
	guint _tmp7_;
	GType type = 0UL;
	GParamSpec* _tmp8_;
	GType _tmp9_;
	GValue val = {0};
	GType _tmp10_;
	GValue _tmp11_ = {0};
	GParamSpec* _tmp12_;
	const gchar* _tmp13_;
	GParamSpec* _tmp14_;
	GType _tmp15_;
	gboolean _tmp75_;
#line 274 "../lib/Services/Settings.vala"
	g_return_if_fail (self != NULL);
#line 274 "../lib/Services/Settings.vala"
	g_return_if_fail (key != NULL);
#line 275 "../lib/Services/Settings.vala"
	if (g_strcmp0 (key, "schema") == 0) {
#line 275 "../lib/Services/Settings.vala"
		_tmp0_ = TRUE;
#line 1021 "Settings.c"
	} else {
		gboolean _tmp1_;
#line 275 "../lib/Services/Settings.vala"
		_tmp1_ = self->priv->saving_key;
#line 275 "../lib/Services/Settings.vala"
		_tmp0_ = _tmp1_;
#line 1028 "Settings.c"
	}
#line 275 "../lib/Services/Settings.vala"
	if (_tmp0_) {
#line 276 "../lib/Services/Settings.vala"
		return;
#line 1034 "Settings.c"
	}
#line 278 "../lib/Services/Settings.vala"
	_tmp2_ = g_type_class_ref (G_TYPE_FROM_INSTANCE ((GObject*) self));
#line 278 "../lib/Services/Settings.vala"
	obj_class = (GObjectClass*) _tmp2_;
#line 279 "../lib/Services/Settings.vala"
	_tmp3_ = obj_class;
#line 279 "../lib/Services/Settings.vala"
	_tmp4_ = g_object_class_find_property (_tmp3_, key);
#line 279 "../lib/Services/Settings.vala"
	_tmp5_ = _g_param_spec_ref0 (_tmp4_);
#line 279 "../lib/Services/Settings.vala"
	prop = _tmp5_;
#line 282 "../lib/Services/Settings.vala"
	_tmp6_ = prop;
#line 282 "../lib/Services/Settings.vala"
	if (_tmp6_ == NULL) {
#line 283 "../lib/Services/Settings.vala"
		_g_param_spec_unref0 (prop);
#line 283 "../lib/Services/Settings.vala"
		_g_type_class_unref0 (obj_class);
#line 283 "../lib/Services/Settings.vala"
		return;
#line 1058 "Settings.c"
	}
#line 285 "../lib/Services/Settings.vala"
	success = TRUE;
#line 287 "../lib/Services/Settings.vala"
	self->priv->saving_key = TRUE;
#line 288 "../lib/Services/Settings.vala"
	g_signal_parse_name ("notify", G_TYPE_OBJECT, &_tmp7_, NULL, FALSE);
#line 288 "../lib/Services/Settings.vala"
	g_signal_handlers_disconnect_matched ((GObject*) self, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp7_, 0, NULL, (GCallback) _granite_services_settings_handle_notify_g_object_notify, self);
#line 290 "../lib/Services/Settings.vala"
	_tmp8_ = prop;
#line 290 "../lib/Services/Settings.vala"
	_tmp9_ = _tmp8_->value_type;
#line 290 "../lib/Services/Settings.vala"
	type = _tmp9_;
#line 291 "../lib/Services/Settings.vala"
	_tmp10_ = type;
#line 291 "../lib/Services/Settings.vala"
	g_value_init (&_tmp11_, _tmp10_);
#line 291 "../lib/Services/Settings.vala"
	val = _tmp11_;
#line 292 "../lib/Services/Settings.vala"
	_tmp12_ = prop;
#line 292 "../lib/Services/Settings.vala"
	_tmp13_ = _tmp12_->name;
#line 292 "../lib/Services/Settings.vala"
	g_object_get_property ((GObject*) self, _tmp13_, &val);
#line 294 "../lib/Services/Settings.vala"
	_tmp14_ = prop;
#line 294 "../lib/Services/Settings.vala"
	_tmp15_ = _tmp14_->value_type;
#line 294 "../lib/Services/Settings.vala"
	if (G_VALUE_TYPE (&val) == _tmp15_) {
#line 1092 "Settings.c"
		GType _tmp16_;
#line 295 "../lib/Services/Settings.vala"
		_tmp16_ = type;
#line 295 "../lib/Services/Settings.vala"
		if (_tmp16_ == G_TYPE_INT) {
#line 1098 "Settings.c"
			GSettings* _tmp17_;
#line 296 "../lib/Services/Settings.vala"
			_tmp17_ = self->priv->_schema;
#line 296 "../lib/Services/Settings.vala"
			if (g_value_get_int (&val) != g_settings_get_int (_tmp17_, key)) {
#line 1104 "Settings.c"
				GSettings* _tmp18_;
#line 297 "../lib/Services/Settings.vala"
				_tmp18_ = self->priv->_schema;
#line 297 "../lib/Services/Settings.vala"
				success = g_settings_set_int (_tmp18_, key, g_value_get_int (&val));
#line 1110 "Settings.c"
			}
		} else {
			GType _tmp19_;
#line 299 "../lib/Services/Settings.vala"
			_tmp19_ = type;
#line 299 "../lib/Services/Settings.vala"
			if (_tmp19_ == G_TYPE_UINT) {
#line 1118 "Settings.c"
				GSettings* _tmp20_;
#line 300 "../lib/Services/Settings.vala"
				_tmp20_ = self->priv->_schema;
#line 300 "../lib/Services/Settings.vala"
				if (g_value_get_uint (&val) != g_settings_get_uint (_tmp20_, key)) {
#line 1124 "Settings.c"
					GSettings* _tmp21_;
#line 301 "../lib/Services/Settings.vala"
					_tmp21_ = self->priv->_schema;
#line 301 "../lib/Services/Settings.vala"
					success = g_settings_set_uint (_tmp21_, key, g_value_get_uint (&val));
#line 1130 "Settings.c"
				}
			} else {
				GType _tmp22_;
#line 303 "../lib/Services/Settings.vala"
				_tmp22_ = type;
#line 303 "../lib/Services/Settings.vala"
				if (_tmp22_ == G_TYPE_INT64) {
#line 1138 "Settings.c"
					GSettings* _tmp23_;
					GVariant* _tmp24_;
					GVariant* _tmp25_;
					gboolean _tmp26_;
#line 304 "../lib/Services/Settings.vala"
					_tmp23_ = self->priv->_schema;
#line 304 "../lib/Services/Settings.vala"
					_tmp24_ = g_settings_get_value (_tmp23_, key);
#line 304 "../lib/Services/Settings.vala"
					_tmp25_ = _tmp24_;
#line 304 "../lib/Services/Settings.vala"
					_tmp26_ = g_value_get_int64 (&val) != g_variant_get_int64 (_tmp25_);
#line 304 "../lib/Services/Settings.vala"
					_g_variant_unref0 (_tmp25_);
#line 304 "../lib/Services/Settings.vala"
					if (_tmp26_) {
#line 1155 "Settings.c"
						GSettings* _tmp27_;
						GVariant* _tmp28_;
						GVariant* _tmp29_;
#line 305 "../lib/Services/Settings.vala"
						_tmp27_ = self->priv->_schema;
#line 305 "../lib/Services/Settings.vala"
						_tmp28_ = g_variant_new_int64 (g_value_get_int64 (&val));
#line 305 "../lib/Services/Settings.vala"
						g_variant_ref_sink (_tmp28_);
#line 305 "../lib/Services/Settings.vala"
						_tmp29_ = _tmp28_;
#line 305 "../lib/Services/Settings.vala"
						success = g_settings_set_value (_tmp27_, key, _tmp29_);
#line 305 "../lib/Services/Settings.vala"
						_g_variant_unref0 (_tmp29_);
#line 1171 "Settings.c"
					}
				} else {
					GType _tmp30_;
#line 307 "../lib/Services/Settings.vala"
					_tmp30_ = type;
#line 307 "../lib/Services/Settings.vala"
					if (_tmp30_ == G_TYPE_UINT64) {
#line 1179 "Settings.c"
						GSettings* _tmp31_;
						GVariant* _tmp32_;
						GVariant* _tmp33_;
						gboolean _tmp34_;
#line 308 "../lib/Services/Settings.vala"
						_tmp31_ = self->priv->_schema;
#line 308 "../lib/Services/Settings.vala"
						_tmp32_ = g_settings_get_value (_tmp31_, key);
#line 308 "../lib/Services/Settings.vala"
						_tmp33_ = _tmp32_;
#line 308 "../lib/Services/Settings.vala"
						_tmp34_ = g_value_get_uint64 (&val) != g_variant_get_uint64 (_tmp33_);
#line 308 "../lib/Services/Settings.vala"
						_g_variant_unref0 (_tmp33_);
#line 308 "../lib/Services/Settings.vala"
						if (_tmp34_) {
#line 1196 "Settings.c"
							GSettings* _tmp35_;
							GVariant* _tmp36_;
							GVariant* _tmp37_;
#line 309 "../lib/Services/Settings.vala"
							_tmp35_ = self->priv->_schema;
#line 309 "../lib/Services/Settings.vala"
							_tmp36_ = g_variant_new_uint64 (g_value_get_uint64 (&val));
#line 309 "../lib/Services/Settings.vala"
							g_variant_ref_sink (_tmp36_);
#line 309 "../lib/Services/Settings.vala"
							_tmp37_ = _tmp36_;
#line 309 "../lib/Services/Settings.vala"
							success = g_settings_set_value (_tmp35_, key, _tmp37_);
#line 309 "../lib/Services/Settings.vala"
							_g_variant_unref0 (_tmp37_);
#line 1212 "Settings.c"
						}
					} else {
						GType _tmp38_;
#line 311 "../lib/Services/Settings.vala"
						_tmp38_ = type;
#line 311 "../lib/Services/Settings.vala"
						if (_tmp38_ == G_TYPE_DOUBLE) {
#line 1220 "Settings.c"
							GSettings* _tmp39_;
#line 312 "../lib/Services/Settings.vala"
							_tmp39_ = self->priv->_schema;
#line 312 "../lib/Services/Settings.vala"
							if (g_value_get_double (&val) != g_settings_get_double (_tmp39_, key)) {
#line 1226 "Settings.c"
								GSettings* _tmp40_;
#line 313 "../lib/Services/Settings.vala"
								_tmp40_ = self->priv->_schema;
#line 313 "../lib/Services/Settings.vala"
								success = g_settings_set_double (_tmp40_, key, g_value_get_double (&val));
#line 1232 "Settings.c"
							}
						} else {
							GType _tmp41_;
#line 315 "../lib/Services/Settings.vala"
							_tmp41_ = type;
#line 315 "../lib/Services/Settings.vala"
							if (_tmp41_ == G_TYPE_STRING) {
#line 1240 "Settings.c"
								const gchar* _tmp42_;
								GSettings* _tmp43_;
								gchar* _tmp44_;
								gchar* _tmp45_;
								gboolean _tmp46_;
#line 316 "../lib/Services/Settings.vala"
								_tmp42_ = g_value_get_string (&val);
#line 316 "../lib/Services/Settings.vala"
								_tmp43_ = self->priv->_schema;
#line 316 "../lib/Services/Settings.vala"
								_tmp44_ = g_settings_get_string (_tmp43_, key);
#line 316 "../lib/Services/Settings.vala"
								_tmp45_ = _tmp44_;
#line 316 "../lib/Services/Settings.vala"
								_tmp46_ = g_strcmp0 (_tmp42_, _tmp45_) != 0;
#line 316 "../lib/Services/Settings.vala"
								_g_free0 (_tmp45_);
#line 316 "../lib/Services/Settings.vala"
								if (_tmp46_) {
#line 1260 "Settings.c"
									GSettings* _tmp47_;
									const gchar* _tmp48_;
#line 317 "../lib/Services/Settings.vala"
									_tmp47_ = self->priv->_schema;
#line 317 "../lib/Services/Settings.vala"
									_tmp48_ = g_value_get_string (&val);
#line 317 "../lib/Services/Settings.vala"
									success = g_settings_set_string (_tmp47_, key, _tmp48_);
#line 1269 "Settings.c"
								}
							} else {
								GType _tmp49_;
#line 319 "../lib/Services/Settings.vala"
								_tmp49_ = type;
#line 319 "../lib/Services/Settings.vala"
								if (_tmp49_ == G_TYPE_STRV) {
#line 1277 "Settings.c"
									gchar** strings = NULL;
									gint strings_length1;
									gint _strings_size_;
									gchar** _tmp50_;
									gint _tmp50__length1;
									GSettings* _tmp51_;
									gchar** _tmp52_;
									gchar** _tmp53_;
									gchar** _tmp54_;
									gint _tmp54__length1;
									gboolean _tmp55_;
#line 320 "../lib/Services/Settings.vala"
									strings = NULL;
#line 320 "../lib/Services/Settings.vala"
									strings_length1 = 0;
#line 320 "../lib/Services/Settings.vala"
									_strings_size_ = strings_length1;
#line 321 "../lib/Services/Settings.vala"
									g_object_get ((GObject*) self, key, &strings, NULL);
#line 322 "../lib/Services/Settings.vala"
									_tmp50_ = strings;
#line 322 "../lib/Services/Settings.vala"
									_tmp50__length1 = strings_length1;
#line 322 "../lib/Services/Settings.vala"
									_tmp51_ = self->priv->_schema;
#line 322 "../lib/Services/Settings.vala"
									_tmp53_ = _tmp52_ = g_settings_get_strv (_tmp51_, key);
#line 322 "../lib/Services/Settings.vala"
									_tmp54_ = _tmp53_;
#line 322 "../lib/Services/Settings.vala"
									_tmp54__length1 = _vala_array_length (_tmp52_);
#line 322 "../lib/Services/Settings.vala"
									_tmp55_ = _tmp50_ != _tmp54_;
#line 322 "../lib/Services/Settings.vala"
									_tmp54_ = (_vala_array_free (_tmp54_, _tmp54__length1, (GDestroyNotify) g_free), NULL);
#line 322 "../lib/Services/Settings.vala"
									if (_tmp55_) {
#line 1315 "Settings.c"
										GSettings* _tmp56_;
										gchar** _tmp57_;
										gint _tmp57__length1;
#line 323 "../lib/Services/Settings.vala"
										_tmp56_ = self->priv->_schema;
#line 323 "../lib/Services/Settings.vala"
										_tmp57_ = strings;
#line 323 "../lib/Services/Settings.vala"
										_tmp57__length1 = strings_length1;
#line 323 "../lib/Services/Settings.vala"
										success = g_settings_set_strv (_tmp56_, key, _tmp57_);
#line 1327 "Settings.c"
									}
#line 319 "../lib/Services/Settings.vala"
									strings = (_vala_array_free (strings, strings_length1, (GDestroyNotify) g_free), NULL);
#line 1331 "Settings.c"
								} else {
									GType _tmp58_;
#line 325 "../lib/Services/Settings.vala"
									_tmp58_ = type;
#line 325 "../lib/Services/Settings.vala"
									if (_tmp58_ == G_TYPE_BOOLEAN) {
#line 1338 "Settings.c"
										GSettings* _tmp59_;
#line 326 "../lib/Services/Settings.vala"
										_tmp59_ = self->priv->_schema;
#line 326 "../lib/Services/Settings.vala"
										if (g_value_get_boolean (&val) != g_settings_get_boolean (_tmp59_, key)) {
#line 1344 "Settings.c"
											GSettings* _tmp60_;
#line 327 "../lib/Services/Settings.vala"
											_tmp60_ = self->priv->_schema;
#line 327 "../lib/Services/Settings.vala"
											success = g_settings_set_boolean (_tmp60_, key, g_value_get_boolean (&val));
#line 1350 "Settings.c"
										}
									} else {
										GType _tmp61_;
#line 329 "../lib/Services/Settings.vala"
										_tmp61_ = type;
#line 329 "../lib/Services/Settings.vala"
										if (G_TYPE_IS_ENUM (_tmp61_)) {
#line 1358 "Settings.c"
											GSettings* _tmp62_;
#line 330 "../lib/Services/Settings.vala"
											_tmp62_ = self->priv->_schema;
#line 330 "../lib/Services/Settings.vala"
											if (g_value_get_enum (&val) != g_settings_get_enum (_tmp62_, key)) {
#line 1364 "Settings.c"
												GSettings* _tmp63_;
#line 331 "../lib/Services/Settings.vala"
												_tmp63_ = self->priv->_schema;
#line 331 "../lib/Services/Settings.vala"
												success = g_settings_set_enum (_tmp63_, key, g_value_get_enum (&val));
#line 1370 "Settings.c"
											}
										}
									}
								}
							}
						}
					}
				}
			}
		}
	} else {
		GType _tmp64_;
#line 335 "../lib/Services/Settings.vala"
		_tmp64_ = type;
#line 335 "../lib/Services/Settings.vala"
		if (g_type_is_a (_tmp64_, GRANITE_SERVICES_TYPE_SETTINGS_SERIALIZABLE)) {
#line 1387 "Settings.c"
			GSettings* _tmp65_;
			GObject* _tmp66_;
			gchar* _tmp67_;
			gchar* _tmp68_;
#line 336 "../lib/Services/Settings.vala"
			_tmp65_ = self->priv->_schema;
#line 336 "../lib/Services/Settings.vala"
			_tmp66_ = g_value_get_object (&val);
#line 336 "../lib/Services/Settings.vala"
			_tmp67_ = granite_services_settings_serializable_settings_serialize (G_TYPE_CHECK_INSTANCE_TYPE (_tmp66_, GRANITE_SERVICES_TYPE_SETTINGS_SERIALIZABLE) ? ((GraniteServicesSettingsSerializable*) _tmp66_) : NULL);
#line 336 "../lib/Services/Settings.vala"
			_tmp68_ = _tmp67_;
#line 336 "../lib/Services/Settings.vala"
			success = g_settings_set_string (_tmp65_, key, _tmp68_);
#line 336 "../lib/Services/Settings.vala"
			_g_free0 (_tmp68_);
#line 1404 "Settings.c"
		} else {
			GType _tmp69_;
			const gchar* _tmp70_;
			GSettings* _tmp71_;
			gchar* _tmp72_;
			gchar* _tmp73_;
			gchar* _tmp74_;
#line 338 "../lib/Services/Settings.vala"
			_tmp69_ = type;
#line 338 "../lib/Services/Settings.vala"
			_tmp70_ = g_type_name (_tmp69_);
#line 338 "../lib/Services/Settings.vala"
			_tmp71_ = self->priv->_schema;
#line 338 "../lib/Services/Settings.vala"
			g_object_get (_tmp71_, "schema-id", &_tmp72_, NULL);
#line 338 "../lib/Services/Settings.vala"
			_tmp73_ = _tmp72_;
#line 338 "../lib/Services/Settings.vala"
			_tmp74_ = _tmp73_;
#line 338 "../lib/Services/Settings.vala"
			g_debug ("Settings.vala:338: Unsupported settings type '%s' for key '%s' in sche" \
"ma '%s'", _tmp70_, key, _tmp74_);
#line 338 "../lib/Services/Settings.vala"
			_g_free0 (_tmp74_);
#line 1428 "Settings.c"
		}
	}
#line 340 "../lib/Services/Settings.vala"
	_tmp75_ = success;
#line 340 "../lib/Services/Settings.vala"
	if (!_tmp75_) {
#line 341 "../lib/Services/Settings.vala"
		g_warning ("Settings.vala:341: Key '%s' could not be written to.", key);
#line 1437 "Settings.c"
	}
#line 343 "../lib/Services/Settings.vala"
	g_signal_connect_object ((GObject*) self, "notify", (GCallback) _granite_services_settings_handle_notify_g_object_notify, self, 0);
#line 344 "../lib/Services/Settings.vala"
	self->priv->saving_key = FALSE;
#line 274 "../lib/Services/Settings.vala"
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 274 "../lib/Services/Settings.vala"
	_g_param_spec_unref0 (prop);
#line 274 "../lib/Services/Settings.vala"
	_g_type_class_unref0 (obj_class);
#line 1449 "Settings.c"
}


GSettings*
granite_services_settings_get_schema (GraniteServicesSettings* self)
{
	GSettings* result;
	GSettings* _tmp0_;
#line 113 "../lib/Services/Settings.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 113 "../lib/Services/Settings.vala"
	_tmp0_ = self->priv->_schema;
#line 113 "../lib/Services/Settings.vala"
	result = _tmp0_;
#line 113 "../lib/Services/Settings.vala"
	return result;
#line 1466 "Settings.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 113 "../lib/Services/Settings.vala"
	return self ? g_object_ref (self) : NULL;
#line 1475 "Settings.c"
}


static void
granite_services_settings_set_schema (GraniteServicesSettings* self,
                                      GSettings* value)
{
#line 113 "../lib/Services/Settings.vala"
	g_return_if_fail (self != NULL);
#line 113 "../lib/Services/Settings.vala"
	if (granite_services_settings_get_schema (self) != value) {
#line 1487 "Settings.c"
		GSettings* _tmp0_;
#line 113 "../lib/Services/Settings.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 113 "../lib/Services/Settings.vala"
		_g_object_unref0 (self->priv->_schema);
#line 113 "../lib/Services/Settings.vala"
		self->priv->_schema = _tmp0_;
#line 113 "../lib/Services/Settings.vala"
		g_object_notify_by_pspec ((GObject *) self, granite_services_settings_properties[GRANITE_SERVICES_SETTINGS_SCHEMA_PROPERTY]);
#line 1497 "Settings.c"
	}
}


static GObject *
granite_services_settings_constructor (GType type,
                                       guint n_construct_properties,
                                       GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GraniteServicesSettings * self;
	GSettings* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GObjectClass* obj_class = NULL;
	GTypeClass* _tmp4_;
	GParamSpec** properties = NULL;
	GObjectClass* _tmp5_;
	guint _tmp6_ = 0;
	GParamSpec** _tmp7_;
	gint properties_length1;
	gint _properties_size_;
	GParamSpec** _tmp8_;
	gint _tmp8__length1;
#line 161 "../lib/Services/Settings.vala"
	parent_class = G_OBJECT_CLASS (granite_services_settings_parent_class);
#line 161 "../lib/Services/Settings.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 161 "../lib/Services/Settings.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GRANITE_SERVICES_TYPE_SETTINGS, GraniteServicesSettings);
#line 163 "../lib/Services/Settings.vala"
	_tmp0_ = self->priv->_schema;
#line 163 "../lib/Services/Settings.vala"
	g_object_get (_tmp0_, "schema-id", &_tmp1_, NULL);
#line 163 "../lib/Services/Settings.vala"
	_tmp2_ = _tmp1_;
#line 163 "../lib/Services/Settings.vala"
	_tmp3_ = _tmp2_;
#line 163 "../lib/Services/Settings.vala"
	g_debug ("Settings.vala:163: Loading settings from schema '%s'", _tmp3_);
#line 163 "../lib/Services/Settings.vala"
	_g_free0 (_tmp3_);
#line 165 "../lib/Services/Settings.vala"
	_tmp4_ = g_type_class_ref (G_TYPE_FROM_INSTANCE ((GObject*) self));
#line 165 "../lib/Services/Settings.vala"
	obj_class = (GObjectClass*) _tmp4_;
#line 166 "../lib/Services/Settings.vala"
	_tmp5_ = obj_class;
#line 166 "../lib/Services/Settings.vala"
	_tmp7_ = g_object_class_list_properties (_tmp5_, &_tmp6_);
#line 166 "../lib/Services/Settings.vala"
	properties = _tmp7_;
#line 166 "../lib/Services/Settings.vala"
	properties_length1 = _tmp6_;
#line 166 "../lib/Services/Settings.vala"
	_properties_size_ = properties_length1;
#line 167 "../lib/Services/Settings.vala"
	_tmp8_ = properties;
#line 167 "../lib/Services/Settings.vala"
	_tmp8__length1 = properties_length1;
#line 1560 "Settings.c"
	{
		GParamSpec** prop_collection = NULL;
		gint prop_collection_length1 = 0;
		gint _prop_collection_size_ = 0;
		gint prop_it = 0;
#line 167 "../lib/Services/Settings.vala"
		prop_collection = _tmp8_;
#line 167 "../lib/Services/Settings.vala"
		prop_collection_length1 = _tmp8__length1;
#line 167 "../lib/Services/Settings.vala"
		for (prop_it = 0; prop_it < _tmp8__length1; prop_it = prop_it + 1) {
#line 1572 "Settings.c"
			GParamSpec* prop = NULL;
#line 167 "../lib/Services/Settings.vala"
			prop = prop_collection[prop_it];
#line 1576 "Settings.c"
			{
				GParamSpec* _tmp9_;
				const gchar* _tmp10_;
#line 168 "../lib/Services/Settings.vala"
				_tmp9_ = prop;
#line 168 "../lib/Services/Settings.vala"
				_tmp10_ = _tmp9_->name;
#line 168 "../lib/Services/Settings.vala"
				granite_services_settings_load_key (self, _tmp10_);
#line 1586 "Settings.c"
			}
		}
	}
#line 170 "../lib/Services/Settings.vala"
	granite_services_settings_start_monitor (self);
#line 161 "../lib/Services/Settings.vala"
	properties = (g_free (properties), NULL);
#line 161 "../lib/Services/Settings.vala"
	_g_type_class_unref0 (obj_class);
#line 161 "../lib/Services/Settings.vala"
	return obj;
#line 1598 "Settings.c"
}


static void
granite_services_settings_class_init (GraniteServicesSettingsClass * klass)
{
#line 94 "../lib/Services/Settings.vala"
	granite_services_settings_parent_class = g_type_class_peek_parent (klass);
#line 94 "../lib/Services/Settings.vala"
	g_type_class_adjust_private_offset (klass, &GraniteServicesSettings_private_offset);
#line 94 "../lib/Services/Settings.vala"
	((GraniteServicesSettingsClass *) klass)->verify = (void (*) (GraniteServicesSettings*, const gchar*)) granite_services_settings_real_verify;
#line 94 "../lib/Services/Settings.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_granite_services_settings_get_property;
#line 94 "../lib/Services/Settings.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_granite_services_settings_set_property;
#line 94 "../lib/Services/Settings.vala"
	G_OBJECT_CLASS (klass)->constructor = granite_services_settings_constructor;
#line 94 "../lib/Services/Settings.vala"
	G_OBJECT_CLASS (klass)->finalize = granite_services_settings_finalize;
#line 94 "../lib/Services/Settings.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_SERVICES_SETTINGS_SCHEMA_PROPERTY, granite_services_settings_properties[GRANITE_SERVICES_SETTINGS_SCHEMA_PROPERTY] = g_param_spec_object ("schema", "schema", "schema", g_settings_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 1621 "Settings.c"
	/**
	         * This signal is to be used in place of the standard {@link GLib.Object.notify} signal.
	         *
	         * This signal ''only'' emits after a property's value was verified.
	         *
	         * Note that in the case where a property was set to an invalid value,
	         * (and thus, sanitized to a valid value), the {@link GLib.Object.notify} signal will emit 
	         * twice: once with the invalid value and once with the sanitized value.
	         */
#line 94 "../lib/Services/Settings.vala"
	granite_services_settings_signals[GRANITE_SERVICES_SETTINGS_CHANGED_SIGNAL] = g_signal_new ("changed", GRANITE_SERVICES_TYPE_SETTINGS, G_SIGNAL_RUN_FIRST | G_SIGNAL_DETAILED | G_SIGNAL_NO_RECURSE | G_SIGNAL_ACTION | G_SIGNAL_NO_HOOKS, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1633 "Settings.c"
}


static void
granite_services_settings_instance_init (GraniteServicesSettings * self)
{
#line 94 "../lib/Services/Settings.vala"
	self->priv = granite_services_settings_get_instance_private (self);
#line 1642 "Settings.c"
}


static void
granite_services_settings_finalize (GObject * obj)
{
	GraniteServicesSettings * self;
#line 94 "../lib/Services/Settings.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GRANITE_SERVICES_TYPE_SETTINGS, GraniteServicesSettings);
#line 174 "../lib/Services/Settings.vala"
	granite_services_settings_stop_monitor (self);
#line 113 "../lib/Services/Settings.vala"
	_g_object_unref0 (self->priv->_schema);
#line 94 "../lib/Services/Settings.vala"
	G_OBJECT_CLASS (granite_services_settings_parent_class)->finalize (obj);
#line 1658 "Settings.c"
}


/**
     * Class for interacting with an internal {@link GLib.Settings} using native Vala properties.
     * Clients of this class should not connect to the {@link GLib.Object.notify} signal.
     * Instead, they should connect to the {@link Granite.Services.Settings.changed} signal.
     *
     * For example, if a developer wanted to interact with desktop.Wallpaper's (http:/www.launchpad.net/pantheon-wallpaper) schema,
     * this is what his/her subclass might look like:
     *
     * {{{
     *    public class WallpaperSettings : Granite.Services.Settings {
     *    
     *        public PictureMode picture_mode { get; set; }
     *    
     *        public string picture_path { get; set; }
     *    
     *        public string background_color { get; set; }
     *    
     *        public WallpaperSettings () {
     *            base ("desktop.Wallpaper");
     *        }
     *    
     *        protected override void verify (string key) {
     *    
     *            switch (key) {
     *    
     *                case "background-color":
     *                    Gdk.Color bg;
     *                    if (!Gdk.Color.parse (background_color, out bg))
     *                        background_color = "#000000";
     *                    break;
     *            }
     *        }
     *    
     *    }
     * }}}
     *
     * Keep in mind that the developer must define his/her enums to match the schema's.
     * 
     * The following is a simplified explanation of how this library works:
*
     *  1. Any subclass looks at all properties it contains, and loads their initial values from the keys they represent.
     *     Because Vala properties are stored as GLib properties, the string representation of a property replaces underscores with
     *     hyphens (i.e. property_name becomes "property-name"). This is how this library knows which keys to load from. If the key
     *     does not exist, it will result in a fatal error.
     *  1. When a property of the subclass changes, the library will first verify the data before emitting a changed signal. If necessary,
     *     the library will change the value of the property while verifying.
     *     This is why developers should only act upon emissions of the changed () signal and never the native {@link GLib.Object.notify} signal.
     *  1. When the corresponding key of one of the properties of the subclass changes, it will also verify the data and change it, if necessary,
     *     before loading it into as the corresponding property's value.
     */
GType
granite_services_settings_get_type (void)
{
	static volatile gsize granite_services_settings_type_id__volatile = 0;
	if (g_once_init_enter (&granite_services_settings_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GraniteServicesSettingsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) granite_services_settings_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GraniteServicesSettings), 0, (GInstanceInitFunc) granite_services_settings_instance_init, NULL };
		GType granite_services_settings_type_id;
		granite_services_settings_type_id = g_type_register_static (G_TYPE_OBJECT, "GraniteServicesSettings", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		GraniteServicesSettings_private_offset = g_type_add_instance_private (granite_services_settings_type_id, sizeof (GraniteServicesSettingsPrivate));
		g_once_init_leave (&granite_services_settings_type_id__volatile, granite_services_settings_type_id);
	}
	return granite_services_settings_type_id__volatile;
}


static void
_vala_granite_services_settings_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec)
{
	GraniteServicesSettings * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GRANITE_SERVICES_TYPE_SETTINGS, GraniteServicesSettings);
#line 94 "../lib/Services/Settings.vala"
	switch (property_id) {
#line 94 "../lib/Services/Settings.vala"
		case GRANITE_SERVICES_SETTINGS_SCHEMA_PROPERTY:
#line 94 "../lib/Services/Settings.vala"
		g_value_set_object (value, granite_services_settings_get_schema (self));
#line 94 "../lib/Services/Settings.vala"
		break;
#line 1743 "Settings.c"
		default:
#line 94 "../lib/Services/Settings.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 94 "../lib/Services/Settings.vala"
		break;
#line 1749 "Settings.c"
	}
}


static void
_vala_granite_services_settings_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec)
{
	GraniteServicesSettings * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GRANITE_SERVICES_TYPE_SETTINGS, GraniteServicesSettings);
#line 94 "../lib/Services/Settings.vala"
	switch (property_id) {
#line 94 "../lib/Services/Settings.vala"
		case GRANITE_SERVICES_SETTINGS_SCHEMA_PROPERTY:
#line 94 "../lib/Services/Settings.vala"
		granite_services_settings_set_schema (self, g_value_get_object (value));
#line 94 "../lib/Services/Settings.vala"
		break;
#line 1770 "Settings.c"
		default:
#line 94 "../lib/Services/Settings.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 94 "../lib/Services/Settings.vala"
		break;
#line 1776 "Settings.c"
	}
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



