/* Avatar.c generated by valac 0.42.7, the Vala compiler
 * generated from Avatar.vala, do not modify */

/*
 *  Copyright (C) 2015-2017 Granite Developers (https://launchpad.net/granite)
 *
 *  This program or library is free software; you can redistribute it
 *  and/or modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 3 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General
 *  Public License along with this library; if not, write to the
 *  Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 *  Boston, MA 02110-1301 USA.
 *
 *  Authored by: Felipe Escoto <felescoto95@hotmail.com>, Rico Tzschichholz <ricotz@ubuntu.com>
 */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <cairo.h>
#include <gdk/gdk.h>
#include <stdio.h>
#include <float.h>
#include <math.h>


#define GRANITE_WIDGETS_TYPE_AVATAR (granite_widgets_avatar_get_type ())
#define GRANITE_WIDGETS_AVATAR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GRANITE_WIDGETS_TYPE_AVATAR, GraniteWidgetsAvatar))
#define GRANITE_WIDGETS_AVATAR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GRANITE_WIDGETS_TYPE_AVATAR, GraniteWidgetsAvatarClass))
#define GRANITE_WIDGETS_IS_AVATAR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GRANITE_WIDGETS_TYPE_AVATAR))
#define GRANITE_WIDGETS_IS_AVATAR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GRANITE_WIDGETS_TYPE_AVATAR))
#define GRANITE_WIDGETS_AVATAR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GRANITE_WIDGETS_TYPE_AVATAR, GraniteWidgetsAvatarClass))

typedef struct _GraniteWidgetsAvatar GraniteWidgetsAvatar;
typedef struct _GraniteWidgetsAvatarClass GraniteWidgetsAvatarClass;
typedef struct _GraniteWidgetsAvatarPrivate GraniteWidgetsAvatarPrivate;
enum  {
	GRANITE_WIDGETS_AVATAR_0_PROPERTY,
	GRANITE_WIDGETS_AVATAR_PIXBUF_PROPERTY,
	GRANITE_WIDGETS_AVATAR_NUM_PROPERTIES
};
static GParamSpec* granite_widgets_avatar_properties[GRANITE_WIDGETS_AVATAR_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _GraniteWidgetsAvatar {
	GtkEventBox parent_instance;
	GraniteWidgetsAvatarPrivate * priv;
};

struct _GraniteWidgetsAvatarClass {
	GtkEventBoxClass parent_class;
};

struct _GraniteWidgetsAvatarPrivate {
	gboolean draw_theme_background;
	gboolean is_default;
	gchar* orig_filename;
	gint* orig_pixel_size;
	GdkPixbuf* _pixbuf;
};


static gint GraniteWidgetsAvatar_private_offset;
static gpointer granite_widgets_avatar_parent_class = NULL;

GType granite_widgets_avatar_get_type (void) G_GNUC_CONST;
static void granite_widgets_avatar_refresh_size_request (GraniteWidgetsAvatar* self);
static void _granite_widgets_avatar_refresh_size_request_g_object_notify (GObject* _sender,
                                                                   GParamSpec* pspec,
                                                                   gpointer self);
static void granite_widgets_avatar_dpi_change (GraniteWidgetsAvatar* self);
static void _granite_widgets_avatar_dpi_change_gdk_screen_monitors_changed (GdkScreen* _sender,
                                                                     gpointer self);
#define GRANITE_WIDGETS_AVATAR_DEFAULT_ICON "avatar-default"
#define GRANITE_WIDGETS_AVATAR_EXTRA_MARGIN 4
GraniteWidgetsAvatar* granite_widgets_avatar_new (void);
GraniteWidgetsAvatar* granite_widgets_avatar_construct (GType object_type);
GraniteWidgetsAvatar* granite_widgets_avatar_new_from_pixbuf (GdkPixbuf* pixbuf);
GraniteWidgetsAvatar* granite_widgets_avatar_construct_from_pixbuf (GType object_type,
                                                                    GdkPixbuf* pixbuf);
GraniteWidgetsAvatar* granite_widgets_avatar_new_from_file (const gchar* filepath,
                                                            gint pixel_size);
GraniteWidgetsAvatar* granite_widgets_avatar_construct_from_file (GType object_type,
                                                                  const gchar* filepath,
                                                                  gint pixel_size);
static void granite_widgets_avatar_load_image (GraniteWidgetsAvatar* self,
                                        const gchar* filepath,
                                        gint pixel_size);
static gint* _int_dup (gint* self);
void granite_widgets_avatar_set_pixbuf (GraniteWidgetsAvatar* self,
                                        GdkPixbuf* value);
void granite_widgets_avatar_show_default (GraniteWidgetsAvatar* self,
                                          gint pixel_size);
GraniteWidgetsAvatar* granite_widgets_avatar_new_with_default_icon (gint pixel_size);
GraniteWidgetsAvatar* granite_widgets_avatar_construct_with_default_icon (GType object_type,
                                                                          gint pixel_size);
GdkPixbuf* granite_widgets_avatar_get_pixbuf (GraniteWidgetsAvatar* self);
static gboolean granite_widgets_avatar_real_draw (GtkWidget* base,
                                           cairo_t* cr);
void granite_drawing_utilities_cairo_rounded_rectangle (cairo_t* cr,
                                                        gdouble x,
                                                        gdouble y,
                                                        gdouble width,
                                                        gdouble height,
                                                        gdouble radius);
static GObject * granite_widgets_avatar_constructor (GType type,
                                              guint n_construct_properties,
                                              GObjectConstructParam * construct_properties);
#define GRANITE_STYLE_CLASS_AVATAR "avatar"
static void granite_widgets_avatar_finalize (GObject * obj);
static void _vala_granite_widgets_avatar_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec);
static void _vala_granite_widgets_avatar_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec);


static inline gpointer
granite_widgets_avatar_get_instance_private (GraniteWidgetsAvatar* self)
{
	return G_STRUCT_MEMBER_P (self, GraniteWidgetsAvatar_private_offset);
}


static void
_granite_widgets_avatar_refresh_size_request_g_object_notify (GObject* _sender,
                                                              GParamSpec* pspec,
                                                              gpointer self)
{
#line 115 "../lib/Widgets/Avatar.vala"
	granite_widgets_avatar_refresh_size_request ((GraniteWidgetsAvatar*) self);
#line 150 "Avatar.c"
}


static void
_granite_widgets_avatar_dpi_change_gdk_screen_monitors_changed (GdkScreen* _sender,
                                                                gpointer self)
{
#line 116 "../lib/Widgets/Avatar.vala"
	granite_widgets_avatar_dpi_change ((GraniteWidgetsAvatar*) self);
#line 160 "Avatar.c"
}


/**
     * Makes new Avatar widget
     *
     */
GraniteWidgetsAvatar*
granite_widgets_avatar_construct (GType object_type)
{
	GraniteWidgetsAvatar * self = NULL;
#line 60 "../lib/Widgets/Avatar.vala"
	self = (GraniteWidgetsAvatar*) g_object_new (object_type, NULL);
#line 60 "../lib/Widgets/Avatar.vala"
	return self;
#line 176 "Avatar.c"
}


GraniteWidgetsAvatar*
granite_widgets_avatar_new (void)
{
#line 60 "../lib/Widgets/Avatar.vala"
	return granite_widgets_avatar_construct (GRANITE_WIDGETS_TYPE_AVATAR);
#line 185 "Avatar.c"
}


/**
    * Creates a new Avatar from the specified pixbuf
    *
    * @param pixbuf image to be used
    */
GraniteWidgetsAvatar*
granite_widgets_avatar_construct_from_pixbuf (GType object_type,
                                              GdkPixbuf* pixbuf)
{
	GraniteWidgetsAvatar * self = NULL;
#line 68 "../lib/Widgets/Avatar.vala"
	g_return_val_if_fail (pixbuf != NULL, NULL);
#line 69 "../lib/Widgets/Avatar.vala"
	self = (GraniteWidgetsAvatar*) g_object_new (object_type, "pixbuf", pixbuf, NULL);
#line 68 "../lib/Widgets/Avatar.vala"
	return self;
#line 205 "Avatar.c"
}


GraniteWidgetsAvatar*
granite_widgets_avatar_new_from_pixbuf (GdkPixbuf* pixbuf)
{
#line 68 "../lib/Widgets/Avatar.vala"
	return granite_widgets_avatar_construct_from_pixbuf (GRANITE_WIDGETS_TYPE_AVATAR, pixbuf);
#line 214 "Avatar.c"
}


/**
     * Creates a new Avatar from the specified filepath and icon size
     *
     * @param filepath image to be used
     * @param pixel_size to scale the image
     */
static gint*
_int_dup (gint* self)
{
	gint* dup;
#line 81 "../lib/Widgets/Avatar.vala"
	dup = g_new0 (gint, 1);
#line 81 "../lib/Widgets/Avatar.vala"
	memcpy (dup, self, sizeof (gint));
#line 81 "../lib/Widgets/Avatar.vala"
	return dup;
#line 234 "Avatar.c"
}


static gpointer
__int_dup0 (gpointer self)
{
#line 81 "../lib/Widgets/Avatar.vala"
	return self ? _int_dup (self) : NULL;
#line 243 "Avatar.c"
}


GraniteWidgetsAvatar*
granite_widgets_avatar_construct_from_file (GType object_type,
                                            const gchar* filepath,
                                            gint pixel_size)
{
	GraniteWidgetsAvatar * self = NULL;
	gchar* _tmp0_;
	gint* _tmp1_;
#line 78 "../lib/Widgets/Avatar.vala"
	g_return_val_if_fail (filepath != NULL, NULL);
#line 78 "../lib/Widgets/Avatar.vala"
	self = (GraniteWidgetsAvatar*) g_object_new (object_type, NULL);
#line 79 "../lib/Widgets/Avatar.vala"
	granite_widgets_avatar_load_image (self, filepath, pixel_size);
#line 80 "../lib/Widgets/Avatar.vala"
	_tmp0_ = g_strdup (filepath);
#line 80 "../lib/Widgets/Avatar.vala"
	_g_free0 (self->priv->orig_filename);
#line 80 "../lib/Widgets/Avatar.vala"
	self->priv->orig_filename = _tmp0_;
#line 81 "../lib/Widgets/Avatar.vala"
	_tmp1_ = __int_dup0 (&pixel_size);
#line 81 "../lib/Widgets/Avatar.vala"
	_g_free0 (self->priv->orig_pixel_size);
#line 81 "../lib/Widgets/Avatar.vala"
	self->priv->orig_pixel_size = _tmp1_;
#line 78 "../lib/Widgets/Avatar.vala"
	return self;
#line 275 "Avatar.c"
}


GraniteWidgetsAvatar*
granite_widgets_avatar_new_from_file (const gchar* filepath,
                                      gint pixel_size)
{
#line 78 "../lib/Widgets/Avatar.vala"
	return granite_widgets_avatar_construct_from_file (GRANITE_WIDGETS_TYPE_AVATAR, filepath, pixel_size);
#line 285 "Avatar.c"
}


static void
granite_widgets_avatar_load_image (GraniteWidgetsAvatar* self,
                                   const gchar* filepath,
                                   gint pixel_size)
{
	GError* _inner_error0_ = NULL;
#line 84 "../lib/Widgets/Avatar.vala"
	g_return_if_fail (self != NULL);
#line 84 "../lib/Widgets/Avatar.vala"
	g_return_if_fail (filepath != NULL);
#line 299 "Avatar.c"
	{
		gint size = 0;
		GdkPixbuf* _tmp0_ = NULL;
		GdkPixbuf* _tmp1_;
#line 86 "../lib/Widgets/Avatar.vala"
		size = pixel_size * gtk_widget_get_scale_factor ((GtkWidget*) self);
#line 87 "../lib/Widgets/Avatar.vala"
		_tmp1_ = gdk_pixbuf_new_from_file_at_size (filepath, size, size, &_inner_error0_);
#line 87 "../lib/Widgets/Avatar.vala"
		_tmp0_ = _tmp1_;
#line 87 "../lib/Widgets/Avatar.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 312 "Avatar.c"
			goto __catch26_g_error;
		}
#line 87 "../lib/Widgets/Avatar.vala"
		granite_widgets_avatar_set_pixbuf (self, _tmp0_);
#line 85 "../lib/Widgets/Avatar.vala"
		_g_object_unref0 (_tmp0_);
#line 319 "Avatar.c"
	}
	goto __finally26;
	__catch26_g_error:
	{
		GError* e = NULL;
#line 85 "../lib/Widgets/Avatar.vala"
		e = _inner_error0_;
#line 85 "../lib/Widgets/Avatar.vala"
		_inner_error0_ = NULL;
#line 89 "../lib/Widgets/Avatar.vala"
		granite_widgets_avatar_show_default (self, pixel_size);
#line 85 "../lib/Widgets/Avatar.vala"
		_g_error_free0 (e);
#line 333 "Avatar.c"
	}
	__finally26:
#line 85 "../lib/Widgets/Avatar.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 85 "../lib/Widgets/Avatar.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 85 "../lib/Widgets/Avatar.vala"
		g_clear_error (&_inner_error0_);
#line 85 "../lib/Widgets/Avatar.vala"
		return;
#line 344 "Avatar.c"
	}
}


/**
     * Creates a new Avatar with the default icon from theme without applying the css style
     *
     * @param pixel_size size of the icon to be loaded
     */
GraniteWidgetsAvatar*
granite_widgets_avatar_construct_with_default_icon (GType object_type,
                                                    gint pixel_size)
{
	GraniteWidgetsAvatar * self = NULL;
	gint* _tmp0_;
#line 98 "../lib/Widgets/Avatar.vala"
	self = (GraniteWidgetsAvatar*) g_object_new (object_type, NULL);
#line 99 "../lib/Widgets/Avatar.vala"
	granite_widgets_avatar_show_default (self, pixel_size);
#line 100 "../lib/Widgets/Avatar.vala"
	_tmp0_ = __int_dup0 (&pixel_size);
#line 100 "../lib/Widgets/Avatar.vala"
	_g_free0 (self->priv->orig_pixel_size);
#line 100 "../lib/Widgets/Avatar.vala"
	self->priv->orig_pixel_size = _tmp0_;
#line 98 "../lib/Widgets/Avatar.vala"
	return self;
#line 372 "Avatar.c"
}


GraniteWidgetsAvatar*
granite_widgets_avatar_new_with_default_icon (gint pixel_size)
{
#line 98 "../lib/Widgets/Avatar.vala"
	return granite_widgets_avatar_construct_with_default_icon (GRANITE_WIDGETS_TYPE_AVATAR, pixel_size);
#line 381 "Avatar.c"
}


static void
granite_widgets_avatar_refresh_size_request (GraniteWidgetsAvatar* self)
{
	GdkPixbuf* _tmp0_;
#line 119 "../lib/Widgets/Avatar.vala"
	g_return_if_fail (self != NULL);
#line 120 "../lib/Widgets/Avatar.vala"
	_tmp0_ = self->priv->_pixbuf;
#line 120 "../lib/Widgets/Avatar.vala"
	if (_tmp0_ != NULL) {
#line 395 "Avatar.c"
		gint scale_factor = 0;
		GdkPixbuf* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		GdkPixbuf* _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
#line 121 "../lib/Widgets/Avatar.vala"
		scale_factor = gtk_widget_get_scale_factor ((GtkWidget*) self);
#line 122 "../lib/Widgets/Avatar.vala"
		_tmp1_ = self->priv->_pixbuf;
#line 122 "../lib/Widgets/Avatar.vala"
		_tmp2_ = gdk_pixbuf_get_width (_tmp1_);
#line 122 "../lib/Widgets/Avatar.vala"
		_tmp3_ = _tmp2_;
#line 122 "../lib/Widgets/Avatar.vala"
		_tmp4_ = scale_factor;
#line 122 "../lib/Widgets/Avatar.vala"
		_tmp5_ = self->priv->_pixbuf;
#line 122 "../lib/Widgets/Avatar.vala"
		_tmp6_ = gdk_pixbuf_get_height (_tmp5_);
#line 122 "../lib/Widgets/Avatar.vala"
		_tmp7_ = _tmp6_;
#line 122 "../lib/Widgets/Avatar.vala"
		_tmp8_ = scale_factor;
#line 122 "../lib/Widgets/Avatar.vala"
		gtk_widget_set_size_request ((GtkWidget*) self, (_tmp3_ / _tmp4_) + (GRANITE_WIDGETS_AVATAR_EXTRA_MARGIN * 2), (_tmp7_ / _tmp8_) + (GRANITE_WIDGETS_AVATAR_EXTRA_MARGIN * 2));
#line 123 "../lib/Widgets/Avatar.vala"
		self->priv->draw_theme_background = TRUE;
#line 427 "Avatar.c"
	} else {
#line 125 "../lib/Widgets/Avatar.vala"
		gtk_widget_set_size_request ((GtkWidget*) self, 0, 0);
#line 431 "Avatar.c"
	}
#line 128 "../lib/Widgets/Avatar.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 435 "Avatar.c"
}


static void
granite_widgets_avatar_dpi_change (GraniteWidgetsAvatar* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
#line 131 "../lib/Widgets/Avatar.vala"
	g_return_if_fail (self != NULL);
#line 132 "../lib/Widgets/Avatar.vala"
	_tmp1_ = self->priv->is_default;
#line 132 "../lib/Widgets/Avatar.vala"
	if (_tmp1_) {
#line 450 "Avatar.c"
		gint* _tmp2_;
#line 132 "../lib/Widgets/Avatar.vala"
		_tmp2_ = self->priv->orig_pixel_size;
#line 132 "../lib/Widgets/Avatar.vala"
		_tmp0_ = _tmp2_ != NULL;
#line 456 "Avatar.c"
	} else {
#line 132 "../lib/Widgets/Avatar.vala"
		_tmp0_ = FALSE;
#line 460 "Avatar.c"
	}
#line 132 "../lib/Widgets/Avatar.vala"
	if (_tmp0_) {
#line 464 "Avatar.c"
		gint* _tmp3_;
#line 133 "../lib/Widgets/Avatar.vala"
		_tmp3_ = self->priv->orig_pixel_size;
#line 133 "../lib/Widgets/Avatar.vala"
		granite_widgets_avatar_show_default (self, *_tmp3_);
#line 470 "Avatar.c"
	} else {
		gboolean _tmp4_ = FALSE;
		const gchar* _tmp5_;
#line 135 "../lib/Widgets/Avatar.vala"
		_tmp5_ = self->priv->orig_filename;
#line 135 "../lib/Widgets/Avatar.vala"
		if (_tmp5_ != NULL) {
#line 478 "Avatar.c"
			gint* _tmp6_;
#line 135 "../lib/Widgets/Avatar.vala"
			_tmp6_ = self->priv->orig_pixel_size;
#line 135 "../lib/Widgets/Avatar.vala"
			_tmp4_ = _tmp6_ != NULL;
#line 484 "Avatar.c"
		} else {
#line 135 "../lib/Widgets/Avatar.vala"
			_tmp4_ = FALSE;
#line 488 "Avatar.c"
		}
#line 135 "../lib/Widgets/Avatar.vala"
		if (_tmp4_) {
#line 492 "Avatar.c"
			const gchar* _tmp7_;
			gint* _tmp8_;
#line 136 "../lib/Widgets/Avatar.vala"
			_tmp7_ = self->priv->orig_filename;
#line 136 "../lib/Widgets/Avatar.vala"
			_tmp8_ = self->priv->orig_pixel_size;
#line 136 "../lib/Widgets/Avatar.vala"
			granite_widgets_avatar_load_image (self, _tmp7_, *_tmp8_);
#line 501 "Avatar.c"
		}
	}
}


/**
     * Load the default avatar icon from theme into the widget without applying the css style
     *
     * @param pixel_size size of the icon to be loaded
     */
static gpointer
_g_object_ref0 (gpointer self)
{
#line 147 "../lib/Widgets/Avatar.vala"
	return self ? g_object_ref (self) : NULL;
#line 517 "Avatar.c"
}


void
granite_widgets_avatar_show_default (GraniteWidgetsAvatar* self,
                                     gint pixel_size)
{
	GtkIconTheme* icon_theme = NULL;
	GtkIconTheme* _tmp0_;
	GtkIconTheme* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 146 "../lib/Widgets/Avatar.vala"
	g_return_if_fail (self != NULL);
#line 147 "../lib/Widgets/Avatar.vala"
	_tmp0_ = gtk_icon_theme_get_default ();
#line 147 "../lib/Widgets/Avatar.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 147 "../lib/Widgets/Avatar.vala"
	icon_theme = _tmp1_;
#line 537 "Avatar.c"
	{
		GdkPixbuf* _tmp2_ = NULL;
		GdkPixbuf* _tmp3_;
#line 149 "../lib/Widgets/Avatar.vala"
		_tmp3_ = gtk_icon_theme_load_icon_for_scale (icon_theme, GRANITE_WIDGETS_AVATAR_DEFAULT_ICON, pixel_size, gtk_widget_get_scale_factor ((GtkWidget*) self), 0, &_inner_error0_);
#line 149 "../lib/Widgets/Avatar.vala"
		_tmp2_ = _tmp3_;
#line 149 "../lib/Widgets/Avatar.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 547 "Avatar.c"
			goto __catch27_g_error;
		}
#line 149 "../lib/Widgets/Avatar.vala"
		granite_widgets_avatar_set_pixbuf (self, _tmp2_);
#line 148 "../lib/Widgets/Avatar.vala"
		_g_object_unref0 (_tmp2_);
#line 554 "Avatar.c"
	}
	goto __finally27;
	__catch27_g_error:
	{
		GError* e = NULL;
		FILE* _tmp4_;
		GError* _tmp5_;
		const gchar* _tmp6_;
#line 148 "../lib/Widgets/Avatar.vala"
		e = _inner_error0_;
#line 148 "../lib/Widgets/Avatar.vala"
		_inner_error0_ = NULL;
#line 151 "../lib/Widgets/Avatar.vala"
		_tmp4_ = stderr;
#line 151 "../lib/Widgets/Avatar.vala"
		_tmp5_ = e;
#line 151 "../lib/Widgets/Avatar.vala"
		_tmp6_ = _tmp5_->message;
#line 151 "../lib/Widgets/Avatar.vala"
		fprintf (_tmp4_, "Error setting default avatar icon: %s ", _tmp6_);
#line 148 "../lib/Widgets/Avatar.vala"
		_g_error_free0 (e);
#line 577 "Avatar.c"
	}
	__finally27:
#line 148 "../lib/Widgets/Avatar.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 148 "../lib/Widgets/Avatar.vala"
		_g_object_unref0 (icon_theme);
#line 148 "../lib/Widgets/Avatar.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 148 "../lib/Widgets/Avatar.vala"
		g_clear_error (&_inner_error0_);
#line 148 "../lib/Widgets/Avatar.vala"
		return;
#line 590 "Avatar.c"
	}
#line 154 "../lib/Widgets/Avatar.vala"
	self->priv->draw_theme_background = FALSE;
#line 155 "../lib/Widgets/Avatar.vala"
	self->priv->is_default = TRUE;
#line 146 "../lib/Widgets/Avatar.vala"
	_g_object_unref0 (icon_theme);
#line 598 "Avatar.c"
}


static gboolean
granite_widgets_avatar_real_draw (GtkWidget* base,
                                  cairo_t* cr)
{
	GraniteWidgetsAvatar * self;
	gboolean result = FALSE;
	GdkPixbuf* _tmp0_;
	GtkStyleContext* style_context = NULL;
	GtkStyleContext* _tmp1_;
	gint width = 0;
	gint height = 0;
	gint scale_factor = 0;
	gboolean _tmp2_;
#line 158 "../lib/Widgets/Avatar.vala"
	self = (GraniteWidgetsAvatar*) base;
#line 158 "../lib/Widgets/Avatar.vala"
	g_return_val_if_fail (cr != NULL, FALSE);
#line 159 "../lib/Widgets/Avatar.vala"
	_tmp0_ = self->priv->_pixbuf;
#line 159 "../lib/Widgets/Avatar.vala"
	if (_tmp0_ == NULL) {
#line 160 "../lib/Widgets/Avatar.vala"
		result = GTK_WIDGET_CLASS (granite_widgets_avatar_parent_class)->draw ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_event_box_get_type (), GtkEventBox), cr);
#line 160 "../lib/Widgets/Avatar.vala"
		return result;
#line 627 "Avatar.c"
	}
#line 163 "../lib/Widgets/Avatar.vala"
	_tmp1_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 163 "../lib/Widgets/Avatar.vala"
	style_context = _tmp1_;
#line 164 "../lib/Widgets/Avatar.vala"
	width = gtk_widget_get_allocated_width ((GtkWidget*) self) - (GRANITE_WIDGETS_AVATAR_EXTRA_MARGIN * 2);
#line 165 "../lib/Widgets/Avatar.vala"
	height = gtk_widget_get_allocated_height ((GtkWidget*) self) - (GRANITE_WIDGETS_AVATAR_EXTRA_MARGIN * 2);
#line 166 "../lib/Widgets/Avatar.vala"
	scale_factor = gtk_widget_get_scale_factor ((GtkWidget*) self);
#line 168 "../lib/Widgets/Avatar.vala"
	_tmp2_ = self->priv->draw_theme_background;
#line 168 "../lib/Widgets/Avatar.vala"
	if (_tmp2_) {
#line 643 "Avatar.c"
		gint border_radius = 0;
		GtkStyleContext* _tmp3_;
		GtkStyleContext* _tmp4_;
		GValue _tmp5_ = {0};
		GValue _tmp6_;
		gint _tmp7_;
		gint crop_radius = 0;
		gint _tmp8_;
		gint _tmp9_;
		gint _tmp10_;
		gint _tmp11_;
		gint _tmp12_;
		gint _tmp13_;
		gint _tmp14_;
		gint _tmp15_;
		GdkPixbuf* _tmp16_;
		gint _tmp17_;
		gint _tmp18_;
		GtkStyleContext* _tmp19_;
		gint _tmp20_;
		gint _tmp21_;
		GtkStyleContext* _tmp22_;
		gint _tmp23_;
		gint _tmp24_;
#line 169 "../lib/Widgets/Avatar.vala"
		_tmp3_ = style_context;
#line 169 "../lib/Widgets/Avatar.vala"
		_tmp4_ = style_context;
#line 169 "../lib/Widgets/Avatar.vala"
		gtk_style_context_get_property (_tmp3_, GTK_STYLE_PROPERTY_BORDER_RADIUS, gtk_style_context_get_state (_tmp4_), &_tmp5_);
#line 169 "../lib/Widgets/Avatar.vala"
		_tmp6_ = _tmp5_;
#line 169 "../lib/Widgets/Avatar.vala"
		_tmp7_ = g_value_get_int (&_tmp6_);
#line 169 "../lib/Widgets/Avatar.vala"
		G_IS_VALUE (&_tmp6_) ? (g_value_unset (&_tmp6_), NULL) : NULL;
#line 169 "../lib/Widgets/Avatar.vala"
		border_radius = _tmp7_;
#line 170 "../lib/Widgets/Avatar.vala"
		_tmp8_ = width;
#line 170 "../lib/Widgets/Avatar.vala"
		_tmp9_ = border_radius;
#line 170 "../lib/Widgets/Avatar.vala"
		_tmp10_ = width;
#line 170 "../lib/Widgets/Avatar.vala"
		crop_radius = MIN (_tmp8_ / 2, (_tmp9_ * _tmp10_) / 100);
#line 172 "../lib/Widgets/Avatar.vala"
		_tmp11_ = width;
#line 172 "../lib/Widgets/Avatar.vala"
		_tmp12_ = height;
#line 172 "../lib/Widgets/Avatar.vala"
		_tmp13_ = crop_radius;
#line 172 "../lib/Widgets/Avatar.vala"
		granite_drawing_utilities_cairo_rounded_rectangle (cr, (gdouble) GRANITE_WIDGETS_AVATAR_EXTRA_MARGIN, (gdouble) GRANITE_WIDGETS_AVATAR_EXTRA_MARGIN, (gdouble) _tmp11_, (gdouble) _tmp12_, (gdouble) _tmp13_);
#line 173 "../lib/Widgets/Avatar.vala"
		cairo_save (cr);
#line 174 "../lib/Widgets/Avatar.vala"
		_tmp14_ = scale_factor;
#line 174 "../lib/Widgets/Avatar.vala"
		_tmp15_ = scale_factor;
#line 174 "../lib/Widgets/Avatar.vala"
		cairo_scale (cr, 1.0 / _tmp14_, 1.0 / _tmp15_);
#line 175 "../lib/Widgets/Avatar.vala"
		_tmp16_ = self->priv->_pixbuf;
#line 175 "../lib/Widgets/Avatar.vala"
		_tmp17_ = scale_factor;
#line 175 "../lib/Widgets/Avatar.vala"
		_tmp18_ = scale_factor;
#line 175 "../lib/Widgets/Avatar.vala"
		gdk_cairo_set_source_pixbuf (cr, _tmp16_, (gdouble) (GRANITE_WIDGETS_AVATAR_EXTRA_MARGIN * _tmp17_), (gdouble) (GRANITE_WIDGETS_AVATAR_EXTRA_MARGIN * _tmp18_));
#line 176 "../lib/Widgets/Avatar.vala"
		cairo_fill_preserve (cr);
#line 177 "../lib/Widgets/Avatar.vala"
		cairo_restore (cr);
#line 178 "../lib/Widgets/Avatar.vala"
		_tmp19_ = style_context;
#line 178 "../lib/Widgets/Avatar.vala"
		_tmp20_ = width;
#line 178 "../lib/Widgets/Avatar.vala"
		_tmp21_ = height;
#line 178 "../lib/Widgets/Avatar.vala"
		gtk_render_background (_tmp19_, cr, (gdouble) GRANITE_WIDGETS_AVATAR_EXTRA_MARGIN, (gdouble) GRANITE_WIDGETS_AVATAR_EXTRA_MARGIN, (gdouble) _tmp20_, (gdouble) _tmp21_);
#line 179 "../lib/Widgets/Avatar.vala"
		_tmp22_ = style_context;
#line 179 "../lib/Widgets/Avatar.vala"
		_tmp23_ = width;
#line 179 "../lib/Widgets/Avatar.vala"
		_tmp24_ = height;
#line 179 "../lib/Widgets/Avatar.vala"
		gtk_render_frame (_tmp22_, cr, (gdouble) GRANITE_WIDGETS_AVATAR_EXTRA_MARGIN, (gdouble) GRANITE_WIDGETS_AVATAR_EXTRA_MARGIN, (gdouble) _tmp23_, (gdouble) _tmp24_);
#line 734 "Avatar.c"
	} else {
		gint _tmp25_;
		gint _tmp26_;
		GtkStyleContext* _tmp27_;
		GdkPixbuf* _tmp28_;
#line 182 "../lib/Widgets/Avatar.vala"
		cairo_save (cr);
#line 183 "../lib/Widgets/Avatar.vala"
		_tmp25_ = scale_factor;
#line 183 "../lib/Widgets/Avatar.vala"
		_tmp26_ = scale_factor;
#line 183 "../lib/Widgets/Avatar.vala"
		cairo_scale (cr, 1.0 / _tmp25_, 1.0 / _tmp26_);
#line 184 "../lib/Widgets/Avatar.vala"
		_tmp27_ = style_context;
#line 184 "../lib/Widgets/Avatar.vala"
		_tmp28_ = self->priv->_pixbuf;
#line 184 "../lib/Widgets/Avatar.vala"
		gtk_render_icon (_tmp27_, cr, _tmp28_, (gdouble) GRANITE_WIDGETS_AVATAR_EXTRA_MARGIN, (gdouble) GRANITE_WIDGETS_AVATAR_EXTRA_MARGIN);
#line 185 "../lib/Widgets/Avatar.vala"
		cairo_restore (cr);
#line 756 "Avatar.c"
	}
#line 188 "../lib/Widgets/Avatar.vala"
	result = GDK_EVENT_STOP;
#line 188 "../lib/Widgets/Avatar.vala"
	return result;
#line 762 "Avatar.c"
}


GdkPixbuf*
granite_widgets_avatar_get_pixbuf (GraniteWidgetsAvatar* self)
{
	GdkPixbuf* result;
	GdkPixbuf* _tmp0_;
#line 54 "../lib/Widgets/Avatar.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 54 "../lib/Widgets/Avatar.vala"
	_tmp0_ = self->priv->_pixbuf;
#line 54 "../lib/Widgets/Avatar.vala"
	result = _tmp0_;
#line 54 "../lib/Widgets/Avatar.vala"
	return result;
#line 779 "Avatar.c"
}


void
granite_widgets_avatar_set_pixbuf (GraniteWidgetsAvatar* self,
                                   GdkPixbuf* value)
{
#line 54 "../lib/Widgets/Avatar.vala"
	g_return_if_fail (self != NULL);
#line 54 "../lib/Widgets/Avatar.vala"
	if (granite_widgets_avatar_get_pixbuf (self) != value) {
#line 791 "Avatar.c"
		GdkPixbuf* _tmp0_;
#line 54 "../lib/Widgets/Avatar.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 54 "../lib/Widgets/Avatar.vala"
		_g_object_unref0 (self->priv->_pixbuf);
#line 54 "../lib/Widgets/Avatar.vala"
		self->priv->_pixbuf = _tmp0_;
#line 54 "../lib/Widgets/Avatar.vala"
		g_object_notify_by_pspec ((GObject *) self, granite_widgets_avatar_properties[GRANITE_WIDGETS_AVATAR_PIXBUF_PROPERTY]);
#line 801 "Avatar.c"
	}
}


static GObject *
granite_widgets_avatar_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GraniteWidgetsAvatar * self;
	GtkStyleContext* style_context = NULL;
	GtkStyleContext* _tmp0_;
	GtkStyleContext* _tmp1_;
	GtkStyleContext* _tmp2_;
	GdkScreen* _tmp3_;
#line 103 "../lib/Widgets/Avatar.vala"
	parent_class = G_OBJECT_CLASS (granite_widgets_avatar_parent_class);
#line 103 "../lib/Widgets/Avatar.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 103 "../lib/Widgets/Avatar.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GRANITE_WIDGETS_TYPE_AVATAR, GraniteWidgetsAvatar);
#line 104 "../lib/Widgets/Avatar.vala"
	gtk_widget_set_valign ((GtkWidget*) self, GTK_ALIGN_CENTER);
#line 105 "../lib/Widgets/Avatar.vala"
	gtk_widget_set_halign ((GtkWidget*) self, GTK_ALIGN_CENTER);
#line 106 "../lib/Widgets/Avatar.vala"
	gtk_event_box_set_visible_window ((GtkEventBox*) self, FALSE);
#line 107 "../lib/Widgets/Avatar.vala"
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 107 "../lib/Widgets/Avatar.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 107 "../lib/Widgets/Avatar.vala"
	style_context = _tmp1_;
#line 108 "../lib/Widgets/Avatar.vala"
	_tmp2_ = style_context;
#line 108 "../lib/Widgets/Avatar.vala"
	gtk_style_context_add_class (_tmp2_, GRANITE_STYLE_CLASS_AVATAR);
#line 110 "../lib/Widgets/Avatar.vala"
	g_signal_connect_object ((GObject*) self, "notify::pixbuf", (GCallback) _granite_widgets_avatar_refresh_size_request_g_object_notify, self, 0);
#line 111 "../lib/Widgets/Avatar.vala"
	_tmp3_ = gdk_screen_get_default ();
#line 111 "../lib/Widgets/Avatar.vala"
	g_signal_connect_object (_tmp3_, "monitors-changed", (GCallback) _granite_widgets_avatar_dpi_change_gdk_screen_monitors_changed, self, 0);
#line 103 "../lib/Widgets/Avatar.vala"
	_g_object_unref0 (style_context);
#line 103 "../lib/Widgets/Avatar.vala"
	return obj;
#line 851 "Avatar.c"
}


static void
granite_widgets_avatar_class_init (GraniteWidgetsAvatarClass * klass)
{
#line 45 "../lib/Widgets/Avatar.vala"
	granite_widgets_avatar_parent_class = g_type_class_peek_parent (klass);
#line 45 "../lib/Widgets/Avatar.vala"
	g_type_class_adjust_private_offset (klass, &GraniteWidgetsAvatar_private_offset);
#line 45 "../lib/Widgets/Avatar.vala"
	((GtkWidgetClass *) klass)->draw = (gboolean (*) (GtkWidget*, cairo_t*)) granite_widgets_avatar_real_draw;
#line 45 "../lib/Widgets/Avatar.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_granite_widgets_avatar_get_property;
#line 45 "../lib/Widgets/Avatar.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_granite_widgets_avatar_set_property;
#line 45 "../lib/Widgets/Avatar.vala"
	G_OBJECT_CLASS (klass)->constructor = granite_widgets_avatar_constructor;
#line 45 "../lib/Widgets/Avatar.vala"
	G_OBJECT_CLASS (klass)->finalize = granite_widgets_avatar_finalize;
#line 45 "../lib/Widgets/Avatar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_AVATAR_PIXBUF_PROPERTY, granite_widgets_avatar_properties[GRANITE_WIDGETS_AVATAR_PIXBUF_PROPERTY] = g_param_spec_object ("pixbuf", "pixbuf", "pixbuf", gdk_pixbuf_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 874 "Avatar.c"
}


static void
granite_widgets_avatar_instance_init (GraniteWidgetsAvatar * self)
{
#line 45 "../lib/Widgets/Avatar.vala"
	self->priv = granite_widgets_avatar_get_instance_private (self);
#line 48 "../lib/Widgets/Avatar.vala"
	self->priv->draw_theme_background = TRUE;
#line 50 "../lib/Widgets/Avatar.vala"
	self->priv->is_default = FALSE;
#line 51 "../lib/Widgets/Avatar.vala"
	self->priv->orig_filename = NULL;
#line 52 "../lib/Widgets/Avatar.vala"
	self->priv->orig_pixel_size = NULL;
#line 891 "Avatar.c"
}


static void
granite_widgets_avatar_finalize (GObject * obj)
{
	GraniteWidgetsAvatar * self;
	guint _tmp0_;
	GQuark _tmp1_;
	GdkScreen* _tmp2_;
	guint _tmp3_;
#line 45 "../lib/Widgets/Avatar.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GRANITE_WIDGETS_TYPE_AVATAR, GraniteWidgetsAvatar);
#line 115 "../lib/Widgets/Avatar.vala"
	g_signal_parse_name ("notify::pixbuf", G_TYPE_OBJECT, &_tmp0_, &_tmp1_, TRUE);
#line 115 "../lib/Widgets/Avatar.vala"
	g_signal_handlers_disconnect_matched ((GObject*) self, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_DETAIL | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, _tmp1_, NULL, (GCallback) _granite_widgets_avatar_refresh_size_request_g_object_notify, self);
#line 116 "../lib/Widgets/Avatar.vala"
	_tmp2_ = gdk_screen_get_default ();
#line 116 "../lib/Widgets/Avatar.vala"
	g_signal_parse_name ("monitors-changed", gdk_screen_get_type (), &_tmp3_, NULL, FALSE);
#line 116 "../lib/Widgets/Avatar.vala"
	g_signal_handlers_disconnect_matched (_tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _granite_widgets_avatar_dpi_change_gdk_screen_monitors_changed, self);
#line 51 "../lib/Widgets/Avatar.vala"
	_g_free0 (self->priv->orig_filename);
#line 52 "../lib/Widgets/Avatar.vala"
	_g_free0 (self->priv->orig_pixel_size);
#line 54 "../lib/Widgets/Avatar.vala"
	_g_object_unref0 (self->priv->_pixbuf);
#line 45 "../lib/Widgets/Avatar.vala"
	G_OBJECT_CLASS (granite_widgets_avatar_parent_class)->finalize (obj);
#line 923 "Avatar.c"
}


/**
 * The Avatar widget allowes to theme & crop images with css BORDER_RADIUS property in the .avatar class.
 *
 * ''Example''<<BR>>
 * {{{
 * public class AvatarView : Gtk.Grid {
 *     construct {
 *         var username = GLib.Environment.get_user_name ();
 *         var iconfile = @"/var/lib/AccountsService/icons/$username";
 *
 *         var avatar_dialog = new Granite.Widgets.Avatar.from_file (iconfile, 48);
 *
 *         var avatar_default_dialog = new Granite.Widgets.Avatar.with_default_icon (48);
 *
 *         row_spacing = 6;
 *         halign = Gtk.Align.CENTER;
 *         valign = Gtk.Align.CENTER;
 *         attach (avatar_dialog, 0, 0, 1, 1);
 *         attach (avatar_default_dialog, 0, 1, 1, 1);
 *     }
 * }
 * }}}
 */
GType
granite_widgets_avatar_get_type (void)
{
	static volatile gsize granite_widgets_avatar_type_id__volatile = 0;
	if (g_once_init_enter (&granite_widgets_avatar_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GraniteWidgetsAvatarClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) granite_widgets_avatar_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GraniteWidgetsAvatar), 0, (GInstanceInitFunc) granite_widgets_avatar_instance_init, NULL };
		GType granite_widgets_avatar_type_id;
		granite_widgets_avatar_type_id = g_type_register_static (gtk_event_box_get_type (), "GraniteWidgetsAvatar", &g_define_type_info, 0);
		GraniteWidgetsAvatar_private_offset = g_type_add_instance_private (granite_widgets_avatar_type_id, sizeof (GraniteWidgetsAvatarPrivate));
		g_once_init_leave (&granite_widgets_avatar_type_id__volatile, granite_widgets_avatar_type_id);
	}
	return granite_widgets_avatar_type_id__volatile;
}


static void
_vala_granite_widgets_avatar_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec)
{
	GraniteWidgetsAvatar * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GRANITE_WIDGETS_TYPE_AVATAR, GraniteWidgetsAvatar);
#line 45 "../lib/Widgets/Avatar.vala"
	switch (property_id) {
#line 45 "../lib/Widgets/Avatar.vala"
		case GRANITE_WIDGETS_AVATAR_PIXBUF_PROPERTY:
#line 45 "../lib/Widgets/Avatar.vala"
		g_value_set_object (value, granite_widgets_avatar_get_pixbuf (self));
#line 45 "../lib/Widgets/Avatar.vala"
		break;
#line 981 "Avatar.c"
		default:
#line 45 "../lib/Widgets/Avatar.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 45 "../lib/Widgets/Avatar.vala"
		break;
#line 987 "Avatar.c"
	}
}


static void
_vala_granite_widgets_avatar_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec)
{
	GraniteWidgetsAvatar * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GRANITE_WIDGETS_TYPE_AVATAR, GraniteWidgetsAvatar);
#line 45 "../lib/Widgets/Avatar.vala"
	switch (property_id) {
#line 45 "../lib/Widgets/Avatar.vala"
		case GRANITE_WIDGETS_AVATAR_PIXBUF_PROPERTY:
#line 45 "../lib/Widgets/Avatar.vala"
		granite_widgets_avatar_set_pixbuf (self, g_value_get_object (value));
#line 45 "../lib/Widgets/Avatar.vala"
		break;
#line 1008 "Avatar.c"
		default:
#line 45 "../lib/Widgets/Avatar.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 45 "../lib/Widgets/Avatar.vala"
		break;
#line 1014 "Avatar.c"
	}
}



