/* SourceList.c generated by valac 0.42.7, the Vala compiler
 * generated from SourceList.vala, do not modify */

/*
 *  Copyright (C) 2012-2014 Victor Martinez <victoreduardm@gmail.com>
 *
 *  This program or library is free software; you can redistribute it
 *  and/or modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 3 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General
 *  Public License along with this library; if not, write to the
 *  Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 *  Boston, MA 02110-1301 USA.
 */
/**
     * = WORKING INTERNALS =
     *
     * In order to offer a transparent Item-based API, and avoid the need of providing methods
     * to deal with items directly on the SourceList widget, it was decided to follow a monitor-like
     * implementation, where the source list permanently monitors its root item and any other
     * child item added to it. The task of monitoring the properties of the items has been
     * divided among different objects, as shown below:
     *
     * Monitored by: Object::method that receives the signals indicating the property change.
     * Applied by: Object::method that actually updates the tree to reflect the property changes
     *             (directly or indirectly, as in the case of the tree data model).
     *
     * ---------------------------------------------------------------------------------------------
     *   PROPERTY        |  MONITORED BY                     |  APPLIED BY
     * ---------------------------------------------------------------------------------------------
     * + Item            |                                   |
     *   - parent        | Not monitored                     | N/A
     *   - name          | DataModel::on_item_prop_changed   | Tree::name_cell_data_func
     *   - editable      | DataModel::on_item_prop_changed   | Queried when needed (See Tree::start_editing_item)
     *   - visible       | DataModel::on_item_prop_changed   | DataModel::filter_visible_func
     *   - icon          | DataModel::on_item_prop_changed   | Tree::icon_cell_data_func
     *   - activatable   | Same as @icon                     | Same as @icon
     * + ExpandableItem  |                                   |
     *   - collapsible   | DataModel::on_item_prop_changed   | Tree::update_expansion
     *                   |                                   | Tree::expander_cell_data_func
     *   - expanded      | Same as @collapsible              | Same as @collapsible
     * ---------------------------------------------------------------------------------------------
     * * Only automatic properties are monitored. ExpandableItem's additions/removals are handled by
     *   DataModel::add_item() and DataModel::remove_item()
     *
     * Other features:
     * - Sorting: this happens on the tree-model level (DataModel).
     */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>
#include <pango/pango.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <gee.h>
#include <cairo.h>
#include <gobject/gvaluecollector.h>


#define GRANITE_WIDGETS_TYPE_SOURCE_LIST_SORTABLE (granite_widgets_source_list_sortable_get_type ())
#define GRANITE_WIDGETS_SOURCE_LIST_SORTABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GRANITE_WIDGETS_TYPE_SOURCE_LIST_SORTABLE, GraniteWidgetsSourceListSortable))
#define GRANITE_WIDGETS_IS_SOURCE_LIST_SORTABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GRANITE_WIDGETS_TYPE_SOURCE_LIST_SORTABLE))
#define GRANITE_WIDGETS_SOURCE_LIST_SORTABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GRANITE_WIDGETS_TYPE_SOURCE_LIST_SORTABLE, GraniteWidgetsSourceListSortableIface))

typedef struct _GraniteWidgetsSourceListSortable GraniteWidgetsSourceListSortable;
typedef struct _GraniteWidgetsSourceListSortableIface GraniteWidgetsSourceListSortableIface;

#define GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM (granite_widgets_source_list_item_get_type ())
#define GRANITE_WIDGETS_SOURCE_LIST_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM, GraniteWidgetsSourceListItem))
#define GRANITE_WIDGETS_SOURCE_LIST_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM, GraniteWidgetsSourceListItemClass))
#define GRANITE_WIDGETS_SOURCE_LIST_IS_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM))
#define GRANITE_WIDGETS_SOURCE_LIST_IS_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM))
#define GRANITE_WIDGETS_SOURCE_LIST_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM, GraniteWidgetsSourceListItemClass))

typedef struct _GraniteWidgetsSourceListItem GraniteWidgetsSourceListItem;
typedef struct _GraniteWidgetsSourceListItemClass GraniteWidgetsSourceListItemClass;

#define GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM (granite_widgets_source_list_expandable_item_get_type ())
#define GRANITE_WIDGETS_SOURCE_LIST_EXPANDABLE_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM, GraniteWidgetsSourceListExpandableItem))
#define GRANITE_WIDGETS_SOURCE_LIST_EXPANDABLE_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM, GraniteWidgetsSourceListExpandableItemClass))
#define GRANITE_WIDGETS_SOURCE_LIST_IS_EXPANDABLE_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM))
#define GRANITE_WIDGETS_SOURCE_LIST_IS_EXPANDABLE_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM))
#define GRANITE_WIDGETS_SOURCE_LIST_EXPANDABLE_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM, GraniteWidgetsSourceListExpandableItemClass))

typedef struct _GraniteWidgetsSourceListExpandableItem GraniteWidgetsSourceListExpandableItem;
typedef struct _GraniteWidgetsSourceListExpandableItemClass GraniteWidgetsSourceListExpandableItemClass;
enum  {
	GRANITE_WIDGETS_SOURCE_LIST_SORTABLE_USER_MOVED_ITEM_SIGNAL,
	GRANITE_WIDGETS_SOURCE_LIST_SORTABLE_NUM_SIGNALS
};
static guint granite_widgets_source_list_sortable_signals[GRANITE_WIDGETS_SOURCE_LIST_SORTABLE_NUM_SIGNALS] = {0};

#define GRANITE_WIDGETS_TYPE_SOURCE_LIST_DRAG_SOURCE (granite_widgets_source_list_drag_source_get_type ())
#define GRANITE_WIDGETS_SOURCE_LIST_DRAG_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GRANITE_WIDGETS_TYPE_SOURCE_LIST_DRAG_SOURCE, GraniteWidgetsSourceListDragSource))
#define GRANITE_WIDGETS_IS_SOURCE_LIST_DRAG_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GRANITE_WIDGETS_TYPE_SOURCE_LIST_DRAG_SOURCE))
#define GRANITE_WIDGETS_SOURCE_LIST_DRAG_SOURCE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GRANITE_WIDGETS_TYPE_SOURCE_LIST_DRAG_SOURCE, GraniteWidgetsSourceListDragSourceIface))

typedef struct _GraniteWidgetsSourceListDragSource GraniteWidgetsSourceListDragSource;
typedef struct _GraniteWidgetsSourceListDragSourceIface GraniteWidgetsSourceListDragSourceIface;

#define GRANITE_WIDGETS_TYPE_SOURCE_LIST_DRAG_DEST (granite_widgets_source_list_drag_dest_get_type ())
#define GRANITE_WIDGETS_SOURCE_LIST_DRAG_DEST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GRANITE_WIDGETS_TYPE_SOURCE_LIST_DRAG_DEST, GraniteWidgetsSourceListDragDest))
#define GRANITE_WIDGETS_IS_SOURCE_LIST_DRAG_DEST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GRANITE_WIDGETS_TYPE_SOURCE_LIST_DRAG_DEST))
#define GRANITE_WIDGETS_SOURCE_LIST_DRAG_DEST_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GRANITE_WIDGETS_TYPE_SOURCE_LIST_DRAG_DEST, GraniteWidgetsSourceListDragDestIface))

typedef struct _GraniteWidgetsSourceListDragDest GraniteWidgetsSourceListDragDest;
typedef struct _GraniteWidgetsSourceListDragDestIface GraniteWidgetsSourceListDragDestIface;

#define GRANITE_WIDGETS_TYPE_SOURCE_LIST (granite_widgets_source_list_get_type ())
#define GRANITE_WIDGETS_SOURCE_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GRANITE_WIDGETS_TYPE_SOURCE_LIST, GraniteWidgetsSourceList))
#define GRANITE_WIDGETS_SOURCE_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GRANITE_WIDGETS_TYPE_SOURCE_LIST, GraniteWidgetsSourceListClass))
#define GRANITE_WIDGETS_IS_SOURCE_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GRANITE_WIDGETS_TYPE_SOURCE_LIST))
#define GRANITE_WIDGETS_IS_SOURCE_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GRANITE_WIDGETS_TYPE_SOURCE_LIST))
#define GRANITE_WIDGETS_SOURCE_LIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GRANITE_WIDGETS_TYPE_SOURCE_LIST, GraniteWidgetsSourceListClass))

typedef struct _GraniteWidgetsSourceList GraniteWidgetsSourceList;
typedef struct _GraniteWidgetsSourceListClass GraniteWidgetsSourceListClass;
typedef struct _GraniteWidgetsSourceListPrivate GraniteWidgetsSourceListPrivate;

#define GRANITE_WIDGETS_SOURCE_LIST_TYPE_TREE (granite_widgets_source_list_tree_get_type ())
#define GRANITE_WIDGETS_SOURCE_LIST_TREE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GRANITE_WIDGETS_SOURCE_LIST_TYPE_TREE, GraniteWidgetsSourceListTree))
#define GRANITE_WIDGETS_SOURCE_LIST_TREE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GRANITE_WIDGETS_SOURCE_LIST_TYPE_TREE, GraniteWidgetsSourceListTreeClass))
#define GRANITE_WIDGETS_SOURCE_LIST_IS_TREE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GRANITE_WIDGETS_SOURCE_LIST_TYPE_TREE))
#define GRANITE_WIDGETS_SOURCE_LIST_IS_TREE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GRANITE_WIDGETS_SOURCE_LIST_TYPE_TREE))
#define GRANITE_WIDGETS_SOURCE_LIST_TREE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GRANITE_WIDGETS_SOURCE_LIST_TYPE_TREE, GraniteWidgetsSourceListTreeClass))

typedef struct _GraniteWidgetsSourceListTree GraniteWidgetsSourceListTree;
typedef struct _GraniteWidgetsSourceListTreeClass GraniteWidgetsSourceListTreeClass;

#define GRANITE_WIDGETS_SOURCE_LIST_TYPE_DATA_MODEL (granite_widgets_source_list_data_model_get_type ())
#define GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GRANITE_WIDGETS_SOURCE_LIST_TYPE_DATA_MODEL, GraniteWidgetsSourceListDataModel))
#define GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GRANITE_WIDGETS_SOURCE_LIST_TYPE_DATA_MODEL, GraniteWidgetsSourceListDataModelClass))
#define GRANITE_WIDGETS_SOURCE_LIST_IS_DATA_MODEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GRANITE_WIDGETS_SOURCE_LIST_TYPE_DATA_MODEL))
#define GRANITE_WIDGETS_SOURCE_LIST_IS_DATA_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GRANITE_WIDGETS_SOURCE_LIST_TYPE_DATA_MODEL))
#define GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GRANITE_WIDGETS_SOURCE_LIST_TYPE_DATA_MODEL, GraniteWidgetsSourceListDataModelClass))

typedef struct _GraniteWidgetsSourceListDataModel GraniteWidgetsSourceListDataModel;
typedef struct _GraniteWidgetsSourceListDataModelClass GraniteWidgetsSourceListDataModelClass;
enum  {
	GRANITE_WIDGETS_SOURCE_LIST_0_PROPERTY,
	GRANITE_WIDGETS_SOURCE_LIST_ROOT_PROPERTY,
	GRANITE_WIDGETS_SOURCE_LIST_SELECTED_PROPERTY,
	GRANITE_WIDGETS_SOURCE_LIST_ELLIPSIZE_MODE_PROPERTY,
	GRANITE_WIDGETS_SOURCE_LIST_EDITING_PROPERTY,
	GRANITE_WIDGETS_SOURCE_LIST_NUM_PROPERTIES
};
static GParamSpec* granite_widgets_source_list_properties[GRANITE_WIDGETS_SOURCE_LIST_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef gboolean (*GraniteWidgetsSourceListVisibleFunc) (GraniteWidgetsSourceListItem* item, gpointer user_data);
#define __vala_GtkTreePath_free0(var) ((var == NULL) ? NULL : (var = (_vala_GtkTreePath_free (var), NULL)))
#define _g_free0(var) ((var == NULL) ? NULL : (var = (g_free (var), NULL)))
typedef struct _GraniteWidgetsSourceListItemPrivate GraniteWidgetsSourceListItemPrivate;
enum  {
	GRANITE_WIDGETS_SOURCE_LIST_ITEM_0_PROPERTY,
	GRANITE_WIDGETS_SOURCE_LIST_ITEM_PARENT_PROPERTY,
	GRANITE_WIDGETS_SOURCE_LIST_ITEM_NAME_PROPERTY,
	GRANITE_WIDGETS_SOURCE_LIST_ITEM_MARKUP_PROPERTY,
	GRANITE_WIDGETS_SOURCE_LIST_ITEM_BADGE_PROPERTY,
	GRANITE_WIDGETS_SOURCE_LIST_ITEM_EDITABLE_PROPERTY,
	GRANITE_WIDGETS_SOURCE_LIST_ITEM_VISIBLE_PROPERTY,
	GRANITE_WIDGETS_SOURCE_LIST_ITEM_SELECTABLE_PROPERTY,
	GRANITE_WIDGETS_SOURCE_LIST_ITEM_ICON_PROPERTY,
	GRANITE_WIDGETS_SOURCE_LIST_ITEM_ACTIVATABLE_PROPERTY,
	GRANITE_WIDGETS_SOURCE_LIST_ITEM_NUM_PROPERTIES
};
static GParamSpec* granite_widgets_source_list_item_properties[GRANITE_WIDGETS_SOURCE_LIST_ITEM_NUM_PROPERTIES];
enum  {
	GRANITE_WIDGETS_SOURCE_LIST_ITEM_EDITED_SIGNAL,
	GRANITE_WIDGETS_SOURCE_LIST_ITEM_ACTION_ACTIVATED_SIGNAL,
	GRANITE_WIDGETS_SOURCE_LIST_ITEM_ACTIVATED_SIGNAL,
	GRANITE_WIDGETS_SOURCE_LIST_ITEM_NUM_SIGNALS
};
static guint granite_widgets_source_list_item_signals[GRANITE_WIDGETS_SOURCE_LIST_ITEM_NUM_SIGNALS] = {0};
typedef struct _GraniteWidgetsSourceListExpandableItemPrivate GraniteWidgetsSourceListExpandableItemPrivate;
enum  {
	GRANITE_WIDGETS_SOURCE_LIST_EXPANDABLE_ITEM_0_PROPERTY,
	GRANITE_WIDGETS_SOURCE_LIST_EXPANDABLE_ITEM_COLLAPSIBLE_PROPERTY,
	GRANITE_WIDGETS_SOURCE_LIST_EXPANDABLE_ITEM_EXPANDED_PROPERTY,
	GRANITE_WIDGETS_SOURCE_LIST_EXPANDABLE_ITEM_N_CHILDREN_PROPERTY,
	GRANITE_WIDGETS_SOURCE_LIST_EXPANDABLE_ITEM_CHILDREN_PROPERTY,
	GRANITE_WIDGETS_SOURCE_LIST_EXPANDABLE_ITEM_NUM_PROPERTIES
};
static GParamSpec* granite_widgets_source_list_expandable_item_properties[GRANITE_WIDGETS_SOURCE_LIST_EXPANDABLE_ITEM_NUM_PROPERTIES];
enum  {
	GRANITE_WIDGETS_SOURCE_LIST_EXPANDABLE_ITEM_CHILD_ADDED_SIGNAL,
	GRANITE_WIDGETS_SOURCE_LIST_EXPANDABLE_ITEM_CHILD_REMOVED_SIGNAL,
	GRANITE_WIDGETS_SOURCE_LIST_EXPANDABLE_ITEM_TOGGLED_SIGNAL,
	GRANITE_WIDGETS_SOURCE_LIST_EXPANDABLE_ITEM_NUM_SIGNALS
};
static guint granite_widgets_source_list_expandable_item_signals[GRANITE_WIDGETS_SOURCE_LIST_EXPANDABLE_ITEM_NUM_SIGNALS] = {0};
typedef struct _GraniteWidgetsSourceListDataModelPrivate GraniteWidgetsSourceListDataModelPrivate;

#define GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_NODE_WRAPPER (granite_widgets_source_list_data_model_node_wrapper_get_type ())
#define GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_NODE_WRAPPER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_NODE_WRAPPER, GraniteWidgetsSourceListDataModelNodeWrapper))
#define GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_NODE_WRAPPER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_NODE_WRAPPER, GraniteWidgetsSourceListDataModelNodeWrapperClass))
#define GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_IS_NODE_WRAPPER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_NODE_WRAPPER))
#define GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_IS_NODE_WRAPPER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_NODE_WRAPPER))
#define GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_NODE_WRAPPER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_NODE_WRAPPER, GraniteWidgetsSourceListDataModelNodeWrapperClass))

typedef struct _GraniteWidgetsSourceListDataModelNodeWrapper GraniteWidgetsSourceListDataModelNodeWrapper;
typedef struct _GraniteWidgetsSourceListDataModelNodeWrapperClass GraniteWidgetsSourceListDataModelNodeWrapperClass;

#define GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_ITEM_MONITOR (granite_widgets_source_list_data_model_item_monitor_get_type ())
#define GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_ITEM_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_ITEM_MONITOR, GraniteWidgetsSourceListDataModelItemMonitor))
#define GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_ITEM_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_ITEM_MONITOR, GraniteWidgetsSourceListDataModelItemMonitorClass))
#define GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_IS_ITEM_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_ITEM_MONITOR))
#define GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_IS_ITEM_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_ITEM_MONITOR))
#define GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_ITEM_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_ITEM_MONITOR, GraniteWidgetsSourceListDataModelItemMonitorClass))

typedef struct _GraniteWidgetsSourceListDataModelItemMonitor GraniteWidgetsSourceListDataModelItemMonitor;
typedef struct _GraniteWidgetsSourceListDataModelItemMonitorClass GraniteWidgetsSourceListDataModelItemMonitorClass;
enum  {
	GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_0_PROPERTY,
	GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_ROOT_PROPERTY,
	GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_NUM_PROPERTIES
};
static GParamSpec* granite_widgets_source_list_data_model_properties[GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_NUM_PROPERTIES];
typedef enum  {
	GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_COLUMN_ITEM,
	GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_COLUMN_N_COLUMNS
} GraniteWidgetsSourceListDataModelColumn;


#define GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_COLUMN (granite_widgets_source_list_data_model_column_get_type ())
#define _granite_widgets_source_list_data_model_node_wrapper_unref0(var) ((var == NULL) ? NULL : (var = (granite_widgets_source_list_data_model_node_wrapper_unref (var), NULL)))
#define _granite_widgets_source_list_data_model_item_monitor_unref0(var) ((var == NULL) ? NULL : (var = (granite_widgets_source_list_data_model_item_monitor_unref (var), NULL)))
typedef struct _Block12Data Block12Data;
typedef struct _GraniteWidgetsSourceListDataModelNodeWrapperPrivate GraniteWidgetsSourceListDataModelNodeWrapperPrivate;
#define __vala_GtkTreeRowReference_free0(var) ((var == NULL) ? NULL : (var = (_vala_GtkTreeRowReference_free (var), NULL)))
typedef struct _GraniteWidgetsSourceListDataModelParamSpecNodeWrapper GraniteWidgetsSourceListDataModelParamSpecNodeWrapper;
typedef struct _GraniteWidgetsSourceListDataModelItemMonitorPrivate GraniteWidgetsSourceListDataModelItemMonitorPrivate;
typedef struct _GraniteWidgetsSourceListDataModelParamSpecItemMonitor GraniteWidgetsSourceListDataModelParamSpecItemMonitor;
enum  {
	GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_ITEM_MONITOR_CHANGED_SIGNAL,
	GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_ITEM_MONITOR_NUM_SIGNALS
};
static guint granite_widgets_source_list_data_model_item_monitor_signals[GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_ITEM_MONITOR_NUM_SIGNALS] = {0};
enum  {
	GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_ITEM_UPDATED_SIGNAL,
	GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_NUM_SIGNALS
};
static guint granite_widgets_source_list_data_model_signals[GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_NUM_SIGNALS] = {0};

#define GRANITE_WIDGETS_SOURCE_LIST_TYPE_CELL_RENDERER_ICON (granite_widgets_source_list_cell_renderer_icon_get_type ())
#define GRANITE_WIDGETS_SOURCE_LIST_CELL_RENDERER_ICON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GRANITE_WIDGETS_SOURCE_LIST_TYPE_CELL_RENDERER_ICON, GraniteWidgetsSourceListCellRendererIcon))
#define GRANITE_WIDGETS_SOURCE_LIST_CELL_RENDERER_ICON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GRANITE_WIDGETS_SOURCE_LIST_TYPE_CELL_RENDERER_ICON, GraniteWidgetsSourceListCellRendererIconClass))
#define GRANITE_WIDGETS_SOURCE_LIST_IS_CELL_RENDERER_ICON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GRANITE_WIDGETS_SOURCE_LIST_TYPE_CELL_RENDERER_ICON))
#define GRANITE_WIDGETS_SOURCE_LIST_IS_CELL_RENDERER_ICON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GRANITE_WIDGETS_SOURCE_LIST_TYPE_CELL_RENDERER_ICON))
#define GRANITE_WIDGETS_SOURCE_LIST_CELL_RENDERER_ICON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GRANITE_WIDGETS_SOURCE_LIST_TYPE_CELL_RENDERER_ICON, GraniteWidgetsSourceListCellRendererIconClass))

typedef struct _GraniteWidgetsSourceListCellRendererIcon GraniteWidgetsSourceListCellRendererIcon;
typedef struct _GraniteWidgetsSourceListCellRendererIconClass GraniteWidgetsSourceListCellRendererIconClass;
typedef struct _GraniteWidgetsSourceListCellRendererIconPrivate GraniteWidgetsSourceListCellRendererIconPrivate;
enum  {
	GRANITE_WIDGETS_SOURCE_LIST_CELL_RENDERER_ICON_0_PROPERTY,
	GRANITE_WIDGETS_SOURCE_LIST_CELL_RENDERER_ICON_NUM_PROPERTIES
};
static GParamSpec* granite_widgets_source_list_cell_renderer_icon_properties[GRANITE_WIDGETS_SOURCE_LIST_CELL_RENDERER_ICON_NUM_PROPERTIES];
enum  {
	GRANITE_WIDGETS_SOURCE_LIST_CELL_RENDERER_ICON_ACTIVATED_SIGNAL,
	GRANITE_WIDGETS_SOURCE_LIST_CELL_RENDERER_ICON_NUM_SIGNALS
};
static guint granite_widgets_source_list_cell_renderer_icon_signals[GRANITE_WIDGETS_SOURCE_LIST_CELL_RENDERER_ICON_NUM_SIGNALS] = {0};

#define GRANITE_WIDGETS_SOURCE_LIST_TYPE_CELL_RENDERER_SPACER (granite_widgets_source_list_cell_renderer_spacer_get_type ())
#define GRANITE_WIDGETS_SOURCE_LIST_CELL_RENDERER_SPACER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GRANITE_WIDGETS_SOURCE_LIST_TYPE_CELL_RENDERER_SPACER, GraniteWidgetsSourceListCellRendererSpacer))
#define GRANITE_WIDGETS_SOURCE_LIST_CELL_RENDERER_SPACER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GRANITE_WIDGETS_SOURCE_LIST_TYPE_CELL_RENDERER_SPACER, GraniteWidgetsSourceListCellRendererSpacerClass))
#define GRANITE_WIDGETS_SOURCE_LIST_IS_CELL_RENDERER_SPACER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GRANITE_WIDGETS_SOURCE_LIST_TYPE_CELL_RENDERER_SPACER))
#define GRANITE_WIDGETS_SOURCE_LIST_IS_CELL_RENDERER_SPACER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GRANITE_WIDGETS_SOURCE_LIST_TYPE_CELL_RENDERER_SPACER))
#define GRANITE_WIDGETS_SOURCE_LIST_CELL_RENDERER_SPACER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GRANITE_WIDGETS_SOURCE_LIST_TYPE_CELL_RENDERER_SPACER, GraniteWidgetsSourceListCellRendererSpacerClass))

typedef struct _GraniteWidgetsSourceListCellRendererSpacer GraniteWidgetsSourceListCellRendererSpacer;
typedef struct _GraniteWidgetsSourceListCellRendererSpacerClass GraniteWidgetsSourceListCellRendererSpacerClass;
typedef struct _GraniteWidgetsSourceListCellRendererSpacerPrivate GraniteWidgetsSourceListCellRendererSpacerPrivate;
enum  {
	GRANITE_WIDGETS_SOURCE_LIST_CELL_RENDERER_SPACER_0_PROPERTY,
	GRANITE_WIDGETS_SOURCE_LIST_CELL_RENDERER_SPACER_LEVEL_PROPERTY,
	GRANITE_WIDGETS_SOURCE_LIST_CELL_RENDERER_SPACER_NUM_PROPERTIES
};
static GParamSpec* granite_widgets_source_list_cell_renderer_spacer_properties[GRANITE_WIDGETS_SOURCE_LIST_CELL_RENDERER_SPACER_NUM_PROPERTIES];
typedef struct _GraniteWidgetsSourceListTreePrivate GraniteWidgetsSourceListTreePrivate;

#define GRANITE_WIDGETS_TYPE_CELL_RENDERER_BADGE (granite_widgets_cell_renderer_badge_get_type ())
#define GRANITE_WIDGETS_CELL_RENDERER_BADGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GRANITE_WIDGETS_TYPE_CELL_RENDERER_BADGE, GraniteWidgetsCellRendererBadge))
#define GRANITE_WIDGETS_CELL_RENDERER_BADGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GRANITE_WIDGETS_TYPE_CELL_RENDERER_BADGE, GraniteWidgetsCellRendererBadgeClass))
#define GRANITE_WIDGETS_IS_CELL_RENDERER_BADGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GRANITE_WIDGETS_TYPE_CELL_RENDERER_BADGE))
#define GRANITE_WIDGETS_IS_CELL_RENDERER_BADGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GRANITE_WIDGETS_TYPE_CELL_RENDERER_BADGE))
#define GRANITE_WIDGETS_CELL_RENDERER_BADGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GRANITE_WIDGETS_TYPE_CELL_RENDERER_BADGE, GraniteWidgetsCellRendererBadgeClass))

typedef struct _GraniteWidgetsCellRendererBadge GraniteWidgetsCellRendererBadge;
typedef struct _GraniteWidgetsCellRendererBadgeClass GraniteWidgetsCellRendererBadgeClass;

#define GRANITE_WIDGETS_TYPE_CELL_RENDERER_EXPANDER (granite_widgets_cell_renderer_expander_get_type ())
#define GRANITE_WIDGETS_CELL_RENDERER_EXPANDER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GRANITE_WIDGETS_TYPE_CELL_RENDERER_EXPANDER, GraniteWidgetsCellRendererExpander))
#define GRANITE_WIDGETS_CELL_RENDERER_EXPANDER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GRANITE_WIDGETS_TYPE_CELL_RENDERER_EXPANDER, GraniteWidgetsCellRendererExpanderClass))
#define GRANITE_WIDGETS_IS_CELL_RENDERER_EXPANDER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GRANITE_WIDGETS_TYPE_CELL_RENDERER_EXPANDER))
#define GRANITE_WIDGETS_IS_CELL_RENDERER_EXPANDER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GRANITE_WIDGETS_TYPE_CELL_RENDERER_EXPANDER))
#define GRANITE_WIDGETS_CELL_RENDERER_EXPANDER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GRANITE_WIDGETS_TYPE_CELL_RENDERER_EXPANDER, GraniteWidgetsCellRendererExpanderClass))

typedef struct _GraniteWidgetsCellRendererExpander GraniteWidgetsCellRendererExpander;
typedef struct _GraniteWidgetsCellRendererExpanderClass GraniteWidgetsCellRendererExpanderClass;
enum  {
	GRANITE_WIDGETS_SOURCE_LIST_TREE_0_PROPERTY,
	GRANITE_WIDGETS_SOURCE_LIST_TREE_DATA_MODEL_PROPERTY,
	GRANITE_WIDGETS_SOURCE_LIST_TREE_SELECTED_ITEM_PROPERTY,
	GRANITE_WIDGETS_SOURCE_LIST_TREE_EDITING_PROPERTY,
	GRANITE_WIDGETS_SOURCE_LIST_TREE_ELLIPSIZE_MODE_PROPERTY,
	GRANITE_WIDGETS_SOURCE_LIST_TREE_NUM_PROPERTIES
};
static GParamSpec* granite_widgets_source_list_tree_properties[GRANITE_WIDGETS_SOURCE_LIST_TREE_NUM_PROPERTIES];
typedef enum  {
	GRANITE_WIDGETS_SOURCE_LIST_TREE_COLUMN_ITEM,
	GRANITE_WIDGETS_SOURCE_LIST_TREE_COLUMN_N_COLS
} GraniteWidgetsSourceListTreeColumn;


#define GRANITE_WIDGETS_SOURCE_LIST_TREE_TYPE_COLUMN (granite_widgets_source_list_tree_column_get_type ())
#define _gtk_target_list_unref0(var) ((var == NULL) ? NULL : (var = (gtk_target_list_unref (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _g_param_spec_unref0(var) ((var == NULL) ? NULL : (var = (g_param_spec_unref (var), NULL)))
enum  {
	GRANITE_WIDGETS_SOURCE_LIST_TREE_ITEM_SELECTED_SIGNAL,
	GRANITE_WIDGETS_SOURCE_LIST_TREE_NUM_SIGNALS
};
static guint granite_widgets_source_list_tree_signals[GRANITE_WIDGETS_SOURCE_LIST_TREE_NUM_SIGNALS] = {0};
enum  {
	GRANITE_WIDGETS_SOURCE_LIST_ITEM_SELECTED_SIGNAL,
	GRANITE_WIDGETS_SOURCE_LIST_NUM_SIGNALS
};
static guint granite_widgets_source_list_signals[GRANITE_WIDGETS_SOURCE_LIST_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _GraniteWidgetsSourceListSortableIface {
	GTypeInterface parent_iface;
	gboolean (*allow_dnd_sorting) (GraniteWidgetsSourceListSortable* self);
	gint (*compare) (GraniteWidgetsSourceListSortable* self, GraniteWidgetsSourceListItem* a, GraniteWidgetsSourceListItem* b);
};

struct _GraniteWidgetsSourceListDragSourceIface {
	GTypeInterface parent_iface;
	gboolean (*draggable) (GraniteWidgetsSourceListDragSource* self);
	void (*prepare_selection_data) (GraniteWidgetsSourceListDragSource* self, GtkSelectionData* selection_data);
};

struct _GraniteWidgetsSourceListDragDestIface {
	GTypeInterface parent_iface;
	gboolean (*data_drop_possible) (GraniteWidgetsSourceListDragDest* self, GdkDragContext* context, GtkSelectionData* data);
	GdkDragAction (*data_received) (GraniteWidgetsSourceListDragDest* self, GdkDragContext* context, GtkSelectionData* data);
};

struct _GraniteWidgetsSourceList {
	GtkScrolledWindow parent_instance;
	GraniteWidgetsSourceListPrivate * priv;
};

struct _GraniteWidgetsSourceListClass {
	GtkScrolledWindowClass parent_class;
	void (*item_selected) (GraniteWidgetsSourceList* self, GraniteWidgetsSourceListItem* item);
};

struct _GraniteWidgetsSourceListPrivate {
	GraniteWidgetsSourceListTree* tree;
	GraniteWidgetsSourceListDataModel* data_model;
};

struct _GraniteWidgetsSourceListItem {
	GObject parent_instance;
	GraniteWidgetsSourceListItemPrivate * priv;
};

struct _GraniteWidgetsSourceListItemClass {
	GObjectClass parent_class;
	void (*edited) (GraniteWidgetsSourceListItem* self, const gchar* new_name);
	void (*action_activated) (GraniteWidgetsSourceListItem* self);
	void (*activated) (GraniteWidgetsSourceListItem* self);
	GtkMenu* (*get_context_menu) (GraniteWidgetsSourceListItem* self);
};

struct _GraniteWidgetsSourceListItemPrivate {
	GraniteWidgetsSourceListExpandableItem* _parent;
	gchar* _name;
	gchar* _markup;
	gchar* _badge;
	gboolean _editable;
	gboolean _visible;
	gboolean _selectable;
	GIcon* _icon;
	GIcon* _activatable;
};

struct _GraniteWidgetsSourceListExpandableItem {
	GraniteWidgetsSourceListItem parent_instance;
	GraniteWidgetsSourceListExpandableItemPrivate * priv;
};

struct _GraniteWidgetsSourceListExpandableItemClass {
	GraniteWidgetsSourceListItemClass parent_class;
	void (*toggled) (GraniteWidgetsSourceListExpandableItem* self);
};

struct _GraniteWidgetsSourceListExpandableItemPrivate {
	gboolean _collapsible;
	gboolean _expanded;
	GeeCollection* children_list;
};

struct _GraniteWidgetsSourceListDataModel {
	GtkTreeModelFilter parent_instance;
	GraniteWidgetsSourceListDataModelPrivate * priv;
};

struct _GraniteWidgetsSourceListDataModelClass {
	GtkTreeModelFilterClass parent_class;
};

struct _GraniteWidgetsSourceListDataModelPrivate {
	GraniteWidgetsSourceListExpandableItem* _root;
	GeeHashMap* items;
	GeeHashMap* monitors;
	GtkTreeStore* child_tree;
	GraniteWidgetsSourceListVisibleFunc filter_func;
	gpointer filter_func_target;
};

struct _Block12Data {
	int _ref_count_;
	GraniteWidgetsSourceListDataModel* self;
	GraniteWidgetsSourceListExpandableItem* parent;
};

struct _GraniteWidgetsSourceListDataModelNodeWrapper {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GraniteWidgetsSourceListDataModelNodeWrapperPrivate * priv;
};

struct _GraniteWidgetsSourceListDataModelNodeWrapperClass {
	GTypeClass parent_class;
	void (*finalize) (GraniteWidgetsSourceListDataModelNodeWrapper *self);
};

struct _GraniteWidgetsSourceListDataModelNodeWrapperPrivate {
	GtkTreeRowReference* row_reference;
};

struct _GraniteWidgetsSourceListDataModelParamSpecNodeWrapper {
	GParamSpec parent_instance;
};

struct _GraniteWidgetsSourceListDataModelItemMonitor {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GraniteWidgetsSourceListDataModelItemMonitorPrivate * priv;
};

struct _GraniteWidgetsSourceListDataModelItemMonitorClass {
	GTypeClass parent_class;
	void (*finalize) (GraniteWidgetsSourceListDataModelItemMonitor *self);
};

struct _GraniteWidgetsSourceListDataModelItemMonitorPrivate {
	GraniteWidgetsSourceListItem* item;
};

struct _GraniteWidgetsSourceListDataModelParamSpecItemMonitor {
	GParamSpec parent_instance;
};

struct _GraniteWidgetsSourceListCellRendererIcon {
	GtkCellRendererPixbuf parent_instance;
	GraniteWidgetsSourceListCellRendererIconPrivate * priv;
};

struct _GraniteWidgetsSourceListCellRendererIconClass {
	GtkCellRendererPixbufClass parent_class;
};

struct _GraniteWidgetsSourceListCellRendererSpacer {
	GtkCellRenderer parent_instance;
	GraniteWidgetsSourceListCellRendererSpacerPrivate * priv;
};

struct _GraniteWidgetsSourceListCellRendererSpacerClass {
	GtkCellRendererClass parent_class;
};

struct _GraniteWidgetsSourceListCellRendererSpacerPrivate {
	gint _level;
};

struct _GraniteWidgetsSourceListTree {
	GtkTreeView parent_instance;
	GraniteWidgetsSourceListTreePrivate * priv;
};

struct _GraniteWidgetsSourceListTreeClass {
	GtkTreeViewClass parent_class;
};

struct _GraniteWidgetsSourceListTreePrivate {
	GraniteWidgetsSourceListDataModel* _data_model;
	GraniteWidgetsSourceListItem* selected;
	GraniteWidgetsSourceListItem* edited;
	GtkEntry* editable_entry;
	GtkCellRendererText* text_cell;
	GraniteWidgetsSourceListCellRendererIcon* icon_cell;
	GraniteWidgetsSourceListCellRendererIcon* activatable_cell;
	GraniteWidgetsCellRendererBadge* badge_cell;
	GraniteWidgetsCellRendererExpander* primary_expander_cell;
	GraniteWidgetsCellRendererExpander* secondary_expander_cell;
	GeeHashMap* spacer_cells;
	gboolean unselectable_item_clicked;
};


static gint GraniteWidgetsSourceList_private_offset;
static gpointer granite_widgets_source_list_parent_class = NULL;
static gint GraniteWidgetsSourceListItem_private_offset;
static gpointer granite_widgets_source_list_item_parent_class = NULL;
static gint GraniteWidgetsSourceListExpandableItem_private_offset;
static gpointer granite_widgets_source_list_expandable_item_parent_class = NULL;
static gint GraniteWidgetsSourceListDataModel_private_offset;
static gpointer granite_widgets_source_list_data_model_parent_class = NULL;
static gint GraniteWidgetsSourceListDataModelNodeWrapper_private_offset;
static gpointer granite_widgets_source_list_data_model_node_wrapper_parent_class = NULL;
static gint GraniteWidgetsSourceListDataModelItemMonitor_private_offset;
static gpointer granite_widgets_source_list_data_model_item_monitor_parent_class = NULL;
static GtkTreeDragSourceIface * granite_widgets_source_list_data_model_gtk_tree_drag_source_parent_iface = NULL;
static GtkTreeDragDestIface * granite_widgets_source_list_data_model_gtk_tree_drag_dest_parent_iface = NULL;
static gpointer granite_widgets_source_list_cell_renderer_icon_parent_class = NULL;
static gint GraniteWidgetsSourceListCellRendererSpacer_private_offset;
static gpointer granite_widgets_source_list_cell_renderer_spacer_parent_class = NULL;
static gint GraniteWidgetsSourceListTree_private_offset;
static gpointer granite_widgets_source_list_tree_parent_class = NULL;

GType granite_widgets_source_list_item_get_type (void) G_GNUC_CONST;
GType granite_widgets_source_list_expandable_item_get_type (void) G_GNUC_CONST;
GType granite_widgets_source_list_sortable_get_type (void) G_GNUC_CONST;
gboolean granite_widgets_source_list_sortable_allow_dnd_sorting (GraniteWidgetsSourceListSortable* self);
gint granite_widgets_source_list_sortable_compare (GraniteWidgetsSourceListSortable* self,
                                                   GraniteWidgetsSourceListItem* a,
                                                   GraniteWidgetsSourceListItem* b);
GType granite_widgets_source_list_drag_source_get_type (void) G_GNUC_CONST;
gboolean granite_widgets_source_list_drag_source_draggable (GraniteWidgetsSourceListDragSource* self);
void granite_widgets_source_list_drag_source_prepare_selection_data (GraniteWidgetsSourceListDragSource* self,
                                                                     GtkSelectionData* selection_data);
GType granite_widgets_source_list_drag_dest_get_type (void) G_GNUC_CONST;
gboolean granite_widgets_source_list_drag_dest_data_drop_possible (GraniteWidgetsSourceListDragDest* self,
                                                                   GdkDragContext* context,
                                                                   GtkSelectionData* data);
GdkDragAction granite_widgets_source_list_drag_dest_data_received (GraniteWidgetsSourceListDragDest* self,
                                                                   GdkDragContext* context,
                                                                   GtkSelectionData* data);
GType granite_widgets_source_list_get_type (void) G_GNUC_CONST;
static GType granite_widgets_source_list_tree_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static GType granite_widgets_source_list_data_model_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static GraniteWidgetsSourceListDataModel* granite_widgets_source_list_data_model_new (void);
static GraniteWidgetsSourceListDataModel* granite_widgets_source_list_data_model_construct (GType object_type);
GraniteWidgetsSourceList* granite_widgets_source_list_new (GraniteWidgetsSourceListExpandableItem* root);
GraniteWidgetsSourceList* granite_widgets_source_list_construct (GType object_type,
                                                                 GraniteWidgetsSourceListExpandableItem* root);
void granite_widgets_source_list_set_root (GraniteWidgetsSourceList* self,
                                           GraniteWidgetsSourceListExpandableItem* value);
gboolean granite_widgets_source_list_has_item (GraniteWidgetsSourceList* self,
                                               GraniteWidgetsSourceListItem* item);
static gboolean granite_widgets_source_list_data_model_has_item (GraniteWidgetsSourceListDataModel* self,
                                                          GraniteWidgetsSourceListItem* item);
void granite_widgets_source_list_set_filter_func (GraniteWidgetsSourceList* self,
                                                  GraniteWidgetsSourceListVisibleFunc visible_func,
                                                  gpointer visible_func_target,
                                                  gboolean refilter);
static void granite_widgets_source_list_data_model_set_filter_func (GraniteWidgetsSourceListDataModel* self,
                                                             GraniteWidgetsSourceListVisibleFunc visible_func,
                                                             gpointer visible_func_target);
void granite_widgets_source_list_refilter (GraniteWidgetsSourceList* self);
gboolean granite_widgets_source_list_is_item_expanded (GraniteWidgetsSourceList* self,
                                                       GraniteWidgetsSourceListItem* item);
static GtkTreePath* granite_widgets_source_list_data_model_get_item_path (GraniteWidgetsSourceListDataModel* self,
                                                                   GraniteWidgetsSourceListItem* item);
static void _vala_GtkTreePath_free (GtkTreePath* self);
gboolean granite_widgets_source_list_start_editing_item (GraniteWidgetsSourceList* self,
                                                         GraniteWidgetsSourceListItem* item);
static gboolean granite_widgets_source_list_tree_start_editing_item (GraniteWidgetsSourceListTree* self,
                                                              GraniteWidgetsSourceListItem* item);
void granite_widgets_source_list_stop_editing (GraniteWidgetsSourceList* self);
gboolean granite_widgets_source_list_get_editing (GraniteWidgetsSourceList* self);
static void granite_widgets_source_list_tree_stop_editing (GraniteWidgetsSourceListTree* self);
void granite_widgets_source_list_enable_drag_source (GraniteWidgetsSourceList* self,
                                                     GtkTargetEntry* src_entries,
                                                     int src_entries_length1);
static void granite_widgets_source_list_tree_configure_drag_source (GraniteWidgetsSourceListTree* self,
                                                             GtkTargetEntry* src_entries,
                                                             int src_entries_length1);
void granite_widgets_source_list_disable_drag_source (GraniteWidgetsSourceList* self);
void granite_widgets_source_list_enable_drag_dest (GraniteWidgetsSourceList* self,
                                                   GtkTargetEntry* dest_entries,
                                                   int dest_entries_length1,
                                                   GdkDragAction actions);
static void granite_widgets_source_list_tree_configure_drag_dest (GraniteWidgetsSourceListTree* self,
                                                           GtkTargetEntry* dest_entries,
                                                           int dest_entries_length1,
                                                           GdkDragAction actions);
void granite_widgets_source_list_disable_drag_dest (GraniteWidgetsSourceList* self);
gboolean granite_widgets_source_list_scroll_to_item (GraniteWidgetsSourceList* self,
                                                     GraniteWidgetsSourceListItem* item,
                                                     gboolean expand_parents,
                                                     gboolean use_align,
                                                     gfloat row_align);
GraniteWidgetsSourceListExpandableItem* granite_widgets_source_list_item_get_parent (GraniteWidgetsSourceListItem* self);
void granite_widgets_source_list_expandable_item_expand_with_parents (GraniteWidgetsSourceListExpandableItem* self);
static gboolean granite_widgets_source_list_tree_scroll_to_item (GraniteWidgetsSourceListTree* self,
                                                          GraniteWidgetsSourceListItem* item,
                                                          gboolean use_align,
                                                          gfloat row_align);
GraniteWidgetsSourceListItem* granite_widgets_source_list_get_previous_item (GraniteWidgetsSourceList* self,
                                                                             GraniteWidgetsSourceListItem* reference);
static GtkTreeIter* granite_widgets_source_list_data_model_get_item_iter (GraniteWidgetsSourceListDataModel* self,
                                                                   GraniteWidgetsSourceListItem* item);
static GraniteWidgetsSourceListItem* granite_widgets_source_list_data_model_get_item (GraniteWidgetsSourceListDataModel* self,
                                                                               GtkTreeIter* iter);
GraniteWidgetsSourceListItem* granite_widgets_source_list_get_next_item (GraniteWidgetsSourceList* self,
                                                                         GraniteWidgetsSourceListItem* reference);
GraniteWidgetsSourceListItem* granite_widgets_source_list_get_first_child (GraniteWidgetsSourceList* self,
                                                                           GraniteWidgetsSourceListExpandableItem* parent);
static GraniteWidgetsSourceListItem* granite_widgets_source_list_get_nth_child (GraniteWidgetsSourceList* self,
                                                                         GraniteWidgetsSourceListExpandableItem* parent,
                                                                         gint index);
GraniteWidgetsSourceListItem* granite_widgets_source_list_get_last_child (GraniteWidgetsSourceList* self,
                                                                          GraniteWidgetsSourceListExpandableItem* parent);
guint granite_widgets_source_list_get_n_visible_children (GraniteWidgetsSourceList* self,
                                                          GraniteWidgetsSourceListExpandableItem* parent);
GraniteWidgetsSourceListExpandableItem* granite_widgets_source_list_get_root (GraniteWidgetsSourceList* self);
static GraniteWidgetsSourceListExpandableItem* granite_widgets_source_list_data_model_get_root (GraniteWidgetsSourceListDataModel* self);
static void granite_widgets_source_list_data_model_set_root (GraniteWidgetsSourceListDataModel* self,
                                                      GraniteWidgetsSourceListExpandableItem* value);
GraniteWidgetsSourceListItem* granite_widgets_source_list_get_selected (GraniteWidgetsSourceList* self);
static GraniteWidgetsSourceListItem* granite_widgets_source_list_tree_get_selected_item (GraniteWidgetsSourceListTree* self);
void granite_widgets_source_list_set_selected (GraniteWidgetsSourceList* self,
                                               GraniteWidgetsSourceListItem* value);
static void granite_widgets_source_list_tree_set_selected_item (GraniteWidgetsSourceListTree* self,
                                                         GraniteWidgetsSourceListItem* value);
PangoEllipsizeMode granite_widgets_source_list_get_ellipsize_mode (GraniteWidgetsSourceList* self);
static PangoEllipsizeMode granite_widgets_source_list_tree_get_ellipsize_mode (GraniteWidgetsSourceListTree* self);
void granite_widgets_source_list_set_ellipsize_mode (GraniteWidgetsSourceList* self,
                                                     PangoEllipsizeMode value);
static void granite_widgets_source_list_tree_set_ellipsize_mode (GraniteWidgetsSourceListTree* self,
                                                          PangoEllipsizeMode value);
static gboolean granite_widgets_source_list_tree_get_editing (GraniteWidgetsSourceListTree* self);
static void granite_widgets_source_list_real_item_selected (GraniteWidgetsSourceList* self,
                                                     GraniteWidgetsSourceListItem* item);
static GObject * granite_widgets_source_list_constructor (GType type,
                                                   guint n_construct_properties,
                                                   GObjectConstructParam * construct_properties);
static GraniteWidgetsSourceListTree* granite_widgets_source_list_tree_new (GraniteWidgetsSourceListDataModel* data_model);
static GraniteWidgetsSourceListTree* granite_widgets_source_list_tree_construct (GType object_type,
                                                                          GraniteWidgetsSourceListDataModel* data_model);
static void _granite_widgets_source_list___lambda77_ (GraniteWidgetsSourceList* self,
                                               GraniteWidgetsSourceListItem* item);
static void __granite_widgets_source_list___lambda77__granite_widgets_source_list_tree_item_selected (GraniteWidgetsSourceListTree* _sender,
                                                                                               GraniteWidgetsSourceListItem* item,
                                                                                               gpointer self);
GraniteWidgetsSourceListItem* granite_widgets_source_list_item_new (const gchar* name);
GraniteWidgetsSourceListItem* granite_widgets_source_list_item_construct (GType object_type,
                                                                          const gchar* name);
void granite_widgets_source_list_item_set_name (GraniteWidgetsSourceListItem* self,
                                                const gchar* value);
GtkMenu* granite_widgets_source_list_item_get_context_menu (GraniteWidgetsSourceListItem* self);
static GtkMenu* granite_widgets_source_list_item_real_get_context_menu (GraniteWidgetsSourceListItem* self);
G_GNUC_INTERNAL void granite_widgets_source_list_item_set_parent (GraniteWidgetsSourceListItem* self,
                                                  GraniteWidgetsSourceListExpandableItem* value);
const gchar* granite_widgets_source_list_item_get_name (GraniteWidgetsSourceListItem* self);
const gchar* granite_widgets_source_list_item_get_markup (GraniteWidgetsSourceListItem* self);
void granite_widgets_source_list_item_set_markup (GraniteWidgetsSourceListItem* self,
                                                  const gchar* value);
const gchar* granite_widgets_source_list_item_get_badge (GraniteWidgetsSourceListItem* self);
void granite_widgets_source_list_item_set_badge (GraniteWidgetsSourceListItem* self,
                                                 const gchar* value);
gboolean granite_widgets_source_list_item_get_editable (GraniteWidgetsSourceListItem* self);
void granite_widgets_source_list_item_set_editable (GraniteWidgetsSourceListItem* self,
                                                    gboolean value);
gboolean granite_widgets_source_list_item_get_visible (GraniteWidgetsSourceListItem* self);
void granite_widgets_source_list_item_set_visible (GraniteWidgetsSourceListItem* self,
                                                   gboolean value);
gboolean granite_widgets_source_list_item_get_selectable (GraniteWidgetsSourceListItem* self);
void granite_widgets_source_list_item_set_selectable (GraniteWidgetsSourceListItem* self,
                                                      gboolean value);
GIcon* granite_widgets_source_list_item_get_icon (GraniteWidgetsSourceListItem* self);
void granite_widgets_source_list_item_set_icon (GraniteWidgetsSourceListItem* self,
                                                GIcon* value);
GIcon* granite_widgets_source_list_item_get_activatable (GraniteWidgetsSourceListItem* self);
void granite_widgets_source_list_item_set_activatable (GraniteWidgetsSourceListItem* self,
                                                       GIcon* value);
static void granite_widgets_source_list_item_real_edited (GraniteWidgetsSourceListItem* self,
                                                   const gchar* new_name);
static void granite_widgets_source_list_item_real_action_activated (GraniteWidgetsSourceListItem* self);
static void granite_widgets_source_list_item_real_activated (GraniteWidgetsSourceListItem* self);
static void granite_widgets_source_list_item_finalize (GObject * obj);
static void _vala_granite_widgets_source_list_item_get_property (GObject * object,
                                                          guint property_id,
                                                          GValue * value,
                                                          GParamSpec * pspec);
static void _vala_granite_widgets_source_list_item_set_property (GObject * object,
                                                          guint property_id,
                                                          const GValue * value,
                                                          GParamSpec * pspec);
GraniteWidgetsSourceListExpandableItem* granite_widgets_source_list_expandable_item_new (const gchar* name);
GraniteWidgetsSourceListExpandableItem* granite_widgets_source_list_expandable_item_construct (GType object_type,
                                                                                               const gchar* name);
gboolean granite_widgets_source_list_expandable_item_contains (GraniteWidgetsSourceListExpandableItem* self,
                                                               GraniteWidgetsSourceListItem* item);
void granite_widgets_source_list_expandable_item_add (GraniteWidgetsSourceListExpandableItem* self,
                                                      GraniteWidgetsSourceListItem* item);
void granite_widgets_source_list_expandable_item_remove (GraniteWidgetsSourceListExpandableItem* self,
                                                         GraniteWidgetsSourceListItem* item);
void granite_widgets_source_list_expandable_item_clear (GraniteWidgetsSourceListExpandableItem* self);
GeeCollection* granite_widgets_source_list_expandable_item_get_children (GraniteWidgetsSourceListExpandableItem* self);
void granite_widgets_source_list_expandable_item_expand_all (GraniteWidgetsSourceListExpandableItem* self,
                                                             gboolean inclusive,
                                                             gboolean recursive);
static void granite_widgets_source_list_expandable_item_set_expansion (GraniteWidgetsSourceListExpandableItem* item,
                                                                gboolean inclusive,
                                                                gboolean recursive,
                                                                gboolean expanded);
void granite_widgets_source_list_expandable_item_collapse_all (GraniteWidgetsSourceListExpandableItem* self,
                                                               gboolean inclusive,
                                                               gboolean recursive);
void granite_widgets_source_list_expandable_item_set_expanded (GraniteWidgetsSourceListExpandableItem* self,
                                                               gboolean value);
void granite_widgets_source_list_expandable_item_collapse_with_parents (GraniteWidgetsSourceListExpandableItem* self);
gboolean granite_widgets_source_list_expandable_item_get_collapsible (GraniteWidgetsSourceListExpandableItem* self);
void granite_widgets_source_list_expandable_item_set_collapsible (GraniteWidgetsSourceListExpandableItem* self,
                                                                  gboolean value);
gboolean granite_widgets_source_list_expandable_item_get_expanded (GraniteWidgetsSourceListExpandableItem* self);
guint granite_widgets_source_list_expandable_item_get_n_children (GraniteWidgetsSourceListExpandableItem* self);
static void granite_widgets_source_list_expandable_item_real_toggled (GraniteWidgetsSourceListExpandableItem* self);
static GObject * granite_widgets_source_list_expandable_item_constructor (GType type,
                                                                   guint n_construct_properties,
                                                                   GObjectConstructParam * construct_properties);
static void granite_widgets_source_list_expandable_item_finalize (GObject * obj);
static void _vala_granite_widgets_source_list_expandable_item_get_property (GObject * object,
                                                                     guint property_id,
                                                                     GValue * value,
                                                                     GParamSpec * pspec);
static void _vala_granite_widgets_source_list_expandable_item_set_property (GObject * object,
                                                                     guint property_id,
                                                                     const GValue * value,
                                                                     GParamSpec * pspec);
static gpointer granite_widgets_source_list_data_model_node_wrapper_ref (gpointer instance);
static void granite_widgets_source_list_data_model_node_wrapper_unref (gpointer instance);
static GParamSpec* granite_widgets_source_list_data_model_param_spec_node_wrapper (const gchar* name,
                                                                            const gchar* nick,
                                                                            const gchar* blurb,
                                                                            GType object_type,
                                                                            GParamFlags flags) G_GNUC_UNUSED;
static void granite_widgets_source_list_data_model_value_set_node_wrapper (GValue* value,
                                                                    gpointer v_object) G_GNUC_UNUSED;
static void granite_widgets_source_list_data_model_value_take_node_wrapper (GValue* value,
                                                                     gpointer v_object) G_GNUC_UNUSED;
static gpointer granite_widgets_source_list_data_model_value_get_node_wrapper (const GValue* value) G_GNUC_UNUSED;
static GType granite_widgets_source_list_data_model_node_wrapper_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static gpointer granite_widgets_source_list_data_model_item_monitor_ref (gpointer instance);
static void granite_widgets_source_list_data_model_item_monitor_unref (gpointer instance);
static GParamSpec* granite_widgets_source_list_data_model_param_spec_item_monitor (const gchar* name,
                                                                            const gchar* nick,
                                                                            const gchar* blurb,
                                                                            GType object_type,
                                                                            GParamFlags flags) G_GNUC_UNUSED;
static void granite_widgets_source_list_data_model_value_set_item_monitor (GValue* value,
                                                                    gpointer v_object) G_GNUC_UNUSED;
static void granite_widgets_source_list_data_model_value_take_item_monitor (GValue* value,
                                                                     gpointer v_object) G_GNUC_UNUSED;
static gpointer granite_widgets_source_list_data_model_value_get_item_monitor (const GValue* value) G_GNUC_UNUSED;
static GType granite_widgets_source_list_data_model_item_monitor_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static GType granite_widgets_source_list_data_model_column_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static GType granite_widgets_source_list_data_model_column_type (GraniteWidgetsSourceListDataModelColumn self);
#define GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_ITEM_PARENT_NEEDS_UPDATE "item-parent-needs-update"
static void granite_widgets_source_list_data_model_update_item (GraniteWidgetsSourceListDataModel* self,
                                                         GraniteWidgetsSourceListItem* item);
static GtkTreePath* granite_widgets_source_list_data_model_node_wrapper_get_path (GraniteWidgetsSourceListDataModelNodeWrapper* self);
static GtkTreeIter* granite_widgets_source_list_data_model_node_wrapper_get_iter (GraniteWidgetsSourceListDataModelNodeWrapper* self);
static void granite_widgets_source_list_data_model_add_item (GraniteWidgetsSourceListDataModel* self,
                                                      GraniteWidgetsSourceListItem* item);
static GtkTreeIter* granite_widgets_source_list_data_model_get_item_child_iter (GraniteWidgetsSourceListDataModel* self,
                                                                         GraniteWidgetsSourceListItem* item);
static GtkTreeIter* _gtk_tree_iter_dup (GtkTreeIter* self);
static GraniteWidgetsSourceListDataModelNodeWrapper* granite_widgets_source_list_data_model_node_wrapper_new (GtkTreeModel* model,
                                                                                                       GtkTreeIter* iter);
static GraniteWidgetsSourceListDataModelNodeWrapper* granite_widgets_source_list_data_model_node_wrapper_construct (GType object_type,
                                                                                                             GtkTreeModel* model,
                                                                                                             GtkTreeIter* iter);
static void granite_widgets_source_list_data_model_add_property_monitor (GraniteWidgetsSourceListDataModel* self,
                                                                  GraniteWidgetsSourceListItem* item);
static void granite_widgets_source_list_data_model_push_parent_update (GraniteWidgetsSourceListDataModel* self,
                                                                GraniteWidgetsSourceListExpandableItem* parent);
static void granite_widgets_source_list_data_model_add_children_monitor (GraniteWidgetsSourceListDataModel* self,
                                                                  GraniteWidgetsSourceListExpandableItem* item);
static void granite_widgets_source_list_data_model_remove_item (GraniteWidgetsSourceListDataModel* self,
                                                         GraniteWidgetsSourceListItem* item);
static void granite_widgets_source_list_data_model_remove_property_monitor (GraniteWidgetsSourceListDataModel* self,
                                                                     GraniteWidgetsSourceListItem* item);
static void granite_widgets_source_list_data_model_remove_children_monitor (GraniteWidgetsSourceListDataModel* self,
                                                                     GraniteWidgetsSourceListExpandableItem* item);
static GraniteWidgetsSourceListDataModelItemMonitor* granite_widgets_source_list_data_model_item_monitor_new (GraniteWidgetsSourceListItem* item);
static GraniteWidgetsSourceListDataModelItemMonitor* granite_widgets_source_list_data_model_item_monitor_construct (GType object_type,
                                                                                                             GraniteWidgetsSourceListItem* item);
static void granite_widgets_source_list_data_model_on_item_prop_changed (GraniteWidgetsSourceListDataModel* self,
                                                                  GraniteWidgetsSourceListItem* item,
                                                                  const gchar* prop_name);
static void _granite_widgets_source_list_data_model_on_item_prop_changed_granite_widgets_source_list_data_model_item_monitor_changed (GraniteWidgetsSourceListDataModelItemMonitor* _sender,
                                                                                                                               GraniteWidgetsSourceListItem* _self_,
                                                                                                                               const gchar* prop_name,
                                                                                                                               gpointer self);
static void granite_widgets_source_list_data_model_on_item_child_added (GraniteWidgetsSourceListDataModel* self,
                                                                 GraniteWidgetsSourceListItem* item);
static void _granite_widgets_source_list_data_model_on_item_child_added_granite_widgets_source_list_expandable_item_child_added (GraniteWidgetsSourceListExpandableItem* _sender,
                                                                                                                          GraniteWidgetsSourceListItem* item,
                                                                                                                          gpointer self);
static void granite_widgets_source_list_data_model_on_item_child_removed (GraniteWidgetsSourceListDataModel* self,
                                                                   GraniteWidgetsSourceListItem* item);
static void _granite_widgets_source_list_data_model_on_item_child_removed_granite_widgets_source_list_expandable_item_child_removed (GraniteWidgetsSourceListExpandableItem* _sender,
                                                                                                                              GraniteWidgetsSourceListItem* item,
                                                                                                                              gpointer self);
static Block12Data* block12_data_ref (Block12Data* _data12_);
static void block12_data_unref (void * _userdata_);
static gboolean ___lambda76_ (Block12Data* _data12_);
static gboolean ____lambda76__gsource_func (gpointer self);
static GraniteWidgetsSourceListItem* granite_widgets_source_list_data_model_get_item_from_path (GraniteWidgetsSourceListDataModel* self,
                                                                                         GtkTreePath* path);
static GtkTreePath* granite_widgets_source_list_data_model_get_item_child_path (GraniteWidgetsSourceListDataModel* self,
                                                                         GraniteWidgetsSourceListItem* item);
static gboolean granite_widgets_source_list_data_model_is_category (GraniteWidgetsSourceListDataModel* self,
                                                             GraniteWidgetsSourceListItem* item,
                                                             GtkTreeIter* iter,
                                                             GtkTreePath* path);
static gboolean granite_widgets_source_list_data_model_is_iter_at_root_level (GraniteWidgetsSourceListDataModel* self,
                                                                       GtkTreeIter* iter);
static gboolean granite_widgets_source_list_data_model_is_path_at_root_level (GraniteWidgetsSourceListDataModel* self,
                                                                       GtkTreePath* path);
static void granite_widgets_source_list_data_model_resort (GraniteWidgetsSourceListDataModel* self);
static gint granite_widgets_source_list_data_model_child_model_sort_func (GraniteWidgetsSourceListDataModel* self,
                                                                   GtkTreeModel* model,
                                                                   GtkTreeIter* a,
                                                                   GtkTreeIter* b);
static gboolean granite_widgets_source_list_data_model_filter_visible_func (GraniteWidgetsSourceListDataModel* self,
                                                                     GtkTreeModel* child_model,
                                                                     GtkTreeIter* iter);
static gboolean granite_widgets_source_list_data_model_real_drag_data_received (GtkTreeDragDest* base,
                                                                         GtkTreePath* dest,
                                                                         GtkSelectionData* selection_data);
static gboolean granite_widgets_source_list_data_model_child_tree_drag_data_received (GraniteWidgetsSourceListDataModel* self,
                                                                               GtkTreePath* dest,
                                                                               GtkTreePath* src_path);
static GtkTreePath* _vala_GtkTreePath_copy (GtkTreePath* self);
static void granite_widgets_source_list_data_model_recursive_node_copy (GraniteWidgetsSourceListDataModel* self,
                                                                 GtkTreeIter* src_iter,
                                                                 GtkTreeIter* dest_iter);
static void granite_widgets_source_list_data_model_move_item (GraniteWidgetsSourceListDataModel* self,
                                                       GtkTreeIter* src_iter,
                                                       GtkTreeIter* dest_iter);
static gboolean granite_widgets_source_list_data_model_real_row_drop_possible (GtkTreeDragDest* base,
                                                                        GtkTreePath* dest,
                                                                        GtkSelectionData* selection_data);
static gint* _vala_array_dup4 (gint* self,
                        int length);
static gint* _vala_array_dup5 (gint* self,
                        int length);
static gboolean granite_widgets_source_list_data_model_real_drag_data_get (GtkTreeDragSource* base,
                                                                    GtkTreePath* path,
                                                                    GtkSelectionData* selection_data);
static gboolean granite_widgets_source_list_data_model_real_row_draggable (GtkTreeDragSource* base,
                                                                    GtkTreePath* path);
static GObject * granite_widgets_source_list_data_model_constructor (GType type,
                                                              guint n_construct_properties,
                                                              GObjectConstructParam * construct_properties);
static gint _granite_widgets_source_list_data_model_child_model_sort_func_gtk_tree_iter_compare_func (GtkTreeModel* model,
                                                                                               GtkTreeIter* a,
                                                                                               GtkTreeIter* b,
                                                                                               gpointer self);
static gboolean _granite_widgets_source_list_data_model_filter_visible_func_gtk_tree_model_filter_visible_func (GtkTreeModel* model,
                                                                                                         GtkTreeIter* iter,
                                                                                                         gpointer self);
static void _vala_GtkTreeRowReference_free (GtkTreeRowReference* self);
static gboolean granite_widgets_source_list_data_model_node_wrapper_get_valid (GraniteWidgetsSourceListDataModelNodeWrapper* self);
static void granite_widgets_source_list_data_model_node_wrapper_finalize (GraniteWidgetsSourceListDataModelNodeWrapper * obj);
static void granite_widgets_source_list_data_model_item_monitor_on_notify (GraniteWidgetsSourceListDataModelItemMonitor* self,
                                                                    GParamSpec* prop);
static void _granite_widgets_source_list_data_model_item_monitor_on_notify_g_object_notify (GObject* _sender,
                                                                                     GParamSpec* pspec,
                                                                                     gpointer self);
static void g_cclosure_user_marshal_VOID__OBJECT_STRING (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data);
static void granite_widgets_source_list_data_model_item_monitor_finalize (GraniteWidgetsSourceListDataModelItemMonitor * obj);
static void granite_widgets_source_list_data_model_finalize (GObject * obj);
static void _vala_granite_widgets_source_list_data_model_get_property (GObject * object,
                                                                guint property_id,
                                                                GValue * value,
                                                                GParamSpec * pspec);
static void _vala_granite_widgets_source_list_data_model_set_property (GObject * object,
                                                                guint property_id,
                                                                const GValue * value,
                                                                GParamSpec * pspec);
static GType granite_widgets_source_list_cell_renderer_icon_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
#define GRANITE_WIDGETS_SOURCE_LIST_CELL_RENDERER_ICON_ICON_SIZE GTK_ICON_SIZE_MENU
static GraniteWidgetsSourceListCellRendererIcon* granite_widgets_source_list_cell_renderer_icon_new (void);
static GraniteWidgetsSourceListCellRendererIcon* granite_widgets_source_list_cell_renderer_icon_construct (GType object_type);
static gboolean granite_widgets_source_list_cell_renderer_icon_real_activate (GtkCellRenderer* base,
                                                                       GdkEvent* event,
                                                                       GtkWidget* widget,
                                                                       const gchar* path,
                                                                       GdkRectangle* background_area,
                                                                       GdkRectangle* cell_area,
                                                                       GtkCellRendererState flags);
static GObject * granite_widgets_source_list_cell_renderer_icon_constructor (GType type,
                                                                      guint n_construct_properties,
                                                                      GObjectConstructParam * construct_properties);
static GType granite_widgets_source_list_cell_renderer_spacer_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static GtkSizeRequestMode granite_widgets_source_list_cell_renderer_spacer_real_get_request_mode (GtkCellRenderer* base);
static void granite_widgets_source_list_cell_renderer_spacer_real_get_preferred_width (GtkCellRenderer* base,
                                                                                GtkWidget* widget,
                                                                                gint* min_size,
                                                                                gint* natural_size);
static void granite_widgets_source_list_cell_renderer_spacer_real_get_preferred_height_for_width (GtkCellRenderer* base,
                                                                                           GtkWidget* widget,
                                                                                           gint width,
                                                                                           gint* min_height,
                                                                                           gint* natural_height);
static void granite_widgets_source_list_cell_renderer_spacer_real_render (GtkCellRenderer* base,
                                                                   cairo_t* context,
                                                                   GtkWidget* widget,
                                                                   GdkRectangle* bg_area,
                                                                   GdkRectangle* cell_area,
                                                                   GtkCellRendererState flags);
static void granite_widgets_source_list_cell_renderer_spacer_real_get_size (GtkCellRenderer* base,
                                                                     GtkWidget* widget,
                                                                     GdkRectangle* cell_area,
                                                                     gint* x_offset,
                                                                     gint* y_offset,
                                                                     gint* width,
                                                                     gint* height) G_GNUC_DEPRECATED;
static GraniteWidgetsSourceListCellRendererSpacer* granite_widgets_source_list_cell_renderer_spacer_new (void);
static GraniteWidgetsSourceListCellRendererSpacer* granite_widgets_source_list_cell_renderer_spacer_construct (GType object_type);
static gint granite_widgets_source_list_cell_renderer_spacer_get_level (GraniteWidgetsSourceListCellRendererSpacer* self);
static void granite_widgets_source_list_cell_renderer_spacer_set_level (GraniteWidgetsSourceListCellRendererSpacer* self,
                                                                 gint value);
static void granite_widgets_source_list_cell_renderer_spacer_finalize (GObject * obj);
static void _vala_granite_widgets_source_list_cell_renderer_spacer_get_property (GObject * object,
                                                                          guint property_id,
                                                                          GValue * value,
                                                                          GParamSpec * pspec);
static void _vala_granite_widgets_source_list_cell_renderer_spacer_set_property (GObject * object,
                                                                          guint property_id,
                                                                          const GValue * value,
                                                                          GParamSpec * pspec);
GType granite_widgets_cell_renderer_badge_get_type (void) G_GNUC_CONST;
GType granite_widgets_cell_renderer_expander_get_type (void) G_GNUC_CONST;
static void granite_widgets_source_list_tree_disable_item_property_monitor (GraniteWidgetsSourceListTree* self);
static GType granite_widgets_source_list_tree_column_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
#define GRANITE_WIDGETS_SOURCE_LIST_TREE_DEFAULT_STYLESHEET "\n" \
"            .source-list.badge {\n" \
"                border-radius: 10px;\n" \
"                border-width: 0;\n" \
"                padding: 1px 2px 1px 2px;\n" \
"                font-weight: bold;\n" \
"            }\n" \
"        "
#define GRANITE_WIDGETS_SOURCE_LIST_TREE_STYLE_PROP_LEVEL_INDENTATION "level-indentation"
#define GRANITE_WIDGETS_SOURCE_LIST_TREE_STYLE_PROP_LEFT_PADDING "left-padding"
#define GRANITE_WIDGETS_SOURCE_LIST_TREE_STYLE_PROP_EXPANDER_SPACING "expander-spacing"
static gboolean granite_widgets_source_list_tree_real_drag_motion (GtkWidget* base,
                                                            GdkDragContext* context,
                                                            gint x,
                                                            gint y,
                                                            guint time);
static GraniteWidgetsSourceListDataModel* granite_widgets_source_list_tree_get_data_model (GraniteWidgetsSourceListTree* self);
static void granite_widgets_source_list_tree_real_drag_data_received (GtkWidget* base,
                                                               GdkDragContext* context,
                                                               gint x,
                                                               gint y,
                                                               GtkSelectionData* selection_data,
                                                               guint info,
                                                               guint time);
static GtkTargetEntry* granite_widgets_source_list_tree_append_row_target_entry (GtkTargetEntry* orig,
                                                                          int orig_length1,
                                                                          int* result_length1);
static void _vala_array_add2 (GtkTargetEntry* * array,
                       int* length,
                       int* size,
                       const GtkTargetEntry* value);
static void _vala_array_add3 (GtkTargetEntry* * array,
                       int* length,
                       int* size,
                       const GtkTargetEntry* value);
static void granite_widgets_source_list_tree_enable_item_property_monitor (GraniteWidgetsSourceListTree* self);
static void granite_widgets_source_list_tree_on_model_item_updated (GraniteWidgetsSourceListTree* self,
                                                             GraniteWidgetsSourceListItem* item);
static void _granite_widgets_source_list_tree_on_model_item_updated_granite_widgets_source_list_data_model_item_updated (GraniteWidgetsSourceListDataModel* _sender,
                                                                                                                  GraniteWidgetsSourceListItem* item,
                                                                                                                  gpointer self);
static void granite_widgets_source_list_tree_update_expansion (GraniteWidgetsSourceListTree* self,
                                                        GraniteWidgetsSourceListExpandableItem* expandable_item);
static void granite_widgets_source_list_tree_add_spacer_cell_for_level (GraniteWidgetsSourceListTree* self,
                                                                 gint level,
                                                                 gboolean check_previous);
static void granite_widgets_source_list_tree_spacer_cell_data_func (GtkCellLayout* layout,
                                                             GtkCellRenderer* renderer,
                                                             GtkTreeModel* model,
                                                             GtkTreeIter* iter);
static void _granite_widgets_source_list_tree_spacer_cell_data_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout,
                                                                                        GtkCellRenderer* cell,
                                                                                        GtkTreeModel* tree_model,
                                                                                        GtkTreeIter* iter,
                                                                                        gpointer self);
static gboolean granite_widgets_source_list_tree_select_func (GraniteWidgetsSourceListTree* self,
                                                       GtkTreeSelection* selection,
                                                       GtkTreeModel* model,
                                                       GtkTreePath* path,
                                                       gboolean path_currently_selected);
static GtkTreePath* granite_widgets_source_list_tree_get_selected_path (GraniteWidgetsSourceListTree* self);
static void __vala_GtkTreePath_free0_ (gpointer var);
static inline void _g_list_free___vala_GtkTreePath_free0_ (GList* self);
static void granite_widgets_source_list_tree_set_selected (GraniteWidgetsSourceListTree* self,
                                                    GraniteWidgetsSourceListItem* item,
                                                    gboolean scroll_to_item);
static void granite_widgets_source_list_tree_real_cursor_changed (GtkTreeView* base);
static void granite_widgets_source_list_tree_on_editing_started (GraniteWidgetsSourceListTree* self,
                                                          GtkCellEditable* editable,
                                                          const gchar* path);
static void granite_widgets_source_list_tree_on_editing_done (GraniteWidgetsSourceListTree* self);
static void _granite_widgets_source_list_tree_on_editing_done_gtk_cell_editable_editing_done (GtkCellEditable* _sender,
                                                                                       gpointer self);
static void granite_widgets_source_list_tree_on_editing_canceled (GraniteWidgetsSourceListTree* self);
static void granite_widgets_source_list_tree_on_activatable_activated (GraniteWidgetsSourceListTree* self,
                                                                const gchar* item_path_str);
static GraniteWidgetsSourceListItem* granite_widgets_source_list_tree_get_item_from_path_string (GraniteWidgetsSourceListTree* self,
                                                                                          const gchar* item_path_str);
static gboolean granite_widgets_source_list_tree_toggle_expansion (GraniteWidgetsSourceListTree* self,
                                                            GraniteWidgetsSourceListExpandableItem* item);
static void granite_widgets_source_list_tree_real_row_expanded (GtkTreeView* base,
                                                         GtkTreeIter* iter,
                                                         GtkTreePath* path);
static void granite_widgets_source_list_tree_real_row_collapsed (GtkTreeView* base,
                                                          GtkTreeIter* iter,
                                                          GtkTreePath* path);
static void granite_widgets_source_list_tree_real_row_activated (GtkTreeView* base,
                                                          GtkTreePath* path,
                                                          GtkTreeViewColumn* column);
static gboolean granite_widgets_source_list_tree_real_key_release_event (GtkWidget* base,
                                                                  GdkEventKey* event);
static gboolean granite_widgets_source_list_tree_real_button_release_event (GtkWidget* base,
                                                                     GdkEventButton* event);
static gboolean granite_widgets_source_list_tree_real_button_press_event (GtkWidget* base,
                                                                   GdkEventButton* event);
static gboolean granite_widgets_source_list_tree_popup_context_menu (GraniteWidgetsSourceListTree* self,
                                                              GraniteWidgetsSourceListItem* item,
                                                              GdkEventButton* event);
static gboolean granite_widgets_source_list_tree_over_cell (GraniteWidgetsSourceListTree* self,
                                                     GtkTreeViewColumn* col,
                                                     GtkTreePath* path,
                                                     GtkCellRenderer* cell,
                                                     gint x);
static gboolean granite_widgets_source_list_tree_over_primary_expander (GraniteWidgetsSourceListTree* self,
                                                                 GtkTreeViewColumn* col,
                                                                 GtkTreePath* path,
                                                                 gint x);
static void granite_widgets_source_list_tree_expander_cell_data_func (GraniteWidgetsSourceListTree* self,
                                                               GtkCellLayout* layout,
                                                               GtkCellRenderer* renderer,
                                                               GtkTreeModel* model,
                                                               GtkTreeIter* iter);
static gint granite_widgets_source_list_tree_get_cell_width (GraniteWidgetsSourceListTree* self,
                                                      GtkCellRenderer* cell_renderer);
G_GNUC_INTERNAL gboolean granite_widgets_utils_is_left_to_right (GtkWidget* widget);
static gboolean granite_widgets_source_list_tree_real_popup_menu (GtkWidget* base);
static GraniteWidgetsSourceListItem* granite_widgets_source_list_tree_get_item_from_model (GtkTreeModel* model,
                                                                                    GtkTreeIter* iter);
static void granite_widgets_source_list_tree_name_cell_data_func (GraniteWidgetsSourceListTree* self,
                                                           GtkCellLayout* layout,
                                                           GtkCellRenderer* renderer,
                                                           GtkTreeModel* model,
                                                           GtkTreeIter* iter);
static void granite_widgets_source_list_tree_badge_cell_data_func (GraniteWidgetsSourceListTree* self,
                                                            GtkCellLayout* layout,
                                                            GtkCellRenderer* renderer,
                                                            GtkTreeModel* model,
                                                            GtkTreeIter* iter);
void granite_widgets_cell_renderer_badge_set_text (GraniteWidgetsCellRendererBadge* self,
                                                   const gchar* value);
static void granite_widgets_source_list_tree_icon_cell_data_func (GraniteWidgetsSourceListTree* self,
                                                           GtkCellLayout* layout,
                                                           GtkCellRenderer* renderer,
                                                           GtkTreeModel* model,
                                                           GtkTreeIter* iter);
static void granite_widgets_source_list_tree_set_data_model (GraniteWidgetsSourceListTree* self,
                                                      GraniteWidgetsSourceListDataModel* value);
static GObject * granite_widgets_source_list_tree_constructor (GType type,
                                                        guint n_construct_properties,
                                                        GObjectConstructParam * construct_properties);
GtkCssProvider* granite_widgets_utils_set_theming (GtkWidget* widget,
                                                   const gchar* stylesheet,
                                                   const gchar* class_name,
                                                   gint priority);
#define GRANITE_STYLE_CLASS_SOURCE_LIST "source-list"
GraniteWidgetsCellRendererExpander* granite_widgets_cell_renderer_expander_new (void);
GraniteWidgetsCellRendererExpander* granite_widgets_cell_renderer_expander_construct (GType object_type);
void granite_widgets_cell_renderer_expander_set_is_category_expander (GraniteWidgetsCellRendererExpander* self,
                                                                      gboolean value);
static void _granite_widgets_source_list_tree_expander_cell_data_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout,
                                                                                          GtkCellRenderer* cell,
                                                                                          GtkTreeModel* tree_model,
                                                                                          GtkTreeIter* iter,
                                                                                          gpointer self);
static void _granite_widgets_source_list_tree_on_activatable_activated_granite_widgets_source_list_cell_renderer_icon_activated (GraniteWidgetsSourceListCellRendererIcon* _sender,
                                                                                                                          const gchar* path,
                                                                                                                          gpointer self);
static void _granite_widgets_source_list_tree_icon_cell_data_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout,
                                                                                      GtkCellRenderer* cell,
                                                                                      GtkTreeModel* tree_model,
                                                                                      GtkTreeIter* iter,
                                                                                      gpointer self);
GraniteWidgetsCellRendererBadge* granite_widgets_cell_renderer_badge_new (void);
GraniteWidgetsCellRendererBadge* granite_widgets_cell_renderer_badge_construct (GType object_type);
static void _granite_widgets_source_list_tree_badge_cell_data_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout,
                                                                                       GtkCellRenderer* cell,
                                                                                       GtkTreeModel* tree_model,
                                                                                       GtkTreeIter* iter,
                                                                                       gpointer self);
static void _granite_widgets_source_list_tree_on_editing_started_gtk_cell_renderer_editing_started (GtkCellRenderer* _sender,
                                                                                             GtkCellEditable* editable,
                                                                                             const gchar* path,
                                                                                             gpointer self);
static void _granite_widgets_source_list_tree_on_editing_canceled_gtk_cell_renderer_editing_canceled (GtkCellRenderer* _sender,
                                                                                               gpointer self);
static void _granite_widgets_source_list_tree_name_cell_data_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout,
                                                                                      GtkCellRenderer* cell,
                                                                                      GtkTreeModel* tree_model,
                                                                                      GtkTreeIter* iter,
                                                                                      gpointer self);
static gboolean _granite_widgets_source_list_tree_select_func_gtk_tree_selection_func (GtkTreeSelection* selection,
                                                                                GtkTreeModel* model,
                                                                                GtkTreePath* path,
                                                                                gboolean path_currently_selected,
                                                                                gpointer self);
static void granite_widgets_source_list_tree_finalize (GObject * obj);
static void _vala_granite_widgets_source_list_tree_get_property (GObject * object,
                                                          guint property_id,
                                                          GValue * value,
                                                          GParamSpec * pspec);
static void _vala_granite_widgets_source_list_tree_set_property (GObject * object,
                                                          guint property_id,
                                                          const GValue * value,
                                                          GParamSpec * pspec);
static void granite_widgets_source_list_finalize (GObject * obj);
static void _vala_granite_widgets_source_list_get_property (GObject * object,
                                                     guint property_id,
                                                     GValue * value,
                                                     GParamSpec * pspec);
static void _vala_granite_widgets_source_list_set_property (GObject * object,
                                                     guint property_id,
                                                     const GValue * value,
                                                     GParamSpec * pspec);


/**
     * Whether this item will allow users to re-arrange its children via DnD.
     *
     * This feature can co-exist with a sort algorithm (implemented
     * by {@link Granite.Widgets.SourceListSortable.compare}), but
     * the actual order of the items in the list will always
     * honor that method. The sort function has to be compatible with
     * the kind of DnD reordering the item wants to allow, since the user can
     * only reorder those items for which //compare// returns 0.
     *
     * @return Whether the item's children can be re-arranged by users.
     * @since 0.3
     */
gboolean
granite_widgets_source_list_sortable_allow_dnd_sorting (GraniteWidgetsSourceListSortable* self)
{
#line 49 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 49 "../lib/Widgets/SourceList.vala"
	return GRANITE_WIDGETS_SOURCE_LIST_SORTABLE_GET_INTERFACE (self)->allow_dnd_sorting (self);
#line 1197 "SourceList.c"
}


/**
     * Should return a negative integer, zero, or a positive integer if ''a''
     * sorts //before// ''b'', ''a'' sorts //with// ''b'', or ''a'' sorts
     * //after// ''b'' respectively. If two items compare as equal, their
     * order in the sorted source list is undefined.
     *
     * In order to ensure that the source list behaves as expected, this
     * method must define a partial order on the source list tree; i.e. it
     * must be reflexive, antisymmetric and transitive. Not complying with
     * those requirements could make the program fall into an infinite loop
     * and freeze the user interface.
     *
     * Should return //0// to allow any pair of items to be sortable via DnD.
     *
     * @param a First item.
     * @param b Second item.
     * @return A //negative// integer if //a// sorts before //b//,
     *         //zero// if //a// equals //b//, or a //positive//
     *         integer if //a// sorts after //b//.
     * @since 0.3
     */
gint
granite_widgets_source_list_sortable_compare (GraniteWidgetsSourceListSortable* self,
                                              GraniteWidgetsSourceListItem* a,
                                              GraniteWidgetsSourceListItem* b)
{
#line 72 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 72 "../lib/Widgets/SourceList.vala"
	return GRANITE_WIDGETS_SOURCE_LIST_SORTABLE_GET_INTERFACE (self)->compare (self, a, b);
#line 1231 "SourceList.c"
}


static void
granite_widgets_source_list_sortable_default_init (GraniteWidgetsSourceListSortableIface * iface)
{
	/**
	     * Emitted after a user has re-ordered an item via DnD.
	     *
	     * @param moved The item that was moved to a different position by the user.
	     * @since 0.3
	     */
#line 27 "../lib/Widgets/SourceList.vala"
	granite_widgets_source_list_sortable_signals[GRANITE_WIDGETS_SOURCE_LIST_SORTABLE_USER_MOVED_ITEM_SIGNAL] = g_signal_new ("user-moved-item", GRANITE_WIDGETS_TYPE_SOURCE_LIST_SORTABLE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM);
#line 1246 "SourceList.c"
}


/**
 * An interface for sorting items.
 *
 * @since 0.3
 */
GType
granite_widgets_source_list_sortable_get_type (void)
{
	static volatile gsize granite_widgets_source_list_sortable_type_id__volatile = 0;
	if (g_once_init_enter (&granite_widgets_source_list_sortable_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GraniteWidgetsSourceListSortableIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) granite_widgets_source_list_sortable_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType granite_widgets_source_list_sortable_type_id;
		granite_widgets_source_list_sortable_type_id = g_type_register_static (G_TYPE_INTERFACE, "GraniteWidgetsSourceListSortable", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (granite_widgets_source_list_sortable_type_id, GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM);
		g_once_init_leave (&granite_widgets_source_list_sortable_type_id__volatile, granite_widgets_source_list_sortable_type_id);
	}
	return granite_widgets_source_list_sortable_type_id__volatile;
}


/**
     * Determines whether this item can be dragged outside the source list widget.
     *
     * Even if this method returns //false//, the item could still be dragged around
     * within the source list if its parent allows DnD reordering. This only happens
     * when the parent implements {@link Granite.Widgets.SourceListSortable}.
     *
     * @return //true// if the item can be dragged; //false// otherwise.
     * @since 0.3
     * @see Granite.Widgets.SourceListSortable
     */
gboolean
granite_widgets_source_list_drag_source_draggable (GraniteWidgetsSourceListDragSource* self)
{
#line 92 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 92 "../lib/Widgets/SourceList.vala"
	return GRANITE_WIDGETS_SOURCE_LIST_DRAG_SOURCE_GET_INTERFACE (self)->draggable (self);
#line 1288 "SourceList.c"
}


/**
     * This method is called when the drop site requests the data which is dragged.
     *
     * It is the responsibility of this method to fill //selection_data// with the
     * data in the format which is indicated by {@link Gtk.SelectionData.get_target}.
     *
     * @param selection_data {@link Gtk.SelectionData} containing source data.
     * @since 0.3
     * @see Gtk.SelectionData.set
     * @see Gtk.SelectionData.set_uris
     * @see Gtk.SelectionData.set_text
     */
void
granite_widgets_source_list_drag_source_prepare_selection_data (GraniteWidgetsSourceListDragSource* self,
                                                                GtkSelectionData* selection_data)
{
#line 106 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 106 "../lib/Widgets/SourceList.vala"
	GRANITE_WIDGETS_SOURCE_LIST_DRAG_SOURCE_GET_INTERFACE (self)->prepare_selection_data (self, selection_data);
#line 1312 "SourceList.c"
}


static void
granite_widgets_source_list_drag_source_default_init (GraniteWidgetsSourceListDragSourceIface * iface)
{
}


/**
 * An interface for dragging items out of the source list widget.
 *
 * @since 0.3
 */
GType
granite_widgets_source_list_drag_source_get_type (void)
{
	static volatile gsize granite_widgets_source_list_drag_source_type_id__volatile = 0;
	if (g_once_init_enter (&granite_widgets_source_list_drag_source_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GraniteWidgetsSourceListDragSourceIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) granite_widgets_source_list_drag_source_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType granite_widgets_source_list_drag_source_type_id;
		granite_widgets_source_list_drag_source_type_id = g_type_register_static (G_TYPE_INTERFACE, "GraniteWidgetsSourceListDragSource", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (granite_widgets_source_list_drag_source_type_id, GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM);
		g_once_init_leave (&granite_widgets_source_list_drag_source_type_id__volatile, granite_widgets_source_list_drag_source_type_id);
	}
	return granite_widgets_source_list_drag_source_type_id__volatile;
}


/**
     * Determines whether //data// can be dropped into this item.
     *
     * @param context The drag context.
     * @param data {@link Gtk.SelectionData} containing source data.
     * @return //true// if the drop is possible; //false// otherwise.
     * @since 0.3
     */
gboolean
granite_widgets_source_list_drag_dest_data_drop_possible (GraniteWidgetsSourceListDragDest* self,
                                                          GdkDragContext* context,
                                                          GtkSelectionData* data)
{
#line 123 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 123 "../lib/Widgets/SourceList.vala"
	return GRANITE_WIDGETS_SOURCE_LIST_DRAG_DEST_GET_INTERFACE (self)->data_drop_possible (self, context, data);
#line 1359 "SourceList.c"
}


/**
     * If a data drop is deemed possible, then this method is called
     * when the data is actually dropped into this item. Any actions
     * consequence of the data received should be handled here.
     *
     * @param context The drag context.
     * @param data {@link Gtk.SelectionData} containing source data.
     * @return The action taken, or //0// to indicate that the dropped data was not accepted.
     * @since 0.3
     */
GdkDragAction
granite_widgets_source_list_drag_dest_data_received (GraniteWidgetsSourceListDragDest* self,
                                                     GdkDragContext* context,
                                                     GtkSelectionData* data)
{
#line 135 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 135 "../lib/Widgets/SourceList.vala"
	return GRANITE_WIDGETS_SOURCE_LIST_DRAG_DEST_GET_INTERFACE (self)->data_received (self, context, data);
#line 1382 "SourceList.c"
}


static void
granite_widgets_source_list_drag_dest_default_init (GraniteWidgetsSourceListDragDestIface * iface)
{
}


/**
 * An interface for receiving data from other widgets via drag-and-drop.
 *
 * @since 0.3
 */
GType
granite_widgets_source_list_drag_dest_get_type (void)
{
	static volatile gsize granite_widgets_source_list_drag_dest_type_id__volatile = 0;
	if (g_once_init_enter (&granite_widgets_source_list_drag_dest_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GraniteWidgetsSourceListDragDestIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) granite_widgets_source_list_drag_dest_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType granite_widgets_source_list_drag_dest_type_id;
		granite_widgets_source_list_drag_dest_type_id = g_type_register_static (G_TYPE_INTERFACE, "GraniteWidgetsSourceListDragDest", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (granite_widgets_source_list_drag_dest_type_id, GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM);
		g_once_init_leave (&granite_widgets_source_list_drag_dest_type_id__volatile, granite_widgets_source_list_drag_dest_type_id);
	}
	return granite_widgets_source_list_drag_dest_type_id__volatile;
}


static inline gpointer
granite_widgets_source_list_get_instance_private (GraniteWidgetsSourceList* self)
{
	return G_STRUCT_MEMBER_P (self, GraniteWidgetsSourceList_private_offset);
}


/**
     * Creates a new {@link Granite.Widgets.SourceList}.
     *
     * @return A new {@link Granite.Widgets.SourceList}.
     * @since 0.2
     */
GraniteWidgetsSourceList*
granite_widgets_source_list_construct (GType object_type,
                                       GraniteWidgetsSourceListExpandableItem* root)
{
	GraniteWidgetsSourceList * self = NULL;
#line 2551 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (root != NULL, NULL);
#line 2551 "../lib/Widgets/SourceList.vala"
	self = (GraniteWidgetsSourceList*) g_object_new (object_type, NULL);
#line 2552 "../lib/Widgets/SourceList.vala"
	granite_widgets_source_list_set_root (self, root);
#line 2551 "../lib/Widgets/SourceList.vala"
	return self;
#line 1438 "SourceList.c"
}


GraniteWidgetsSourceList*
granite_widgets_source_list_new (GraniteWidgetsSourceListExpandableItem* root)
{
#line 2551 "../lib/Widgets/SourceList.vala"
	return granite_widgets_source_list_construct (GRANITE_WIDGETS_TYPE_SOURCE_LIST, root);
#line 1447 "SourceList.c"
}


/**
     * Checks whether //item// is part of the source list.
     *
     * @param item The item to query.
     * @return //true// if the item belongs to the source list; //false// otherwise.
     * @since 0.2
     */
gboolean
granite_widgets_source_list_has_item (GraniteWidgetsSourceList* self,
                                      GraniteWidgetsSourceListItem* item)
{
	gboolean result = FALSE;
	GraniteWidgetsSourceListDataModel* _tmp0_;
#line 2572 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2572 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (item != NULL, FALSE);
#line 2573 "../lib/Widgets/SourceList.vala"
	_tmp0_ = self->priv->data_model;
#line 2573 "../lib/Widgets/SourceList.vala"
	result = granite_widgets_source_list_data_model_has_item (_tmp0_, item);
#line 2573 "../lib/Widgets/SourceList.vala"
	return result;
#line 1474 "SourceList.c"
}


/**
     * Sets the method used for filtering out items.
     *
     * @param visible_func The method to use for filtering items.
     * @param refilter Whether to call {@link Granite.Widgets.SourceList.refilter} using the new function.
     * @see Granite.Widgets.SourceList.VisibleFunc
     * @see Granite.Widgets.SourceList.refilter
     * @since 0.2
     */
void
granite_widgets_source_list_set_filter_func (GraniteWidgetsSourceList* self,
                                             GraniteWidgetsSourceListVisibleFunc visible_func,
                                             gpointer visible_func_target,
                                             gboolean refilter)
{
	GraniteWidgetsSourceListDataModel* _tmp0_;
#line 2585 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 2586 "../lib/Widgets/SourceList.vala"
	_tmp0_ = self->priv->data_model;
#line 2586 "../lib/Widgets/SourceList.vala"
	granite_widgets_source_list_data_model_set_filter_func (_tmp0_, visible_func, visible_func_target);
#line 2587 "../lib/Widgets/SourceList.vala"
	if (refilter) {
#line 2588 "../lib/Widgets/SourceList.vala"
		granite_widgets_source_list_refilter (self);
#line 1504 "SourceList.c"
	}
}


/**
     * Applies the filter method set by {@link Granite.Widgets.SourceList.set_filter_func}
     * to all the items that are part of the current tree.
     *
     * @see Granite.Widgets.SourceList.VisibleFunc
     * @see Granite.Widgets.SourceList.set_filter_func
     * @since 0.2
     */
void
granite_widgets_source_list_refilter (GraniteWidgetsSourceList* self)
{
	GraniteWidgetsSourceListDataModel* _tmp0_;
#line 2599 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 2600 "../lib/Widgets/SourceList.vala"
	_tmp0_ = self->priv->data_model;
#line 2600 "../lib/Widgets/SourceList.vala"
	gtk_tree_model_filter_refilter ((GtkTreeModelFilter*) _tmp0_);
#line 1527 "SourceList.c"
}


/**
     * Queries the actual expansion state of //item//.
     *
     * @see Granite.Widgets.SourceList.ExpandableItem.expanded
     * @return Whether //item// is expanded or not.
     * @since 0.2
     */
static void
_vala_GtkTreePath_free (GtkTreePath* self)
{
#line 2612 "../lib/Widgets/SourceList.vala"
	g_boxed_free (gtk_tree_path_get_type (), self);
#line 1543 "SourceList.c"
}


gboolean
granite_widgets_source_list_is_item_expanded (GraniteWidgetsSourceList* self,
                                              GraniteWidgetsSourceListItem* item)
{
	gboolean result = FALSE;
	GtkTreePath* path = NULL;
	GraniteWidgetsSourceListDataModel* _tmp0_;
	GtkTreePath* _tmp1_;
	gboolean _tmp2_ = FALSE;
	GtkTreePath* _tmp3_;
#line 2610 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2610 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (item != NULL, FALSE);
#line 2610 "../lib/Widgets/SourceList.vala"
	_vala_return_val_if_fail (granite_widgets_source_list_has_item (self, item), "has_item (item)", FALSE);
#line 2611 "../lib/Widgets/SourceList.vala"
	_tmp0_ = self->priv->data_model;
#line 2611 "../lib/Widgets/SourceList.vala"
	_tmp1_ = granite_widgets_source_list_data_model_get_item_path (_tmp0_, item);
#line 2611 "../lib/Widgets/SourceList.vala"
	path = _tmp1_;
#line 2612 "../lib/Widgets/SourceList.vala"
	_tmp3_ = path;
#line 2612 "../lib/Widgets/SourceList.vala"
	if (_tmp3_ != NULL) {
#line 1573 "SourceList.c"
		GraniteWidgetsSourceListTree* _tmp4_;
		GtkTreePath* _tmp5_;
#line 2612 "../lib/Widgets/SourceList.vala"
		_tmp4_ = self->priv->tree;
#line 2612 "../lib/Widgets/SourceList.vala"
		_tmp5_ = path;
#line 2612 "../lib/Widgets/SourceList.vala"
		_tmp2_ = gtk_tree_view_row_expanded ((GtkTreeView*) _tmp4_, _tmp5_);
#line 1582 "SourceList.c"
	} else {
#line 2612 "../lib/Widgets/SourceList.vala"
		_tmp2_ = FALSE;
#line 1586 "SourceList.c"
	}
#line 2612 "../lib/Widgets/SourceList.vala"
	result = _tmp2_;
#line 2612 "../lib/Widgets/SourceList.vala"
	__vala_GtkTreePath_free0 (path);
#line 2612 "../lib/Widgets/SourceList.vala"
	return result;
#line 1594 "SourceList.c"
}


/**
     * If //item// is editable, this activates the editor; otherwise, it does nothing.
     * If an item was already being edited, this will fail.
     *
     * @param item Item to edit.
     * @see Granite.Widgets.SourceList.Item.editable
     * @see Granite.Widgets.SourceList.editing
     * @see Granite.Widgets.SourceList.stop_editing
     * @return true if the editing started successfully; false otherwise.
     * @since 0.2
     */
gboolean
granite_widgets_source_list_start_editing_item (GraniteWidgetsSourceList* self,
                                                GraniteWidgetsSourceListItem* item)
{
	gboolean result = FALSE;
	GraniteWidgetsSourceListTree* _tmp0_;
#line 2626 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2626 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (item != NULL, FALSE);
#line 2626 "../lib/Widgets/SourceList.vala"
	_vala_return_val_if_fail (granite_widgets_source_list_has_item (self, item), "has_item (item)", FALSE);
#line 2627 "../lib/Widgets/SourceList.vala"
	_tmp0_ = self->priv->tree;
#line 2627 "../lib/Widgets/SourceList.vala"
	result = granite_widgets_source_list_tree_start_editing_item (_tmp0_, item);
#line 2627 "../lib/Widgets/SourceList.vala"
	return result;
#line 1627 "SourceList.c"
}


/**
     * Cancels any editing operation going on.
     *
     * @see Granite.Widgets.SourceList.editing
     * @see Granite.Widgets.SourceList.start_editing_item
     * @since 0.2
     */
void
granite_widgets_source_list_stop_editing (GraniteWidgetsSourceList* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 2637 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 2638 "../lib/Widgets/SourceList.vala"
	_tmp0_ = granite_widgets_source_list_get_editing (self);
#line 2638 "../lib/Widgets/SourceList.vala"
	_tmp1_ = _tmp0_;
#line 2638 "../lib/Widgets/SourceList.vala"
	if (_tmp1_) {
#line 1651 "SourceList.c"
		GraniteWidgetsSourceListTree* _tmp2_;
#line 2639 "../lib/Widgets/SourceList.vala"
		_tmp2_ = self->priv->tree;
#line 2639 "../lib/Widgets/SourceList.vala"
		granite_widgets_source_list_tree_stop_editing (_tmp2_);
#line 1657 "SourceList.c"
	}
}


/**
     * Turns Source List into a //drag source//.
     *
     * This enables items that implement {@link Granite.Widgets.SourceListDragSource}
     * to be dragged outside the Source List and drop data into external widgets.
     *
     * @param src_entries an array of {@link Gtk.TargetEntry}s indicating the targets
     * that the drag will support.
     * @see Granite.Widgets.SourceListDragSource
     * @see Granite.Widgets.SourceList.disable_drag_source
     * @since 0.3
     */
void
granite_widgets_source_list_enable_drag_source (GraniteWidgetsSourceList* self,
                                                GtkTargetEntry* src_entries,
                                                int src_entries_length1)
{
	GraniteWidgetsSourceListTree* _tmp0_;
#line 2654 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 2655 "../lib/Widgets/SourceList.vala"
	_tmp0_ = self->priv->tree;
#line 2655 "../lib/Widgets/SourceList.vala"
	granite_widgets_source_list_tree_configure_drag_source (_tmp0_, src_entries, src_entries_length1);
#line 1686 "SourceList.c"
}


/**
     * Undoes the effect of {@link Granite.Widgets.SourceList.enable_drag_source}
     *
     * @see Granite.Widgets.SourceList.enable_drag_source
     * @since 0.3
     */
void
granite_widgets_source_list_disable_drag_source (GraniteWidgetsSourceList* self)
{
	GraniteWidgetsSourceListTree* _tmp0_;
#line 2664 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 2665 "../lib/Widgets/SourceList.vala"
	_tmp0_ = self->priv->tree;
#line 2665 "../lib/Widgets/SourceList.vala"
	granite_widgets_source_list_tree_configure_drag_source (_tmp0_, NULL, 0);
#line 1706 "SourceList.c"
}


/**
     * Turns Source List into a //drop destination//.
     *
     * This enables items that implement {@link Granite.Widgets.SourceListDragDest}
     * to receive data from external widgets via drag-and-drop.
     *
     * @param dest_entries an array of {@link Gtk.TargetEntry}s indicating the drop
     * types that Source List items will accept.
     * @param actions a bitmask of possible actions for a drop onto Source List items.
     * @see Granite.Widgets.SourceListDragDest
     * @see Granite.Widgets.SourceList.disable_drag_dest
     * @since 0.3
     */
void
granite_widgets_source_list_enable_drag_dest (GraniteWidgetsSourceList* self,
                                              GtkTargetEntry* dest_entries,
                                              int dest_entries_length1,
                                              GdkDragAction actions)
{
	GraniteWidgetsSourceListTree* _tmp0_;
#line 2681 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 2682 "../lib/Widgets/SourceList.vala"
	_tmp0_ = self->priv->tree;
#line 2682 "../lib/Widgets/SourceList.vala"
	granite_widgets_source_list_tree_configure_drag_dest (_tmp0_, dest_entries, dest_entries_length1, actions);
#line 1736 "SourceList.c"
}


/**
     * Undoes the effect of {@link Granite.Widgets.SourceList.enable_drag_dest}
     *
     * @see Granite.Widgets.SourceList.enable_drag_dest
     * @since 0.3
     */
void
granite_widgets_source_list_disable_drag_dest (GraniteWidgetsSourceList* self)
{
	GraniteWidgetsSourceListTree* _tmp0_;
#line 2691 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 2692 "../lib/Widgets/SourceList.vala"
	_tmp0_ = self->priv->tree;
#line 2692 "../lib/Widgets/SourceList.vala"
	granite_widgets_source_list_tree_configure_drag_dest (_tmp0_, NULL, 0, 0);
#line 1756 "SourceList.c"
}


/**
     * Scrolls the source list tree to make //item// visible.
     *
     * {@link Granite.Widgets.SourceList.ExpandableItem.expand_with_parents} is called
     * for the item's parent if //expand_parents// is //true//, to make sure it's not
     * hidden behind a collapsed row.
     *
     * If use_align is //false//, then the row_align argument is ignored, and the tree
     * does the minimum amount of work to scroll the item onto the screen. This means that
     * the item will be scrolled to the edge closest to its current position. If the item
     * is currently visible on the screen, nothing is done.
     *
     * @param item Item to scroll to.
     * @param expand_parents Whether to recursively expand item's parent in case they are collapsed.
     * @param use_align Whether to use the //row_align// argument.
     * @param row_align The vertical alignment of //item//. 0.0 means top, 0.5 center, and 1.0 bottom.
     * @return //true// if successful; //false// otherwise.
     * @since 0.2
     */
gboolean
granite_widgets_source_list_scroll_to_item (GraniteWidgetsSourceList* self,
                                            GraniteWidgetsSourceListItem* item,
                                            gboolean expand_parents,
                                            gboolean use_align,
                                            gfloat row_align)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	GraniteWidgetsSourceListTree* _tmp5_;
#line 2714 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2714 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (item != NULL, FALSE);
#line 2714 "../lib/Widgets/SourceList.vala"
	_vala_return_val_if_fail (granite_widgets_source_list_has_item (self, item), "has_item (item)", FALSE);
#line 2717 "../lib/Widgets/SourceList.vala"
	if (expand_parents) {
#line 1797 "SourceList.c"
		GraniteWidgetsSourceListExpandableItem* _tmp1_;
		GraniteWidgetsSourceListExpandableItem* _tmp2_;
#line 2717 "../lib/Widgets/SourceList.vala"
		_tmp1_ = granite_widgets_source_list_item_get_parent (item);
#line 2717 "../lib/Widgets/SourceList.vala"
		_tmp2_ = _tmp1_;
#line 2717 "../lib/Widgets/SourceList.vala"
		_tmp0_ = _tmp2_ != NULL;
#line 1806 "SourceList.c"
	} else {
#line 2717 "../lib/Widgets/SourceList.vala"
		_tmp0_ = FALSE;
#line 1810 "SourceList.c"
	}
#line 2717 "../lib/Widgets/SourceList.vala"
	if (_tmp0_) {
#line 1814 "SourceList.c"
		GraniteWidgetsSourceListExpandableItem* _tmp3_;
		GraniteWidgetsSourceListExpandableItem* _tmp4_;
#line 2718 "../lib/Widgets/SourceList.vala"
		_tmp3_ = granite_widgets_source_list_item_get_parent (item);
#line 2718 "../lib/Widgets/SourceList.vala"
		_tmp4_ = _tmp3_;
#line 2718 "../lib/Widgets/SourceList.vala"
		granite_widgets_source_list_expandable_item_expand_with_parents (_tmp4_);
#line 1823 "SourceList.c"
	}
#line 2720 "../lib/Widgets/SourceList.vala"
	_tmp5_ = self->priv->tree;
#line 2720 "../lib/Widgets/SourceList.vala"
	result = granite_widgets_source_list_tree_scroll_to_item (_tmp5_, item, use_align, row_align);
#line 2720 "../lib/Widgets/SourceList.vala"
	return result;
#line 1831 "SourceList.c"
}


/**
     * Gets the previous item with respect to //reference//.
     *
     * @param reference Item to use as reference.
     * @return The item that appears before //reference//, or //null// if there's none.
     * @since 0.2
     */
GraniteWidgetsSourceListItem*
granite_widgets_source_list_get_previous_item (GraniteWidgetsSourceList* self,
                                               GraniteWidgetsSourceListItem* reference)
{
	GraniteWidgetsSourceListItem* result = NULL;
	GtkTreeIter* iter = NULL;
	GraniteWidgetsSourceListDataModel* _tmp0_;
	GtkTreeIter* _tmp1_;
	GtkTreeIter* _tmp2_;
#line 2730 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 2730 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (reference != NULL, NULL);
#line 2730 "../lib/Widgets/SourceList.vala"
	_vala_return_val_if_fail (granite_widgets_source_list_has_item (self, reference), "has_item (reference)", NULL);
#line 2732 "../lib/Widgets/SourceList.vala"
	_tmp0_ = self->priv->data_model;
#line 2732 "../lib/Widgets/SourceList.vala"
	_tmp1_ = granite_widgets_source_list_data_model_get_item_iter (_tmp0_, reference);
#line 2732 "../lib/Widgets/SourceList.vala"
	iter = _tmp1_;
#line 2733 "../lib/Widgets/SourceList.vala"
	_tmp2_ = iter;
#line 2733 "../lib/Widgets/SourceList.vala"
	if (_tmp2_ != NULL) {
#line 1867 "SourceList.c"
		GtkTreeIter new_iter = {0};
		GtkTreeIter* _tmp3_;
		GraniteWidgetsSourceListDataModel* _tmp4_;
		gboolean _tmp5_;
#line 2734 "../lib/Widgets/SourceList.vala"
		_tmp3_ = iter;
#line 2734 "../lib/Widgets/SourceList.vala"
		new_iter = *_tmp3_;
#line 2735 "../lib/Widgets/SourceList.vala"
		_tmp4_ = self->priv->data_model;
#line 2735 "../lib/Widgets/SourceList.vala"
		_tmp5_ = gtk_tree_model_iter_previous ((GtkTreeModel*) _tmp4_, &new_iter);
#line 2735 "../lib/Widgets/SourceList.vala"
		if (_tmp5_) {
#line 1882 "SourceList.c"
			GraniteWidgetsSourceListDataModel* _tmp6_;
			GtkTreeIter _tmp7_;
			GraniteWidgetsSourceListItem* _tmp8_;
#line 2736 "../lib/Widgets/SourceList.vala"
			_tmp6_ = self->priv->data_model;
#line 2736 "../lib/Widgets/SourceList.vala"
			_tmp7_ = new_iter;
#line 2736 "../lib/Widgets/SourceList.vala"
			_tmp8_ = granite_widgets_source_list_data_model_get_item (_tmp6_, &_tmp7_);
#line 2736 "../lib/Widgets/SourceList.vala"
			result = _tmp8_;
#line 2736 "../lib/Widgets/SourceList.vala"
			_g_free0 (iter);
#line 2736 "../lib/Widgets/SourceList.vala"
			return result;
#line 1898 "SourceList.c"
		}
	}
#line 2739 "../lib/Widgets/SourceList.vala"
	result = NULL;
#line 2739 "../lib/Widgets/SourceList.vala"
	_g_free0 (iter);
#line 2739 "../lib/Widgets/SourceList.vala"
	return result;
#line 1907 "SourceList.c"
}


/**
     * Gets the next item with respect to //reference//.
     *
     * @param reference Item to use as reference.
     * @return The item that appears after //reference//, or //null// if there's none.
     * @since 0.2
     */
GraniteWidgetsSourceListItem*
granite_widgets_source_list_get_next_item (GraniteWidgetsSourceList* self,
                                           GraniteWidgetsSourceListItem* reference)
{
	GraniteWidgetsSourceListItem* result = NULL;
	GtkTreeIter* iter = NULL;
	GraniteWidgetsSourceListDataModel* _tmp0_;
	GtkTreeIter* _tmp1_;
	GtkTreeIter* _tmp2_;
#line 2749 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 2749 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (reference != NULL, NULL);
#line 2749 "../lib/Widgets/SourceList.vala"
	_vala_return_val_if_fail (granite_widgets_source_list_has_item (self, reference), "has_item (reference)", NULL);
#line 2751 "../lib/Widgets/SourceList.vala"
	_tmp0_ = self->priv->data_model;
#line 2751 "../lib/Widgets/SourceList.vala"
	_tmp1_ = granite_widgets_source_list_data_model_get_item_iter (_tmp0_, reference);
#line 2751 "../lib/Widgets/SourceList.vala"
	iter = _tmp1_;
#line 2752 "../lib/Widgets/SourceList.vala"
	_tmp2_ = iter;
#line 2752 "../lib/Widgets/SourceList.vala"
	if (_tmp2_ != NULL) {
#line 1943 "SourceList.c"
		GtkTreeIter new_iter = {0};
		GtkTreeIter* _tmp3_;
		GraniteWidgetsSourceListDataModel* _tmp4_;
		gboolean _tmp5_;
#line 2753 "../lib/Widgets/SourceList.vala"
		_tmp3_ = iter;
#line 2753 "../lib/Widgets/SourceList.vala"
		new_iter = *_tmp3_;
#line 2754 "../lib/Widgets/SourceList.vala"
		_tmp4_ = self->priv->data_model;
#line 2754 "../lib/Widgets/SourceList.vala"
		_tmp5_ = gtk_tree_model_iter_next ((GtkTreeModel*) _tmp4_, &new_iter);
#line 2754 "../lib/Widgets/SourceList.vala"
		if (_tmp5_) {
#line 1958 "SourceList.c"
			GraniteWidgetsSourceListDataModel* _tmp6_;
			GtkTreeIter _tmp7_;
			GraniteWidgetsSourceListItem* _tmp8_;
#line 2755 "../lib/Widgets/SourceList.vala"
			_tmp6_ = self->priv->data_model;
#line 2755 "../lib/Widgets/SourceList.vala"
			_tmp7_ = new_iter;
#line 2755 "../lib/Widgets/SourceList.vala"
			_tmp8_ = granite_widgets_source_list_data_model_get_item (_tmp6_, &_tmp7_);
#line 2755 "../lib/Widgets/SourceList.vala"
			result = _tmp8_;
#line 2755 "../lib/Widgets/SourceList.vala"
			_g_free0 (iter);
#line 2755 "../lib/Widgets/SourceList.vala"
			return result;
#line 1974 "SourceList.c"
		}
	}
#line 2758 "../lib/Widgets/SourceList.vala"
	result = NULL;
#line 2758 "../lib/Widgets/SourceList.vala"
	_g_free0 (iter);
#line 2758 "../lib/Widgets/SourceList.vala"
	return result;
#line 1983 "SourceList.c"
}


/**
     * Gets the first visible child of an expandable item.
     *
     * @param parent Parent of the child to look up.
     * @return The first visible child of //parent//, or null if it was not found.
     * @since 0.2
     */
GraniteWidgetsSourceListItem*
granite_widgets_source_list_get_first_child (GraniteWidgetsSourceList* self,
                                             GraniteWidgetsSourceListExpandableItem* parent)
{
	GraniteWidgetsSourceListItem* result = NULL;
	GraniteWidgetsSourceListItem* _tmp0_;
#line 2768 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 2768 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (parent != NULL, NULL);
#line 2769 "../lib/Widgets/SourceList.vala"
	_tmp0_ = granite_widgets_source_list_get_nth_child (self, parent, 0);
#line 2769 "../lib/Widgets/SourceList.vala"
	result = _tmp0_;
#line 2769 "../lib/Widgets/SourceList.vala"
	return result;
#line 2010 "SourceList.c"
}


/**
     * Gets the last visible child of an expandable item.
     *
     * @param parent Parent of the child to look up.
     * @return The last visible child of //parent//, or null if it was not found.
     * @since 0.2
     */
GraniteWidgetsSourceListItem*
granite_widgets_source_list_get_last_child (GraniteWidgetsSourceList* self,
                                            GraniteWidgetsSourceListExpandableItem* parent)
{
	GraniteWidgetsSourceListItem* result = NULL;
	GraniteWidgetsSourceListItem* _tmp0_;
#line 2779 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 2779 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (parent != NULL, NULL);
#line 2780 "../lib/Widgets/SourceList.vala"
	_tmp0_ = granite_widgets_source_list_get_nth_child (self, parent, ((gint) granite_widgets_source_list_get_n_visible_children (self, parent)) - 1);
#line 2780 "../lib/Widgets/SourceList.vala"
	result = _tmp0_;
#line 2780 "../lib/Widgets/SourceList.vala"
	return result;
#line 2037 "SourceList.c"
}


/**
     * Gets the number of visible children of an expandable item.
     *
     * @param parent Item to query.
     * @return Number of visible children of //parent//.
     * @since 0.2
     */
guint
granite_widgets_source_list_get_n_visible_children (GraniteWidgetsSourceList* self,
                                                    GraniteWidgetsSourceListExpandableItem* parent)
{
	guint result = 0U;
	GtkTreeIter* parent_iter = NULL;
	GraniteWidgetsSourceListDataModel* _tmp0_;
	GtkTreeIter* _tmp1_;
	GraniteWidgetsSourceListDataModel* _tmp2_;
#line 2790 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 2790 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (parent != NULL, 0U);
#line 2792 "../lib/Widgets/SourceList.vala"
	_tmp0_ = self->priv->data_model;
#line 2792 "../lib/Widgets/SourceList.vala"
	_tmp1_ = granite_widgets_source_list_data_model_get_item_iter (_tmp0_, (GraniteWidgetsSourceListItem*) parent);
#line 2792 "../lib/Widgets/SourceList.vala"
	parent_iter = _tmp1_;
#line 2793 "../lib/Widgets/SourceList.vala"
	_tmp2_ = self->priv->data_model;
#line 2793 "../lib/Widgets/SourceList.vala"
	result = (guint) gtk_tree_model_iter_n_children ((GtkTreeModel*) _tmp2_, parent_iter);
#line 2793 "../lib/Widgets/SourceList.vala"
	_g_free0 (parent_iter);
#line 2793 "../lib/Widgets/SourceList.vala"
	return result;
#line 2075 "SourceList.c"
}


static GraniteWidgetsSourceListItem*
granite_widgets_source_list_get_nth_child (GraniteWidgetsSourceList* self,
                                           GraniteWidgetsSourceListExpandableItem* parent,
                                           gint index)
{
	GraniteWidgetsSourceListItem* result = NULL;
	GtkTreeIter* parent_iter = NULL;
	GraniteWidgetsSourceListDataModel* _tmp0_;
	GtkTreeIter* _tmp1_;
	GtkTreeIter child_iter = {0};
	GraniteWidgetsSourceListDataModel* _tmp2_;
	GtkTreeIter* _tmp3_;
	GtkTreeIter _tmp4_ = {0};
	gboolean _tmp5_;
#line 2796 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 2796 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (parent != NULL, NULL);
#line 2797 "../lib/Widgets/SourceList.vala"
	if (index < 0) {
#line 2798 "../lib/Widgets/SourceList.vala"
		result = NULL;
#line 2798 "../lib/Widgets/SourceList.vala"
		return result;
#line 2103 "SourceList.c"
	}
#line 2801 "../lib/Widgets/SourceList.vala"
	_tmp0_ = self->priv->data_model;
#line 2801 "../lib/Widgets/SourceList.vala"
	_tmp1_ = granite_widgets_source_list_data_model_get_item_iter (_tmp0_, (GraniteWidgetsSourceListItem*) parent);
#line 2801 "../lib/Widgets/SourceList.vala"
	parent_iter = _tmp1_;
#line 2804 "../lib/Widgets/SourceList.vala"
	_tmp2_ = self->priv->data_model;
#line 2804 "../lib/Widgets/SourceList.vala"
	_tmp3_ = parent_iter;
#line 2804 "../lib/Widgets/SourceList.vala"
	_tmp5_ = gtk_tree_model_iter_nth_child ((GtkTreeModel*) _tmp2_, &_tmp4_, _tmp3_, index);
#line 2804 "../lib/Widgets/SourceList.vala"
	child_iter = _tmp4_;
#line 2804 "../lib/Widgets/SourceList.vala"
	if (_tmp5_) {
#line 2121 "SourceList.c"
		GraniteWidgetsSourceListDataModel* _tmp6_;
		GtkTreeIter _tmp7_;
		GraniteWidgetsSourceListItem* _tmp8_;
#line 2805 "../lib/Widgets/SourceList.vala"
		_tmp6_ = self->priv->data_model;
#line 2805 "../lib/Widgets/SourceList.vala"
		_tmp7_ = child_iter;
#line 2805 "../lib/Widgets/SourceList.vala"
		_tmp8_ = granite_widgets_source_list_data_model_get_item (_tmp6_, &_tmp7_);
#line 2805 "../lib/Widgets/SourceList.vala"
		result = _tmp8_;
#line 2805 "../lib/Widgets/SourceList.vala"
		_g_free0 (parent_iter);
#line 2805 "../lib/Widgets/SourceList.vala"
		return result;
#line 2137 "SourceList.c"
	}
#line 2807 "../lib/Widgets/SourceList.vala"
	result = NULL;
#line 2807 "../lib/Widgets/SourceList.vala"
	_g_free0 (parent_iter);
#line 2807 "../lib/Widgets/SourceList.vala"
	return result;
#line 2145 "SourceList.c"
}


GraniteWidgetsSourceListExpandableItem*
granite_widgets_source_list_get_root (GraniteWidgetsSourceList* self)
{
	GraniteWidgetsSourceListExpandableItem* result;
	GraniteWidgetsSourceListDataModel* _tmp0_;
	GraniteWidgetsSourceListExpandableItem* _tmp1_;
	GraniteWidgetsSourceListExpandableItem* _tmp2_;
#line 2500 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 2500 "../lib/Widgets/SourceList.vala"
	_tmp0_ = self->priv->data_model;
#line 2500 "../lib/Widgets/SourceList.vala"
	_tmp1_ = granite_widgets_source_list_data_model_get_root (_tmp0_);
#line 2500 "../lib/Widgets/SourceList.vala"
	_tmp2_ = _tmp1_;
#line 2500 "../lib/Widgets/SourceList.vala"
	result = _tmp2_;
#line 2500 "../lib/Widgets/SourceList.vala"
	return result;
#line 2168 "SourceList.c"
}


void
granite_widgets_source_list_set_root (GraniteWidgetsSourceList* self,
                                      GraniteWidgetsSourceListExpandableItem* value)
{
	GraniteWidgetsSourceListDataModel* _tmp0_;
#line 2501 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 2501 "../lib/Widgets/SourceList.vala"
	_tmp0_ = self->priv->data_model;
#line 2501 "../lib/Widgets/SourceList.vala"
	granite_widgets_source_list_data_model_set_root (_tmp0_, value);
#line 2501 "../lib/Widgets/SourceList.vala"
	g_object_notify_by_pspec ((GObject *) self, granite_widgets_source_list_properties[GRANITE_WIDGETS_SOURCE_LIST_ROOT_PROPERTY]);
#line 2185 "SourceList.c"
}


GraniteWidgetsSourceListItem*
granite_widgets_source_list_get_selected (GraniteWidgetsSourceList* self)
{
	GraniteWidgetsSourceListItem* result;
	GraniteWidgetsSourceListTree* _tmp0_;
	GraniteWidgetsSourceListItem* _tmp1_;
	GraniteWidgetsSourceListItem* _tmp2_;
#line 2514 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 2514 "../lib/Widgets/SourceList.vala"
	_tmp0_ = self->priv->tree;
#line 2514 "../lib/Widgets/SourceList.vala"
	_tmp1_ = granite_widgets_source_list_tree_get_selected_item (_tmp0_);
#line 2514 "../lib/Widgets/SourceList.vala"
	_tmp2_ = _tmp1_;
#line 2514 "../lib/Widgets/SourceList.vala"
	result = _tmp2_;
#line 2514 "../lib/Widgets/SourceList.vala"
	return result;
#line 2208 "SourceList.c"
}


void
granite_widgets_source_list_set_selected (GraniteWidgetsSourceList* self,
                                          GraniteWidgetsSourceListItem* value)
{
	gboolean _tmp0_ = FALSE;
	GraniteWidgetsSourceListTree* _tmp5_;
#line 2515 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 2516 "../lib/Widgets/SourceList.vala"
	if (value != NULL) {
#line 2222 "SourceList.c"
		GraniteWidgetsSourceListExpandableItem* _tmp1_;
		GraniteWidgetsSourceListExpandableItem* _tmp2_;
#line 2516 "../lib/Widgets/SourceList.vala"
		_tmp1_ = granite_widgets_source_list_item_get_parent (value);
#line 2516 "../lib/Widgets/SourceList.vala"
		_tmp2_ = _tmp1_;
#line 2516 "../lib/Widgets/SourceList.vala"
		_tmp0_ = _tmp2_ != NULL;
#line 2231 "SourceList.c"
	} else {
#line 2516 "../lib/Widgets/SourceList.vala"
		_tmp0_ = FALSE;
#line 2235 "SourceList.c"
	}
#line 2516 "../lib/Widgets/SourceList.vala"
	if (_tmp0_) {
#line 2239 "SourceList.c"
		GraniteWidgetsSourceListExpandableItem* _tmp3_;
		GraniteWidgetsSourceListExpandableItem* _tmp4_;
#line 2517 "../lib/Widgets/SourceList.vala"
		_tmp3_ = granite_widgets_source_list_item_get_parent (value);
#line 2517 "../lib/Widgets/SourceList.vala"
		_tmp4_ = _tmp3_;
#line 2517 "../lib/Widgets/SourceList.vala"
		granite_widgets_source_list_expandable_item_expand_with_parents (_tmp4_);
#line 2248 "SourceList.c"
	}
#line 2518 "../lib/Widgets/SourceList.vala"
	_tmp5_ = self->priv->tree;
#line 2518 "../lib/Widgets/SourceList.vala"
	granite_widgets_source_list_tree_set_selected_item (_tmp5_, value);
#line 2515 "../lib/Widgets/SourceList.vala"
	g_object_notify_by_pspec ((GObject *) self, granite_widgets_source_list_properties[GRANITE_WIDGETS_SOURCE_LIST_SELECTED_PROPERTY]);
#line 2256 "SourceList.c"
}


PangoEllipsizeMode
granite_widgets_source_list_get_ellipsize_mode (GraniteWidgetsSourceList* self)
{
	PangoEllipsizeMode result;
	GraniteWidgetsSourceListTree* _tmp0_;
	PangoEllipsizeMode _tmp1_;
	PangoEllipsizeMode _tmp2_;
#line 2528 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 2528 "../lib/Widgets/SourceList.vala"
	_tmp0_ = self->priv->tree;
#line 2528 "../lib/Widgets/SourceList.vala"
	_tmp1_ = granite_widgets_source_list_tree_get_ellipsize_mode (_tmp0_);
#line 2528 "../lib/Widgets/SourceList.vala"
	_tmp2_ = _tmp1_;
#line 2528 "../lib/Widgets/SourceList.vala"
	result = _tmp2_;
#line 2528 "../lib/Widgets/SourceList.vala"
	return result;
#line 2279 "SourceList.c"
}


void
granite_widgets_source_list_set_ellipsize_mode (GraniteWidgetsSourceList* self,
                                                PangoEllipsizeMode value)
{
	GraniteWidgetsSourceListTree* _tmp0_;
#line 2529 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 2529 "../lib/Widgets/SourceList.vala"
	_tmp0_ = self->priv->tree;
#line 2529 "../lib/Widgets/SourceList.vala"
	granite_widgets_source_list_tree_set_ellipsize_mode (_tmp0_, value);
#line 2529 "../lib/Widgets/SourceList.vala"
	g_object_notify_by_pspec ((GObject *) self, granite_widgets_source_list_properties[GRANITE_WIDGETS_SOURCE_LIST_ELLIPSIZE_MODE_PROPERTY]);
#line 2296 "SourceList.c"
}


gboolean
granite_widgets_source_list_get_editing (GraniteWidgetsSourceList* self)
{
	gboolean result;
	GraniteWidgetsSourceListTree* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 2539 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2539 "../lib/Widgets/SourceList.vala"
	_tmp0_ = self->priv->tree;
#line 2539 "../lib/Widgets/SourceList.vala"
	_tmp1_ = granite_widgets_source_list_tree_get_editing (_tmp0_);
#line 2539 "../lib/Widgets/SourceList.vala"
	_tmp2_ = _tmp1_;
#line 2539 "../lib/Widgets/SourceList.vala"
	result = _tmp2_;
#line 2539 "../lib/Widgets/SourceList.vala"
	return result;
#line 2319 "SourceList.c"
}


static void
granite_widgets_source_list_real_item_selected (GraniteWidgetsSourceList* self,
                                                GraniteWidgetsSourceListItem* item)
{
}


static void
_granite_widgets_source_list___lambda77_ (GraniteWidgetsSourceList* self,
                                          GraniteWidgetsSourceListItem* item)
{
#line 2562 "../lib/Widgets/SourceList.vala"
	g_signal_emit (self, granite_widgets_source_list_signals[GRANITE_WIDGETS_SOURCE_LIST_ITEM_SELECTED_SIGNAL], 0, item);
#line 2336 "SourceList.c"
}


static void
__granite_widgets_source_list___lambda77__granite_widgets_source_list_tree_item_selected (GraniteWidgetsSourceListTree* _sender,
                                                                                          GraniteWidgetsSourceListItem* item,
                                                                                          gpointer self)
{
#line 2562 "../lib/Widgets/SourceList.vala"
	_granite_widgets_source_list___lambda77_ ((GraniteWidgetsSourceList*) self, item);
#line 2347 "SourceList.c"
}


static GObject *
granite_widgets_source_list_constructor (GType type,
                                         guint n_construct_properties,
                                         GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GraniteWidgetsSourceList * self;
	GraniteWidgetsSourceListDataModel* _tmp0_;
	GraniteWidgetsSourceListTree* _tmp1_;
	GraniteWidgetsSourceListTree* _tmp2_;
	GraniteWidgetsSourceListTree* _tmp3_;
#line 2555 "../lib/Widgets/SourceList.vala"
	parent_class = G_OBJECT_CLASS (granite_widgets_source_list_parent_class);
#line 2555 "../lib/Widgets/SourceList.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 2555 "../lib/Widgets/SourceList.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GRANITE_WIDGETS_TYPE_SOURCE_LIST, GraniteWidgetsSourceList);
#line 2556 "../lib/Widgets/SourceList.vala"
	_tmp0_ = self->priv->data_model;
#line 2556 "../lib/Widgets/SourceList.vala"
	_tmp1_ = granite_widgets_source_list_tree_new (_tmp0_);
#line 2556 "../lib/Widgets/SourceList.vala"
	g_object_ref_sink (_tmp1_);
#line 2556 "../lib/Widgets/SourceList.vala"
	_g_object_unref0 (self->priv->tree);
#line 2556 "../lib/Widgets/SourceList.vala"
	self->priv->tree = _tmp1_;
#line 2558 "../lib/Widgets/SourceList.vala"
	gtk_scrolled_window_set_policy ((GtkScrolledWindow*) self, GTK_POLICY_NEVER, GTK_POLICY_AUTOMATIC);
#line 2559 "../lib/Widgets/SourceList.vala"
	_tmp2_ = self->priv->tree;
#line 2559 "../lib/Widgets/SourceList.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp2_);
#line 2560 "../lib/Widgets/SourceList.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 2562 "../lib/Widgets/SourceList.vala"
	_tmp3_ = self->priv->tree;
#line 2562 "../lib/Widgets/SourceList.vala"
	g_signal_connect_object (_tmp3_, "item-selected", (GCallback) __granite_widgets_source_list___lambda77__granite_widgets_source_list_tree_item_selected, self, 0);
#line 2555 "../lib/Widgets/SourceList.vala"
	return obj;
#line 2393 "SourceList.c"
}


static inline gpointer
granite_widgets_source_list_item_get_instance_private (GraniteWidgetsSourceListItem* self)
{
	return G_STRUCT_MEMBER_P (self, GraniteWidgetsSourceListItem_private_offset);
}


/**
         * Creates a new {@link Granite.Widgets.SourceList.Item}.
         *
         * @param name Name of the item.
         * @return (transfer full) A new {@link Granite.Widgets.SourceList.Item}.
         * @since 0.2
         */
GraniteWidgetsSourceListItem*
granite_widgets_source_list_item_construct (GType object_type,
                                            const gchar* name)
{
	GraniteWidgetsSourceListItem * self = NULL;
#line 412 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 412 "../lib/Widgets/SourceList.vala"
	self = (GraniteWidgetsSourceListItem*) g_object_new (object_type, NULL);
#line 413 "../lib/Widgets/SourceList.vala"
	granite_widgets_source_list_item_set_name (self, name);
#line 412 "../lib/Widgets/SourceList.vala"
	return self;
#line 2424 "SourceList.c"
}


GraniteWidgetsSourceListItem*
granite_widgets_source_list_item_new (const gchar* name)
{
#line 412 "../lib/Widgets/SourceList.vala"
	return granite_widgets_source_list_item_construct (GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM, name);
#line 2433 "SourceList.c"
}


/**
         * Invoked when the item is secondary-clicked or when the usual menu keys are pressed.
         *
         * Note that since Granite 5.0, right clicking on an item no longer selects/activates it, so
         * any context menu items should be actioned on the item instance rather than the selected item
         * in the SourceList
         *
         * @return A {@link Gtk.Menu} or //null// if nothing should be displayed.
         * @since 0.2
         */
static GtkMenu*
granite_widgets_source_list_item_real_get_context_menu (GraniteWidgetsSourceListItem* self)
{
	GtkMenu* result = NULL;
#line 427 "../lib/Widgets/SourceList.vala"
	result = NULL;
#line 427 "../lib/Widgets/SourceList.vala"
	return result;
#line 2455 "SourceList.c"
}


GtkMenu*
granite_widgets_source_list_item_get_context_menu (GraniteWidgetsSourceListItem* self)
{
#line 426 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 426 "../lib/Widgets/SourceList.vala"
	return GRANITE_WIDGETS_SOURCE_LIST_ITEM_GET_CLASS (self)->get_context_menu (self);
#line 2466 "SourceList.c"
}


GraniteWidgetsSourceListExpandableItem*
granite_widgets_source_list_item_get_parent (GraniteWidgetsSourceListItem* self)
{
	GraniteWidgetsSourceListExpandableItem* result;
	GraniteWidgetsSourceListExpandableItem* _tmp0_;
#line 319 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 319 "../lib/Widgets/SourceList.vala"
	_tmp0_ = self->priv->_parent;
#line 319 "../lib/Widgets/SourceList.vala"
	result = _tmp0_;
#line 319 "../lib/Widgets/SourceList.vala"
	return result;
#line 2483 "SourceList.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 319 "../lib/Widgets/SourceList.vala"
	return self ? g_object_ref (self) : NULL;
#line 2492 "SourceList.c"
}


G_GNUC_INTERNAL void
granite_widgets_source_list_item_set_parent (GraniteWidgetsSourceListItem* self,
                                             GraniteWidgetsSourceListExpandableItem* value)
{
#line 319 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 319 "../lib/Widgets/SourceList.vala"
	if (granite_widgets_source_list_item_get_parent (self) != value) {
#line 2504 "SourceList.c"
		GraniteWidgetsSourceListExpandableItem* _tmp0_;
#line 319 "../lib/Widgets/SourceList.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 319 "../lib/Widgets/SourceList.vala"
		_g_object_unref0 (self->priv->_parent);
#line 319 "../lib/Widgets/SourceList.vala"
		self->priv->_parent = _tmp0_;
#line 319 "../lib/Widgets/SourceList.vala"
		g_object_notify_by_pspec ((GObject *) self, granite_widgets_source_list_item_properties[GRANITE_WIDGETS_SOURCE_LIST_ITEM_PARENT_PROPERTY]);
#line 2514 "SourceList.c"
	}
}


const gchar*
granite_widgets_source_list_item_get_name (GraniteWidgetsSourceListItem* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 326 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 326 "../lib/Widgets/SourceList.vala"
	_tmp0_ = self->priv->_name;
#line 326 "../lib/Widgets/SourceList.vala"
	result = _tmp0_;
#line 326 "../lib/Widgets/SourceList.vala"
	return result;
#line 2532 "SourceList.c"
}


void
granite_widgets_source_list_item_set_name (GraniteWidgetsSourceListItem* self,
                                           const gchar* value)
{
#line 326 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 326 "../lib/Widgets/SourceList.vala"
	if (g_strcmp0 (value, granite_widgets_source_list_item_get_name (self)) != 0) {
#line 2544 "SourceList.c"
		gchar* _tmp0_;
#line 326 "../lib/Widgets/SourceList.vala"
		_tmp0_ = g_strdup (value);
#line 326 "../lib/Widgets/SourceList.vala"
		_g_free0 (self->priv->_name);
#line 326 "../lib/Widgets/SourceList.vala"
		self->priv->_name = _tmp0_;
#line 326 "../lib/Widgets/SourceList.vala"
		g_object_notify_by_pspec ((GObject *) self, granite_widgets_source_list_item_properties[GRANITE_WIDGETS_SOURCE_LIST_ITEM_NAME_PROPERTY]);
#line 2554 "SourceList.c"
	}
}


const gchar*
granite_widgets_source_list_item_get_markup (GraniteWidgetsSourceListItem* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 339 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 339 "../lib/Widgets/SourceList.vala"
	_tmp0_ = self->priv->_markup;
#line 339 "../lib/Widgets/SourceList.vala"
	result = _tmp0_;
#line 339 "../lib/Widgets/SourceList.vala"
	return result;
#line 2572 "SourceList.c"
}


void
granite_widgets_source_list_item_set_markup (GraniteWidgetsSourceListItem* self,
                                             const gchar* value)
{
#line 339 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 339 "../lib/Widgets/SourceList.vala"
	if (g_strcmp0 (value, granite_widgets_source_list_item_get_markup (self)) != 0) {
#line 2584 "SourceList.c"
		gchar* _tmp0_;
#line 339 "../lib/Widgets/SourceList.vala"
		_tmp0_ = g_strdup (value);
#line 339 "../lib/Widgets/SourceList.vala"
		_g_free0 (self->priv->_markup);
#line 339 "../lib/Widgets/SourceList.vala"
		self->priv->_markup = _tmp0_;
#line 339 "../lib/Widgets/SourceList.vala"
		g_object_notify_by_pspec ((GObject *) self, granite_widgets_source_list_item_properties[GRANITE_WIDGETS_SOURCE_LIST_ITEM_MARKUP_PROPERTY]);
#line 2594 "SourceList.c"
	}
}


const gchar*
granite_widgets_source_list_item_get_badge (GraniteWidgetsSourceListItem* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 349 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 349 "../lib/Widgets/SourceList.vala"
	_tmp0_ = self->priv->_badge;
#line 349 "../lib/Widgets/SourceList.vala"
	result = _tmp0_;
#line 349 "../lib/Widgets/SourceList.vala"
	return result;
#line 2612 "SourceList.c"
}


void
granite_widgets_source_list_item_set_badge (GraniteWidgetsSourceListItem* self,
                                            const gchar* value)
{
#line 349 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 349 "../lib/Widgets/SourceList.vala"
	if (g_strcmp0 (value, granite_widgets_source_list_item_get_badge (self)) != 0) {
#line 2624 "SourceList.c"
		gchar* _tmp0_;
#line 349 "../lib/Widgets/SourceList.vala"
		_tmp0_ = g_strdup (value);
#line 349 "../lib/Widgets/SourceList.vala"
		_g_free0 (self->priv->_badge);
#line 349 "../lib/Widgets/SourceList.vala"
		self->priv->_badge = _tmp0_;
#line 349 "../lib/Widgets/SourceList.vala"
		g_object_notify_by_pspec ((GObject *) self, granite_widgets_source_list_item_properties[GRANITE_WIDGETS_SOURCE_LIST_ITEM_BADGE_PROPERTY]);
#line 2634 "SourceList.c"
	}
}


gboolean
granite_widgets_source_list_item_get_editable (GraniteWidgetsSourceListItem* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 363 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 363 "../lib/Widgets/SourceList.vala"
	_tmp0_ = self->priv->_editable;
#line 363 "../lib/Widgets/SourceList.vala"
	result = _tmp0_;
#line 363 "../lib/Widgets/SourceList.vala"
	return result;
#line 2652 "SourceList.c"
}


void
granite_widgets_source_list_item_set_editable (GraniteWidgetsSourceListItem* self,
                                               gboolean value)
{
#line 363 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 363 "../lib/Widgets/SourceList.vala"
	if (granite_widgets_source_list_item_get_editable (self) != value) {
#line 363 "../lib/Widgets/SourceList.vala"
		self->priv->_editable = value;
#line 363 "../lib/Widgets/SourceList.vala"
		g_object_notify_by_pspec ((GObject *) self, granite_widgets_source_list_item_properties[GRANITE_WIDGETS_SOURCE_LIST_ITEM_EDITABLE_PROPERTY]);
#line 2668 "SourceList.c"
	}
}


gboolean
granite_widgets_source_list_item_get_visible (GraniteWidgetsSourceListItem* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 370 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 370 "../lib/Widgets/SourceList.vala"
	_tmp0_ = self->priv->_visible;
#line 370 "../lib/Widgets/SourceList.vala"
	result = _tmp0_;
#line 370 "../lib/Widgets/SourceList.vala"
	return result;
#line 2686 "SourceList.c"
}


void
granite_widgets_source_list_item_set_visible (GraniteWidgetsSourceListItem* self,
                                              gboolean value)
{
#line 370 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 370 "../lib/Widgets/SourceList.vala"
	if (granite_widgets_source_list_item_get_visible (self) != value) {
#line 370 "../lib/Widgets/SourceList.vala"
		self->priv->_visible = value;
#line 370 "../lib/Widgets/SourceList.vala"
		g_object_notify_by_pspec ((GObject *) self, granite_widgets_source_list_item_properties[GRANITE_WIDGETS_SOURCE_LIST_ITEM_VISIBLE_PROPERTY]);
#line 2702 "SourceList.c"
	}
}


gboolean
granite_widgets_source_list_item_get_selectable (GraniteWidgetsSourceListItem* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 383 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 383 "../lib/Widgets/SourceList.vala"
	_tmp0_ = self->priv->_selectable;
#line 383 "../lib/Widgets/SourceList.vala"
	result = _tmp0_;
#line 383 "../lib/Widgets/SourceList.vala"
	return result;
#line 2720 "SourceList.c"
}


void
granite_widgets_source_list_item_set_selectable (GraniteWidgetsSourceListItem* self,
                                                 gboolean value)
{
#line 383 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 383 "../lib/Widgets/SourceList.vala"
	if (granite_widgets_source_list_item_get_selectable (self) != value) {
#line 383 "../lib/Widgets/SourceList.vala"
		self->priv->_selectable = value;
#line 383 "../lib/Widgets/SourceList.vala"
		g_object_notify_by_pspec ((GObject *) self, granite_widgets_source_list_item_properties[GRANITE_WIDGETS_SOURCE_LIST_ITEM_SELECTABLE_PROPERTY]);
#line 2736 "SourceList.c"
	}
}


GIcon*
granite_widgets_source_list_item_get_icon (GraniteWidgetsSourceListItem* self)
{
	GIcon* result;
	GIcon* _tmp0_;
#line 393 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 393 "../lib/Widgets/SourceList.vala"
	_tmp0_ = self->priv->_icon;
#line 393 "../lib/Widgets/SourceList.vala"
	result = _tmp0_;
#line 393 "../lib/Widgets/SourceList.vala"
	return result;
#line 2754 "SourceList.c"
}


void
granite_widgets_source_list_item_set_icon (GraniteWidgetsSourceListItem* self,
                                           GIcon* value)
{
#line 393 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 393 "../lib/Widgets/SourceList.vala"
	if (granite_widgets_source_list_item_get_icon (self) != value) {
#line 2766 "SourceList.c"
		GIcon* _tmp0_;
#line 393 "../lib/Widgets/SourceList.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 393 "../lib/Widgets/SourceList.vala"
		_g_object_unref0 (self->priv->_icon);
#line 393 "../lib/Widgets/SourceList.vala"
		self->priv->_icon = _tmp0_;
#line 393 "../lib/Widgets/SourceList.vala"
		g_object_notify_by_pspec ((GObject *) self, granite_widgets_source_list_item_properties[GRANITE_WIDGETS_SOURCE_LIST_ITEM_ICON_PROPERTY]);
#line 2776 "SourceList.c"
	}
}


GIcon*
granite_widgets_source_list_item_get_activatable (GraniteWidgetsSourceListItem* self)
{
	GIcon* result;
	GIcon* _tmp0_;
#line 403 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 403 "../lib/Widgets/SourceList.vala"
	_tmp0_ = self->priv->_activatable;
#line 403 "../lib/Widgets/SourceList.vala"
	result = _tmp0_;
#line 403 "../lib/Widgets/SourceList.vala"
	return result;
#line 2794 "SourceList.c"
}


void
granite_widgets_source_list_item_set_activatable (GraniteWidgetsSourceListItem* self,
                                                  GIcon* value)
{
#line 403 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 403 "../lib/Widgets/SourceList.vala"
	if (granite_widgets_source_list_item_get_activatable (self) != value) {
#line 2806 "SourceList.c"
		GIcon* _tmp0_;
#line 403 "../lib/Widgets/SourceList.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 403 "../lib/Widgets/SourceList.vala"
		_g_object_unref0 (self->priv->_activatable);
#line 403 "../lib/Widgets/SourceList.vala"
		self->priv->_activatable = _tmp0_;
#line 403 "../lib/Widgets/SourceList.vala"
		g_object_notify_by_pspec ((GObject *) self, granite_widgets_source_list_item_properties[GRANITE_WIDGETS_SOURCE_LIST_ITEM_ACTIVATABLE_PROPERTY]);
#line 2816 "SourceList.c"
	}
}


static gchar*
string_strip (const gchar* self)
{
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
#line 1304 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1305 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1305 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1306 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1306 "glib-2.0.vapi"
	g_strstrip (_tmp1_);
#line 1307 "glib-2.0.vapi"
	result = _result_;
#line 1307 "glib-2.0.vapi"
	return result;
#line 2842 "SourceList.c"
}


static void
granite_widgets_source_list_item_real_edited (GraniteWidgetsSourceListItem* self,
                                              const gchar* new_name)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
#line 291 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (new_name != NULL);
#line 292 "../lib/Widgets/SourceList.vala"
	_tmp1_ = self->priv->_editable;
#line 292 "../lib/Widgets/SourceList.vala"
	if (_tmp1_) {
#line 2858 "SourceList.c"
		gchar* _tmp2_;
		gchar* _tmp3_;
#line 292 "../lib/Widgets/SourceList.vala"
		_tmp2_ = string_strip (new_name);
#line 292 "../lib/Widgets/SourceList.vala"
		_tmp3_ = _tmp2_;
#line 292 "../lib/Widgets/SourceList.vala"
		_tmp0_ = g_strcmp0 (_tmp3_, "") != 0;
#line 292 "../lib/Widgets/SourceList.vala"
		_g_free0 (_tmp3_);
#line 2869 "SourceList.c"
	} else {
#line 292 "../lib/Widgets/SourceList.vala"
		_tmp0_ = FALSE;
#line 2873 "SourceList.c"
	}
#line 292 "../lib/Widgets/SourceList.vala"
	if (_tmp0_) {
#line 293 "../lib/Widgets/SourceList.vala"
		granite_widgets_source_list_item_set_name (self, new_name);
#line 2879 "SourceList.c"
	}
}


static void
granite_widgets_source_list_item_real_action_activated (GraniteWidgetsSourceListItem* self)
{
}


static void
granite_widgets_source_list_item_real_activated (GraniteWidgetsSourceListItem* self)
{
}


static void
granite_widgets_source_list_item_class_init (GraniteWidgetsSourceListItemClass * klass)
{
#line 280 "../lib/Widgets/SourceList.vala"
	granite_widgets_source_list_item_parent_class = g_type_class_peek_parent (klass);
#line 280 "../lib/Widgets/SourceList.vala"
	g_type_class_adjust_private_offset (klass, &GraniteWidgetsSourceListItem_private_offset);
#line 280 "../lib/Widgets/SourceList.vala"
	((GraniteWidgetsSourceListItemClass *) klass)->get_context_menu = (GtkMenu* (*) (GraniteWidgetsSourceListItem*)) granite_widgets_source_list_item_real_get_context_menu;
#line 280 "../lib/Widgets/SourceList.vala"
	((GraniteWidgetsSourceListItemClass *) klass)->edited = granite_widgets_source_list_item_real_edited;
#line 280 "../lib/Widgets/SourceList.vala"
	((GraniteWidgetsSourceListItemClass *) klass)->action_activated = granite_widgets_source_list_item_real_action_activated;
#line 280 "../lib/Widgets/SourceList.vala"
	((GraniteWidgetsSourceListItemClass *) klass)->activated = granite_widgets_source_list_item_real_activated;
#line 280 "../lib/Widgets/SourceList.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_granite_widgets_source_list_item_get_property;
#line 280 "../lib/Widgets/SourceList.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_granite_widgets_source_list_item_set_property;
#line 280 "../lib/Widgets/SourceList.vala"
	G_OBJECT_CLASS (klass)->finalize = granite_widgets_source_list_item_finalize;
#line 2917 "SourceList.c"
	/**
	         * Parent {@link Granite.Widgets.SourceList.ExpandableItem} of the item.
	         * ''Must not'' be modified.
	         *
	         * @since 0.2
	         */
#line 280 "../lib/Widgets/SourceList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_ITEM_PARENT_PROPERTY, granite_widgets_source_list_item_properties[GRANITE_WIDGETS_SOURCE_LIST_ITEM_PARENT_PROPERTY] = g_param_spec_object ("parent", "parent", "parent", GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2926 "SourceList.c"
	/**
	         * The item's name. Primary and most important information.
	         *
	         * @since 0.2
	         */
#line 280 "../lib/Widgets/SourceList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_ITEM_NAME_PROPERTY, granite_widgets_source_list_item_properties[GRANITE_WIDGETS_SOURCE_LIST_ITEM_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2934 "SourceList.c"
	/**
	         * Markup to be used instead of {@link Granite.Widgets.SourceList.ExpandableItem.name}
	         * This would mean that &, <, etc have to be escaped in the text, but basic formatting
	         * can be done on the item with HTML style tags.
	         *
	         * Note: Only the {@link Granite.Widgets.SourceList.ExpandableItem.name} property
	         * is modified for editable items. So this property will be need to updated and
	         * reformatted with editable items.
	         *
	         * @since 5.0
	         */
#line 280 "../lib/Widgets/SourceList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_ITEM_MARKUP_PROPERTY, granite_widgets_source_list_item_properties[GRANITE_WIDGETS_SOURCE_LIST_ITEM_MARKUP_PROPERTY] = g_param_spec_string ("markup", "markup", "markup", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2948 "SourceList.c"
	/**
	         * A badge shown next to the item's name.
	         *
	         * It can be used for displaying the number of unread messages in the "Inbox" item,
	         * for instance.
	         *
	         * @since 0.2
	         */
#line 280 "../lib/Widgets/SourceList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_ITEM_BADGE_PROPERTY, granite_widgets_source_list_item_properties[GRANITE_WIDGETS_SOURCE_LIST_ITEM_BADGE_PROPERTY] = g_param_spec_string ("badge", "badge", "badge", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2959 "SourceList.c"
	/**
	         * Whether the item's name can be edited from within the source list.
	         *
	         * When this property is set to //true//, users can edit the item by pressing
	         * the F2 key, or by double-clicking its name.
	         *
	         * ''This property only works for selectable items''.
	         *
	         * @see Granite.Widgets.SourceList.Item.selectable
	         * @see Granite.Widgets.SourceList.start_editing_item
	         * @since 0.2
	         */
#line 280 "../lib/Widgets/SourceList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_ITEM_EDITABLE_PROPERTY, granite_widgets_source_list_item_properties[GRANITE_WIDGETS_SOURCE_LIST_ITEM_EDITABLE_PROPERTY] = g_param_spec_boolean ("editable", "editable", "editable", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2974 "SourceList.c"
	/**
	         * Whether the item should appear in the source list's tree or not.
	         *
	         * @since 0.2
	         */
#line 280 "../lib/Widgets/SourceList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_ITEM_VISIBLE_PROPERTY, granite_widgets_source_list_item_properties[GRANITE_WIDGETS_SOURCE_LIST_ITEM_VISIBLE_PROPERTY] = g_param_spec_boolean ("visible", "visible", "visible", TRUE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2982 "SourceList.c"
	/**
	         * Whether the item can be selected or not.
	         *
	         * Setting this property to true doesn't guarantee that the item will actually be
	         * selectable, since there are other external factors to take into account, like the
	         * item's {@link Granite.Widgets.SourceList.Item.visible} property; whether the item is
	         * a category; the parent item is collapsed, etc.
	         *
	         * @see Granite.Widgets.SourceList.Item.visible
	         * @since 0.2
	         */
#line 280 "../lib/Widgets/SourceList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_ITEM_SELECTABLE_PROPERTY, granite_widgets_source_list_item_properties[GRANITE_WIDGETS_SOURCE_LIST_ITEM_SELECTABLE_PROPERTY] = g_param_spec_boolean ("selectable", "selectable", "selectable", TRUE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2996 "SourceList.c"
	/**
	         * Primary icon.
	         *
	         * This property should be used to give the user an idea of what the item represents
	         * (i.e. content type.)
	         *
	         * @since 0.2
	         */
#line 280 "../lib/Widgets/SourceList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_ITEM_ICON_PROPERTY, granite_widgets_source_list_item_properties[GRANITE_WIDGETS_SOURCE_LIST_ITEM_ICON_PROPERTY] = g_param_spec_object ("icon", "icon", "icon", g_icon_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 3007 "SourceList.c"
	/**
	         * An activatable icon that works like a button.
	         *
	         * It can be used for e.g. showing an //"eject"// icon on a device's item.
	         *
	         * @see Granite.Widgets.SourceList.Item.action_activated
	         * @since 0.2
	         */
#line 280 "../lib/Widgets/SourceList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_ITEM_ACTIVATABLE_PROPERTY, granite_widgets_source_list_item_properties[GRANITE_WIDGETS_SOURCE_LIST_ITEM_ACTIVATABLE_PROPERTY] = g_param_spec_object ("activatable", "activatable", "activatable", g_icon_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 3018 "SourceList.c"
	/**
	         * Emitted when the user has finished editing the item's name.
	         *
	         * By default, if the name doesn't consist of white space, it is automatically assigned
	         * to the {@link Granite.Widgets.SourceList.Item.name} property. The default behavior can
	         * be changed by overriding this signal.
	         * @param new_name The item's new name (result of editing.)
	         * @since 0.2
	         */
#line 280 "../lib/Widgets/SourceList.vala"
	granite_widgets_source_list_item_signals[GRANITE_WIDGETS_SOURCE_LIST_ITEM_EDITED_SIGNAL] = g_signal_new ("edited", GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (GraniteWidgetsSourceListItemClass, edited), NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
#line 3030 "SourceList.c"
	/**
	         * The {@link Granite.Widgets.SourceList.Item.activatable} icon was activated.
	         *
	         * @see Granite.Widgets.SourceList.Item.activatable
	         * @since 0.2
	         */
#line 280 "../lib/Widgets/SourceList.vala"
	granite_widgets_source_list_item_signals[GRANITE_WIDGETS_SOURCE_LIST_ITEM_ACTION_ACTIVATED_SIGNAL] = g_signal_new ("action-activated", GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (GraniteWidgetsSourceListItemClass, action_activated), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 3039 "SourceList.c"
	/**
	         * Emitted when the item is double-clicked or when it is selected and one of the keys:
	         * Space, Shift+Space, Return or Enter is pressed. This signal is //also// for
	         * editable items.
	         *
	         * @since 0.2
	         */
#line 280 "../lib/Widgets/SourceList.vala"
	granite_widgets_source_list_item_signals[GRANITE_WIDGETS_SOURCE_LIST_ITEM_ACTIVATED_SIGNAL] = g_signal_new ("activated", GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (GraniteWidgetsSourceListItemClass, activated), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 3049 "SourceList.c"
}


static void
granite_widgets_source_list_item_instance_init (GraniteWidgetsSourceListItem * self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 280 "../lib/Widgets/SourceList.vala"
	self->priv = granite_widgets_source_list_item_get_instance_private (self);
#line 326 "../lib/Widgets/SourceList.vala"
	_tmp0_ = g_strdup ("");
#line 326 "../lib/Widgets/SourceList.vala"
	self->priv->_name = _tmp0_;
#line 339 "../lib/Widgets/SourceList.vala"
	self->priv->_markup = NULL;
#line 349 "../lib/Widgets/SourceList.vala"
	_tmp1_ = g_strdup ("");
#line 349 "../lib/Widgets/SourceList.vala"
	self->priv->_badge = _tmp1_;
#line 363 "../lib/Widgets/SourceList.vala"
	self->priv->_editable = FALSE;
#line 370 "../lib/Widgets/SourceList.vala"
	self->priv->_visible = TRUE;
#line 383 "../lib/Widgets/SourceList.vala"
	self->priv->_selectable = TRUE;
#line 3076 "SourceList.c"
}


static void
granite_widgets_source_list_item_finalize (GObject * obj)
{
	GraniteWidgetsSourceListItem * self;
#line 280 "../lib/Widgets/SourceList.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM, GraniteWidgetsSourceListItem);
#line 319 "../lib/Widgets/SourceList.vala"
	_g_object_unref0 (self->priv->_parent);
#line 326 "../lib/Widgets/SourceList.vala"
	_g_free0 (self->priv->_name);
#line 339 "../lib/Widgets/SourceList.vala"
	_g_free0 (self->priv->_markup);
#line 349 "../lib/Widgets/SourceList.vala"
	_g_free0 (self->priv->_badge);
#line 393 "../lib/Widgets/SourceList.vala"
	_g_object_unref0 (self->priv->_icon);
#line 403 "../lib/Widgets/SourceList.vala"
	_g_object_unref0 (self->priv->_activatable);
#line 280 "../lib/Widgets/SourceList.vala"
	G_OBJECT_CLASS (granite_widgets_source_list_item_parent_class)->finalize (obj);
#line 3100 "SourceList.c"
}


/**
     * A source list entry.
     *
     * Any change made to any of its properties will be ''automatically'' reflected
     * by the {@link Granite.Widgets.SourceList} widget.
     *
     * @since 0.2
     */
GType
granite_widgets_source_list_item_get_type (void)
{
	static volatile gsize granite_widgets_source_list_item_type_id__volatile = 0;
	if (g_once_init_enter (&granite_widgets_source_list_item_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GraniteWidgetsSourceListItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) granite_widgets_source_list_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GraniteWidgetsSourceListItem), 0, (GInstanceInitFunc) granite_widgets_source_list_item_instance_init, NULL };
		GType granite_widgets_source_list_item_type_id;
		granite_widgets_source_list_item_type_id = g_type_register_static (G_TYPE_OBJECT, "GraniteWidgetsSourceListItem", &g_define_type_info, 0);
		GraniteWidgetsSourceListItem_private_offset = g_type_add_instance_private (granite_widgets_source_list_item_type_id, sizeof (GraniteWidgetsSourceListItemPrivate));
		g_once_init_leave (&granite_widgets_source_list_item_type_id__volatile, granite_widgets_source_list_item_type_id);
	}
	return granite_widgets_source_list_item_type_id__volatile;
}


static void
_vala_granite_widgets_source_list_item_get_property (GObject * object,
                                                     guint property_id,
                                                     GValue * value,
                                                     GParamSpec * pspec)
{
	GraniteWidgetsSourceListItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM, GraniteWidgetsSourceListItem);
#line 280 "../lib/Widgets/SourceList.vala"
	switch (property_id) {
#line 280 "../lib/Widgets/SourceList.vala"
		case GRANITE_WIDGETS_SOURCE_LIST_ITEM_PARENT_PROPERTY:
#line 280 "../lib/Widgets/SourceList.vala"
		g_value_set_object (value, granite_widgets_source_list_item_get_parent (self));
#line 280 "../lib/Widgets/SourceList.vala"
		break;
#line 280 "../lib/Widgets/SourceList.vala"
		case GRANITE_WIDGETS_SOURCE_LIST_ITEM_NAME_PROPERTY:
#line 280 "../lib/Widgets/SourceList.vala"
		g_value_set_string (value, granite_widgets_source_list_item_get_name (self));
#line 280 "../lib/Widgets/SourceList.vala"
		break;
#line 280 "../lib/Widgets/SourceList.vala"
		case GRANITE_WIDGETS_SOURCE_LIST_ITEM_MARKUP_PROPERTY:
#line 280 "../lib/Widgets/SourceList.vala"
		g_value_set_string (value, granite_widgets_source_list_item_get_markup (self));
#line 280 "../lib/Widgets/SourceList.vala"
		break;
#line 280 "../lib/Widgets/SourceList.vala"
		case GRANITE_WIDGETS_SOURCE_LIST_ITEM_BADGE_PROPERTY:
#line 280 "../lib/Widgets/SourceList.vala"
		g_value_set_string (value, granite_widgets_source_list_item_get_badge (self));
#line 280 "../lib/Widgets/SourceList.vala"
		break;
#line 280 "../lib/Widgets/SourceList.vala"
		case GRANITE_WIDGETS_SOURCE_LIST_ITEM_EDITABLE_PROPERTY:
#line 280 "../lib/Widgets/SourceList.vala"
		g_value_set_boolean (value, granite_widgets_source_list_item_get_editable (self));
#line 280 "../lib/Widgets/SourceList.vala"
		break;
#line 280 "../lib/Widgets/SourceList.vala"
		case GRANITE_WIDGETS_SOURCE_LIST_ITEM_VISIBLE_PROPERTY:
#line 280 "../lib/Widgets/SourceList.vala"
		g_value_set_boolean (value, granite_widgets_source_list_item_get_visible (self));
#line 280 "../lib/Widgets/SourceList.vala"
		break;
#line 280 "../lib/Widgets/SourceList.vala"
		case GRANITE_WIDGETS_SOURCE_LIST_ITEM_SELECTABLE_PROPERTY:
#line 280 "../lib/Widgets/SourceList.vala"
		g_value_set_boolean (value, granite_widgets_source_list_item_get_selectable (self));
#line 280 "../lib/Widgets/SourceList.vala"
		break;
#line 280 "../lib/Widgets/SourceList.vala"
		case GRANITE_WIDGETS_SOURCE_LIST_ITEM_ICON_PROPERTY:
#line 280 "../lib/Widgets/SourceList.vala"
		g_value_set_object (value, granite_widgets_source_list_item_get_icon (self));
#line 280 "../lib/Widgets/SourceList.vala"
		break;
#line 280 "../lib/Widgets/SourceList.vala"
		case GRANITE_WIDGETS_SOURCE_LIST_ITEM_ACTIVATABLE_PROPERTY:
#line 280 "../lib/Widgets/SourceList.vala"
		g_value_set_object (value, granite_widgets_source_list_item_get_activatable (self));
#line 280 "../lib/Widgets/SourceList.vala"
		break;
#line 3191 "SourceList.c"
		default:
#line 280 "../lib/Widgets/SourceList.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 280 "../lib/Widgets/SourceList.vala"
		break;
#line 3197 "SourceList.c"
	}
}


static void
_vala_granite_widgets_source_list_item_set_property (GObject * object,
                                                     guint property_id,
                                                     const GValue * value,
                                                     GParamSpec * pspec)
{
	GraniteWidgetsSourceListItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM, GraniteWidgetsSourceListItem);
#line 280 "../lib/Widgets/SourceList.vala"
	switch (property_id) {
#line 280 "../lib/Widgets/SourceList.vala"
		case GRANITE_WIDGETS_SOURCE_LIST_ITEM_PARENT_PROPERTY:
#line 280 "../lib/Widgets/SourceList.vala"
		granite_widgets_source_list_item_set_parent (self, g_value_get_object (value));
#line 280 "../lib/Widgets/SourceList.vala"
		break;
#line 280 "../lib/Widgets/SourceList.vala"
		case GRANITE_WIDGETS_SOURCE_LIST_ITEM_NAME_PROPERTY:
#line 280 "../lib/Widgets/SourceList.vala"
		granite_widgets_source_list_item_set_name (self, g_value_get_string (value));
#line 280 "../lib/Widgets/SourceList.vala"
		break;
#line 280 "../lib/Widgets/SourceList.vala"
		case GRANITE_WIDGETS_SOURCE_LIST_ITEM_MARKUP_PROPERTY:
#line 280 "../lib/Widgets/SourceList.vala"
		granite_widgets_source_list_item_set_markup (self, g_value_get_string (value));
#line 280 "../lib/Widgets/SourceList.vala"
		break;
#line 280 "../lib/Widgets/SourceList.vala"
		case GRANITE_WIDGETS_SOURCE_LIST_ITEM_BADGE_PROPERTY:
#line 280 "../lib/Widgets/SourceList.vala"
		granite_widgets_source_list_item_set_badge (self, g_value_get_string (value));
#line 280 "../lib/Widgets/SourceList.vala"
		break;
#line 280 "../lib/Widgets/SourceList.vala"
		case GRANITE_WIDGETS_SOURCE_LIST_ITEM_EDITABLE_PROPERTY:
#line 280 "../lib/Widgets/SourceList.vala"
		granite_widgets_source_list_item_set_editable (self, g_value_get_boolean (value));
#line 280 "../lib/Widgets/SourceList.vala"
		break;
#line 280 "../lib/Widgets/SourceList.vala"
		case GRANITE_WIDGETS_SOURCE_LIST_ITEM_VISIBLE_PROPERTY:
#line 280 "../lib/Widgets/SourceList.vala"
		granite_widgets_source_list_item_set_visible (self, g_value_get_boolean (value));
#line 280 "../lib/Widgets/SourceList.vala"
		break;
#line 280 "../lib/Widgets/SourceList.vala"
		case GRANITE_WIDGETS_SOURCE_LIST_ITEM_SELECTABLE_PROPERTY:
#line 280 "../lib/Widgets/SourceList.vala"
		granite_widgets_source_list_item_set_selectable (self, g_value_get_boolean (value));
#line 280 "../lib/Widgets/SourceList.vala"
		break;
#line 280 "../lib/Widgets/SourceList.vala"
		case GRANITE_WIDGETS_SOURCE_LIST_ITEM_ICON_PROPERTY:
#line 280 "../lib/Widgets/SourceList.vala"
		granite_widgets_source_list_item_set_icon (self, g_value_get_object (value));
#line 280 "../lib/Widgets/SourceList.vala"
		break;
#line 280 "../lib/Widgets/SourceList.vala"
		case GRANITE_WIDGETS_SOURCE_LIST_ITEM_ACTIVATABLE_PROPERTY:
#line 280 "../lib/Widgets/SourceList.vala"
		granite_widgets_source_list_item_set_activatable (self, g_value_get_object (value));
#line 280 "../lib/Widgets/SourceList.vala"
		break;
#line 3266 "SourceList.c"
		default:
#line 280 "../lib/Widgets/SourceList.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 280 "../lib/Widgets/SourceList.vala"
		break;
#line 3272 "SourceList.c"
	}
}


static inline gpointer
granite_widgets_source_list_expandable_item_get_instance_private (GraniteWidgetsSourceListExpandableItem* self)
{
	return G_STRUCT_MEMBER_P (self, GraniteWidgetsSourceListExpandableItem_private_offset);
}


/**
         * Creates a new {@link Granite.Widgets.SourceList.ExpandableItem}
         *
         * @param name Title of the item.
         * @return (transfer full) A new {@link Granite.Widgets.SourceList.ExpandableItem}.
         * @since 0.2
         */
GraniteWidgetsSourceListExpandableItem*
granite_widgets_source_list_expandable_item_construct (GType object_type,
                                                       const gchar* name)
{
	GraniteWidgetsSourceListExpandableItem * self = NULL;
#line 558 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 559 "../lib/Widgets/SourceList.vala"
	self = (GraniteWidgetsSourceListExpandableItem*) granite_widgets_source_list_item_construct (object_type, name);
#line 558 "../lib/Widgets/SourceList.vala"
	return self;
#line 3302 "SourceList.c"
}


GraniteWidgetsSourceListExpandableItem*
granite_widgets_source_list_expandable_item_new (const gchar* name)
{
#line 558 "../lib/Widgets/SourceList.vala"
	return granite_widgets_source_list_expandable_item_construct (GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM, name);
#line 3311 "SourceList.c"
}


/**
         * Checks whether the item contains the specified child.
         *
         * This method only considers the item's immediate children.
         *
         * @param item Item to search.
         * @return Whether the item was found or not.
         * @since 0.2
         */
gboolean
granite_widgets_source_list_expandable_item_contains (GraniteWidgetsSourceListExpandableItem* self,
                                                      GraniteWidgetsSourceListItem* item)
{
	gboolean result = FALSE;
	GeeCollection* _tmp0_;
#line 575 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 575 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (item != NULL, FALSE);
#line 576 "../lib/Widgets/SourceList.vala"
	_tmp0_ = self->priv->children_list;
#line 576 "../lib/Widgets/SourceList.vala"
	result = gee_collection_contains (_tmp0_, item);
#line 576 "../lib/Widgets/SourceList.vala"
	return result;
#line 3340 "SourceList.c"
}


/**
         * Adds an item.
         *
         * {@link Granite.Widgets.SourceList.ExpandableItem.child_added} is fired after the item is added.
         *
         * While adding a child item, //the item it's being added to will set itself as the parent//.
         * Please note that items are required to have their //parent// property set to //null// before
         * being added, so make sure the item is removed from its previous parent before attempting
         * to add it to another item. For instance:
         * {{{
         * if (item.parent != null)
         *     item.parent.remove (item); // this will set item's parent to null
         * new_parent.add (item);
         * }}}
         *
         * @param item The item to add. Its parent __must__ be //null//.
         * @see Granite.Widgets.SourceList.ExpandableItem.child_added
         * @see Granite.Widgets.SourceList.ExpandableItem.remove
         * @since 0.2
         */
void
granite_widgets_source_list_expandable_item_add (GraniteWidgetsSourceListExpandableItem* self,
                                                 GraniteWidgetsSourceListItem* item)
{
	GraniteWidgetsSourceListExpandableItem* _tmp0_;
	GraniteWidgetsSourceListExpandableItem* _tmp1_;
	GeeCollection* _tmp2_;
#line 599 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 599 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (item != NULL);
#line 599 "../lib/Widgets/SourceList.vala"
	_tmp0_ = granite_widgets_source_list_item_get_parent (item);
#line 599 "../lib/Widgets/SourceList.vala"
	_tmp1_ = _tmp0_;
#line 599 "../lib/Widgets/SourceList.vala"
	_vala_return_if_fail (_tmp1_ == NULL, "item.parent == null");
#line 600 "../lib/Widgets/SourceList.vala"
	granite_widgets_source_list_item_set_parent (item, self);
#line 601 "../lib/Widgets/SourceList.vala"
	_tmp2_ = self->priv->children_list;
#line 601 "../lib/Widgets/SourceList.vala"
	gee_collection_add (_tmp2_, item);
#line 602 "../lib/Widgets/SourceList.vala"
	g_signal_emit (self, granite_widgets_source_list_expandable_item_signals[GRANITE_WIDGETS_SOURCE_LIST_EXPANDABLE_ITEM_CHILD_ADDED_SIGNAL], 0, item);
#line 3389 "SourceList.c"
}


/**
         * Removes an item.
         *
         * The {@link Granite.Widgets.SourceList.ExpandableItem.child_removed} signal is fired
         * //after removing the item//. Finally (i.e. after all the handlers have been invoked),
         * the item's {@link Granite.Widgets.SourceList.Item.parent} property is set to //null//.
         * This has the advantage of letting signal handlers know the parent from which //item//
         * is being removed.
         *
         * @param item The item to remove. This will fail if item has a different parent.
         * @see Granite.Widgets.SourceList.ExpandableItem.child_removed
         * @see Granite.Widgets.SourceList.ExpandableItem.clear
         * @since 0.2
         */
void
granite_widgets_source_list_expandable_item_remove (GraniteWidgetsSourceListExpandableItem* self,
                                                    GraniteWidgetsSourceListItem* item)
{
	GraniteWidgetsSourceListExpandableItem* _tmp0_;
	GraniteWidgetsSourceListExpandableItem* _tmp1_;
	GeeCollection* _tmp2_;
#line 619 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 619 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (item != NULL);
#line 619 "../lib/Widgets/SourceList.vala"
	_tmp0_ = granite_widgets_source_list_item_get_parent (item);
#line 619 "../lib/Widgets/SourceList.vala"
	_tmp1_ = _tmp0_;
#line 619 "../lib/Widgets/SourceList.vala"
	_vala_return_if_fail (_tmp1_ == self, "item.parent == this");
#line 620 "../lib/Widgets/SourceList.vala"
	_tmp2_ = self->priv->children_list;
#line 620 "../lib/Widgets/SourceList.vala"
	gee_collection_remove (_tmp2_, item);
#line 621 "../lib/Widgets/SourceList.vala"
	g_signal_emit (self, granite_widgets_source_list_expandable_item_signals[GRANITE_WIDGETS_SOURCE_LIST_EXPANDABLE_ITEM_CHILD_REMOVED_SIGNAL], 0, item);
#line 622 "../lib/Widgets/SourceList.vala"
	granite_widgets_source_list_item_set_parent (item, NULL);
#line 3432 "SourceList.c"
}


/**
         * Removes all the items contained by the item. It works similarly to
         * {@link Granite.Widgets.SourceList.ExpandableItem.remove}.
         *
         * @see Granite.Widgets.SourceList.ExpandableItem.remove
         * @see Granite.Widgets.SourceList.ExpandableItem.child_removed
         * @since 0.2
         */
void
granite_widgets_source_list_expandable_item_clear (GraniteWidgetsSourceListExpandableItem* self)
{
#line 633 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 3449 "SourceList.c"
	{
		GeeIterator* _item_it = NULL;
		GeeCollection* _tmp0_;
		GeeCollection* _tmp1_;
		GeeCollection* _tmp2_;
		GeeIterator* _tmp3_;
		GeeIterator* _tmp4_;
#line 634 "../lib/Widgets/SourceList.vala"
		_tmp0_ = granite_widgets_source_list_expandable_item_get_children (self);
#line 634 "../lib/Widgets/SourceList.vala"
		_tmp1_ = _tmp0_;
#line 634 "../lib/Widgets/SourceList.vala"
		_tmp2_ = _tmp1_;
#line 634 "../lib/Widgets/SourceList.vala"
		_tmp3_ = gee_iterable_iterator ((GeeIterable*) _tmp2_);
#line 634 "../lib/Widgets/SourceList.vala"
		_tmp4_ = _tmp3_;
#line 634 "../lib/Widgets/SourceList.vala"
		_g_object_unref0 (_tmp2_);
#line 634 "../lib/Widgets/SourceList.vala"
		_item_it = _tmp4_;
#line 634 "../lib/Widgets/SourceList.vala"
		while (TRUE) {
#line 3473 "SourceList.c"
			GeeIterator* _tmp5_;
			GraniteWidgetsSourceListItem* item = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			GraniteWidgetsSourceListItem* _tmp8_;
#line 634 "../lib/Widgets/SourceList.vala"
			_tmp5_ = _item_it;
#line 634 "../lib/Widgets/SourceList.vala"
			if (!gee_iterator_next (_tmp5_)) {
#line 634 "../lib/Widgets/SourceList.vala"
				break;
#line 3485 "SourceList.c"
			}
#line 634 "../lib/Widgets/SourceList.vala"
			_tmp6_ = _item_it;
#line 634 "../lib/Widgets/SourceList.vala"
			_tmp7_ = gee_iterator_get (_tmp6_);
#line 634 "../lib/Widgets/SourceList.vala"
			item = (GraniteWidgetsSourceListItem*) _tmp7_;
#line 635 "../lib/Widgets/SourceList.vala"
			_tmp8_ = item;
#line 635 "../lib/Widgets/SourceList.vala"
			granite_widgets_source_list_expandable_item_remove (self, _tmp8_);
#line 634 "../lib/Widgets/SourceList.vala"
			_g_object_unref0 (item);
#line 3499 "SourceList.c"
		}
#line 634 "../lib/Widgets/SourceList.vala"
		_g_object_unref0 (_item_it);
#line 3503 "SourceList.c"
	}
}


/**
         * Expands the item and/or its children.
         *
         * @param inclusive Whether to also expand this item (true), or only its children (false).
         * @param recursive Whether to recursively expand all the children (true), or only
         * immediate children (false).
         * @see Granite.Widgets.SourceList.ExpandableItem.expanded
         * @since 0.2
         */
void
granite_widgets_source_list_expandable_item_expand_all (GraniteWidgetsSourceListExpandableItem* self,
                                                        gboolean inclusive,
                                                        gboolean recursive)
{
#line 647 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 648 "../lib/Widgets/SourceList.vala"
	granite_widgets_source_list_expandable_item_set_expansion (self, inclusive, recursive, TRUE);
#line 3526 "SourceList.c"
}


/**
         * Collapses the item and/or its children.
         *
         * @param inclusive Whether to also collapse this item (true), or only its children (false).
         * @param recursive Whether to recursively collapse all the children (true), or only
         * immediate children (false).
         * @see Granite.Widgets.SourceList.ExpandableItem.expanded
         * @since 0.2
         */
void
granite_widgets_source_list_expandable_item_collapse_all (GraniteWidgetsSourceListExpandableItem* self,
                                                          gboolean inclusive,
                                                          gboolean recursive)
{
#line 660 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 661 "../lib/Widgets/SourceList.vala"
	granite_widgets_source_list_expandable_item_set_expansion (self, inclusive, recursive, FALSE);
#line 3548 "SourceList.c"
}


static void
granite_widgets_source_list_expandable_item_set_expansion (GraniteWidgetsSourceListExpandableItem* item,
                                                           gboolean inclusive,
                                                           gboolean recursive,
                                                           gboolean expanded)
{
#line 664 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (item != NULL);
#line 665 "../lib/Widgets/SourceList.vala"
	if (inclusive) {
#line 666 "../lib/Widgets/SourceList.vala"
		granite_widgets_source_list_expandable_item_set_expanded (item, expanded);
#line 3564 "SourceList.c"
	}
	{
		GeeIterator* _child_item_it = NULL;
		GeeCollection* _tmp0_;
		GeeCollection* _tmp1_;
		GeeCollection* _tmp2_;
		GeeIterator* _tmp3_;
		GeeIterator* _tmp4_;
#line 668 "../lib/Widgets/SourceList.vala"
		_tmp0_ = granite_widgets_source_list_expandable_item_get_children (item);
#line 668 "../lib/Widgets/SourceList.vala"
		_tmp1_ = _tmp0_;
#line 668 "../lib/Widgets/SourceList.vala"
		_tmp2_ = _tmp1_;
#line 668 "../lib/Widgets/SourceList.vala"
		_tmp3_ = gee_iterable_iterator ((GeeIterable*) _tmp2_);
#line 668 "../lib/Widgets/SourceList.vala"
		_tmp4_ = _tmp3_;
#line 668 "../lib/Widgets/SourceList.vala"
		_g_object_unref0 (_tmp2_);
#line 668 "../lib/Widgets/SourceList.vala"
		_child_item_it = _tmp4_;
#line 668 "../lib/Widgets/SourceList.vala"
		while (TRUE) {
#line 3589 "SourceList.c"
			GeeIterator* _tmp5_;
			GraniteWidgetsSourceListItem* child_item = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			GraniteWidgetsSourceListExpandableItem* child_expandable_item = NULL;
			GraniteWidgetsSourceListItem* _tmp8_;
			GraniteWidgetsSourceListExpandableItem* _tmp9_;
			GraniteWidgetsSourceListExpandableItem* _tmp10_;
#line 668 "../lib/Widgets/SourceList.vala"
			_tmp5_ = _child_item_it;
#line 668 "../lib/Widgets/SourceList.vala"
			if (!gee_iterator_next (_tmp5_)) {
#line 668 "../lib/Widgets/SourceList.vala"
				break;
#line 3604 "SourceList.c"
			}
#line 668 "../lib/Widgets/SourceList.vala"
			_tmp6_ = _child_item_it;
#line 668 "../lib/Widgets/SourceList.vala"
			_tmp7_ = gee_iterator_get (_tmp6_);
#line 668 "../lib/Widgets/SourceList.vala"
			child_item = (GraniteWidgetsSourceListItem*) _tmp7_;
#line 669 "../lib/Widgets/SourceList.vala"
			_tmp8_ = child_item;
#line 669 "../lib/Widgets/SourceList.vala"
			_tmp9_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp8_, GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM) ? ((GraniteWidgetsSourceListExpandableItem*) _tmp8_) : NULL);
#line 669 "../lib/Widgets/SourceList.vala"
			child_expandable_item = _tmp9_;
#line 670 "../lib/Widgets/SourceList.vala"
			_tmp10_ = child_expandable_item;
#line 670 "../lib/Widgets/SourceList.vala"
			if (_tmp10_ != NULL) {
#line 671 "../lib/Widgets/SourceList.vala"
				if (recursive) {
#line 3624 "SourceList.c"
					GraniteWidgetsSourceListExpandableItem* _tmp11_;
#line 672 "../lib/Widgets/SourceList.vala"
					_tmp11_ = child_expandable_item;
#line 672 "../lib/Widgets/SourceList.vala"
					granite_widgets_source_list_expandable_item_set_expansion (_tmp11_, TRUE, TRUE, expanded);
#line 3630 "SourceList.c"
				} else {
					GraniteWidgetsSourceListExpandableItem* _tmp12_;
#line 674 "../lib/Widgets/SourceList.vala"
					_tmp12_ = child_expandable_item;
#line 674 "../lib/Widgets/SourceList.vala"
					granite_widgets_source_list_expandable_item_set_expanded (_tmp12_, expanded);
#line 3637 "SourceList.c"
				}
			}
#line 668 "../lib/Widgets/SourceList.vala"
			_g_object_unref0 (child_expandable_item);
#line 668 "../lib/Widgets/SourceList.vala"
			_g_object_unref0 (child_item);
#line 3644 "SourceList.c"
		}
#line 668 "../lib/Widgets/SourceList.vala"
		_g_object_unref0 (_child_item_it);
#line 3648 "SourceList.c"
	}
}


/**
         * Recursively expands the item along with its parent(s).
         *
         * @see Granite.Widgets.SourceList.ExpandableItem.expanded
         * @since 0.2
         */
void
granite_widgets_source_list_expandable_item_expand_with_parents (GraniteWidgetsSourceListExpandableItem* self)
{
	GraniteWidgetsSourceListExpandableItem* _tmp0_;
	GraniteWidgetsSourceListExpandableItem* _tmp1_;
#line 685 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 690 "../lib/Widgets/SourceList.vala"
	_tmp0_ = granite_widgets_source_list_item_get_parent ((GraniteWidgetsSourceListItem*) self);
#line 690 "../lib/Widgets/SourceList.vala"
	_tmp1_ = _tmp0_;
#line 690 "../lib/Widgets/SourceList.vala"
	if (_tmp1_ != NULL) {
#line 3672 "SourceList.c"
		GraniteWidgetsSourceListExpandableItem* _tmp2_;
		GraniteWidgetsSourceListExpandableItem* _tmp3_;
#line 691 "../lib/Widgets/SourceList.vala"
		_tmp2_ = granite_widgets_source_list_item_get_parent ((GraniteWidgetsSourceListItem*) self);
#line 691 "../lib/Widgets/SourceList.vala"
		_tmp3_ = _tmp2_;
#line 691 "../lib/Widgets/SourceList.vala"
		granite_widgets_source_list_expandable_item_expand_with_parents (_tmp3_);
#line 3681 "SourceList.c"
	}
#line 692 "../lib/Widgets/SourceList.vala"
	granite_widgets_source_list_expandable_item_set_expanded (self, TRUE);
#line 3685 "SourceList.c"
}


/**
         * Recursively collapses the item along with its parent(s).
         *
         * @see Granite.Widgets.SourceList.ExpandableItem.expanded
         * @since 0.2
         */
void
granite_widgets_source_list_expandable_item_collapse_with_parents (GraniteWidgetsSourceListExpandableItem* self)
{
	GraniteWidgetsSourceListExpandableItem* _tmp0_;
	GraniteWidgetsSourceListExpandableItem* _tmp1_;
#line 701 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 702 "../lib/Widgets/SourceList.vala"
	_tmp0_ = granite_widgets_source_list_item_get_parent ((GraniteWidgetsSourceListItem*) self);
#line 702 "../lib/Widgets/SourceList.vala"
	_tmp1_ = _tmp0_;
#line 702 "../lib/Widgets/SourceList.vala"
	if (_tmp1_ != NULL) {
#line 3708 "SourceList.c"
		GraniteWidgetsSourceListExpandableItem* _tmp2_;
		GraniteWidgetsSourceListExpandableItem* _tmp3_;
#line 703 "../lib/Widgets/SourceList.vala"
		_tmp2_ = granite_widgets_source_list_item_get_parent ((GraniteWidgetsSourceListItem*) self);
#line 703 "../lib/Widgets/SourceList.vala"
		_tmp3_ = _tmp2_;
#line 703 "../lib/Widgets/SourceList.vala"
		granite_widgets_source_list_expandable_item_collapse_with_parents (_tmp3_);
#line 3717 "SourceList.c"
	}
#line 704 "../lib/Widgets/SourceList.vala"
	granite_widgets_source_list_expandable_item_set_expanded (self, FALSE);
#line 3721 "SourceList.c"
}


gboolean
granite_widgets_source_list_expandable_item_get_collapsible (GraniteWidgetsSourceListExpandableItem* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 488 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 488 "../lib/Widgets/SourceList.vala"
	_tmp0_ = self->priv->_collapsible;
#line 488 "../lib/Widgets/SourceList.vala"
	result = _tmp0_;
#line 488 "../lib/Widgets/SourceList.vala"
	return result;
#line 3738 "SourceList.c"
}


void
granite_widgets_source_list_expandable_item_set_collapsible (GraniteWidgetsSourceListExpandableItem* self,
                                                             gboolean value)
{
#line 488 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 488 "../lib/Widgets/SourceList.vala"
	if (granite_widgets_source_list_expandable_item_get_collapsible (self) != value) {
#line 488 "../lib/Widgets/SourceList.vala"
		self->priv->_collapsible = value;
#line 488 "../lib/Widgets/SourceList.vala"
		g_object_notify_by_pspec ((GObject *) self, granite_widgets_source_list_expandable_item_properties[GRANITE_WIDGETS_SOURCE_LIST_EXPANDABLE_ITEM_COLLAPSIBLE_PROPERTY]);
#line 3754 "SourceList.c"
	}
}


gboolean
granite_widgets_source_list_expandable_item_get_expanded (GraniteWidgetsSourceListExpandableItem* self)
{
	gboolean result;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
#line 512 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 512 "../lib/Widgets/SourceList.vala"
	_tmp1_ = self->priv->_expanded;
#line 512 "../lib/Widgets/SourceList.vala"
	if (_tmp1_) {
#line 512 "../lib/Widgets/SourceList.vala"
		_tmp0_ = TRUE;
#line 3773 "SourceList.c"
	} else {
		gboolean _tmp2_;
#line 512 "../lib/Widgets/SourceList.vala"
		_tmp2_ = self->priv->_collapsible;
#line 512 "../lib/Widgets/SourceList.vala"
		_tmp0_ = !_tmp2_;
#line 3780 "SourceList.c"
	}
#line 512 "../lib/Widgets/SourceList.vala"
	result = _tmp0_;
#line 512 "../lib/Widgets/SourceList.vala"
	return result;
#line 3786 "SourceList.c"
}


void
granite_widgets_source_list_expandable_item_set_expanded (GraniteWidgetsSourceListExpandableItem* self,
                                                          gboolean value)
{
	gboolean _tmp0_;
#line 513 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 514 "../lib/Widgets/SourceList.vala"
	_tmp0_ = self->priv->_expanded;
#line 514 "../lib/Widgets/SourceList.vala"
	if (value != _tmp0_) {
#line 515 "../lib/Widgets/SourceList.vala"
		self->priv->_expanded = value;
#line 516 "../lib/Widgets/SourceList.vala"
		g_signal_emit (self, granite_widgets_source_list_expandable_item_signals[GRANITE_WIDGETS_SOURCE_LIST_EXPANDABLE_ITEM_TOGGLED_SIGNAL], 0);
#line 3805 "SourceList.c"
	}
#line 513 "../lib/Widgets/SourceList.vala"
	g_object_notify_by_pspec ((GObject *) self, granite_widgets_source_list_expandable_item_properties[GRANITE_WIDGETS_SOURCE_LIST_EXPANDABLE_ITEM_EXPANDED_PROPERTY]);
#line 3809 "SourceList.c"
}


guint
granite_widgets_source_list_expandable_item_get_n_children (GraniteWidgetsSourceListExpandableItem* self)
{
	guint result;
	GeeCollection* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 527 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 527 "../lib/Widgets/SourceList.vala"
	_tmp0_ = self->priv->children_list;
#line 527 "../lib/Widgets/SourceList.vala"
	_tmp1_ = gee_collection_get_size (_tmp0_);
#line 527 "../lib/Widgets/SourceList.vala"
	_tmp2_ = _tmp1_;
#line 527 "../lib/Widgets/SourceList.vala"
	result = (guint) _tmp2_;
#line 527 "../lib/Widgets/SourceList.vala"
	return result;
#line 3832 "SourceList.c"
}


GeeCollection*
granite_widgets_source_list_expandable_item_get_children (GraniteWidgetsSourceListExpandableItem* self)
{
	GeeCollection* result;
	GeeArrayList* children_list_copy = NULL;
	GeeArrayList* _tmp0_;
	GeeCollection* _tmp1_;
#line 540 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 543 "../lib/Widgets/SourceList.vala"
	_tmp0_ = gee_array_list_new (GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 543 "../lib/Widgets/SourceList.vala"
	children_list_copy = _tmp0_;
#line 544 "../lib/Widgets/SourceList.vala"
	_tmp1_ = self->priv->children_list;
#line 544 "../lib/Widgets/SourceList.vala"
	gee_array_list_add_all (children_list_copy, _tmp1_);
#line 545 "../lib/Widgets/SourceList.vala"
	result = (GeeCollection*) children_list_copy;
#line 545 "../lib/Widgets/SourceList.vala"
	return result;
#line 3857 "SourceList.c"
}


static void
granite_widgets_source_list_expandable_item_real_toggled (GraniteWidgetsSourceListExpandableItem* self)
{
}


static GObject *
granite_widgets_source_list_expandable_item_constructor (GType type,
                                                         guint n_construct_properties,
                                                         GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GraniteWidgetsSourceListExpandableItem * self;
#line 562 "../lib/Widgets/SourceList.vala"
	parent_class = G_OBJECT_CLASS (granite_widgets_source_list_expandable_item_parent_class);
#line 562 "../lib/Widgets/SourceList.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 562 "../lib/Widgets/SourceList.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM, GraniteWidgetsSourceListExpandableItem);
#line 563 "../lib/Widgets/SourceList.vala"
	granite_widgets_source_list_item_set_editable ((GraniteWidgetsSourceListItem*) self, FALSE);
#line 562 "../lib/Widgets/SourceList.vala"
	return obj;
#line 3885 "SourceList.c"
}


static void
granite_widgets_source_list_expandable_item_class_init (GraniteWidgetsSourceListExpandableItemClass * klass)
{
#line 451 "../lib/Widgets/SourceList.vala"
	granite_widgets_source_list_expandable_item_parent_class = g_type_class_peek_parent (klass);
#line 451 "../lib/Widgets/SourceList.vala"
	g_type_class_adjust_private_offset (klass, &GraniteWidgetsSourceListExpandableItem_private_offset);
#line 451 "../lib/Widgets/SourceList.vala"
	((GraniteWidgetsSourceListExpandableItemClass *) klass)->toggled = granite_widgets_source_list_expandable_item_real_toggled;
#line 451 "../lib/Widgets/SourceList.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_granite_widgets_source_list_expandable_item_get_property;
#line 451 "../lib/Widgets/SourceList.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_granite_widgets_source_list_expandable_item_set_property;
#line 451 "../lib/Widgets/SourceList.vala"
	G_OBJECT_CLASS (klass)->constructor = granite_widgets_source_list_expandable_item_constructor;
#line 451 "../lib/Widgets/SourceList.vala"
	G_OBJECT_CLASS (klass)->finalize = granite_widgets_source_list_expandable_item_finalize;
#line 3906 "SourceList.c"
	/**
	         * Whether the item is collapsible or not.
	         *
	         * When set to //false//, the item is //always// expanded and the expander is
	         * not shown. Please note that this will also affect the value returned by the
	         * {@link Granite.Widgets.SourceList.ExpandableItem.expanded} property.
	         *
	         * @see Granite.Widgets.SourceList.ExpandableItem.expanded
	         * @since 0.2
	         */
#line 451 "../lib/Widgets/SourceList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_EXPANDABLE_ITEM_COLLAPSIBLE_PROPERTY, granite_widgets_source_list_expandable_item_properties[GRANITE_WIDGETS_SOURCE_LIST_EXPANDABLE_ITEM_COLLAPSIBLE_PROPERTY] = g_param_spec_boolean ("collapsible", "collapsible", "collapsible", TRUE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 451 "../lib/Widgets/SourceList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_EXPANDABLE_ITEM_EXPANDED_PROPERTY, granite_widgets_source_list_expandable_item_properties[GRANITE_WIDGETS_SOURCE_LIST_EXPANDABLE_ITEM_EXPANDED_PROPERTY] = g_param_spec_boolean ("expanded", "expanded", "expanded", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 3921 "SourceList.c"
	/**
	         * Number of children contained by the item.
	         *
	         * @since 0.2
	         */
#line 451 "../lib/Widgets/SourceList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_EXPANDABLE_ITEM_N_CHILDREN_PROPERTY, granite_widgets_source_list_expandable_item_properties[GRANITE_WIDGETS_SOURCE_LIST_EXPANDABLE_ITEM_N_CHILDREN_PROPERTY] = g_param_spec_uint ("n-children", "n-children", "n-children", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 3929 "SourceList.c"
	/**
	         * The item's children.
	         *
	         * This returns a newly-created list containing the children.
	         * It's safe to iterate it while removing items with
	         * {@link Granite.Widgets.SourceList.ExpandableItem.remove}
	         *
	         * @since 0.2
	         */
#line 451 "../lib/Widgets/SourceList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_EXPANDABLE_ITEM_CHILDREN_PROPERTY, granite_widgets_source_list_expandable_item_properties[GRANITE_WIDGETS_SOURCE_LIST_EXPANDABLE_ITEM_CHILDREN_PROPERTY] = g_param_spec_object ("children", "children", "children", GEE_TYPE_COLLECTION, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 3941 "SourceList.c"
	/**
	         * Emitted when an item is added.
	         *
	         * @param item Item added.
	         * @see Granite.Widgets.SourceList.ExpandableItem.add
	         * @since 0.2
	         */
#line 451 "../lib/Widgets/SourceList.vala"
	granite_widgets_source_list_expandable_item_signals[GRANITE_WIDGETS_SOURCE_LIST_EXPANDABLE_ITEM_CHILD_ADDED_SIGNAL] = g_signal_new ("child-added", GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM);
#line 3951 "SourceList.c"
	/**
	         * Emitted when an item is removed.
	         *
	         * @param item Item removed.
	         * @see Granite.Widgets.SourceList.ExpandableItem.remove
	         * @since 0.2
	         */
#line 451 "../lib/Widgets/SourceList.vala"
	granite_widgets_source_list_expandable_item_signals[GRANITE_WIDGETS_SOURCE_LIST_EXPANDABLE_ITEM_CHILD_REMOVED_SIGNAL] = g_signal_new ("child-removed", GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM);
#line 3961 "SourceList.c"
	/**
	         * Emitted when the item is expanded or collapsed.
	         *
	         * @since 0.2
	         */
#line 451 "../lib/Widgets/SourceList.vala"
	granite_widgets_source_list_expandable_item_signals[GRANITE_WIDGETS_SOURCE_LIST_EXPANDABLE_ITEM_TOGGLED_SIGNAL] = g_signal_new ("toggled", GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (GraniteWidgetsSourceListExpandableItemClass, toggled), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 3969 "SourceList.c"
}


static void
granite_widgets_source_list_expandable_item_instance_init (GraniteWidgetsSourceListExpandableItem * self)
{
	GeeArrayList* _tmp0_;
#line 451 "../lib/Widgets/SourceList.vala"
	self->priv = granite_widgets_source_list_expandable_item_get_instance_private (self);
#line 488 "../lib/Widgets/SourceList.vala"
	self->priv->_collapsible = TRUE;
#line 510 "../lib/Widgets/SourceList.vala"
	self->priv->_expanded = FALSE;
#line 549 "../lib/Widgets/SourceList.vala"
	_tmp0_ = gee_array_list_new (GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 549 "../lib/Widgets/SourceList.vala"
	self->priv->children_list = (GeeCollection*) _tmp0_;
#line 3987 "SourceList.c"
}


static void
granite_widgets_source_list_expandable_item_finalize (GObject * obj)
{
	GraniteWidgetsSourceListExpandableItem * self;
#line 451 "../lib/Widgets/SourceList.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM, GraniteWidgetsSourceListExpandableItem);
#line 549 "../lib/Widgets/SourceList.vala"
	_g_object_unref0 (self->priv->children_list);
#line 451 "../lib/Widgets/SourceList.vala"
	G_OBJECT_CLASS (granite_widgets_source_list_expandable_item_parent_class)->finalize (obj);
#line 4001 "SourceList.c"
}


/**
     * An item that can contain more items.
     *
     * It supports all the properties inherited from {@link Granite.Widgets.SourceList.Item},
     * and behaves like a normal item, except when it is located at the root level; in that case,
     * the following properties are ignored by the widget:
     *
     * * {@link Granite.Widgets.SourceList.Item.selectable}
     * * {@link Granite.Widgets.SourceList.Item.editable}
     * * {@link Granite.Widgets.SourceList.Item.icon}
     * * {@link Granite.Widgets.SourceList.Item.activatable}
     * * {@link Granite.Widgets.SourceList.Item.badge}
     *
     * Root-level expandable items (i.e. Main Categories) are ''not'' displayed when they contain
     * zero visible children.
     *
     * @since 0.2
     */
GType
granite_widgets_source_list_expandable_item_get_type (void)
{
	static volatile gsize granite_widgets_source_list_expandable_item_type_id__volatile = 0;
	if (g_once_init_enter (&granite_widgets_source_list_expandable_item_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GraniteWidgetsSourceListExpandableItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) granite_widgets_source_list_expandable_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GraniteWidgetsSourceListExpandableItem), 0, (GInstanceInitFunc) granite_widgets_source_list_expandable_item_instance_init, NULL };
		GType granite_widgets_source_list_expandable_item_type_id;
		granite_widgets_source_list_expandable_item_type_id = g_type_register_static (GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM, "GraniteWidgetsSourceListExpandableItem", &g_define_type_info, 0);
		GraniteWidgetsSourceListExpandableItem_private_offset = g_type_add_instance_private (granite_widgets_source_list_expandable_item_type_id, sizeof (GraniteWidgetsSourceListExpandableItemPrivate));
		g_once_init_leave (&granite_widgets_source_list_expandable_item_type_id__volatile, granite_widgets_source_list_expandable_item_type_id);
	}
	return granite_widgets_source_list_expandable_item_type_id__volatile;
}


static void
_vala_granite_widgets_source_list_expandable_item_get_property (GObject * object,
                                                                guint property_id,
                                                                GValue * value,
                                                                GParamSpec * pspec)
{
	GraniteWidgetsSourceListExpandableItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM, GraniteWidgetsSourceListExpandableItem);
#line 451 "../lib/Widgets/SourceList.vala"
	switch (property_id) {
#line 451 "../lib/Widgets/SourceList.vala"
		case GRANITE_WIDGETS_SOURCE_LIST_EXPANDABLE_ITEM_COLLAPSIBLE_PROPERTY:
#line 451 "../lib/Widgets/SourceList.vala"
		g_value_set_boolean (value, granite_widgets_source_list_expandable_item_get_collapsible (self));
#line 451 "../lib/Widgets/SourceList.vala"
		break;
#line 451 "../lib/Widgets/SourceList.vala"
		case GRANITE_WIDGETS_SOURCE_LIST_EXPANDABLE_ITEM_EXPANDED_PROPERTY:
#line 451 "../lib/Widgets/SourceList.vala"
		g_value_set_boolean (value, granite_widgets_source_list_expandable_item_get_expanded (self));
#line 451 "../lib/Widgets/SourceList.vala"
		break;
#line 451 "../lib/Widgets/SourceList.vala"
		case GRANITE_WIDGETS_SOURCE_LIST_EXPANDABLE_ITEM_N_CHILDREN_PROPERTY:
#line 451 "../lib/Widgets/SourceList.vala"
		g_value_set_uint (value, granite_widgets_source_list_expandable_item_get_n_children (self));
#line 451 "../lib/Widgets/SourceList.vala"
		break;
#line 451 "../lib/Widgets/SourceList.vala"
		case GRANITE_WIDGETS_SOURCE_LIST_EXPANDABLE_ITEM_CHILDREN_PROPERTY:
#line 451 "../lib/Widgets/SourceList.vala"
		g_value_take_object (value, granite_widgets_source_list_expandable_item_get_children (self));
#line 451 "../lib/Widgets/SourceList.vala"
		break;
#line 4072 "SourceList.c"
		default:
#line 451 "../lib/Widgets/SourceList.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 451 "../lib/Widgets/SourceList.vala"
		break;
#line 4078 "SourceList.c"
	}
}


static void
_vala_granite_widgets_source_list_expandable_item_set_property (GObject * object,
                                                                guint property_id,
                                                                const GValue * value,
                                                                GParamSpec * pspec)
{
	GraniteWidgetsSourceListExpandableItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM, GraniteWidgetsSourceListExpandableItem);
#line 451 "../lib/Widgets/SourceList.vala"
	switch (property_id) {
#line 451 "../lib/Widgets/SourceList.vala"
		case GRANITE_WIDGETS_SOURCE_LIST_EXPANDABLE_ITEM_COLLAPSIBLE_PROPERTY:
#line 451 "../lib/Widgets/SourceList.vala"
		granite_widgets_source_list_expandable_item_set_collapsible (self, g_value_get_boolean (value));
#line 451 "../lib/Widgets/SourceList.vala"
		break;
#line 451 "../lib/Widgets/SourceList.vala"
		case GRANITE_WIDGETS_SOURCE_LIST_EXPANDABLE_ITEM_EXPANDED_PROPERTY:
#line 451 "../lib/Widgets/SourceList.vala"
		granite_widgets_source_list_expandable_item_set_expanded (self, g_value_get_boolean (value));
#line 451 "../lib/Widgets/SourceList.vala"
		break;
#line 4105 "SourceList.c"
		default:
#line 451 "../lib/Widgets/SourceList.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 451 "../lib/Widgets/SourceList.vala"
		break;
#line 4111 "SourceList.c"
	}
}


static inline gpointer
granite_widgets_source_list_data_model_get_instance_private (GraniteWidgetsSourceListDataModel* self)
{
	return G_STRUCT_MEMBER_P (self, GraniteWidgetsSourceListDataModel_private_offset);
}


static GType
granite_widgets_source_list_data_model_column_type (GraniteWidgetsSourceListDataModelColumn self)
{
	GType result = 0UL;
#line 800 "../lib/Widgets/SourceList.vala"
	switch (self) {
#line 800 "../lib/Widgets/SourceList.vala"
		case GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_COLUMN_ITEM:
#line 4131 "SourceList.c"
		{
#line 802 "../lib/Widgets/SourceList.vala"
			result = GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM;
#line 802 "../lib/Widgets/SourceList.vala"
			return result;
#line 4137 "SourceList.c"
		}
		default:
		{
#line 805 "../lib/Widgets/SourceList.vala"
			g_assert_not_reached ();
#line 4143 "SourceList.c"
		}
	}
}


static GType
granite_widgets_source_list_data_model_column_get_type (void)
{
	static volatile gsize granite_widgets_source_list_data_model_column_type_id__volatile = 0;
	if (g_once_init_enter (&granite_widgets_source_list_data_model_column_type_id__volatile)) {
		static const GEnumValue values[] = {{GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_COLUMN_ITEM, "GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_COLUMN_ITEM", "item"}, {GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_COLUMN_N_COLUMNS, "GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_COLUMN_N_COLUMNS", "n-columns"}, {0, NULL, NULL}};
		GType granite_widgets_source_list_data_model_column_type_id;
		granite_widgets_source_list_data_model_column_type_id = g_enum_register_static ("GraniteWidgetsSourceListDataModelColumn", values);
		g_once_init_leave (&granite_widgets_source_list_data_model_column_type_id__volatile, granite_widgets_source_list_data_model_column_type_id);
	}
	return granite_widgets_source_list_data_model_column_type_id__volatile;
}


static GraniteWidgetsSourceListDataModel*
granite_widgets_source_list_data_model_construct (GType object_type)
{
	GraniteWidgetsSourceListDataModel * self = NULL;
#line 852 "../lib/Widgets/SourceList.vala"
	self = (GraniteWidgetsSourceListDataModel*) g_object_new (object_type, NULL);
#line 852 "../lib/Widgets/SourceList.vala"
	return self;
#line 4171 "SourceList.c"
}


static GraniteWidgetsSourceListDataModel*
granite_widgets_source_list_data_model_new (void)
{
#line 852 "../lib/Widgets/SourceList.vala"
	return granite_widgets_source_list_data_model_construct (GRANITE_WIDGETS_SOURCE_LIST_TYPE_DATA_MODEL);
#line 4180 "SourceList.c"
}


static gboolean
granite_widgets_source_list_data_model_has_item (GraniteWidgetsSourceListDataModel* self,
                                                 GraniteWidgetsSourceListItem* item)
{
	gboolean result = FALSE;
	GeeHashMap* _tmp0_;
#line 867 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 867 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (item != NULL, FALSE);
#line 868 "../lib/Widgets/SourceList.vala"
	_tmp0_ = self->priv->items;
#line 868 "../lib/Widgets/SourceList.vala"
	result = gee_abstract_map_has_key ((GeeAbstractMap*) _tmp0_, item);
#line 868 "../lib/Widgets/SourceList.vala"
	return result;
#line 4200 "SourceList.c"
}


static void
granite_widgets_source_list_data_model_update_item (GraniteWidgetsSourceListDataModel* self,
                                                    GraniteWidgetsSourceListItem* item)
{
	GraniteWidgetsSourceListExpandableItem* _tmp0_;
	GraniteWidgetsSourceListExpandableItem* _tmp1_;
	GraniteWidgetsSourceListDataModelNodeWrapper* node_reference = NULL;
	GeeHashMap* _tmp2_;
	gpointer _tmp3_;
	GraniteWidgetsSourceListDataModelNodeWrapper* _tmp4_;
#line 871 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 871 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (item != NULL);
#line 871 "../lib/Widgets/SourceList.vala"
	_vala_return_if_fail (granite_widgets_source_list_data_model_has_item (self, item), "has_item (item)");
#line 872 "../lib/Widgets/SourceList.vala"
	_tmp0_ = granite_widgets_source_list_data_model_get_root (self);
#line 872 "../lib/Widgets/SourceList.vala"
	_tmp1_ = _tmp0_;
#line 872 "../lib/Widgets/SourceList.vala"
	_vala_assert (_tmp1_ != NULL, "root != null");
#line 877 "../lib/Widgets/SourceList.vala"
	_tmp2_ = self->priv->items;
#line 877 "../lib/Widgets/SourceList.vala"
	_tmp3_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp2_, item);
#line 877 "../lib/Widgets/SourceList.vala"
	node_reference = (GraniteWidgetsSourceListDataModelNodeWrapper*) _tmp3_;
#line 878 "../lib/Widgets/SourceList.vala"
	_tmp4_ = node_reference;
#line 878 "../lib/Widgets/SourceList.vala"
	if (_tmp4_ != NULL) {
#line 4236 "SourceList.c"
		GtkTreePath* path = NULL;
		GraniteWidgetsSourceListDataModelNodeWrapper* _tmp5_;
		GtkTreePath* _tmp6_;
		GtkTreePath* _tmp7_;
		GtkTreeIter* iter = NULL;
		GraniteWidgetsSourceListDataModelNodeWrapper* _tmp8_;
		GtkTreeIter* _tmp9_;
		GtkTreeIter* _tmp10_;
		gboolean _tmp11_ = FALSE;
		GtkTreePath* _tmp12_;
#line 879 "../lib/Widgets/SourceList.vala"
		_tmp5_ = node_reference;
#line 879 "../lib/Widgets/SourceList.vala"
		_tmp6_ = granite_widgets_source_list_data_model_node_wrapper_get_path (_tmp5_);
#line 879 "../lib/Widgets/SourceList.vala"
		_tmp7_ = _tmp6_;
#line 879 "../lib/Widgets/SourceList.vala"
		path = _tmp7_;
#line 880 "../lib/Widgets/SourceList.vala"
		_tmp8_ = node_reference;
#line 880 "../lib/Widgets/SourceList.vala"
		_tmp9_ = granite_widgets_source_list_data_model_node_wrapper_get_iter (_tmp8_);
#line 880 "../lib/Widgets/SourceList.vala"
		_tmp10_ = _tmp9_;
#line 880 "../lib/Widgets/SourceList.vala"
		iter = _tmp10_;
#line 881 "../lib/Widgets/SourceList.vala"
		_tmp12_ = path;
#line 881 "../lib/Widgets/SourceList.vala"
		if (_tmp12_ != NULL) {
#line 4267 "SourceList.c"
			GtkTreeIter* _tmp13_;
#line 881 "../lib/Widgets/SourceList.vala"
			_tmp13_ = iter;
#line 881 "../lib/Widgets/SourceList.vala"
			_tmp11_ = _tmp13_ != NULL;
#line 4273 "SourceList.c"
		} else {
#line 881 "../lib/Widgets/SourceList.vala"
			_tmp11_ = FALSE;
#line 4277 "SourceList.c"
		}
#line 881 "../lib/Widgets/SourceList.vala"
		if (_tmp11_) {
#line 4281 "SourceList.c"
			GtkTreeStore* _tmp14_;
			GtkTreePath* _tmp15_;
			GtkTreeIter* _tmp16_;
			GtkTreeIter _tmp17_;
#line 882 "../lib/Widgets/SourceList.vala"
			_tmp14_ = self->priv->child_tree;
#line 882 "../lib/Widgets/SourceList.vala"
			_tmp15_ = path;
#line 882 "../lib/Widgets/SourceList.vala"
			_tmp16_ = iter;
#line 882 "../lib/Widgets/SourceList.vala"
			_tmp17_ = *_tmp16_;
#line 882 "../lib/Widgets/SourceList.vala"
			gtk_tree_model_row_changed ((GtkTreeModel*) _tmp14_, _tmp15_, &_tmp17_);
#line 883 "../lib/Widgets/SourceList.vala"
			g_signal_emit (self, granite_widgets_source_list_data_model_signals[GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_ITEM_UPDATED_SIGNAL], 0, item);
#line 4298 "SourceList.c"
		}
#line 878 "../lib/Widgets/SourceList.vala"
		_g_free0 (iter);
#line 878 "../lib/Widgets/SourceList.vala"
		__vala_GtkTreePath_free0 (path);
#line 4304 "SourceList.c"
	}
#line 871 "../lib/Widgets/SourceList.vala"
	_granite_widgets_source_list_data_model_node_wrapper_unref0 (node_reference);
#line 4308 "SourceList.c"
}


static GtkTreeIter*
_gtk_tree_iter_dup (GtkTreeIter* self)
{
	GtkTreeIter* dup;
#line 907 "../lib/Widgets/SourceList.vala"
	dup = g_new0 (GtkTreeIter, 1);
#line 907 "../lib/Widgets/SourceList.vala"
	memcpy (dup, self, sizeof (GtkTreeIter));
#line 907 "../lib/Widgets/SourceList.vala"
	return dup;
#line 4322 "SourceList.c"
}


static gpointer
__gtk_tree_iter_dup0 (gpointer self)
{
#line 907 "../lib/Widgets/SourceList.vala"
	return self ? _gtk_tree_iter_dup (self) : NULL;
#line 4331 "SourceList.c"
}


static void
granite_widgets_source_list_data_model_add_item (GraniteWidgetsSourceListDataModel* self,
                                                 GraniteWidgetsSourceListItem* item)
{
	GraniteWidgetsSourceListExpandableItem* _tmp0_;
	GraniteWidgetsSourceListExpandableItem* _tmp1_;
	GtkTreeIter* parent_child_iter = NULL;
	GtkTreeIter* child_iter = NULL;
	GraniteWidgetsSourceListExpandableItem* parent = NULL;
	GraniteWidgetsSourceListExpandableItem* _tmp2_;
	GraniteWidgetsSourceListExpandableItem* _tmp3_;
	GraniteWidgetsSourceListExpandableItem* _tmp4_;
	gboolean _tmp5_ = FALSE;
	GraniteWidgetsSourceListExpandableItem* _tmp6_;
	GtkTreeStore* _tmp15_;
	GtkTreeIter* _tmp16_;
	GtkTreeIter _tmp17_ = {0};
	GtkTreeIter _tmp18_;
	GtkTreeIter* _tmp19_;
	GtkTreeStore* _tmp20_;
	GtkTreeIter* _tmp21_;
	GtkTreeIter _tmp22_;
	GeeHashMap* _tmp23_;
	GtkTreeStore* _tmp24_;
	GtkTreeIter* _tmp25_;
	GtkTreeIter _tmp26_;
	GraniteWidgetsSourceListDataModelNodeWrapper* _tmp27_;
	GraniteWidgetsSourceListDataModelNodeWrapper* _tmp28_;
	GraniteWidgetsSourceListExpandableItem* _tmp29_;
	GraniteWidgetsSourceListExpandableItem* expandable = NULL;
	GraniteWidgetsSourceListExpandableItem* _tmp30_;
	GraniteWidgetsSourceListExpandableItem* _tmp31_;
#line 888 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 888 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (item != NULL);
#line 888 "../lib/Widgets/SourceList.vala"
	_vala_return_if_fail (!granite_widgets_source_list_data_model_has_item (self, item), "!has_item (item)");
#line 889 "../lib/Widgets/SourceList.vala"
	_tmp0_ = granite_widgets_source_list_data_model_get_root (self);
#line 889 "../lib/Widgets/SourceList.vala"
	_tmp1_ = _tmp0_;
#line 889 "../lib/Widgets/SourceList.vala"
	_vala_assert (_tmp1_ != NULL, "root != null");
#line 892 "../lib/Widgets/SourceList.vala"
	parent_child_iter = NULL;
#line 893 "../lib/Widgets/SourceList.vala"
	_tmp2_ = granite_widgets_source_list_item_get_parent (item);
#line 893 "../lib/Widgets/SourceList.vala"
	_tmp3_ = _tmp2_;
#line 893 "../lib/Widgets/SourceList.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 893 "../lib/Widgets/SourceList.vala"
	parent = _tmp4_;
#line 895 "../lib/Widgets/SourceList.vala"
	_tmp6_ = parent;
#line 895 "../lib/Widgets/SourceList.vala"
	if (_tmp6_ != NULL) {
#line 4393 "SourceList.c"
		GraniteWidgetsSourceListExpandableItem* _tmp7_;
		GraniteWidgetsSourceListExpandableItem* _tmp8_;
		GraniteWidgetsSourceListExpandableItem* _tmp9_;
#line 895 "../lib/Widgets/SourceList.vala"
		_tmp7_ = parent;
#line 895 "../lib/Widgets/SourceList.vala"
		_tmp8_ = granite_widgets_source_list_data_model_get_root (self);
#line 895 "../lib/Widgets/SourceList.vala"
		_tmp9_ = _tmp8_;
#line 895 "../lib/Widgets/SourceList.vala"
		_tmp5_ = _tmp7_ != _tmp9_;
#line 4405 "SourceList.c"
	} else {
#line 895 "../lib/Widgets/SourceList.vala"
		_tmp5_ = FALSE;
#line 4409 "SourceList.c"
	}
#line 895 "../lib/Widgets/SourceList.vala"
	if (_tmp5_) {
#line 4413 "SourceList.c"
		GraniteWidgetsSourceListExpandableItem* _tmp10_;
		GraniteWidgetsSourceListExpandableItem* _tmp12_;
		GtkTreeIter* _tmp13_;
		GtkTreeIter* _tmp14_;
#line 897 "../lib/Widgets/SourceList.vala"
		_tmp10_ = parent;
#line 897 "../lib/Widgets/SourceList.vala"
		if (!granite_widgets_source_list_data_model_has_item (self, (GraniteWidgetsSourceListItem*) _tmp10_)) {
#line 4422 "SourceList.c"
			GraniteWidgetsSourceListExpandableItem* _tmp11_;
#line 898 "../lib/Widgets/SourceList.vala"
			_tmp11_ = parent;
#line 898 "../lib/Widgets/SourceList.vala"
			granite_widgets_source_list_data_model_add_item (self, (GraniteWidgetsSourceListItem*) _tmp11_);
#line 4428 "SourceList.c"
		}
#line 901 "../lib/Widgets/SourceList.vala"
		_tmp12_ = parent;
#line 901 "../lib/Widgets/SourceList.vala"
		_tmp13_ = granite_widgets_source_list_data_model_get_item_child_iter (self, (GraniteWidgetsSourceListItem*) _tmp12_);
#line 901 "../lib/Widgets/SourceList.vala"
		_g_free0 (parent_child_iter);
#line 901 "../lib/Widgets/SourceList.vala"
		parent_child_iter = _tmp13_;
#line 904 "../lib/Widgets/SourceList.vala"
		_tmp14_ = parent_child_iter;
#line 904 "../lib/Widgets/SourceList.vala"
		_vala_assert (_tmp14_ != NULL, "parent_child_iter != null");
#line 4442 "SourceList.c"
	}
#line 907 "../lib/Widgets/SourceList.vala"
	_tmp15_ = self->priv->child_tree;
#line 907 "../lib/Widgets/SourceList.vala"
	_tmp16_ = parent_child_iter;
#line 907 "../lib/Widgets/SourceList.vala"
	gtk_tree_store_append (_tmp15_, &_tmp17_, _tmp16_);
#line 907 "../lib/Widgets/SourceList.vala"
	_g_free0 (child_iter);
#line 907 "../lib/Widgets/SourceList.vala"
	_tmp18_ = _tmp17_;
#line 907 "../lib/Widgets/SourceList.vala"
	_tmp19_ = __gtk_tree_iter_dup0 (&_tmp18_);
#line 907 "../lib/Widgets/SourceList.vala"
	child_iter = _tmp19_;
#line 908 "../lib/Widgets/SourceList.vala"
	_tmp20_ = self->priv->child_tree;
#line 908 "../lib/Widgets/SourceList.vala"
	_tmp21_ = child_iter;
#line 908 "../lib/Widgets/SourceList.vala"
	_tmp22_ = *_tmp21_;
#line 908 "../lib/Widgets/SourceList.vala"
	gtk_tree_store_set (_tmp20_, &_tmp22_, GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_COLUMN_ITEM, item, -1, -1);
#line 910 "../lib/Widgets/SourceList.vala"
	_tmp23_ = self->priv->items;
#line 910 "../lib/Widgets/SourceList.vala"
	_tmp24_ = self->priv->child_tree;
#line 910 "../lib/Widgets/SourceList.vala"
	_tmp25_ = child_iter;
#line 910 "../lib/Widgets/SourceList.vala"
	_tmp26_ = *_tmp25_;
#line 910 "../lib/Widgets/SourceList.vala"
	_tmp27_ = granite_widgets_source_list_data_model_node_wrapper_new ((GtkTreeModel*) _tmp24_, &_tmp26_);
#line 910 "../lib/Widgets/SourceList.vala"
	_tmp28_ = _tmp27_;
#line 910 "../lib/Widgets/SourceList.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp23_, item, _tmp28_);
#line 910 "../lib/Widgets/SourceList.vala"
	_granite_widgets_source_list_data_model_node_wrapper_unref0 (_tmp28_);
#line 914 "../lib/Widgets/SourceList.vala"
	g_signal_emit (self, granite_widgets_source_list_data_model_signals[GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_ITEM_UPDATED_SIGNAL], 0, item);
#line 916 "../lib/Widgets/SourceList.vala"
	granite_widgets_source_list_data_model_add_property_monitor (self, item);
#line 918 "../lib/Widgets/SourceList.vala"
	_tmp29_ = parent;
#line 918 "../lib/Widgets/SourceList.vala"
	granite_widgets_source_list_data_model_push_parent_update (self, _tmp29_);
#line 921 "../lib/Widgets/SourceList.vala"
	_tmp30_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (item, GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM) ? ((GraniteWidgetsSourceListExpandableItem*) item) : NULL);
#line 921 "../lib/Widgets/SourceList.vala"
	expandable = _tmp30_;
#line 922 "../lib/Widgets/SourceList.vala"
	_tmp31_ = expandable;
#line 922 "../lib/Widgets/SourceList.vala"
	if (_tmp31_ != NULL) {
#line 4498 "SourceList.c"
		GraniteWidgetsSourceListExpandableItem* _tmp42_;
		{
			GeeIterator* _child_item_it = NULL;
			GraniteWidgetsSourceListExpandableItem* _tmp32_;
			GeeCollection* _tmp33_;
			GeeCollection* _tmp34_;
			GeeCollection* _tmp35_;
			GeeIterator* _tmp36_;
			GeeIterator* _tmp37_;
#line 923 "../lib/Widgets/SourceList.vala"
			_tmp32_ = expandable;
#line 923 "../lib/Widgets/SourceList.vala"
			_tmp33_ = granite_widgets_source_list_expandable_item_get_children (_tmp32_);
#line 923 "../lib/Widgets/SourceList.vala"
			_tmp34_ = _tmp33_;
#line 923 "../lib/Widgets/SourceList.vala"
			_tmp35_ = _tmp34_;
#line 923 "../lib/Widgets/SourceList.vala"
			_tmp36_ = gee_iterable_iterator ((GeeIterable*) _tmp35_);
#line 923 "../lib/Widgets/SourceList.vala"
			_tmp37_ = _tmp36_;
#line 923 "../lib/Widgets/SourceList.vala"
			_g_object_unref0 (_tmp35_);
#line 923 "../lib/Widgets/SourceList.vala"
			_child_item_it = _tmp37_;
#line 923 "../lib/Widgets/SourceList.vala"
			while (TRUE) {
#line 4526 "SourceList.c"
				GeeIterator* _tmp38_;
				GraniteWidgetsSourceListItem* child_item = NULL;
				GeeIterator* _tmp39_;
				gpointer _tmp40_;
				GraniteWidgetsSourceListItem* _tmp41_;
#line 923 "../lib/Widgets/SourceList.vala"
				_tmp38_ = _child_item_it;
#line 923 "../lib/Widgets/SourceList.vala"
				if (!gee_iterator_next (_tmp38_)) {
#line 923 "../lib/Widgets/SourceList.vala"
					break;
#line 4538 "SourceList.c"
				}
#line 923 "../lib/Widgets/SourceList.vala"
				_tmp39_ = _child_item_it;
#line 923 "../lib/Widgets/SourceList.vala"
				_tmp40_ = gee_iterator_get (_tmp39_);
#line 923 "../lib/Widgets/SourceList.vala"
				child_item = (GraniteWidgetsSourceListItem*) _tmp40_;
#line 924 "../lib/Widgets/SourceList.vala"
				_tmp41_ = child_item;
#line 924 "../lib/Widgets/SourceList.vala"
				granite_widgets_source_list_data_model_add_item (self, _tmp41_);
#line 923 "../lib/Widgets/SourceList.vala"
				_g_object_unref0 (child_item);
#line 4552 "SourceList.c"
			}
#line 923 "../lib/Widgets/SourceList.vala"
			_g_object_unref0 (_child_item_it);
#line 4556 "SourceList.c"
		}
#line 927 "../lib/Widgets/SourceList.vala"
		_tmp42_ = expandable;
#line 927 "../lib/Widgets/SourceList.vala"
		granite_widgets_source_list_data_model_add_children_monitor (self, _tmp42_);
#line 4562 "SourceList.c"
	}
#line 888 "../lib/Widgets/SourceList.vala"
	_g_object_unref0 (expandable);
#line 888 "../lib/Widgets/SourceList.vala"
	_g_object_unref0 (parent);
#line 888 "../lib/Widgets/SourceList.vala"
	_g_free0 (child_iter);
#line 888 "../lib/Widgets/SourceList.vala"
	_g_free0 (parent_child_iter);
#line 4572 "SourceList.c"
}


static void
granite_widgets_source_list_data_model_remove_item (GraniteWidgetsSourceListDataModel* self,
                                                    GraniteWidgetsSourceListItem* item)
{
	GraniteWidgetsSourceListExpandableItem* _tmp0_;
	GraniteWidgetsSourceListExpandableItem* _tmp1_;
	GtkTreeIter* child_iter = NULL;
	GtkTreeIter* _tmp2_;
	GeeHashMap* _tmp3_;
	GtkTreeIter* _tmp4_;
	GraniteWidgetsSourceListExpandableItem* _tmp6_;
	GraniteWidgetsSourceListExpandableItem* _tmp7_;
	GraniteWidgetsSourceListExpandableItem* expandable = NULL;
	GraniteWidgetsSourceListExpandableItem* _tmp8_;
	GraniteWidgetsSourceListExpandableItem* _tmp9_;
#line 931 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 931 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (item != NULL);
#line 931 "../lib/Widgets/SourceList.vala"
	_vala_return_if_fail (granite_widgets_source_list_data_model_has_item (self, item), "has_item (item)");
#line 932 "../lib/Widgets/SourceList.vala"
	_tmp0_ = granite_widgets_source_list_data_model_get_root (self);
#line 932 "../lib/Widgets/SourceList.vala"
	_tmp1_ = _tmp0_;
#line 932 "../lib/Widgets/SourceList.vala"
	_vala_assert (_tmp1_ != NULL, "root != null");
#line 934 "../lib/Widgets/SourceList.vala"
	granite_widgets_source_list_data_model_remove_property_monitor (self, item);
#line 939 "../lib/Widgets/SourceList.vala"
	_tmp2_ = granite_widgets_source_list_data_model_get_item_child_iter (self, item);
#line 939 "../lib/Widgets/SourceList.vala"
	child_iter = _tmp2_;
#line 945 "../lib/Widgets/SourceList.vala"
	_tmp3_ = self->priv->items;
#line 945 "../lib/Widgets/SourceList.vala"
	gee_abstract_map_unset ((GeeAbstractMap*) _tmp3_, item, NULL);
#line 947 "../lib/Widgets/SourceList.vala"
	_tmp4_ = child_iter;
#line 947 "../lib/Widgets/SourceList.vala"
	if (_tmp4_ != NULL) {
#line 4617 "SourceList.c"
		GtkTreeStore* _tmp5_;
#line 948 "../lib/Widgets/SourceList.vala"
		_tmp5_ = self->priv->child_tree;
#line 948 "../lib/Widgets/SourceList.vala"
		gtk_tree_store_remove (_tmp5_, child_iter);
#line 4623 "SourceList.c"
	}
#line 950 "../lib/Widgets/SourceList.vala"
	_tmp6_ = granite_widgets_source_list_item_get_parent (item);
#line 950 "../lib/Widgets/SourceList.vala"
	_tmp7_ = _tmp6_;
#line 950 "../lib/Widgets/SourceList.vala"
	granite_widgets_source_list_data_model_push_parent_update (self, _tmp7_);
#line 953 "../lib/Widgets/SourceList.vala"
	_tmp8_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (item, GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM) ? ((GraniteWidgetsSourceListExpandableItem*) item) : NULL);
#line 953 "../lib/Widgets/SourceList.vala"
	expandable = _tmp8_;
#line 954 "../lib/Widgets/SourceList.vala"
	_tmp9_ = expandable;
#line 954 "../lib/Widgets/SourceList.vala"
	if (_tmp9_ != NULL) {
#line 4639 "SourceList.c"
		GraniteWidgetsSourceListExpandableItem* _tmp10_;
#line 956 "../lib/Widgets/SourceList.vala"
		_tmp10_ = expandable;
#line 956 "../lib/Widgets/SourceList.vala"
		granite_widgets_source_list_data_model_remove_children_monitor (self, _tmp10_);
#line 4645 "SourceList.c"
		{
			GeeIterator* _child_item_it = NULL;
			GraniteWidgetsSourceListExpandableItem* _tmp11_;
			GeeCollection* _tmp12_;
			GeeCollection* _tmp13_;
			GeeCollection* _tmp14_;
			GeeIterator* _tmp15_;
			GeeIterator* _tmp16_;
#line 958 "../lib/Widgets/SourceList.vala"
			_tmp11_ = expandable;
#line 958 "../lib/Widgets/SourceList.vala"
			_tmp12_ = granite_widgets_source_list_expandable_item_get_children (_tmp11_);
#line 958 "../lib/Widgets/SourceList.vala"
			_tmp13_ = _tmp12_;
#line 958 "../lib/Widgets/SourceList.vala"
			_tmp14_ = _tmp13_;
#line 958 "../lib/Widgets/SourceList.vala"
			_tmp15_ = gee_iterable_iterator ((GeeIterable*) _tmp14_);
#line 958 "../lib/Widgets/SourceList.vala"
			_tmp16_ = _tmp15_;
#line 958 "../lib/Widgets/SourceList.vala"
			_g_object_unref0 (_tmp14_);
#line 958 "../lib/Widgets/SourceList.vala"
			_child_item_it = _tmp16_;
#line 958 "../lib/Widgets/SourceList.vala"
			while (TRUE) {
#line 4672 "SourceList.c"
				GeeIterator* _tmp17_;
				GraniteWidgetsSourceListItem* child_item = NULL;
				GeeIterator* _tmp18_;
				gpointer _tmp19_;
				GraniteWidgetsSourceListItem* _tmp20_;
#line 958 "../lib/Widgets/SourceList.vala"
				_tmp17_ = _child_item_it;
#line 958 "../lib/Widgets/SourceList.vala"
				if (!gee_iterator_next (_tmp17_)) {
#line 958 "../lib/Widgets/SourceList.vala"
					break;
#line 4684 "SourceList.c"
				}
#line 958 "../lib/Widgets/SourceList.vala"
				_tmp18_ = _child_item_it;
#line 958 "../lib/Widgets/SourceList.vala"
				_tmp19_ = gee_iterator_get (_tmp18_);
#line 958 "../lib/Widgets/SourceList.vala"
				child_item = (GraniteWidgetsSourceListItem*) _tmp19_;
#line 959 "../lib/Widgets/SourceList.vala"
				_tmp20_ = child_item;
#line 959 "../lib/Widgets/SourceList.vala"
				granite_widgets_source_list_data_model_remove_item (self, _tmp20_);
#line 958 "../lib/Widgets/SourceList.vala"
				_g_object_unref0 (child_item);
#line 4698 "SourceList.c"
			}
#line 958 "../lib/Widgets/SourceList.vala"
			_g_object_unref0 (_child_item_it);
#line 4702 "SourceList.c"
		}
	}
#line 931 "../lib/Widgets/SourceList.vala"
	_g_object_unref0 (expandable);
#line 931 "../lib/Widgets/SourceList.vala"
	_g_free0 (child_iter);
#line 4709 "SourceList.c"
}


static void
_granite_widgets_source_list_data_model_on_item_prop_changed_granite_widgets_source_list_data_model_item_monitor_changed (GraniteWidgetsSourceListDataModelItemMonitor* _sender,
                                                                                                                          GraniteWidgetsSourceListItem* _self_,
                                                                                                                          const gchar* prop_name,
                                                                                                                          gpointer self)
{
#line 966 "../lib/Widgets/SourceList.vala"
	granite_widgets_source_list_data_model_on_item_prop_changed ((GraniteWidgetsSourceListDataModel*) self, _self_, prop_name);
#line 4721 "SourceList.c"
}


static void
granite_widgets_source_list_data_model_add_property_monitor (GraniteWidgetsSourceListDataModel* self,
                                                             GraniteWidgetsSourceListItem* item)
{
	GraniteWidgetsSourceListDataModelItemMonitor* wrapper = NULL;
	GraniteWidgetsSourceListDataModelItemMonitor* _tmp0_;
	GeeHashMap* _tmp1_;
#line 963 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 963 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (item != NULL);
#line 964 "../lib/Widgets/SourceList.vala"
	_tmp0_ = granite_widgets_source_list_data_model_item_monitor_new (item);
#line 964 "../lib/Widgets/SourceList.vala"
	wrapper = _tmp0_;
#line 965 "../lib/Widgets/SourceList.vala"
	_tmp1_ = self->priv->monitors;
#line 965 "../lib/Widgets/SourceList.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp1_, item, wrapper);
#line 966 "../lib/Widgets/SourceList.vala"
	g_signal_connect_object (wrapper, "changed", (GCallback) _granite_widgets_source_list_data_model_on_item_prop_changed_granite_widgets_source_list_data_model_item_monitor_changed, self, 0);
#line 963 "../lib/Widgets/SourceList.vala"
	_granite_widgets_source_list_data_model_item_monitor_unref0 (wrapper);
#line 4748 "SourceList.c"
}


static void
granite_widgets_source_list_data_model_remove_property_monitor (GraniteWidgetsSourceListDataModel* self,
                                                                GraniteWidgetsSourceListItem* item)
{
	GraniteWidgetsSourceListDataModelItemMonitor* wrapper = NULL;
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	GraniteWidgetsSourceListDataModelItemMonitor* _tmp2_;
	GeeHashMap* _tmp5_;
#line 969 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 969 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (item != NULL);
#line 970 "../lib/Widgets/SourceList.vala"
	_tmp0_ = self->priv->monitors;
#line 970 "../lib/Widgets/SourceList.vala"
	_tmp1_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, item);
#line 970 "../lib/Widgets/SourceList.vala"
	wrapper = (GraniteWidgetsSourceListDataModelItemMonitor*) _tmp1_;
#line 971 "../lib/Widgets/SourceList.vala"
	_tmp2_ = wrapper;
#line 971 "../lib/Widgets/SourceList.vala"
	if (_tmp2_ != NULL) {
#line 4775 "SourceList.c"
		GraniteWidgetsSourceListDataModelItemMonitor* _tmp3_;
		guint _tmp4_;
#line 972 "../lib/Widgets/SourceList.vala"
		_tmp3_ = wrapper;
#line 972 "../lib/Widgets/SourceList.vala"
		g_signal_parse_name ("changed", GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_ITEM_MONITOR, &_tmp4_, NULL, FALSE);
#line 972 "../lib/Widgets/SourceList.vala"
		g_signal_handlers_disconnect_matched (_tmp3_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp4_, 0, NULL, (GCallback) _granite_widgets_source_list_data_model_on_item_prop_changed_granite_widgets_source_list_data_model_item_monitor_changed, self);
#line 4784 "SourceList.c"
	}
#line 973 "../lib/Widgets/SourceList.vala"
	_tmp5_ = self->priv->monitors;
#line 973 "../lib/Widgets/SourceList.vala"
	gee_abstract_map_unset ((GeeAbstractMap*) _tmp5_, item, NULL);
#line 969 "../lib/Widgets/SourceList.vala"
	_granite_widgets_source_list_data_model_item_monitor_unref0 (wrapper);
#line 4792 "SourceList.c"
}


static void
_granite_widgets_source_list_data_model_on_item_child_added_granite_widgets_source_list_expandable_item_child_added (GraniteWidgetsSourceListExpandableItem* _sender,
                                                                                                                     GraniteWidgetsSourceListItem* item,
                                                                                                                     gpointer self)
{
#line 977 "../lib/Widgets/SourceList.vala"
	granite_widgets_source_list_data_model_on_item_child_added ((GraniteWidgetsSourceListDataModel*) self, item);
#line 4803 "SourceList.c"
}


static void
_granite_widgets_source_list_data_model_on_item_child_removed_granite_widgets_source_list_expandable_item_child_removed (GraniteWidgetsSourceListExpandableItem* _sender,
                                                                                                                         GraniteWidgetsSourceListItem* item,
                                                                                                                         gpointer self)
{
#line 978 "../lib/Widgets/SourceList.vala"
	granite_widgets_source_list_data_model_on_item_child_removed ((GraniteWidgetsSourceListDataModel*) self, item);
#line 4814 "SourceList.c"
}


static void
granite_widgets_source_list_data_model_add_children_monitor (GraniteWidgetsSourceListDataModel* self,
                                                             GraniteWidgetsSourceListExpandableItem* item)
{
#line 976 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 976 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (item != NULL);
#line 977 "../lib/Widgets/SourceList.vala"
	g_signal_connect_object (item, "child-added", (GCallback) _granite_widgets_source_list_data_model_on_item_child_added_granite_widgets_source_list_expandable_item_child_added, self, G_CONNECT_AFTER);
#line 978 "../lib/Widgets/SourceList.vala"
	g_signal_connect_object (item, "child-removed", (GCallback) _granite_widgets_source_list_data_model_on_item_child_removed_granite_widgets_source_list_expandable_item_child_removed, self, G_CONNECT_AFTER);
#line 4830 "SourceList.c"
}


static void
granite_widgets_source_list_data_model_remove_children_monitor (GraniteWidgetsSourceListDataModel* self,
                                                                GraniteWidgetsSourceListExpandableItem* item)
{
	guint _tmp0_;
	guint _tmp1_;
#line 981 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 981 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (item != NULL);
#line 982 "../lib/Widgets/SourceList.vala"
	g_signal_parse_name ("child-added", GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM, &_tmp0_, NULL, FALSE);
#line 982 "../lib/Widgets/SourceList.vala"
	g_signal_handlers_disconnect_matched (item, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) _granite_widgets_source_list_data_model_on_item_child_added_granite_widgets_source_list_expandable_item_child_added, self);
#line 983 "../lib/Widgets/SourceList.vala"
	g_signal_parse_name ("child-removed", GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM, &_tmp1_, NULL, FALSE);
#line 983 "../lib/Widgets/SourceList.vala"
	g_signal_handlers_disconnect_matched (item, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _granite_widgets_source_list_data_model_on_item_child_removed_granite_widgets_source_list_expandable_item_child_removed, self);
#line 4852 "SourceList.c"
}


static void
granite_widgets_source_list_data_model_on_item_child_added (GraniteWidgetsSourceListDataModel* self,
                                                            GraniteWidgetsSourceListItem* item)
{
#line 986 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 986 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (item != NULL);
#line 987 "../lib/Widgets/SourceList.vala"
	granite_widgets_source_list_data_model_add_item (self, item);
#line 4866 "SourceList.c"
}


static void
granite_widgets_source_list_data_model_on_item_child_removed (GraniteWidgetsSourceListDataModel* self,
                                                              GraniteWidgetsSourceListItem* item)
{
#line 990 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 990 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (item != NULL);
#line 991 "../lib/Widgets/SourceList.vala"
	granite_widgets_source_list_data_model_remove_item (self, item);
#line 4880 "SourceList.c"
}


static void
granite_widgets_source_list_data_model_on_item_prop_changed (GraniteWidgetsSourceListDataModel* self,
                                                             GraniteWidgetsSourceListItem* item,
                                                             const gchar* prop_name)
{
#line 994 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 994 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (item != NULL);
#line 994 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (prop_name != NULL);
#line 995 "../lib/Widgets/SourceList.vala"
	if (g_strcmp0 (prop_name, "parent") != 0) {
#line 996 "../lib/Widgets/SourceList.vala"
		granite_widgets_source_list_data_model_update_item (self, item);
#line 4899 "SourceList.c"
	}
}


/**
         * Pushes a call to update_item() if //parent// is not //null//.
         *
         * This is needed because the visibility of categories depends on their n_children property,
         * and also because item expansion should be updated after adding or removing items.
         * If many updates are pushed, and the item has still not been updated, only one is processed.
         * This guarantees efficiency as updating a category item could trigger expensive actions.
         */
static Block12Data*
block12_data_ref (Block12Data* _data12_)
{
#line 1007 "../lib/Widgets/SourceList.vala"
	g_atomic_int_inc (&_data12_->_ref_count_);
#line 1007 "../lib/Widgets/SourceList.vala"
	return _data12_;
#line 4919 "SourceList.c"
}


static void
block12_data_unref (void * _userdata_)
{
	Block12Data* _data12_;
	_data12_ = (Block12Data*) _userdata_;
#line 1007 "../lib/Widgets/SourceList.vala"
	if (g_atomic_int_dec_and_test (&_data12_->_ref_count_)) {
#line 4930 "SourceList.c"
		GraniteWidgetsSourceListDataModel* self;
#line 1007 "../lib/Widgets/SourceList.vala"
		self = _data12_->self;
#line 1007 "../lib/Widgets/SourceList.vala"
		_g_object_unref0 (_data12_->parent);
#line 1007 "../lib/Widgets/SourceList.vala"
		_g_object_unref0 (self);
#line 1007 "../lib/Widgets/SourceList.vala"
		g_slice_free (Block12Data, _data12_);
#line 4940 "SourceList.c"
	}
}


static gboolean
___lambda76_ (Block12Data* _data12_)
{
	GraniteWidgetsSourceListDataModel* self;
	gboolean result = FALSE;
#line 1024 "../lib/Widgets/SourceList.vala"
	self = _data12_->self;
#line 1025 "../lib/Widgets/SourceList.vala"
	if (_data12_->parent != NULL) {
#line 1026 "../lib/Widgets/SourceList.vala"
		granite_widgets_source_list_data_model_update_item (self, (GraniteWidgetsSourceListItem*) _data12_->parent);
#line 1029 "../lib/Widgets/SourceList.vala"
		g_object_set_data_full ((GObject*) _data12_->parent, GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_ITEM_PARENT_NEEDS_UPDATE, (gpointer) ((gintptr) FALSE), NULL);
#line 4958 "SourceList.c"
	}
#line 1032 "../lib/Widgets/SourceList.vala"
	result = FALSE;
#line 1032 "../lib/Widgets/SourceList.vala"
	return result;
#line 4964 "SourceList.c"
}


static gboolean
____lambda76__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda76_ (self);
#line 1024 "../lib/Widgets/SourceList.vala"
	return result;
#line 4975 "SourceList.c"
}


static void
granite_widgets_source_list_data_model_push_parent_update (GraniteWidgetsSourceListDataModel* self,
                                                           GraniteWidgetsSourceListExpandableItem* parent)
{
	Block12Data* _data12_;
	GraniteWidgetsSourceListExpandableItem* _tmp0_;
	gboolean needs_update = FALSE;
	gconstpointer _tmp1_;
	gboolean _tmp2_;
	GtkTreePath* path = NULL;
	GtkTreePath* _tmp3_;
	GtkTreePath* _tmp4_;
#line 1007 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 1007 "../lib/Widgets/SourceList.vala"
	_data12_ = g_slice_new0 (Block12Data);
#line 1007 "../lib/Widgets/SourceList.vala"
	_data12_->_ref_count_ = 1;
#line 1007 "../lib/Widgets/SourceList.vala"
	_data12_->self = g_object_ref (self);
#line 1007 "../lib/Widgets/SourceList.vala"
	_tmp0_ = _g_object_ref0 (parent);
#line 1007 "../lib/Widgets/SourceList.vala"
	_g_object_unref0 (_data12_->parent);
#line 1007 "../lib/Widgets/SourceList.vala"
	_data12_->parent = _tmp0_;
#line 1008 "../lib/Widgets/SourceList.vala"
	if (_data12_->parent == NULL) {
#line 1009 "../lib/Widgets/SourceList.vala"
		block12_data_unref (_data12_);
#line 1009 "../lib/Widgets/SourceList.vala"
		_data12_ = NULL;
#line 1009 "../lib/Widgets/SourceList.vala"
		return;
#line 5013 "SourceList.c"
	}
#line 1011 "../lib/Widgets/SourceList.vala"
	_tmp1_ = g_object_get_data ((GObject*) _data12_->parent, GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_ITEM_PARENT_NEEDS_UPDATE);
#line 1011 "../lib/Widgets/SourceList.vala"
	needs_update = (gboolean) ((gintptr) _tmp1_);
#line 1015 "../lib/Widgets/SourceList.vala"
	_tmp2_ = needs_update;
#line 1015 "../lib/Widgets/SourceList.vala"
	if (_tmp2_) {
#line 1016 "../lib/Widgets/SourceList.vala"
		block12_data_unref (_data12_);
#line 1016 "../lib/Widgets/SourceList.vala"
		_data12_ = NULL;
#line 1016 "../lib/Widgets/SourceList.vala"
		return;
#line 5029 "SourceList.c"
	}
#line 1018 "../lib/Widgets/SourceList.vala"
	_tmp3_ = granite_widgets_source_list_data_model_get_item_path (self, (GraniteWidgetsSourceListItem*) _data12_->parent);
#line 1018 "../lib/Widgets/SourceList.vala"
	path = _tmp3_;
#line 1020 "../lib/Widgets/SourceList.vala"
	_tmp4_ = path;
#line 1020 "../lib/Widgets/SourceList.vala"
	if (_tmp4_ != NULL) {
#line 1022 "../lib/Widgets/SourceList.vala"
		g_object_set_data_full ((GObject*) _data12_->parent, GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_ITEM_PARENT_NEEDS_UPDATE, (gpointer) ((gintptr) TRUE), NULL);
#line 1024 "../lib/Widgets/SourceList.vala"
		g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ____lambda76__gsource_func, block12_data_ref (_data12_), block12_data_unref);
#line 5043 "SourceList.c"
	}
#line 1007 "../lib/Widgets/SourceList.vala"
	__vala_GtkTreePath_free0 (path);
#line 1007 "../lib/Widgets/SourceList.vala"
	block12_data_unref (_data12_);
#line 1007 "../lib/Widgets/SourceList.vala"
	_data12_ = NULL;
#line 5051 "SourceList.c"
}


/**
         * Returns the Item pointed by iter, or null if the iter doesn't refer to a valid item.
         */
static GraniteWidgetsSourceListItem*
granite_widgets_source_list_data_model_get_item (GraniteWidgetsSourceListDataModel* self,
                                                 GtkTreeIter* iter)
{
	GraniteWidgetsSourceListItem* result = NULL;
	GraniteWidgetsSourceListItem* item = NULL;
	GtkTreeIter _tmp0_;
	GraniteWidgetsSourceListItem* _tmp1_ = NULL;
#line 1040 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1040 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (iter != NULL, NULL);
#line 1042 "../lib/Widgets/SourceList.vala"
	_tmp0_ = *iter;
#line 1042 "../lib/Widgets/SourceList.vala"
	gtk_tree_model_get ((GtkTreeModel*) self, &_tmp0_, GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_COLUMN_ITEM, &_tmp1_, -1, -1);
#line 1042 "../lib/Widgets/SourceList.vala"
	_g_object_unref0 (item);
#line 1042 "../lib/Widgets/SourceList.vala"
	item = _tmp1_;
#line 1043 "../lib/Widgets/SourceList.vala"
	result = item;
#line 1043 "../lib/Widgets/SourceList.vala"
	return result;
#line 5082 "SourceList.c"
}


/**
         * Returns the Item pointed by path, or null if the path doesn't refer to a valid item.
         */
static GraniteWidgetsSourceListItem*
granite_widgets_source_list_data_model_get_item_from_path (GraniteWidgetsSourceListDataModel* self,
                                                           GtkTreePath* path)
{
	GraniteWidgetsSourceListItem* result = NULL;
	GtkTreeIter iter = {0};
	GtkTreeIter _tmp0_ = {0};
	gboolean _tmp1_;
#line 1049 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1049 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 1051 "../lib/Widgets/SourceList.vala"
	_tmp1_ = gtk_tree_model_get_iter ((GtkTreeModel*) self, &_tmp0_, path);
#line 1051 "../lib/Widgets/SourceList.vala"
	iter = _tmp0_;
#line 1051 "../lib/Widgets/SourceList.vala"
	if (_tmp1_) {
#line 5107 "SourceList.c"
		GtkTreeIter _tmp2_;
		GraniteWidgetsSourceListItem* _tmp3_;
#line 1052 "../lib/Widgets/SourceList.vala"
		_tmp2_ = iter;
#line 1052 "../lib/Widgets/SourceList.vala"
		_tmp3_ = granite_widgets_source_list_data_model_get_item (self, &_tmp2_);
#line 1052 "../lib/Widgets/SourceList.vala"
		result = _tmp3_;
#line 1052 "../lib/Widgets/SourceList.vala"
		return result;
#line 5118 "SourceList.c"
	}
#line 1054 "../lib/Widgets/SourceList.vala"
	result = NULL;
#line 1054 "../lib/Widgets/SourceList.vala"
	return result;
#line 5124 "SourceList.c"
}


/**
         * Returns a newly-created path pointing to the item, or null in case a valid path
         * is not found.
         */
static GtkTreePath*
granite_widgets_source_list_data_model_get_item_path (GraniteWidgetsSourceListDataModel* self,
                                                      GraniteWidgetsSourceListItem* item)
{
	GtkTreePath* result = NULL;
	GtkTreePath* path = NULL;
	GtkTreePath* child_path = NULL;
	GtkTreePath* _tmp0_;
	GtkTreePath* _tmp1_;
#line 1061 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1061 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (item != NULL, NULL);
#line 1062 "../lib/Widgets/SourceList.vala"
	path = NULL;
#line 1062 "../lib/Widgets/SourceList.vala"
	_tmp0_ = granite_widgets_source_list_data_model_get_item_child_path (self, item);
#line 1062 "../lib/Widgets/SourceList.vala"
	child_path = _tmp0_;
#line 1065 "../lib/Widgets/SourceList.vala"
	_tmp1_ = child_path;
#line 1065 "../lib/Widgets/SourceList.vala"
	if (_tmp1_ != NULL) {
#line 5155 "SourceList.c"
		GtkTreePath* _tmp2_;
		GtkTreePath* _tmp3_;
#line 1066 "../lib/Widgets/SourceList.vala"
		_tmp2_ = child_path;
#line 1066 "../lib/Widgets/SourceList.vala"
		_tmp3_ = gtk_tree_model_filter_convert_child_path_to_path ((GtkTreeModelFilter*) self, _tmp2_);
#line 1066 "../lib/Widgets/SourceList.vala"
		__vala_GtkTreePath_free0 (path);
#line 1066 "../lib/Widgets/SourceList.vala"
		path = _tmp3_;
#line 5166 "SourceList.c"
	}
#line 1068 "../lib/Widgets/SourceList.vala"
	result = path;
#line 1068 "../lib/Widgets/SourceList.vala"
	__vala_GtkTreePath_free0 (child_path);
#line 1068 "../lib/Widgets/SourceList.vala"
	return result;
#line 5174 "SourceList.c"
}


/**
         * Returns a newly-created iterator pointing to the item, or null in case a valid iter
         * was not found.
         */
static GtkTreeIter*
granite_widgets_source_list_data_model_get_item_iter (GraniteWidgetsSourceListDataModel* self,
                                                      GraniteWidgetsSourceListItem* item)
{
	GtkTreeIter* result = NULL;
	GtkTreeIter* child_iter = NULL;
	GtkTreeIter* _tmp0_;
	GtkTreeIter* _tmp1_;
#line 1075 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1075 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (item != NULL, NULL);
#line 1076 "../lib/Widgets/SourceList.vala"
	_tmp0_ = granite_widgets_source_list_data_model_get_item_child_iter (self, item);
#line 1076 "../lib/Widgets/SourceList.vala"
	child_iter = _tmp0_;
#line 1078 "../lib/Widgets/SourceList.vala"
	_tmp1_ = child_iter;
#line 1078 "../lib/Widgets/SourceList.vala"
	if (_tmp1_ != NULL) {
#line 5202 "SourceList.c"
		GtkTreeIter iter = {0};
		GtkTreeIter* _tmp2_;
		GtkTreeIter _tmp3_ = {0};
		GtkTreeIter _tmp4_;
		gboolean _tmp5_;
#line 1080 "../lib/Widgets/SourceList.vala"
		_tmp2_ = child_iter;
#line 1080 "../lib/Widgets/SourceList.vala"
		_tmp4_ = *_tmp2_;
#line 1080 "../lib/Widgets/SourceList.vala"
		_tmp5_ = gtk_tree_model_filter_convert_child_iter_to_iter ((GtkTreeModelFilter*) self, &_tmp3_, &_tmp4_);
#line 1080 "../lib/Widgets/SourceList.vala"
		iter = _tmp3_;
#line 1080 "../lib/Widgets/SourceList.vala"
		if (_tmp5_) {
#line 5218 "SourceList.c"
			GtkTreeIter* _tmp6_;
#line 1081 "../lib/Widgets/SourceList.vala"
			_tmp6_ = __gtk_tree_iter_dup0 (&iter);
#line 1081 "../lib/Widgets/SourceList.vala"
			result = _tmp6_;
#line 1081 "../lib/Widgets/SourceList.vala"
			_g_free0 (child_iter);
#line 1081 "../lib/Widgets/SourceList.vala"
			return result;
#line 5228 "SourceList.c"
		}
	}
#line 1084 "../lib/Widgets/SourceList.vala"
	result = NULL;
#line 1084 "../lib/Widgets/SourceList.vala"
	_g_free0 (child_iter);
#line 1084 "../lib/Widgets/SourceList.vala"
	return result;
#line 5237 "SourceList.c"
}


/**
         * External "extra" filter method.
         */
static void
granite_widgets_source_list_data_model_set_filter_func (GraniteWidgetsSourceListDataModel* self,
                                                        GraniteWidgetsSourceListVisibleFunc visible_func,
                                                        gpointer visible_func_target)
{
#line 1090 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 1091 "../lib/Widgets/SourceList.vala"
	self->priv->filter_func = visible_func;
#line 1091 "../lib/Widgets/SourceList.vala"
	self->priv->filter_func_target = visible_func_target;
#line 5255 "SourceList.c"
}


/**
         * Checks whether an item is a category (i.e. a root-level expandable item).
         * The caller must pass an iter or path pointing to the item, but not both
         * (one of them must be null.)
         *
         * TODO: instead of checking the position of the iter or path, we should simply
         * check whether the item's parent is the root item and whether the item is
         * expandable. We don't do so right now because vala still allows client code
         * to access the Item.parent property, even though its setter is defined as internal.
         */
static gboolean
granite_widgets_source_list_data_model_is_category (GraniteWidgetsSourceListDataModel* self,
                                                    GraniteWidgetsSourceListItem* item,
                                                    GtkTreeIter* iter,
                                                    GtkTreePath* path)
{
	gboolean result = FALSE;
	gboolean is_category = FALSE;
#line 1104 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1104 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (item != NULL, FALSE);
#line 1105 "../lib/Widgets/SourceList.vala"
	is_category = FALSE;
#line 1107 "../lib/Widgets/SourceList.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (item, GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM)) {
#line 1108 "../lib/Widgets/SourceList.vala"
		if (iter != NULL) {
#line 5287 "SourceList.c"
			GtkTreeIter _tmp0_;
#line 1109 "../lib/Widgets/SourceList.vala"
			_vala_assert (path == NULL, "path == null");
#line 1110 "../lib/Widgets/SourceList.vala"
			_tmp0_ = *iter;
#line 1110 "../lib/Widgets/SourceList.vala"
			is_category = granite_widgets_source_list_data_model_is_iter_at_root_level (self, &_tmp0_);
#line 5295 "SourceList.c"
		} else {
#line 1112 "../lib/Widgets/SourceList.vala"
			_vala_assert (iter == NULL, "iter == null");
#line 1113 "../lib/Widgets/SourceList.vala"
			is_category = granite_widgets_source_list_data_model_is_path_at_root_level (self, path);
#line 5301 "SourceList.c"
		}
	}
#line 1116 "../lib/Widgets/SourceList.vala"
	result = is_category;
#line 1116 "../lib/Widgets/SourceList.vala"
	return result;
#line 5308 "SourceList.c"
}


static gboolean
granite_widgets_source_list_data_model_is_iter_at_root_level (GraniteWidgetsSourceListDataModel* self,
                                                              GtkTreeIter* iter)
{
	gboolean result = FALSE;
	GtkTreeIter _tmp0_;
	GtkTreePath* _tmp1_;
	GtkTreePath* _tmp2_;
	gboolean _tmp3_;
#line 1119 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1119 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (iter != NULL, FALSE);
#line 1120 "../lib/Widgets/SourceList.vala"
	_tmp0_ = *iter;
#line 1120 "../lib/Widgets/SourceList.vala"
	_tmp1_ = gtk_tree_model_get_path ((GtkTreeModel*) self, &_tmp0_);
#line 1120 "../lib/Widgets/SourceList.vala"
	_tmp2_ = _tmp1_;
#line 1120 "../lib/Widgets/SourceList.vala"
	_tmp3_ = granite_widgets_source_list_data_model_is_path_at_root_level (self, _tmp2_);
#line 1120 "../lib/Widgets/SourceList.vala"
	__vala_GtkTreePath_free0 (_tmp2_);
#line 1120 "../lib/Widgets/SourceList.vala"
	result = _tmp3_;
#line 1120 "../lib/Widgets/SourceList.vala"
	return result;
#line 5339 "SourceList.c"
}


static gboolean
granite_widgets_source_list_data_model_is_path_at_root_level (GraniteWidgetsSourceListDataModel* self,
                                                              GtkTreePath* path)
{
	gboolean result = FALSE;
#line 1123 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1123 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 1124 "../lib/Widgets/SourceList.vala"
	result = gtk_tree_path_get_depth (path) == 1;
#line 1124 "../lib/Widgets/SourceList.vala"
	return result;
#line 5356 "SourceList.c"
}


static void
granite_widgets_source_list_data_model_resort (GraniteWidgetsSourceListDataModel* self)
{
	GtkTreeStore* _tmp0_;
	GtkTreeStore* _tmp1_;
#line 1127 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 1128 "../lib/Widgets/SourceList.vala"
	_tmp0_ = self->priv->child_tree;
#line 1128 "../lib/Widgets/SourceList.vala"
	gtk_tree_sortable_set_sort_column_id ((GtkTreeSortable*) _tmp0_, GTK_TREE_SORTABLE_UNSORTED_SORT_COLUMN_ID, GTK_SORT_ASCENDING);
#line 1129 "../lib/Widgets/SourceList.vala"
	_tmp1_ = self->priv->child_tree;
#line 1129 "../lib/Widgets/SourceList.vala"
	gtk_tree_sortable_set_sort_column_id ((GtkTreeSortable*) _tmp1_, GTK_TREE_SORTABLE_DEFAULT_SORT_COLUMN_ID, GTK_SORT_ASCENDING);
#line 5375 "SourceList.c"
}


static gint
granite_widgets_source_list_data_model_child_model_sort_func (GraniteWidgetsSourceListDataModel* self,
                                                              GtkTreeModel* model,
                                                              GtkTreeIter* a,
                                                              GtkTreeIter* b)
{
	gint result = 0;
	gint order = 0;
	GraniteWidgetsSourceListItem* item_a = NULL;
	GraniteWidgetsSourceListItem* item_b = NULL;
	GtkTreeStore* _tmp0_;
	GtkTreeIter _tmp1_;
	GraniteWidgetsSourceListItem* _tmp2_ = NULL;
	GtkTreeStore* _tmp3_;
	GtkTreeIter _tmp4_;
	GraniteWidgetsSourceListItem* _tmp5_ = NULL;
	GraniteWidgetsSourceListItem* _tmp6_;
	GraniteWidgetsSourceListExpandableItem* _tmp7_;
	GraniteWidgetsSourceListExpandableItem* _tmp8_;
	GraniteWidgetsSourceListItem* _tmp9_;
	GraniteWidgetsSourceListExpandableItem* _tmp10_;
	GraniteWidgetsSourceListExpandableItem* _tmp11_;
	GraniteWidgetsSourceListSortable* parent = NULL;
	GraniteWidgetsSourceListItem* _tmp12_;
	GraniteWidgetsSourceListExpandableItem* _tmp13_;
	GraniteWidgetsSourceListExpandableItem* _tmp14_;
	GraniteWidgetsSourceListSortable* _tmp15_;
	GraniteWidgetsSourceListSortable* _tmp16_;
#line 1132 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 1132 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (model != NULL, 0);
#line 1132 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 1132 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 1133 "../lib/Widgets/SourceList.vala"
	order = 0;
#line 1136 "../lib/Widgets/SourceList.vala"
	_tmp0_ = self->priv->child_tree;
#line 1136 "../lib/Widgets/SourceList.vala"
	_tmp1_ = *a;
#line 1136 "../lib/Widgets/SourceList.vala"
	gtk_tree_model_get ((GtkTreeModel*) _tmp0_, &_tmp1_, GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_COLUMN_ITEM, &_tmp2_, -1, -1);
#line 1136 "../lib/Widgets/SourceList.vala"
	_g_object_unref0 (item_a);
#line 1136 "../lib/Widgets/SourceList.vala"
	item_a = _tmp2_;
#line 1137 "../lib/Widgets/SourceList.vala"
	_tmp3_ = self->priv->child_tree;
#line 1137 "../lib/Widgets/SourceList.vala"
	_tmp4_ = *b;
#line 1137 "../lib/Widgets/SourceList.vala"
	gtk_tree_model_get ((GtkTreeModel*) _tmp3_, &_tmp4_, GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_COLUMN_ITEM, &_tmp5_, -1, -1);
#line 1137 "../lib/Widgets/SourceList.vala"
	_g_object_unref0 (item_b);
#line 1137 "../lib/Widgets/SourceList.vala"
	item_b = _tmp5_;
#line 1140 "../lib/Widgets/SourceList.vala"
	_tmp6_ = item_a;
#line 1140 "../lib/Widgets/SourceList.vala"
	_tmp7_ = granite_widgets_source_list_item_get_parent (_tmp6_);
#line 1140 "../lib/Widgets/SourceList.vala"
	_tmp8_ = _tmp7_;
#line 1140 "../lib/Widgets/SourceList.vala"
	_tmp9_ = item_b;
#line 1140 "../lib/Widgets/SourceList.vala"
	_tmp10_ = granite_widgets_source_list_item_get_parent (_tmp9_);
#line 1140 "../lib/Widgets/SourceList.vala"
	_tmp11_ = _tmp10_;
#line 1140 "../lib/Widgets/SourceList.vala"
	_vala_assert (_tmp8_ == _tmp11_, "item_a.parent == item_b.parent");
#line 1142 "../lib/Widgets/SourceList.vala"
	_tmp12_ = item_a;
#line 1142 "../lib/Widgets/SourceList.vala"
	_tmp13_ = granite_widgets_source_list_item_get_parent (_tmp12_);
#line 1142 "../lib/Widgets/SourceList.vala"
	_tmp14_ = _tmp13_;
#line 1142 "../lib/Widgets/SourceList.vala"
	_tmp15_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp14_, GRANITE_WIDGETS_TYPE_SOURCE_LIST_SORTABLE) ? ((GraniteWidgetsSourceListSortable*) _tmp14_) : NULL);
#line 1142 "../lib/Widgets/SourceList.vala"
	parent = _tmp15_;
#line 1143 "../lib/Widgets/SourceList.vala"
	_tmp16_ = parent;
#line 1143 "../lib/Widgets/SourceList.vala"
	if (_tmp16_ != NULL) {
#line 5465 "SourceList.c"
		GraniteWidgetsSourceListSortable* _tmp17_;
		GraniteWidgetsSourceListItem* _tmp18_;
		GraniteWidgetsSourceListItem* _tmp19_;
#line 1144 "../lib/Widgets/SourceList.vala"
		_tmp17_ = parent;
#line 1144 "../lib/Widgets/SourceList.vala"
		_tmp18_ = item_a;
#line 1144 "../lib/Widgets/SourceList.vala"
		_tmp19_ = item_b;
#line 1144 "../lib/Widgets/SourceList.vala"
		order = granite_widgets_source_list_sortable_compare (_tmp17_, _tmp18_, _tmp19_);
#line 5477 "SourceList.c"
	}
#line 1146 "../lib/Widgets/SourceList.vala"
	result = order;
#line 1146 "../lib/Widgets/SourceList.vala"
	_g_object_unref0 (parent);
#line 1146 "../lib/Widgets/SourceList.vala"
	_g_object_unref0 (item_b);
#line 1146 "../lib/Widgets/SourceList.vala"
	_g_object_unref0 (item_a);
#line 1146 "../lib/Widgets/SourceList.vala"
	return result;
#line 5489 "SourceList.c"
}


static GtkTreeIter*
granite_widgets_source_list_data_model_get_item_child_iter (GraniteWidgetsSourceListDataModel* self,
                                                            GraniteWidgetsSourceListItem* item)
{
	GtkTreeIter* result = NULL;
	GtkTreeIter* child_iter = NULL;
	GraniteWidgetsSourceListDataModelNodeWrapper* child_node_wrapper = NULL;
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	GraniteWidgetsSourceListDataModelNodeWrapper* _tmp2_;
#line 1149 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1149 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (item != NULL, NULL);
#line 1150 "../lib/Widgets/SourceList.vala"
	child_iter = NULL;
#line 1152 "../lib/Widgets/SourceList.vala"
	_tmp0_ = self->priv->items;
#line 1152 "../lib/Widgets/SourceList.vala"
	_tmp1_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, item);
#line 1152 "../lib/Widgets/SourceList.vala"
	child_node_wrapper = (GraniteWidgetsSourceListDataModelNodeWrapper*) _tmp1_;
#line 1153 "../lib/Widgets/SourceList.vala"
	_tmp2_ = child_node_wrapper;
#line 1153 "../lib/Widgets/SourceList.vala"
	if (_tmp2_ != NULL) {
#line 5519 "SourceList.c"
		GraniteWidgetsSourceListDataModelNodeWrapper* _tmp3_;
		GtkTreeIter* _tmp4_;
		GtkTreeIter* _tmp5_;
#line 1154 "../lib/Widgets/SourceList.vala"
		_tmp3_ = child_node_wrapper;
#line 1154 "../lib/Widgets/SourceList.vala"
		_tmp4_ = granite_widgets_source_list_data_model_node_wrapper_get_iter (_tmp3_);
#line 1154 "../lib/Widgets/SourceList.vala"
		_tmp5_ = _tmp4_;
#line 1154 "../lib/Widgets/SourceList.vala"
		_g_free0 (child_iter);
#line 1154 "../lib/Widgets/SourceList.vala"
		child_iter = _tmp5_;
#line 5533 "SourceList.c"
	}
#line 1156 "../lib/Widgets/SourceList.vala"
	result = child_iter;
#line 1156 "../lib/Widgets/SourceList.vala"
	_granite_widgets_source_list_data_model_node_wrapper_unref0 (child_node_wrapper);
#line 1156 "../lib/Widgets/SourceList.vala"
	return result;
#line 5541 "SourceList.c"
}


static GtkTreePath*
granite_widgets_source_list_data_model_get_item_child_path (GraniteWidgetsSourceListDataModel* self,
                                                            GraniteWidgetsSourceListItem* item)
{
	GtkTreePath* result = NULL;
	GtkTreePath* child_path = NULL;
	GraniteWidgetsSourceListDataModelNodeWrapper* child_node_wrapper = NULL;
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	GraniteWidgetsSourceListDataModelNodeWrapper* _tmp2_;
#line 1159 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1159 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (item != NULL, NULL);
#line 1160 "../lib/Widgets/SourceList.vala"
	child_path = NULL;
#line 1162 "../lib/Widgets/SourceList.vala"
	_tmp0_ = self->priv->items;
#line 1162 "../lib/Widgets/SourceList.vala"
	_tmp1_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, item);
#line 1162 "../lib/Widgets/SourceList.vala"
	child_node_wrapper = (GraniteWidgetsSourceListDataModelNodeWrapper*) _tmp1_;
#line 1163 "../lib/Widgets/SourceList.vala"
	_tmp2_ = child_node_wrapper;
#line 1163 "../lib/Widgets/SourceList.vala"
	if (_tmp2_ != NULL) {
#line 5571 "SourceList.c"
		GraniteWidgetsSourceListDataModelNodeWrapper* _tmp3_;
		GtkTreePath* _tmp4_;
		GtkTreePath* _tmp5_;
#line 1164 "../lib/Widgets/SourceList.vala"
		_tmp3_ = child_node_wrapper;
#line 1164 "../lib/Widgets/SourceList.vala"
		_tmp4_ = granite_widgets_source_list_data_model_node_wrapper_get_path (_tmp3_);
#line 1164 "../lib/Widgets/SourceList.vala"
		_tmp5_ = _tmp4_;
#line 1164 "../lib/Widgets/SourceList.vala"
		__vala_GtkTreePath_free0 (child_path);
#line 1164 "../lib/Widgets/SourceList.vala"
		child_path = _tmp5_;
#line 5585 "SourceList.c"
	}
#line 1166 "../lib/Widgets/SourceList.vala"
	result = child_path;
#line 1166 "../lib/Widgets/SourceList.vala"
	_granite_widgets_source_list_data_model_node_wrapper_unref0 (child_node_wrapper);
#line 1166 "../lib/Widgets/SourceList.vala"
	return result;
#line 5593 "SourceList.c"
}


/**
         * Filters the child-tree items based on their "visible" property.
         */
static gboolean
granite_widgets_source_list_data_model_filter_visible_func (GraniteWidgetsSourceListDataModel* self,
                                                            GtkTreeModel* child_model,
                                                            GtkTreeIter* iter)
{
	gboolean result = FALSE;
	gboolean item_visible = FALSE;
	GraniteWidgetsSourceListItem* item = NULL;
	GtkTreeStore* _tmp0_;
	GtkTreeIter _tmp1_;
	GraniteWidgetsSourceListItem* _tmp2_ = NULL;
	GraniteWidgetsSourceListItem* _tmp3_;
	GraniteWidgetsSourceListVisibleFunc _tmp29_;
	void* _tmp29__target;
#line 1172 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1172 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (child_model != NULL, FALSE);
#line 1172 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (iter != NULL, FALSE);
#line 1173 "../lib/Widgets/SourceList.vala"
	item_visible = FALSE;
#line 1176 "../lib/Widgets/SourceList.vala"
	_tmp0_ = self->priv->child_tree;
#line 1176 "../lib/Widgets/SourceList.vala"
	_tmp1_ = *iter;
#line 1176 "../lib/Widgets/SourceList.vala"
	gtk_tree_model_get ((GtkTreeModel*) _tmp0_, &_tmp1_, GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_COLUMN_ITEM, &_tmp2_, -1, -1);
#line 1176 "../lib/Widgets/SourceList.vala"
	_g_object_unref0 (item);
#line 1176 "../lib/Widgets/SourceList.vala"
	item = _tmp2_;
#line 1178 "../lib/Widgets/SourceList.vala"
	_tmp3_ = item;
#line 1178 "../lib/Widgets/SourceList.vala"
	if (_tmp3_ != NULL) {
#line 5636 "SourceList.c"
		GraniteWidgetsSourceListItem* _tmp4_;
		gboolean _tmp5_;
		gboolean _tmp6_;
		GraniteWidgetsSourceListExpandableItem* expandable = NULL;
		GraniteWidgetsSourceListItem* _tmp7_;
		GraniteWidgetsSourceListExpandableItem* _tmp8_;
		gboolean _tmp9_ = FALSE;
		GraniteWidgetsSourceListExpandableItem* _tmp10_;
#line 1179 "../lib/Widgets/SourceList.vala"
		_tmp4_ = item;
#line 1179 "../lib/Widgets/SourceList.vala"
		_tmp5_ = granite_widgets_source_list_item_get_visible (_tmp4_);
#line 1179 "../lib/Widgets/SourceList.vala"
		_tmp6_ = _tmp5_;
#line 1179 "../lib/Widgets/SourceList.vala"
		item_visible = _tmp6_;
#line 1183 "../lib/Widgets/SourceList.vala"
		_tmp7_ = item;
#line 1183 "../lib/Widgets/SourceList.vala"
		_tmp8_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp7_, GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM) ? ((GraniteWidgetsSourceListExpandableItem*) _tmp7_) : NULL);
#line 1183 "../lib/Widgets/SourceList.vala"
		expandable = _tmp8_;
#line 1184 "../lib/Widgets/SourceList.vala"
		_tmp10_ = expandable;
#line 1184 "../lib/Widgets/SourceList.vala"
		if (_tmp10_ != NULL) {
#line 5663 "SourceList.c"
			GtkTreeStore* _tmp11_;
			GtkTreeIter _tmp12_;
#line 1184 "../lib/Widgets/SourceList.vala"
			_tmp11_ = self->priv->child_tree;
#line 1184 "../lib/Widgets/SourceList.vala"
			_tmp12_ = *iter;
#line 1184 "../lib/Widgets/SourceList.vala"
			_tmp9_ = gtk_tree_store_iter_depth (_tmp11_, &_tmp12_) == 0;
#line 5672 "SourceList.c"
		} else {
#line 1184 "../lib/Widgets/SourceList.vala"
			_tmp9_ = FALSE;
#line 5676 "SourceList.c"
		}
#line 1184 "../lib/Widgets/SourceList.vala"
		if (_tmp9_) {
#line 5680 "SourceList.c"
			guint n_visible_children = 0U;
			gboolean _tmp26_ = FALSE;
			gboolean _tmp27_;
#line 1185 "../lib/Widgets/SourceList.vala"
			n_visible_children = (guint) 0;
#line 5686 "SourceList.c"
			{
				GeeIterator* _child_item_it = NULL;
				GraniteWidgetsSourceListExpandableItem* _tmp13_;
				GeeCollection* _tmp14_;
				GeeCollection* _tmp15_;
				GeeCollection* _tmp16_;
				GeeIterator* _tmp17_;
				GeeIterator* _tmp18_;
#line 1186 "../lib/Widgets/SourceList.vala"
				_tmp13_ = expandable;
#line 1186 "../lib/Widgets/SourceList.vala"
				_tmp14_ = granite_widgets_source_list_expandable_item_get_children (_tmp13_);
#line 1186 "../lib/Widgets/SourceList.vala"
				_tmp15_ = _tmp14_;
#line 1186 "../lib/Widgets/SourceList.vala"
				_tmp16_ = _tmp15_;
#line 1186 "../lib/Widgets/SourceList.vala"
				_tmp17_ = gee_iterable_iterator ((GeeIterable*) _tmp16_);
#line 1186 "../lib/Widgets/SourceList.vala"
				_tmp18_ = _tmp17_;
#line 1186 "../lib/Widgets/SourceList.vala"
				_g_object_unref0 (_tmp16_);
#line 1186 "../lib/Widgets/SourceList.vala"
				_child_item_it = _tmp18_;
#line 1186 "../lib/Widgets/SourceList.vala"
				while (TRUE) {
#line 5713 "SourceList.c"
					GeeIterator* _tmp19_;
					GraniteWidgetsSourceListItem* child_item = NULL;
					GeeIterator* _tmp20_;
					gpointer _tmp21_;
					GraniteWidgetsSourceListItem* _tmp22_;
					gboolean _tmp23_;
					gboolean _tmp24_;
#line 1186 "../lib/Widgets/SourceList.vala"
					_tmp19_ = _child_item_it;
#line 1186 "../lib/Widgets/SourceList.vala"
					if (!gee_iterator_next (_tmp19_)) {
#line 1186 "../lib/Widgets/SourceList.vala"
						break;
#line 5727 "SourceList.c"
					}
#line 1186 "../lib/Widgets/SourceList.vala"
					_tmp20_ = _child_item_it;
#line 1186 "../lib/Widgets/SourceList.vala"
					_tmp21_ = gee_iterator_get (_tmp20_);
#line 1186 "../lib/Widgets/SourceList.vala"
					child_item = (GraniteWidgetsSourceListItem*) _tmp21_;
#line 1187 "../lib/Widgets/SourceList.vala"
					_tmp22_ = child_item;
#line 1187 "../lib/Widgets/SourceList.vala"
					_tmp23_ = granite_widgets_source_list_item_get_visible (_tmp22_);
#line 1187 "../lib/Widgets/SourceList.vala"
					_tmp24_ = _tmp23_;
#line 1187 "../lib/Widgets/SourceList.vala"
					if (_tmp24_) {
#line 5743 "SourceList.c"
						guint _tmp25_;
#line 1188 "../lib/Widgets/SourceList.vala"
						_tmp25_ = n_visible_children;
#line 1188 "../lib/Widgets/SourceList.vala"
						n_visible_children = _tmp25_ + 1;
#line 5749 "SourceList.c"
					}
#line 1186 "../lib/Widgets/SourceList.vala"
					_g_object_unref0 (child_item);
#line 5753 "SourceList.c"
				}
#line 1186 "../lib/Widgets/SourceList.vala"
				_g_object_unref0 (_child_item_it);
#line 5757 "SourceList.c"
			}
#line 1190 "../lib/Widgets/SourceList.vala"
			_tmp27_ = item_visible;
#line 1190 "../lib/Widgets/SourceList.vala"
			if (_tmp27_) {
#line 5763 "SourceList.c"
				guint _tmp28_;
#line 1190 "../lib/Widgets/SourceList.vala"
				_tmp28_ = n_visible_children;
#line 1190 "../lib/Widgets/SourceList.vala"
				_tmp26_ = _tmp28_ > ((guint) 0);
#line 5769 "SourceList.c"
			} else {
#line 1190 "../lib/Widgets/SourceList.vala"
				_tmp26_ = FALSE;
#line 5773 "SourceList.c"
			}
#line 1190 "../lib/Widgets/SourceList.vala"
			item_visible = _tmp26_;
#line 5777 "SourceList.c"
		}
#line 1178 "../lib/Widgets/SourceList.vala"
		_g_object_unref0 (expandable);
#line 5781 "SourceList.c"
	}
#line 1194 "../lib/Widgets/SourceList.vala"
	_tmp29_ = self->priv->filter_func;
#line 1194 "../lib/Widgets/SourceList.vala"
	_tmp29__target = self->priv->filter_func_target;
#line 1194 "../lib/Widgets/SourceList.vala"
	if (_tmp29_ != NULL) {
#line 5789 "SourceList.c"
		gboolean _tmp30_ = FALSE;
		gboolean _tmp31_;
#line 1195 "../lib/Widgets/SourceList.vala"
		_tmp31_ = item_visible;
#line 1195 "../lib/Widgets/SourceList.vala"
		if (_tmp31_) {
#line 5796 "SourceList.c"
			GraniteWidgetsSourceListVisibleFunc _tmp32_;
			void* _tmp32__target;
			GraniteWidgetsSourceListItem* _tmp33_;
#line 1195 "../lib/Widgets/SourceList.vala"
			_tmp32_ = self->priv->filter_func;
#line 1195 "../lib/Widgets/SourceList.vala"
			_tmp32__target = self->priv->filter_func_target;
#line 1195 "../lib/Widgets/SourceList.vala"
			_tmp33_ = item;
#line 1195 "../lib/Widgets/SourceList.vala"
			_tmp30_ = _tmp32_ (_tmp33_, _tmp32__target);
#line 5808 "SourceList.c"
		} else {
#line 1195 "../lib/Widgets/SourceList.vala"
			_tmp30_ = FALSE;
#line 5812 "SourceList.c"
		}
#line 1195 "../lib/Widgets/SourceList.vala"
		item_visible = _tmp30_;
#line 5816 "SourceList.c"
	}
#line 1197 "../lib/Widgets/SourceList.vala"
	result = item_visible;
#line 1197 "../lib/Widgets/SourceList.vala"
	_g_object_unref0 (item);
#line 1197 "../lib/Widgets/SourceList.vala"
	return result;
#line 5824 "SourceList.c"
}


/**
         * TreeDragDest implementation
         */
static gboolean
granite_widgets_source_list_data_model_real_drag_data_received (GtkTreeDragDest* base,
                                                                GtkTreePath* dest,
                                                                GtkSelectionData* selection_data)
{
	GraniteWidgetsSourceListDataModel * self;
	gboolean result = FALSE;
	GtkTreeModel* model = NULL;
	GtkTreePath* src_path = NULL;
	gboolean _tmp0_ = FALSE;
	GtkTreeModel* _tmp1_ = NULL;
	GtkTreePath* _tmp2_ = NULL;
	gboolean _tmp3_;
	GtkTreeModel* _tmp4_;
#line 1204 "../lib/Widgets/SourceList.vala"
	self = (GraniteWidgetsSourceListDataModel*) base;
#line 1204 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (dest != NULL, FALSE);
#line 1204 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (selection_data != NULL, FALSE);
#line 1212 "../lib/Widgets/SourceList.vala"
	_tmp3_ = gtk_tree_get_row_drag_data (selection_data, &_tmp1_, &_tmp2_);
#line 1212 "../lib/Widgets/SourceList.vala"
	_g_object_unref0 (model);
#line 1212 "../lib/Widgets/SourceList.vala"
	_tmp4_ = _g_object_ref0 (_tmp1_);
#line 1212 "../lib/Widgets/SourceList.vala"
	model = _tmp4_;
#line 1212 "../lib/Widgets/SourceList.vala"
	__vala_GtkTreePath_free0 (src_path);
#line 1212 "../lib/Widgets/SourceList.vala"
	src_path = _tmp2_;
#line 1212 "../lib/Widgets/SourceList.vala"
	if (_tmp3_) {
#line 5865 "SourceList.c"
		GtkTreeModel* _tmp5_;
		GtkTreeStore* _tmp6_;
#line 1212 "../lib/Widgets/SourceList.vala"
		_tmp5_ = model;
#line 1212 "../lib/Widgets/SourceList.vala"
		_tmp6_ = self->priv->child_tree;
#line 1212 "../lib/Widgets/SourceList.vala"
		_tmp0_ = _tmp5_ == _tmp6_;
#line 5874 "SourceList.c"
	} else {
#line 1212 "../lib/Widgets/SourceList.vala"
		_tmp0_ = FALSE;
#line 5878 "SourceList.c"
	}
#line 1212 "../lib/Widgets/SourceList.vala"
	if (_tmp0_) {
#line 5882 "SourceList.c"
		GtkTreePath* child_dest = NULL;
		GtkTreePath* _tmp7_;
		GtkTreePath* _tmp8_;
#line 1214 "../lib/Widgets/SourceList.vala"
		_tmp7_ = gtk_tree_model_filter_convert_path_to_child_path ((GtkTreeModelFilter*) self, dest);
#line 1214 "../lib/Widgets/SourceList.vala"
		child_dest = _tmp7_;
#line 1216 "../lib/Widgets/SourceList.vala"
		_tmp8_ = child_dest;
#line 1216 "../lib/Widgets/SourceList.vala"
		if (_tmp8_ != NULL) {
#line 5894 "SourceList.c"
			GtkTreePath* _tmp9_;
			GtkTreePath* _tmp10_;
#line 1218 "../lib/Widgets/SourceList.vala"
			_tmp9_ = child_dest;
#line 1218 "../lib/Widgets/SourceList.vala"
			_tmp10_ = src_path;
#line 1218 "../lib/Widgets/SourceList.vala"
			if (granite_widgets_source_list_data_model_child_tree_drag_data_received (self, _tmp9_, _tmp10_)) {
#line 1219 "../lib/Widgets/SourceList.vala"
				result = TRUE;
#line 1219 "../lib/Widgets/SourceList.vala"
				__vala_GtkTreePath_free0 (child_dest);
#line 1219 "../lib/Widgets/SourceList.vala"
				__vala_GtkTreePath_free0 (src_path);
#line 1219 "../lib/Widgets/SourceList.vala"
				_g_object_unref0 (model);
#line 1219 "../lib/Widgets/SourceList.vala"
				return result;
#line 5913 "SourceList.c"
			}
		}
#line 1212 "../lib/Widgets/SourceList.vala"
		__vala_GtkTreePath_free0 (child_dest);
#line 5918 "SourceList.c"
	}
#line 1224 "../lib/Widgets/SourceList.vala"
	result = FALSE;
#line 1224 "../lib/Widgets/SourceList.vala"
	__vala_GtkTreePath_free0 (src_path);
#line 1224 "../lib/Widgets/SourceList.vala"
	_g_object_unref0 (model);
#line 1224 "../lib/Widgets/SourceList.vala"
	return result;
#line 5928 "SourceList.c"
}


static GtkTreePath*
_vala_GtkTreePath_copy (GtkTreePath* self)
{
#line 1234 "../lib/Widgets/SourceList.vala"
	return g_boxed_copy (gtk_tree_path_get_type (), self);
#line 5937 "SourceList.c"
}


static gpointer
__vala_GtkTreePath_copy0 (gpointer self)
{
#line 1234 "../lib/Widgets/SourceList.vala"
	return self ? _vala_GtkTreePath_copy (self) : NULL;
#line 5946 "SourceList.c"
}


static gboolean
granite_widgets_source_list_data_model_child_tree_drag_data_received (GraniteWidgetsSourceListDataModel* self,
                                                                      GtkTreePath* dest,
                                                                      GtkTreePath* src_path)
{
	gboolean result = FALSE;
	gboolean retval = FALSE;
	GtkTreeIter src_iter = {0};
	GtkTreeIter dest_iter = {0};
	GtkTreeStore* _tmp0_;
	GtkTreeIter _tmp1_ = {0};
	gboolean _tmp2_;
	GtkTreePath* prev = NULL;
	GtkTreePath* _tmp3_;
	GtkTreePath* _tmp4_;
	gboolean _tmp25_;
#line 1227 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1227 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (dest != NULL, FALSE);
#line 1227 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (src_path != NULL, FALSE);
#line 1228 "../lib/Widgets/SourceList.vala"
	retval = FALSE;
#line 1231 "../lib/Widgets/SourceList.vala"
	_tmp0_ = self->priv->child_tree;
#line 1231 "../lib/Widgets/SourceList.vala"
	_tmp2_ = gtk_tree_model_get_iter ((GtkTreeModel*) _tmp0_, &_tmp1_, src_path);
#line 1231 "../lib/Widgets/SourceList.vala"
	src_iter = _tmp1_;
#line 1231 "../lib/Widgets/SourceList.vala"
	if (!_tmp2_) {
#line 1232 "../lib/Widgets/SourceList.vala"
		result = FALSE;
#line 1232 "../lib/Widgets/SourceList.vala"
		return result;
#line 5986 "SourceList.c"
	}
#line 1234 "../lib/Widgets/SourceList.vala"
	_tmp3_ = __vala_GtkTreePath_copy0 (dest);
#line 1234 "../lib/Widgets/SourceList.vala"
	prev = _tmp3_;
#line 1237 "../lib/Widgets/SourceList.vala"
	_tmp4_ = prev;
#line 1237 "../lib/Widgets/SourceList.vala"
	if (!gtk_tree_path_prev (_tmp4_)) {
#line 5996 "SourceList.c"
		GtkTreePath* parent = NULL;
		GtkTreePath* _tmp5_;
		GtkTreeIter* dest_parent = NULL;
		gboolean _tmp6_ = FALSE;
		GtkTreePath* _tmp7_;
		GtkTreeStore* _tmp14_;
		GtkTreeIter* _tmp15_;
		GtkTreeIter _tmp16_ = {0};
#line 1241 "../lib/Widgets/SourceList.vala"
		_tmp5_ = __vala_GtkTreePath_copy0 (dest);
#line 1241 "../lib/Widgets/SourceList.vala"
		parent = _tmp5_;
#line 1242 "../lib/Widgets/SourceList.vala"
		dest_parent = NULL;
#line 1244 "../lib/Widgets/SourceList.vala"
		_tmp7_ = parent;
#line 1244 "../lib/Widgets/SourceList.vala"
		if (gtk_tree_path_up (_tmp7_)) {
#line 6015 "SourceList.c"
			GtkTreePath* _tmp8_;
#line 1244 "../lib/Widgets/SourceList.vala"
			_tmp8_ = parent;
#line 1244 "../lib/Widgets/SourceList.vala"
			_tmp6_ = gtk_tree_path_get_depth (_tmp8_) > 0;
#line 6021 "SourceList.c"
		} else {
#line 1244 "../lib/Widgets/SourceList.vala"
			_tmp6_ = FALSE;
#line 6025 "SourceList.c"
		}
#line 1244 "../lib/Widgets/SourceList.vala"
		if (_tmp6_) {
#line 6029 "SourceList.c"
			GtkTreeStore* _tmp9_;
			GtkTreePath* _tmp10_;
			GtkTreeIter _tmp11_ = {0};
			GtkTreeIter _tmp12_;
			GtkTreeIter* _tmp13_;
#line 1245 "../lib/Widgets/SourceList.vala"
			_tmp9_ = self->priv->child_tree;
#line 1245 "../lib/Widgets/SourceList.vala"
			_tmp10_ = parent;
#line 1245 "../lib/Widgets/SourceList.vala"
			gtk_tree_model_get_iter ((GtkTreeModel*) _tmp9_, &_tmp11_, _tmp10_);
#line 1245 "../lib/Widgets/SourceList.vala"
			_g_free0 (dest_parent);
#line 1245 "../lib/Widgets/SourceList.vala"
			_tmp12_ = _tmp11_;
#line 1245 "../lib/Widgets/SourceList.vala"
			_tmp13_ = __gtk_tree_iter_dup0 (&_tmp12_);
#line 1245 "../lib/Widgets/SourceList.vala"
			dest_parent = _tmp13_;
#line 6049 "SourceList.c"
		}
#line 1247 "../lib/Widgets/SourceList.vala"
		_tmp14_ = self->priv->child_tree;
#line 1247 "../lib/Widgets/SourceList.vala"
		_tmp15_ = dest_parent;
#line 1247 "../lib/Widgets/SourceList.vala"
		gtk_tree_store_prepend (_tmp14_, &_tmp16_, _tmp15_);
#line 1247 "../lib/Widgets/SourceList.vala"
		dest_iter = _tmp16_;
#line 1248 "../lib/Widgets/SourceList.vala"
		retval = TRUE;
#line 1237 "../lib/Widgets/SourceList.vala"
		_g_free0 (dest_parent);
#line 1237 "../lib/Widgets/SourceList.vala"
		__vala_GtkTreePath_free0 (parent);
#line 6065 "SourceList.c"
	} else {
		GtkTreeStore* _tmp17_;
		GtkTreePath* _tmp18_;
		GtkTreeIter _tmp19_ = {0};
		gboolean _tmp20_;
#line 1249 "../lib/Widgets/SourceList.vala"
		_tmp17_ = self->priv->child_tree;
#line 1249 "../lib/Widgets/SourceList.vala"
		_tmp18_ = prev;
#line 1249 "../lib/Widgets/SourceList.vala"
		_tmp20_ = gtk_tree_model_get_iter ((GtkTreeModel*) _tmp17_, &_tmp19_, _tmp18_);
#line 1249 "../lib/Widgets/SourceList.vala"
		dest_iter = _tmp19_;
#line 1249 "../lib/Widgets/SourceList.vala"
		if (_tmp20_) {
#line 6081 "SourceList.c"
			GtkTreeIter tmp_iter = {0};
			GtkTreeIter _tmp21_;
			GtkTreeStore* _tmp22_;
			GtkTreeIter _tmp23_;
			GtkTreeIter _tmp24_ = {0};
#line 1250 "../lib/Widgets/SourceList.vala"
			_tmp21_ = dest_iter;
#line 1250 "../lib/Widgets/SourceList.vala"
			tmp_iter = _tmp21_;
#line 1251 "../lib/Widgets/SourceList.vala"
			_tmp22_ = self->priv->child_tree;
#line 1251 "../lib/Widgets/SourceList.vala"
			_tmp23_ = tmp_iter;
#line 1251 "../lib/Widgets/SourceList.vala"
			gtk_tree_store_insert_after (_tmp22_, &_tmp24_, NULL, &_tmp23_);
#line 1251 "../lib/Widgets/SourceList.vala"
			dest_iter = _tmp24_;
#line 1252 "../lib/Widgets/SourceList.vala"
			retval = TRUE;
#line 6101 "SourceList.c"
		}
	}
#line 1257 "../lib/Widgets/SourceList.vala"
	_tmp25_ = retval;
#line 1257 "../lib/Widgets/SourceList.vala"
	if (_tmp25_) {
#line 6108 "SourceList.c"
		GtkTreeIter _tmp26_;
		GtkTreeIter _tmp27_;
		GraniteWidgetsSourceListItem* item = NULL;
		GtkTreeStore* _tmp28_;
		GtkTreeIter _tmp29_;
		GraniteWidgetsSourceListItem* _tmp30_ = NULL;
		GraniteWidgetsSourceListItem* _tmp31_;
		gboolean _tmp32_;
		GraniteWidgetsSourceListItem* _tmp33_;
		GraniteWidgetsSourceListSortable* parent = NULL;
		GraniteWidgetsSourceListItem* _tmp34_;
		GraniteWidgetsSourceListExpandableItem* _tmp35_;
		GraniteWidgetsSourceListExpandableItem* _tmp36_;
		GraniteWidgetsSourceListSortable* _tmp37_;
		GraniteWidgetsSourceListSortable* _tmp38_;
		gboolean _tmp39_;
		GraniteWidgetsSourceListSortable* _tmp40_;
		GraniteWidgetsSourceListItem* _tmp41_;
#line 1258 "../lib/Widgets/SourceList.vala"
		_tmp26_ = src_iter;
#line 1258 "../lib/Widgets/SourceList.vala"
		_tmp27_ = dest_iter;
#line 1258 "../lib/Widgets/SourceList.vala"
		granite_widgets_source_list_data_model_recursive_node_copy (self, &_tmp26_, &_tmp27_);
#line 1262 "../lib/Widgets/SourceList.vala"
		_tmp28_ = self->priv->child_tree;
#line 1262 "../lib/Widgets/SourceList.vala"
		_tmp29_ = src_iter;
#line 1262 "../lib/Widgets/SourceList.vala"
		gtk_tree_model_get ((GtkTreeModel*) _tmp28_, &_tmp29_, GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_COLUMN_ITEM, &_tmp30_, -1, -1);
#line 1262 "../lib/Widgets/SourceList.vala"
		_g_object_unref0 (item);
#line 1262 "../lib/Widgets/SourceList.vala"
		item = _tmp30_;
#line 1263 "../lib/Widgets/SourceList.vala"
		_tmp31_ = item;
#line 1263 "../lib/Widgets/SourceList.vala"
		_tmp32_ = retval;
#line 1263 "../lib/Widgets/SourceList.vala"
		g_return_val_if_fail (_tmp31_ != NULL, _tmp32_);
#line 1272 "../lib/Widgets/SourceList.vala"
		_tmp33_ = item;
#line 1272 "../lib/Widgets/SourceList.vala"
		granite_widgets_source_list_data_model_update_item (self, _tmp33_);
#line 1274 "../lib/Widgets/SourceList.vala"
		_tmp34_ = item;
#line 1274 "../lib/Widgets/SourceList.vala"
		_tmp35_ = granite_widgets_source_list_item_get_parent (_tmp34_);
#line 1274 "../lib/Widgets/SourceList.vala"
		_tmp36_ = _tmp35_;
#line 1274 "../lib/Widgets/SourceList.vala"
		_tmp37_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp36_, GRANITE_WIDGETS_TYPE_SOURCE_LIST_SORTABLE) ? ((GraniteWidgetsSourceListSortable*) _tmp36_) : NULL);
#line 1274 "../lib/Widgets/SourceList.vala"
		parent = _tmp37_;
#line 1275 "../lib/Widgets/SourceList.vala"
		_tmp38_ = parent;
#line 1275 "../lib/Widgets/SourceList.vala"
		_tmp39_ = retval;
#line 1275 "../lib/Widgets/SourceList.vala"
		g_return_val_if_fail (_tmp38_ != NULL, _tmp39_);
#line 1277 "../lib/Widgets/SourceList.vala"
		_tmp40_ = parent;
#line 1277 "../lib/Widgets/SourceList.vala"
		_tmp41_ = item;
#line 1277 "../lib/Widgets/SourceList.vala"
		g_signal_emit (_tmp40_, granite_widgets_source_list_sortable_signals[GRANITE_WIDGETS_SOURCE_LIST_SORTABLE_USER_MOVED_ITEM_SIGNAL], 0, _tmp41_);
#line 1257 "../lib/Widgets/SourceList.vala"
		_g_object_unref0 (parent);
#line 1257 "../lib/Widgets/SourceList.vala"
		_g_object_unref0 (item);
#line 6179 "SourceList.c"
	}
#line 1280 "../lib/Widgets/SourceList.vala"
	result = retval;
#line 1280 "../lib/Widgets/SourceList.vala"
	__vala_GtkTreePath_free0 (prev);
#line 1280 "../lib/Widgets/SourceList.vala"
	return result;
#line 6187 "SourceList.c"
}


static void
granite_widgets_source_list_data_model_recursive_node_copy (GraniteWidgetsSourceListDataModel* self,
                                                            GtkTreeIter* src_iter,
                                                            GtkTreeIter* dest_iter)
{
	GtkTreeIter _tmp0_;
	GtkTreeIter _tmp1_;
	GtkTreeIter child = {0};
	GtkTreeStore* _tmp2_;
	GtkTreeIter _tmp3_;
	GtkTreeIter _tmp4_ = {0};
	gboolean _tmp5_;
#line 1283 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 1283 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (src_iter != NULL);
#line 1283 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (dest_iter != NULL);
#line 1284 "../lib/Widgets/SourceList.vala"
	_tmp0_ = *src_iter;
#line 1284 "../lib/Widgets/SourceList.vala"
	_tmp1_ = *dest_iter;
#line 1284 "../lib/Widgets/SourceList.vala"
	granite_widgets_source_list_data_model_move_item (self, &_tmp0_, &_tmp1_);
#line 1287 "../lib/Widgets/SourceList.vala"
	_tmp2_ = self->priv->child_tree;
#line 1287 "../lib/Widgets/SourceList.vala"
	_tmp3_ = *src_iter;
#line 1287 "../lib/Widgets/SourceList.vala"
	_tmp5_ = gtk_tree_model_iter_children ((GtkTreeModel*) _tmp2_, &_tmp4_, &_tmp3_);
#line 1287 "../lib/Widgets/SourceList.vala"
	child = _tmp4_;
#line 1287 "../lib/Widgets/SourceList.vala"
	if (_tmp5_) {
#line 6225 "SourceList.c"
		{
			gboolean _tmp6_ = FALSE;
#line 1290 "../lib/Widgets/SourceList.vala"
			_tmp6_ = TRUE;
#line 1290 "../lib/Widgets/SourceList.vala"
			while (TRUE) {
#line 6232 "SourceList.c"
				GtkTreeIter copy = {0};
				GtkTreeStore* _tmp9_;
				GtkTreeIter _tmp10_;
				GtkTreeIter _tmp11_ = {0};
				GtkTreeIter _tmp12_;
				GtkTreeIter _tmp13_;
#line 1290 "../lib/Widgets/SourceList.vala"
				if (!_tmp6_) {
#line 6241 "SourceList.c"
					GtkTreeStore* _tmp7_;
					gboolean _tmp8_;
#line 1294 "../lib/Widgets/SourceList.vala"
					_tmp7_ = self->priv->child_tree;
#line 1294 "../lib/Widgets/SourceList.vala"
					_tmp8_ = gtk_tree_model_iter_next ((GtkTreeModel*) _tmp7_, &child);
#line 1294 "../lib/Widgets/SourceList.vala"
					if (!_tmp8_) {
#line 1294 "../lib/Widgets/SourceList.vala"
						break;
#line 6252 "SourceList.c"
					}
				}
#line 1290 "../lib/Widgets/SourceList.vala"
				_tmp6_ = FALSE;
#line 1292 "../lib/Widgets/SourceList.vala"
				_tmp9_ = self->priv->child_tree;
#line 1292 "../lib/Widgets/SourceList.vala"
				_tmp10_ = *dest_iter;
#line 1292 "../lib/Widgets/SourceList.vala"
				gtk_tree_store_append (_tmp9_, &_tmp11_, &_tmp10_);
#line 1292 "../lib/Widgets/SourceList.vala"
				copy = _tmp11_;
#line 1293 "../lib/Widgets/SourceList.vala"
				_tmp12_ = child;
#line 1293 "../lib/Widgets/SourceList.vala"
				_tmp13_ = copy;
#line 1293 "../lib/Widgets/SourceList.vala"
				granite_widgets_source_list_data_model_recursive_node_copy (self, &_tmp12_, &_tmp13_);
#line 6271 "SourceList.c"
			}
		}
	}
}


static void
granite_widgets_source_list_data_model_move_item (GraniteWidgetsSourceListDataModel* self,
                                                  GtkTreeIter* src_iter,
                                                  GtkTreeIter* dest_iter)
{
	GraniteWidgetsSourceListItem* item = NULL;
	GtkTreeStore* _tmp0_;
	GtkTreeIter _tmp1_;
	GraniteWidgetsSourceListItem* _tmp2_ = NULL;
	GtkTreeStore* _tmp3_;
	GtkTreeIter _tmp4_;
	GeeHashMap* _tmp5_;
	GtkTreeStore* _tmp6_;
	GtkTreeIter _tmp7_;
	GraniteWidgetsSourceListDataModelNodeWrapper* _tmp8_;
	GraniteWidgetsSourceListDataModelNodeWrapper* _tmp9_;
#line 1298 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 1298 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (src_iter != NULL);
#line 1298 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (dest_iter != NULL);
#line 1300 "../lib/Widgets/SourceList.vala"
	_tmp0_ = self->priv->child_tree;
#line 1300 "../lib/Widgets/SourceList.vala"
	_tmp1_ = *src_iter;
#line 1300 "../lib/Widgets/SourceList.vala"
	gtk_tree_model_get ((GtkTreeModel*) _tmp0_, &_tmp1_, GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_COLUMN_ITEM, &_tmp2_, -1, -1);
#line 1300 "../lib/Widgets/SourceList.vala"
	_g_object_unref0 (item);
#line 1300 "../lib/Widgets/SourceList.vala"
	item = _tmp2_;
#line 1301 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (item != NULL);
#line 1304 "../lib/Widgets/SourceList.vala"
	_tmp3_ = self->priv->child_tree;
#line 1304 "../lib/Widgets/SourceList.vala"
	_tmp4_ = *dest_iter;
#line 1304 "../lib/Widgets/SourceList.vala"
	gtk_tree_store_set (_tmp3_, &_tmp4_, GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_COLUMN_ITEM, item, -1, -1);
#line 1305 "../lib/Widgets/SourceList.vala"
	_tmp5_ = self->priv->items;
#line 1305 "../lib/Widgets/SourceList.vala"
	_tmp6_ = self->priv->child_tree;
#line 1305 "../lib/Widgets/SourceList.vala"
	_tmp7_ = *dest_iter;
#line 1305 "../lib/Widgets/SourceList.vala"
	_tmp8_ = granite_widgets_source_list_data_model_node_wrapper_new ((GtkTreeModel*) _tmp6_, &_tmp7_);
#line 1305 "../lib/Widgets/SourceList.vala"
	_tmp9_ = _tmp8_;
#line 1305 "../lib/Widgets/SourceList.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp5_, item, _tmp9_);
#line 1305 "../lib/Widgets/SourceList.vala"
	_granite_widgets_source_list_data_model_node_wrapper_unref0 (_tmp9_);
#line 1298 "../lib/Widgets/SourceList.vala"
	_g_object_unref0 (item);
#line 6334 "SourceList.c"
}


static gint*
_vala_array_dup4 (gint* self,
                  int length)
{
#line 1352 "../lib/Widgets/SourceList.vala"
	return g_memdup (self, length * sizeof (gint));
#line 6344 "SourceList.c"
}


static gint*
_vala_array_dup5 (gint* self,
                  int length)
{
#line 1353 "../lib/Widgets/SourceList.vala"
	return g_memdup (self, length * sizeof (gint));
#line 6354 "SourceList.c"
}


static gboolean
granite_widgets_source_list_data_model_real_row_drop_possible (GtkTreeDragDest* base,
                                                               GtkTreePath* dest,
                                                               GtkSelectionData* selection_data)
{
	GraniteWidgetsSourceListDataModel * self;
	gboolean result = FALSE;
	GtkTreeModel* model = NULL;
	GtkTreePath* src_path = NULL;
	gboolean _tmp0_ = FALSE;
	GtkTreeModel* _tmp1_ = NULL;
	GtkTreePath* _tmp2_ = NULL;
	gboolean _tmp3_;
	GtkTreeModel* _tmp4_;
	GtkTreePath* child_dest = NULL;
	GtkTreePath* _tmp7_;
	gboolean _tmp8_ = FALSE;
	GtkTreePath* _tmp9_;
	gint src_depth = 0;
	GtkTreePath* _tmp12_;
	gint dest_depth = 0;
	GtkTreePath* _tmp13_;
	gint _tmp14_;
	gint _tmp15_;
	gint _tmp16_;
	GraniteWidgetsSourceListItem* parent = NULL;
	gint _tmp17_;
	GraniteWidgetsSourceListSortable* sortable = NULL;
	GraniteWidgetsSourceListItem* _tmp44_;
	GraniteWidgetsSourceListSortable* _tmp45_;
	gboolean _tmp46_ = FALSE;
	GraniteWidgetsSourceListSortable* _tmp47_;
	GraniteWidgetsSourceListItem* dest_item = NULL;
	GraniteWidgetsSourceListItem* _tmp49_;
	GraniteWidgetsSourceListItem* _tmp50_;
	GraniteWidgetsSourceListItem* source_item = NULL;
	GtkTreePath* filter_src_path = NULL;
	GtkTreePath* _tmp51_;
	GtkTreePath* _tmp52_;
	GtkTreePath* _tmp53_;
	GraniteWidgetsSourceListItem* _tmp56_;
	GraniteWidgetsSourceListSortable* _tmp57_;
	GraniteWidgetsSourceListItem* _tmp58_;
	GraniteWidgetsSourceListItem* _tmp59_;
#line 1308 "../lib/Widgets/SourceList.vala"
	self = (GraniteWidgetsSourceListDataModel*) base;
#line 1308 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (dest != NULL, FALSE);
#line 1308 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (selection_data != NULL, FALSE);
#line 1315 "../lib/Widgets/SourceList.vala"
	_tmp3_ = gtk_tree_get_row_drag_data (selection_data, &_tmp1_, &_tmp2_);
#line 1315 "../lib/Widgets/SourceList.vala"
	_g_object_unref0 (model);
#line 1315 "../lib/Widgets/SourceList.vala"
	_tmp4_ = _g_object_ref0 (_tmp1_);
#line 1315 "../lib/Widgets/SourceList.vala"
	model = _tmp4_;
#line 1315 "../lib/Widgets/SourceList.vala"
	__vala_GtkTreePath_free0 (src_path);
#line 1315 "../lib/Widgets/SourceList.vala"
	src_path = _tmp2_;
#line 1315 "../lib/Widgets/SourceList.vala"
	if (!_tmp3_) {
#line 1315 "../lib/Widgets/SourceList.vala"
		_tmp0_ = TRUE;
#line 6424 "SourceList.c"
	} else {
		GtkTreeModel* _tmp5_;
		GtkTreeStore* _tmp6_;
#line 1315 "../lib/Widgets/SourceList.vala"
		_tmp5_ = model;
#line 1315 "../lib/Widgets/SourceList.vala"
		_tmp6_ = self->priv->child_tree;
#line 1315 "../lib/Widgets/SourceList.vala"
		_tmp0_ = _tmp5_ != _tmp6_;
#line 6434 "SourceList.c"
	}
#line 1315 "../lib/Widgets/SourceList.vala"
	if (_tmp0_) {
#line 1316 "../lib/Widgets/SourceList.vala"
		result = FALSE;
#line 1316 "../lib/Widgets/SourceList.vala"
		__vala_GtkTreePath_free0 (src_path);
#line 1316 "../lib/Widgets/SourceList.vala"
		_g_object_unref0 (model);
#line 1316 "../lib/Widgets/SourceList.vala"
		return result;
#line 6446 "SourceList.c"
	}
#line 1319 "../lib/Widgets/SourceList.vala"
	_tmp7_ = gtk_tree_model_filter_convert_path_to_child_path ((GtkTreeModelFilter*) self, dest);
#line 1319 "../lib/Widgets/SourceList.vala"
	child_dest = _tmp7_;
#line 1322 "../lib/Widgets/SourceList.vala"
	_tmp9_ = child_dest;
#line 1322 "../lib/Widgets/SourceList.vala"
	if (_tmp9_ == NULL) {
#line 1322 "../lib/Widgets/SourceList.vala"
		_tmp8_ = TRUE;
#line 6458 "SourceList.c"
	} else {
		GtkTreePath* _tmp10_;
		GtkTreePath* _tmp11_;
#line 1322 "../lib/Widgets/SourceList.vala"
		_tmp10_ = src_path;
#line 1322 "../lib/Widgets/SourceList.vala"
		_tmp11_ = child_dest;
#line 1322 "../lib/Widgets/SourceList.vala"
		_tmp8_ = gtk_tree_path_compare (_tmp10_, _tmp11_) == 0;
#line 6468 "SourceList.c"
	}
#line 1322 "../lib/Widgets/SourceList.vala"
	if (_tmp8_) {
#line 1323 "../lib/Widgets/SourceList.vala"
		result = FALSE;
#line 1323 "../lib/Widgets/SourceList.vala"
		__vala_GtkTreePath_free0 (child_dest);
#line 1323 "../lib/Widgets/SourceList.vala"
		__vala_GtkTreePath_free0 (src_path);
#line 1323 "../lib/Widgets/SourceList.vala"
		_g_object_unref0 (model);
#line 1323 "../lib/Widgets/SourceList.vala"
		return result;
#line 6482 "SourceList.c"
	}
#line 1327 "../lib/Widgets/SourceList.vala"
	_tmp12_ = src_path;
#line 1327 "../lib/Widgets/SourceList.vala"
	src_depth = gtk_tree_path_get_depth (_tmp12_);
#line 1328 "../lib/Widgets/SourceList.vala"
	_tmp13_ = child_dest;
#line 1328 "../lib/Widgets/SourceList.vala"
	dest_depth = gtk_tree_path_get_depth (_tmp13_);
#line 1330 "../lib/Widgets/SourceList.vala"
	_tmp14_ = src_depth;
#line 1330 "../lib/Widgets/SourceList.vala"
	_tmp15_ = dest_depth;
#line 1330 "../lib/Widgets/SourceList.vala"
	if (_tmp14_ != _tmp15_) {
#line 1331 "../lib/Widgets/SourceList.vala"
		result = FALSE;
#line 1331 "../lib/Widgets/SourceList.vala"
		__vala_GtkTreePath_free0 (child_dest);
#line 1331 "../lib/Widgets/SourceList.vala"
		__vala_GtkTreePath_free0 (src_path);
#line 1331 "../lib/Widgets/SourceList.vala"
		_g_object_unref0 (model);
#line 1331 "../lib/Widgets/SourceList.vala"
		return result;
#line 6508 "SourceList.c"
	}
#line 1334 "../lib/Widgets/SourceList.vala"
	_tmp16_ = src_depth;
#line 1334 "../lib/Widgets/SourceList.vala"
	if (_tmp16_ < 1) {
#line 1335 "../lib/Widgets/SourceList.vala"
		result = FALSE;
#line 1335 "../lib/Widgets/SourceList.vala"
		__vala_GtkTreePath_free0 (child_dest);
#line 1335 "../lib/Widgets/SourceList.vala"
		__vala_GtkTreePath_free0 (src_path);
#line 1335 "../lib/Widgets/SourceList.vala"
		_g_object_unref0 (model);
#line 1335 "../lib/Widgets/SourceList.vala"
		return result;
#line 6524 "SourceList.c"
	}
#line 1337 "../lib/Widgets/SourceList.vala"
	parent = NULL;
#line 1342 "../lib/Widgets/SourceList.vala"
	_tmp17_ = src_depth;
#line 1342 "../lib/Widgets/SourceList.vala"
	if (_tmp17_ == 1) {
#line 6532 "SourceList.c"
		GraniteWidgetsSourceListExpandableItem* _tmp18_;
		GraniteWidgetsSourceListExpandableItem* _tmp19_;
		GraniteWidgetsSourceListItem* _tmp20_;
#line 1343 "../lib/Widgets/SourceList.vala"
		_tmp18_ = granite_widgets_source_list_data_model_get_root (self);
#line 1343 "../lib/Widgets/SourceList.vala"
		_tmp19_ = _tmp18_;
#line 1343 "../lib/Widgets/SourceList.vala"
		_tmp20_ = _g_object_ref0 ((GraniteWidgetsSourceListItem*) _tmp19_);
#line 1343 "../lib/Widgets/SourceList.vala"
		_g_object_unref0 (parent);
#line 1343 "../lib/Widgets/SourceList.vala"
		parent = _tmp20_;
#line 6546 "SourceList.c"
	} else {
		gint _tmp21_;
		gint* src_indices = NULL;
		GtkTreePath* _tmp22_;
		gint _tmp23_ = 0;
		gint* _tmp24_;
		gint* _tmp25_;
		gint _tmp25__length1;
		gint src_indices_length1;
		gint _src_indices_size_;
		gint* dest_indices = NULL;
		GtkTreePath* _tmp26_;
		gint _tmp27_ = 0;
		gint* _tmp28_;
		gint* _tmp29_;
		gint _tmp29__length1;
		gint dest_indices_length1;
		gint _dest_indices_size_;
		gint src_parent_index = 0;
		gint* _tmp30_;
		gint _tmp30__length1;
		gint _tmp31_;
		gint _tmp32_;
		gint dest_parent_index = 0;
		gint* _tmp33_;
		gint _tmp33__length1;
		gint _tmp34_;
		gint _tmp35_;
		gint _tmp36_;
		gint _tmp37_;
		GtkTreePath* dest_parent = NULL;
		GtkTreePath* _tmp38_;
		gboolean _tmp39_ = FALSE;
		GtkTreePath* _tmp40_;
		GtkTreePath* _tmp42_;
		GraniteWidgetsSourceListItem* _tmp43_;
#line 1346 "../lib/Widgets/SourceList.vala"
		_tmp21_ = dest_depth;
#line 1346 "../lib/Widgets/SourceList.vala"
		_vala_assert (_tmp21_ > 1, "dest_depth > 1");
#line 1352 "../lib/Widgets/SourceList.vala"
		_tmp22_ = src_path;
#line 1352 "../lib/Widgets/SourceList.vala"
		_tmp24_ = gtk_tree_path_get_indices_with_depth (_tmp22_, &_tmp23_);
#line 1352 "../lib/Widgets/SourceList.vala"
		_tmp25_ = (_tmp24_ != NULL) ? _vala_array_dup4 (_tmp24_, _tmp23_) : ((gpointer) _tmp24_);
#line 1352 "../lib/Widgets/SourceList.vala"
		_tmp25__length1 = _tmp23_;
#line 1352 "../lib/Widgets/SourceList.vala"
		src_indices = _tmp25_;
#line 1352 "../lib/Widgets/SourceList.vala"
		src_indices_length1 = _tmp25__length1;
#line 1352 "../lib/Widgets/SourceList.vala"
		_src_indices_size_ = src_indices_length1;
#line 1353 "../lib/Widgets/SourceList.vala"
		_tmp26_ = child_dest;
#line 1353 "../lib/Widgets/SourceList.vala"
		_tmp28_ = gtk_tree_path_get_indices_with_depth (_tmp26_, &_tmp27_);
#line 1353 "../lib/Widgets/SourceList.vala"
		_tmp29_ = (_tmp28_ != NULL) ? _vala_array_dup5 (_tmp28_, _tmp27_) : ((gpointer) _tmp28_);
#line 1353 "../lib/Widgets/SourceList.vala"
		_tmp29__length1 = _tmp27_;
#line 1353 "../lib/Widgets/SourceList.vala"
		dest_indices = _tmp29_;
#line 1353 "../lib/Widgets/SourceList.vala"
		dest_indices_length1 = _tmp29__length1;
#line 1353 "../lib/Widgets/SourceList.vala"
		_dest_indices_size_ = dest_indices_length1;
#line 1356 "../lib/Widgets/SourceList.vala"
		_tmp30_ = src_indices;
#line 1356 "../lib/Widgets/SourceList.vala"
		_tmp30__length1 = src_indices_length1;
#line 1356 "../lib/Widgets/SourceList.vala"
		_tmp31_ = src_depth;
#line 1356 "../lib/Widgets/SourceList.vala"
		_tmp32_ = _tmp30_[_tmp31_ - 2];
#line 1356 "../lib/Widgets/SourceList.vala"
		src_parent_index = _tmp32_;
#line 1357 "../lib/Widgets/SourceList.vala"
		_tmp33_ = dest_indices;
#line 1357 "../lib/Widgets/SourceList.vala"
		_tmp33__length1 = dest_indices_length1;
#line 1357 "../lib/Widgets/SourceList.vala"
		_tmp34_ = dest_depth;
#line 1357 "../lib/Widgets/SourceList.vala"
		_tmp35_ = _tmp33_[_tmp34_ - 2];
#line 1357 "../lib/Widgets/SourceList.vala"
		dest_parent_index = _tmp35_;
#line 1359 "../lib/Widgets/SourceList.vala"
		_tmp36_ = src_parent_index;
#line 1359 "../lib/Widgets/SourceList.vala"
		_tmp37_ = dest_parent_index;
#line 1359 "../lib/Widgets/SourceList.vala"
		if (_tmp36_ != _tmp37_) {
#line 1360 "../lib/Widgets/SourceList.vala"
			result = FALSE;
#line 1360 "../lib/Widgets/SourceList.vala"
			dest_indices = (g_free (dest_indices), NULL);
#line 1360 "../lib/Widgets/SourceList.vala"
			src_indices = (g_free (src_indices), NULL);
#line 1360 "../lib/Widgets/SourceList.vala"
			_g_object_unref0 (parent);
#line 1360 "../lib/Widgets/SourceList.vala"
			__vala_GtkTreePath_free0 (child_dest);
#line 1360 "../lib/Widgets/SourceList.vala"
			__vala_GtkTreePath_free0 (src_path);
#line 1360 "../lib/Widgets/SourceList.vala"
			_g_object_unref0 (model);
#line 1360 "../lib/Widgets/SourceList.vala"
			return result;
#line 6657 "SourceList.c"
		}
#line 1363 "../lib/Widgets/SourceList.vala"
		_tmp38_ = __vala_GtkTreePath_copy0 (dest);
#line 1363 "../lib/Widgets/SourceList.vala"
		dest_parent = _tmp38_;
#line 1365 "../lib/Widgets/SourceList.vala"
		_tmp40_ = dest_parent;
#line 1365 "../lib/Widgets/SourceList.vala"
		if (!gtk_tree_path_up (_tmp40_)) {
#line 1365 "../lib/Widgets/SourceList.vala"
			_tmp39_ = TRUE;
#line 6669 "SourceList.c"
		} else {
			GtkTreePath* _tmp41_;
#line 1365 "../lib/Widgets/SourceList.vala"
			_tmp41_ = dest_parent;
#line 1365 "../lib/Widgets/SourceList.vala"
			_tmp39_ = gtk_tree_path_get_depth (_tmp41_) < 1;
#line 6676 "SourceList.c"
		}
#line 1365 "../lib/Widgets/SourceList.vala"
		if (_tmp39_) {
#line 1366 "../lib/Widgets/SourceList.vala"
			result = FALSE;
#line 1366 "../lib/Widgets/SourceList.vala"
			__vala_GtkTreePath_free0 (dest_parent);
#line 1366 "../lib/Widgets/SourceList.vala"
			dest_indices = (g_free (dest_indices), NULL);
#line 1366 "../lib/Widgets/SourceList.vala"
			src_indices = (g_free (src_indices), NULL);
#line 1366 "../lib/Widgets/SourceList.vala"
			_g_object_unref0 (parent);
#line 1366 "../lib/Widgets/SourceList.vala"
			__vala_GtkTreePath_free0 (child_dest);
#line 1366 "../lib/Widgets/SourceList.vala"
			__vala_GtkTreePath_free0 (src_path);
#line 1366 "../lib/Widgets/SourceList.vala"
			_g_object_unref0 (model);
#line 1366 "../lib/Widgets/SourceList.vala"
			return result;
#line 6698 "SourceList.c"
		}
#line 1368 "../lib/Widgets/SourceList.vala"
		_tmp42_ = dest_parent;
#line 1368 "../lib/Widgets/SourceList.vala"
		_tmp43_ = granite_widgets_source_list_data_model_get_item_from_path (self, _tmp42_);
#line 1368 "../lib/Widgets/SourceList.vala"
		_g_object_unref0 (parent);
#line 1368 "../lib/Widgets/SourceList.vala"
		parent = _tmp43_;
#line 1342 "../lib/Widgets/SourceList.vala"
		__vala_GtkTreePath_free0 (dest_parent);
#line 1342 "../lib/Widgets/SourceList.vala"
		dest_indices = (g_free (dest_indices), NULL);
#line 1342 "../lib/Widgets/SourceList.vala"
		src_indices = (g_free (src_indices), NULL);
#line 6714 "SourceList.c"
	}
#line 1371 "../lib/Widgets/SourceList.vala"
	_tmp44_ = parent;
#line 1371 "../lib/Widgets/SourceList.vala"
	_tmp45_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp44_, GRANITE_WIDGETS_TYPE_SOURCE_LIST_SORTABLE) ? ((GraniteWidgetsSourceListSortable*) _tmp44_) : NULL);
#line 1371 "../lib/Widgets/SourceList.vala"
	sortable = _tmp45_;
#line 1373 "../lib/Widgets/SourceList.vala"
	_tmp47_ = sortable;
#line 1373 "../lib/Widgets/SourceList.vala"
	if (_tmp47_ == NULL) {
#line 1373 "../lib/Widgets/SourceList.vala"
		_tmp46_ = TRUE;
#line 6728 "SourceList.c"
	} else {
		GraniteWidgetsSourceListSortable* _tmp48_;
#line 1373 "../lib/Widgets/SourceList.vala"
		_tmp48_ = sortable;
#line 1373 "../lib/Widgets/SourceList.vala"
		_tmp46_ = !granite_widgets_source_list_sortable_allow_dnd_sorting (_tmp48_);
#line 6735 "SourceList.c"
	}
#line 1373 "../lib/Widgets/SourceList.vala"
	if (_tmp46_) {
#line 1374 "../lib/Widgets/SourceList.vala"
		result = FALSE;
#line 1374 "../lib/Widgets/SourceList.vala"
		_g_object_unref0 (sortable);
#line 1374 "../lib/Widgets/SourceList.vala"
		_g_object_unref0 (parent);
#line 1374 "../lib/Widgets/SourceList.vala"
		__vala_GtkTreePath_free0 (child_dest);
#line 1374 "../lib/Widgets/SourceList.vala"
		__vala_GtkTreePath_free0 (src_path);
#line 1374 "../lib/Widgets/SourceList.vala"
		_g_object_unref0 (model);
#line 1374 "../lib/Widgets/SourceList.vala"
		return result;
#line 6753 "SourceList.c"
	}
#line 1376 "../lib/Widgets/SourceList.vala"
	_tmp49_ = granite_widgets_source_list_data_model_get_item_from_path (self, dest);
#line 1376 "../lib/Widgets/SourceList.vala"
	dest_item = _tmp49_;
#line 1378 "../lib/Widgets/SourceList.vala"
	_tmp50_ = dest_item;
#line 1378 "../lib/Widgets/SourceList.vala"
	if (_tmp50_ == NULL) {
#line 1379 "../lib/Widgets/SourceList.vala"
		result = TRUE;
#line 1379 "../lib/Widgets/SourceList.vala"
		_g_object_unref0 (dest_item);
#line 1379 "../lib/Widgets/SourceList.vala"
		_g_object_unref0 (sortable);
#line 1379 "../lib/Widgets/SourceList.vala"
		_g_object_unref0 (parent);
#line 1379 "../lib/Widgets/SourceList.vala"
		__vala_GtkTreePath_free0 (child_dest);
#line 1379 "../lib/Widgets/SourceList.vala"
		__vala_GtkTreePath_free0 (src_path);
#line 1379 "../lib/Widgets/SourceList.vala"
		_g_object_unref0 (model);
#line 1379 "../lib/Widgets/SourceList.vala"
		return result;
#line 6779 "SourceList.c"
	}
#line 1381 "../lib/Widgets/SourceList.vala"
	source_item = NULL;
#line 1382 "../lib/Widgets/SourceList.vala"
	_tmp51_ = src_path;
#line 1382 "../lib/Widgets/SourceList.vala"
	_tmp52_ = gtk_tree_model_filter_convert_child_path_to_path ((GtkTreeModelFilter*) self, _tmp51_);
#line 1382 "../lib/Widgets/SourceList.vala"
	filter_src_path = _tmp52_;
#line 1384 "../lib/Widgets/SourceList.vala"
	_tmp53_ = filter_src_path;
#line 1384 "../lib/Widgets/SourceList.vala"
	if (_tmp53_ != NULL) {
#line 6793 "SourceList.c"
		GtkTreePath* _tmp54_;
		GraniteWidgetsSourceListItem* _tmp55_;
#line 1385 "../lib/Widgets/SourceList.vala"
		_tmp54_ = filter_src_path;
#line 1385 "../lib/Widgets/SourceList.vala"
		_tmp55_ = granite_widgets_source_list_data_model_get_item_from_path (self, _tmp54_);
#line 1385 "../lib/Widgets/SourceList.vala"
		_g_object_unref0 (source_item);
#line 1385 "../lib/Widgets/SourceList.vala"
		source_item = _tmp55_;
#line 6804 "SourceList.c"
	}
#line 1387 "../lib/Widgets/SourceList.vala"
	_tmp56_ = source_item;
#line 1387 "../lib/Widgets/SourceList.vala"
	if (_tmp56_ == NULL) {
#line 1388 "../lib/Widgets/SourceList.vala"
		result = FALSE;
#line 1388 "../lib/Widgets/SourceList.vala"
		__vala_GtkTreePath_free0 (filter_src_path);
#line 1388 "../lib/Widgets/SourceList.vala"
		_g_object_unref0 (source_item);
#line 1388 "../lib/Widgets/SourceList.vala"
		_g_object_unref0 (dest_item);
#line 1388 "../lib/Widgets/SourceList.vala"
		_g_object_unref0 (sortable);
#line 1388 "../lib/Widgets/SourceList.vala"
		_g_object_unref0 (parent);
#line 1388 "../lib/Widgets/SourceList.vala"
		__vala_GtkTreePath_free0 (child_dest);
#line 1388 "../lib/Widgets/SourceList.vala"
		__vala_GtkTreePath_free0 (src_path);
#line 1388 "../lib/Widgets/SourceList.vala"
		_g_object_unref0 (model);
#line 1388 "../lib/Widgets/SourceList.vala"
		return result;
#line 6830 "SourceList.c"
	}
#line 1396 "../lib/Widgets/SourceList.vala"
	_tmp57_ = sortable;
#line 1396 "../lib/Widgets/SourceList.vala"
	_tmp58_ = dest_item;
#line 1396 "../lib/Widgets/SourceList.vala"
	_tmp59_ = source_item;
#line 1396 "../lib/Widgets/SourceList.vala"
	if (granite_widgets_source_list_sortable_compare (_tmp57_, _tmp58_, _tmp59_) >= 0) {
#line 6840 "SourceList.c"
		GraniteWidgetsSourceListItem* dest_item_prev = NULL;
		GraniteWidgetsSourceListItem* _tmp60_;
		gboolean _tmp61_ = FALSE;
		gboolean _tmp62_ = FALSE;
		GraniteWidgetsSourceListItem* _tmp63_;
#line 1397 "../lib/Widgets/SourceList.vala"
		if (!gtk_tree_path_prev (dest)) {
#line 1398 "../lib/Widgets/SourceList.vala"
			result = TRUE;
#line 1398 "../lib/Widgets/SourceList.vala"
			__vala_GtkTreePath_free0 (filter_src_path);
#line 1398 "../lib/Widgets/SourceList.vala"
			_g_object_unref0 (source_item);
#line 1398 "../lib/Widgets/SourceList.vala"
			_g_object_unref0 (dest_item);
#line 1398 "../lib/Widgets/SourceList.vala"
			_g_object_unref0 (sortable);
#line 1398 "../lib/Widgets/SourceList.vala"
			_g_object_unref0 (parent);
#line 1398 "../lib/Widgets/SourceList.vala"
			__vala_GtkTreePath_free0 (child_dest);
#line 1398 "../lib/Widgets/SourceList.vala"
			__vala_GtkTreePath_free0 (src_path);
#line 1398 "../lib/Widgets/SourceList.vala"
			_g_object_unref0 (model);
#line 1398 "../lib/Widgets/SourceList.vala"
			return result;
#line 6868 "SourceList.c"
		}
#line 1402 "../lib/Widgets/SourceList.vala"
		_tmp60_ = granite_widgets_source_list_data_model_get_item_from_path (self, dest);
#line 1402 "../lib/Widgets/SourceList.vala"
		dest_item_prev = _tmp60_;
#line 1404 "../lib/Widgets/SourceList.vala"
		_tmp63_ = dest_item_prev;
#line 1404 "../lib/Widgets/SourceList.vala"
		if (_tmp63_ != NULL) {
#line 6878 "SourceList.c"
			GraniteWidgetsSourceListItem* _tmp64_;
			GraniteWidgetsSourceListItem* _tmp65_;
#line 1405 "../lib/Widgets/SourceList.vala"
			_tmp64_ = dest_item_prev;
#line 1405 "../lib/Widgets/SourceList.vala"
			_tmp65_ = source_item;
#line 1405 "../lib/Widgets/SourceList.vala"
			_tmp62_ = _tmp64_ != _tmp65_;
#line 6887 "SourceList.c"
		} else {
#line 1404 "../lib/Widgets/SourceList.vala"
			_tmp62_ = FALSE;
#line 6891 "SourceList.c"
		}
#line 1404 "../lib/Widgets/SourceList.vala"
		if (_tmp62_) {
#line 6895 "SourceList.c"
			GraniteWidgetsSourceListSortable* _tmp66_;
			GraniteWidgetsSourceListItem* _tmp67_;
			GraniteWidgetsSourceListItem* _tmp68_;
#line 1406 "../lib/Widgets/SourceList.vala"
			_tmp66_ = sortable;
#line 1406 "../lib/Widgets/SourceList.vala"
			_tmp67_ = dest_item_prev;
#line 1406 "../lib/Widgets/SourceList.vala"
			_tmp68_ = source_item;
#line 1406 "../lib/Widgets/SourceList.vala"
			_tmp61_ = granite_widgets_source_list_sortable_compare (_tmp66_, _tmp67_, _tmp68_) <= 0;
#line 6907 "SourceList.c"
		} else {
#line 1404 "../lib/Widgets/SourceList.vala"
			_tmp61_ = FALSE;
#line 6911 "SourceList.c"
		}
#line 1404 "../lib/Widgets/SourceList.vala"
		result = _tmp61_;
#line 1404 "../lib/Widgets/SourceList.vala"
		_g_object_unref0 (dest_item_prev);
#line 1404 "../lib/Widgets/SourceList.vala"
		__vala_GtkTreePath_free0 (filter_src_path);
#line 1404 "../lib/Widgets/SourceList.vala"
		_g_object_unref0 (source_item);
#line 1404 "../lib/Widgets/SourceList.vala"
		_g_object_unref0 (dest_item);
#line 1404 "../lib/Widgets/SourceList.vala"
		_g_object_unref0 (sortable);
#line 1404 "../lib/Widgets/SourceList.vala"
		_g_object_unref0 (parent);
#line 1404 "../lib/Widgets/SourceList.vala"
		__vala_GtkTreePath_free0 (child_dest);
#line 1404 "../lib/Widgets/SourceList.vala"
		__vala_GtkTreePath_free0 (src_path);
#line 1404 "../lib/Widgets/SourceList.vala"
		_g_object_unref0 (model);
#line 1404 "../lib/Widgets/SourceList.vala"
		return result;
#line 6935 "SourceList.c"
	}
#line 1409 "../lib/Widgets/SourceList.vala"
	result = FALSE;
#line 1409 "../lib/Widgets/SourceList.vala"
	__vala_GtkTreePath_free0 (filter_src_path);
#line 1409 "../lib/Widgets/SourceList.vala"
	_g_object_unref0 (source_item);
#line 1409 "../lib/Widgets/SourceList.vala"
	_g_object_unref0 (dest_item);
#line 1409 "../lib/Widgets/SourceList.vala"
	_g_object_unref0 (sortable);
#line 1409 "../lib/Widgets/SourceList.vala"
	_g_object_unref0 (parent);
#line 1409 "../lib/Widgets/SourceList.vala"
	__vala_GtkTreePath_free0 (child_dest);
#line 1409 "../lib/Widgets/SourceList.vala"
	__vala_GtkTreePath_free0 (src_path);
#line 1409 "../lib/Widgets/SourceList.vala"
	_g_object_unref0 (model);
#line 1409 "../lib/Widgets/SourceList.vala"
	return result;
#line 6957 "SourceList.c"
}


/**
         * Override default implementation of TreeDragSource
         *
         * drag_data_delete is not overriden because the default implementation
         * does exactly what we need.
         */
static gboolean
granite_widgets_source_list_data_model_real_drag_data_get (GtkTreeDragSource* base,
                                                           GtkTreePath* path,
                                                           GtkSelectionData* selection_data)
{
	GraniteWidgetsSourceListDataModel * self;
	gboolean result = FALSE;
	GraniteWidgetsSourceListDragSource* drag_source_item = NULL;
	GraniteWidgetsSourceListItem* _tmp0_;
	GraniteWidgetsSourceListDragSource* _tmp1_;
	gboolean _tmp2_ = FALSE;
	GraniteWidgetsSourceListDragSource* _tmp3_;
#line 1419 "../lib/Widgets/SourceList.vala"
	self = (GraniteWidgetsSourceListDataModel*) base;
#line 1419 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 1419 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (selection_data != NULL, FALSE);
#line 1422 "../lib/Widgets/SourceList.vala"
	if (gtk_selection_data_get_target (selection_data) == gdk_atom_intern_static_string ("GTK_TREE_MODEL_ROW")) {
#line 1423 "../lib/Widgets/SourceList.vala"
		result = granite_widgets_source_list_data_model_gtk_tree_drag_source_parent_iface->drag_data_get ((GtkTreeDragSource*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_tree_model_filter_get_type (), GtkTreeModelFilter), path, selection_data);
#line 1423 "../lib/Widgets/SourceList.vala"
		return result;
#line 6991 "SourceList.c"
	}
#line 1426 "../lib/Widgets/SourceList.vala"
	_tmp0_ = granite_widgets_source_list_data_model_get_item_from_path (self, path);
#line 1426 "../lib/Widgets/SourceList.vala"
	_tmp1_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, GRANITE_WIDGETS_TYPE_SOURCE_LIST_DRAG_SOURCE) ? ((GraniteWidgetsSourceListDragSource*) _tmp0_) : NULL;
#line 1426 "../lib/Widgets/SourceList.vala"
	if (_tmp1_ == NULL) {
#line 1426 "../lib/Widgets/SourceList.vala"
		_g_object_unref0 (_tmp0_);
#line 7001 "SourceList.c"
	}
#line 1426 "../lib/Widgets/SourceList.vala"
	drag_source_item = _tmp1_;
#line 1427 "../lib/Widgets/SourceList.vala"
	_tmp3_ = drag_source_item;
#line 1427 "../lib/Widgets/SourceList.vala"
	if (_tmp3_ != NULL) {
#line 7009 "SourceList.c"
		GraniteWidgetsSourceListDragSource* _tmp4_;
#line 1427 "../lib/Widgets/SourceList.vala"
		_tmp4_ = drag_source_item;
#line 1427 "../lib/Widgets/SourceList.vala"
		_tmp2_ = granite_widgets_source_list_drag_source_draggable (_tmp4_);
#line 7015 "SourceList.c"
	} else {
#line 1427 "../lib/Widgets/SourceList.vala"
		_tmp2_ = FALSE;
#line 7019 "SourceList.c"
	}
#line 1427 "../lib/Widgets/SourceList.vala"
	if (_tmp2_) {
#line 7023 "SourceList.c"
		GraniteWidgetsSourceListDragSource* _tmp5_;
#line 1428 "../lib/Widgets/SourceList.vala"
		_tmp5_ = drag_source_item;
#line 1428 "../lib/Widgets/SourceList.vala"
		granite_widgets_source_list_drag_source_prepare_selection_data (_tmp5_, selection_data);
#line 1429 "../lib/Widgets/SourceList.vala"
		result = TRUE;
#line 1429 "../lib/Widgets/SourceList.vala"
		_g_object_unref0 (drag_source_item);
#line 1429 "../lib/Widgets/SourceList.vala"
		return result;
#line 7035 "SourceList.c"
	}
#line 1432 "../lib/Widgets/SourceList.vala"
	result = FALSE;
#line 1432 "../lib/Widgets/SourceList.vala"
	_g_object_unref0 (drag_source_item);
#line 1432 "../lib/Widgets/SourceList.vala"
	return result;
#line 7043 "SourceList.c"
}


static gboolean
granite_widgets_source_list_data_model_real_row_draggable (GtkTreeDragSource* base,
                                                           GtkTreePath* path)
{
	GraniteWidgetsSourceListDataModel * self;
	gboolean result = FALSE;
	GraniteWidgetsSourceListItem* item = NULL;
	GraniteWidgetsSourceListItem* _tmp0_;
	GraniteWidgetsSourceListItem* _tmp1_;
#line 1435 "../lib/Widgets/SourceList.vala"
	self = (GraniteWidgetsSourceListDataModel*) base;
#line 1435 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 1436 "../lib/Widgets/SourceList.vala"
	if (!granite_widgets_source_list_data_model_gtk_tree_drag_source_parent_iface->row_draggable ((GtkTreeDragSource*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_tree_model_filter_get_type (), GtkTreeModelFilter), path)) {
#line 1437 "../lib/Widgets/SourceList.vala"
		result = FALSE;
#line 1437 "../lib/Widgets/SourceList.vala"
		return result;
#line 7066 "SourceList.c"
	}
#line 1439 "../lib/Widgets/SourceList.vala"
	_tmp0_ = granite_widgets_source_list_data_model_get_item_from_path (self, path);
#line 1439 "../lib/Widgets/SourceList.vala"
	item = _tmp0_;
#line 1441 "../lib/Widgets/SourceList.vala"
	_tmp1_ = item;
#line 1441 "../lib/Widgets/SourceList.vala"
	if (_tmp1_ != NULL) {
#line 7076 "SourceList.c"
		GraniteWidgetsSourceListSortable* sortable_item = NULL;
		GraniteWidgetsSourceListItem* _tmp2_;
		GraniteWidgetsSourceListExpandableItem* _tmp3_;
		GraniteWidgetsSourceListExpandableItem* _tmp4_;
		GraniteWidgetsSourceListSortable* _tmp5_;
		gboolean _tmp6_ = FALSE;
		GraniteWidgetsSourceListSortable* _tmp7_;
		GraniteWidgetsSourceListDragSource* drag_source_item = NULL;
		GraniteWidgetsSourceListItem* _tmp9_;
		GraniteWidgetsSourceListDragSource* _tmp10_;
		gboolean _tmp11_ = FALSE;
		GraniteWidgetsSourceListDragSource* _tmp12_;
#line 1443 "../lib/Widgets/SourceList.vala"
		_tmp2_ = item;
#line 1443 "../lib/Widgets/SourceList.vala"
		_tmp3_ = granite_widgets_source_list_item_get_parent (_tmp2_);
#line 1443 "../lib/Widgets/SourceList.vala"
		_tmp4_ = _tmp3_;
#line 1443 "../lib/Widgets/SourceList.vala"
		_tmp5_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp4_, GRANITE_WIDGETS_TYPE_SOURCE_LIST_SORTABLE) ? ((GraniteWidgetsSourceListSortable*) _tmp4_) : NULL);
#line 1443 "../lib/Widgets/SourceList.vala"
		sortable_item = _tmp5_;
#line 1445 "../lib/Widgets/SourceList.vala"
		_tmp7_ = sortable_item;
#line 1445 "../lib/Widgets/SourceList.vala"
		if (_tmp7_ != NULL) {
#line 7103 "SourceList.c"
			GraniteWidgetsSourceListSortable* _tmp8_;
#line 1445 "../lib/Widgets/SourceList.vala"
			_tmp8_ = sortable_item;
#line 1445 "../lib/Widgets/SourceList.vala"
			_tmp6_ = granite_widgets_source_list_sortable_allow_dnd_sorting (_tmp8_);
#line 7109 "SourceList.c"
		} else {
#line 1445 "../lib/Widgets/SourceList.vala"
			_tmp6_ = FALSE;
#line 7113 "SourceList.c"
		}
#line 1445 "../lib/Widgets/SourceList.vala"
		if (_tmp6_) {
#line 1446 "../lib/Widgets/SourceList.vala"
			result = TRUE;
#line 1446 "../lib/Widgets/SourceList.vala"
			_g_object_unref0 (sortable_item);
#line 1446 "../lib/Widgets/SourceList.vala"
			_g_object_unref0 (item);
#line 1446 "../lib/Widgets/SourceList.vala"
			return result;
#line 7125 "SourceList.c"
		}
#line 1450 "../lib/Widgets/SourceList.vala"
		_tmp9_ = item;
#line 1450 "../lib/Widgets/SourceList.vala"
		_tmp10_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp9_, GRANITE_WIDGETS_TYPE_SOURCE_LIST_DRAG_SOURCE) ? ((GraniteWidgetsSourceListDragSource*) _tmp9_) : NULL);
#line 1450 "../lib/Widgets/SourceList.vala"
		drag_source_item = _tmp10_;
#line 1452 "../lib/Widgets/SourceList.vala"
		_tmp12_ = drag_source_item;
#line 1452 "../lib/Widgets/SourceList.vala"
		if (_tmp12_ != NULL) {
#line 7137 "SourceList.c"
			GraniteWidgetsSourceListDragSource* _tmp13_;
#line 1452 "../lib/Widgets/SourceList.vala"
			_tmp13_ = drag_source_item;
#line 1452 "../lib/Widgets/SourceList.vala"
			_tmp11_ = granite_widgets_source_list_drag_source_draggable (_tmp13_);
#line 7143 "SourceList.c"
		} else {
#line 1452 "../lib/Widgets/SourceList.vala"
			_tmp11_ = FALSE;
#line 7147 "SourceList.c"
		}
#line 1452 "../lib/Widgets/SourceList.vala"
		if (_tmp11_) {
#line 1453 "../lib/Widgets/SourceList.vala"
			result = TRUE;
#line 1453 "../lib/Widgets/SourceList.vala"
			_g_object_unref0 (drag_source_item);
#line 1453 "../lib/Widgets/SourceList.vala"
			_g_object_unref0 (sortable_item);
#line 1453 "../lib/Widgets/SourceList.vala"
			_g_object_unref0 (item);
#line 1453 "../lib/Widgets/SourceList.vala"
			return result;
#line 7161 "SourceList.c"
		}
#line 1441 "../lib/Widgets/SourceList.vala"
		_g_object_unref0 (drag_source_item);
#line 1441 "../lib/Widgets/SourceList.vala"
		_g_object_unref0 (sortable_item);
#line 7167 "SourceList.c"
	}
#line 1456 "../lib/Widgets/SourceList.vala"
	result = FALSE;
#line 1456 "../lib/Widgets/SourceList.vala"
	_g_object_unref0 (item);
#line 1456 "../lib/Widgets/SourceList.vala"
	return result;
#line 7175 "SourceList.c"
}


static GraniteWidgetsSourceListExpandableItem*
granite_widgets_source_list_data_model_get_root (GraniteWidgetsSourceListDataModel* self)
{
	GraniteWidgetsSourceListExpandableItem* result;
	GraniteWidgetsSourceListExpandableItem* _tmp0_;
#line 826 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 826 "../lib/Widgets/SourceList.vala"
	_tmp0_ = self->priv->_root;
#line 826 "../lib/Widgets/SourceList.vala"
	result = _tmp0_;
#line 826 "../lib/Widgets/SourceList.vala"
	return result;
#line 7192 "SourceList.c"
}


static void
granite_widgets_source_list_data_model_set_root (GraniteWidgetsSourceListDataModel* self,
                                                 GraniteWidgetsSourceListExpandableItem* value)
{
	GraniteWidgetsSourceListExpandableItem* _tmp0_;
	GraniteWidgetsSourceListExpandableItem* _tmp12_;
	GraniteWidgetsSourceListExpandableItem* _tmp13_;
#line 827 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 828 "../lib/Widgets/SourceList.vala"
	_tmp0_ = self->priv->_root;
#line 828 "../lib/Widgets/SourceList.vala"
	if (_tmp0_ != NULL) {
#line 7209 "SourceList.c"
		GraniteWidgetsSourceListExpandableItem* _tmp1_;
#line 829 "../lib/Widgets/SourceList.vala"
		_tmp1_ = self->priv->_root;
#line 829 "../lib/Widgets/SourceList.vala"
		granite_widgets_source_list_data_model_remove_children_monitor (self, _tmp1_);
#line 7215 "SourceList.c"
		{
			GeeIterator* _item_it = NULL;
			GraniteWidgetsSourceListExpandableItem* _tmp2_;
			GeeCollection* _tmp3_;
			GeeCollection* _tmp4_;
			GeeCollection* _tmp5_;
			GeeIterator* _tmp6_;
			GeeIterator* _tmp7_;
#line 830 "../lib/Widgets/SourceList.vala"
			_tmp2_ = self->priv->_root;
#line 830 "../lib/Widgets/SourceList.vala"
			_tmp3_ = granite_widgets_source_list_expandable_item_get_children (_tmp2_);
#line 830 "../lib/Widgets/SourceList.vala"
			_tmp4_ = _tmp3_;
#line 830 "../lib/Widgets/SourceList.vala"
			_tmp5_ = _tmp4_;
#line 830 "../lib/Widgets/SourceList.vala"
			_tmp6_ = gee_iterable_iterator ((GeeIterable*) _tmp5_);
#line 830 "../lib/Widgets/SourceList.vala"
			_tmp7_ = _tmp6_;
#line 830 "../lib/Widgets/SourceList.vala"
			_g_object_unref0 (_tmp5_);
#line 830 "../lib/Widgets/SourceList.vala"
			_item_it = _tmp7_;
#line 830 "../lib/Widgets/SourceList.vala"
			while (TRUE) {
#line 7242 "SourceList.c"
				GeeIterator* _tmp8_;
				GraniteWidgetsSourceListItem* item = NULL;
				GeeIterator* _tmp9_;
				gpointer _tmp10_;
				GraniteWidgetsSourceListItem* _tmp11_;
#line 830 "../lib/Widgets/SourceList.vala"
				_tmp8_ = _item_it;
#line 830 "../lib/Widgets/SourceList.vala"
				if (!gee_iterator_next (_tmp8_)) {
#line 830 "../lib/Widgets/SourceList.vala"
					break;
#line 7254 "SourceList.c"
				}
#line 830 "../lib/Widgets/SourceList.vala"
				_tmp9_ = _item_it;
#line 830 "../lib/Widgets/SourceList.vala"
				_tmp10_ = gee_iterator_get (_tmp9_);
#line 830 "../lib/Widgets/SourceList.vala"
				item = (GraniteWidgetsSourceListItem*) _tmp10_;
#line 831 "../lib/Widgets/SourceList.vala"
				_tmp11_ = item;
#line 831 "../lib/Widgets/SourceList.vala"
				granite_widgets_source_list_data_model_remove_item (self, _tmp11_);
#line 830 "../lib/Widgets/SourceList.vala"
				_g_object_unref0 (item);
#line 7268 "SourceList.c"
			}
#line 830 "../lib/Widgets/SourceList.vala"
			_g_object_unref0 (_item_it);
#line 7272 "SourceList.c"
		}
	}
#line 834 "../lib/Widgets/SourceList.vala"
	_tmp12_ = _g_object_ref0 (value);
#line 834 "../lib/Widgets/SourceList.vala"
	_g_object_unref0 (self->priv->_root);
#line 834 "../lib/Widgets/SourceList.vala"
	self->priv->_root = _tmp12_;
#line 836 "../lib/Widgets/SourceList.vala"
	_tmp13_ = self->priv->_root;
#line 836 "../lib/Widgets/SourceList.vala"
	granite_widgets_source_list_data_model_add_children_monitor (self, _tmp13_);
#line 7285 "SourceList.c"
	{
		GeeIterator* _item_it = NULL;
		GraniteWidgetsSourceListExpandableItem* _tmp14_;
		GeeCollection* _tmp15_;
		GeeCollection* _tmp16_;
		GeeCollection* _tmp17_;
		GeeIterator* _tmp18_;
		GeeIterator* _tmp19_;
#line 837 "../lib/Widgets/SourceList.vala"
		_tmp14_ = self->priv->_root;
#line 837 "../lib/Widgets/SourceList.vala"
		_tmp15_ = granite_widgets_source_list_expandable_item_get_children (_tmp14_);
#line 837 "../lib/Widgets/SourceList.vala"
		_tmp16_ = _tmp15_;
#line 837 "../lib/Widgets/SourceList.vala"
		_tmp17_ = _tmp16_;
#line 837 "../lib/Widgets/SourceList.vala"
		_tmp18_ = gee_iterable_iterator ((GeeIterable*) _tmp17_);
#line 837 "../lib/Widgets/SourceList.vala"
		_tmp19_ = _tmp18_;
#line 837 "../lib/Widgets/SourceList.vala"
		_g_object_unref0 (_tmp17_);
#line 837 "../lib/Widgets/SourceList.vala"
		_item_it = _tmp19_;
#line 837 "../lib/Widgets/SourceList.vala"
		while (TRUE) {
#line 7312 "SourceList.c"
			GeeIterator* _tmp20_;
			GraniteWidgetsSourceListItem* item = NULL;
			GeeIterator* _tmp21_;
			gpointer _tmp22_;
			GraniteWidgetsSourceListItem* _tmp23_;
#line 837 "../lib/Widgets/SourceList.vala"
			_tmp20_ = _item_it;
#line 837 "../lib/Widgets/SourceList.vala"
			if (!gee_iterator_next (_tmp20_)) {
#line 837 "../lib/Widgets/SourceList.vala"
				break;
#line 7324 "SourceList.c"
			}
#line 837 "../lib/Widgets/SourceList.vala"
			_tmp21_ = _item_it;
#line 837 "../lib/Widgets/SourceList.vala"
			_tmp22_ = gee_iterator_get (_tmp21_);
#line 837 "../lib/Widgets/SourceList.vala"
			item = (GraniteWidgetsSourceListItem*) _tmp22_;
#line 838 "../lib/Widgets/SourceList.vala"
			_tmp23_ = item;
#line 838 "../lib/Widgets/SourceList.vala"
			granite_widgets_source_list_data_model_add_item (self, _tmp23_);
#line 837 "../lib/Widgets/SourceList.vala"
			_g_object_unref0 (item);
#line 7338 "SourceList.c"
		}
#line 837 "../lib/Widgets/SourceList.vala"
		_g_object_unref0 (_item_it);
#line 7342 "SourceList.c"
	}
#line 827 "../lib/Widgets/SourceList.vala"
	g_object_notify_by_pspec ((GObject *) self, granite_widgets_source_list_data_model_properties[GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_ROOT_PROPERTY]);
#line 7346 "SourceList.c"
}


static gint
_granite_widgets_source_list_data_model_child_model_sort_func_gtk_tree_iter_compare_func (GtkTreeModel* model,
                                                                                          GtkTreeIter* a,
                                                                                          GtkTreeIter* b,
                                                                                          gpointer self)
{
	gint result;
	result = granite_widgets_source_list_data_model_child_model_sort_func ((GraniteWidgetsSourceListDataModel*) self, model, a, b);
#line 861 "../lib/Widgets/SourceList.vala"
	return result;
#line 7360 "SourceList.c"
}


static gboolean
_granite_widgets_source_list_data_model_filter_visible_func_gtk_tree_model_filter_visible_func (GtkTreeModel* model,
                                                                                                GtkTreeIter* iter,
                                                                                                gpointer self)
{
	gboolean result;
	result = granite_widgets_source_list_data_model_filter_visible_func ((GraniteWidgetsSourceListDataModel*) self, model, iter);
#line 864 "../lib/Widgets/SourceList.vala"
	return result;
#line 7373 "SourceList.c"
}


static GObject *
granite_widgets_source_list_data_model_constructor (GType type,
                                                    guint n_construct_properties,
                                                    GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GraniteWidgetsSourceListDataModel * self;
	GtkTreeStore* _tmp0_;
	GtkTreeStore* _tmp1_;
	GtkTreeStore* _tmp2_;
#line 856 "../lib/Widgets/SourceList.vala"
	parent_class = G_OBJECT_CLASS (granite_widgets_source_list_data_model_parent_class);
#line 856 "../lib/Widgets/SourceList.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 856 "../lib/Widgets/SourceList.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GRANITE_WIDGETS_SOURCE_LIST_TYPE_DATA_MODEL, GraniteWidgetsSourceListDataModel);
#line 857 "../lib/Widgets/SourceList.vala"
	_tmp0_ = gtk_tree_store_new ((gint) GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_COLUMN_N_COLUMNS, granite_widgets_source_list_data_model_column_type (GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_COLUMN_ITEM));
#line 857 "../lib/Widgets/SourceList.vala"
	_g_object_unref0 (self->priv->child_tree);
#line 857 "../lib/Widgets/SourceList.vala"
	self->priv->child_tree = _tmp0_;
#line 858 "../lib/Widgets/SourceList.vala"
	_tmp1_ = self->priv->child_tree;
#line 858 "../lib/Widgets/SourceList.vala"
	g_object_set ((GtkTreeModelFilter*) self, "child-model", (GtkTreeModel*) _tmp1_, NULL);
#line 859 "../lib/Widgets/SourceList.vala"
	g_object_set ((GtkTreeModelFilter*) self, "virtual-root", NULL, NULL);
#line 861 "../lib/Widgets/SourceList.vala"
	_tmp2_ = self->priv->child_tree;
#line 861 "../lib/Widgets/SourceList.vala"
	gtk_tree_sortable_set_default_sort_func ((GtkTreeSortable*) _tmp2_, _granite_widgets_source_list_data_model_child_model_sort_func_gtk_tree_iter_compare_func, g_object_ref (self), g_object_unref);
#line 862 "../lib/Widgets/SourceList.vala"
	granite_widgets_source_list_data_model_resort (self);
#line 864 "../lib/Widgets/SourceList.vala"
	gtk_tree_model_filter_set_visible_func ((GtkTreeModelFilter*) self, _granite_widgets_source_list_data_model_filter_visible_func_gtk_tree_model_filter_visible_func, g_object_ref (self), g_object_unref);
#line 856 "../lib/Widgets/SourceList.vala"
	return obj;
#line 7416 "SourceList.c"
}


static inline gpointer
granite_widgets_source_list_data_model_node_wrapper_get_instance_private (GraniteWidgetsSourceListDataModelNodeWrapper* self)
{
	return G_STRUCT_MEMBER_P (self, GraniteWidgetsSourceListDataModelNodeWrapper_private_offset);
}


static void
_vala_GtkTreeRowReference_free (GtkTreeRowReference* self)
{
#line 732 "../lib/Widgets/SourceList.vala"
	g_boxed_free (gtk_tree_row_reference_get_type (), self);
#line 7432 "SourceList.c"
}


static GraniteWidgetsSourceListDataModelNodeWrapper*
granite_widgets_source_list_data_model_node_wrapper_construct (GType object_type,
                                                               GtkTreeModel* model,
                                                               GtkTreeIter* iter)
{
	GraniteWidgetsSourceListDataModelNodeWrapper* self = NULL;
	GtkTreeIter _tmp0_;
	GtkTreePath* _tmp1_;
	GtkTreePath* _tmp2_;
	GtkTreeRowReference* _tmp3_;
#line 769 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (model != NULL, NULL);
#line 769 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (iter != NULL, NULL);
#line 769 "../lib/Widgets/SourceList.vala"
	self = (GraniteWidgetsSourceListDataModelNodeWrapper*) g_type_create_instance (object_type);
#line 770 "../lib/Widgets/SourceList.vala"
	_tmp0_ = *iter;
#line 770 "../lib/Widgets/SourceList.vala"
	_tmp1_ = gtk_tree_model_get_path (model, &_tmp0_);
#line 770 "../lib/Widgets/SourceList.vala"
	_tmp2_ = _tmp1_;
#line 770 "../lib/Widgets/SourceList.vala"
	_tmp3_ = gtk_tree_row_reference_new (model, _tmp2_);
#line 770 "../lib/Widgets/SourceList.vala"
	__vala_GtkTreeRowReference_free0 (self->priv->row_reference);
#line 770 "../lib/Widgets/SourceList.vala"
	self->priv->row_reference = _tmp3_;
#line 770 "../lib/Widgets/SourceList.vala"
	__vala_GtkTreePath_free0 (_tmp2_);
#line 769 "../lib/Widgets/SourceList.vala"
	return self;
#line 7468 "SourceList.c"
}


static GraniteWidgetsSourceListDataModelNodeWrapper*
granite_widgets_source_list_data_model_node_wrapper_new (GtkTreeModel* model,
                                                         GtkTreeIter* iter)
{
#line 769 "../lib/Widgets/SourceList.vala"
	return granite_widgets_source_list_data_model_node_wrapper_construct (GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_NODE_WRAPPER, model, iter);
#line 7478 "SourceList.c"
}


static GtkTreeIter*
granite_widgets_source_list_data_model_node_wrapper_get_iter (GraniteWidgetsSourceListDataModelNodeWrapper* self)
{
	GtkTreeIter* result;
	GtkTreeIter* rv = NULL;
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 738 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 739 "../lib/Widgets/SourceList.vala"
	rv = NULL;
#line 741 "../lib/Widgets/SourceList.vala"
	_tmp0_ = granite_widgets_source_list_data_model_node_wrapper_get_valid (self);
#line 741 "../lib/Widgets/SourceList.vala"
	_tmp1_ = _tmp0_;
#line 741 "../lib/Widgets/SourceList.vala"
	if (_tmp1_) {
#line 7499 "SourceList.c"
		GtkTreePath* _path = NULL;
		GtkTreePath* _tmp2_;
		GtkTreePath* _tmp3_;
		GtkTreePath* _tmp4_;
#line 742 "../lib/Widgets/SourceList.vala"
		_tmp2_ = granite_widgets_source_list_data_model_node_wrapper_get_path (self);
#line 742 "../lib/Widgets/SourceList.vala"
		_tmp3_ = _tmp2_;
#line 742 "../lib/Widgets/SourceList.vala"
		_path = _tmp3_;
#line 743 "../lib/Widgets/SourceList.vala"
		_tmp4_ = _path;
#line 743 "../lib/Widgets/SourceList.vala"
		if (_tmp4_ != NULL) {
#line 7514 "SourceList.c"
			GtkTreeIter _iter = {0};
			GtkTreeRowReference* _tmp5_;
			GtkTreeModel* _tmp6_;
			GtkTreePath* _tmp7_;
			GtkTreeIter _tmp8_ = {0};
			gboolean _tmp9_;
#line 745 "../lib/Widgets/SourceList.vala"
			_tmp5_ = self->priv->row_reference;
#line 745 "../lib/Widgets/SourceList.vala"
			_tmp6_ = gtk_tree_row_reference_get_model (_tmp5_);
#line 745 "../lib/Widgets/SourceList.vala"
			_tmp7_ = _path;
#line 745 "../lib/Widgets/SourceList.vala"
			_tmp9_ = gtk_tree_model_get_iter (_tmp6_, &_tmp8_, _tmp7_);
#line 745 "../lib/Widgets/SourceList.vala"
			_iter = _tmp8_;
#line 745 "../lib/Widgets/SourceList.vala"
			if (_tmp9_) {
#line 7533 "SourceList.c"
				GtkTreeIter _tmp10_;
				GtkTreeIter* _tmp11_;
#line 746 "../lib/Widgets/SourceList.vala"
				_tmp10_ = _iter;
#line 746 "../lib/Widgets/SourceList.vala"
				_tmp11_ = __gtk_tree_iter_dup0 (&_tmp10_);
#line 746 "../lib/Widgets/SourceList.vala"
				_g_free0 (rv);
#line 746 "../lib/Widgets/SourceList.vala"
				rv = _tmp11_;
#line 7544 "SourceList.c"
			}
		}
#line 741 "../lib/Widgets/SourceList.vala"
		__vala_GtkTreePath_free0 (_path);
#line 7549 "SourceList.c"
	}
#line 750 "../lib/Widgets/SourceList.vala"
	result = rv;
#line 750 "../lib/Widgets/SourceList.vala"
	return result;
#line 7555 "SourceList.c"
}


static GtkTreePath*
granite_widgets_source_list_data_model_node_wrapper_get_path (GraniteWidgetsSourceListDataModelNodeWrapper* self)
{
	GtkTreePath* result;
	GtkTreePath* _tmp0_ = NULL;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 758 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 758 "../lib/Widgets/SourceList.vala"
	_tmp1_ = granite_widgets_source_list_data_model_node_wrapper_get_valid (self);
#line 758 "../lib/Widgets/SourceList.vala"
	_tmp2_ = _tmp1_;
#line 758 "../lib/Widgets/SourceList.vala"
	if (_tmp2_) {
#line 7574 "SourceList.c"
		GtkTreeRowReference* _tmp3_;
		GtkTreePath* _tmp4_;
#line 758 "../lib/Widgets/SourceList.vala"
		_tmp3_ = self->priv->row_reference;
#line 758 "../lib/Widgets/SourceList.vala"
		_tmp4_ = gtk_tree_row_reference_get_path (_tmp3_);
#line 758 "../lib/Widgets/SourceList.vala"
		__vala_GtkTreePath_free0 (_tmp0_);
#line 758 "../lib/Widgets/SourceList.vala"
		_tmp0_ = _tmp4_;
#line 7585 "SourceList.c"
	} else {
#line 758 "../lib/Widgets/SourceList.vala"
		__vala_GtkTreePath_free0 (_tmp0_);
#line 758 "../lib/Widgets/SourceList.vala"
		_tmp0_ = NULL;
#line 7591 "SourceList.c"
	}
#line 758 "../lib/Widgets/SourceList.vala"
	result = _tmp0_;
#line 758 "../lib/Widgets/SourceList.vala"
	return result;
#line 7597 "SourceList.c"
}


static gboolean
granite_widgets_source_list_data_model_node_wrapper_get_valid (GraniteWidgetsSourceListDataModelNodeWrapper* self)
{
	gboolean result;
	gboolean _tmp0_ = FALSE;
	GtkTreeRowReference* _tmp1_;
#line 766 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 766 "../lib/Widgets/SourceList.vala"
	_tmp1_ = self->priv->row_reference;
#line 766 "../lib/Widgets/SourceList.vala"
	if (_tmp1_ != NULL) {
#line 7613 "SourceList.c"
		GtkTreeRowReference* _tmp2_;
#line 766 "../lib/Widgets/SourceList.vala"
		_tmp2_ = self->priv->row_reference;
#line 766 "../lib/Widgets/SourceList.vala"
		_tmp0_ = gtk_tree_row_reference_valid (_tmp2_);
#line 7619 "SourceList.c"
	} else {
#line 766 "../lib/Widgets/SourceList.vala"
		_tmp0_ = FALSE;
#line 7623 "SourceList.c"
	}
#line 766 "../lib/Widgets/SourceList.vala"
	result = _tmp0_;
#line 766 "../lib/Widgets/SourceList.vala"
	return result;
#line 7629 "SourceList.c"
}


static void
granite_widgets_source_list_data_model_value_node_wrapper_init (GValue* value)
{
#line 727 "../lib/Widgets/SourceList.vala"
	value->data[0].v_pointer = NULL;
#line 7638 "SourceList.c"
}


static void
granite_widgets_source_list_data_model_value_node_wrapper_free_value (GValue* value)
{
#line 727 "../lib/Widgets/SourceList.vala"
	if (value->data[0].v_pointer) {
#line 727 "../lib/Widgets/SourceList.vala"
		granite_widgets_source_list_data_model_node_wrapper_unref (value->data[0].v_pointer);
#line 7649 "SourceList.c"
	}
}


static void
granite_widgets_source_list_data_model_value_node_wrapper_copy_value (const GValue* src_value,
                                                                      GValue* dest_value)
{
#line 727 "../lib/Widgets/SourceList.vala"
	if (src_value->data[0].v_pointer) {
#line 727 "../lib/Widgets/SourceList.vala"
		dest_value->data[0].v_pointer = granite_widgets_source_list_data_model_node_wrapper_ref (src_value->data[0].v_pointer);
#line 7662 "SourceList.c"
	} else {
#line 727 "../lib/Widgets/SourceList.vala"
		dest_value->data[0].v_pointer = NULL;
#line 7666 "SourceList.c"
	}
}


static gpointer
granite_widgets_source_list_data_model_value_node_wrapper_peek_pointer (const GValue* value)
{
#line 727 "../lib/Widgets/SourceList.vala"
	return value->data[0].v_pointer;
#line 7676 "SourceList.c"
}


static gchar*
granite_widgets_source_list_data_model_value_node_wrapper_collect_value (GValue* value,
                                                                         guint n_collect_values,
                                                                         GTypeCValue* collect_values,
                                                                         guint collect_flags)
{
#line 727 "../lib/Widgets/SourceList.vala"
	if (collect_values[0].v_pointer) {
#line 7688 "SourceList.c"
		GraniteWidgetsSourceListDataModelNodeWrapper * object;
		object = collect_values[0].v_pointer;
#line 727 "../lib/Widgets/SourceList.vala"
		if (object->parent_instance.g_class == NULL) {
#line 727 "../lib/Widgets/SourceList.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 7695 "SourceList.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 727 "../lib/Widgets/SourceList.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 7699 "SourceList.c"
		}
#line 727 "../lib/Widgets/SourceList.vala"
		value->data[0].v_pointer = granite_widgets_source_list_data_model_node_wrapper_ref (object);
#line 7703 "SourceList.c"
	} else {
#line 727 "../lib/Widgets/SourceList.vala"
		value->data[0].v_pointer = NULL;
#line 7707 "SourceList.c"
	}
#line 727 "../lib/Widgets/SourceList.vala"
	return NULL;
#line 7711 "SourceList.c"
}


static gchar*
granite_widgets_source_list_data_model_value_node_wrapper_lcopy_value (const GValue* value,
                                                                       guint n_collect_values,
                                                                       GTypeCValue* collect_values,
                                                                       guint collect_flags)
{
	GraniteWidgetsSourceListDataModelNodeWrapper ** object_p;
	object_p = collect_values[0].v_pointer;
#line 727 "../lib/Widgets/SourceList.vala"
	if (!object_p) {
#line 727 "../lib/Widgets/SourceList.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 7727 "SourceList.c"
	}
#line 727 "../lib/Widgets/SourceList.vala"
	if (!value->data[0].v_pointer) {
#line 727 "../lib/Widgets/SourceList.vala"
		*object_p = NULL;
#line 7733 "SourceList.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 727 "../lib/Widgets/SourceList.vala"
		*object_p = value->data[0].v_pointer;
#line 7737 "SourceList.c"
	} else {
#line 727 "../lib/Widgets/SourceList.vala"
		*object_p = granite_widgets_source_list_data_model_node_wrapper_ref (value->data[0].v_pointer);
#line 7741 "SourceList.c"
	}
#line 727 "../lib/Widgets/SourceList.vala"
	return NULL;
#line 7745 "SourceList.c"
}


static GParamSpec*
granite_widgets_source_list_data_model_param_spec_node_wrapper (const gchar* name,
                                                                const gchar* nick,
                                                                const gchar* blurb,
                                                                GType object_type,
                                                                GParamFlags flags)
{
	GraniteWidgetsSourceListDataModelParamSpecNodeWrapper* spec;
#line 727 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (g_type_is_a (object_type, GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_NODE_WRAPPER), NULL);
#line 727 "../lib/Widgets/SourceList.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 727 "../lib/Widgets/SourceList.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 727 "../lib/Widgets/SourceList.vala"
	return G_PARAM_SPEC (spec);
#line 7765 "SourceList.c"
}


static gpointer
granite_widgets_source_list_data_model_value_get_node_wrapper (const GValue* value)
{
#line 727 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_NODE_WRAPPER), NULL);
#line 727 "../lib/Widgets/SourceList.vala"
	return value->data[0].v_pointer;
#line 7776 "SourceList.c"
}


static void
granite_widgets_source_list_data_model_value_set_node_wrapper (GValue* value,
                                                               gpointer v_object)
{
	GraniteWidgetsSourceListDataModelNodeWrapper * old;
#line 727 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_NODE_WRAPPER));
#line 727 "../lib/Widgets/SourceList.vala"
	old = value->data[0].v_pointer;
#line 727 "../lib/Widgets/SourceList.vala"
	if (v_object) {
#line 727 "../lib/Widgets/SourceList.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_NODE_WRAPPER));
#line 727 "../lib/Widgets/SourceList.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 727 "../lib/Widgets/SourceList.vala"
		value->data[0].v_pointer = v_object;
#line 727 "../lib/Widgets/SourceList.vala"
		granite_widgets_source_list_data_model_node_wrapper_ref (value->data[0].v_pointer);
#line 7799 "SourceList.c"
	} else {
#line 727 "../lib/Widgets/SourceList.vala"
		value->data[0].v_pointer = NULL;
#line 7803 "SourceList.c"
	}
#line 727 "../lib/Widgets/SourceList.vala"
	if (old) {
#line 727 "../lib/Widgets/SourceList.vala"
		granite_widgets_source_list_data_model_node_wrapper_unref (old);
#line 7809 "SourceList.c"
	}
}


static void
granite_widgets_source_list_data_model_value_take_node_wrapper (GValue* value,
                                                                gpointer v_object)
{
	GraniteWidgetsSourceListDataModelNodeWrapper * old;
#line 727 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_NODE_WRAPPER));
#line 727 "../lib/Widgets/SourceList.vala"
	old = value->data[0].v_pointer;
#line 727 "../lib/Widgets/SourceList.vala"
	if (v_object) {
#line 727 "../lib/Widgets/SourceList.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_NODE_WRAPPER));
#line 727 "../lib/Widgets/SourceList.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 727 "../lib/Widgets/SourceList.vala"
		value->data[0].v_pointer = v_object;
#line 7831 "SourceList.c"
	} else {
#line 727 "../lib/Widgets/SourceList.vala"
		value->data[0].v_pointer = NULL;
#line 7835 "SourceList.c"
	}
#line 727 "../lib/Widgets/SourceList.vala"
	if (old) {
#line 727 "../lib/Widgets/SourceList.vala"
		granite_widgets_source_list_data_model_node_wrapper_unref (old);
#line 7841 "SourceList.c"
	}
}


static void
granite_widgets_source_list_data_model_node_wrapper_class_init (GraniteWidgetsSourceListDataModelNodeWrapperClass * klass)
{
#line 727 "../lib/Widgets/SourceList.vala"
	granite_widgets_source_list_data_model_node_wrapper_parent_class = g_type_class_peek_parent (klass);
#line 727 "../lib/Widgets/SourceList.vala"
	((GraniteWidgetsSourceListDataModelNodeWrapperClass *) klass)->finalize = granite_widgets_source_list_data_model_node_wrapper_finalize;
#line 727 "../lib/Widgets/SourceList.vala"
	g_type_class_adjust_private_offset (klass, &GraniteWidgetsSourceListDataModelNodeWrapper_private_offset);
#line 7855 "SourceList.c"
}


static void
granite_widgets_source_list_data_model_node_wrapper_instance_init (GraniteWidgetsSourceListDataModelNodeWrapper * self)
{
#line 727 "../lib/Widgets/SourceList.vala"
	self->priv = granite_widgets_source_list_data_model_node_wrapper_get_instance_private (self);
#line 727 "../lib/Widgets/SourceList.vala"
	self->ref_count = 1;
#line 7866 "SourceList.c"
}


static void
granite_widgets_source_list_data_model_node_wrapper_finalize (GraniteWidgetsSourceListDataModelNodeWrapper * obj)
{
	GraniteWidgetsSourceListDataModelNodeWrapper * self;
#line 727 "../lib/Widgets/SourceList.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_NODE_WRAPPER, GraniteWidgetsSourceListDataModelNodeWrapper);
#line 727 "../lib/Widgets/SourceList.vala"
	g_signal_handlers_destroy (self);
#line 732 "../lib/Widgets/SourceList.vala"
	__vala_GtkTreeRowReference_free0 (self->priv->row_reference);
#line 7880 "SourceList.c"
}


/**
         * An object that references a particular row in a model. This class is a wrapper built around
         * Gtk.TreeRowReference, and exists with the purpose of ensuring we never use invalid tree paths
         * or iters in the model, since most of these errors provoke failures due to GTK+ assertions
         * or, even worse, unexpected behavior.
         */
static GType
granite_widgets_source_list_data_model_node_wrapper_get_type (void)
{
	static volatile gsize granite_widgets_source_list_data_model_node_wrapper_type_id__volatile = 0;
	if (g_once_init_enter (&granite_widgets_source_list_data_model_node_wrapper_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { granite_widgets_source_list_data_model_value_node_wrapper_init, granite_widgets_source_list_data_model_value_node_wrapper_free_value, granite_widgets_source_list_data_model_value_node_wrapper_copy_value, granite_widgets_source_list_data_model_value_node_wrapper_peek_pointer, "p", granite_widgets_source_list_data_model_value_node_wrapper_collect_value, "p", granite_widgets_source_list_data_model_value_node_wrapper_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (GraniteWidgetsSourceListDataModelNodeWrapperClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) granite_widgets_source_list_data_model_node_wrapper_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GraniteWidgetsSourceListDataModelNodeWrapper), 0, (GInstanceInitFunc) granite_widgets_source_list_data_model_node_wrapper_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType granite_widgets_source_list_data_model_node_wrapper_type_id;
		granite_widgets_source_list_data_model_node_wrapper_type_id = g_type_register_fundamental (g_type_fundamental_next (), "GraniteWidgetsSourceListDataModelNodeWrapper", &g_define_type_info, &g_define_type_fundamental_info, 0);
		GraniteWidgetsSourceListDataModelNodeWrapper_private_offset = g_type_add_instance_private (granite_widgets_source_list_data_model_node_wrapper_type_id, sizeof (GraniteWidgetsSourceListDataModelNodeWrapperPrivate));
		g_once_init_leave (&granite_widgets_source_list_data_model_node_wrapper_type_id__volatile, granite_widgets_source_list_data_model_node_wrapper_type_id);
	}
	return granite_widgets_source_list_data_model_node_wrapper_type_id__volatile;
}


static gpointer
granite_widgets_source_list_data_model_node_wrapper_ref (gpointer instance)
{
	GraniteWidgetsSourceListDataModelNodeWrapper * self;
	self = instance;
#line 727 "../lib/Widgets/SourceList.vala"
	g_atomic_int_inc (&self->ref_count);
#line 727 "../lib/Widgets/SourceList.vala"
	return instance;
#line 7916 "SourceList.c"
}


static void
granite_widgets_source_list_data_model_node_wrapper_unref (gpointer instance)
{
	GraniteWidgetsSourceListDataModelNodeWrapper * self;
	self = instance;
#line 727 "../lib/Widgets/SourceList.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 727 "../lib/Widgets/SourceList.vala"
		GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_NODE_WRAPPER_GET_CLASS (self)->finalize (self);
#line 727 "../lib/Widgets/SourceList.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 7931 "SourceList.c"
	}
}


static inline gpointer
granite_widgets_source_list_data_model_item_monitor_get_instance_private (GraniteWidgetsSourceListDataModelItemMonitor* self)
{
	return G_STRUCT_MEMBER_P (self, GraniteWidgetsSourceListDataModelItemMonitor_private_offset);
}


static void
_granite_widgets_source_list_data_model_item_monitor_on_notify_g_object_notify (GObject* _sender,
                                                                                GParamSpec* pspec,
                                                                                gpointer self)
{
#line 787 "../lib/Widgets/SourceList.vala"
	granite_widgets_source_list_data_model_item_monitor_on_notify ((GraniteWidgetsSourceListDataModelItemMonitor*) self, pspec);
#line 7950 "SourceList.c"
}


static GraniteWidgetsSourceListDataModelItemMonitor*
granite_widgets_source_list_data_model_item_monitor_construct (GType object_type,
                                                               GraniteWidgetsSourceListItem* item)
{
	GraniteWidgetsSourceListDataModelItemMonitor* self = NULL;
	GraniteWidgetsSourceListItem* _tmp0_;
#line 781 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (item != NULL, NULL);
#line 781 "../lib/Widgets/SourceList.vala"
	self = (GraniteWidgetsSourceListDataModelItemMonitor*) g_type_create_instance (object_type);
#line 782 "../lib/Widgets/SourceList.vala"
	_tmp0_ = _g_object_ref0 (item);
#line 782 "../lib/Widgets/SourceList.vala"
	_g_object_unref0 (self->priv->item);
#line 782 "../lib/Widgets/SourceList.vala"
	self->priv->item = _tmp0_;
#line 783 "../lib/Widgets/SourceList.vala"
	g_signal_connect_after ((GObject*) item, "notify", (GCallback) _granite_widgets_source_list_data_model_item_monitor_on_notify_g_object_notify, self);
#line 781 "../lib/Widgets/SourceList.vala"
	return self;
#line 7974 "SourceList.c"
}


static GraniteWidgetsSourceListDataModelItemMonitor*
granite_widgets_source_list_data_model_item_monitor_new (GraniteWidgetsSourceListItem* item)
{
#line 781 "../lib/Widgets/SourceList.vala"
	return granite_widgets_source_list_data_model_item_monitor_construct (GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_ITEM_MONITOR, item);
#line 7983 "SourceList.c"
}


static void
granite_widgets_source_list_data_model_item_monitor_on_notify (GraniteWidgetsSourceListDataModelItemMonitor* self,
                                                               GParamSpec* prop)
{
	GraniteWidgetsSourceListItem* _tmp0_;
	const gchar* _tmp1_;
#line 790 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 790 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (prop != NULL);
#line 791 "../lib/Widgets/SourceList.vala"
	_tmp0_ = self->priv->item;
#line 791 "../lib/Widgets/SourceList.vala"
	_tmp1_ = prop->name;
#line 791 "../lib/Widgets/SourceList.vala"
	g_signal_emit (self, granite_widgets_source_list_data_model_item_monitor_signals[GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_ITEM_MONITOR_CHANGED_SIGNAL], 0, _tmp0_, _tmp1_);
#line 8003 "SourceList.c"
}


static void
g_cclosure_user_marshal_VOID__OBJECT_STRING (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_STRING) (gpointer data1, gpointer arg_1, const char* arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_STRING callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 777 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (n_param_values == 3);
#line 777 "../lib/Widgets/SourceList.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 777 "../lib/Widgets/SourceList.vala"
		data1 = closure->data;
#line 777 "../lib/Widgets/SourceList.vala"
		data2 = param_values->data[0].v_pointer;
#line 8029 "SourceList.c"
	} else {
#line 777 "../lib/Widgets/SourceList.vala"
		data1 = param_values->data[0].v_pointer;
#line 777 "../lib/Widgets/SourceList.vala"
		data2 = closure->data;
#line 8035 "SourceList.c"
	}
#line 777 "../lib/Widgets/SourceList.vala"
	callback = (GMarshalFunc_VOID__OBJECT_STRING) (marshal_data ? marshal_data : cc->callback);
#line 777 "../lib/Widgets/SourceList.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_string (param_values + 2), data2);
#line 8041 "SourceList.c"
}


static void
granite_widgets_source_list_data_model_value_item_monitor_init (GValue* value)
{
#line 777 "../lib/Widgets/SourceList.vala"
	value->data[0].v_pointer = NULL;
#line 8050 "SourceList.c"
}


static void
granite_widgets_source_list_data_model_value_item_monitor_free_value (GValue* value)
{
#line 777 "../lib/Widgets/SourceList.vala"
	if (value->data[0].v_pointer) {
#line 777 "../lib/Widgets/SourceList.vala"
		granite_widgets_source_list_data_model_item_monitor_unref (value->data[0].v_pointer);
#line 8061 "SourceList.c"
	}
}


static void
granite_widgets_source_list_data_model_value_item_monitor_copy_value (const GValue* src_value,
                                                                      GValue* dest_value)
{
#line 777 "../lib/Widgets/SourceList.vala"
	if (src_value->data[0].v_pointer) {
#line 777 "../lib/Widgets/SourceList.vala"
		dest_value->data[0].v_pointer = granite_widgets_source_list_data_model_item_monitor_ref (src_value->data[0].v_pointer);
#line 8074 "SourceList.c"
	} else {
#line 777 "../lib/Widgets/SourceList.vala"
		dest_value->data[0].v_pointer = NULL;
#line 8078 "SourceList.c"
	}
}


static gpointer
granite_widgets_source_list_data_model_value_item_monitor_peek_pointer (const GValue* value)
{
#line 777 "../lib/Widgets/SourceList.vala"
	return value->data[0].v_pointer;
#line 8088 "SourceList.c"
}


static gchar*
granite_widgets_source_list_data_model_value_item_monitor_collect_value (GValue* value,
                                                                         guint n_collect_values,
                                                                         GTypeCValue* collect_values,
                                                                         guint collect_flags)
{
#line 777 "../lib/Widgets/SourceList.vala"
	if (collect_values[0].v_pointer) {
#line 8100 "SourceList.c"
		GraniteWidgetsSourceListDataModelItemMonitor * object;
		object = collect_values[0].v_pointer;
#line 777 "../lib/Widgets/SourceList.vala"
		if (object->parent_instance.g_class == NULL) {
#line 777 "../lib/Widgets/SourceList.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 8107 "SourceList.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 777 "../lib/Widgets/SourceList.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 8111 "SourceList.c"
		}
#line 777 "../lib/Widgets/SourceList.vala"
		value->data[0].v_pointer = granite_widgets_source_list_data_model_item_monitor_ref (object);
#line 8115 "SourceList.c"
	} else {
#line 777 "../lib/Widgets/SourceList.vala"
		value->data[0].v_pointer = NULL;
#line 8119 "SourceList.c"
	}
#line 777 "../lib/Widgets/SourceList.vala"
	return NULL;
#line 8123 "SourceList.c"
}


static gchar*
granite_widgets_source_list_data_model_value_item_monitor_lcopy_value (const GValue* value,
                                                                       guint n_collect_values,
                                                                       GTypeCValue* collect_values,
                                                                       guint collect_flags)
{
	GraniteWidgetsSourceListDataModelItemMonitor ** object_p;
	object_p = collect_values[0].v_pointer;
#line 777 "../lib/Widgets/SourceList.vala"
	if (!object_p) {
#line 777 "../lib/Widgets/SourceList.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 8139 "SourceList.c"
	}
#line 777 "../lib/Widgets/SourceList.vala"
	if (!value->data[0].v_pointer) {
#line 777 "../lib/Widgets/SourceList.vala"
		*object_p = NULL;
#line 8145 "SourceList.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 777 "../lib/Widgets/SourceList.vala"
		*object_p = value->data[0].v_pointer;
#line 8149 "SourceList.c"
	} else {
#line 777 "../lib/Widgets/SourceList.vala"
		*object_p = granite_widgets_source_list_data_model_item_monitor_ref (value->data[0].v_pointer);
#line 8153 "SourceList.c"
	}
#line 777 "../lib/Widgets/SourceList.vala"
	return NULL;
#line 8157 "SourceList.c"
}


static GParamSpec*
granite_widgets_source_list_data_model_param_spec_item_monitor (const gchar* name,
                                                                const gchar* nick,
                                                                const gchar* blurb,
                                                                GType object_type,
                                                                GParamFlags flags)
{
	GraniteWidgetsSourceListDataModelParamSpecItemMonitor* spec;
#line 777 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (g_type_is_a (object_type, GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_ITEM_MONITOR), NULL);
#line 777 "../lib/Widgets/SourceList.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 777 "../lib/Widgets/SourceList.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 777 "../lib/Widgets/SourceList.vala"
	return G_PARAM_SPEC (spec);
#line 8177 "SourceList.c"
}


static gpointer
granite_widgets_source_list_data_model_value_get_item_monitor (const GValue* value)
{
#line 777 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_ITEM_MONITOR), NULL);
#line 777 "../lib/Widgets/SourceList.vala"
	return value->data[0].v_pointer;
#line 8188 "SourceList.c"
}


static void
granite_widgets_source_list_data_model_value_set_item_monitor (GValue* value,
                                                               gpointer v_object)
{
	GraniteWidgetsSourceListDataModelItemMonitor * old;
#line 777 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_ITEM_MONITOR));
#line 777 "../lib/Widgets/SourceList.vala"
	old = value->data[0].v_pointer;
#line 777 "../lib/Widgets/SourceList.vala"
	if (v_object) {
#line 777 "../lib/Widgets/SourceList.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_ITEM_MONITOR));
#line 777 "../lib/Widgets/SourceList.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 777 "../lib/Widgets/SourceList.vala"
		value->data[0].v_pointer = v_object;
#line 777 "../lib/Widgets/SourceList.vala"
		granite_widgets_source_list_data_model_item_monitor_ref (value->data[0].v_pointer);
#line 8211 "SourceList.c"
	} else {
#line 777 "../lib/Widgets/SourceList.vala"
		value->data[0].v_pointer = NULL;
#line 8215 "SourceList.c"
	}
#line 777 "../lib/Widgets/SourceList.vala"
	if (old) {
#line 777 "../lib/Widgets/SourceList.vala"
		granite_widgets_source_list_data_model_item_monitor_unref (old);
#line 8221 "SourceList.c"
	}
}


static void
granite_widgets_source_list_data_model_value_take_item_monitor (GValue* value,
                                                                gpointer v_object)
{
	GraniteWidgetsSourceListDataModelItemMonitor * old;
#line 777 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_ITEM_MONITOR));
#line 777 "../lib/Widgets/SourceList.vala"
	old = value->data[0].v_pointer;
#line 777 "../lib/Widgets/SourceList.vala"
	if (v_object) {
#line 777 "../lib/Widgets/SourceList.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_ITEM_MONITOR));
#line 777 "../lib/Widgets/SourceList.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 777 "../lib/Widgets/SourceList.vala"
		value->data[0].v_pointer = v_object;
#line 8243 "SourceList.c"
	} else {
#line 777 "../lib/Widgets/SourceList.vala"
		value->data[0].v_pointer = NULL;
#line 8247 "SourceList.c"
	}
#line 777 "../lib/Widgets/SourceList.vala"
	if (old) {
#line 777 "../lib/Widgets/SourceList.vala"
		granite_widgets_source_list_data_model_item_monitor_unref (old);
#line 8253 "SourceList.c"
	}
}


static void
granite_widgets_source_list_data_model_item_monitor_class_init (GraniteWidgetsSourceListDataModelItemMonitorClass * klass)
{
#line 777 "../lib/Widgets/SourceList.vala"
	granite_widgets_source_list_data_model_item_monitor_parent_class = g_type_class_peek_parent (klass);
#line 777 "../lib/Widgets/SourceList.vala"
	((GraniteWidgetsSourceListDataModelItemMonitorClass *) klass)->finalize = granite_widgets_source_list_data_model_item_monitor_finalize;
#line 777 "../lib/Widgets/SourceList.vala"
	g_type_class_adjust_private_offset (klass, &GraniteWidgetsSourceListDataModelItemMonitor_private_offset);
#line 777 "../lib/Widgets/SourceList.vala"
	granite_widgets_source_list_data_model_item_monitor_signals[GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_ITEM_MONITOR_CHANGED_SIGNAL] = g_signal_new ("changed", GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_ITEM_MONITOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_STRING, G_TYPE_NONE, 2, GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM, G_TYPE_STRING);
#line 8269 "SourceList.c"
}


static void
granite_widgets_source_list_data_model_item_monitor_instance_init (GraniteWidgetsSourceListDataModelItemMonitor * self)
{
#line 777 "../lib/Widgets/SourceList.vala"
	self->priv = granite_widgets_source_list_data_model_item_monitor_get_instance_private (self);
#line 777 "../lib/Widgets/SourceList.vala"
	self->ref_count = 1;
#line 8280 "SourceList.c"
}


static void
granite_widgets_source_list_data_model_item_monitor_finalize (GraniteWidgetsSourceListDataModelItemMonitor * obj)
{
	GraniteWidgetsSourceListDataModelItemMonitor * self;
	GraniteWidgetsSourceListItem* _tmp0_;
	guint _tmp1_;
#line 777 "../lib/Widgets/SourceList.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_ITEM_MONITOR, GraniteWidgetsSourceListDataModelItemMonitor);
#line 777 "../lib/Widgets/SourceList.vala"
	g_signal_handlers_destroy (self);
#line 787 "../lib/Widgets/SourceList.vala"
	_tmp0_ = self->priv->item;
#line 787 "../lib/Widgets/SourceList.vala"
	g_signal_parse_name ("notify", G_TYPE_OBJECT, &_tmp1_, NULL, FALSE);
#line 787 "../lib/Widgets/SourceList.vala"
	g_signal_handlers_disconnect_matched ((GObject*) _tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _granite_widgets_source_list_data_model_item_monitor_on_notify_g_object_notify, self);
#line 779 "../lib/Widgets/SourceList.vala"
	_g_object_unref0 (self->priv->item);
#line 8302 "SourceList.c"
}


/**
         * Helper object used to monitor item property changes.
         */
static GType
granite_widgets_source_list_data_model_item_monitor_get_type (void)
{
	static volatile gsize granite_widgets_source_list_data_model_item_monitor_type_id__volatile = 0;
	if (g_once_init_enter (&granite_widgets_source_list_data_model_item_monitor_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { granite_widgets_source_list_data_model_value_item_monitor_init, granite_widgets_source_list_data_model_value_item_monitor_free_value, granite_widgets_source_list_data_model_value_item_monitor_copy_value, granite_widgets_source_list_data_model_value_item_monitor_peek_pointer, "p", granite_widgets_source_list_data_model_value_item_monitor_collect_value, "p", granite_widgets_source_list_data_model_value_item_monitor_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (GraniteWidgetsSourceListDataModelItemMonitorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) granite_widgets_source_list_data_model_item_monitor_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GraniteWidgetsSourceListDataModelItemMonitor), 0, (GInstanceInitFunc) granite_widgets_source_list_data_model_item_monitor_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType granite_widgets_source_list_data_model_item_monitor_type_id;
		granite_widgets_source_list_data_model_item_monitor_type_id = g_type_register_fundamental (g_type_fundamental_next (), "GraniteWidgetsSourceListDataModelItemMonitor", &g_define_type_info, &g_define_type_fundamental_info, 0);
		GraniteWidgetsSourceListDataModelItemMonitor_private_offset = g_type_add_instance_private (granite_widgets_source_list_data_model_item_monitor_type_id, sizeof (GraniteWidgetsSourceListDataModelItemMonitorPrivate));
		g_once_init_leave (&granite_widgets_source_list_data_model_item_monitor_type_id__volatile, granite_widgets_source_list_data_model_item_monitor_type_id);
	}
	return granite_widgets_source_list_data_model_item_monitor_type_id__volatile;
}


static gpointer
granite_widgets_source_list_data_model_item_monitor_ref (gpointer instance)
{
	GraniteWidgetsSourceListDataModelItemMonitor * self;
	self = instance;
#line 777 "../lib/Widgets/SourceList.vala"
	g_atomic_int_inc (&self->ref_count);
#line 777 "../lib/Widgets/SourceList.vala"
	return instance;
#line 8335 "SourceList.c"
}


static void
granite_widgets_source_list_data_model_item_monitor_unref (gpointer instance)
{
	GraniteWidgetsSourceListDataModelItemMonitor * self;
	self = instance;
#line 777 "../lib/Widgets/SourceList.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 777 "../lib/Widgets/SourceList.vala"
		GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_ITEM_MONITOR_GET_CLASS (self)->finalize (self);
#line 777 "../lib/Widgets/SourceList.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 8350 "SourceList.c"
	}
}


static void
granite_widgets_source_list_data_model_class_init (GraniteWidgetsSourceListDataModelClass * klass)
{
#line 719 "../lib/Widgets/SourceList.vala"
	granite_widgets_source_list_data_model_parent_class = g_type_class_peek_parent (klass);
#line 719 "../lib/Widgets/SourceList.vala"
	g_type_class_adjust_private_offset (klass, &GraniteWidgetsSourceListDataModel_private_offset);
#line 719 "../lib/Widgets/SourceList.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_granite_widgets_source_list_data_model_get_property;
#line 719 "../lib/Widgets/SourceList.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_granite_widgets_source_list_data_model_set_property;
#line 719 "../lib/Widgets/SourceList.vala"
	G_OBJECT_CLASS (klass)->constructor = granite_widgets_source_list_data_model_constructor;
#line 719 "../lib/Widgets/SourceList.vala"
	G_OBJECT_CLASS (klass)->finalize = granite_widgets_source_list_data_model_finalize;
#line 8370 "SourceList.c"
	/**
	         * Root item.
	         *
	         * This item is not actually part of the model. It's only used as a proxy
	         * for adding and removing items.
	         */
#line 719 "../lib/Widgets/SourceList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_ROOT_PROPERTY, granite_widgets_source_list_data_model_properties[GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_ROOT_PROPERTY] = g_param_spec_object ("root", "root", "root", GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 719 "../lib/Widgets/SourceList.vala"
	granite_widgets_source_list_data_model_signals[GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_ITEM_UPDATED_SIGNAL] = g_signal_new ("item-updated", GRANITE_WIDGETS_SOURCE_LIST_TYPE_DATA_MODEL, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM);
#line 8381 "SourceList.c"
}


static void
granite_widgets_source_list_data_model_gtk_tree_drag_source_interface_init (GtkTreeDragSourceIface * iface)
{
#line 719 "../lib/Widgets/SourceList.vala"
	granite_widgets_source_list_data_model_gtk_tree_drag_source_parent_iface = g_type_interface_peek_parent (iface);
#line 719 "../lib/Widgets/SourceList.vala"
	iface->drag_data_get = (gboolean (*) (GtkTreeDragSource*, GtkTreePath*, GtkSelectionData*)) granite_widgets_source_list_data_model_real_drag_data_get;
#line 719 "../lib/Widgets/SourceList.vala"
	iface->row_draggable = (gboolean (*) (GtkTreeDragSource*, GtkTreePath*)) granite_widgets_source_list_data_model_real_row_draggable;
#line 8394 "SourceList.c"
}


static void
granite_widgets_source_list_data_model_gtk_tree_drag_dest_interface_init (GtkTreeDragDestIface * iface)
{
#line 719 "../lib/Widgets/SourceList.vala"
	granite_widgets_source_list_data_model_gtk_tree_drag_dest_parent_iface = g_type_interface_peek_parent (iface);
#line 719 "../lib/Widgets/SourceList.vala"
	iface->drag_data_received = (gboolean (*) (GtkTreeDragDest*, GtkTreePath*, GtkSelectionData*)) granite_widgets_source_list_data_model_real_drag_data_received;
#line 719 "../lib/Widgets/SourceList.vala"
	iface->row_drop_possible = (gboolean (*) (GtkTreeDragDest*, GtkTreePath*, GtkSelectionData*)) granite_widgets_source_list_data_model_real_row_drop_possible;
#line 8407 "SourceList.c"
}


static void
granite_widgets_source_list_data_model_instance_init (GraniteWidgetsSourceListDataModel * self)
{
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
#line 719 "../lib/Widgets/SourceList.vala"
	self->priv = granite_widgets_source_list_data_model_get_instance_private (self);
#line 845 "../lib/Widgets/SourceList.vala"
	_tmp0_ = gee_hash_map_new (GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_NODE_WRAPPER, (GBoxedCopyFunc) granite_widgets_source_list_data_model_node_wrapper_ref, (GDestroyNotify) granite_widgets_source_list_data_model_node_wrapper_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 845 "../lib/Widgets/SourceList.vala"
	self->priv->items = _tmp0_;
#line 847 "../lib/Widgets/SourceList.vala"
	_tmp1_ = gee_hash_map_new (GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_ITEM_MONITOR, (GBoxedCopyFunc) granite_widgets_source_list_data_model_item_monitor_ref, (GDestroyNotify) granite_widgets_source_list_data_model_item_monitor_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 847 "../lib/Widgets/SourceList.vala"
	self->priv->monitors = _tmp1_;
#line 8426 "SourceList.c"
}


static void
granite_widgets_source_list_data_model_finalize (GObject * obj)
{
	GraniteWidgetsSourceListDataModel * self;
#line 719 "../lib/Widgets/SourceList.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GRANITE_WIDGETS_SOURCE_LIST_TYPE_DATA_MODEL, GraniteWidgetsSourceListDataModel);
#line 817 "../lib/Widgets/SourceList.vala"
	_g_object_unref0 (self->priv->_root);
#line 845 "../lib/Widgets/SourceList.vala"
	_g_object_unref0 (self->priv->items);
#line 847 "../lib/Widgets/SourceList.vala"
	_g_object_unref0 (self->priv->monitors);
#line 849 "../lib/Widgets/SourceList.vala"
	_g_object_unref0 (self->priv->child_tree);
#line 719 "../lib/Widgets/SourceList.vala"
	G_OBJECT_CLASS (granite_widgets_source_list_data_model_parent_class)->finalize (obj);
#line 8446 "SourceList.c"
}


/**
     * The model backing the SourceList tree.
     *
     * It monitors item property changes, and handles children additions and removals. It also controls
     * the visibility of the items based on their "visible" property, and on their number of children,
     * if they happen to be categories. Its main purpose is to provide an easy and practical interface
     * for sorting, adding, removing and updating items, eliminating the need of repeatedly dealing with
     * the Gtk.TreeModel API directly.
     */
static GType
granite_widgets_source_list_data_model_get_type (void)
{
	static volatile gsize granite_widgets_source_list_data_model_type_id__volatile = 0;
	if (g_once_init_enter (&granite_widgets_source_list_data_model_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GraniteWidgetsSourceListDataModelClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) granite_widgets_source_list_data_model_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GraniteWidgetsSourceListDataModel), 0, (GInstanceInitFunc) granite_widgets_source_list_data_model_instance_init, NULL };
		static const GInterfaceInfo gtk_tree_drag_source_info = { (GInterfaceInitFunc) granite_widgets_source_list_data_model_gtk_tree_drag_source_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		static const GInterfaceInfo gtk_tree_drag_dest_info = { (GInterfaceInitFunc) granite_widgets_source_list_data_model_gtk_tree_drag_dest_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType granite_widgets_source_list_data_model_type_id;
		granite_widgets_source_list_data_model_type_id = g_type_register_static (gtk_tree_model_filter_get_type (), "GraniteWidgetsSourceListDataModel", &g_define_type_info, 0);
		g_type_add_interface_static (granite_widgets_source_list_data_model_type_id, gtk_tree_drag_source_get_type (), &gtk_tree_drag_source_info);
		g_type_add_interface_static (granite_widgets_source_list_data_model_type_id, gtk_tree_drag_dest_get_type (), &gtk_tree_drag_dest_info);
		GraniteWidgetsSourceListDataModel_private_offset = g_type_add_instance_private (granite_widgets_source_list_data_model_type_id, sizeof (GraniteWidgetsSourceListDataModelPrivate));
		g_once_init_leave (&granite_widgets_source_list_data_model_type_id__volatile, granite_widgets_source_list_data_model_type_id);
	}
	return granite_widgets_source_list_data_model_type_id__volatile;
}


static void
_vala_granite_widgets_source_list_data_model_get_property (GObject * object,
                                                           guint property_id,
                                                           GValue * value,
                                                           GParamSpec * pspec)
{
	GraniteWidgetsSourceListDataModel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GRANITE_WIDGETS_SOURCE_LIST_TYPE_DATA_MODEL, GraniteWidgetsSourceListDataModel);
#line 719 "../lib/Widgets/SourceList.vala"
	switch (property_id) {
#line 719 "../lib/Widgets/SourceList.vala"
		case GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_ROOT_PROPERTY:
#line 719 "../lib/Widgets/SourceList.vala"
		g_value_set_object (value, granite_widgets_source_list_data_model_get_root (self));
#line 719 "../lib/Widgets/SourceList.vala"
		break;
#line 8494 "SourceList.c"
		default:
#line 719 "../lib/Widgets/SourceList.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 719 "../lib/Widgets/SourceList.vala"
		break;
#line 8500 "SourceList.c"
	}
}


static void
_vala_granite_widgets_source_list_data_model_set_property (GObject * object,
                                                           guint property_id,
                                                           const GValue * value,
                                                           GParamSpec * pspec)
{
	GraniteWidgetsSourceListDataModel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GRANITE_WIDGETS_SOURCE_LIST_TYPE_DATA_MODEL, GraniteWidgetsSourceListDataModel);
#line 719 "../lib/Widgets/SourceList.vala"
	switch (property_id) {
#line 719 "../lib/Widgets/SourceList.vala"
		case GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_ROOT_PROPERTY:
#line 719 "../lib/Widgets/SourceList.vala"
		granite_widgets_source_list_data_model_set_root (self, g_value_get_object (value));
#line 719 "../lib/Widgets/SourceList.vala"
		break;
#line 8521 "SourceList.c"
		default:
#line 719 "../lib/Widgets/SourceList.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 719 "../lib/Widgets/SourceList.vala"
		break;
#line 8527 "SourceList.c"
	}
}


static GraniteWidgetsSourceListCellRendererIcon*
granite_widgets_source_list_cell_renderer_icon_construct (GType object_type)
{
	GraniteWidgetsSourceListCellRendererIcon * self = NULL;
#line 1470 "../lib/Widgets/SourceList.vala"
	self = (GraniteWidgetsSourceListCellRendererIcon*) g_object_new (object_type, NULL);
#line 1470 "../lib/Widgets/SourceList.vala"
	return self;
#line 8540 "SourceList.c"
}


static GraniteWidgetsSourceListCellRendererIcon*
granite_widgets_source_list_cell_renderer_icon_new (void)
{
#line 1470 "../lib/Widgets/SourceList.vala"
	return granite_widgets_source_list_cell_renderer_icon_construct (GRANITE_WIDGETS_SOURCE_LIST_TYPE_CELL_RENDERER_ICON);
#line 8549 "SourceList.c"
}


static gboolean
granite_widgets_source_list_cell_renderer_icon_real_activate (GtkCellRenderer* base,
                                                              GdkEvent* event,
                                                              GtkWidget* widget,
                                                              const gchar* path,
                                                              GdkRectangle* background_area,
                                                              GdkRectangle* cell_area,
                                                              GtkCellRendererState flags)
{
	GraniteWidgetsSourceListCellRendererIcon * self;
	gboolean result = FALSE;
#line 1479 "../lib/Widgets/SourceList.vala"
	self = (GraniteWidgetsSourceListCellRendererIcon*) base;
#line 1479 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 1479 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (widget != NULL, FALSE);
#line 1479 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 1479 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (background_area != NULL, FALSE);
#line 1479 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (cell_area != NULL, FALSE);
#line 1483 "../lib/Widgets/SourceList.vala"
	g_signal_emit (self, granite_widgets_source_list_cell_renderer_icon_signals[GRANITE_WIDGETS_SOURCE_LIST_CELL_RENDERER_ICON_ACTIVATED_SIGNAL], 0, path);
#line 1484 "../lib/Widgets/SourceList.vala"
	result = TRUE;
#line 1484 "../lib/Widgets/SourceList.vala"
	return result;
#line 8582 "SourceList.c"
}


static GObject *
granite_widgets_source_list_cell_renderer_icon_constructor (GType type,
                                                            guint n_construct_properties,
                                                            GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GraniteWidgetsSourceListCellRendererIcon * self;
#line 1474 "../lib/Widgets/SourceList.vala"
	parent_class = G_OBJECT_CLASS (granite_widgets_source_list_cell_renderer_icon_parent_class);
#line 1474 "../lib/Widgets/SourceList.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 1474 "../lib/Widgets/SourceList.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GRANITE_WIDGETS_SOURCE_LIST_TYPE_CELL_RENDERER_ICON, GraniteWidgetsSourceListCellRendererIcon);
#line 1475 "../lib/Widgets/SourceList.vala"
	g_object_set ((GtkCellRenderer*) self, "mode", GTK_CELL_RENDERER_MODE_ACTIVATABLE, NULL);
#line 1476 "../lib/Widgets/SourceList.vala"
	g_object_set ((GtkCellRendererPixbuf*) self, "stock-size", (guint) GRANITE_WIDGETS_SOURCE_LIST_CELL_RENDERER_ICON_ICON_SIZE, NULL);
#line 1474 "../lib/Widgets/SourceList.vala"
	return obj;
#line 8606 "SourceList.c"
}


static void
granite_widgets_source_list_cell_renderer_icon_class_init (GraniteWidgetsSourceListCellRendererIconClass * klass)
{
#line 1465 "../lib/Widgets/SourceList.vala"
	granite_widgets_source_list_cell_renderer_icon_parent_class = g_type_class_peek_parent (klass);
#line 1465 "../lib/Widgets/SourceList.vala"
	((GtkCellRendererClass *) klass)->activate = (gboolean (*) (GtkCellRenderer*, GdkEvent*, GtkWidget*, const gchar*, GdkRectangle*, GdkRectangle*, GtkCellRendererState)) granite_widgets_source_list_cell_renderer_icon_real_activate;
#line 1465 "../lib/Widgets/SourceList.vala"
	G_OBJECT_CLASS (klass)->constructor = granite_widgets_source_list_cell_renderer_icon_constructor;
#line 1465 "../lib/Widgets/SourceList.vala"
	granite_widgets_source_list_cell_renderer_icon_signals[GRANITE_WIDGETS_SOURCE_LIST_CELL_RENDERER_ICON_ACTIVATED_SIGNAL] = g_signal_new ("activated", GRANITE_WIDGETS_SOURCE_LIST_TYPE_CELL_RENDERER_ICON, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
#line 8621 "SourceList.c"
}


static void
granite_widgets_source_list_cell_renderer_icon_instance_init (GraniteWidgetsSourceListCellRendererIcon * self)
{
}


/**
     * Class responsible for rendering Item.icon and Item.activatable. It also
     * notifies about clicks through the activated() signal.
     */
static GType
granite_widgets_source_list_cell_renderer_icon_get_type (void)
{
	static volatile gsize granite_widgets_source_list_cell_renderer_icon_type_id__volatile = 0;
	if (g_once_init_enter (&granite_widgets_source_list_cell_renderer_icon_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GraniteWidgetsSourceListCellRendererIconClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) granite_widgets_source_list_cell_renderer_icon_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GraniteWidgetsSourceListCellRendererIcon), 0, (GInstanceInitFunc) granite_widgets_source_list_cell_renderer_icon_instance_init, NULL };
		GType granite_widgets_source_list_cell_renderer_icon_type_id;
		granite_widgets_source_list_cell_renderer_icon_type_id = g_type_register_static (gtk_cell_renderer_pixbuf_get_type (), "GraniteWidgetsSourceListCellRendererIcon", &g_define_type_info, 0);
		g_once_init_leave (&granite_widgets_source_list_cell_renderer_icon_type_id__volatile, granite_widgets_source_list_cell_renderer_icon_type_id);
	}
	return granite_widgets_source_list_cell_renderer_icon_type_id__volatile;
}


static inline gpointer
granite_widgets_source_list_cell_renderer_spacer_get_instance_private (GraniteWidgetsSourceListCellRendererSpacer* self)
{
	return G_STRUCT_MEMBER_P (self, GraniteWidgetsSourceListCellRendererSpacer_private_offset);
}


static GtkSizeRequestMode
granite_widgets_source_list_cell_renderer_spacer_real_get_request_mode (GtkCellRenderer* base)
{
	GraniteWidgetsSourceListCellRendererSpacer * self;
	GtkSizeRequestMode result = 0;
#line 1499 "../lib/Widgets/SourceList.vala"
	self = (GraniteWidgetsSourceListCellRendererSpacer*) base;
#line 1500 "../lib/Widgets/SourceList.vala"
	result = GTK_SIZE_REQUEST_HEIGHT_FOR_WIDTH;
#line 1500 "../lib/Widgets/SourceList.vala"
	return result;
#line 8667 "SourceList.c"
}


static void
granite_widgets_source_list_cell_renderer_spacer_real_get_preferred_width (GtkCellRenderer* base,
                                                                           GtkWidget* widget,
                                                                           gint* min_size,
                                                                           gint* natural_size)
{
	GraniteWidgetsSourceListCellRendererSpacer * self;
	gint _vala_min_size = 0;
	gint _vala_natural_size = 0;
	guint _tmp0_;
	guint _tmp1_;
#line 1503 "../lib/Widgets/SourceList.vala"
	self = (GraniteWidgetsSourceListCellRendererSpacer*) base;
#line 1503 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (widget != NULL);
#line 1504 "../lib/Widgets/SourceList.vala"
	g_object_get ((GtkCellRenderer*) self, "xpad", &_tmp0_, NULL);
#line 1504 "../lib/Widgets/SourceList.vala"
	_tmp1_ = _tmp0_;
#line 1504 "../lib/Widgets/SourceList.vala"
	_vala_natural_size = 2 * ((gint) _tmp1_);
#line 1504 "../lib/Widgets/SourceList.vala"
	_vala_min_size = _vala_natural_size;
#line 1503 "../lib/Widgets/SourceList.vala"
	if (min_size) {
#line 1503 "../lib/Widgets/SourceList.vala"
		*min_size = _vala_min_size;
#line 8698 "SourceList.c"
	}
#line 1503 "../lib/Widgets/SourceList.vala"
	if (natural_size) {
#line 1503 "../lib/Widgets/SourceList.vala"
		*natural_size = _vala_natural_size;
#line 8704 "SourceList.c"
	}
}


static void
granite_widgets_source_list_cell_renderer_spacer_real_get_preferred_height_for_width (GtkCellRenderer* base,
                                                                                      GtkWidget* widget,
                                                                                      gint width,
                                                                                      gint* min_height,
                                                                                      gint* natural_height)
{
	GraniteWidgetsSourceListCellRendererSpacer * self;
	gint _vala_min_height = 0;
	gint _vala_natural_height = 0;
	guint _tmp0_;
	guint _tmp1_;
#line 1507 "../lib/Widgets/SourceList.vala"
	self = (GraniteWidgetsSourceListCellRendererSpacer*) base;
#line 1507 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (widget != NULL);
#line 1510 "../lib/Widgets/SourceList.vala"
	g_object_get ((GtkCellRenderer*) self, "ypad", &_tmp0_, NULL);
#line 1510 "../lib/Widgets/SourceList.vala"
	_tmp1_ = _tmp0_;
#line 1510 "../lib/Widgets/SourceList.vala"
	_vala_natural_height = 2 * ((gint) _tmp1_);
#line 1510 "../lib/Widgets/SourceList.vala"
	_vala_min_height = _vala_natural_height;
#line 1507 "../lib/Widgets/SourceList.vala"
	if (min_height) {
#line 1507 "../lib/Widgets/SourceList.vala"
		*min_height = _vala_min_height;
#line 8737 "SourceList.c"
	}
#line 1507 "../lib/Widgets/SourceList.vala"
	if (natural_height) {
#line 1507 "../lib/Widgets/SourceList.vala"
		*natural_height = _vala_natural_height;
#line 8743 "SourceList.c"
	}
}


static void
granite_widgets_source_list_cell_renderer_spacer_real_render (GtkCellRenderer* base,
                                                              cairo_t* context,
                                                              GtkWidget* widget,
                                                              GdkRectangle* bg_area,
                                                              GdkRectangle* cell_area,
                                                              GtkCellRendererState flags)
{
	GraniteWidgetsSourceListCellRendererSpacer * self;
#line 1513 "../lib/Widgets/SourceList.vala"
	self = (GraniteWidgetsSourceListCellRendererSpacer*) base;
#line 1513 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (context != NULL);
#line 1513 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (widget != NULL);
#line 1513 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (bg_area != NULL);
#line 1513 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (cell_area != NULL);
#line 8767 "SourceList.c"
}


static void
granite_widgets_source_list_cell_renderer_spacer_real_get_size (GtkCellRenderer* base,
                                                                GtkWidget* widget,
                                                                GdkRectangle* cell_area,
                                                                gint* x_offset,
                                                                gint* y_offset,
                                                                gint* width,
                                                                gint* height)
{
	GraniteWidgetsSourceListCellRendererSpacer * self;
	gint _vala_x_offset = 0;
	gint _vala_y_offset = 0;
	gint _vala_width = 0;
	gint _vala_height = 0;
#line 1520 "../lib/Widgets/SourceList.vala"
	self = (GraniteWidgetsSourceListCellRendererSpacer*) base;
#line 1520 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (widget != NULL);
#line 1524 "../lib/Widgets/SourceList.vala"
	g_assert_not_reached ();
#line 1520 "../lib/Widgets/SourceList.vala"
	if (x_offset) {
#line 1520 "../lib/Widgets/SourceList.vala"
		*x_offset = _vala_x_offset;
#line 8795 "SourceList.c"
	}
#line 1520 "../lib/Widgets/SourceList.vala"
	if (y_offset) {
#line 1520 "../lib/Widgets/SourceList.vala"
		*y_offset = _vala_y_offset;
#line 8801 "SourceList.c"
	}
#line 1520 "../lib/Widgets/SourceList.vala"
	if (width) {
#line 1520 "../lib/Widgets/SourceList.vala"
		*width = _vala_width;
#line 8807 "SourceList.c"
	}
#line 1520 "../lib/Widgets/SourceList.vala"
	if (height) {
#line 1520 "../lib/Widgets/SourceList.vala"
		*height = _vala_height;
#line 8813 "SourceList.c"
	}
}


static GraniteWidgetsSourceListCellRendererSpacer*
granite_widgets_source_list_cell_renderer_spacer_construct (GType object_type)
{
	GraniteWidgetsSourceListCellRendererSpacer * self = NULL;
#line 1493 "../lib/Widgets/SourceList.vala"
	self = (GraniteWidgetsSourceListCellRendererSpacer*) g_object_new (object_type, NULL);
#line 1493 "../lib/Widgets/SourceList.vala"
	return self;
#line 8826 "SourceList.c"
}


static GraniteWidgetsSourceListCellRendererSpacer*
granite_widgets_source_list_cell_renderer_spacer_new (void)
{
#line 1493 "../lib/Widgets/SourceList.vala"
	return granite_widgets_source_list_cell_renderer_spacer_construct (GRANITE_WIDGETS_SOURCE_LIST_TYPE_CELL_RENDERER_SPACER);
#line 8835 "SourceList.c"
}


static gint
granite_widgets_source_list_cell_renderer_spacer_get_level (GraniteWidgetsSourceListCellRendererSpacer* self)
{
	gint result;
	gint _tmp0_;
#line 1497 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 1497 "../lib/Widgets/SourceList.vala"
	_tmp0_ = self->priv->_level;
#line 1497 "../lib/Widgets/SourceList.vala"
	result = _tmp0_;
#line 1497 "../lib/Widgets/SourceList.vala"
	return result;
#line 8852 "SourceList.c"
}


static void
granite_widgets_source_list_cell_renderer_spacer_set_level (GraniteWidgetsSourceListCellRendererSpacer* self,
                                                            gint value)
{
#line 1497 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 1497 "../lib/Widgets/SourceList.vala"
	if (granite_widgets_source_list_cell_renderer_spacer_get_level (self) != value) {
#line 1497 "../lib/Widgets/SourceList.vala"
		self->priv->_level = value;
#line 1497 "../lib/Widgets/SourceList.vala"
		g_object_notify_by_pspec ((GObject *) self, granite_widgets_source_list_cell_renderer_spacer_properties[GRANITE_WIDGETS_SOURCE_LIST_CELL_RENDERER_SPACER_LEVEL_PROPERTY]);
#line 8868 "SourceList.c"
	}
}


static void
granite_widgets_source_list_cell_renderer_spacer_class_init (GraniteWidgetsSourceListCellRendererSpacerClass * klass)
{
#line 1493 "../lib/Widgets/SourceList.vala"
	granite_widgets_source_list_cell_renderer_spacer_parent_class = g_type_class_peek_parent (klass);
#line 1493 "../lib/Widgets/SourceList.vala"
	g_type_class_adjust_private_offset (klass, &GraniteWidgetsSourceListCellRendererSpacer_private_offset);
#line 1493 "../lib/Widgets/SourceList.vala"
	((GtkCellRendererClass *) klass)->get_request_mode = (GtkSizeRequestMode (*) (GtkCellRenderer*)) granite_widgets_source_list_cell_renderer_spacer_real_get_request_mode;
#line 1493 "../lib/Widgets/SourceList.vala"
	((GtkCellRendererClass *) klass)->get_preferred_width = (void (*) (GtkCellRenderer*, GtkWidget*, gint*, gint*)) granite_widgets_source_list_cell_renderer_spacer_real_get_preferred_width;
#line 1493 "../lib/Widgets/SourceList.vala"
	((GtkCellRendererClass *) klass)->get_preferred_height_for_width = (void (*) (GtkCellRenderer*, GtkWidget*, gint, gint*, gint*)) granite_widgets_source_list_cell_renderer_spacer_real_get_preferred_height_for_width;
#line 1493 "../lib/Widgets/SourceList.vala"
	((GtkCellRendererClass *) klass)->render = (void (*) (GtkCellRenderer*, cairo_t*, GtkWidget*, GdkRectangle*, GdkRectangle*, GtkCellRendererState)) granite_widgets_source_list_cell_renderer_spacer_real_render;
#line 1493 "../lib/Widgets/SourceList.vala"
	((GtkCellRendererClass *) klass)->get_size = (void (*) (GtkCellRenderer*, GtkWidget*, GdkRectangle*, gint*, gint*, gint*, gint*)) granite_widgets_source_list_cell_renderer_spacer_real_get_size;
#line 1493 "../lib/Widgets/SourceList.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_granite_widgets_source_list_cell_renderer_spacer_get_property;
#line 1493 "../lib/Widgets/SourceList.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_granite_widgets_source_list_cell_renderer_spacer_set_property;
#line 1493 "../lib/Widgets/SourceList.vala"
	G_OBJECT_CLASS (klass)->finalize = granite_widgets_source_list_cell_renderer_spacer_finalize;
#line 8896 "SourceList.c"
	/**
	         * Indentation level represented by this cell renderer
	         */
#line 1493 "../lib/Widgets/SourceList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_CELL_RENDERER_SPACER_LEVEL_PROPERTY, granite_widgets_source_list_cell_renderer_spacer_properties[GRANITE_WIDGETS_SOURCE_LIST_CELL_RENDERER_SPACER_LEVEL_PROPERTY] = g_param_spec_int ("level", "level", "level", G_MININT, G_MAXINT, -1, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 8902 "SourceList.c"
}


static void
granite_widgets_source_list_cell_renderer_spacer_instance_init (GraniteWidgetsSourceListCellRendererSpacer * self)
{
#line 1493 "../lib/Widgets/SourceList.vala"
	self->priv = granite_widgets_source_list_cell_renderer_spacer_get_instance_private (self);
#line 1497 "../lib/Widgets/SourceList.vala"
	self->priv->_level = -1;
#line 8913 "SourceList.c"
}


static void
granite_widgets_source_list_cell_renderer_spacer_finalize (GObject * obj)
{
	GraniteWidgetsSourceListCellRendererSpacer * self;
#line 1493 "../lib/Widgets/SourceList.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GRANITE_WIDGETS_SOURCE_LIST_TYPE_CELL_RENDERER_SPACER, GraniteWidgetsSourceListCellRendererSpacer);
#line 1493 "../lib/Widgets/SourceList.vala"
	G_OBJECT_CLASS (granite_widgets_source_list_cell_renderer_spacer_parent_class)->finalize (obj);
#line 8925 "SourceList.c"
}


/**
     * A cell renderer that only adds space.
     */
static GType
granite_widgets_source_list_cell_renderer_spacer_get_type (void)
{
	static volatile gsize granite_widgets_source_list_cell_renderer_spacer_type_id__volatile = 0;
	if (g_once_init_enter (&granite_widgets_source_list_cell_renderer_spacer_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GraniteWidgetsSourceListCellRendererSpacerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) granite_widgets_source_list_cell_renderer_spacer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GraniteWidgetsSourceListCellRendererSpacer), 0, (GInstanceInitFunc) granite_widgets_source_list_cell_renderer_spacer_instance_init, NULL };
		GType granite_widgets_source_list_cell_renderer_spacer_type_id;
		granite_widgets_source_list_cell_renderer_spacer_type_id = g_type_register_static (gtk_cell_renderer_get_type (), "GraniteWidgetsSourceListCellRendererSpacer", &g_define_type_info, 0);
		GraniteWidgetsSourceListCellRendererSpacer_private_offset = g_type_add_instance_private (granite_widgets_source_list_cell_renderer_spacer_type_id, sizeof (GraniteWidgetsSourceListCellRendererSpacerPrivate));
		g_once_init_leave (&granite_widgets_source_list_cell_renderer_spacer_type_id__volatile, granite_widgets_source_list_cell_renderer_spacer_type_id);
	}
	return granite_widgets_source_list_cell_renderer_spacer_type_id__volatile;
}


static void
_vala_granite_widgets_source_list_cell_renderer_spacer_get_property (GObject * object,
                                                                     guint property_id,
                                                                     GValue * value,
                                                                     GParamSpec * pspec)
{
	GraniteWidgetsSourceListCellRendererSpacer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GRANITE_WIDGETS_SOURCE_LIST_TYPE_CELL_RENDERER_SPACER, GraniteWidgetsSourceListCellRendererSpacer);
#line 1493 "../lib/Widgets/SourceList.vala"
	switch (property_id) {
#line 1493 "../lib/Widgets/SourceList.vala"
		case GRANITE_WIDGETS_SOURCE_LIST_CELL_RENDERER_SPACER_LEVEL_PROPERTY:
#line 1493 "../lib/Widgets/SourceList.vala"
		g_value_set_int (value, granite_widgets_source_list_cell_renderer_spacer_get_level (self));
#line 1493 "../lib/Widgets/SourceList.vala"
		break;
#line 8963 "SourceList.c"
		default:
#line 1493 "../lib/Widgets/SourceList.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 1493 "../lib/Widgets/SourceList.vala"
		break;
#line 8969 "SourceList.c"
	}
}


static void
_vala_granite_widgets_source_list_cell_renderer_spacer_set_property (GObject * object,
                                                                     guint property_id,
                                                                     const GValue * value,
                                                                     GParamSpec * pspec)
{
	GraniteWidgetsSourceListCellRendererSpacer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GRANITE_WIDGETS_SOURCE_LIST_TYPE_CELL_RENDERER_SPACER, GraniteWidgetsSourceListCellRendererSpacer);
#line 1493 "../lib/Widgets/SourceList.vala"
	switch (property_id) {
#line 1493 "../lib/Widgets/SourceList.vala"
		case GRANITE_WIDGETS_SOURCE_LIST_CELL_RENDERER_SPACER_LEVEL_PROPERTY:
#line 1493 "../lib/Widgets/SourceList.vala"
		granite_widgets_source_list_cell_renderer_spacer_set_level (self, g_value_get_int (value));
#line 1493 "../lib/Widgets/SourceList.vala"
		break;
#line 8990 "SourceList.c"
		default:
#line 1493 "../lib/Widgets/SourceList.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 1493 "../lib/Widgets/SourceList.vala"
		break;
#line 8996 "SourceList.c"
	}
}


static inline gpointer
granite_widgets_source_list_tree_get_instance_private (GraniteWidgetsSourceListTree* self)
{
	return G_STRUCT_MEMBER_P (self, GraniteWidgetsSourceListTree_private_offset);
}


static GType
granite_widgets_source_list_tree_column_get_type (void)
{
	static volatile gsize granite_widgets_source_list_tree_column_type_id__volatile = 0;
	if (g_once_init_enter (&granite_widgets_source_list_tree_column_type_id__volatile)) {
		static const GEnumValue values[] = {{GRANITE_WIDGETS_SOURCE_LIST_TREE_COLUMN_ITEM, "GRANITE_WIDGETS_SOURCE_LIST_TREE_COLUMN_ITEM", "item"}, {GRANITE_WIDGETS_SOURCE_LIST_TREE_COLUMN_N_COLS, "GRANITE_WIDGETS_SOURCE_LIST_TREE_COLUMN_N_COLS", "n-cols"}, {0, NULL, NULL}};
		GType granite_widgets_source_list_tree_column_type_id;
		granite_widgets_source_list_tree_column_type_id = g_enum_register_static ("GraniteWidgetsSourceListTreeColumn", values);
		g_once_init_leave (&granite_widgets_source_list_tree_column_type_id__volatile, granite_widgets_source_list_tree_column_type_id);
	}
	return granite_widgets_source_list_tree_column_type_id__volatile;
}


static GraniteWidgetsSourceListTree*
granite_widgets_source_list_tree_construct (GType object_type,
                                            GraniteWidgetsSourceListDataModel* data_model)
{
	GraniteWidgetsSourceListTree * self = NULL;
#line 1606 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (data_model != NULL, NULL);
#line 1607 "../lib/Widgets/SourceList.vala"
	self = (GraniteWidgetsSourceListTree*) g_object_new (object_type, "data-model", data_model, NULL);
#line 1606 "../lib/Widgets/SourceList.vala"
	return self;
#line 9033 "SourceList.c"
}


static GraniteWidgetsSourceListTree*
granite_widgets_source_list_tree_new (GraniteWidgetsSourceListDataModel* data_model)
{
#line 1606 "../lib/Widgets/SourceList.vala"
	return granite_widgets_source_list_tree_construct (GRANITE_WIDGETS_SOURCE_LIST_TYPE_TREE, data_model);
#line 9042 "SourceList.c"
}


static gpointer
_gtk_target_list_ref0 (gpointer self)
{
#line 1743 "../lib/Widgets/SourceList.vala"
	return self ? gtk_target_list_ref (self) : NULL;
#line 9051 "SourceList.c"
}


static gboolean
granite_widgets_source_list_tree_real_drag_motion (GtkWidget* base,
                                                   GdkDragContext* context,
                                                   gint x,
                                                   gint y,
                                                   guint time)
{
	GraniteWidgetsSourceListTree * self;
	gboolean result = FALSE;
	GtkTreePath* suggested_path = NULL;
	GtkTreePath* current_path = NULL;
	GtkTreeViewDropPosition suggested_pos = 0;
	GtkTreeViewDropPosition current_pos = 0;
	GtkTreePath* _tmp0_ = NULL;
	GtkTreeViewDropPosition _tmp1_ = 0;
	gboolean _tmp2_;
#line 1701 "../lib/Widgets/SourceList.vala"
	self = (GraniteWidgetsSourceListTree*) base;
#line 1701 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (context != NULL, FALSE);
#line 1703 "../lib/Widgets/SourceList.vala"
	if (!GTK_WIDGET_CLASS (granite_widgets_source_list_tree_parent_class)->drag_motion ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_tree_view_get_type (), GtkTreeView), context, x, y, time)) {
#line 1704 "../lib/Widgets/SourceList.vala"
		result = FALSE;
#line 1704 "../lib/Widgets/SourceList.vala"
		return result;
#line 9081 "SourceList.c"
	}
#line 1709 "../lib/Widgets/SourceList.vala"
	_tmp2_ = gtk_tree_view_get_dest_row_at_pos ((GtkTreeView*) self, x, y, &_tmp0_, &_tmp1_);
#line 1709 "../lib/Widgets/SourceList.vala"
	__vala_GtkTreePath_free0 (suggested_path);
#line 1709 "../lib/Widgets/SourceList.vala"
	suggested_path = _tmp0_;
#line 1709 "../lib/Widgets/SourceList.vala"
	suggested_pos = _tmp1_;
#line 1709 "../lib/Widgets/SourceList.vala"
	if (_tmp2_) {
#line 9093 "SourceList.c"
		GtkTreePath* _tmp3_ = NULL;
		GtkTreeViewDropPosition _tmp4_ = 0;
		gboolean _tmp5_ = FALSE;
		GtkTreePath* _tmp6_;
#line 1713 "../lib/Widgets/SourceList.vala"
		gtk_tree_view_get_drag_dest_row ((GtkTreeView*) self, &_tmp3_, &_tmp4_);
#line 1713 "../lib/Widgets/SourceList.vala"
		__vala_GtkTreePath_free0 (current_path);
#line 1713 "../lib/Widgets/SourceList.vala"
		current_path = _tmp3_;
#line 1713 "../lib/Widgets/SourceList.vala"
		current_pos = _tmp4_;
#line 1715 "../lib/Widgets/SourceList.vala"
		_tmp6_ = current_path;
#line 1715 "../lib/Widgets/SourceList.vala"
		if (_tmp6_ != NULL) {
#line 9110 "SourceList.c"
			GtkTreePath* _tmp7_;
			GtkTreePath* _tmp8_;
#line 1715 "../lib/Widgets/SourceList.vala"
			_tmp7_ = suggested_path;
#line 1715 "../lib/Widgets/SourceList.vala"
			_tmp8_ = current_path;
#line 1715 "../lib/Widgets/SourceList.vala"
			_tmp5_ = gtk_tree_path_compare (_tmp7_, _tmp8_) == 0;
#line 9119 "SourceList.c"
		} else {
#line 1715 "../lib/Widgets/SourceList.vala"
			_tmp5_ = FALSE;
#line 9123 "SourceList.c"
		}
#line 1715 "../lib/Widgets/SourceList.vala"
		if (_tmp5_) {
#line 9127 "SourceList.c"
			GtkWidget* source_widget = NULL;
			GtkWidget* _tmp9_;
			GtkWidget* _tmp10_;
			gboolean dragging_treemodel_row = FALSE;
			GtkWidget* _tmp11_;
			gboolean _tmp12_;
#line 1719 "../lib/Widgets/SourceList.vala"
			_tmp9_ = gtk_drag_get_source_widget (context);
#line 1719 "../lib/Widgets/SourceList.vala"
			_tmp10_ = _g_object_ref0 (_tmp9_);
#line 1719 "../lib/Widgets/SourceList.vala"
			source_widget = _tmp10_;
#line 1720 "../lib/Widgets/SourceList.vala"
			_tmp11_ = source_widget;
#line 1720 "../lib/Widgets/SourceList.vala"
			dragging_treemodel_row = _tmp11_ == G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget);
#line 1722 "../lib/Widgets/SourceList.vala"
			_tmp12_ = dragging_treemodel_row;
#line 1722 "../lib/Widgets/SourceList.vala"
			if (_tmp12_) {
#line 9148 "SourceList.c"
				GtkTreeViewDropPosition _tmp13_;
#line 1725 "../lib/Widgets/SourceList.vala"
				_tmp13_ = current_pos;
#line 1725 "../lib/Widgets/SourceList.vala"
				if (_tmp13_ != GTK_TREE_VIEW_DROP_BEFORE) {
#line 9154 "SourceList.c"
					GtkTreeViewDropPosition _tmp14_;
#line 1726 "../lib/Widgets/SourceList.vala"
					_tmp14_ = current_pos;
#line 1726 "../lib/Widgets/SourceList.vala"
					if (_tmp14_ == GTK_TREE_VIEW_DROP_INTO_OR_BEFORE) {
#line 9160 "SourceList.c"
						GtkTreePath* _tmp15_;
#line 1727 "../lib/Widgets/SourceList.vala"
						_tmp15_ = current_path;
#line 1727 "../lib/Widgets/SourceList.vala"
						gtk_tree_view_set_drag_dest_row ((GtkTreeView*) self, _tmp15_, GTK_TREE_VIEW_DROP_BEFORE);
#line 9166 "SourceList.c"
					} else {
#line 1729 "../lib/Widgets/SourceList.vala"
						gtk_tree_view_set_drag_dest_row ((GtkTreeView*) self, NULL, GTK_TREE_VIEW_DROP_AFTER);
#line 9170 "SourceList.c"
					}
				}
			} else {
				GtkTreeViewDropPosition _tmp16_;
				GraniteWidgetsSourceListDragDest* dest = NULL;
				GraniteWidgetsSourceListDataModel* _tmp20_;
				GtkTreePath* _tmp21_;
				GraniteWidgetsSourceListItem* _tmp22_;
				GraniteWidgetsSourceListDragDest* _tmp23_;
				GraniteWidgetsSourceListDragDest* _tmp24_;
#line 1734 "../lib/Widgets/SourceList.vala"
				_tmp16_ = current_pos;
#line 1734 "../lib/Widgets/SourceList.vala"
				if (_tmp16_ == GTK_TREE_VIEW_DROP_BEFORE) {
#line 9185 "SourceList.c"
					GtkTreePath* _tmp17_;
#line 1735 "../lib/Widgets/SourceList.vala"
					_tmp17_ = current_path;
#line 1735 "../lib/Widgets/SourceList.vala"
					gtk_tree_view_set_drag_dest_row ((GtkTreeView*) self, _tmp17_, GTK_TREE_VIEW_DROP_INTO_OR_BEFORE);
#line 9191 "SourceList.c"
				} else {
					GtkTreeViewDropPosition _tmp18_;
#line 1736 "../lib/Widgets/SourceList.vala"
					_tmp18_ = current_pos;
#line 1736 "../lib/Widgets/SourceList.vala"
					if (_tmp18_ == GTK_TREE_VIEW_DROP_AFTER) {
#line 9198 "SourceList.c"
						GtkTreePath* _tmp19_;
#line 1737 "../lib/Widgets/SourceList.vala"
						_tmp19_ = current_path;
#line 1737 "../lib/Widgets/SourceList.vala"
						gtk_tree_view_set_drag_dest_row ((GtkTreeView*) self, _tmp19_, GTK_TREE_VIEW_DROP_INTO_OR_AFTER);
#line 9204 "SourceList.c"
					}
				}
#line 1740 "../lib/Widgets/SourceList.vala"
				_tmp20_ = self->priv->_data_model;
#line 1740 "../lib/Widgets/SourceList.vala"
				_tmp21_ = current_path;
#line 1740 "../lib/Widgets/SourceList.vala"
				_tmp22_ = granite_widgets_source_list_data_model_get_item_from_path (_tmp20_, _tmp21_);
#line 1740 "../lib/Widgets/SourceList.vala"
				_tmp23_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp22_, GRANITE_WIDGETS_TYPE_SOURCE_LIST_DRAG_DEST) ? ((GraniteWidgetsSourceListDragDest*) _tmp22_) : NULL;
#line 1740 "../lib/Widgets/SourceList.vala"
				if (_tmp23_ == NULL) {
#line 1740 "../lib/Widgets/SourceList.vala"
					_g_object_unref0 (_tmp22_);
#line 9219 "SourceList.c"
				}
#line 1740 "../lib/Widgets/SourceList.vala"
				dest = _tmp23_;
#line 1742 "../lib/Widgets/SourceList.vala"
				_tmp24_ = dest;
#line 1742 "../lib/Widgets/SourceList.vala"
				if (_tmp24_ != NULL) {
#line 9227 "SourceList.c"
					GtkTargetList* target_list = NULL;
					GtkTargetList* _tmp25_;
					GtkTargetList* _tmp26_;
					GdkAtom target = 0U;
					GtkTargetList* _tmp27_;
					GdkAtom _tmp28_;
#line 1743 "../lib/Widgets/SourceList.vala"
					_tmp25_ = gtk_drag_dest_get_target_list ((GtkWidget*) self);
#line 1743 "../lib/Widgets/SourceList.vala"
					_tmp26_ = _gtk_target_list_ref0 (_tmp25_);
#line 1743 "../lib/Widgets/SourceList.vala"
					target_list = _tmp26_;
#line 1744 "../lib/Widgets/SourceList.vala"
					_tmp27_ = target_list;
#line 1744 "../lib/Widgets/SourceList.vala"
					target = gtk_drag_dest_find_target ((GtkWidget*) self, context, _tmp27_);
#line 1748 "../lib/Widgets/SourceList.vala"
					g_object_set_data_full ((GObject*) context, "suggested-dnd-action", (gpointer) ((gintptr) ((gint) gdk_drag_context_get_suggested_action (context))), NULL);
#line 1749 "../lib/Widgets/SourceList.vala"
					_tmp28_ = target;
#line 1749 "../lib/Widgets/SourceList.vala"
					gtk_drag_get_data ((GtkWidget*) self, context, _tmp28_, (guint32) time);
#line 1742 "../lib/Widgets/SourceList.vala"
					_gtk_target_list_unref0 (target_list);
#line 9252 "SourceList.c"
				} else {
#line 1752 "../lib/Widgets/SourceList.vala"
					gtk_tree_view_set_drag_dest_row ((GtkTreeView*) self, NULL, GTK_TREE_VIEW_DROP_BEFORE);
#line 9256 "SourceList.c"
				}
#line 1722 "../lib/Widgets/SourceList.vala"
				_g_object_unref0 (dest);
#line 9260 "SourceList.c"
			}
#line 1715 "../lib/Widgets/SourceList.vala"
			_g_object_unref0 (source_widget);
#line 9264 "SourceList.c"
		}
	} else {
#line 1758 "../lib/Widgets/SourceList.vala"
		gtk_tree_view_set_drag_dest_row ((GtkTreeView*) self, NULL, GTK_TREE_VIEW_DROP_AFTER);
#line 1759 "../lib/Widgets/SourceList.vala"
		result = FALSE;
#line 1759 "../lib/Widgets/SourceList.vala"
		__vala_GtkTreePath_free0 (current_path);
#line 1759 "../lib/Widgets/SourceList.vala"
		__vala_GtkTreePath_free0 (suggested_path);
#line 1759 "../lib/Widgets/SourceList.vala"
		return result;
#line 9277 "SourceList.c"
	}
#line 1762 "../lib/Widgets/SourceList.vala"
	result = TRUE;
#line 1762 "../lib/Widgets/SourceList.vala"
	__vala_GtkTreePath_free0 (current_path);
#line 1762 "../lib/Widgets/SourceList.vala"
	__vala_GtkTreePath_free0 (suggested_path);
#line 1762 "../lib/Widgets/SourceList.vala"
	return result;
#line 9287 "SourceList.c"
}


static void
granite_widgets_source_list_tree_real_drag_data_received (GtkWidget* base,
                                                          GdkDragContext* context,
                                                          gint x,
                                                          gint y,
                                                          GtkSelectionData* selection_data,
                                                          guint info,
                                                          guint time)
{
	GraniteWidgetsSourceListTree * self;
	GtkTargetList* target_list = NULL;
	GtkTargetList* _tmp0_;
	GtkTargetList* _tmp1_;
	GdkAtom target = 0U;
	GtkTargetList* _tmp2_;
	GdkAtom _tmp3_;
	GtkTreePath* path = NULL;
	GtkTreeViewDropPosition pos = 0;
	gconstpointer _tmp4_;
#line 1765 "../lib/Widgets/SourceList.vala"
	self = (GraniteWidgetsSourceListTree*) base;
#line 1765 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (context != NULL);
#line 1765 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (selection_data != NULL);
#line 1769 "../lib/Widgets/SourceList.vala"
	_tmp0_ = gtk_drag_dest_get_target_list ((GtkWidget*) self);
#line 1769 "../lib/Widgets/SourceList.vala"
	_tmp1_ = _gtk_target_list_ref0 (_tmp0_);
#line 1769 "../lib/Widgets/SourceList.vala"
	target_list = _tmp1_;
#line 1770 "../lib/Widgets/SourceList.vala"
	_tmp2_ = target_list;
#line 1770 "../lib/Widgets/SourceList.vala"
	target = gtk_drag_dest_find_target ((GtkWidget*) self, context, _tmp2_);
#line 1772 "../lib/Widgets/SourceList.vala"
	_tmp3_ = target;
#line 1772 "../lib/Widgets/SourceList.vala"
	if (_tmp3_ == gdk_atom_intern_static_string ("GTK_TREE_MODEL_ROW")) {
#line 1773 "../lib/Widgets/SourceList.vala"
		GTK_WIDGET_CLASS (granite_widgets_source_list_tree_parent_class)->drag_data_received ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_tree_view_get_type (), GtkTreeView), context, x, y, selection_data, info, time);
#line 1774 "../lib/Widgets/SourceList.vala"
		_gtk_target_list_unref0 (target_list);
#line 1774 "../lib/Widgets/SourceList.vala"
		return;
#line 9336 "SourceList.c"
	}
#line 1780 "../lib/Widgets/SourceList.vala"
	_tmp4_ = g_object_get_data ((GObject*) context, "suggested-dnd-action");
#line 1780 "../lib/Widgets/SourceList.vala"
	if (((gint) ((gintptr) _tmp4_)) != 0) {
#line 9342 "SourceList.c"
		GtkTreePath* _tmp5_ = NULL;
		GtkTreeViewDropPosition _tmp6_ = 0;
		GtkTreePath* _tmp7_;
#line 1781 "../lib/Widgets/SourceList.vala"
		g_object_set_data_full ((GObject*) context, "suggested-dnd-action", (gpointer) ((gintptr) 0), NULL);
#line 1783 "../lib/Widgets/SourceList.vala"
		gtk_tree_view_get_drag_dest_row ((GtkTreeView*) self, &_tmp5_, &_tmp6_);
#line 1783 "../lib/Widgets/SourceList.vala"
		__vala_GtkTreePath_free0 (path);
#line 1783 "../lib/Widgets/SourceList.vala"
		path = _tmp5_;
#line 1783 "../lib/Widgets/SourceList.vala"
		pos = _tmp6_;
#line 1785 "../lib/Widgets/SourceList.vala"
		_tmp7_ = path;
#line 1785 "../lib/Widgets/SourceList.vala"
		if (_tmp7_ != NULL) {
#line 9360 "SourceList.c"
			GraniteWidgetsSourceListDragDest* dest = NULL;
			GraniteWidgetsSourceListDataModel* _tmp8_;
			GtkTreePath* _tmp9_;
			GraniteWidgetsSourceListItem* _tmp10_;
			GraniteWidgetsSourceListDragDest* _tmp11_;
			gboolean _tmp12_ = FALSE;
			GraniteWidgetsSourceListDragDest* _tmp13_;
#line 1787 "../lib/Widgets/SourceList.vala"
			_tmp8_ = self->priv->_data_model;
#line 1787 "../lib/Widgets/SourceList.vala"
			_tmp9_ = path;
#line 1787 "../lib/Widgets/SourceList.vala"
			_tmp10_ = granite_widgets_source_list_data_model_get_item_from_path (_tmp8_, _tmp9_);
#line 1787 "../lib/Widgets/SourceList.vala"
			_tmp11_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp10_, GRANITE_WIDGETS_TYPE_SOURCE_LIST_DRAG_DEST) ? ((GraniteWidgetsSourceListDragDest*) _tmp10_) : NULL;
#line 1787 "../lib/Widgets/SourceList.vala"
			if (_tmp11_ == NULL) {
#line 1787 "../lib/Widgets/SourceList.vala"
				_g_object_unref0 (_tmp10_);
#line 9380 "SourceList.c"
			}
#line 1787 "../lib/Widgets/SourceList.vala"
			dest = _tmp11_;
#line 1789 "../lib/Widgets/SourceList.vala"
			_tmp13_ = dest;
#line 1789 "../lib/Widgets/SourceList.vala"
			if (_tmp13_ == NULL) {
#line 1789 "../lib/Widgets/SourceList.vala"
				_tmp12_ = TRUE;
#line 9390 "SourceList.c"
			} else {
				GraniteWidgetsSourceListDragDest* _tmp14_;
#line 1789 "../lib/Widgets/SourceList.vala"
				_tmp14_ = dest;
#line 1789 "../lib/Widgets/SourceList.vala"
				_tmp12_ = !granite_widgets_source_list_drag_dest_data_drop_possible (_tmp14_, context, selection_data);
#line 9397 "SourceList.c"
			}
#line 1789 "../lib/Widgets/SourceList.vala"
			if (_tmp12_) {
#line 1792 "../lib/Widgets/SourceList.vala"
				gtk_tree_view_set_drag_dest_row ((GtkTreeView*) self, NULL, GTK_TREE_VIEW_DROP_BEFORE);
#line 1793 "../lib/Widgets/SourceList.vala"
				gdk_drag_status (context, 0, (guint32) time);
#line 1794 "../lib/Widgets/SourceList.vala"
				_g_object_unref0 (dest);
#line 1794 "../lib/Widgets/SourceList.vala"
				__vala_GtkTreePath_free0 (path);
#line 1794 "../lib/Widgets/SourceList.vala"
				_gtk_target_list_unref0 (target_list);
#line 1794 "../lib/Widgets/SourceList.vala"
				return;
#line 9413 "SourceList.c"
			}
#line 1785 "../lib/Widgets/SourceList.vala"
			_g_object_unref0 (dest);
#line 9417 "SourceList.c"
		}
#line 1798 "../lib/Widgets/SourceList.vala"
		gdk_drag_status (context, gdk_drag_context_get_suggested_action (context), (guint32) time);
#line 9421 "SourceList.c"
	} else {
		GtkTreePath* _tmp15_ = NULL;
		GtkTreeViewDropPosition _tmp16_ = 0;
		gboolean _tmp17_;
#line 1800 "../lib/Widgets/SourceList.vala"
		_tmp17_ = gtk_tree_view_get_dest_row_at_pos ((GtkTreeView*) self, x, y, &_tmp15_, &_tmp16_);
#line 1800 "../lib/Widgets/SourceList.vala"
		__vala_GtkTreePath_free0 (path);
#line 1800 "../lib/Widgets/SourceList.vala"
		path = _tmp15_;
#line 1800 "../lib/Widgets/SourceList.vala"
		pos = _tmp16_;
#line 1800 "../lib/Widgets/SourceList.vala"
		if (_tmp17_) {
#line 9436 "SourceList.c"
			GraniteWidgetsSourceListDragDest* drag_dest = NULL;
			GraniteWidgetsSourceListDataModel* _tmp18_;
			GtkTreePath* _tmp19_;
			GraniteWidgetsSourceListItem* _tmp20_;
			GraniteWidgetsSourceListDragDest* _tmp21_;
			GraniteWidgetsSourceListDragDest* _tmp22_;
#line 1806 "../lib/Widgets/SourceList.vala"
			_tmp18_ = self->priv->_data_model;
#line 1806 "../lib/Widgets/SourceList.vala"
			_tmp19_ = path;
#line 1806 "../lib/Widgets/SourceList.vala"
			_tmp20_ = granite_widgets_source_list_data_model_get_item_from_path (_tmp18_, _tmp19_);
#line 1806 "../lib/Widgets/SourceList.vala"
			_tmp21_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp20_, GRANITE_WIDGETS_TYPE_SOURCE_LIST_DRAG_DEST) ? ((GraniteWidgetsSourceListDragDest*) _tmp20_) : NULL;
#line 1806 "../lib/Widgets/SourceList.vala"
			if (_tmp21_ == NULL) {
#line 1806 "../lib/Widgets/SourceList.vala"
				_g_object_unref0 (_tmp20_);
#line 9455 "SourceList.c"
			}
#line 1806 "../lib/Widgets/SourceList.vala"
			drag_dest = _tmp21_;
#line 1808 "../lib/Widgets/SourceList.vala"
			_tmp22_ = drag_dest;
#line 1808 "../lib/Widgets/SourceList.vala"
			if (_tmp22_ != NULL) {
#line 9463 "SourceList.c"
				GdkDragAction action = 0U;
				GraniteWidgetsSourceListDragDest* _tmp23_;
				GdkDragAction _tmp24_;
				GdkDragAction _tmp25_;
#line 1809 "../lib/Widgets/SourceList.vala"
				_tmp23_ = drag_dest;
#line 1809 "../lib/Widgets/SourceList.vala"
				action = granite_widgets_source_list_drag_dest_data_received (_tmp23_, context, selection_data);
#line 1810 "../lib/Widgets/SourceList.vala"
				_tmp24_ = action;
#line 1810 "../lib/Widgets/SourceList.vala"
				_tmp25_ = action;
#line 1810 "../lib/Widgets/SourceList.vala"
				gtk_drag_finish (context, _tmp24_ != 0, _tmp25_ == GDK_ACTION_MOVE, (guint32) time);
#line 1811 "../lib/Widgets/SourceList.vala"
				_g_object_unref0 (drag_dest);
#line 1811 "../lib/Widgets/SourceList.vala"
				__vala_GtkTreePath_free0 (path);
#line 1811 "../lib/Widgets/SourceList.vala"
				_gtk_target_list_unref0 (target_list);
#line 1811 "../lib/Widgets/SourceList.vala"
				return;
#line 9486 "SourceList.c"
			}
#line 1800 "../lib/Widgets/SourceList.vala"
			_g_object_unref0 (drag_dest);
#line 9490 "SourceList.c"
		}
#line 1816 "../lib/Widgets/SourceList.vala"
		gtk_drag_finish (context, FALSE, FALSE, (guint32) time);
#line 9494 "SourceList.c"
	}
#line 1765 "../lib/Widgets/SourceList.vala"
	__vala_GtkTreePath_free0 (path);
#line 1765 "../lib/Widgets/SourceList.vala"
	_gtk_target_list_unref0 (target_list);
#line 9500 "SourceList.c"
}


static void
granite_widgets_source_list_tree_configure_drag_source (GraniteWidgetsSourceListTree* self,
                                                        GtkTargetEntry* src_entries,
                                                        int src_entries_length1)
{
	GtkTargetEntry* entries = NULL;
	gint _tmp0_ = 0;
	GtkTargetEntry* _tmp1_;
	gint entries_length1;
	gint _entries_size_;
#line 1820 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 1822 "../lib/Widgets/SourceList.vala"
	_tmp1_ = granite_widgets_source_list_tree_append_row_target_entry (src_entries, src_entries_length1, &_tmp0_);
#line 1822 "../lib/Widgets/SourceList.vala"
	entries = _tmp1_;
#line 1822 "../lib/Widgets/SourceList.vala"
	entries_length1 = _tmp0_;
#line 1822 "../lib/Widgets/SourceList.vala"
	_entries_size_ = entries_length1;
#line 1824 "../lib/Widgets/SourceList.vala"
	gtk_tree_view_unset_rows_drag_source ((GtkTreeView*) self);
#line 1825 "../lib/Widgets/SourceList.vala"
	gtk_tree_view_enable_model_drag_source ((GtkTreeView*) self, GDK_BUTTON1_MASK, entries, entries_length1, GDK_ACTION_MOVE);
#line 1820 "../lib/Widgets/SourceList.vala"
	entries = (g_free (entries), NULL);
#line 9530 "SourceList.c"
}


static void
granite_widgets_source_list_tree_configure_drag_dest (GraniteWidgetsSourceListTree* self,
                                                      GtkTargetEntry* dest_entries,
                                                      int dest_entries_length1,
                                                      GdkDragAction actions)
{
	GtkTargetEntry* entries = NULL;
	gint _tmp0_ = 0;
	GtkTargetEntry* _tmp1_;
	gint entries_length1;
	gint _entries_size_;
#line 1828 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 1830 "../lib/Widgets/SourceList.vala"
	_tmp1_ = granite_widgets_source_list_tree_append_row_target_entry (dest_entries, dest_entries_length1, &_tmp0_);
#line 1830 "../lib/Widgets/SourceList.vala"
	entries = _tmp1_;
#line 1830 "../lib/Widgets/SourceList.vala"
	entries_length1 = _tmp0_;
#line 1830 "../lib/Widgets/SourceList.vala"
	_entries_size_ = entries_length1;
#line 1832 "../lib/Widgets/SourceList.vala"
	gtk_tree_view_unset_rows_drag_dest ((GtkTreeView*) self);
#line 1835 "../lib/Widgets/SourceList.vala"
	gtk_tree_view_enable_model_drag_dest ((GtkTreeView*) self, entries, entries_length1, GDK_ACTION_MOVE | actions);
#line 1828 "../lib/Widgets/SourceList.vala"
	entries = (g_free (entries), NULL);
#line 9561 "SourceList.c"
}


static void
_vala_array_add2 (GtkTargetEntry* * array,
                  int* length,
                  int* size,
                  const GtkTargetEntry* value)
{
#line 1843 "../lib/Widgets/SourceList.vala"
	if ((*length) == (*size)) {
#line 1843 "../lib/Widgets/SourceList.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1843 "../lib/Widgets/SourceList.vala"
		*array = g_renew (GtkTargetEntry, *array, *size);
#line 9577 "SourceList.c"
	}
#line 1843 "../lib/Widgets/SourceList.vala"
	(*array)[(*length)++] = *value;
#line 9581 "SourceList.c"
}


static void
_vala_array_add3 (GtkTargetEntry* * array,
                  int* length,
                  int* size,
                  const GtkTargetEntry* value)
{
#line 1847 "../lib/Widgets/SourceList.vala"
	if ((*length) == (*size)) {
#line 1847 "../lib/Widgets/SourceList.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1847 "../lib/Widgets/SourceList.vala"
		*array = g_renew (GtkTargetEntry, *array, *size);
#line 9597 "SourceList.c"
	}
#line 1847 "../lib/Widgets/SourceList.vala"
	(*array)[(*length)++] = *value;
#line 9601 "SourceList.c"
}


static GtkTargetEntry*
granite_widgets_source_list_tree_append_row_target_entry (GtkTargetEntry* orig,
                                                          int orig_length1,
                                                          int* result_length1)
{
	GtkTargetEntry* result = NULL;
#line 1839 "../lib/Widgets/SourceList.vala"
	static const GtkTargetEntry row_target_entry = {"GTK_TREE_MODEL_ROW", (guint) GTK_TARGET_SAME_WIDGET, (guint) 0};
#line 9613 "SourceList.c"
	GtkTargetEntry* entries = NULL;
	GtkTargetEntry* _tmp0_;
	gint entries_length1;
	gint _entries_size_;
	GtkTargetEntry* _tmp1_;
	gint _tmp1__length1;
	GtkTargetEntry* _tmp4_;
	gint _tmp4__length1;
#line 1842 "../lib/Widgets/SourceList.vala"
	_tmp0_ = g_new0 (GtkTargetEntry, 0);
#line 1842 "../lib/Widgets/SourceList.vala"
	entries = _tmp0_;
#line 1842 "../lib/Widgets/SourceList.vala"
	entries_length1 = 0;
#line 1842 "../lib/Widgets/SourceList.vala"
	_entries_size_ = entries_length1;
#line 1843 "../lib/Widgets/SourceList.vala"
	_tmp1_ = entries;
#line 1843 "../lib/Widgets/SourceList.vala"
	_tmp1__length1 = entries_length1;
#line 1843 "../lib/Widgets/SourceList.vala"
	_vala_array_add2 (&entries, &entries_length1, &_entries_size_, &row_target_entry);
#line 1845 "../lib/Widgets/SourceList.vala"
	if (orig != NULL) {
#line 9638 "SourceList.c"
		{
			GtkTargetEntry* target_entry_collection = NULL;
			gint target_entry_collection_length1 = 0;
			gint _target_entry_collection_size_ = 0;
			gint target_entry_it = 0;
#line 1846 "../lib/Widgets/SourceList.vala"
			target_entry_collection = orig;
#line 1846 "../lib/Widgets/SourceList.vala"
			target_entry_collection_length1 = orig_length1;
#line 1846 "../lib/Widgets/SourceList.vala"
			for (target_entry_it = 0; target_entry_it < orig_length1; target_entry_it = target_entry_it + 1) {
#line 9650 "SourceList.c"
				GtkTargetEntry target_entry = {0};
#line 1846 "../lib/Widgets/SourceList.vala"
				target_entry = target_entry_collection[target_entry_it];
#line 9654 "SourceList.c"
				{
					GtkTargetEntry* _tmp2_;
					gint _tmp2__length1;
					GtkTargetEntry _tmp3_;
#line 1847 "../lib/Widgets/SourceList.vala"
					_tmp2_ = entries;
#line 1847 "../lib/Widgets/SourceList.vala"
					_tmp2__length1 = entries_length1;
#line 1847 "../lib/Widgets/SourceList.vala"
					_tmp3_ = target_entry;
#line 1847 "../lib/Widgets/SourceList.vala"
					_vala_array_add3 (&entries, &entries_length1, &_entries_size_, &_tmp3_);
#line 9667 "SourceList.c"
				}
			}
		}
	}
#line 1850 "../lib/Widgets/SourceList.vala"
	_tmp4_ = entries;
#line 1850 "../lib/Widgets/SourceList.vala"
	_tmp4__length1 = entries_length1;
#line 1850 "../lib/Widgets/SourceList.vala"
	if (result_length1) {
#line 1850 "../lib/Widgets/SourceList.vala"
		*result_length1 = _tmp4__length1;
#line 9680 "SourceList.c"
	}
#line 1850 "../lib/Widgets/SourceList.vala"
	result = _tmp4_;
#line 1850 "../lib/Widgets/SourceList.vala"
	return result;
#line 9686 "SourceList.c"
}


static void
_granite_widgets_source_list_tree_on_model_item_updated_granite_widgets_source_list_data_model_item_updated (GraniteWidgetsSourceListDataModel* _sender,
                                                                                                             GraniteWidgetsSourceListItem* item,
                                                                                                             gpointer self)
{
#line 1854 "../lib/Widgets/SourceList.vala"
	granite_widgets_source_list_tree_on_model_item_updated ((GraniteWidgetsSourceListTree*) self, item);
#line 9697 "SourceList.c"
}


static void
granite_widgets_source_list_tree_enable_item_property_monitor (GraniteWidgetsSourceListTree* self)
{
	GraniteWidgetsSourceListDataModel* _tmp0_;
#line 1853 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 1854 "../lib/Widgets/SourceList.vala"
	_tmp0_ = self->priv->_data_model;
#line 1854 "../lib/Widgets/SourceList.vala"
	g_signal_connect_object (_tmp0_, "item-updated", (GCallback) _granite_widgets_source_list_tree_on_model_item_updated_granite_widgets_source_list_data_model_item_updated, self, G_CONNECT_AFTER);
#line 9711 "SourceList.c"
}


static void
granite_widgets_source_list_tree_disable_item_property_monitor (GraniteWidgetsSourceListTree* self)
{
	GraniteWidgetsSourceListDataModel* _tmp0_;
	guint _tmp1_;
#line 1857 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 1858 "../lib/Widgets/SourceList.vala"
	_tmp0_ = self->priv->_data_model;
#line 1858 "../lib/Widgets/SourceList.vala"
	g_signal_parse_name ("item-updated", GRANITE_WIDGETS_SOURCE_LIST_TYPE_DATA_MODEL, &_tmp1_, NULL, FALSE);
#line 1858 "../lib/Widgets/SourceList.vala"
	g_signal_handlers_disconnect_matched (_tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _granite_widgets_source_list_tree_on_model_item_updated_granite_widgets_source_list_data_model_item_updated, self);
#line 9728 "SourceList.c"
}


static void
granite_widgets_source_list_tree_on_model_item_updated (GraniteWidgetsSourceListTree* self,
                                                        GraniteWidgetsSourceListItem* item)
{
	GraniteWidgetsSourceListExpandableItem* expandable_item = NULL;
	GraniteWidgetsSourceListExpandableItem* _tmp0_;
	GraniteWidgetsSourceListExpandableItem* _tmp1_;
#line 1861 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 1861 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (item != NULL);
#line 1864 "../lib/Widgets/SourceList.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (item, GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM) ? ((GraniteWidgetsSourceListExpandableItem*) item) : NULL);
#line 1864 "../lib/Widgets/SourceList.vala"
	expandable_item = _tmp0_;
#line 1865 "../lib/Widgets/SourceList.vala"
	_tmp1_ = expandable_item;
#line 1865 "../lib/Widgets/SourceList.vala"
	if (_tmp1_ != NULL) {
#line 9751 "SourceList.c"
		GraniteWidgetsSourceListExpandableItem* _tmp2_;
#line 1866 "../lib/Widgets/SourceList.vala"
		_tmp2_ = expandable_item;
#line 1866 "../lib/Widgets/SourceList.vala"
		granite_widgets_source_list_tree_update_expansion (self, _tmp2_);
#line 9757 "SourceList.c"
	}
#line 1861 "../lib/Widgets/SourceList.vala"
	_g_object_unref0 (expandable_item);
#line 9761 "SourceList.c"
}


static void
_granite_widgets_source_list_tree_spacer_cell_data_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout,
                                                                                   GtkCellRenderer* cell,
                                                                                   GtkTreeModel* tree_model,
                                                                                   GtkTreeIter* iter,
                                                                                   gpointer self)
{
#line 1910 "../lib/Widgets/SourceList.vala"
	granite_widgets_source_list_tree_spacer_cell_data_func (cell_layout, cell, tree_model, iter);
#line 9774 "SourceList.c"
}


static void
granite_widgets_source_list_tree_add_spacer_cell_for_level (GraniteWidgetsSourceListTree* self,
                                                            gint level,
                                                            gboolean check_previous)
{
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp2_;
#line 1869 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 1869 "../lib/Widgets/SourceList.vala"
	_vala_return_if_fail (level > 0, "level > 0");
#line 1872 "../lib/Widgets/SourceList.vala"
	_tmp0_ = self->priv->spacer_cells;
#line 1872 "../lib/Widgets/SourceList.vala"
	if (_tmp0_ == NULL) {
#line 9793 "SourceList.c"
		GeeHashMap* _tmp1_;
#line 1873 "../lib/Widgets/SourceList.vala"
		_tmp1_ = gee_hash_map_new (G_TYPE_INT, NULL, NULL, GRANITE_WIDGETS_SOURCE_LIST_TYPE_CELL_RENDERER_SPACER, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 1873 "../lib/Widgets/SourceList.vala"
		_g_object_unref0 (self->priv->spacer_cells);
#line 1873 "../lib/Widgets/SourceList.vala"
		self->priv->spacer_cells = _tmp1_;
#line 9801 "SourceList.c"
	}
#line 1875 "../lib/Widgets/SourceList.vala"
	_tmp2_ = self->priv->spacer_cells;
#line 1875 "../lib/Widgets/SourceList.vala"
	if (!gee_abstract_map_has_key ((GeeAbstractMap*) _tmp2_, (gpointer) ((gintptr) level))) {
#line 9807 "SourceList.c"
		GraniteWidgetsSourceListCellRendererSpacer* spacer_cell = NULL;
		GraniteWidgetsSourceListCellRendererSpacer* _tmp3_;
		GraniteWidgetsSourceListCellRendererSpacer* _tmp4_;
		GeeHashMap* _tmp5_;
		GraniteWidgetsSourceListCellRendererSpacer* _tmp6_;
		guint cell_xpadding = 0U;
		GraniteWidgetsSourceListCellRendererSpacer* _tmp11_;
		guint _tmp12_;
		GtkTreeViewColumn* item_column = NULL;
		GtkTreeViewColumn* _tmp13_;
		GtkTreeViewColumn* _tmp14_;
		GtkTreeViewColumn* _tmp15_;
		GraniteWidgetsSourceListCellRendererSpacer* _tmp16_;
		GtkTreeViewColumn* _tmp17_;
		GraniteWidgetsSourceListCellRendererSpacer* _tmp18_;
#line 1876 "../lib/Widgets/SourceList.vala"
		_tmp3_ = granite_widgets_source_list_cell_renderer_spacer_new ();
#line 1876 "../lib/Widgets/SourceList.vala"
		g_object_ref_sink (_tmp3_);
#line 1876 "../lib/Widgets/SourceList.vala"
		spacer_cell = _tmp3_;
#line 1877 "../lib/Widgets/SourceList.vala"
		_tmp4_ = spacer_cell;
#line 1877 "../lib/Widgets/SourceList.vala"
		granite_widgets_source_list_cell_renderer_spacer_set_level (_tmp4_, level);
#line 1878 "../lib/Widgets/SourceList.vala"
		_tmp5_ = self->priv->spacer_cells;
#line 1878 "../lib/Widgets/SourceList.vala"
		_tmp6_ = spacer_cell;
#line 1878 "../lib/Widgets/SourceList.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp5_, (gpointer) ((gintptr) level), _tmp6_);
#line 1888 "../lib/Widgets/SourceList.vala"
		switch (level) {
#line 1888 "../lib/Widgets/SourceList.vala"
			case 1:
#line 9843 "SourceList.c"
			{
				gint left_padding = 0;
				gint _tmp7_ = 0;
				gint _tmp8_;
#line 1891 "../lib/Widgets/SourceList.vala"
				gtk_widget_style_get ((GtkWidget*) self, GRANITE_WIDGETS_SOURCE_LIST_TREE_STYLE_PROP_LEFT_PADDING, &_tmp7_, NULL);
#line 1891 "../lib/Widgets/SourceList.vala"
				left_padding = _tmp7_;
#line 1892 "../lib/Widgets/SourceList.vala"
				_tmp8_ = left_padding;
#line 1892 "../lib/Widgets/SourceList.vala"
				cell_xpadding = (guint) (_tmp8_ / 2);
#line 1893 "../lib/Widgets/SourceList.vala"
				break;
#line 9858 "SourceList.c"
			}
#line 1888 "../lib/Widgets/SourceList.vala"
			case 2:
#line 9862 "SourceList.c"
			{
#line 1896 "../lib/Widgets/SourceList.vala"
				cell_xpadding = (guint) 0;
#line 1897 "../lib/Widgets/SourceList.vala"
				break;
#line 9868 "SourceList.c"
			}
			default:
			{
				gint level_indentation = 0;
				gint _tmp9_ = 0;
				gint _tmp10_;
#line 1901 "../lib/Widgets/SourceList.vala"
				gtk_widget_style_get ((GtkWidget*) self, GRANITE_WIDGETS_SOURCE_LIST_TREE_STYLE_PROP_LEVEL_INDENTATION, &_tmp9_, NULL);
#line 1901 "../lib/Widgets/SourceList.vala"
				level_indentation = _tmp9_;
#line 1902 "../lib/Widgets/SourceList.vala"
				_tmp10_ = level_indentation;
#line 1902 "../lib/Widgets/SourceList.vala"
				cell_xpadding = (guint) (_tmp10_ / 2);
#line 1903 "../lib/Widgets/SourceList.vala"
				break;
#line 9885 "SourceList.c"
			}
		}
#line 1906 "../lib/Widgets/SourceList.vala"
		_tmp11_ = spacer_cell;
#line 1906 "../lib/Widgets/SourceList.vala"
		_tmp12_ = cell_xpadding;
#line 1906 "../lib/Widgets/SourceList.vala"
		g_object_set ((GtkCellRenderer*) _tmp11_, "xpad", _tmp12_, NULL);
#line 1908 "../lib/Widgets/SourceList.vala"
		_tmp13_ = gtk_tree_view_get_column ((GtkTreeView*) self, (gint) GRANITE_WIDGETS_SOURCE_LIST_TREE_COLUMN_ITEM);
#line 1908 "../lib/Widgets/SourceList.vala"
		_tmp14_ = _g_object_ref0 (_tmp13_);
#line 1908 "../lib/Widgets/SourceList.vala"
		item_column = _tmp14_;
#line 1909 "../lib/Widgets/SourceList.vala"
		_tmp15_ = item_column;
#line 1909 "../lib/Widgets/SourceList.vala"
		_tmp16_ = spacer_cell;
#line 1909 "../lib/Widgets/SourceList.vala"
		gtk_cell_layout_pack_start ((GtkCellLayout*) _tmp15_, (GtkCellRenderer*) _tmp16_, FALSE);
#line 1910 "../lib/Widgets/SourceList.vala"
		_tmp17_ = item_column;
#line 1910 "../lib/Widgets/SourceList.vala"
		_tmp18_ = spacer_cell;
#line 1910 "../lib/Widgets/SourceList.vala"
		gtk_cell_layout_set_cell_data_func ((GtkCellLayout*) _tmp17_, (GtkCellRenderer*) _tmp18_, _granite_widgets_source_list_tree_spacer_cell_data_func_gtk_cell_layout_data_func, NULL, NULL);
#line 1913 "../lib/Widgets/SourceList.vala"
		if (check_previous) {
#line 9914 "SourceList.c"
			{
				gint i = 0;
#line 1914 "../lib/Widgets/SourceList.vala"
				i = level - 1;
#line 9919 "SourceList.c"
				{
					gboolean _tmp19_ = FALSE;
#line 1914 "../lib/Widgets/SourceList.vala"
					_tmp19_ = TRUE;
#line 1914 "../lib/Widgets/SourceList.vala"
					while (TRUE) {
#line 9926 "SourceList.c"
						gint _tmp21_;
						gint _tmp22_;
#line 1914 "../lib/Widgets/SourceList.vala"
						if (!_tmp19_) {
#line 9931 "SourceList.c"
							gint _tmp20_;
#line 1914 "../lib/Widgets/SourceList.vala"
							_tmp20_ = i;
#line 1914 "../lib/Widgets/SourceList.vala"
							i = _tmp20_ - 1;
#line 9937 "SourceList.c"
						}
#line 1914 "../lib/Widgets/SourceList.vala"
						_tmp19_ = FALSE;
#line 1914 "../lib/Widgets/SourceList.vala"
						_tmp21_ = i;
#line 1914 "../lib/Widgets/SourceList.vala"
						if (!(_tmp21_ > 0)) {
#line 1914 "../lib/Widgets/SourceList.vala"
							break;
#line 9947 "SourceList.c"
						}
#line 1915 "../lib/Widgets/SourceList.vala"
						_tmp22_ = i;
#line 1915 "../lib/Widgets/SourceList.vala"
						granite_widgets_source_list_tree_add_spacer_cell_for_level (self, _tmp22_, FALSE);
#line 9953 "SourceList.c"
					}
				}
			}
		}
#line 1875 "../lib/Widgets/SourceList.vala"
		_g_object_unref0 (item_column);
#line 1875 "../lib/Widgets/SourceList.vala"
		_g_object_unref0 (spacer_cell);
#line 9962 "SourceList.c"
	}
}


/**
         * Evaluates whether the item at the specified path can be selected or not.
         */
static gboolean
granite_widgets_source_list_tree_select_func (GraniteWidgetsSourceListTree* self,
                                              GtkTreeSelection* selection,
                                              GtkTreeModel* model,
                                              GtkTreePath* path,
                                              gboolean path_currently_selected)
{
	gboolean result = FALSE;
	gboolean selectable = FALSE;
	GraniteWidgetsSourceListItem* item = NULL;
	GraniteWidgetsSourceListDataModel* _tmp0_;
	GraniteWidgetsSourceListItem* _tmp1_;
	GraniteWidgetsSourceListItem* _tmp2_;
#line 1923 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1923 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (selection != NULL, FALSE);
#line 1923 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (model != NULL, FALSE);
#line 1923 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 1926 "../lib/Widgets/SourceList.vala"
	selectable = FALSE;
#line 1927 "../lib/Widgets/SourceList.vala"
	_tmp0_ = self->priv->_data_model;
#line 1927 "../lib/Widgets/SourceList.vala"
	_tmp1_ = granite_widgets_source_list_data_model_get_item_from_path (_tmp0_, path);
#line 1927 "../lib/Widgets/SourceList.vala"
	item = _tmp1_;
#line 1929 "../lib/Widgets/SourceList.vala"
	_tmp2_ = item;
#line 1929 "../lib/Widgets/SourceList.vala"
	if (_tmp2_ != NULL) {
#line 10003 "SourceList.c"
		GraniteWidgetsSourceListDataModel* _tmp3_;
		GraniteWidgetsSourceListItem* _tmp4_;
#line 1931 "../lib/Widgets/SourceList.vala"
		_tmp3_ = self->priv->_data_model;
#line 1931 "../lib/Widgets/SourceList.vala"
		_tmp4_ = item;
#line 1931 "../lib/Widgets/SourceList.vala"
		if (!granite_widgets_source_list_data_model_is_category (_tmp3_, _tmp4_, NULL, path)) {
#line 10012 "SourceList.c"
			GraniteWidgetsSourceListItem* _tmp5_;
			gboolean _tmp6_;
			gboolean _tmp7_;
#line 1932 "../lib/Widgets/SourceList.vala"
			_tmp5_ = item;
#line 1932 "../lib/Widgets/SourceList.vala"
			_tmp6_ = granite_widgets_source_list_item_get_selectable (_tmp5_);
#line 1932 "../lib/Widgets/SourceList.vala"
			_tmp7_ = _tmp6_;
#line 1932 "../lib/Widgets/SourceList.vala"
			selectable = _tmp7_;
#line 10024 "SourceList.c"
		}
	}
#line 1935 "../lib/Widgets/SourceList.vala"
	result = selectable;
#line 1935 "../lib/Widgets/SourceList.vala"
	_g_object_unref0 (item);
#line 1935 "../lib/Widgets/SourceList.vala"
	return result;
#line 10033 "SourceList.c"
}


static void
__vala_GtkTreePath_free0_ (gpointer var)
{
#line 1942 "../lib/Widgets/SourceList.vala"
	(var == NULL) ? NULL : (var = (_vala_GtkTreePath_free (var), NULL));
#line 10042 "SourceList.c"
}


static inline void
_g_list_free___vala_GtkTreePath_free0_ (GList* self)
{
#line 1942 "../lib/Widgets/SourceList.vala"
	g_list_free_full (self, (GDestroyNotify) __vala_GtkTreePath_free0_);
#line 10051 "SourceList.c"
}


static GtkTreePath*
granite_widgets_source_list_tree_get_selected_path (GraniteWidgetsSourceListTree* self)
{
	GtkTreePath* result = NULL;
	GtkTreePath* selected_path = NULL;
	GtkTreeSelection* selection = NULL;
	GtkTreeSelection* _tmp0_;
	GtkTreeSelection* _tmp1_;
	GtkTreeSelection* _tmp2_;
#line 1938 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1939 "../lib/Widgets/SourceList.vala"
	selected_path = NULL;
#line 1940 "../lib/Widgets/SourceList.vala"
	_tmp0_ = gtk_tree_view_get_selection ((GtkTreeView*) self);
#line 1940 "../lib/Widgets/SourceList.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 1940 "../lib/Widgets/SourceList.vala"
	selection = _tmp1_;
#line 1942 "../lib/Widgets/SourceList.vala"
	_tmp2_ = selection;
#line 1942 "../lib/Widgets/SourceList.vala"
	if (_tmp2_ != NULL) {
#line 10078 "SourceList.c"
		GtkTreeModel* model = NULL;
		GList* selected_rows = NULL;
		GtkTreeSelection* _tmp3_;
		GtkTreeModel* _tmp4_ = NULL;
		GList* _tmp5_;
		GtkTreeModel* _tmp6_;
		GList* _tmp7_;
#line 1944 "../lib/Widgets/SourceList.vala"
		_tmp3_ = selection;
#line 1944 "../lib/Widgets/SourceList.vala"
		_tmp5_ = gtk_tree_selection_get_selected_rows (_tmp3_, &_tmp4_);
#line 1944 "../lib/Widgets/SourceList.vala"
		_g_object_unref0 (model);
#line 1944 "../lib/Widgets/SourceList.vala"
		_tmp6_ = _g_object_ref0 (_tmp4_);
#line 1944 "../lib/Widgets/SourceList.vala"
		model = _tmp6_;
#line 1944 "../lib/Widgets/SourceList.vala"
		selected_rows = _tmp5_;
#line 1945 "../lib/Widgets/SourceList.vala"
		_tmp7_ = selected_rows;
#line 1945 "../lib/Widgets/SourceList.vala"
		if (g_list_length (_tmp7_) == ((guint) 1)) {
#line 10102 "SourceList.c"
			GList* _tmp8_;
			gconstpointer _tmp9_;
			GtkTreePath* _tmp10_;
#line 1946 "../lib/Widgets/SourceList.vala"
			_tmp8_ = selected_rows;
#line 1946 "../lib/Widgets/SourceList.vala"
			_tmp9_ = g_list_nth_data (_tmp8_, (guint) 0);
#line 1946 "../lib/Widgets/SourceList.vala"
			_tmp10_ = __vala_GtkTreePath_copy0 ((GtkTreePath*) _tmp9_);
#line 1946 "../lib/Widgets/SourceList.vala"
			__vala_GtkTreePath_free0 (selected_path);
#line 1946 "../lib/Widgets/SourceList.vala"
			selected_path = _tmp10_;
#line 10116 "SourceList.c"
		}
#line 1942 "../lib/Widgets/SourceList.vala"
		(selected_rows == NULL) ? NULL : (selected_rows = (_g_list_free___vala_GtkTreePath_free0_ (selected_rows), NULL));
#line 1942 "../lib/Widgets/SourceList.vala"
		_g_object_unref0 (model);
#line 10122 "SourceList.c"
	}
#line 1949 "../lib/Widgets/SourceList.vala"
	result = selected_path;
#line 1949 "../lib/Widgets/SourceList.vala"
	_g_object_unref0 (selection);
#line 1949 "../lib/Widgets/SourceList.vala"
	return result;
#line 10130 "SourceList.c"
}


static void
granite_widgets_source_list_tree_set_selected (GraniteWidgetsSourceListTree* self,
                                               GraniteWidgetsSourceListItem* item,
                                               gboolean scroll_to_item)
{
#line 1952 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 1953 "../lib/Widgets/SourceList.vala"
	if (item == NULL) {
#line 10143 "SourceList.c"
		GtkTreeSelection* selection = NULL;
		GtkTreeSelection* _tmp0_;
		GtkTreeSelection* _tmp1_;
		GtkTreeSelection* _tmp2_;
#line 1954 "../lib/Widgets/SourceList.vala"
		_tmp0_ = gtk_tree_view_get_selection ((GtkTreeView*) self);
#line 1954 "../lib/Widgets/SourceList.vala"
		_tmp1_ = _g_object_ref0 (_tmp0_);
#line 1954 "../lib/Widgets/SourceList.vala"
		selection = _tmp1_;
#line 1955 "../lib/Widgets/SourceList.vala"
		_tmp2_ = selection;
#line 1955 "../lib/Widgets/SourceList.vala"
		if (_tmp2_ != NULL) {
#line 10158 "SourceList.c"
			GtkTreeSelection* _tmp3_;
#line 1956 "../lib/Widgets/SourceList.vala"
			_tmp3_ = selection;
#line 1956 "../lib/Widgets/SourceList.vala"
			gtk_tree_selection_unselect_all (_tmp3_);
#line 10164 "SourceList.c"
		}
#line 1967 "../lib/Widgets/SourceList.vala"
		_g_object_unref0 (self->priv->selected);
#line 1967 "../lib/Widgets/SourceList.vala"
		self->priv->selected = NULL;
#line 1968 "../lib/Widgets/SourceList.vala"
		g_signal_emit (self, granite_widgets_source_list_tree_signals[GRANITE_WIDGETS_SOURCE_LIST_TREE_ITEM_SELECTED_SIGNAL], 0, NULL);
#line 1953 "../lib/Widgets/SourceList.vala"
		_g_object_unref0 (selection);
#line 10174 "SourceList.c"
	} else {
		gboolean _tmp4_;
		gboolean _tmp5_;
#line 1969 "../lib/Widgets/SourceList.vala"
		_tmp4_ = granite_widgets_source_list_item_get_selectable (item);
#line 1969 "../lib/Widgets/SourceList.vala"
		_tmp5_ = _tmp4_;
#line 1969 "../lib/Widgets/SourceList.vala"
		if (_tmp5_) {
#line 10184 "SourceList.c"
			GtkTreePath* to_select = NULL;
			GraniteWidgetsSourceListDataModel* _tmp6_;
			GtkTreePath* _tmp7_;
			GtkTreePath* _tmp8_;
#line 1970 "../lib/Widgets/SourceList.vala"
			if (scroll_to_item) {
#line 1971 "../lib/Widgets/SourceList.vala"
				granite_widgets_source_list_tree_scroll_to_item (self, item, FALSE, (gfloat) 0);
#line 10193 "SourceList.c"
			}
#line 1973 "../lib/Widgets/SourceList.vala"
			_tmp6_ = self->priv->_data_model;
#line 1973 "../lib/Widgets/SourceList.vala"
			_tmp7_ = granite_widgets_source_list_data_model_get_item_path (_tmp6_, item);
#line 1973 "../lib/Widgets/SourceList.vala"
			to_select = _tmp7_;
#line 1974 "../lib/Widgets/SourceList.vala"
			_tmp8_ = to_select;
#line 1974 "../lib/Widgets/SourceList.vala"
			if (_tmp8_ != NULL) {
#line 10205 "SourceList.c"
				GtkTreePath* _tmp9_;
				GtkTreeViewColumn* _tmp10_;
				GtkCellRendererText* _tmp11_;
#line 1975 "../lib/Widgets/SourceList.vala"
				_tmp9_ = to_select;
#line 1975 "../lib/Widgets/SourceList.vala"
				_tmp10_ = gtk_tree_view_get_column ((GtkTreeView*) self, (gint) GRANITE_WIDGETS_SOURCE_LIST_TREE_COLUMN_ITEM);
#line 1975 "../lib/Widgets/SourceList.vala"
				_tmp11_ = self->priv->text_cell;
#line 1975 "../lib/Widgets/SourceList.vala"
				gtk_tree_view_set_cursor_on_cell ((GtkTreeView*) self, _tmp9_, _tmp10_, (GtkCellRenderer*) _tmp11_, FALSE);
#line 10217 "SourceList.c"
			}
#line 1969 "../lib/Widgets/SourceList.vala"
			__vala_GtkTreePath_free0 (to_select);
#line 10221 "SourceList.c"
		}
	}
}


static void
granite_widgets_source_list_tree_real_cursor_changed (GtkTreeView* base)
{
	GraniteWidgetsSourceListTree * self;
	GtkTreePath* path = NULL;
	GtkTreePath* _tmp0_;
	GraniteWidgetsSourceListItem* _tmp1_ = NULL;
	GtkTreePath* _tmp2_;
	GraniteWidgetsSourceListItem* new_item = NULL;
	GraniteWidgetsSourceListItem* _tmp6_;
	gboolean _tmp7_ = FALSE;
	GraniteWidgetsSourceListItem* _tmp8_;
#line 1979 "../lib/Widgets/SourceList.vala"
	self = (GraniteWidgetsSourceListTree*) base;
#line 1980 "../lib/Widgets/SourceList.vala"
	_tmp0_ = granite_widgets_source_list_tree_get_selected_path (self);
#line 1980 "../lib/Widgets/SourceList.vala"
	path = _tmp0_;
#line 1981 "../lib/Widgets/SourceList.vala"
	_tmp2_ = path;
#line 1981 "../lib/Widgets/SourceList.vala"
	if (_tmp2_ != NULL) {
#line 10249 "SourceList.c"
		GraniteWidgetsSourceListDataModel* _tmp3_;
		GtkTreePath* _tmp4_;
		GraniteWidgetsSourceListItem* _tmp5_;
#line 1981 "../lib/Widgets/SourceList.vala"
		_tmp3_ = self->priv->_data_model;
#line 1981 "../lib/Widgets/SourceList.vala"
		_tmp4_ = path;
#line 1981 "../lib/Widgets/SourceList.vala"
		_tmp5_ = granite_widgets_source_list_data_model_get_item_from_path (_tmp3_, _tmp4_);
#line 1981 "../lib/Widgets/SourceList.vala"
		_g_object_unref0 (_tmp1_);
#line 1981 "../lib/Widgets/SourceList.vala"
		_tmp1_ = _tmp5_;
#line 10263 "SourceList.c"
	} else {
#line 1981 "../lib/Widgets/SourceList.vala"
		_g_object_unref0 (_tmp1_);
#line 1981 "../lib/Widgets/SourceList.vala"
		_tmp1_ = NULL;
#line 10269 "SourceList.c"
	}
#line 1981 "../lib/Widgets/SourceList.vala"
	_tmp6_ = _g_object_ref0 (_tmp1_);
#line 1981 "../lib/Widgets/SourceList.vala"
	new_item = _tmp6_;
#line 1994 "../lib/Widgets/SourceList.vala"
	_tmp8_ = new_item;
#line 1994 "../lib/Widgets/SourceList.vala"
	if (_tmp8_ != NULL) {
#line 10279 "SourceList.c"
		GraniteWidgetsSourceListItem* _tmp9_;
		GraniteWidgetsSourceListItem* _tmp10_;
#line 1994 "../lib/Widgets/SourceList.vala"
		_tmp9_ = new_item;
#line 1994 "../lib/Widgets/SourceList.vala"
		_tmp10_ = self->priv->selected;
#line 1994 "../lib/Widgets/SourceList.vala"
		_tmp7_ = _tmp9_ != _tmp10_;
#line 10288 "SourceList.c"
	} else {
#line 1994 "../lib/Widgets/SourceList.vala"
		_tmp7_ = FALSE;
#line 10292 "SourceList.c"
	}
#line 1994 "../lib/Widgets/SourceList.vala"
	if (_tmp7_) {
#line 10296 "SourceList.c"
		GraniteWidgetsSourceListItem* _tmp11_;
		GraniteWidgetsSourceListItem* _tmp12_;
		GraniteWidgetsSourceListItem* _tmp13_;
#line 1995 "../lib/Widgets/SourceList.vala"
		_tmp11_ = new_item;
#line 1995 "../lib/Widgets/SourceList.vala"
		_tmp12_ = _g_object_ref0 (_tmp11_);
#line 1995 "../lib/Widgets/SourceList.vala"
		_g_object_unref0 (self->priv->selected);
#line 1995 "../lib/Widgets/SourceList.vala"
		self->priv->selected = _tmp12_;
#line 1996 "../lib/Widgets/SourceList.vala"
		_tmp13_ = new_item;
#line 1996 "../lib/Widgets/SourceList.vala"
		g_signal_emit (self, granite_widgets_source_list_tree_signals[GRANITE_WIDGETS_SOURCE_LIST_TREE_ITEM_SELECTED_SIGNAL], 0, _tmp13_);
#line 10312 "SourceList.c"
	}
#line 1979 "../lib/Widgets/SourceList.vala"
	_g_object_unref0 (new_item);
#line 1979 "../lib/Widgets/SourceList.vala"
	_g_object_unref0 (_tmp1_);
#line 1979 "../lib/Widgets/SourceList.vala"
	__vala_GtkTreePath_free0 (path);
#line 10320 "SourceList.c"
}


static gboolean
granite_widgets_source_list_tree_scroll_to_item (GraniteWidgetsSourceListTree* self,
                                                 GraniteWidgetsSourceListItem* item,
                                                 gboolean use_align,
                                                 gfloat row_align)
{
	gboolean result = FALSE;
	gboolean scrolled = FALSE;
	GtkTreePath* path = NULL;
	GraniteWidgetsSourceListDataModel* _tmp0_;
	GtkTreePath* _tmp1_;
	GtkTreePath* _tmp2_;
#line 2000 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2000 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (item != NULL, FALSE);
#line 2001 "../lib/Widgets/SourceList.vala"
	scrolled = FALSE;
#line 2003 "../lib/Widgets/SourceList.vala"
	_tmp0_ = self->priv->_data_model;
#line 2003 "../lib/Widgets/SourceList.vala"
	_tmp1_ = granite_widgets_source_list_data_model_get_item_path (_tmp0_, item);
#line 2003 "../lib/Widgets/SourceList.vala"
	path = _tmp1_;
#line 2004 "../lib/Widgets/SourceList.vala"
	_tmp2_ = path;
#line 2004 "../lib/Widgets/SourceList.vala"
	if (_tmp2_ != NULL) {
#line 10352 "SourceList.c"
		GtkTreePath* _tmp3_;
#line 2005 "../lib/Widgets/SourceList.vala"
		_tmp3_ = path;
#line 2005 "../lib/Widgets/SourceList.vala"
		gtk_tree_view_scroll_to_cell ((GtkTreeView*) self, _tmp3_, NULL, use_align, row_align, (gfloat) 0);
#line 2006 "../lib/Widgets/SourceList.vala"
		scrolled = TRUE;
#line 10360 "SourceList.c"
	}
#line 2009 "../lib/Widgets/SourceList.vala"
	result = scrolled;
#line 2009 "../lib/Widgets/SourceList.vala"
	__vala_GtkTreePath_free0 (path);
#line 2009 "../lib/Widgets/SourceList.vala"
	return result;
#line 10368 "SourceList.c"
}


static gboolean
granite_widgets_source_list_tree_start_editing_item (GraniteWidgetsSourceListTree* self,
                                                     GraniteWidgetsSourceListItem* item)
{
	gboolean result = FALSE;
	gboolean _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_;
	gboolean _tmp6_;
	GtkTreePath* path = NULL;
	GraniteWidgetsSourceListDataModel* _tmp8_;
	GtkTreePath* _tmp9_;
	GtkTreePath* _tmp10_;
	gboolean _tmp17_;
	gboolean _tmp18_;
#line 2012 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2012 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (item != NULL, FALSE);
#line 2012 "../lib/Widgets/SourceList.vala"
	_tmp0_ = granite_widgets_source_list_item_get_editable (item);
#line 2012 "../lib/Widgets/SourceList.vala"
	_tmp1_ = _tmp0_;
#line 2012 "../lib/Widgets/SourceList.vala"
	_vala_return_val_if_fail (_tmp1_, "item.editable", FALSE);
#line 2012 "../lib/Widgets/SourceList.vala"
	_tmp2_ = granite_widgets_source_list_item_get_selectable (item);
#line 2012 "../lib/Widgets/SourceList.vala"
	_tmp3_ = _tmp2_;
#line 2012 "../lib/Widgets/SourceList.vala"
	_vala_return_val_if_fail (_tmp3_, "item.selectable", FALSE);
#line 2013 "../lib/Widgets/SourceList.vala"
	_tmp5_ = granite_widgets_source_list_tree_get_editing (self);
#line 2013 "../lib/Widgets/SourceList.vala"
	_tmp6_ = _tmp5_;
#line 2013 "../lib/Widgets/SourceList.vala"
	if (_tmp6_) {
#line 10412 "SourceList.c"
		GraniteWidgetsSourceListItem* _tmp7_;
#line 2013 "../lib/Widgets/SourceList.vala"
		_tmp7_ = self->priv->edited;
#line 2013 "../lib/Widgets/SourceList.vala"
		_tmp4_ = item == _tmp7_;
#line 10418 "SourceList.c"
	} else {
#line 2013 "../lib/Widgets/SourceList.vala"
		_tmp4_ = FALSE;
#line 10422 "SourceList.c"
	}
#line 2013 "../lib/Widgets/SourceList.vala"
	if (_tmp4_) {
#line 2014 "../lib/Widgets/SourceList.vala"
		result = FALSE;
#line 2014 "../lib/Widgets/SourceList.vala"
		return result;
#line 10430 "SourceList.c"
	}
#line 2016 "../lib/Widgets/SourceList.vala"
	_tmp8_ = self->priv->_data_model;
#line 2016 "../lib/Widgets/SourceList.vala"
	_tmp9_ = granite_widgets_source_list_data_model_get_item_path (_tmp8_, item);
#line 2016 "../lib/Widgets/SourceList.vala"
	path = _tmp9_;
#line 2017 "../lib/Widgets/SourceList.vala"
	_tmp10_ = path;
#line 2017 "../lib/Widgets/SourceList.vala"
	if (_tmp10_ != NULL) {
#line 10442 "SourceList.c"
		GtkCellRendererText* _tmp11_;
		GtkTreePath* _tmp12_;
		GtkTreeViewColumn* _tmp13_;
		GtkCellRendererText* _tmp14_;
#line 2018 "../lib/Widgets/SourceList.vala"
		self->priv->edited = item;
#line 2019 "../lib/Widgets/SourceList.vala"
		_tmp11_ = self->priv->text_cell;
#line 2019 "../lib/Widgets/SourceList.vala"
		g_object_set (_tmp11_, "editable", TRUE, NULL);
#line 2020 "../lib/Widgets/SourceList.vala"
		_tmp12_ = path;
#line 2020 "../lib/Widgets/SourceList.vala"
		_tmp13_ = gtk_tree_view_get_column ((GtkTreeView*) self, (gint) GRANITE_WIDGETS_SOURCE_LIST_TREE_COLUMN_ITEM);
#line 2020 "../lib/Widgets/SourceList.vala"
		_tmp14_ = self->priv->text_cell;
#line 2020 "../lib/Widgets/SourceList.vala"
		gtk_tree_view_set_cursor_on_cell ((GtkTreeView*) self, _tmp12_, _tmp13_, (GtkCellRenderer*) _tmp14_, TRUE);
#line 10461 "SourceList.c"
	} else {
		const gchar* _tmp15_;
		const gchar* _tmp16_;
#line 2022 "../lib/Widgets/SourceList.vala"
		_tmp15_ = granite_widgets_source_list_item_get_name (item);
#line 2022 "../lib/Widgets/SourceList.vala"
		_tmp16_ = _tmp15_;
#line 2022 "../lib/Widgets/SourceList.vala"
		g_warning ("SourceList.vala:2022: Could not edit \"%s\": path not found", _tmp16_);
#line 10471 "SourceList.c"
	}
#line 2025 "../lib/Widgets/SourceList.vala"
	_tmp17_ = granite_widgets_source_list_tree_get_editing (self);
#line 2025 "../lib/Widgets/SourceList.vala"
	_tmp18_ = _tmp17_;
#line 2025 "../lib/Widgets/SourceList.vala"
	result = _tmp18_;
#line 2025 "../lib/Widgets/SourceList.vala"
	__vala_GtkTreePath_free0 (path);
#line 2025 "../lib/Widgets/SourceList.vala"
	return result;
#line 10483 "SourceList.c"
}


static void
granite_widgets_source_list_tree_stop_editing (GraniteWidgetsSourceListTree* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 2028 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 2029 "../lib/Widgets/SourceList.vala"
	_tmp1_ = granite_widgets_source_list_tree_get_editing (self);
#line 2029 "../lib/Widgets/SourceList.vala"
	_tmp2_ = _tmp1_;
#line 2029 "../lib/Widgets/SourceList.vala"
	if (_tmp2_) {
#line 10501 "SourceList.c"
		GraniteWidgetsSourceListItem* _tmp3_;
#line 2029 "../lib/Widgets/SourceList.vala"
		_tmp3_ = self->priv->edited;
#line 2029 "../lib/Widgets/SourceList.vala"
		_tmp0_ = _tmp3_ != NULL;
#line 10507 "SourceList.c"
	} else {
#line 2029 "../lib/Widgets/SourceList.vala"
		_tmp0_ = FALSE;
#line 10511 "SourceList.c"
	}
#line 2029 "../lib/Widgets/SourceList.vala"
	if (_tmp0_) {
#line 10515 "SourceList.c"
		GtkTreePath* path = NULL;
		GraniteWidgetsSourceListDataModel* _tmp4_;
		GraniteWidgetsSourceListItem* _tmp5_;
		GtkTreePath* _tmp6_;
		GtkTreePath* _tmp7_;
#line 2030 "../lib/Widgets/SourceList.vala"
		_tmp4_ = self->priv->_data_model;
#line 2030 "../lib/Widgets/SourceList.vala"
		_tmp5_ = self->priv->edited;
#line 2030 "../lib/Widgets/SourceList.vala"
		_tmp6_ = granite_widgets_source_list_data_model_get_item_path (_tmp4_, _tmp5_);
#line 2030 "../lib/Widgets/SourceList.vala"
		path = _tmp6_;
#line 2034 "../lib/Widgets/SourceList.vala"
		_tmp7_ = path;
#line 2034 "../lib/Widgets/SourceList.vala"
		if (_tmp7_ != NULL) {
#line 10533 "SourceList.c"
			GtkTreePath* _tmp8_;
			GtkTreeViewColumn* _tmp9_;
			GtkCellRendererText* _tmp10_;
#line 2035 "../lib/Widgets/SourceList.vala"
			_tmp8_ = path;
#line 2035 "../lib/Widgets/SourceList.vala"
			_tmp9_ = gtk_tree_view_get_column ((GtkTreeView*) self, (gint) GRANITE_WIDGETS_SOURCE_LIST_TREE_COLUMN_ITEM);
#line 2035 "../lib/Widgets/SourceList.vala"
			_tmp10_ = self->priv->text_cell;
#line 2035 "../lib/Widgets/SourceList.vala"
			gtk_tree_view_set_cursor_on_cell ((GtkTreeView*) self, _tmp8_, _tmp9_, (GtkCellRenderer*) _tmp10_, FALSE);
#line 10545 "SourceList.c"
		}
#line 2029 "../lib/Widgets/SourceList.vala"
		__vala_GtkTreePath_free0 (path);
#line 10549 "SourceList.c"
	}
}


static void
_granite_widgets_source_list_tree_on_editing_done_gtk_cell_editable_editing_done (GtkCellEditable* _sender,
                                                                                  gpointer self)
{
#line 2042 "../lib/Widgets/SourceList.vala"
	granite_widgets_source_list_tree_on_editing_done ((GraniteWidgetsSourceListTree*) self);
#line 10560 "SourceList.c"
}


static void
granite_widgets_source_list_tree_on_editing_started (GraniteWidgetsSourceListTree* self,
                                                     GtkCellEditable* editable,
                                                     const gchar* path)
{
	GtkEntry* _tmp0_;
	GtkEntry* _tmp1_;
#line 2039 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 2039 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (editable != NULL);
#line 2039 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (path != NULL);
#line 2040 "../lib/Widgets/SourceList.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (editable, gtk_entry_get_type ()) ? ((GtkEntry*) editable) : NULL);
#line 2040 "../lib/Widgets/SourceList.vala"
	_g_object_unref0 (self->priv->editable_entry);
#line 2040 "../lib/Widgets/SourceList.vala"
	self->priv->editable_entry = _tmp0_;
#line 2041 "../lib/Widgets/SourceList.vala"
	_tmp1_ = self->priv->editable_entry;
#line 2041 "../lib/Widgets/SourceList.vala"
	if (_tmp1_ != NULL) {
#line 10587 "SourceList.c"
		GtkEntry* _tmp2_;
		GtkEntry* _tmp3_;
#line 2042 "../lib/Widgets/SourceList.vala"
		_tmp2_ = self->priv->editable_entry;
#line 2042 "../lib/Widgets/SourceList.vala"
		g_signal_connect_object ((GtkCellEditable*) _tmp2_, "editing-done", (GCallback) _granite_widgets_source_list_tree_on_editing_done_gtk_cell_editable_editing_done, self, 0);
#line 2043 "../lib/Widgets/SourceList.vala"
		_tmp3_ = self->priv->editable_entry;
#line 2043 "../lib/Widgets/SourceList.vala"
		g_object_set (_tmp3_, "editable", TRUE, NULL);
#line 10598 "SourceList.c"
	}
}


static void
granite_widgets_source_list_tree_on_editing_canceled (GraniteWidgetsSourceListTree* self)
{
	GtkEntry* _tmp0_;
	GtkCellRendererText* _tmp4_;
#line 2047 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 2048 "../lib/Widgets/SourceList.vala"
	_tmp0_ = self->priv->editable_entry;
#line 2048 "../lib/Widgets/SourceList.vala"
	if (_tmp0_ != NULL) {
#line 10614 "SourceList.c"
		GtkEntry* _tmp1_;
		GtkEntry* _tmp2_;
		guint _tmp3_;
#line 2049 "../lib/Widgets/SourceList.vala"
		_tmp1_ = self->priv->editable_entry;
#line 2049 "../lib/Widgets/SourceList.vala"
		g_object_set (_tmp1_, "editable", FALSE, NULL);
#line 2050 "../lib/Widgets/SourceList.vala"
		_tmp2_ = self->priv->editable_entry;
#line 2050 "../lib/Widgets/SourceList.vala"
		g_signal_parse_name ("editing-done", gtk_cell_editable_get_type (), &_tmp3_, NULL, FALSE);
#line 2050 "../lib/Widgets/SourceList.vala"
		g_signal_handlers_disconnect_matched ((GtkCellEditable*) _tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _granite_widgets_source_list_tree_on_editing_done_gtk_cell_editable_editing_done, self);
#line 10628 "SourceList.c"
	}
#line 2053 "../lib/Widgets/SourceList.vala"
	_tmp4_ = self->priv->text_cell;
#line 2053 "../lib/Widgets/SourceList.vala"
	g_object_set (_tmp4_, "editable", FALSE, NULL);
#line 2054 "../lib/Widgets/SourceList.vala"
	self->priv->edited = NULL;
#line 10636 "SourceList.c"
}


static void
granite_widgets_source_list_tree_on_editing_done (GraniteWidgetsSourceListTree* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GraniteWidgetsSourceListItem* _tmp2_;
#line 2057 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 2058 "../lib/Widgets/SourceList.vala"
	_tmp2_ = self->priv->edited;
#line 2058 "../lib/Widgets/SourceList.vala"
	if (_tmp2_ != NULL) {
#line 10652 "SourceList.c"
		GraniteWidgetsSourceListItem* _tmp3_;
		gboolean _tmp4_;
		gboolean _tmp5_;
#line 2058 "../lib/Widgets/SourceList.vala"
		_tmp3_ = self->priv->edited;
#line 2058 "../lib/Widgets/SourceList.vala"
		_tmp4_ = granite_widgets_source_list_item_get_editable (_tmp3_);
#line 2058 "../lib/Widgets/SourceList.vala"
		_tmp5_ = _tmp4_;
#line 2058 "../lib/Widgets/SourceList.vala"
		_tmp1_ = _tmp5_;
#line 10664 "SourceList.c"
	} else {
#line 2058 "../lib/Widgets/SourceList.vala"
		_tmp1_ = FALSE;
#line 10668 "SourceList.c"
	}
#line 2058 "../lib/Widgets/SourceList.vala"
	if (_tmp1_) {
#line 10672 "SourceList.c"
		GtkEntry* _tmp6_;
#line 2058 "../lib/Widgets/SourceList.vala"
		_tmp6_ = self->priv->editable_entry;
#line 2058 "../lib/Widgets/SourceList.vala"
		_tmp0_ = _tmp6_ != NULL;
#line 10678 "SourceList.c"
	} else {
#line 2058 "../lib/Widgets/SourceList.vala"
		_tmp0_ = FALSE;
#line 10682 "SourceList.c"
	}
#line 2058 "../lib/Widgets/SourceList.vala"
	if (_tmp0_) {
#line 10686 "SourceList.c"
		GraniteWidgetsSourceListItem* _tmp7_;
		GtkEntry* _tmp8_;
		const gchar* _tmp9_;
#line 2059 "../lib/Widgets/SourceList.vala"
		_tmp7_ = self->priv->edited;
#line 2059 "../lib/Widgets/SourceList.vala"
		_tmp8_ = self->priv->editable_entry;
#line 2059 "../lib/Widgets/SourceList.vala"
		_tmp9_ = gtk_entry_get_text (_tmp8_);
#line 2059 "../lib/Widgets/SourceList.vala"
		g_signal_emit (_tmp7_, granite_widgets_source_list_item_signals[GRANITE_WIDGETS_SOURCE_LIST_ITEM_EDITED_SIGNAL], 0, _tmp9_);
#line 10698 "SourceList.c"
	}
#line 2062 "../lib/Widgets/SourceList.vala"
	granite_widgets_source_list_tree_on_editing_canceled (self);
#line 10702 "SourceList.c"
}


static void
granite_widgets_source_list_tree_on_activatable_activated (GraniteWidgetsSourceListTree* self,
                                                           const gchar* item_path_str)
{
	GraniteWidgetsSourceListItem* item = NULL;
	GraniteWidgetsSourceListItem* _tmp0_;
	GraniteWidgetsSourceListItem* _tmp1_;
#line 2065 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 2065 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (item_path_str != NULL);
#line 2066 "../lib/Widgets/SourceList.vala"
	_tmp0_ = granite_widgets_source_list_tree_get_item_from_path_string (self, item_path_str);
#line 2066 "../lib/Widgets/SourceList.vala"
	item = _tmp0_;
#line 2067 "../lib/Widgets/SourceList.vala"
	_tmp1_ = item;
#line 2067 "../lib/Widgets/SourceList.vala"
	if (_tmp1_ != NULL) {
#line 10725 "SourceList.c"
		GraniteWidgetsSourceListItem* _tmp2_;
#line 2068 "../lib/Widgets/SourceList.vala"
		_tmp2_ = item;
#line 2068 "../lib/Widgets/SourceList.vala"
		g_signal_emit (_tmp2_, granite_widgets_source_list_item_signals[GRANITE_WIDGETS_SOURCE_LIST_ITEM_ACTION_ACTIVATED_SIGNAL], 0);
#line 10731 "SourceList.c"
	}
#line 2065 "../lib/Widgets/SourceList.vala"
	_g_object_unref0 (item);
#line 10735 "SourceList.c"
}


static GraniteWidgetsSourceListItem*
granite_widgets_source_list_tree_get_item_from_path_string (GraniteWidgetsSourceListTree* self,
                                                            const gchar* item_path_str)
{
	GraniteWidgetsSourceListItem* result = NULL;
	GtkTreePath* item_path = NULL;
	GtkTreePath* _tmp0_;
	GraniteWidgetsSourceListDataModel* _tmp1_;
	GraniteWidgetsSourceListItem* _tmp2_;
#line 2071 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 2071 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (item_path_str != NULL, NULL);
#line 2072 "../lib/Widgets/SourceList.vala"
	_tmp0_ = gtk_tree_path_new_from_string (item_path_str);
#line 2072 "../lib/Widgets/SourceList.vala"
	item_path = _tmp0_;
#line 2073 "../lib/Widgets/SourceList.vala"
	_tmp1_ = self->priv->_data_model;
#line 2073 "../lib/Widgets/SourceList.vala"
	_tmp2_ = granite_widgets_source_list_data_model_get_item_from_path (_tmp1_, item_path);
#line 2073 "../lib/Widgets/SourceList.vala"
	result = _tmp2_;
#line 2073 "../lib/Widgets/SourceList.vala"
	__vala_GtkTreePath_free0 (item_path);
#line 2073 "../lib/Widgets/SourceList.vala"
	return result;
#line 10766 "SourceList.c"
}


static gboolean
granite_widgets_source_list_tree_toggle_expansion (GraniteWidgetsSourceListTree* self,
                                                   GraniteWidgetsSourceListExpandableItem* item)
{
	gboolean result = FALSE;
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 2076 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2076 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (item != NULL, FALSE);
#line 2077 "../lib/Widgets/SourceList.vala"
	_tmp0_ = granite_widgets_source_list_expandable_item_get_collapsible (item);
#line 2077 "../lib/Widgets/SourceList.vala"
	_tmp1_ = _tmp0_;
#line 2077 "../lib/Widgets/SourceList.vala"
	if (_tmp1_) {
#line 10787 "SourceList.c"
		gboolean _tmp2_;
		gboolean _tmp3_;
#line 2078 "../lib/Widgets/SourceList.vala"
		_tmp2_ = granite_widgets_source_list_expandable_item_get_expanded (item);
#line 2078 "../lib/Widgets/SourceList.vala"
		_tmp3_ = _tmp2_;
#line 2078 "../lib/Widgets/SourceList.vala"
		granite_widgets_source_list_expandable_item_set_expanded (item, !_tmp3_);
#line 2079 "../lib/Widgets/SourceList.vala"
		result = TRUE;
#line 2079 "../lib/Widgets/SourceList.vala"
		return result;
#line 10800 "SourceList.c"
	}
#line 2081 "../lib/Widgets/SourceList.vala"
	result = FALSE;
#line 2081 "../lib/Widgets/SourceList.vala"
	return result;
#line 10806 "SourceList.c"
}


/**
         * Updates the tree to reflect the ''expanded'' property of expandable_item.
         */
static void
granite_widgets_source_list_tree_update_expansion (GraniteWidgetsSourceListTree* self,
                                                   GraniteWidgetsSourceListExpandableItem* expandable_item)
{
	GtkTreePath* path = NULL;
	GraniteWidgetsSourceListDataModel* _tmp0_;
	GtkTreePath* _tmp1_;
	GtkTreePath* _tmp2_;
#line 2087 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 2087 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (expandable_item != NULL);
#line 2088 "../lib/Widgets/SourceList.vala"
	_tmp0_ = self->priv->_data_model;
#line 2088 "../lib/Widgets/SourceList.vala"
	_tmp1_ = granite_widgets_source_list_data_model_get_item_path (_tmp0_, (GraniteWidgetsSourceListItem*) expandable_item);
#line 2088 "../lib/Widgets/SourceList.vala"
	path = _tmp1_;
#line 2090 "../lib/Widgets/SourceList.vala"
	_tmp2_ = path;
#line 2090 "../lib/Widgets/SourceList.vala"
	if (_tmp2_ != NULL) {
#line 10835 "SourceList.c"
		GtkTreePath* _tmp3_;
		gboolean _tmp4_;
		gboolean _tmp5_;
#line 2094 "../lib/Widgets/SourceList.vala"
		_tmp3_ = path;
#line 2094 "../lib/Widgets/SourceList.vala"
		granite_widgets_source_list_tree_add_spacer_cell_for_level (self, gtk_tree_path_get_depth (_tmp3_) + 1, TRUE);
#line 2096 "../lib/Widgets/SourceList.vala"
		_tmp4_ = granite_widgets_source_list_expandable_item_get_expanded (expandable_item);
#line 2096 "../lib/Widgets/SourceList.vala"
		_tmp5_ = _tmp4_;
#line 2096 "../lib/Widgets/SourceList.vala"
		if (_tmp5_) {
#line 10849 "SourceList.c"
			GtkTreePath* _tmp6_;
			gboolean _tmp7_ = FALSE;
			GraniteWidgetsSourceListItem* _tmp8_;
#line 2097 "../lib/Widgets/SourceList.vala"
			_tmp6_ = path;
#line 2097 "../lib/Widgets/SourceList.vala"
			gtk_tree_view_expand_row ((GtkTreeView*) self, _tmp6_, FALSE);
#line 2105 "../lib/Widgets/SourceList.vala"
			_tmp8_ = self->priv->selected;
#line 2105 "../lib/Widgets/SourceList.vala"
			if (_tmp8_ != NULL) {
#line 10861 "SourceList.c"
				GraniteWidgetsSourceListItem* _tmp9_;
				GraniteWidgetsSourceListExpandableItem* _tmp10_;
				GraniteWidgetsSourceListExpandableItem* _tmp11_;
#line 2105 "../lib/Widgets/SourceList.vala"
				_tmp9_ = self->priv->selected;
#line 2105 "../lib/Widgets/SourceList.vala"
				_tmp10_ = granite_widgets_source_list_item_get_parent (_tmp9_);
#line 2105 "../lib/Widgets/SourceList.vala"
				_tmp11_ = _tmp10_;
#line 2105 "../lib/Widgets/SourceList.vala"
				_tmp7_ = _tmp11_ == expandable_item;
#line 10873 "SourceList.c"
			} else {
#line 2105 "../lib/Widgets/SourceList.vala"
				_tmp7_ = FALSE;
#line 10877 "SourceList.c"
			}
#line 2105 "../lib/Widgets/SourceList.vala"
			if (_tmp7_) {
#line 10881 "SourceList.c"
				GraniteWidgetsSourceListItem* _tmp12_;
#line 2106 "../lib/Widgets/SourceList.vala"
				_tmp12_ = self->priv->selected;
#line 2106 "../lib/Widgets/SourceList.vala"
				granite_widgets_source_list_tree_set_selected (self, _tmp12_, TRUE);
#line 10887 "SourceList.c"
			}
			{
				GeeIterator* _child_item_it = NULL;
				GeeCollection* _tmp13_;
				GeeCollection* _tmp14_;
				GeeCollection* _tmp15_;
				GeeIterator* _tmp16_;
				GeeIterator* _tmp17_;
#line 2111 "../lib/Widgets/SourceList.vala"
				_tmp13_ = granite_widgets_source_list_expandable_item_get_children (expandable_item);
#line 2111 "../lib/Widgets/SourceList.vala"
				_tmp14_ = _tmp13_;
#line 2111 "../lib/Widgets/SourceList.vala"
				_tmp15_ = _tmp14_;
#line 2111 "../lib/Widgets/SourceList.vala"
				_tmp16_ = gee_iterable_iterator ((GeeIterable*) _tmp15_);
#line 2111 "../lib/Widgets/SourceList.vala"
				_tmp17_ = _tmp16_;
#line 2111 "../lib/Widgets/SourceList.vala"
				_g_object_unref0 (_tmp15_);
#line 2111 "../lib/Widgets/SourceList.vala"
				_child_item_it = _tmp17_;
#line 2111 "../lib/Widgets/SourceList.vala"
				while (TRUE) {
#line 10912 "SourceList.c"
					GeeIterator* _tmp18_;
					GraniteWidgetsSourceListItem* child_item = NULL;
					GeeIterator* _tmp19_;
					gpointer _tmp20_;
					GraniteWidgetsSourceListExpandableItem* child_expandable_item = NULL;
					GraniteWidgetsSourceListItem* _tmp21_;
					GraniteWidgetsSourceListExpandableItem* _tmp22_;
					GraniteWidgetsSourceListExpandableItem* _tmp23_;
#line 2111 "../lib/Widgets/SourceList.vala"
					_tmp18_ = _child_item_it;
#line 2111 "../lib/Widgets/SourceList.vala"
					if (!gee_iterator_next (_tmp18_)) {
#line 2111 "../lib/Widgets/SourceList.vala"
						break;
#line 10927 "SourceList.c"
					}
#line 2111 "../lib/Widgets/SourceList.vala"
					_tmp19_ = _child_item_it;
#line 2111 "../lib/Widgets/SourceList.vala"
					_tmp20_ = gee_iterator_get (_tmp19_);
#line 2111 "../lib/Widgets/SourceList.vala"
					child_item = (GraniteWidgetsSourceListItem*) _tmp20_;
#line 2112 "../lib/Widgets/SourceList.vala"
					_tmp21_ = child_item;
#line 2112 "../lib/Widgets/SourceList.vala"
					_tmp22_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp21_, GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM) ? ((GraniteWidgetsSourceListExpandableItem*) _tmp21_) : NULL);
#line 2112 "../lib/Widgets/SourceList.vala"
					child_expandable_item = _tmp22_;
#line 2113 "../lib/Widgets/SourceList.vala"
					_tmp23_ = child_expandable_item;
#line 2113 "../lib/Widgets/SourceList.vala"
					if (_tmp23_ != NULL) {
#line 10945 "SourceList.c"
						GraniteWidgetsSourceListExpandableItem* _tmp24_;
#line 2114 "../lib/Widgets/SourceList.vala"
						_tmp24_ = child_expandable_item;
#line 2114 "../lib/Widgets/SourceList.vala"
						granite_widgets_source_list_tree_update_expansion (self, _tmp24_);
#line 10951 "SourceList.c"
					}
#line 2111 "../lib/Widgets/SourceList.vala"
					_g_object_unref0 (child_expandable_item);
#line 2111 "../lib/Widgets/SourceList.vala"
					_g_object_unref0 (child_item);
#line 10957 "SourceList.c"
				}
#line 2111 "../lib/Widgets/SourceList.vala"
				_g_object_unref0 (_child_item_it);
#line 10961 "SourceList.c"
			}
		} else {
			GtkTreePath* _tmp25_;
#line 2117 "../lib/Widgets/SourceList.vala"
			_tmp25_ = path;
#line 2117 "../lib/Widgets/SourceList.vala"
			gtk_tree_view_collapse_row ((GtkTreeView*) self, _tmp25_);
#line 10969 "SourceList.c"
		}
	}
#line 2087 "../lib/Widgets/SourceList.vala"
	__vala_GtkTreePath_free0 (path);
#line 10974 "SourceList.c"
}


static void
granite_widgets_source_list_tree_real_row_expanded (GtkTreeView* base,
                                                    GtkTreeIter* iter,
                                                    GtkTreePath* path)
{
	GraniteWidgetsSourceListTree * self;
	GraniteWidgetsSourceListExpandableItem* item = NULL;
	GraniteWidgetsSourceListDataModel* _tmp0_;
	GtkTreeIter _tmp1_;
	GraniteWidgetsSourceListItem* _tmp2_;
	GraniteWidgetsSourceListExpandableItem* _tmp3_;
#line 2122 "../lib/Widgets/SourceList.vala"
	self = (GraniteWidgetsSourceListTree*) base;
#line 2122 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (iter != NULL);
#line 2122 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (path != NULL);
#line 2123 "../lib/Widgets/SourceList.vala"
	_tmp0_ = self->priv->_data_model;
#line 2123 "../lib/Widgets/SourceList.vala"
	_tmp1_ = *iter;
#line 2123 "../lib/Widgets/SourceList.vala"
	_tmp2_ = granite_widgets_source_list_data_model_get_item (_tmp0_, &_tmp1_);
#line 2123 "../lib/Widgets/SourceList.vala"
	_tmp3_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM) ? ((GraniteWidgetsSourceListExpandableItem*) _tmp2_) : NULL;
#line 2123 "../lib/Widgets/SourceList.vala"
	if (_tmp3_ == NULL) {
#line 2123 "../lib/Widgets/SourceList.vala"
		_g_object_unref0 (_tmp2_);
#line 11007 "SourceList.c"
	}
#line 2123 "../lib/Widgets/SourceList.vala"
	item = _tmp3_;
#line 2124 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (item != NULL);
#line 2126 "../lib/Widgets/SourceList.vala"
	granite_widgets_source_list_tree_disable_item_property_monitor (self);
#line 2127 "../lib/Widgets/SourceList.vala"
	granite_widgets_source_list_expandable_item_set_expanded (item, TRUE);
#line 2128 "../lib/Widgets/SourceList.vala"
	granite_widgets_source_list_tree_enable_item_property_monitor (self);
#line 2122 "../lib/Widgets/SourceList.vala"
	_g_object_unref0 (item);
#line 11021 "SourceList.c"
}


static void
granite_widgets_source_list_tree_real_row_collapsed (GtkTreeView* base,
                                                     GtkTreeIter* iter,
                                                     GtkTreePath* path)
{
	GraniteWidgetsSourceListTree * self;
	GraniteWidgetsSourceListExpandableItem* item = NULL;
	GraniteWidgetsSourceListDataModel* _tmp0_;
	GtkTreeIter _tmp1_;
	GraniteWidgetsSourceListItem* _tmp2_;
	GraniteWidgetsSourceListExpandableItem* _tmp3_;
#line 2131 "../lib/Widgets/SourceList.vala"
	self = (GraniteWidgetsSourceListTree*) base;
#line 2131 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (iter != NULL);
#line 2131 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (path != NULL);
#line 2132 "../lib/Widgets/SourceList.vala"
	_tmp0_ = self->priv->_data_model;
#line 2132 "../lib/Widgets/SourceList.vala"
	_tmp1_ = *iter;
#line 2132 "../lib/Widgets/SourceList.vala"
	_tmp2_ = granite_widgets_source_list_data_model_get_item (_tmp0_, &_tmp1_);
#line 2132 "../lib/Widgets/SourceList.vala"
	_tmp3_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM) ? ((GraniteWidgetsSourceListExpandableItem*) _tmp2_) : NULL;
#line 2132 "../lib/Widgets/SourceList.vala"
	if (_tmp3_ == NULL) {
#line 2132 "../lib/Widgets/SourceList.vala"
		_g_object_unref0 (_tmp2_);
#line 11054 "SourceList.c"
	}
#line 2132 "../lib/Widgets/SourceList.vala"
	item = _tmp3_;
#line 2133 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (item != NULL);
#line 2135 "../lib/Widgets/SourceList.vala"
	granite_widgets_source_list_tree_disable_item_property_monitor (self);
#line 2136 "../lib/Widgets/SourceList.vala"
	granite_widgets_source_list_expandable_item_set_expanded (item, FALSE);
#line 2137 "../lib/Widgets/SourceList.vala"
	granite_widgets_source_list_tree_enable_item_property_monitor (self);
#line 2131 "../lib/Widgets/SourceList.vala"
	_g_object_unref0 (item);
#line 11068 "SourceList.c"
}


static void
granite_widgets_source_list_tree_real_row_activated (GtkTreeView* base,
                                                     GtkTreePath* path,
                                                     GtkTreeViewColumn* column)
{
	GraniteWidgetsSourceListTree * self;
	GtkTreeViewColumn* _tmp0_;
#line 2140 "../lib/Widgets/SourceList.vala"
	self = (GraniteWidgetsSourceListTree*) base;
#line 2140 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (path != NULL);
#line 2140 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (column != NULL);
#line 2141 "../lib/Widgets/SourceList.vala"
	_tmp0_ = gtk_tree_view_get_column ((GtkTreeView*) self, (gint) GRANITE_WIDGETS_SOURCE_LIST_TREE_COLUMN_ITEM);
#line 2141 "../lib/Widgets/SourceList.vala"
	if (column == _tmp0_) {
#line 11089 "SourceList.c"
		GraniteWidgetsSourceListItem* item = NULL;
		GraniteWidgetsSourceListDataModel* _tmp1_;
		GraniteWidgetsSourceListItem* _tmp2_;
		GraniteWidgetsSourceListItem* _tmp3_;
#line 2142 "../lib/Widgets/SourceList.vala"
		_tmp1_ = self->priv->_data_model;
#line 2142 "../lib/Widgets/SourceList.vala"
		_tmp2_ = granite_widgets_source_list_data_model_get_item_from_path (_tmp1_, path);
#line 2142 "../lib/Widgets/SourceList.vala"
		item = _tmp2_;
#line 2143 "../lib/Widgets/SourceList.vala"
		_tmp3_ = item;
#line 2143 "../lib/Widgets/SourceList.vala"
		if (_tmp3_ != NULL) {
#line 11104 "SourceList.c"
			GraniteWidgetsSourceListItem* _tmp4_;
#line 2144 "../lib/Widgets/SourceList.vala"
			_tmp4_ = item;
#line 2144 "../lib/Widgets/SourceList.vala"
			g_signal_emit (_tmp4_, granite_widgets_source_list_item_signals[GRANITE_WIDGETS_SOURCE_LIST_ITEM_ACTIVATED_SIGNAL], 0);
#line 11110 "SourceList.c"
		}
#line 2141 "../lib/Widgets/SourceList.vala"
		_g_object_unref0 (item);
#line 11114 "SourceList.c"
	}
}


static gboolean
granite_widgets_source_list_tree_real_key_release_event (GtkWidget* base,
                                                         GdkEventKey* event)
{
	GraniteWidgetsSourceListTree * self;
	gboolean result = FALSE;
	GraniteWidgetsSourceListItem* _tmp0_;
	GraniteWidgetsSourceListItem* _tmp1_;
#line 2148 "../lib/Widgets/SourceList.vala"
	self = (GraniteWidgetsSourceListTree*) base;
#line 2148 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 2149 "../lib/Widgets/SourceList.vala"
	_tmp0_ = granite_widgets_source_list_tree_get_selected_item (self);
#line 2149 "../lib/Widgets/SourceList.vala"
	_tmp1_ = _tmp0_;
#line 2149 "../lib/Widgets/SourceList.vala"
	if (_tmp1_ != NULL) {
#line 11137 "SourceList.c"
		guint _tmp2_;
#line 2150 "../lib/Widgets/SourceList.vala"
		_tmp2_ = event->keyval;
#line 2150 "../lib/Widgets/SourceList.vala"
		switch (_tmp2_) {
#line 2150 "../lib/Widgets/SourceList.vala"
			case GDK_KEY_F2:
#line 11145 "SourceList.c"
			{
				GdkModifierType modifiers = 0U;
				gboolean _tmp3_ = FALSE;
				GdkModifierType _tmp4_;
				GdkModifierType _tmp5_;
#line 2152 "../lib/Widgets/SourceList.vala"
				modifiers = gtk_accelerator_get_default_mod_mask ();
#line 2154 "../lib/Widgets/SourceList.vala"
				_tmp4_ = event->state;
#line 2154 "../lib/Widgets/SourceList.vala"
				_tmp5_ = modifiers;
#line 2154 "../lib/Widgets/SourceList.vala"
				if ((_tmp4_ & _tmp5_) == 0) {
#line 11159 "SourceList.c"
					GraniteWidgetsSourceListItem* _tmp6_;
					GraniteWidgetsSourceListItem* _tmp7_;
					gboolean _tmp8_;
					gboolean _tmp9_;
#line 2154 "../lib/Widgets/SourceList.vala"
					_tmp6_ = granite_widgets_source_list_tree_get_selected_item (self);
#line 2154 "../lib/Widgets/SourceList.vala"
					_tmp7_ = _tmp6_;
#line 2154 "../lib/Widgets/SourceList.vala"
					_tmp8_ = granite_widgets_source_list_item_get_editable (_tmp7_);
#line 2154 "../lib/Widgets/SourceList.vala"
					_tmp9_ = _tmp8_;
#line 2154 "../lib/Widgets/SourceList.vala"
					_tmp3_ = _tmp9_;
#line 11174 "SourceList.c"
				} else {
#line 2154 "../lib/Widgets/SourceList.vala"
					_tmp3_ = FALSE;
#line 11178 "SourceList.c"
				}
#line 2154 "../lib/Widgets/SourceList.vala"
				if (_tmp3_) {
#line 11182 "SourceList.c"
					GraniteWidgetsSourceListItem* _tmp10_;
					GraniteWidgetsSourceListItem* _tmp11_;
#line 2155 "../lib/Widgets/SourceList.vala"
					_tmp10_ = granite_widgets_source_list_tree_get_selected_item (self);
#line 2155 "../lib/Widgets/SourceList.vala"
					_tmp11_ = _tmp10_;
#line 2155 "../lib/Widgets/SourceList.vala"
					granite_widgets_source_list_tree_start_editing_item (self, _tmp11_);
#line 11191 "SourceList.c"
				}
#line 2156 "../lib/Widgets/SourceList.vala"
				break;
#line 11195 "SourceList.c"
			}
			default:
#line 2150 "../lib/Widgets/SourceList.vala"
			break;
#line 11200 "SourceList.c"
		}
	}
#line 2160 "../lib/Widgets/SourceList.vala"
	result = GTK_WIDGET_CLASS (granite_widgets_source_list_tree_parent_class)->key_release_event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_tree_view_get_type (), GtkTreeView), event);
#line 2160 "../lib/Widgets/SourceList.vala"
	return result;
#line 11207 "SourceList.c"
}


static gboolean
granite_widgets_source_list_tree_real_button_release_event (GtkWidget* base,
                                                            GdkEventButton* event)
{
	GraniteWidgetsSourceListTree * self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
#line 2163 "../lib/Widgets/SourceList.vala"
	self = (GraniteWidgetsSourceListTree*) base;
#line 2163 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 2164 "../lib/Widgets/SourceList.vala"
	_tmp1_ = self->priv->unselectable_item_clicked;
#line 2164 "../lib/Widgets/SourceList.vala"
	if (_tmp1_) {
#line 11227 "SourceList.c"
		GdkWindow* _tmp2_;
		GdkWindow* _tmp3_;
#line 2164 "../lib/Widgets/SourceList.vala"
		_tmp2_ = event->window;
#line 2164 "../lib/Widgets/SourceList.vala"
		_tmp3_ = gtk_tree_view_get_bin_window ((GtkTreeView*) self);
#line 2164 "../lib/Widgets/SourceList.vala"
		_tmp0_ = _tmp2_ == _tmp3_;
#line 11236 "SourceList.c"
	} else {
#line 2164 "../lib/Widgets/SourceList.vala"
		_tmp0_ = FALSE;
#line 11240 "SourceList.c"
	}
#line 2164 "../lib/Widgets/SourceList.vala"
	if (_tmp0_) {
#line 11244 "SourceList.c"
		GtkTreePath* path = NULL;
		GtkTreeViewColumn* column = NULL;
		gint x = 0;
		gdouble _tmp4_;
		gint y = 0;
		gdouble _tmp5_;
		gint cell_x = 0;
		gint cell_y = 0;
		gint _tmp6_;
		gint _tmp7_;
		GtkTreePath* _tmp8_ = NULL;
		GtkTreeViewColumn* _tmp9_ = NULL;
		gint _tmp10_ = 0;
		gint _tmp11_ = 0;
		gboolean _tmp12_;
		GtkTreeViewColumn* _tmp13_;
#line 2165 "../lib/Widgets/SourceList.vala"
		self->priv->unselectable_item_clicked = FALSE;
#line 2169 "../lib/Widgets/SourceList.vala"
		_tmp4_ = event->x;
#line 2169 "../lib/Widgets/SourceList.vala"
		x = (gint) _tmp4_;
#line 2169 "../lib/Widgets/SourceList.vala"
		_tmp5_ = event->y;
#line 2169 "../lib/Widgets/SourceList.vala"
		y = (gint) _tmp5_;
#line 2171 "../lib/Widgets/SourceList.vala"
		_tmp6_ = x;
#line 2171 "../lib/Widgets/SourceList.vala"
		_tmp7_ = y;
#line 2171 "../lib/Widgets/SourceList.vala"
		_tmp12_ = gtk_tree_view_get_path_at_pos ((GtkTreeView*) self, _tmp6_, _tmp7_, &_tmp8_, &_tmp9_, &_tmp10_, &_tmp11_);
#line 2171 "../lib/Widgets/SourceList.vala"
		__vala_GtkTreePath_free0 (path);
#line 2171 "../lib/Widgets/SourceList.vala"
		path = _tmp8_;
#line 2171 "../lib/Widgets/SourceList.vala"
		_g_object_unref0 (column);
#line 2171 "../lib/Widgets/SourceList.vala"
		_tmp13_ = _g_object_ref0 (_tmp9_);
#line 2171 "../lib/Widgets/SourceList.vala"
		column = _tmp13_;
#line 2171 "../lib/Widgets/SourceList.vala"
		cell_x = _tmp10_;
#line 2171 "../lib/Widgets/SourceList.vala"
		cell_y = _tmp11_;
#line 2171 "../lib/Widgets/SourceList.vala"
		if (_tmp12_) {
#line 11293 "SourceList.c"
			GraniteWidgetsSourceListExpandableItem* item = NULL;
			GraniteWidgetsSourceListDataModel* _tmp14_;
			GtkTreePath* _tmp15_;
			GraniteWidgetsSourceListItem* _tmp16_;
			GraniteWidgetsSourceListExpandableItem* _tmp17_;
			GraniteWidgetsSourceListExpandableItem* _tmp18_;
#line 2172 "../lib/Widgets/SourceList.vala"
			_tmp14_ = self->priv->_data_model;
#line 2172 "../lib/Widgets/SourceList.vala"
			_tmp15_ = path;
#line 2172 "../lib/Widgets/SourceList.vala"
			_tmp16_ = granite_widgets_source_list_data_model_get_item_from_path (_tmp14_, _tmp15_);
#line 2172 "../lib/Widgets/SourceList.vala"
			_tmp17_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp16_, GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM) ? ((GraniteWidgetsSourceListExpandableItem*) _tmp16_) : NULL;
#line 2172 "../lib/Widgets/SourceList.vala"
			if (_tmp17_ == NULL) {
#line 2172 "../lib/Widgets/SourceList.vala"
				_g_object_unref0 (_tmp16_);
#line 11312 "SourceList.c"
			}
#line 2172 "../lib/Widgets/SourceList.vala"
			item = _tmp17_;
#line 2174 "../lib/Widgets/SourceList.vala"
			_tmp18_ = item;
#line 2174 "../lib/Widgets/SourceList.vala"
			if (_tmp18_ != NULL) {
#line 11320 "SourceList.c"
				gboolean _tmp19_ = FALSE;
				GraniteWidgetsSourceListExpandableItem* _tmp20_;
				gboolean _tmp21_;
				gboolean _tmp22_;
#line 2175 "../lib/Widgets/SourceList.vala"
				_tmp20_ = item;
#line 2175 "../lib/Widgets/SourceList.vala"
				_tmp21_ = granite_widgets_source_list_item_get_selectable ((GraniteWidgetsSourceListItem*) _tmp20_);
#line 2175 "../lib/Widgets/SourceList.vala"
				_tmp22_ = _tmp21_;
#line 2175 "../lib/Widgets/SourceList.vala"
				if (!_tmp22_) {
#line 2175 "../lib/Widgets/SourceList.vala"
					_tmp19_ = TRUE;
#line 11335 "SourceList.c"
				} else {
					GraniteWidgetsSourceListDataModel* _tmp23_;
					GraniteWidgetsSourceListExpandableItem* _tmp24_;
					GtkTreePath* _tmp25_;
#line 2175 "../lib/Widgets/SourceList.vala"
					_tmp23_ = self->priv->_data_model;
#line 2175 "../lib/Widgets/SourceList.vala"
					_tmp24_ = item;
#line 2175 "../lib/Widgets/SourceList.vala"
					_tmp25_ = path;
#line 2175 "../lib/Widgets/SourceList.vala"
					_tmp19_ = granite_widgets_source_list_data_model_is_category (_tmp23_, (GraniteWidgetsSourceListItem*) _tmp24_, NULL, _tmp25_);
#line 11348 "SourceList.c"
				}
#line 2175 "../lib/Widgets/SourceList.vala"
				if (_tmp19_) {
#line 11352 "SourceList.c"
					GraniteWidgetsSourceListExpandableItem* _tmp26_;
#line 2176 "../lib/Widgets/SourceList.vala"
					_tmp26_ = item;
#line 2176 "../lib/Widgets/SourceList.vala"
					granite_widgets_source_list_tree_toggle_expansion (self, _tmp26_);
#line 11358 "SourceList.c"
				}
			}
#line 2171 "../lib/Widgets/SourceList.vala"
			_g_object_unref0 (item);
#line 11363 "SourceList.c"
		}
#line 2164 "../lib/Widgets/SourceList.vala"
		_g_object_unref0 (column);
#line 2164 "../lib/Widgets/SourceList.vala"
		__vala_GtkTreePath_free0 (path);
#line 11369 "SourceList.c"
	}
#line 2181 "../lib/Widgets/SourceList.vala"
	result = GTK_WIDGET_CLASS (granite_widgets_source_list_tree_parent_class)->button_release_event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_tree_view_get_type (), GtkTreeView), event);
#line 2181 "../lib/Widgets/SourceList.vala"
	return result;
#line 11375 "SourceList.c"
}


static gboolean
granite_widgets_source_list_tree_real_button_press_event (GtkWidget* base,
                                                          GdkEventButton* event)
{
	GraniteWidgetsSourceListTree * self;
	gboolean result = FALSE;
	GdkWindow* _tmp0_;
	GdkWindow* _tmp1_;
	GtkTreePath* path = NULL;
	GtkTreeViewColumn* column = NULL;
	gint x = 0;
	gdouble _tmp2_;
	gint y = 0;
	gdouble _tmp3_;
	gint cell_x = 0;
	gint cell_y = 0;
	gint _tmp4_;
	gint _tmp5_;
	GtkTreePath* _tmp6_ = NULL;
	GtkTreeViewColumn* _tmp7_ = NULL;
	gint _tmp8_ = 0;
	gint _tmp9_ = 0;
	gboolean _tmp10_;
	GtkTreeViewColumn* _tmp11_;
#line 2184 "../lib/Widgets/SourceList.vala"
	self = (GraniteWidgetsSourceListTree*) base;
#line 2184 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 2185 "../lib/Widgets/SourceList.vala"
	_tmp0_ = event->window;
#line 2185 "../lib/Widgets/SourceList.vala"
	_tmp1_ = gtk_tree_view_get_bin_window ((GtkTreeView*) self);
#line 2185 "../lib/Widgets/SourceList.vala"
	if (_tmp0_ != _tmp1_) {
#line 2186 "../lib/Widgets/SourceList.vala"
		result = GTK_WIDGET_CLASS (granite_widgets_source_list_tree_parent_class)->button_press_event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_tree_view_get_type (), GtkTreeView), event);
#line 2186 "../lib/Widgets/SourceList.vala"
		return result;
#line 11417 "SourceList.c"
	}
#line 2190 "../lib/Widgets/SourceList.vala"
	_tmp2_ = event->x;
#line 2190 "../lib/Widgets/SourceList.vala"
	x = (gint) _tmp2_;
#line 2190 "../lib/Widgets/SourceList.vala"
	_tmp3_ = event->y;
#line 2190 "../lib/Widgets/SourceList.vala"
	y = (gint) _tmp3_;
#line 2192 "../lib/Widgets/SourceList.vala"
	_tmp4_ = x;
#line 2192 "../lib/Widgets/SourceList.vala"
	_tmp5_ = y;
#line 2192 "../lib/Widgets/SourceList.vala"
	_tmp10_ = gtk_tree_view_get_path_at_pos ((GtkTreeView*) self, _tmp4_, _tmp5_, &_tmp6_, &_tmp7_, &_tmp8_, &_tmp9_);
#line 2192 "../lib/Widgets/SourceList.vala"
	__vala_GtkTreePath_free0 (path);
#line 2192 "../lib/Widgets/SourceList.vala"
	path = _tmp6_;
#line 2192 "../lib/Widgets/SourceList.vala"
	_g_object_unref0 (column);
#line 2192 "../lib/Widgets/SourceList.vala"
	_tmp11_ = _g_object_ref0 (_tmp7_);
#line 2192 "../lib/Widgets/SourceList.vala"
	column = _tmp11_;
#line 2192 "../lib/Widgets/SourceList.vala"
	cell_x = _tmp8_;
#line 2192 "../lib/Widgets/SourceList.vala"
	cell_y = _tmp9_;
#line 2192 "../lib/Widgets/SourceList.vala"
	if (_tmp10_) {
#line 11449 "SourceList.c"
		GraniteWidgetsSourceListItem* item = NULL;
		GraniteWidgetsSourceListDataModel* _tmp12_;
		GtkTreePath* _tmp13_;
		GraniteWidgetsSourceListItem* _tmp14_;
		GdkRectangle start_cell_area = {0};
		GtkTreePath* _tmp15_;
		GtkTreeViewColumn* _tmp16_;
		GdkRectangle _tmp17_ = {0};
		gint _tmp18_;
		GdkRectangle _tmp19_;
		gint _tmp20_;
		gboolean _tmp21_ = FALSE;
		GraniteWidgetsSourceListItem* _tmp22_;
#line 2193 "../lib/Widgets/SourceList.vala"
		_tmp12_ = self->priv->_data_model;
#line 2193 "../lib/Widgets/SourceList.vala"
		_tmp13_ = path;
#line 2193 "../lib/Widgets/SourceList.vala"
		_tmp14_ = granite_widgets_source_list_data_model_get_item_from_path (_tmp12_, _tmp13_);
#line 2193 "../lib/Widgets/SourceList.vala"
		item = _tmp14_;
#line 2197 "../lib/Widgets/SourceList.vala"
		_tmp15_ = path;
#line 2197 "../lib/Widgets/SourceList.vala"
		_tmp16_ = gtk_tree_view_get_column ((GtkTreeView*) self, 0);
#line 2197 "../lib/Widgets/SourceList.vala"
		gtk_tree_view_get_cell_area ((GtkTreeView*) self, _tmp15_, _tmp16_, &_tmp17_);
#line 2197 "../lib/Widgets/SourceList.vala"
		start_cell_area = _tmp17_;
#line 2198 "../lib/Widgets/SourceList.vala"
		_tmp18_ = cell_x;
#line 2198 "../lib/Widgets/SourceList.vala"
		_tmp19_ = start_cell_area;
#line 2198 "../lib/Widgets/SourceList.vala"
		_tmp20_ = _tmp19_.x;
#line 2198 "../lib/Widgets/SourceList.vala"
		cell_x = _tmp18_ - _tmp20_;
#line 2200 "../lib/Widgets/SourceList.vala"
		_tmp22_ = item;
#line 2200 "../lib/Widgets/SourceList.vala"
		if (_tmp22_ != NULL) {
#line 11491 "SourceList.c"
			GtkTreeViewColumn* _tmp23_;
			GtkTreeViewColumn* _tmp24_;
#line 2200 "../lib/Widgets/SourceList.vala"
			_tmp23_ = column;
#line 2200 "../lib/Widgets/SourceList.vala"
			_tmp24_ = gtk_tree_view_get_column ((GtkTreeView*) self, (gint) GRANITE_WIDGETS_SOURCE_LIST_TREE_COLUMN_ITEM);
#line 2200 "../lib/Widgets/SourceList.vala"
			_tmp21_ = _tmp23_ == _tmp24_;
#line 11500 "SourceList.c"
		} else {
#line 2200 "../lib/Widgets/SourceList.vala"
			_tmp21_ = FALSE;
#line 11504 "SourceList.c"
		}
#line 2200 "../lib/Widgets/SourceList.vala"
		if (_tmp21_) {
#line 11508 "SourceList.c"
			guint _tmp25_;
#line 2202 "../lib/Widgets/SourceList.vala"
			granite_widgets_source_list_tree_stop_editing (self);
#line 2204 "../lib/Widgets/SourceList.vala"
			_tmp25_ = event->button;
#line 2204 "../lib/Widgets/SourceList.vala"
			if (_tmp25_ == ((guint) GDK_BUTTON_SECONDARY)) {
#line 11516 "SourceList.c"
				GraniteWidgetsSourceListItem* _tmp26_;
#line 2205 "../lib/Widgets/SourceList.vala"
				_tmp26_ = item;
#line 2205 "../lib/Widgets/SourceList.vala"
				granite_widgets_source_list_tree_popup_context_menu (self, _tmp26_, event);
#line 2206 "../lib/Widgets/SourceList.vala"
				result = TRUE;
#line 2206 "../lib/Widgets/SourceList.vala"
				_g_object_unref0 (item);
#line 2206 "../lib/Widgets/SourceList.vala"
				_g_object_unref0 (column);
#line 2206 "../lib/Widgets/SourceList.vala"
				__vala_GtkTreePath_free0 (path);
#line 2206 "../lib/Widgets/SourceList.vala"
				return result;
#line 11532 "SourceList.c"
			} else {
				guint _tmp27_;
#line 2207 "../lib/Widgets/SourceList.vala"
				_tmp27_ = event->button;
#line 2207 "../lib/Widgets/SourceList.vala"
				if (_tmp27_ == ((guint) GDK_BUTTON_PRIMARY)) {
#line 11539 "SourceList.c"
					gboolean is_expandable = FALSE;
					GraniteWidgetsSourceListItem* _tmp28_;
					gboolean _tmp29_ = FALSE;
					gboolean _tmp30_;
					gboolean is_category = FALSE;
					GdkEventType _tmp34_;
#line 2209 "../lib/Widgets/SourceList.vala"
					_tmp28_ = item;
#line 2209 "../lib/Widgets/SourceList.vala"
					is_expandable = G_TYPE_CHECK_INSTANCE_TYPE (_tmp28_, GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM);
#line 2210 "../lib/Widgets/SourceList.vala"
					_tmp30_ = is_expandable;
#line 2210 "../lib/Widgets/SourceList.vala"
					if (_tmp30_) {
#line 11554 "SourceList.c"
						GraniteWidgetsSourceListDataModel* _tmp31_;
						GraniteWidgetsSourceListItem* _tmp32_;
						GtkTreePath* _tmp33_;
#line 2210 "../lib/Widgets/SourceList.vala"
						_tmp31_ = self->priv->_data_model;
#line 2210 "../lib/Widgets/SourceList.vala"
						_tmp32_ = item;
#line 2210 "../lib/Widgets/SourceList.vala"
						_tmp33_ = path;
#line 2210 "../lib/Widgets/SourceList.vala"
						_tmp29_ = granite_widgets_source_list_data_model_is_category (_tmp31_, _tmp32_, NULL, _tmp33_);
#line 11566 "SourceList.c"
					} else {
#line 2210 "../lib/Widgets/SourceList.vala"
						_tmp29_ = FALSE;
#line 11570 "SourceList.c"
					}
#line 2210 "../lib/Widgets/SourceList.vala"
					is_category = _tmp29_;
#line 2212 "../lib/Widgets/SourceList.vala"
					_tmp34_ = event->type;
#line 2212 "../lib/Widgets/SourceList.vala"
					if (_tmp34_ == GDK_BUTTON_PRESS) {
#line 11578 "SourceList.c"
						gboolean _tmp35_;
#line 2213 "../lib/Widgets/SourceList.vala"
						_tmp35_ = is_expandable;
#line 2213 "../lib/Widgets/SourceList.vala"
						if (_tmp35_) {
#line 11584 "SourceList.c"
							gboolean _tmp36_ = FALSE;
							gboolean _tmp37_;
							gboolean _tmp46_ = FALSE;
							gboolean _tmp47_ = FALSE;
							gboolean _tmp48_;
#line 2219 "../lib/Widgets/SourceList.vala"
							_tmp37_ = is_category;
#line 2219 "../lib/Widgets/SourceList.vala"
							if (_tmp37_) {
#line 2219 "../lib/Widgets/SourceList.vala"
								_tmp36_ = TRUE;
#line 11596 "SourceList.c"
							} else {
								gboolean _tmp38_ = FALSE;
								GraniteWidgetsSourceListItem* _tmp39_;
								gboolean _tmp40_;
								gboolean _tmp41_;
#line 2220 "../lib/Widgets/SourceList.vala"
								_tmp39_ = item;
#line 2220 "../lib/Widgets/SourceList.vala"
								_tmp40_ = granite_widgets_source_list_item_get_selectable (_tmp39_);
#line 2220 "../lib/Widgets/SourceList.vala"
								_tmp41_ = _tmp40_;
#line 2220 "../lib/Widgets/SourceList.vala"
								if (!_tmp41_) {
#line 11610 "SourceList.c"
									GtkTreeViewColumn* _tmp42_;
									GtkTreePath* _tmp43_;
									GraniteWidgetsSourceListCellRendererIcon* _tmp44_;
									gint _tmp45_;
#line 2220 "../lib/Widgets/SourceList.vala"
									_tmp42_ = column;
#line 2220 "../lib/Widgets/SourceList.vala"
									_tmp43_ = path;
#line 2220 "../lib/Widgets/SourceList.vala"
									_tmp44_ = self->priv->activatable_cell;
#line 2220 "../lib/Widgets/SourceList.vala"
									_tmp45_ = cell_x;
#line 2220 "../lib/Widgets/SourceList.vala"
									_tmp38_ = !granite_widgets_source_list_tree_over_cell (self, _tmp42_, _tmp43_, (GtkCellRenderer*) _tmp44_, _tmp45_);
#line 11625 "SourceList.c"
								} else {
#line 2220 "../lib/Widgets/SourceList.vala"
									_tmp38_ = FALSE;
#line 11629 "SourceList.c"
								}
#line 2220 "../lib/Widgets/SourceList.vala"
								_tmp36_ = _tmp38_;
#line 11633 "SourceList.c"
							}
#line 2219 "../lib/Widgets/SourceList.vala"
							self->priv->unselectable_item_clicked = _tmp36_;
#line 2222 "../lib/Widgets/SourceList.vala"
							_tmp48_ = self->priv->unselectable_item_clicked;
#line 2222 "../lib/Widgets/SourceList.vala"
							if (!_tmp48_) {
#line 11641 "SourceList.c"
								GtkTreeViewColumn* _tmp49_;
								GtkTreePath* _tmp50_;
								gint _tmp51_;
#line 2223 "../lib/Widgets/SourceList.vala"
								_tmp49_ = column;
#line 2223 "../lib/Widgets/SourceList.vala"
								_tmp50_ = path;
#line 2223 "../lib/Widgets/SourceList.vala"
								_tmp51_ = cell_x;
#line 2223 "../lib/Widgets/SourceList.vala"
								_tmp47_ = granite_widgets_source_list_tree_over_primary_expander (self, _tmp49_, _tmp50_, _tmp51_);
#line 11653 "SourceList.c"
							} else {
#line 2222 "../lib/Widgets/SourceList.vala"
								_tmp47_ = FALSE;
#line 11657 "SourceList.c"
							}
#line 2222 "../lib/Widgets/SourceList.vala"
							if (_tmp47_) {
#line 11661 "SourceList.c"
								GraniteWidgetsSourceListItem* _tmp52_;
#line 2224 "../lib/Widgets/SourceList.vala"
								_tmp52_ = item;
#line 2224 "../lib/Widgets/SourceList.vala"
								_tmp46_ = granite_widgets_source_list_tree_toggle_expansion (self, G_TYPE_CHECK_INSTANCE_TYPE (_tmp52_, GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM) ? ((GraniteWidgetsSourceListExpandableItem*) _tmp52_) : NULL);
#line 11667 "SourceList.c"
							} else {
#line 2222 "../lib/Widgets/SourceList.vala"
								_tmp46_ = FALSE;
#line 11671 "SourceList.c"
							}
#line 2222 "../lib/Widgets/SourceList.vala"
							if (_tmp46_) {
#line 2225 "../lib/Widgets/SourceList.vala"
								result = TRUE;
#line 2225 "../lib/Widgets/SourceList.vala"
								_g_object_unref0 (item);
#line 2225 "../lib/Widgets/SourceList.vala"
								_g_object_unref0 (column);
#line 2225 "../lib/Widgets/SourceList.vala"
								__vala_GtkTreePath_free0 (path);
#line 2225 "../lib/Widgets/SourceList.vala"
								return result;
#line 11685 "SourceList.c"
							}
						}
					} else {
						gboolean _tmp53_ = FALSE;
						gboolean _tmp54_ = FALSE;
						gboolean _tmp55_ = FALSE;
						gboolean _tmp56_ = FALSE;
						gboolean _tmp57_ = FALSE;
						GdkEventType _tmp58_;
#line 2227 "../lib/Widgets/SourceList.vala"
						_tmp58_ = event->type;
#line 2227 "../lib/Widgets/SourceList.vala"
						if (_tmp58_ == GDK_2BUTTON_PRESS) {
#line 11699 "SourceList.c"
							gboolean _tmp59_;
#line 2228 "../lib/Widgets/SourceList.vala"
							_tmp59_ = is_category;
#line 2228 "../lib/Widgets/SourceList.vala"
							_tmp57_ = !_tmp59_;
#line 11705 "SourceList.c"
						} else {
#line 2227 "../lib/Widgets/SourceList.vala"
							_tmp57_ = FALSE;
#line 11709 "SourceList.c"
						}
#line 2227 "../lib/Widgets/SourceList.vala"
						if (_tmp57_) {
#line 11713 "SourceList.c"
							GraniteWidgetsSourceListItem* _tmp60_;
							gboolean _tmp61_;
							gboolean _tmp62_;
#line 2229 "../lib/Widgets/SourceList.vala"
							_tmp60_ = item;
#line 2229 "../lib/Widgets/SourceList.vala"
							_tmp61_ = granite_widgets_source_list_item_get_editable (_tmp60_);
#line 2229 "../lib/Widgets/SourceList.vala"
							_tmp62_ = _tmp61_;
#line 2229 "../lib/Widgets/SourceList.vala"
							_tmp56_ = _tmp62_;
#line 11725 "SourceList.c"
						} else {
#line 2227 "../lib/Widgets/SourceList.vala"
							_tmp56_ = FALSE;
#line 11729 "SourceList.c"
						}
#line 2227 "../lib/Widgets/SourceList.vala"
						if (_tmp56_) {
#line 11733 "SourceList.c"
							GraniteWidgetsSourceListItem* _tmp63_;
							gboolean _tmp64_;
							gboolean _tmp65_;
#line 2230 "../lib/Widgets/SourceList.vala"
							_tmp63_ = item;
#line 2230 "../lib/Widgets/SourceList.vala"
							_tmp64_ = granite_widgets_source_list_item_get_selectable (_tmp63_);
#line 2230 "../lib/Widgets/SourceList.vala"
							_tmp65_ = _tmp64_;
#line 2230 "../lib/Widgets/SourceList.vala"
							_tmp55_ = _tmp65_;
#line 11745 "SourceList.c"
						} else {
#line 2227 "../lib/Widgets/SourceList.vala"
							_tmp55_ = FALSE;
#line 11749 "SourceList.c"
						}
#line 2227 "../lib/Widgets/SourceList.vala"
						if (_tmp55_) {
#line 11753 "SourceList.c"
							GtkTreeViewColumn* _tmp66_;
							GtkTreePath* _tmp67_;
							GtkCellRendererText* _tmp68_;
							gint _tmp69_;
#line 2231 "../lib/Widgets/SourceList.vala"
							_tmp66_ = column;
#line 2231 "../lib/Widgets/SourceList.vala"
							_tmp67_ = path;
#line 2231 "../lib/Widgets/SourceList.vala"
							_tmp68_ = self->priv->text_cell;
#line 2231 "../lib/Widgets/SourceList.vala"
							_tmp69_ = cell_x;
#line 2231 "../lib/Widgets/SourceList.vala"
							_tmp54_ = granite_widgets_source_list_tree_over_cell (self, _tmp66_, _tmp67_, (GtkCellRenderer*) _tmp68_, _tmp69_);
#line 11768 "SourceList.c"
						} else {
#line 2227 "../lib/Widgets/SourceList.vala"
							_tmp54_ = FALSE;
#line 11772 "SourceList.c"
						}
#line 2227 "../lib/Widgets/SourceList.vala"
						if (_tmp54_) {
#line 11776 "SourceList.c"
							GraniteWidgetsSourceListItem* _tmp70_;
#line 2232 "../lib/Widgets/SourceList.vala"
							_tmp70_ = item;
#line 2232 "../lib/Widgets/SourceList.vala"
							_tmp53_ = granite_widgets_source_list_tree_start_editing_item (self, _tmp70_);
#line 11782 "SourceList.c"
						} else {
#line 2227 "../lib/Widgets/SourceList.vala"
							_tmp53_ = FALSE;
#line 11786 "SourceList.c"
						}
#line 2227 "../lib/Widgets/SourceList.vala"
						if (_tmp53_) {
#line 2235 "../lib/Widgets/SourceList.vala"
							result = TRUE;
#line 2235 "../lib/Widgets/SourceList.vala"
							_g_object_unref0 (item);
#line 2235 "../lib/Widgets/SourceList.vala"
							_g_object_unref0 (column);
#line 2235 "../lib/Widgets/SourceList.vala"
							__vala_GtkTreePath_free0 (path);
#line 2235 "../lib/Widgets/SourceList.vala"
							return result;
#line 11800 "SourceList.c"
						}
					}
				}
			}
		}
#line 2192 "../lib/Widgets/SourceList.vala"
		_g_object_unref0 (item);
#line 11808 "SourceList.c"
	}
#line 2241 "../lib/Widgets/SourceList.vala"
	result = GTK_WIDGET_CLASS (granite_widgets_source_list_tree_parent_class)->button_press_event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_tree_view_get_type (), GtkTreeView), event);
#line 2241 "../lib/Widgets/SourceList.vala"
	_g_object_unref0 (column);
#line 2241 "../lib/Widgets/SourceList.vala"
	__vala_GtkTreePath_free0 (path);
#line 2241 "../lib/Widgets/SourceList.vala"
	return result;
#line 11818 "SourceList.c"
}


static gboolean
granite_widgets_source_list_tree_over_primary_expander (GraniteWidgetsSourceListTree* self,
                                                        GtkTreeViewColumn* col,
                                                        GtkTreePath* path,
                                                        gint x)
{
	gboolean result = FALSE;
	GtkTreeIter iter = {0};
	GtkTreeModel* _tmp0_;
	GtkTreeModel* _tmp1_;
	GtkTreeIter _tmp2_ = {0};
	gboolean _tmp3_;
	GraniteWidgetsCellRendererExpander* _tmp4_;
	GtkTreeModel* _tmp5_;
	GtkTreeModel* _tmp6_;
	GtkTreeIter _tmp7_;
	GraniteWidgetsCellRendererExpander* _tmp8_;
	gboolean _tmp9_;
	gboolean _tmp10_;
	GtkTreeModel* _tmp11_;
	GtkTreeModel* _tmp12_;
	GtkTreeIter _tmp13_;
	gint indentation_level = 0;
	GraniteWidgetsSourceListCellRendererSpacer* last_spacer_cell = NULL;
	GeeHashMap* _tmp14_;
	gint _tmp15_;
	gpointer _tmp16_;
	GraniteWidgetsSourceListCellRendererSpacer* _tmp17_;
#line 2244 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2244 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (col != NULL, FALSE);
#line 2244 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 2246 "../lib/Widgets/SourceList.vala"
	_tmp0_ = gtk_tree_view_get_model ((GtkTreeView*) self);
#line 2246 "../lib/Widgets/SourceList.vala"
	_tmp1_ = _tmp0_;
#line 2246 "../lib/Widgets/SourceList.vala"
	_tmp3_ = gtk_tree_model_get_iter (_tmp1_, &_tmp2_, path);
#line 2246 "../lib/Widgets/SourceList.vala"
	iter = _tmp2_;
#line 2246 "../lib/Widgets/SourceList.vala"
	if (!_tmp3_) {
#line 2247 "../lib/Widgets/SourceList.vala"
		result = FALSE;
#line 2247 "../lib/Widgets/SourceList.vala"
		return result;
#line 11870 "SourceList.c"
	}
#line 2250 "../lib/Widgets/SourceList.vala"
	_tmp4_ = self->priv->primary_expander_cell;
#line 2250 "../lib/Widgets/SourceList.vala"
	_tmp5_ = gtk_tree_view_get_model ((GtkTreeView*) self);
#line 2250 "../lib/Widgets/SourceList.vala"
	_tmp6_ = _tmp5_;
#line 2250 "../lib/Widgets/SourceList.vala"
	_tmp7_ = iter;
#line 2250 "../lib/Widgets/SourceList.vala"
	granite_widgets_source_list_tree_expander_cell_data_func (self, (GtkCellLayout*) col, (GtkCellRenderer*) _tmp4_, _tmp6_, &_tmp7_);
#line 2252 "../lib/Widgets/SourceList.vala"
	_tmp8_ = self->priv->primary_expander_cell;
#line 2252 "../lib/Widgets/SourceList.vala"
	_tmp9_ = gtk_cell_renderer_get_visible ((GtkCellRenderer*) _tmp8_);
#line 2252 "../lib/Widgets/SourceList.vala"
	_tmp10_ = _tmp9_;
#line 2252 "../lib/Widgets/SourceList.vala"
	if (!_tmp10_) {
#line 2253 "../lib/Widgets/SourceList.vala"
		result = FALSE;
#line 2253 "../lib/Widgets/SourceList.vala"
		return result;
#line 11894 "SourceList.c"
	}
#line 2256 "../lib/Widgets/SourceList.vala"
	_tmp11_ = gtk_tree_view_get_model ((GtkTreeView*) self);
#line 2256 "../lib/Widgets/SourceList.vala"
	_tmp12_ = _tmp11_;
#line 2256 "../lib/Widgets/SourceList.vala"
	_tmp13_ = iter;
#line 2256 "../lib/Widgets/SourceList.vala"
	if (gtk_tree_model_iter_n_children (_tmp12_, &_tmp13_) < 1) {
#line 2257 "../lib/Widgets/SourceList.vala"
		result = FALSE;
#line 2257 "../lib/Widgets/SourceList.vala"
		return result;
#line 11908 "SourceList.c"
	}
#line 2265 "../lib/Widgets/SourceList.vala"
	indentation_level = gtk_tree_path_get_depth (path);
#line 2266 "../lib/Widgets/SourceList.vala"
	_tmp14_ = self->priv->spacer_cells;
#line 2266 "../lib/Widgets/SourceList.vala"
	_tmp15_ = indentation_level;
#line 2266 "../lib/Widgets/SourceList.vala"
	_tmp16_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp14_, (gpointer) ((gintptr) _tmp15_));
#line 2266 "../lib/Widgets/SourceList.vala"
	last_spacer_cell = (GraniteWidgetsSourceListCellRendererSpacer*) _tmp16_;
#line 2268 "../lib/Widgets/SourceList.vala"
	_tmp17_ = last_spacer_cell;
#line 2268 "../lib/Widgets/SourceList.vala"
	if (_tmp17_ != NULL) {
#line 11924 "SourceList.c"
		gint cell_x = 0;
		gint cell_width = 0;
		GraniteWidgetsSourceListCellRendererSpacer* _tmp18_;
		gint _tmp19_ = 0;
		gint _tmp20_ = 0;
		gboolean _tmp21_;
#line 2271 "../lib/Widgets/SourceList.vala"
		_tmp18_ = last_spacer_cell;
#line 2271 "../lib/Widgets/SourceList.vala"
		_tmp21_ = gtk_tree_view_column_cell_get_position (col, (GtkCellRenderer*) _tmp18_, &_tmp19_, &_tmp20_);
#line 2271 "../lib/Widgets/SourceList.vala"
		cell_x = _tmp19_;
#line 2271 "../lib/Widgets/SourceList.vala"
		cell_width = _tmp20_;
#line 2271 "../lib/Widgets/SourceList.vala"
		if (_tmp21_) {
#line 11941 "SourceList.c"
			gint expander_width = 0;
			GraniteWidgetsCellRendererExpander* _tmp22_;
			gboolean _tmp29_ = FALSE;
			gint _tmp30_;
#line 2273 "../lib/Widgets/SourceList.vala"
			_tmp22_ = self->priv->primary_expander_cell;
#line 2273 "../lib/Widgets/SourceList.vala"
			expander_width = granite_widgets_source_list_tree_get_cell_width (self, (GtkCellRenderer*) _tmp22_) + 1;
#line 2275 "../lib/Widgets/SourceList.vala"
			if (granite_widgets_utils_is_left_to_right ((GtkWidget*) self)) {
#line 11952 "SourceList.c"
				gint indentation_offset = 0;
				gint _tmp23_;
				gint _tmp24_;
				gboolean _tmp25_ = FALSE;
				gint _tmp26_;
#line 2276 "../lib/Widgets/SourceList.vala"
				_tmp23_ = cell_x;
#line 2276 "../lib/Widgets/SourceList.vala"
				_tmp24_ = cell_width;
#line 2276 "../lib/Widgets/SourceList.vala"
				indentation_offset = _tmp23_ + _tmp24_;
#line 2277 "../lib/Widgets/SourceList.vala"
				_tmp26_ = indentation_offset;
#line 2277 "../lib/Widgets/SourceList.vala"
				if (x >= _tmp26_) {
#line 11968 "SourceList.c"
					gint _tmp27_;
					gint _tmp28_;
#line 2277 "../lib/Widgets/SourceList.vala"
					_tmp27_ = indentation_offset;
#line 2277 "../lib/Widgets/SourceList.vala"
					_tmp28_ = expander_width;
#line 2277 "../lib/Widgets/SourceList.vala"
					_tmp25_ = x <= (_tmp27_ + _tmp28_);
#line 11977 "SourceList.c"
				} else {
#line 2277 "../lib/Widgets/SourceList.vala"
					_tmp25_ = FALSE;
#line 11981 "SourceList.c"
				}
#line 2277 "../lib/Widgets/SourceList.vala"
				result = _tmp25_;
#line 2277 "../lib/Widgets/SourceList.vala"
				_g_object_unref0 (last_spacer_cell);
#line 2277 "../lib/Widgets/SourceList.vala"
				return result;
#line 11989 "SourceList.c"
			}
#line 2280 "../lib/Widgets/SourceList.vala"
			_tmp30_ = cell_x;
#line 2280 "../lib/Widgets/SourceList.vala"
			if (x <= _tmp30_) {
#line 11995 "SourceList.c"
				gint _tmp31_;
				gint _tmp32_;
#line 2280 "../lib/Widgets/SourceList.vala"
				_tmp31_ = cell_x;
#line 2280 "../lib/Widgets/SourceList.vala"
				_tmp32_ = expander_width;
#line 2280 "../lib/Widgets/SourceList.vala"
				_tmp29_ = x >= (_tmp31_ - _tmp32_);
#line 12004 "SourceList.c"
			} else {
#line 2280 "../lib/Widgets/SourceList.vala"
				_tmp29_ = FALSE;
#line 12008 "SourceList.c"
			}
#line 2280 "../lib/Widgets/SourceList.vala"
			result = _tmp29_;
#line 2280 "../lib/Widgets/SourceList.vala"
			_g_object_unref0 (last_spacer_cell);
#line 2280 "../lib/Widgets/SourceList.vala"
			return result;
#line 12016 "SourceList.c"
		}
	}
#line 2284 "../lib/Widgets/SourceList.vala"
	result = FALSE;
#line 2284 "../lib/Widgets/SourceList.vala"
	_g_object_unref0 (last_spacer_cell);
#line 2284 "../lib/Widgets/SourceList.vala"
	return result;
#line 12025 "SourceList.c"
}


static gboolean
granite_widgets_source_list_tree_over_cell (GraniteWidgetsSourceListTree* self,
                                            GtkTreeViewColumn* col,
                                            GtkTreePath* path,
                                            GtkCellRenderer* cell,
                                            gint x)
{
	gboolean result = FALSE;
	gint cell_x = 0;
	gint cell_width = 0;
	gboolean found = FALSE;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gboolean _tmp2_;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_;
#line 2287 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2287 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (col != NULL, FALSE);
#line 2287 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 2287 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (cell != NULL, FALSE);
#line 2289 "../lib/Widgets/SourceList.vala"
	_tmp2_ = gtk_tree_view_column_cell_get_position (col, cell, &_tmp0_, &_tmp1_);
#line 2289 "../lib/Widgets/SourceList.vala"
	cell_x = _tmp0_;
#line 2289 "../lib/Widgets/SourceList.vala"
	cell_width = _tmp1_;
#line 2289 "../lib/Widgets/SourceList.vala"
	found = _tmp2_;
#line 2290 "../lib/Widgets/SourceList.vala"
	_tmp5_ = found;
#line 2290 "../lib/Widgets/SourceList.vala"
	if (_tmp5_) {
#line 12066 "SourceList.c"
		gint _tmp6_;
#line 2290 "../lib/Widgets/SourceList.vala"
		_tmp6_ = cell_x;
#line 2290 "../lib/Widgets/SourceList.vala"
		_tmp4_ = x > _tmp6_;
#line 12072 "SourceList.c"
	} else {
#line 2290 "../lib/Widgets/SourceList.vala"
		_tmp4_ = FALSE;
#line 12076 "SourceList.c"
	}
#line 2290 "../lib/Widgets/SourceList.vala"
	if (_tmp4_) {
#line 12080 "SourceList.c"
		gint _tmp7_;
		gint _tmp8_;
#line 2290 "../lib/Widgets/SourceList.vala"
		_tmp7_ = cell_x;
#line 2290 "../lib/Widgets/SourceList.vala"
		_tmp8_ = cell_width;
#line 2290 "../lib/Widgets/SourceList.vala"
		_tmp3_ = x < (_tmp7_ + _tmp8_);
#line 12089 "SourceList.c"
	} else {
#line 2290 "../lib/Widgets/SourceList.vala"
		_tmp3_ = FALSE;
#line 12093 "SourceList.c"
	}
#line 2290 "../lib/Widgets/SourceList.vala"
	result = _tmp3_;
#line 2290 "../lib/Widgets/SourceList.vala"
	return result;
#line 12099 "SourceList.c"
}


static gint
granite_widgets_source_list_tree_get_cell_width (GraniteWidgetsSourceListTree* self,
                                                 GtkCellRenderer* cell_renderer)
{
	gint result = 0;
	GtkRequisition min_req = {0};
	GtkRequisition _tmp0_ = {0};
	GtkRequisition _tmp1_;
	gint _tmp2_;
#line 2293 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 2293 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (cell_renderer != NULL, 0);
#line 2295 "../lib/Widgets/SourceList.vala"
	gtk_cell_renderer_get_preferred_size (cell_renderer, (GtkWidget*) self, &_tmp0_, NULL);
#line 2295 "../lib/Widgets/SourceList.vala"
	min_req = _tmp0_;
#line 2296 "../lib/Widgets/SourceList.vala"
	_tmp1_ = min_req;
#line 2296 "../lib/Widgets/SourceList.vala"
	_tmp2_ = _tmp1_.width;
#line 2296 "../lib/Widgets/SourceList.vala"
	result = _tmp2_;
#line 2296 "../lib/Widgets/SourceList.vala"
	return result;
#line 12128 "SourceList.c"
}


static gboolean
granite_widgets_source_list_tree_real_popup_menu (GtkWidget* base)
{
	GraniteWidgetsSourceListTree * self;
	gboolean result = FALSE;
#line 2299 "../lib/Widgets/SourceList.vala"
	self = (GraniteWidgetsSourceListTree*) base;
#line 2300 "../lib/Widgets/SourceList.vala"
	result = granite_widgets_source_list_tree_popup_context_menu (self, NULL, NULL);
#line 2300 "../lib/Widgets/SourceList.vala"
	return result;
#line 12143 "SourceList.c"
}


static gboolean
granite_widgets_source_list_tree_popup_context_menu (GraniteWidgetsSourceListTree* self,
                                                     GraniteWidgetsSourceListItem* item,
                                                     GdkEventButton* event)
{
	gboolean result = FALSE;
#line 2303 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2304 "../lib/Widgets/SourceList.vala"
	if (item == NULL) {
#line 12157 "SourceList.c"
		GraniteWidgetsSourceListItem* _tmp0_;
		GraniteWidgetsSourceListItem* _tmp1_;
#line 2305 "../lib/Widgets/SourceList.vala"
		_tmp0_ = granite_widgets_source_list_tree_get_selected_item (self);
#line 2305 "../lib/Widgets/SourceList.vala"
		_tmp1_ = _tmp0_;
#line 2305 "../lib/Widgets/SourceList.vala"
		item = _tmp1_;
#line 12166 "SourceList.c"
	}
#line 2307 "../lib/Widgets/SourceList.vala"
	if (item != NULL) {
#line 12170 "SourceList.c"
		GtkMenu* menu = NULL;
		GtkMenu* _tmp2_;
		GtkMenu* _tmp3_;
#line 2308 "../lib/Widgets/SourceList.vala"
		_tmp2_ = granite_widgets_source_list_item_get_context_menu (item);
#line 2308 "../lib/Widgets/SourceList.vala"
		menu = _tmp2_;
#line 2309 "../lib/Widgets/SourceList.vala"
		_tmp3_ = menu;
#line 2309 "../lib/Widgets/SourceList.vala"
		if (_tmp3_ != NULL) {
#line 12182 "SourceList.c"
			GtkMenu* _tmp4_;
			GtkMenu* _tmp5_;
#line 2310 "../lib/Widgets/SourceList.vala"
			_tmp4_ = menu;
#line 2310 "../lib/Widgets/SourceList.vala"
			g_object_set (_tmp4_, "attach-widget", (GtkWidget*) self, NULL);
#line 2311 "../lib/Widgets/SourceList.vala"
			_tmp5_ = menu;
#line 2311 "../lib/Widgets/SourceList.vala"
			gtk_menu_popup_at_pointer (_tmp5_, (GdkEvent*) event);
#line 2312 "../lib/Widgets/SourceList.vala"
			if (event == NULL) {
#line 12195 "SourceList.c"
				GtkMenu* _tmp6_;
#line 2313 "../lib/Widgets/SourceList.vala"
				_tmp6_ = menu;
#line 2313 "../lib/Widgets/SourceList.vala"
				gtk_menu_shell_select_first ((GtkMenuShell*) _tmp6_, FALSE);
#line 12201 "SourceList.c"
			}
#line 2316 "../lib/Widgets/SourceList.vala"
			result = TRUE;
#line 2316 "../lib/Widgets/SourceList.vala"
			_g_object_unref0 (menu);
#line 2316 "../lib/Widgets/SourceList.vala"
			return result;
#line 12209 "SourceList.c"
		}
#line 2307 "../lib/Widgets/SourceList.vala"
		_g_object_unref0 (menu);
#line 12213 "SourceList.c"
	}
#line 2320 "../lib/Widgets/SourceList.vala"
	result = FALSE;
#line 2320 "../lib/Widgets/SourceList.vala"
	return result;
#line 12219 "SourceList.c"
}


static GraniteWidgetsSourceListItem*
granite_widgets_source_list_tree_get_item_from_model (GtkTreeModel* model,
                                                      GtkTreeIter* iter)
{
	GraniteWidgetsSourceListItem* result = NULL;
	GraniteWidgetsSourceListDataModel* data_model = NULL;
	GraniteWidgetsSourceListDataModel* _tmp0_;
	GtkTreeIter _tmp1_;
	GraniteWidgetsSourceListItem* _tmp2_;
#line 2323 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (model != NULL, NULL);
#line 2323 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (iter != NULL, NULL);
#line 2324 "../lib/Widgets/SourceList.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (model, GRANITE_WIDGETS_SOURCE_LIST_TYPE_DATA_MODEL) ? ((GraniteWidgetsSourceListDataModel*) model) : NULL);
#line 2324 "../lib/Widgets/SourceList.vala"
	data_model = _tmp0_;
#line 2325 "../lib/Widgets/SourceList.vala"
	_vala_assert (data_model != NULL, "data_model != null");
#line 2326 "../lib/Widgets/SourceList.vala"
	_tmp1_ = *iter;
#line 2326 "../lib/Widgets/SourceList.vala"
	_tmp2_ = granite_widgets_source_list_data_model_get_item (data_model, &_tmp1_);
#line 2326 "../lib/Widgets/SourceList.vala"
	result = _tmp2_;
#line 2326 "../lib/Widgets/SourceList.vala"
	_g_object_unref0 (data_model);
#line 2326 "../lib/Widgets/SourceList.vala"
	return result;
#line 12252 "SourceList.c"
}


static void
granite_widgets_source_list_tree_spacer_cell_data_func (GtkCellLayout* layout,
                                                        GtkCellRenderer* renderer,
                                                        GtkTreeModel* model,
                                                        GtkTreeIter* iter)
{
	GraniteWidgetsSourceListCellRendererSpacer* spacer = NULL;
	GraniteWidgetsSourceListCellRendererSpacer* _tmp0_;
	GraniteWidgetsSourceListCellRendererSpacer* _tmp1_;
	GraniteWidgetsSourceListCellRendererSpacer* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	GtkTreePath* path = NULL;
	GtkTreeIter _tmp5_;
	GtkTreePath* _tmp6_;
	gint level = 0;
	GtkTreePath* _tmp7_;
	GraniteWidgetsSourceListCellRendererSpacer* _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	gint _tmp12_;
#line 2329 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (layout != NULL);
#line 2329 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (renderer != NULL);
#line 2329 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (model != NULL);
#line 2329 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (iter != NULL);
#line 2332 "../lib/Widgets/SourceList.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (renderer, GRANITE_WIDGETS_SOURCE_LIST_TYPE_CELL_RENDERER_SPACER) ? ((GraniteWidgetsSourceListCellRendererSpacer*) renderer) : NULL);
#line 2332 "../lib/Widgets/SourceList.vala"
	spacer = _tmp0_;
#line 2333 "../lib/Widgets/SourceList.vala"
	_tmp1_ = spacer;
#line 2333 "../lib/Widgets/SourceList.vala"
	_vala_assert (_tmp1_ != NULL, "spacer != null");
#line 2334 "../lib/Widgets/SourceList.vala"
	_tmp2_ = spacer;
#line 2334 "../lib/Widgets/SourceList.vala"
	_tmp3_ = granite_widgets_source_list_cell_renderer_spacer_get_level (_tmp2_);
#line 2334 "../lib/Widgets/SourceList.vala"
	_tmp4_ = _tmp3_;
#line 2334 "../lib/Widgets/SourceList.vala"
	_vala_assert (_tmp4_ > 0, "spacer.level > 0");
#line 2336 "../lib/Widgets/SourceList.vala"
	_tmp5_ = *iter;
#line 2336 "../lib/Widgets/SourceList.vala"
	_tmp6_ = gtk_tree_model_get_path (model, &_tmp5_);
#line 2336 "../lib/Widgets/SourceList.vala"
	path = _tmp6_;
#line 2338 "../lib/Widgets/SourceList.vala"
	level = -1;
#line 2339 "../lib/Widgets/SourceList.vala"
	_tmp7_ = path;
#line 2339 "../lib/Widgets/SourceList.vala"
	if (_tmp7_ != NULL) {
#line 12313 "SourceList.c"
		GtkTreePath* _tmp8_;
#line 2340 "../lib/Widgets/SourceList.vala"
		_tmp8_ = path;
#line 2340 "../lib/Widgets/SourceList.vala"
		level = gtk_tree_path_get_depth (_tmp8_);
#line 12319 "SourceList.c"
	}
#line 2342 "../lib/Widgets/SourceList.vala"
	_tmp9_ = spacer;
#line 2342 "../lib/Widgets/SourceList.vala"
	_tmp10_ = granite_widgets_source_list_cell_renderer_spacer_get_level (_tmp9_);
#line 2342 "../lib/Widgets/SourceList.vala"
	_tmp11_ = _tmp10_;
#line 2342 "../lib/Widgets/SourceList.vala"
	_tmp12_ = level;
#line 2342 "../lib/Widgets/SourceList.vala"
	gtk_cell_renderer_set_visible (renderer, _tmp11_ <= _tmp12_);
#line 2329 "../lib/Widgets/SourceList.vala"
	__vala_GtkTreePath_free0 (path);
#line 2329 "../lib/Widgets/SourceList.vala"
	_g_object_unref0 (spacer);
#line 12335 "SourceList.c"
}


static void
granite_widgets_source_list_tree_name_cell_data_func (GraniteWidgetsSourceListTree* self,
                                                      GtkCellLayout* layout,
                                                      GtkCellRenderer* renderer,
                                                      GtkTreeModel* model,
                                                      GtkTreeIter* iter)
{
	GtkCellRendererText* text_renderer = NULL;
	GtkCellRendererText* _tmp0_;
	GtkCellRendererText* _tmp1_;
	GString* text = NULL;
	GString* _tmp2_;
	PangoWeight weight = 0;
	gboolean use_markup = FALSE;
	GraniteWidgetsSourceListItem* item = NULL;
	GtkTreeIter _tmp3_;
	GraniteWidgetsSourceListItem* _tmp4_;
	GraniteWidgetsSourceListItem* _tmp5_;
	GtkCellRendererText* _tmp20_;
	PangoWeight _tmp21_;
	gboolean _tmp22_;
#line 2345 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 2345 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (layout != NULL);
#line 2345 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (renderer != NULL);
#line 2345 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (model != NULL);
#line 2345 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (iter != NULL);
#line 2348 "../lib/Widgets/SourceList.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (renderer, gtk_cell_renderer_text_get_type ()) ? ((GtkCellRendererText*) renderer) : NULL);
#line 2348 "../lib/Widgets/SourceList.vala"
	text_renderer = _tmp0_;
#line 2349 "../lib/Widgets/SourceList.vala"
	_tmp1_ = text_renderer;
#line 2349 "../lib/Widgets/SourceList.vala"
	_vala_assert (_tmp1_ != NULL, "text_renderer != null");
#line 2351 "../lib/Widgets/SourceList.vala"
	_tmp2_ = g_string_new ("");
#line 2351 "../lib/Widgets/SourceList.vala"
	text = _tmp2_;
#line 2352 "../lib/Widgets/SourceList.vala"
	weight = PANGO_WEIGHT_NORMAL;
#line 2353 "../lib/Widgets/SourceList.vala"
	use_markup = FALSE;
#line 2355 "../lib/Widgets/SourceList.vala"
	_tmp3_ = *iter;
#line 2355 "../lib/Widgets/SourceList.vala"
	_tmp4_ = granite_widgets_source_list_tree_get_item_from_model (model, &_tmp3_);
#line 2355 "../lib/Widgets/SourceList.vala"
	item = _tmp4_;
#line 2356 "../lib/Widgets/SourceList.vala"
	_tmp5_ = item;
#line 2356 "../lib/Widgets/SourceList.vala"
	if (_tmp5_ != NULL) {
#line 12396 "SourceList.c"
		GraniteWidgetsSourceListItem* _tmp6_;
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		GraniteWidgetsSourceListDataModel* _tmp17_;
		GraniteWidgetsSourceListItem* _tmp18_;
		GtkTreeIter _tmp19_;
#line 2357 "../lib/Widgets/SourceList.vala"
		_tmp6_ = item;
#line 2357 "../lib/Widgets/SourceList.vala"
		_tmp7_ = granite_widgets_source_list_item_get_markup (_tmp6_);
#line 2357 "../lib/Widgets/SourceList.vala"
		_tmp8_ = _tmp7_;
#line 2357 "../lib/Widgets/SourceList.vala"
		if (_tmp8_ != NULL) {
#line 12411 "SourceList.c"
			GString* _tmp9_;
			GraniteWidgetsSourceListItem* _tmp10_;
			const gchar* _tmp11_;
			const gchar* _tmp12_;
#line 2358 "../lib/Widgets/SourceList.vala"
			_tmp9_ = text;
#line 2358 "../lib/Widgets/SourceList.vala"
			_tmp10_ = item;
#line 2358 "../lib/Widgets/SourceList.vala"
			_tmp11_ = granite_widgets_source_list_item_get_markup (_tmp10_);
#line 2358 "../lib/Widgets/SourceList.vala"
			_tmp12_ = _tmp11_;
#line 2358 "../lib/Widgets/SourceList.vala"
			g_string_append (_tmp9_, _tmp12_);
#line 2359 "../lib/Widgets/SourceList.vala"
			use_markup = TRUE;
#line 12428 "SourceList.c"
		} else {
			GString* _tmp13_;
			GraniteWidgetsSourceListItem* _tmp14_;
			const gchar* _tmp15_;
			const gchar* _tmp16_;
#line 2361 "../lib/Widgets/SourceList.vala"
			_tmp13_ = text;
#line 2361 "../lib/Widgets/SourceList.vala"
			_tmp14_ = item;
#line 2361 "../lib/Widgets/SourceList.vala"
			_tmp15_ = granite_widgets_source_list_item_get_name (_tmp14_);
#line 2361 "../lib/Widgets/SourceList.vala"
			_tmp16_ = _tmp15_;
#line 2361 "../lib/Widgets/SourceList.vala"
			g_string_append (_tmp13_, _tmp16_);
#line 12444 "SourceList.c"
		}
#line 2364 "../lib/Widgets/SourceList.vala"
		_tmp17_ = self->priv->_data_model;
#line 2364 "../lib/Widgets/SourceList.vala"
		_tmp18_ = item;
#line 2364 "../lib/Widgets/SourceList.vala"
		_tmp19_ = *iter;
#line 2364 "../lib/Widgets/SourceList.vala"
		if (granite_widgets_source_list_data_model_is_category (_tmp17_, _tmp18_, &_tmp19_, NULL)) {
#line 2365 "../lib/Widgets/SourceList.vala"
			weight = PANGO_WEIGHT_BOLD;
#line 12456 "SourceList.c"
		}
	}
#line 2368 "../lib/Widgets/SourceList.vala"
	_tmp20_ = text_renderer;
#line 2368 "../lib/Widgets/SourceList.vala"
	_tmp21_ = weight;
#line 2368 "../lib/Widgets/SourceList.vala"
	g_object_set (_tmp20_, "weight", (gint) _tmp21_, NULL);
#line 2369 "../lib/Widgets/SourceList.vala"
	_tmp22_ = use_markup;
#line 2369 "../lib/Widgets/SourceList.vala"
	if (_tmp22_) {
#line 12469 "SourceList.c"
		GtkCellRendererText* _tmp23_;
		GString* _tmp24_;
		const gchar* _tmp25_;
#line 2370 "../lib/Widgets/SourceList.vala"
		_tmp23_ = text_renderer;
#line 2370 "../lib/Widgets/SourceList.vala"
		_tmp24_ = text;
#line 2370 "../lib/Widgets/SourceList.vala"
		_tmp25_ = _tmp24_->str;
#line 2370 "../lib/Widgets/SourceList.vala"
		g_object_set (_tmp23_, "markup", _tmp25_, NULL);
#line 12481 "SourceList.c"
	} else {
		GtkCellRendererText* _tmp26_;
		GString* _tmp27_;
		const gchar* _tmp28_;
#line 2372 "../lib/Widgets/SourceList.vala"
		_tmp26_ = text_renderer;
#line 2372 "../lib/Widgets/SourceList.vala"
		_tmp27_ = text;
#line 2372 "../lib/Widgets/SourceList.vala"
		_tmp28_ = _tmp27_->str;
#line 2372 "../lib/Widgets/SourceList.vala"
		g_object_set (_tmp26_, "text", _tmp28_, NULL);
#line 12494 "SourceList.c"
	}
#line 2345 "../lib/Widgets/SourceList.vala"
	_g_object_unref0 (item);
#line 2345 "../lib/Widgets/SourceList.vala"
	_g_string_free0 (text);
#line 2345 "../lib/Widgets/SourceList.vala"
	_g_object_unref0 (text_renderer);
#line 12502 "SourceList.c"
}


static void
granite_widgets_source_list_tree_badge_cell_data_func (GraniteWidgetsSourceListTree* self,
                                                       GtkCellLayout* layout,
                                                       GtkCellRenderer* renderer,
                                                       GtkTreeModel* model,
                                                       GtkTreeIter* iter)
{
	GraniteWidgetsCellRendererBadge* badge_renderer = NULL;
	GraniteWidgetsCellRendererBadge* _tmp0_;
	GraniteWidgetsCellRendererBadge* _tmp1_;
	gchar* text = NULL;
	gchar* _tmp2_;
	gboolean visible = FALSE;
	GraniteWidgetsSourceListItem* item = NULL;
	GtkTreeIter _tmp3_;
	GraniteWidgetsSourceListItem* _tmp4_;
	GraniteWidgetsSourceListItem* _tmp5_;
	GraniteWidgetsCellRendererBadge* _tmp24_;
	gboolean _tmp25_;
	GraniteWidgetsCellRendererBadge* _tmp26_;
	const gchar* _tmp27_;
#line 2376 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 2376 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (layout != NULL);
#line 2376 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (renderer != NULL);
#line 2376 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (model != NULL);
#line 2376 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (iter != NULL);
#line 2379 "../lib/Widgets/SourceList.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (renderer, GRANITE_WIDGETS_TYPE_CELL_RENDERER_BADGE) ? ((GraniteWidgetsCellRendererBadge*) renderer) : NULL);
#line 2379 "../lib/Widgets/SourceList.vala"
	badge_renderer = _tmp0_;
#line 2380 "../lib/Widgets/SourceList.vala"
	_tmp1_ = badge_renderer;
#line 2380 "../lib/Widgets/SourceList.vala"
	_vala_assert (_tmp1_ != NULL, "badge_renderer != null");
#line 2382 "../lib/Widgets/SourceList.vala"
	_tmp2_ = g_strdup ("");
#line 2382 "../lib/Widgets/SourceList.vala"
	text = _tmp2_;
#line 2383 "../lib/Widgets/SourceList.vala"
	visible = FALSE;
#line 2385 "../lib/Widgets/SourceList.vala"
	_tmp3_ = *iter;
#line 2385 "../lib/Widgets/SourceList.vala"
	_tmp4_ = granite_widgets_source_list_tree_get_item_from_model (model, &_tmp3_);
#line 2385 "../lib/Widgets/SourceList.vala"
	item = _tmp4_;
#line 2386 "../lib/Widgets/SourceList.vala"
	_tmp5_ = item;
#line 2386 "../lib/Widgets/SourceList.vala"
	if (_tmp5_ != NULL) {
#line 12561 "SourceList.c"
		gboolean _tmp6_ = FALSE;
		gboolean _tmp7_ = FALSE;
		GraniteWidgetsSourceListDataModel* _tmp8_;
		GraniteWidgetsSourceListItem* _tmp9_;
		GtkTreeIter _tmp10_;
		gboolean _tmp19_;
#line 2388 "../lib/Widgets/SourceList.vala"
		_tmp8_ = self->priv->_data_model;
#line 2388 "../lib/Widgets/SourceList.vala"
		_tmp9_ = item;
#line 2388 "../lib/Widgets/SourceList.vala"
		_tmp10_ = *iter;
#line 2388 "../lib/Widgets/SourceList.vala"
		if (!granite_widgets_source_list_data_model_is_category (_tmp8_, _tmp9_, &_tmp10_, NULL)) {
#line 12576 "SourceList.c"
			GraniteWidgetsSourceListItem* _tmp11_;
			const gchar* _tmp12_;
			const gchar* _tmp13_;
#line 2389 "../lib/Widgets/SourceList.vala"
			_tmp11_ = item;
#line 2389 "../lib/Widgets/SourceList.vala"
			_tmp12_ = granite_widgets_source_list_item_get_badge (_tmp11_);
#line 2389 "../lib/Widgets/SourceList.vala"
			_tmp13_ = _tmp12_;
#line 2389 "../lib/Widgets/SourceList.vala"
			_tmp7_ = _tmp13_ != NULL;
#line 12588 "SourceList.c"
		} else {
#line 2388 "../lib/Widgets/SourceList.vala"
			_tmp7_ = FALSE;
#line 12592 "SourceList.c"
		}
#line 2388 "../lib/Widgets/SourceList.vala"
		if (_tmp7_) {
#line 12596 "SourceList.c"
			GraniteWidgetsSourceListItem* _tmp14_;
			const gchar* _tmp15_;
			const gchar* _tmp16_;
			gchar* _tmp17_;
			gchar* _tmp18_;
#line 2390 "../lib/Widgets/SourceList.vala"
			_tmp14_ = item;
#line 2390 "../lib/Widgets/SourceList.vala"
			_tmp15_ = granite_widgets_source_list_item_get_badge (_tmp14_);
#line 2390 "../lib/Widgets/SourceList.vala"
			_tmp16_ = _tmp15_;
#line 2390 "../lib/Widgets/SourceList.vala"
			_tmp17_ = string_strip (_tmp16_);
#line 2390 "../lib/Widgets/SourceList.vala"
			_tmp18_ = _tmp17_;
#line 2390 "../lib/Widgets/SourceList.vala"
			_tmp6_ = g_strcmp0 (_tmp18_, "") != 0;
#line 2390 "../lib/Widgets/SourceList.vala"
			_g_free0 (_tmp18_);
#line 12616 "SourceList.c"
		} else {
#line 2388 "../lib/Widgets/SourceList.vala"
			_tmp6_ = FALSE;
#line 12620 "SourceList.c"
		}
#line 2388 "../lib/Widgets/SourceList.vala"
		visible = _tmp6_;
#line 2392 "../lib/Widgets/SourceList.vala"
		_tmp19_ = visible;
#line 2392 "../lib/Widgets/SourceList.vala"
		if (_tmp19_) {
#line 12628 "SourceList.c"
			GraniteWidgetsSourceListItem* _tmp20_;
			const gchar* _tmp21_;
			const gchar* _tmp22_;
			gchar* _tmp23_;
#line 2393 "../lib/Widgets/SourceList.vala"
			_tmp20_ = item;
#line 2393 "../lib/Widgets/SourceList.vala"
			_tmp21_ = granite_widgets_source_list_item_get_badge (_tmp20_);
#line 2393 "../lib/Widgets/SourceList.vala"
			_tmp22_ = _tmp21_;
#line 2393 "../lib/Widgets/SourceList.vala"
			_tmp23_ = g_strdup (_tmp22_);
#line 2393 "../lib/Widgets/SourceList.vala"
			_g_free0 (text);
#line 2393 "../lib/Widgets/SourceList.vala"
			text = _tmp23_;
#line 12645 "SourceList.c"
		}
	}
#line 2396 "../lib/Widgets/SourceList.vala"
	_tmp24_ = badge_renderer;
#line 2396 "../lib/Widgets/SourceList.vala"
	_tmp25_ = visible;
#line 2396 "../lib/Widgets/SourceList.vala"
	gtk_cell_renderer_set_visible ((GtkCellRenderer*) _tmp24_, _tmp25_);
#line 2397 "../lib/Widgets/SourceList.vala"
	_tmp26_ = badge_renderer;
#line 2397 "../lib/Widgets/SourceList.vala"
	_tmp27_ = text;
#line 2397 "../lib/Widgets/SourceList.vala"
	granite_widgets_cell_renderer_badge_set_text (_tmp26_, _tmp27_);
#line 2376 "../lib/Widgets/SourceList.vala"
	_g_object_unref0 (item);
#line 2376 "../lib/Widgets/SourceList.vala"
	_g_free0 (text);
#line 2376 "../lib/Widgets/SourceList.vala"
	_g_object_unref0 (badge_renderer);
#line 12666 "SourceList.c"
}


static void
granite_widgets_source_list_tree_icon_cell_data_func (GraniteWidgetsSourceListTree* self,
                                                      GtkCellLayout* layout,
                                                      GtkCellRenderer* renderer,
                                                      GtkTreeModel* model,
                                                      GtkTreeIter* iter)
{
	GraniteWidgetsSourceListCellRendererIcon* icon_renderer = NULL;
	GraniteWidgetsSourceListCellRendererIcon* _tmp0_;
	GraniteWidgetsSourceListCellRendererIcon* _tmp1_;
	gboolean visible = FALSE;
	GIcon* icon = NULL;
	GraniteWidgetsSourceListItem* item = NULL;
	GtkTreeIter _tmp2_;
	GraniteWidgetsSourceListItem* _tmp3_;
	GraniteWidgetsSourceListItem* _tmp4_;
	gboolean _tmp21_ = FALSE;
	gboolean _tmp22_;
	GraniteWidgetsSourceListCellRendererIcon* _tmp24_;
	gboolean _tmp25_;
	GIcon* _tmp26_ = NULL;
	gboolean _tmp27_;
	GraniteWidgetsSourceListCellRendererIcon* _tmp29_;
#line 2400 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 2400 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (layout != NULL);
#line 2400 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (renderer != NULL);
#line 2400 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (model != NULL);
#line 2400 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (iter != NULL);
#line 2403 "../lib/Widgets/SourceList.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (renderer, GRANITE_WIDGETS_SOURCE_LIST_TYPE_CELL_RENDERER_ICON) ? ((GraniteWidgetsSourceListCellRendererIcon*) renderer) : NULL);
#line 2403 "../lib/Widgets/SourceList.vala"
	icon_renderer = _tmp0_;
#line 2404 "../lib/Widgets/SourceList.vala"
	_tmp1_ = icon_renderer;
#line 2404 "../lib/Widgets/SourceList.vala"
	_vala_assert (_tmp1_ != NULL, "icon_renderer != null");
#line 2406 "../lib/Widgets/SourceList.vala"
	visible = FALSE;
#line 2407 "../lib/Widgets/SourceList.vala"
	icon = NULL;
#line 2409 "../lib/Widgets/SourceList.vala"
	_tmp2_ = *iter;
#line 2409 "../lib/Widgets/SourceList.vala"
	_tmp3_ = granite_widgets_source_list_tree_get_item_from_model (model, &_tmp2_);
#line 2409 "../lib/Widgets/SourceList.vala"
	item = _tmp3_;
#line 2410 "../lib/Widgets/SourceList.vala"
	_tmp4_ = item;
#line 2410 "../lib/Widgets/SourceList.vala"
	if (_tmp4_ != NULL) {
#line 12725 "SourceList.c"
		GraniteWidgetsSourceListDataModel* _tmp5_;
		GraniteWidgetsSourceListItem* _tmp6_;
		GtkTreeIter _tmp7_;
		gboolean _tmp8_;
#line 2412 "../lib/Widgets/SourceList.vala"
		_tmp5_ = self->priv->_data_model;
#line 2412 "../lib/Widgets/SourceList.vala"
		_tmp6_ = item;
#line 2412 "../lib/Widgets/SourceList.vala"
		_tmp7_ = *iter;
#line 2412 "../lib/Widgets/SourceList.vala"
		visible = !granite_widgets_source_list_data_model_is_category (_tmp5_, _tmp6_, &_tmp7_, NULL);
#line 2414 "../lib/Widgets/SourceList.vala"
		_tmp8_ = visible;
#line 2414 "../lib/Widgets/SourceList.vala"
		if (_tmp8_) {
#line 12742 "SourceList.c"
			GraniteWidgetsSourceListCellRendererIcon* _tmp9_;
			GraniteWidgetsSourceListCellRendererIcon* _tmp10_;
#line 2415 "../lib/Widgets/SourceList.vala"
			_tmp9_ = icon_renderer;
#line 2415 "../lib/Widgets/SourceList.vala"
			_tmp10_ = self->priv->icon_cell;
#line 2415 "../lib/Widgets/SourceList.vala"
			if (_tmp9_ == _tmp10_) {
#line 12751 "SourceList.c"
				GraniteWidgetsSourceListItem* _tmp11_;
				GIcon* _tmp12_;
				GIcon* _tmp13_;
				GIcon* _tmp14_;
#line 2416 "../lib/Widgets/SourceList.vala"
				_tmp11_ = item;
#line 2416 "../lib/Widgets/SourceList.vala"
				_tmp12_ = granite_widgets_source_list_item_get_icon (_tmp11_);
#line 2416 "../lib/Widgets/SourceList.vala"
				_tmp13_ = _tmp12_;
#line 2416 "../lib/Widgets/SourceList.vala"
				_tmp14_ = _g_object_ref0 (_tmp13_);
#line 2416 "../lib/Widgets/SourceList.vala"
				_g_object_unref0 (icon);
#line 2416 "../lib/Widgets/SourceList.vala"
				icon = _tmp14_;
#line 12768 "SourceList.c"
			} else {
				GraniteWidgetsSourceListCellRendererIcon* _tmp15_;
				GraniteWidgetsSourceListCellRendererIcon* _tmp16_;
#line 2417 "../lib/Widgets/SourceList.vala"
				_tmp15_ = icon_renderer;
#line 2417 "../lib/Widgets/SourceList.vala"
				_tmp16_ = self->priv->activatable_cell;
#line 2417 "../lib/Widgets/SourceList.vala"
				if (_tmp15_ == _tmp16_) {
#line 12778 "SourceList.c"
					GraniteWidgetsSourceListItem* _tmp17_;
					GIcon* _tmp18_;
					GIcon* _tmp19_;
					GIcon* _tmp20_;
#line 2418 "../lib/Widgets/SourceList.vala"
					_tmp17_ = item;
#line 2418 "../lib/Widgets/SourceList.vala"
					_tmp18_ = granite_widgets_source_list_item_get_activatable (_tmp17_);
#line 2418 "../lib/Widgets/SourceList.vala"
					_tmp19_ = _tmp18_;
#line 2418 "../lib/Widgets/SourceList.vala"
					_tmp20_ = _g_object_ref0 (_tmp19_);
#line 2418 "../lib/Widgets/SourceList.vala"
					_g_object_unref0 (icon);
#line 2418 "../lib/Widgets/SourceList.vala"
					icon = _tmp20_;
#line 12795 "SourceList.c"
				} else {
#line 2420 "../lib/Widgets/SourceList.vala"
					g_assert_not_reached ();
#line 12799 "SourceList.c"
				}
			}
		}
	}
#line 2424 "../lib/Widgets/SourceList.vala"
	_tmp22_ = visible;
#line 2424 "../lib/Widgets/SourceList.vala"
	if (_tmp22_) {
#line 12808 "SourceList.c"
		GIcon* _tmp23_;
#line 2424 "../lib/Widgets/SourceList.vala"
		_tmp23_ = icon;
#line 2424 "../lib/Widgets/SourceList.vala"
		_tmp21_ = _tmp23_ != NULL;
#line 12814 "SourceList.c"
	} else {
#line 2424 "../lib/Widgets/SourceList.vala"
		_tmp21_ = FALSE;
#line 12818 "SourceList.c"
	}
#line 2424 "../lib/Widgets/SourceList.vala"
	visible = _tmp21_;
#line 2426 "../lib/Widgets/SourceList.vala"
	_tmp24_ = icon_renderer;
#line 2426 "../lib/Widgets/SourceList.vala"
	_tmp25_ = visible;
#line 2426 "../lib/Widgets/SourceList.vala"
	gtk_cell_renderer_set_visible ((GtkCellRenderer*) _tmp24_, _tmp25_);
#line 2427 "../lib/Widgets/SourceList.vala"
	_tmp27_ = visible;
#line 2427 "../lib/Widgets/SourceList.vala"
	if (_tmp27_) {
#line 12832 "SourceList.c"
		GIcon* _tmp28_;
#line 2427 "../lib/Widgets/SourceList.vala"
		_tmp28_ = icon;
#line 2427 "../lib/Widgets/SourceList.vala"
		_tmp26_ = _tmp28_;
#line 12838 "SourceList.c"
	} else {
#line 2427 "../lib/Widgets/SourceList.vala"
		_tmp26_ = NULL;
#line 12842 "SourceList.c"
	}
#line 2427 "../lib/Widgets/SourceList.vala"
	_tmp29_ = icon_renderer;
#line 2427 "../lib/Widgets/SourceList.vala"
	g_object_set ((GtkCellRendererPixbuf*) _tmp29_, "gicon", _tmp26_, NULL);
#line 2400 "../lib/Widgets/SourceList.vala"
	_g_object_unref0 (item);
#line 2400 "../lib/Widgets/SourceList.vala"
	_g_object_unref0 (icon);
#line 2400 "../lib/Widgets/SourceList.vala"
	_g_object_unref0 (icon_renderer);
#line 12854 "SourceList.c"
}


/**
         * Controls expander visibility.
         */
static void
granite_widgets_source_list_tree_expander_cell_data_func (GraniteWidgetsSourceListTree* self,
                                                          GtkCellLayout* layout,
                                                          GtkCellRenderer* renderer,
                                                          GtkTreeModel* model,
                                                          GtkTreeIter* iter)
{
	GraniteWidgetsSourceListItem* item = NULL;
	GtkTreeIter _tmp0_;
	GraniteWidgetsSourceListItem* _tmp1_;
	GraniteWidgetsSourceListItem* _tmp2_;
	GraniteWidgetsCellRendererExpander* _tmp12_;
#line 2433 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 2433 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (layout != NULL);
#line 2433 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (renderer != NULL);
#line 2433 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (model != NULL);
#line 2433 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (iter != NULL);
#line 2436 "../lib/Widgets/SourceList.vala"
	_tmp0_ = *iter;
#line 2436 "../lib/Widgets/SourceList.vala"
	_tmp1_ = granite_widgets_source_list_tree_get_item_from_model (model, &_tmp0_);
#line 2436 "../lib/Widgets/SourceList.vala"
	item = _tmp1_;
#line 2437 "../lib/Widgets/SourceList.vala"
	_tmp2_ = item;
#line 2437 "../lib/Widgets/SourceList.vala"
	if (_tmp2_ != NULL) {
#line 12893 "SourceList.c"
		GraniteWidgetsSourceListExpandableItem* expandable_item = NULL;
		GraniteWidgetsSourceListItem* _tmp3_;
		GraniteWidgetsSourceListExpandableItem* _tmp4_;
		GraniteWidgetsSourceListExpandableItem* _tmp5_;
#line 2441 "../lib/Widgets/SourceList.vala"
		_tmp3_ = item;
#line 2441 "../lib/Widgets/SourceList.vala"
		_tmp4_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp3_, GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM) ? ((GraniteWidgetsSourceListExpandableItem*) _tmp3_) : NULL);
#line 2441 "../lib/Widgets/SourceList.vala"
		expandable_item = _tmp4_;
#line 2442 "../lib/Widgets/SourceList.vala"
		_tmp5_ = expandable_item;
#line 2442 "../lib/Widgets/SourceList.vala"
		if (_tmp5_ != NULL) {
#line 12908 "SourceList.c"
			gboolean _tmp6_ = FALSE;
			gboolean _tmp7_;
			gboolean _tmp8_;
#line 2443 "../lib/Widgets/SourceList.vala"
			g_object_get (renderer, "is-expander", &_tmp7_, NULL);
#line 2443 "../lib/Widgets/SourceList.vala"
			_tmp8_ = _tmp7_;
#line 2443 "../lib/Widgets/SourceList.vala"
			if (_tmp8_) {
#line 12918 "SourceList.c"
				GraniteWidgetsSourceListExpandableItem* _tmp9_;
				gboolean _tmp10_;
				gboolean _tmp11_;
#line 2443 "../lib/Widgets/SourceList.vala"
				_tmp9_ = expandable_item;
#line 2443 "../lib/Widgets/SourceList.vala"
				_tmp10_ = granite_widgets_source_list_expandable_item_get_collapsible (_tmp9_);
#line 2443 "../lib/Widgets/SourceList.vala"
				_tmp11_ = _tmp10_;
#line 2443 "../lib/Widgets/SourceList.vala"
				_tmp6_ = _tmp11_;
#line 12930 "SourceList.c"
			} else {
#line 2443 "../lib/Widgets/SourceList.vala"
				_tmp6_ = FALSE;
#line 12934 "SourceList.c"
			}
#line 2443 "../lib/Widgets/SourceList.vala"
			g_object_set (renderer, "is-expander", _tmp6_, NULL);
#line 12938 "SourceList.c"
		}
#line 2437 "../lib/Widgets/SourceList.vala"
		_g_object_unref0 (expandable_item);
#line 12942 "SourceList.c"
	}
#line 2446 "../lib/Widgets/SourceList.vala"
	_tmp12_ = self->priv->primary_expander_cell;
#line 2446 "../lib/Widgets/SourceList.vala"
	if (renderer == G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, gtk_cell_renderer_get_type (), GtkCellRenderer)) {
#line 12948 "SourceList.c"
		GraniteWidgetsSourceListDataModel* _tmp13_;
		GtkTreeIter _tmp14_;
#line 2447 "../lib/Widgets/SourceList.vala"
		_tmp13_ = self->priv->_data_model;
#line 2447 "../lib/Widgets/SourceList.vala"
		_tmp14_ = *iter;
#line 2447 "../lib/Widgets/SourceList.vala"
		gtk_cell_renderer_set_visible (renderer, !granite_widgets_source_list_data_model_is_iter_at_root_level (_tmp13_, &_tmp14_));
#line 12957 "SourceList.c"
	} else {
		GraniteWidgetsCellRendererExpander* _tmp15_;
#line 2448 "../lib/Widgets/SourceList.vala"
		_tmp15_ = self->priv->secondary_expander_cell;
#line 2448 "../lib/Widgets/SourceList.vala"
		if (renderer == G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, gtk_cell_renderer_get_type (), GtkCellRenderer)) {
#line 12964 "SourceList.c"
			GraniteWidgetsSourceListDataModel* _tmp16_;
			GraniteWidgetsSourceListItem* _tmp17_;
			GtkTreeIter _tmp18_;
#line 2449 "../lib/Widgets/SourceList.vala"
			_tmp16_ = self->priv->_data_model;
#line 2449 "../lib/Widgets/SourceList.vala"
			_tmp17_ = item;
#line 2449 "../lib/Widgets/SourceList.vala"
			_tmp18_ = *iter;
#line 2449 "../lib/Widgets/SourceList.vala"
			gtk_cell_renderer_set_visible (renderer, granite_widgets_source_list_data_model_is_category (_tmp16_, _tmp17_, &_tmp18_, NULL));
#line 12976 "SourceList.c"
		} else {
#line 2451 "../lib/Widgets/SourceList.vala"
			g_assert_not_reached ();
#line 12980 "SourceList.c"
		}
	}
#line 2433 "../lib/Widgets/SourceList.vala"
	_g_object_unref0 (item);
#line 12985 "SourceList.c"
}


static GraniteWidgetsSourceListDataModel*
granite_widgets_source_list_tree_get_data_model (GraniteWidgetsSourceListTree* self)
{
	GraniteWidgetsSourceListDataModel* result;
	GraniteWidgetsSourceListDataModel* _tmp0_;
#line 1537 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1537 "../lib/Widgets/SourceList.vala"
	_tmp0_ = self->priv->_data_model;
#line 1537 "../lib/Widgets/SourceList.vala"
	result = _tmp0_;
#line 1537 "../lib/Widgets/SourceList.vala"
	return result;
#line 13002 "SourceList.c"
}


static void
granite_widgets_source_list_tree_set_data_model (GraniteWidgetsSourceListTree* self,
                                                 GraniteWidgetsSourceListDataModel* value)
{
#line 1537 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 1537 "../lib/Widgets/SourceList.vala"
	if (granite_widgets_source_list_tree_get_data_model (self) != value) {
#line 13014 "SourceList.c"
		GraniteWidgetsSourceListDataModel* _tmp0_;
#line 1537 "../lib/Widgets/SourceList.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 1537 "../lib/Widgets/SourceList.vala"
		_g_object_unref0 (self->priv->_data_model);
#line 1537 "../lib/Widgets/SourceList.vala"
		self->priv->_data_model = _tmp0_;
#line 1537 "../lib/Widgets/SourceList.vala"
		g_object_notify_by_pspec ((GObject *) self, granite_widgets_source_list_tree_properties[GRANITE_WIDGETS_SOURCE_LIST_TREE_DATA_MODEL_PROPERTY]);
#line 13024 "SourceList.c"
	}
}


static GraniteWidgetsSourceListItem*
granite_widgets_source_list_tree_get_selected_item (GraniteWidgetsSourceListTree* self)
{
	GraniteWidgetsSourceListItem* result;
	GraniteWidgetsSourceListItem* _tmp0_;
#line 1542 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1542 "../lib/Widgets/SourceList.vala"
	_tmp0_ = self->priv->selected;
#line 1542 "../lib/Widgets/SourceList.vala"
	result = _tmp0_;
#line 1542 "../lib/Widgets/SourceList.vala"
	return result;
#line 13042 "SourceList.c"
}


static void
granite_widgets_source_list_tree_set_selected_item (GraniteWidgetsSourceListTree* self,
                                                    GraniteWidgetsSourceListItem* value)
{
#line 1543 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 1543 "../lib/Widgets/SourceList.vala"
	granite_widgets_source_list_tree_set_selected (self, value, TRUE);
#line 1543 "../lib/Widgets/SourceList.vala"
	g_object_notify_by_pspec ((GObject *) self, granite_widgets_source_list_tree_properties[GRANITE_WIDGETS_SOURCE_LIST_TREE_SELECTED_ITEM_PROPERTY]);
#line 13056 "SourceList.c"
}


static gboolean
granite_widgets_source_list_tree_get_editing (GraniteWidgetsSourceListTree* self)
{
	gboolean result;
	GtkCellRendererText* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 1547 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1547 "../lib/Widgets/SourceList.vala"
	_tmp0_ = self->priv->text_cell;
#line 1547 "../lib/Widgets/SourceList.vala"
	g_object_get ((GtkCellRenderer*) _tmp0_, "editing", &_tmp1_, NULL);
#line 1547 "../lib/Widgets/SourceList.vala"
	_tmp2_ = _tmp1_;
#line 1547 "../lib/Widgets/SourceList.vala"
	result = _tmp2_;
#line 1547 "../lib/Widgets/SourceList.vala"
	return result;
#line 13079 "SourceList.c"
}


static PangoEllipsizeMode
granite_widgets_source_list_tree_get_ellipsize_mode (GraniteWidgetsSourceListTree* self)
{
	PangoEllipsizeMode result;
	GtkCellRendererText* _tmp0_;
	PangoEllipsizeMode _tmp1_;
	PangoEllipsizeMode _tmp2_;
#line 1551 "../lib/Widgets/SourceList.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 1551 "../lib/Widgets/SourceList.vala"
	_tmp0_ = self->priv->text_cell;
#line 1551 "../lib/Widgets/SourceList.vala"
	g_object_get (_tmp0_, "ellipsize", &_tmp1_, NULL);
#line 1551 "../lib/Widgets/SourceList.vala"
	_tmp2_ = _tmp1_;
#line 1551 "../lib/Widgets/SourceList.vala"
	result = _tmp2_;
#line 1551 "../lib/Widgets/SourceList.vala"
	return result;
#line 13102 "SourceList.c"
}


static void
granite_widgets_source_list_tree_set_ellipsize_mode (GraniteWidgetsSourceListTree* self,
                                                     PangoEllipsizeMode value)
{
	GtkCellRendererText* _tmp0_;
#line 1552 "../lib/Widgets/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 1552 "../lib/Widgets/SourceList.vala"
	_tmp0_ = self->priv->text_cell;
#line 1552 "../lib/Widgets/SourceList.vala"
	g_object_set (_tmp0_, "ellipsize", value, NULL);
#line 1552 "../lib/Widgets/SourceList.vala"
	g_object_notify_by_pspec ((GObject *) self, granite_widgets_source_list_tree_properties[GRANITE_WIDGETS_SOURCE_LIST_TREE_ELLIPSIZE_MODE_PROPERTY]);
#line 13119 "SourceList.c"
}


static void
_granite_widgets_source_list_tree_expander_cell_data_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout,
                                                                                     GtkCellRenderer* cell,
                                                                                     GtkTreeModel* tree_model,
                                                                                     GtkTreeIter* iter,
                                                                                     gpointer self)
{
#line 1642 "../lib/Widgets/SourceList.vala"
	granite_widgets_source_list_tree_expander_cell_data_func ((GraniteWidgetsSourceListTree*) self, cell_layout, cell, tree_model, iter);
#line 13132 "SourceList.c"
}


static void
_granite_widgets_source_list_tree_on_activatable_activated_granite_widgets_source_list_cell_renderer_icon_activated (GraniteWidgetsSourceListCellRendererIcon* _sender,
                                                                                                                     const gchar* path,
                                                                                                                     gpointer self)
{
#line 1646 "../lib/Widgets/SourceList.vala"
	granite_widgets_source_list_tree_on_activatable_activated ((GraniteWidgetsSourceListTree*) self, path);
#line 13143 "SourceList.c"
}


static void
_granite_widgets_source_list_tree_icon_cell_data_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout,
                                                                                 GtkCellRenderer* cell,
                                                                                 GtkTreeModel* tree_model,
                                                                                 GtkTreeIter* iter,
                                                                                 gpointer self)
{
#line 1648 "../lib/Widgets/SourceList.vala"
	granite_widgets_source_list_tree_icon_cell_data_func ((GraniteWidgetsSourceListTree*) self, cell_layout, cell, tree_model, iter);
#line 13156 "SourceList.c"
}


static void
_granite_widgets_source_list_tree_badge_cell_data_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout,
                                                                                  GtkCellRenderer* cell,
                                                                                  GtkTreeModel* tree_model,
                                                                                  GtkTreeIter* iter,
                                                                                  gpointer self)
{
#line 1654 "../lib/Widgets/SourceList.vala"
	granite_widgets_source_list_tree_badge_cell_data_func ((GraniteWidgetsSourceListTree*) self, cell_layout, cell, tree_model, iter);
#line 13169 "SourceList.c"
}


static void
_granite_widgets_source_list_tree_on_editing_started_gtk_cell_renderer_editing_started (GtkCellRenderer* _sender,
                                                                                        GtkCellEditable* editable,
                                                                                        const gchar* path,
                                                                                        gpointer self)
{
#line 1659 "../lib/Widgets/SourceList.vala"
	granite_widgets_source_list_tree_on_editing_started ((GraniteWidgetsSourceListTree*) self, editable, path);
#line 13181 "SourceList.c"
}


static void
_granite_widgets_source_list_tree_on_editing_canceled_gtk_cell_renderer_editing_canceled (GtkCellRenderer* _sender,
                                                                                          gpointer self)
{
#line 1660 "../lib/Widgets/SourceList.vala"
	granite_widgets_source_list_tree_on_editing_canceled ((GraniteWidgetsSourceListTree*) self);
#line 13191 "SourceList.c"
}


static void
_granite_widgets_source_list_tree_name_cell_data_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout,
                                                                                 GtkCellRenderer* cell,
                                                                                 GtkTreeModel* tree_model,
                                                                                 GtkTreeIter* iter,
                                                                                 gpointer self)
{
#line 1664 "../lib/Widgets/SourceList.vala"
	granite_widgets_source_list_tree_name_cell_data_func ((GraniteWidgetsSourceListTree*) self, cell_layout, cell, tree_model, iter);
#line 13204 "SourceList.c"
}


static gboolean
_granite_widgets_source_list_tree_select_func_gtk_tree_selection_func (GtkTreeSelection* selection,
                                                                       GtkTreeModel* model,
                                                                       GtkTreePath* path,
                                                                       gboolean path_currently_selected,
                                                                       gpointer self)
{
	gboolean result;
	result = granite_widgets_source_list_tree_select_func ((GraniteWidgetsSourceListTree*) self, selection, model, path, path_currently_selected);
#line 1684 "../lib/Widgets/SourceList.vala"
	return result;
#line 13219 "SourceList.c"
}


static GObject *
granite_widgets_source_list_tree_constructor (GType type,
                                              guint n_construct_properties,
                                              GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GraniteWidgetsSourceListTree * self;
	GtkCssProvider* _tmp0_;
	GtkCssProvider* _tmp1_;
	GraniteWidgetsSourceListDataModel* _tmp2_;
	GtkTreeViewColumn* item_column = NULL;
	GtkTreeViewColumn* _tmp3_;
	GtkTreeViewColumn* _tmp4_;
	GtkTreeViewColumn* _tmp5_;
	GraniteWidgetsCellRendererExpander* _tmp6_;
	GraniteWidgetsCellRendererExpander* _tmp7_;
	GraniteWidgetsCellRendererExpander* _tmp8_;
	GtkTreeViewColumn* _tmp9_;
	GraniteWidgetsCellRendererExpander* _tmp10_;
	GtkTreeViewColumn* _tmp11_;
	GraniteWidgetsCellRendererExpander* _tmp12_;
	GraniteWidgetsSourceListCellRendererIcon* _tmp13_;
	GraniteWidgetsSourceListCellRendererIcon* _tmp14_;
	GraniteWidgetsSourceListCellRendererIcon* _tmp15_;
	GtkTreeViewColumn* _tmp16_;
	GraniteWidgetsSourceListCellRendererIcon* _tmp17_;
	GtkTreeViewColumn* _tmp18_;
	GraniteWidgetsSourceListCellRendererIcon* _tmp19_;
	GraniteWidgetsCellRendererBadge* _tmp20_;
	GraniteWidgetsCellRendererBadge* _tmp21_;
	GraniteWidgetsCellRendererBadge* _tmp22_;
	GtkTreeViewColumn* _tmp23_;
	GraniteWidgetsCellRendererBadge* _tmp24_;
	GtkTreeViewColumn* _tmp25_;
	GraniteWidgetsCellRendererBadge* _tmp26_;
	GtkCellRendererText* _tmp27_;
	GtkCellRendererText* _tmp28_;
	GtkCellRendererText* _tmp29_;
	GtkCellRendererText* _tmp30_;
	GtkCellRendererText* _tmp31_;
	GtkCellRendererText* _tmp32_;
	GtkCellRendererText* _tmp33_;
	GtkTreeViewColumn* _tmp34_;
	GtkCellRendererText* _tmp35_;
	GtkTreeViewColumn* _tmp36_;
	GtkCellRendererText* _tmp37_;
	GraniteWidgetsSourceListCellRendererIcon* _tmp38_;
	GraniteWidgetsSourceListCellRendererIcon* _tmp39_;
	GtkTreeViewColumn* _tmp40_;
	GraniteWidgetsSourceListCellRendererIcon* _tmp41_;
	GtkTreeViewColumn* _tmp42_;
	GraniteWidgetsSourceListCellRendererIcon* _tmp43_;
	GraniteWidgetsCellRendererExpander* _tmp44_;
	gint expander_spacing = 0;
	gint _tmp45_ = 0;
	GraniteWidgetsCellRendererExpander* _tmp46_;
	gint _tmp47_;
	GtkTreeViewColumn* _tmp48_;
	GraniteWidgetsCellRendererExpander* _tmp49_;
	GtkTreeViewColumn* _tmp50_;
	GraniteWidgetsCellRendererExpander* _tmp51_;
	GtkTreeSelection* selection = NULL;
	GtkTreeSelection* _tmp52_;
	GtkTreeSelection* _tmp53_;
	GtkTreeSelection* _tmp54_;
	GtkTreeSelection* _tmp55_;
#line 1610 "../lib/Widgets/SourceList.vala"
	parent_class = G_OBJECT_CLASS (granite_widgets_source_list_tree_parent_class);
#line 1610 "../lib/Widgets/SourceList.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 1610 "../lib/Widgets/SourceList.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GRANITE_WIDGETS_SOURCE_LIST_TYPE_TREE, GraniteWidgetsSourceListTree);
#line 1611 "../lib/Widgets/SourceList.vala"
	_tmp0_ = granite_widgets_utils_set_theming ((GtkWidget*) self, GRANITE_WIDGETS_SOURCE_LIST_TREE_DEFAULT_STYLESHEET, GRANITE_STYLE_CLASS_SOURCE_LIST, GTK_STYLE_PROVIDER_PRIORITY_FALLBACK);
#line 1611 "../lib/Widgets/SourceList.vala"
	_tmp1_ = _tmp0_;
#line 1611 "../lib/Widgets/SourceList.vala"
	_g_object_unref0 (_tmp1_);
#line 1614 "../lib/Widgets/SourceList.vala"
	_tmp2_ = self->priv->_data_model;
#line 1614 "../lib/Widgets/SourceList.vala"
	gtk_tree_view_set_model ((GtkTreeView*) self, (GtkTreeModel*) _tmp2_);
#line 1616 "../lib/Widgets/SourceList.vala"
	gtk_widget_set_valign ((GtkWidget*) self, GTK_ALIGN_FILL);
#line 1616 "../lib/Widgets/SourceList.vala"
	gtk_widget_set_halign ((GtkWidget*) self, GTK_ALIGN_FILL);
#line 1617 "../lib/Widgets/SourceList.vala"
	g_object_set ((GtkWidget*) self, "expand", TRUE, NULL);
#line 1619 "../lib/Widgets/SourceList.vala"
	gtk_tree_view_set_enable_search ((GtkTreeView*) self, FALSE);
#line 1620 "../lib/Widgets/SourceList.vala"
	gtk_tree_view_set_headers_visible ((GtkTreeView*) self, FALSE);
#line 1621 "../lib/Widgets/SourceList.vala"
	g_object_set ((GtkTreeView*) self, "enable-grid-lines", GTK_TREE_VIEW_GRID_LINES_NONE, NULL);
#line 1624 "../lib/Widgets/SourceList.vala"
	gtk_tree_view_set_expander_column ((GtkTreeView*) self, NULL);
#line 1625 "../lib/Widgets/SourceList.vala"
	gtk_tree_view_set_show_expanders ((GtkTreeView*) self, FALSE);
#line 1627 "../lib/Widgets/SourceList.vala"
	_tmp3_ = gtk_tree_view_column_new ();
#line 1627 "../lib/Widgets/SourceList.vala"
	g_object_ref_sink (_tmp3_);
#line 1627 "../lib/Widgets/SourceList.vala"
	item_column = _tmp3_;
#line 1628 "../lib/Widgets/SourceList.vala"
	_tmp4_ = item_column;
#line 1628 "../lib/Widgets/SourceList.vala"
	gtk_tree_view_column_set_expand (_tmp4_, TRUE);
#line 1630 "../lib/Widgets/SourceList.vala"
	_tmp5_ = item_column;
#line 1630 "../lib/Widgets/SourceList.vala"
	gtk_tree_view_insert_column ((GtkTreeView*) self, _tmp5_, (gint) GRANITE_WIDGETS_SOURCE_LIST_TREE_COLUMN_ITEM);
#line 1638 "../lib/Widgets/SourceList.vala"
	_tmp6_ = granite_widgets_cell_renderer_expander_new ();
#line 1638 "../lib/Widgets/SourceList.vala"
	g_object_ref_sink (_tmp6_);
#line 1638 "../lib/Widgets/SourceList.vala"
	_g_object_unref0 (self->priv->secondary_expander_cell);
#line 1638 "../lib/Widgets/SourceList.vala"
	self->priv->secondary_expander_cell = _tmp6_;
#line 1639 "../lib/Widgets/SourceList.vala"
	_tmp7_ = self->priv->secondary_expander_cell;
#line 1639 "../lib/Widgets/SourceList.vala"
	granite_widgets_cell_renderer_expander_set_is_category_expander (_tmp7_, TRUE);
#line 1640 "../lib/Widgets/SourceList.vala"
	_tmp8_ = self->priv->secondary_expander_cell;
#line 1640 "../lib/Widgets/SourceList.vala"
	g_object_set ((GtkCellRenderer*) _tmp8_, "xpad", (guint) 10, NULL);
#line 1641 "../lib/Widgets/SourceList.vala"
	_tmp9_ = item_column;
#line 1641 "../lib/Widgets/SourceList.vala"
	_tmp10_ = self->priv->secondary_expander_cell;
#line 1641 "../lib/Widgets/SourceList.vala"
	gtk_cell_layout_pack_end ((GtkCellLayout*) _tmp9_, (GtkCellRenderer*) _tmp10_, FALSE);
#line 1642 "../lib/Widgets/SourceList.vala"
	_tmp11_ = item_column;
#line 1642 "../lib/Widgets/SourceList.vala"
	_tmp12_ = self->priv->secondary_expander_cell;
#line 1642 "../lib/Widgets/SourceList.vala"
	gtk_cell_layout_set_cell_data_func ((GtkCellLayout*) _tmp11_, (GtkCellRenderer*) _tmp12_, _granite_widgets_source_list_tree_expander_cell_data_func_gtk_cell_layout_data_func, g_object_ref (self), g_object_unref);
#line 1644 "../lib/Widgets/SourceList.vala"
	_tmp13_ = granite_widgets_source_list_cell_renderer_icon_new ();
#line 1644 "../lib/Widgets/SourceList.vala"
	g_object_ref_sink (_tmp13_);
#line 1644 "../lib/Widgets/SourceList.vala"
	_g_object_unref0 (self->priv->activatable_cell);
#line 1644 "../lib/Widgets/SourceList.vala"
	self->priv->activatable_cell = _tmp13_;
#line 1645 "../lib/Widgets/SourceList.vala"
	_tmp14_ = self->priv->activatable_cell;
#line 1645 "../lib/Widgets/SourceList.vala"
	g_object_set ((GtkCellRenderer*) _tmp14_, "xpad", (guint) 6, NULL);
#line 1646 "../lib/Widgets/SourceList.vala"
	_tmp15_ = self->priv->activatable_cell;
#line 1646 "../lib/Widgets/SourceList.vala"
	g_signal_connect_object (_tmp15_, "activated", (GCallback) _granite_widgets_source_list_tree_on_activatable_activated_granite_widgets_source_list_cell_renderer_icon_activated, self, 0);
#line 1647 "../lib/Widgets/SourceList.vala"
	_tmp16_ = item_column;
#line 1647 "../lib/Widgets/SourceList.vala"
	_tmp17_ = self->priv->activatable_cell;
#line 1647 "../lib/Widgets/SourceList.vala"
	gtk_cell_layout_pack_end ((GtkCellLayout*) _tmp16_, (GtkCellRenderer*) _tmp17_, FALSE);
#line 1648 "../lib/Widgets/SourceList.vala"
	_tmp18_ = item_column;
#line 1648 "../lib/Widgets/SourceList.vala"
	_tmp19_ = self->priv->activatable_cell;
#line 1648 "../lib/Widgets/SourceList.vala"
	gtk_cell_layout_set_cell_data_func ((GtkCellLayout*) _tmp18_, (GtkCellRenderer*) _tmp19_, _granite_widgets_source_list_tree_icon_cell_data_func_gtk_cell_layout_data_func, g_object_ref (self), g_object_unref);
#line 1650 "../lib/Widgets/SourceList.vala"
	_tmp20_ = granite_widgets_cell_renderer_badge_new ();
#line 1650 "../lib/Widgets/SourceList.vala"
	g_object_ref_sink (_tmp20_);
#line 1650 "../lib/Widgets/SourceList.vala"
	_g_object_unref0 (self->priv->badge_cell);
#line 1650 "../lib/Widgets/SourceList.vala"
	self->priv->badge_cell = _tmp20_;
#line 1651 "../lib/Widgets/SourceList.vala"
	_tmp21_ = self->priv->badge_cell;
#line 1651 "../lib/Widgets/SourceList.vala"
	g_object_set ((GtkCellRenderer*) _tmp21_, "xpad", (guint) 1, NULL);
#line 1652 "../lib/Widgets/SourceList.vala"
	_tmp22_ = self->priv->badge_cell;
#line 1652 "../lib/Widgets/SourceList.vala"
	g_object_set ((GtkCellRenderer*) _tmp22_, "xalign", (gfloat) 1, NULL);
#line 1653 "../lib/Widgets/SourceList.vala"
	_tmp23_ = item_column;
#line 1653 "../lib/Widgets/SourceList.vala"
	_tmp24_ = self->priv->badge_cell;
#line 1653 "../lib/Widgets/SourceList.vala"
	gtk_cell_layout_pack_end ((GtkCellLayout*) _tmp23_, (GtkCellRenderer*) _tmp24_, FALSE);
#line 1654 "../lib/Widgets/SourceList.vala"
	_tmp25_ = item_column;
#line 1654 "../lib/Widgets/SourceList.vala"
	_tmp26_ = self->priv->badge_cell;
#line 1654 "../lib/Widgets/SourceList.vala"
	gtk_cell_layout_set_cell_data_func ((GtkCellLayout*) _tmp25_, (GtkCellRenderer*) _tmp26_, _granite_widgets_source_list_tree_badge_cell_data_func_gtk_cell_layout_data_func, g_object_ref (self), g_object_unref);
#line 1656 "../lib/Widgets/SourceList.vala"
	_tmp27_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
#line 1656 "../lib/Widgets/SourceList.vala"
	g_object_ref_sink (_tmp27_);
#line 1656 "../lib/Widgets/SourceList.vala"
	_g_object_unref0 (self->priv->text_cell);
#line 1656 "../lib/Widgets/SourceList.vala"
	self->priv->text_cell = _tmp27_;
#line 1657 "../lib/Widgets/SourceList.vala"
	_tmp28_ = self->priv->text_cell;
#line 1657 "../lib/Widgets/SourceList.vala"
	g_object_set (_tmp28_, "editable-set", TRUE, NULL);
#line 1658 "../lib/Widgets/SourceList.vala"
	_tmp29_ = self->priv->text_cell;
#line 1658 "../lib/Widgets/SourceList.vala"
	g_object_set (_tmp29_, "editable", FALSE, NULL);
#line 1659 "../lib/Widgets/SourceList.vala"
	_tmp30_ = self->priv->text_cell;
#line 1659 "../lib/Widgets/SourceList.vala"
	g_signal_connect_object ((GtkCellRenderer*) _tmp30_, "editing-started", (GCallback) _granite_widgets_source_list_tree_on_editing_started_gtk_cell_renderer_editing_started, self, 0);
#line 1660 "../lib/Widgets/SourceList.vala"
	_tmp31_ = self->priv->text_cell;
#line 1660 "../lib/Widgets/SourceList.vala"
	g_signal_connect_object ((GtkCellRenderer*) _tmp31_, "editing-canceled", (GCallback) _granite_widgets_source_list_tree_on_editing_canceled_gtk_cell_renderer_editing_canceled, self, 0);
#line 1661 "../lib/Widgets/SourceList.vala"
	_tmp32_ = self->priv->text_cell;
#line 1661 "../lib/Widgets/SourceList.vala"
	g_object_set (_tmp32_, "ellipsize", PANGO_ELLIPSIZE_END, NULL);
#line 1662 "../lib/Widgets/SourceList.vala"
	_tmp33_ = self->priv->text_cell;
#line 1662 "../lib/Widgets/SourceList.vala"
	g_object_set ((GtkCellRenderer*) _tmp33_, "xalign", (gfloat) 0, NULL);
#line 1663 "../lib/Widgets/SourceList.vala"
	_tmp34_ = item_column;
#line 1663 "../lib/Widgets/SourceList.vala"
	_tmp35_ = self->priv->text_cell;
#line 1663 "../lib/Widgets/SourceList.vala"
	gtk_cell_layout_pack_end ((GtkCellLayout*) _tmp34_, (GtkCellRenderer*) _tmp35_, TRUE);
#line 1664 "../lib/Widgets/SourceList.vala"
	_tmp36_ = item_column;
#line 1664 "../lib/Widgets/SourceList.vala"
	_tmp37_ = self->priv->text_cell;
#line 1664 "../lib/Widgets/SourceList.vala"
	gtk_cell_layout_set_cell_data_func ((GtkCellLayout*) _tmp36_, (GtkCellRenderer*) _tmp37_, _granite_widgets_source_list_tree_name_cell_data_func_gtk_cell_layout_data_func, g_object_ref (self), g_object_unref);
#line 1666 "../lib/Widgets/SourceList.vala"
	_tmp38_ = granite_widgets_source_list_cell_renderer_icon_new ();
#line 1666 "../lib/Widgets/SourceList.vala"
	g_object_ref_sink (_tmp38_);
#line 1666 "../lib/Widgets/SourceList.vala"
	_g_object_unref0 (self->priv->icon_cell);
#line 1666 "../lib/Widgets/SourceList.vala"
	self->priv->icon_cell = _tmp38_;
#line 1667 "../lib/Widgets/SourceList.vala"
	_tmp39_ = self->priv->icon_cell;
#line 1667 "../lib/Widgets/SourceList.vala"
	g_object_set ((GtkCellRenderer*) _tmp39_, "xpad", (guint) 2, NULL);
#line 1668 "../lib/Widgets/SourceList.vala"
	_tmp40_ = item_column;
#line 1668 "../lib/Widgets/SourceList.vala"
	_tmp41_ = self->priv->icon_cell;
#line 1668 "../lib/Widgets/SourceList.vala"
	gtk_cell_layout_pack_end ((GtkCellLayout*) _tmp40_, (GtkCellRenderer*) _tmp41_, FALSE);
#line 1669 "../lib/Widgets/SourceList.vala"
	_tmp42_ = item_column;
#line 1669 "../lib/Widgets/SourceList.vala"
	_tmp43_ = self->priv->icon_cell;
#line 1669 "../lib/Widgets/SourceList.vala"
	gtk_cell_layout_set_cell_data_func ((GtkCellLayout*) _tmp42_, (GtkCellRenderer*) _tmp43_, _granite_widgets_source_list_tree_icon_cell_data_func_gtk_cell_layout_data_func, g_object_ref (self), g_object_unref);
#line 1672 "../lib/Widgets/SourceList.vala"
	_tmp44_ = granite_widgets_cell_renderer_expander_new ();
#line 1672 "../lib/Widgets/SourceList.vala"
	g_object_ref_sink (_tmp44_);
#line 1672 "../lib/Widgets/SourceList.vala"
	_g_object_unref0 (self->priv->primary_expander_cell);
#line 1672 "../lib/Widgets/SourceList.vala"
	self->priv->primary_expander_cell = _tmp44_;
#line 1675 "../lib/Widgets/SourceList.vala"
	gtk_widget_style_get ((GtkWidget*) self, GRANITE_WIDGETS_SOURCE_LIST_TREE_STYLE_PROP_EXPANDER_SPACING, &_tmp45_, NULL);
#line 1675 "../lib/Widgets/SourceList.vala"
	expander_spacing = _tmp45_;
#line 1676 "../lib/Widgets/SourceList.vala"
	_tmp46_ = self->priv->primary_expander_cell;
#line 1676 "../lib/Widgets/SourceList.vala"
	_tmp47_ = expander_spacing;
#line 1676 "../lib/Widgets/SourceList.vala"
	g_object_set ((GtkCellRenderer*) _tmp46_, "xpad", (guint) (_tmp47_ / 2), NULL);
#line 1678 "../lib/Widgets/SourceList.vala"
	_tmp48_ = item_column;
#line 1678 "../lib/Widgets/SourceList.vala"
	_tmp49_ = self->priv->primary_expander_cell;
#line 1678 "../lib/Widgets/SourceList.vala"
	gtk_cell_layout_pack_end ((GtkCellLayout*) _tmp48_, (GtkCellRenderer*) _tmp49_, FALSE);
#line 1679 "../lib/Widgets/SourceList.vala"
	_tmp50_ = item_column;
#line 1679 "../lib/Widgets/SourceList.vala"
	_tmp51_ = self->priv->primary_expander_cell;
#line 1679 "../lib/Widgets/SourceList.vala"
	gtk_cell_layout_set_cell_data_func ((GtkCellLayout*) _tmp50_, (GtkCellRenderer*) _tmp51_, _granite_widgets_source_list_tree_expander_cell_data_func_gtk_cell_layout_data_func, g_object_ref (self), g_object_unref);
#line 1682 "../lib/Widgets/SourceList.vala"
	_tmp52_ = gtk_tree_view_get_selection ((GtkTreeView*) self);
#line 1682 "../lib/Widgets/SourceList.vala"
	_tmp53_ = _g_object_ref0 (_tmp52_);
#line 1682 "../lib/Widgets/SourceList.vala"
	selection = _tmp53_;
#line 1683 "../lib/Widgets/SourceList.vala"
	_tmp54_ = selection;
#line 1683 "../lib/Widgets/SourceList.vala"
	gtk_tree_selection_set_mode (_tmp54_, GTK_SELECTION_BROWSE);
#line 1684 "../lib/Widgets/SourceList.vala"
	_tmp55_ = selection;
#line 1684 "../lib/Widgets/SourceList.vala"
	gtk_tree_selection_set_select_function (_tmp55_, _granite_widgets_source_list_tree_select_func_gtk_tree_selection_func, g_object_ref (self), g_object_unref);
#line 1687 "../lib/Widgets/SourceList.vala"
	granite_widgets_source_list_tree_enable_item_property_monitor (self);
#line 1690 "../lib/Widgets/SourceList.vala"
	granite_widgets_source_list_tree_add_spacer_cell_for_level (self, 1, TRUE);
#line 1693 "../lib/Widgets/SourceList.vala"
	granite_widgets_source_list_tree_configure_drag_source (self, NULL, 0);
#line 1694 "../lib/Widgets/SourceList.vala"
	granite_widgets_source_list_tree_configure_drag_dest (self, NULL, 0, 0);
#line 1610 "../lib/Widgets/SourceList.vala"
	_g_object_unref0 (selection);
#line 1610 "../lib/Widgets/SourceList.vala"
	_g_object_unref0 (item_column);
#line 1610 "../lib/Widgets/SourceList.vala"
	return obj;
#line 13546 "SourceList.c"
}


static void
granite_widgets_source_list_tree_class_init (GraniteWidgetsSourceListTreeClass * klass)
{
	GParamSpecInt* _tmp0_;
	GParamSpecInt* _tmp1_;
	GParamSpecInt* _tmp2_;
	GParamSpecInt* _tmp3_;
	GParamSpecInt* _tmp4_;
	GParamSpecInt* _tmp5_;
#line 1535 "../lib/Widgets/SourceList.vala"
	granite_widgets_source_list_tree_parent_class = g_type_class_peek_parent (klass);
#line 1535 "../lib/Widgets/SourceList.vala"
	g_type_class_adjust_private_offset (klass, &GraniteWidgetsSourceListTree_private_offset);
#line 1535 "../lib/Widgets/SourceList.vala"
	((GtkWidgetClass *) klass)->drag_motion = (gboolean (*) (GtkWidget*, GdkDragContext*, gint, gint, guint)) granite_widgets_source_list_tree_real_drag_motion;
#line 1535 "../lib/Widgets/SourceList.vala"
	((GtkWidgetClass *) klass)->drag_data_received = (void (*) (GtkWidget*, GdkDragContext*, gint, gint, GtkSelectionData*, guint, guint)) granite_widgets_source_list_tree_real_drag_data_received;
#line 1535 "../lib/Widgets/SourceList.vala"
	((GtkTreeViewClass *) klass)->cursor_changed = (void (*) (GtkTreeView*)) granite_widgets_source_list_tree_real_cursor_changed;
#line 1535 "../lib/Widgets/SourceList.vala"
	((GtkTreeViewClass *) klass)->row_expanded = (void (*) (GtkTreeView*, GtkTreeIter*, GtkTreePath*)) granite_widgets_source_list_tree_real_row_expanded;
#line 1535 "../lib/Widgets/SourceList.vala"
	((GtkTreeViewClass *) klass)->row_collapsed = (void (*) (GtkTreeView*, GtkTreeIter*, GtkTreePath*)) granite_widgets_source_list_tree_real_row_collapsed;
#line 1535 "../lib/Widgets/SourceList.vala"
	((GtkTreeViewClass *) klass)->row_activated = (void (*) (GtkTreeView*, GtkTreePath*, GtkTreeViewColumn*)) granite_widgets_source_list_tree_real_row_activated;
#line 1535 "../lib/Widgets/SourceList.vala"
	((GtkWidgetClass *) klass)->key_release_event = (gboolean (*) (GtkWidget*, GdkEventKey*)) granite_widgets_source_list_tree_real_key_release_event;
#line 1535 "../lib/Widgets/SourceList.vala"
	((GtkWidgetClass *) klass)->button_release_event = (gboolean (*) (GtkWidget*, GdkEventButton*)) granite_widgets_source_list_tree_real_button_release_event;
#line 1535 "../lib/Widgets/SourceList.vala"
	((GtkWidgetClass *) klass)->button_press_event = (gboolean (*) (GtkWidget*, GdkEventButton*)) granite_widgets_source_list_tree_real_button_press_event;
#line 1535 "../lib/Widgets/SourceList.vala"
	((GtkWidgetClass *) klass)->popup_menu = (gboolean (*) (GtkWidget*)) granite_widgets_source_list_tree_real_popup_menu;
#line 1535 "../lib/Widgets/SourceList.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_granite_widgets_source_list_tree_get_property;
#line 1535 "../lib/Widgets/SourceList.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_granite_widgets_source_list_tree_set_property;
#line 1535 "../lib/Widgets/SourceList.vala"
	G_OBJECT_CLASS (klass)->constructor = granite_widgets_source_list_tree_constructor;
#line 1535 "../lib/Widgets/SourceList.vala"
	G_OBJECT_CLASS (klass)->finalize = granite_widgets_source_list_tree_finalize;
#line 1535 "../lib/Widgets/SourceList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_TREE_DATA_MODEL_PROPERTY, granite_widgets_source_list_tree_properties[GRANITE_WIDGETS_SOURCE_LIST_TREE_DATA_MODEL_PROPERTY] = g_param_spec_object ("data-model", "data-model", "data-model", GRANITE_WIDGETS_SOURCE_LIST_TYPE_DATA_MODEL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 1535 "../lib/Widgets/SourceList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_TREE_SELECTED_ITEM_PROPERTY, granite_widgets_source_list_tree_properties[GRANITE_WIDGETS_SOURCE_LIST_TREE_SELECTED_ITEM_PROPERTY] = g_param_spec_object ("selected-item", "selected-item", "selected-item", GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1535 "../lib/Widgets/SourceList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_TREE_EDITING_PROPERTY, granite_widgets_source_list_tree_properties[GRANITE_WIDGETS_SOURCE_LIST_TREE_EDITING_PROPERTY] = g_param_spec_boolean ("editing", "editing", "editing", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1535 "../lib/Widgets/SourceList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_TREE_ELLIPSIZE_MODE_PROPERTY, granite_widgets_source_list_tree_properties[GRANITE_WIDGETS_SOURCE_LIST_TREE_ELLIPSIZE_MODE_PROPERTY] = g_param_spec_enum ("ellipsize-mode", "ellipsize-mode", "ellipsize-mode", pango_ellipsize_mode_get_type (), 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1535 "../lib/Widgets/SourceList.vala"
	granite_widgets_source_list_tree_signals[GRANITE_WIDGETS_SOURCE_LIST_TREE_ITEM_SELECTED_SIGNAL] = g_signal_new ("item-selected", GRANITE_WIDGETS_SOURCE_LIST_TYPE_TREE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM);
#line 1587 "../lib/Widgets/SourceList.vala"
	_tmp0_ = g_param_spec_int (GRANITE_WIDGETS_SOURCE_LIST_TREE_STYLE_PROP_LEVEL_INDENTATION, "Level Indentation", "Space to add at the beginning of every indentation level. Must be an e" \
"ven number.", 1, 50, 6, G_PARAM_READABLE);
#line 1587 "../lib/Widgets/SourceList.vala"
	_tmp1_ = _tmp0_;
#line 1587 "../lib/Widgets/SourceList.vala"
	gtk_widget_class_install_style_property (GTK_WIDGET_CLASS (klass), (GParamSpec*) _tmp1_);
#line 1587 "../lib/Widgets/SourceList.vala"
	_g_param_spec_unref0 (_tmp1_);
#line 1593 "../lib/Widgets/SourceList.vala"
	_tmp2_ = g_param_spec_int (GRANITE_WIDGETS_SOURCE_LIST_TREE_STYLE_PROP_LEFT_PADDING, "Left Padding", "Padding added to the left side of the tree. Must be an even number.", 1, 50, 4, G_PARAM_READABLE);
#line 1593 "../lib/Widgets/SourceList.vala"
	_tmp3_ = _tmp2_;
#line 1593 "../lib/Widgets/SourceList.vala"
	gtk_widget_class_install_style_property (GTK_WIDGET_CLASS (klass), (GParamSpec*) _tmp3_);
#line 1593 "../lib/Widgets/SourceList.vala"
	_g_param_spec_unref0 (_tmp3_);
#line 1599 "../lib/Widgets/SourceList.vala"
	_tmp4_ = g_param_spec_int (GRANITE_WIDGETS_SOURCE_LIST_TREE_STYLE_PROP_EXPANDER_SPACING, "Expander Spacing", "Space added between an item and its expander. Must be an even number.", 1, 50, 4, G_PARAM_READABLE);
#line 1599 "../lib/Widgets/SourceList.vala"
	_tmp5_ = _tmp4_;
#line 1599 "../lib/Widgets/SourceList.vala"
	gtk_widget_class_install_style_property (GTK_WIDGET_CLASS (klass), (GParamSpec*) _tmp5_);
#line 1599 "../lib/Widgets/SourceList.vala"
	_g_param_spec_unref0 (_tmp5_);
#line 13625 "SourceList.c"
}


static void
granite_widgets_source_list_tree_instance_init (GraniteWidgetsSourceListTree * self)
{
#line 1535 "../lib/Widgets/SourceList.vala"
	self->priv = granite_widgets_source_list_tree_get_instance_private (self);
#line 1571 "../lib/Widgets/SourceList.vala"
	self->priv->unselectable_item_clicked = FALSE;
#line 13636 "SourceList.c"
}


static void
granite_widgets_source_list_tree_finalize (GObject * obj)
{
	GraniteWidgetsSourceListTree * self;
#line 1535 "../lib/Widgets/SourceList.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GRANITE_WIDGETS_SOURCE_LIST_TYPE_TREE, GraniteWidgetsSourceListTree);
#line 1698 "../lib/Widgets/SourceList.vala"
	granite_widgets_source_list_tree_disable_item_property_monitor (self);
#line 1537 "../lib/Widgets/SourceList.vala"
	_g_object_unref0 (self->priv->_data_model);
#line 1560 "../lib/Widgets/SourceList.vala"
	_g_object_unref0 (self->priv->selected);
#line 1563 "../lib/Widgets/SourceList.vala"
	_g_object_unref0 (self->priv->editable_entry);
#line 1564 "../lib/Widgets/SourceList.vala"
	_g_object_unref0 (self->priv->text_cell);
#line 1565 "../lib/Widgets/SourceList.vala"
	_g_object_unref0 (self->priv->icon_cell);
#line 1566 "../lib/Widgets/SourceList.vala"
	_g_object_unref0 (self->priv->activatable_cell);
#line 1567 "../lib/Widgets/SourceList.vala"
	_g_object_unref0 (self->priv->badge_cell);
#line 1568 "../lib/Widgets/SourceList.vala"
	_g_object_unref0 (self->priv->primary_expander_cell);
#line 1569 "../lib/Widgets/SourceList.vala"
	_g_object_unref0 (self->priv->secondary_expander_cell);
#line 1570 "../lib/Widgets/SourceList.vala"
	_g_object_unref0 (self->priv->spacer_cells);
#line 1535 "../lib/Widgets/SourceList.vala"
	G_OBJECT_CLASS (granite_widgets_source_list_tree_parent_class)->finalize (obj);
#line 13670 "SourceList.c"
}


/**
     * The tree that actually displays the items.
     *
     * All the user interaction happens here.
     */
static GType
granite_widgets_source_list_tree_get_type (void)
{
	static volatile gsize granite_widgets_source_list_tree_type_id__volatile = 0;
	if (g_once_init_enter (&granite_widgets_source_list_tree_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GraniteWidgetsSourceListTreeClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) granite_widgets_source_list_tree_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GraniteWidgetsSourceListTree), 0, (GInstanceInitFunc) granite_widgets_source_list_tree_instance_init, NULL };
		GType granite_widgets_source_list_tree_type_id;
		granite_widgets_source_list_tree_type_id = g_type_register_static (gtk_tree_view_get_type (), "GraniteWidgetsSourceListTree", &g_define_type_info, 0);
		GraniteWidgetsSourceListTree_private_offset = g_type_add_instance_private (granite_widgets_source_list_tree_type_id, sizeof (GraniteWidgetsSourceListTreePrivate));
		g_once_init_leave (&granite_widgets_source_list_tree_type_id__volatile, granite_widgets_source_list_tree_type_id);
	}
	return granite_widgets_source_list_tree_type_id__volatile;
}


static void
_vala_granite_widgets_source_list_tree_get_property (GObject * object,
                                                     guint property_id,
                                                     GValue * value,
                                                     GParamSpec * pspec)
{
	GraniteWidgetsSourceListTree * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GRANITE_WIDGETS_SOURCE_LIST_TYPE_TREE, GraniteWidgetsSourceListTree);
#line 1535 "../lib/Widgets/SourceList.vala"
	switch (property_id) {
#line 1535 "../lib/Widgets/SourceList.vala"
		case GRANITE_WIDGETS_SOURCE_LIST_TREE_DATA_MODEL_PROPERTY:
#line 1535 "../lib/Widgets/SourceList.vala"
		g_value_set_object (value, granite_widgets_source_list_tree_get_data_model (self));
#line 1535 "../lib/Widgets/SourceList.vala"
		break;
#line 1535 "../lib/Widgets/SourceList.vala"
		case GRANITE_WIDGETS_SOURCE_LIST_TREE_SELECTED_ITEM_PROPERTY:
#line 1535 "../lib/Widgets/SourceList.vala"
		g_value_set_object (value, granite_widgets_source_list_tree_get_selected_item (self));
#line 1535 "../lib/Widgets/SourceList.vala"
		break;
#line 1535 "../lib/Widgets/SourceList.vala"
		case GRANITE_WIDGETS_SOURCE_LIST_TREE_EDITING_PROPERTY:
#line 1535 "../lib/Widgets/SourceList.vala"
		g_value_set_boolean (value, granite_widgets_source_list_tree_get_editing (self));
#line 1535 "../lib/Widgets/SourceList.vala"
		break;
#line 1535 "../lib/Widgets/SourceList.vala"
		case GRANITE_WIDGETS_SOURCE_LIST_TREE_ELLIPSIZE_MODE_PROPERTY:
#line 1535 "../lib/Widgets/SourceList.vala"
		g_value_set_enum (value, granite_widgets_source_list_tree_get_ellipsize_mode (self));
#line 1535 "../lib/Widgets/SourceList.vala"
		break;
#line 13728 "SourceList.c"
		default:
#line 1535 "../lib/Widgets/SourceList.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 1535 "../lib/Widgets/SourceList.vala"
		break;
#line 13734 "SourceList.c"
	}
}


static void
_vala_granite_widgets_source_list_tree_set_property (GObject * object,
                                                     guint property_id,
                                                     const GValue * value,
                                                     GParamSpec * pspec)
{
	GraniteWidgetsSourceListTree * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GRANITE_WIDGETS_SOURCE_LIST_TYPE_TREE, GraniteWidgetsSourceListTree);
#line 1535 "../lib/Widgets/SourceList.vala"
	switch (property_id) {
#line 1535 "../lib/Widgets/SourceList.vala"
		case GRANITE_WIDGETS_SOURCE_LIST_TREE_DATA_MODEL_PROPERTY:
#line 1535 "../lib/Widgets/SourceList.vala"
		granite_widgets_source_list_tree_set_data_model (self, g_value_get_object (value));
#line 1535 "../lib/Widgets/SourceList.vala"
		break;
#line 1535 "../lib/Widgets/SourceList.vala"
		case GRANITE_WIDGETS_SOURCE_LIST_TREE_SELECTED_ITEM_PROPERTY:
#line 1535 "../lib/Widgets/SourceList.vala"
		granite_widgets_source_list_tree_set_selected_item (self, g_value_get_object (value));
#line 1535 "../lib/Widgets/SourceList.vala"
		break;
#line 1535 "../lib/Widgets/SourceList.vala"
		case GRANITE_WIDGETS_SOURCE_LIST_TREE_ELLIPSIZE_MODE_PROPERTY:
#line 1535 "../lib/Widgets/SourceList.vala"
		granite_widgets_source_list_tree_set_ellipsize_mode (self, g_value_get_enum (value));
#line 1535 "../lib/Widgets/SourceList.vala"
		break;
#line 13767 "SourceList.c"
		default:
#line 1535 "../lib/Widgets/SourceList.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 1535 "../lib/Widgets/SourceList.vala"
		break;
#line 13773 "SourceList.c"
	}
}


static void
granite_widgets_source_list_class_init (GraniteWidgetsSourceListClass * klass)
{
#line 233 "../lib/Widgets/SourceList.vala"
	granite_widgets_source_list_parent_class = g_type_class_peek_parent (klass);
#line 233 "../lib/Widgets/SourceList.vala"
	g_type_class_adjust_private_offset (klass, &GraniteWidgetsSourceList_private_offset);
#line 233 "../lib/Widgets/SourceList.vala"
	((GraniteWidgetsSourceListClass *) klass)->item_selected = granite_widgets_source_list_real_item_selected;
#line 233 "../lib/Widgets/SourceList.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_granite_widgets_source_list_get_property;
#line 233 "../lib/Widgets/SourceList.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_granite_widgets_source_list_set_property;
#line 233 "../lib/Widgets/SourceList.vala"
	G_OBJECT_CLASS (klass)->constructor = granite_widgets_source_list_constructor;
#line 233 "../lib/Widgets/SourceList.vala"
	G_OBJECT_CLASS (klass)->finalize = granite_widgets_source_list_finalize;
#line 13795 "SourceList.c"
	/**
	     * Root-level expandable item.
	     *
	     * This item contains the first-level source list items. It //only serves as an item container//.
	     * It is used to add and remove items to/from the widget.
	     *
	     * Internally, it allows the source list to connect to its {@link Granite.Widgets.SourceList.ExpandableItem.child_added}
	     * and {@link Granite.Widgets.SourceList.ExpandableItem.child_removed} signals in order to monitor
	     * new children additions/removals.
	     *
	     * @since 0.2
	     */
#line 233 "../lib/Widgets/SourceList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_ROOT_PROPERTY, granite_widgets_source_list_properties[GRANITE_WIDGETS_SOURCE_LIST_ROOT_PROPERTY] = g_param_spec_object ("root", "root", "root", GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 13810 "SourceList.c"
	/**
	     * The current selected item.
	     *
	     * Setting it to //null// un-selects the previously selected item, if there was any.
	     * {@link Granite.Widgets.SourceList.ExpandableItem.expand_with_parents} is called on the
	     * item's parent to make sure it's possible to select it.
	     *
	     * @since 0.2
	     */
#line 233 "../lib/Widgets/SourceList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_SELECTED_PROPERTY, granite_widgets_source_list_properties[GRANITE_WIDGETS_SOURCE_LIST_SELECTED_PROPERTY] = g_param_spec_object ("selected", "selected", "selected", GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 13822 "SourceList.c"
	/**
	     * Text ellipsize mode.
	     *
	     * @since 0.2
	     */
#line 233 "../lib/Widgets/SourceList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_ELLIPSIZE_MODE_PROPERTY, granite_widgets_source_list_properties[GRANITE_WIDGETS_SOURCE_LIST_ELLIPSIZE_MODE_PROPERTY] = g_param_spec_enum ("ellipsize-mode", "ellipsize-mode", "ellipsize-mode", pango_ellipsize_mode_get_type (), 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 13830 "SourceList.c"
	/**
	     * Whether an item is being edited.
	     *
	     * @see Granite.Widgets.SourceList.start_editing_item
	     * @since 0.2
	     */
#line 233 "../lib/Widgets/SourceList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_EDITING_PROPERTY, granite_widgets_source_list_properties[GRANITE_WIDGETS_SOURCE_LIST_EDITING_PROPERTY] = g_param_spec_boolean ("editing", "editing", "editing", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 13839 "SourceList.c"
	/**
	     * Emitted when the source list selection changes.
	     *
	     * @param item Selected item; //null// if nothing is selected.
	     * @since 0.2
	     */
#line 233 "../lib/Widgets/SourceList.vala"
	granite_widgets_source_list_signals[GRANITE_WIDGETS_SOURCE_LIST_ITEM_SELECTED_SIGNAL] = g_signal_new ("item-selected", GRANITE_WIDGETS_TYPE_SOURCE_LIST, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (GraniteWidgetsSourceListClass, item_selected), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM);
#line 13848 "SourceList.c"
}


static void
granite_widgets_source_list_instance_init (GraniteWidgetsSourceList * self)
{
	GraniteWidgetsSourceListDataModel* _tmp0_;
#line 233 "../lib/Widgets/SourceList.vala"
	self->priv = granite_widgets_source_list_get_instance_private (self);
#line 2543 "../lib/Widgets/SourceList.vala"
	_tmp0_ = granite_widgets_source_list_data_model_new ();
#line 2543 "../lib/Widgets/SourceList.vala"
	self->priv->data_model = _tmp0_;
#line 13862 "SourceList.c"
}


static void
granite_widgets_source_list_finalize (GObject * obj)
{
	GraniteWidgetsSourceList * self;
#line 233 "../lib/Widgets/SourceList.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GRANITE_WIDGETS_TYPE_SOURCE_LIST, GraniteWidgetsSourceList);
#line 2542 "../lib/Widgets/SourceList.vala"
	_g_object_unref0 (self->priv->tree);
#line 2543 "../lib/Widgets/SourceList.vala"
	_g_object_unref0 (self->priv->data_model);
#line 233 "../lib/Widgets/SourceList.vala"
	G_OBJECT_CLASS (granite_widgets_source_list_parent_class)->finalize (obj);
#line 13878 "SourceList.c"
}


/**
 * A widget that can display a list of items organized in categories.
 *
 * The source list widget consists of a collection of items, some of which are also expandable (and
 * thus can contain more items). All the items displayed in the source list are children of the widget's
 * root item. The API is meant to be used as follows:
 *
 * 1. Create the items you want to display in the source list, setting the appropriate values for their
 * properties. The desired hierarchy is achieved by creating expandable items and adding items to them.
 * These will be displayed as descendants in the widget's tree structure. The expandable items that are
 * not nested inside any other item are considered to be at root level, and should be added to
 * the widget's root item.<<BR>>
 *
 * Expandable items located at the root level are treated as categories, and only support text.
 *
 * ''Example''<<BR>>
 * The final tree will have the following structure:
 * {{{
 * Libraries
 *   Music
 * Stores
 *   My Store
 *      Music
 *      Podcasts
 * Devices
 *   Player 1
 *   Player 2
 * }}}
 *
 * {{{
 * var library_category = new Granite.Widgets.SourceList.ExpandableItem ("Libraries");
 * var store_category = new Granite.Widgets.SourceList.ExpandableItem ("Stores");
 * var device_category = new Granite.Widgets.SourceList.ExpandableItem ("Devices");
 *
 * var music_item = new Granite.Widgets.SourceList.Item ("Music");
 *
 * // "Libraries" will be the parent category of "Music"
 * library_category.add (music_item);
 *
 * // We plan to add sub-items to the store, so let's use an expandable item
 * var my_store_item = new Granite.Widgets.SourceList.ExpandableItem ("My Store");
 * store_category.add (my_store_item);
 *
 * var my_store_podcast_item = new Granite.Widgets.SourceList.Item ("Podcasts");
 * var my_store_music_item = new Granite.Widgets.SourceList.Item ("Music");
 *
 * my_store_item.add (my_store_music_item);
 * my_store_item.add (my_store_podcast_item);
 *
 * var player1_item = new Granite.Widgets.SourceList.Item ("Player 1");
 * var player2_item = new Granite.Widgets.SourceList.Item ("Player 2");
 *
 * device_category.add (player1_item);
 * device_category.add (player2_item);
 * }}}
 *
 * 2. Create a source list widget.<<BR>>
 * {{{
 * var source_list = new Granite.Widgets.SourceList ();
 * }}}
 *
 * 3. Add root-level items to the {@link Granite.Widgets.SourceList.root} item.
 * This item only serves as a container, and all its properties are ignored by the widget.
 *
 * {{{
 * // This will add the main categories (including their children) to the source list. After
 * // having being added to be widget, any other item added to any of these items
 * // (or any other child item in a deeper level) will be automatically added too.
 * // There's no need to deal with the source list widget directly.
 *
 * var root = source_list.root;
 *
 * root.add (library_category);
 * root.add (store_category);
 * root.add (device_category);
 * }}}
 *
 * The steps mentioned above are enough for initializing the source list. Future changes to the items'
 * properties are ''automatically'' reflected by the widget.
 *
 * Final steps would involve connecting handlers to the source list events, being
 * {@link Granite.Widgets.SourceList.item_selected} the most important, as it indicates that
 * the selection was modified.
 *
 * Pack the source list into the GUI using the {@link Gtk.Paned} widget. 
 * This is usually done as follows:
 * {{{
 * var pane = new Gtk.Paned (Gtk.Orientation.HORIZONTAL);
 * pane.pack1 (source_list, false, false);
 * pane.pack2 (content_area, true, false);
 * }}}
 *
 * @since 0.2
 * @see Gtk.Paned
 */
GType
granite_widgets_source_list_get_type (void)
{
	static volatile gsize granite_widgets_source_list_type_id__volatile = 0;
	if (g_once_init_enter (&granite_widgets_source_list_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GraniteWidgetsSourceListClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) granite_widgets_source_list_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GraniteWidgetsSourceList), 0, (GInstanceInitFunc) granite_widgets_source_list_instance_init, NULL };
		GType granite_widgets_source_list_type_id;
		granite_widgets_source_list_type_id = g_type_register_static (gtk_scrolled_window_get_type (), "GraniteWidgetsSourceList", &g_define_type_info, 0);
		GraniteWidgetsSourceList_private_offset = g_type_add_instance_private (granite_widgets_source_list_type_id, sizeof (GraniteWidgetsSourceListPrivate));
		g_once_init_leave (&granite_widgets_source_list_type_id__volatile, granite_widgets_source_list_type_id);
	}
	return granite_widgets_source_list_type_id__volatile;
}


static void
_vala_granite_widgets_source_list_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec)
{
	GraniteWidgetsSourceList * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GRANITE_WIDGETS_TYPE_SOURCE_LIST, GraniteWidgetsSourceList);
#line 233 "../lib/Widgets/SourceList.vala"
	switch (property_id) {
#line 233 "../lib/Widgets/SourceList.vala"
		case GRANITE_WIDGETS_SOURCE_LIST_ROOT_PROPERTY:
#line 233 "../lib/Widgets/SourceList.vala"
		g_value_set_object (value, granite_widgets_source_list_get_root (self));
#line 233 "../lib/Widgets/SourceList.vala"
		break;
#line 233 "../lib/Widgets/SourceList.vala"
		case GRANITE_WIDGETS_SOURCE_LIST_SELECTED_PROPERTY:
#line 233 "../lib/Widgets/SourceList.vala"
		g_value_set_object (value, granite_widgets_source_list_get_selected (self));
#line 233 "../lib/Widgets/SourceList.vala"
		break;
#line 233 "../lib/Widgets/SourceList.vala"
		case GRANITE_WIDGETS_SOURCE_LIST_ELLIPSIZE_MODE_PROPERTY:
#line 233 "../lib/Widgets/SourceList.vala"
		g_value_set_enum (value, granite_widgets_source_list_get_ellipsize_mode (self));
#line 233 "../lib/Widgets/SourceList.vala"
		break;
#line 233 "../lib/Widgets/SourceList.vala"
		case GRANITE_WIDGETS_SOURCE_LIST_EDITING_PROPERTY:
#line 233 "../lib/Widgets/SourceList.vala"
		g_value_set_boolean (value, granite_widgets_source_list_get_editing (self));
#line 233 "../lib/Widgets/SourceList.vala"
		break;
#line 14026 "SourceList.c"
		default:
#line 233 "../lib/Widgets/SourceList.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 233 "../lib/Widgets/SourceList.vala"
		break;
#line 14032 "SourceList.c"
	}
}


static void
_vala_granite_widgets_source_list_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec)
{
	GraniteWidgetsSourceList * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GRANITE_WIDGETS_TYPE_SOURCE_LIST, GraniteWidgetsSourceList);
#line 233 "../lib/Widgets/SourceList.vala"
	switch (property_id) {
#line 233 "../lib/Widgets/SourceList.vala"
		case GRANITE_WIDGETS_SOURCE_LIST_ROOT_PROPERTY:
#line 233 "../lib/Widgets/SourceList.vala"
		granite_widgets_source_list_set_root (self, g_value_get_object (value));
#line 233 "../lib/Widgets/SourceList.vala"
		break;
#line 233 "../lib/Widgets/SourceList.vala"
		case GRANITE_WIDGETS_SOURCE_LIST_SELECTED_PROPERTY:
#line 233 "../lib/Widgets/SourceList.vala"
		granite_widgets_source_list_set_selected (self, g_value_get_object (value));
#line 233 "../lib/Widgets/SourceList.vala"
		break;
#line 233 "../lib/Widgets/SourceList.vala"
		case GRANITE_WIDGETS_SOURCE_LIST_ELLIPSIZE_MODE_PROPERTY:
#line 233 "../lib/Widgets/SourceList.vala"
		granite_widgets_source_list_set_ellipsize_mode (self, g_value_get_enum (value));
#line 233 "../lib/Widgets/SourceList.vala"
		break;
#line 14065 "SourceList.c"
		default:
#line 233 "../lib/Widgets/SourceList.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 233 "../lib/Widgets/SourceList.vala"
		break;
#line 14071 "SourceList.c"
	}
}



